// $ANTLR 3.5.2 HiveParser.g 2014-11-26 15:19:52

package org.apache.hadoop.hive.ql.parse;

import java.util.Collection;
import java.util.HashMap;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.runtime.tree.*;


/**
   Licensed to the Apache Software Foundation (ASF) under one or more 
   contributor license agreements.  See the NOTICE file distributed with 
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with 
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
@SuppressWarnings("all")
public class HiveParser extends Parser {
	public static final String[] tokenNames = new String[] {
		"<invalid>", "<EOR>", "<DOWN>", "<UP>", "AMPERSAND", "APRIL", "AUGUST", 
		"BITWISEOR", "BITWISEXOR", "BigintLiteral", "ByteLengthLiteral", "COLON", 
		"COMMA", "COMMENT", "CharSetLiteral", "CharSetName", "DAY", "DECEMBER", 
		"DIV", "DIVIDE", "DOLLAR", "DOT", "DecimalLiteral", "Digit", "EQUAL", 
		"EQUAL_NS", "Exponent", "FEBRUARY", "FRIDAY", "GREATERTHAN", "GREATERTHANOREQUALTO", 
		"HOUR", "HexDigit", "Identifier", "JANUARY", "JULY", "JUNE", "KW_ADD", 
		"KW_AFTER", "KW_ALL", "KW_ALTER", "KW_ANALYZE", "KW_AND", "KW_ARCHIVE", 
		"KW_ARRAY", "KW_AS", "KW_ASC", "KW_BEFORE", "KW_BETWEEN", "KW_BIGINT", 
		"KW_BINARY", "KW_BOOLEAN", "KW_BOTH", "KW_BUCKET", "KW_BUCKETS", "KW_BY", 
		"KW_CASCADE", "KW_CASE", "KW_CAST", "KW_CHANGE", "KW_CLUSTER", "KW_CLUSTERED", 
		"KW_CLUSTERSTATUS", "KW_COLLECTION", "KW_COLUMN", "KW_COLUMNS", "KW_COMMENT", 
		"KW_COMPUTE", "KW_CONCATENATE", "KW_CONSTANT", "KW_CONTINUE", "KW_CREATE", 
		"KW_CROSS", "KW_CUBE", "KW_CURRENT", "KW_CURSOR", "KW_DATA", "KW_DATABASE", 
		"KW_DATABASES", "KW_DATE", "KW_DATETIME", "KW_DAY", "KW_DBPROPERTIES", 
		"KW_DECIMAL", "KW_DEFERRED", "KW_DELETE", "KW_DELIMITED", "KW_DEPENDENCY", 
		"KW_DESC", "KW_DESCRIBE", "KW_DIRECTORIES", "KW_DIRECTORY", "KW_DISABLE", 
		"KW_DISTINCT", "KW_DISTRIBUTE", "KW_DOUBLE", "KW_DROP", "KW_ELEM_TYPE", 
		"KW_ELSE", "KW_ENABLE", "KW_END", "KW_ESCAPED", "KW_EXCHANGE", "KW_EXCLUSIVE", 
		"KW_EXISTS", "KW_EXPLAIN", "KW_EXPORT", "KW_EXTENDED", "KW_EXTERNAL", 
		"KW_FALSE", "KW_FETCH", "KW_FIELDS", "KW_FILEFORMAT", "KW_FIRST", "KW_FLOAT", 
		"KW_FOLLOWING", "KW_FOR", "KW_FORMAT", "KW_FORMATTED", "KW_FROM", "KW_FULL", 
		"KW_FUNCTION", "KW_FUNCTIONS", "KW_GRANT", "KW_GROUP", "KW_GROUPING", 
		"KW_HAVING", "KW_HOLD_DDLTIME", "KW_HOUR", "KW_IDXPROPERTIES", "KW_IF", 
		"KW_IGNORE", "KW_IMPORT", "KW_IN", "KW_INCRE", "KW_INDEX", "KW_INDEXES", 
		"KW_INNER", "KW_INPATH", "KW_INPUTDRIVER", "KW_INPUTFORMAT", "KW_INSERT", 
		"KW_INT", "KW_INTERSECT", "KW_INTERVAL", "KW_INTO", "KW_IS", "KW_ITEMS", 
		"KW_JOIN", "KW_KEYS", "KW_KEY_TYPE", "KW_LATERAL", "KW_LEFT", "KW_LESS", 
		"KW_LIKE", "KW_LIMIT", "KW_LINES", "KW_LOAD", "KW_LOCAL", "KW_LOCATION", 
		"KW_LOCK", "KW_LOCKS", "KW_LOGICAL", "KW_LONG", "KW_MACRO", "KW_MAP", 
		"KW_MAPJOIN", "KW_MATERIALIZED", "KW_MINUS", "KW_MINUTE", "KW_MORE", "KW_MSCK", 
		"KW_NOSCAN", "KW_NOT", "KW_NO_DROP", "KW_NULL", "KW_OF", "KW_OFFLINE", 
		"KW_ON", "KW_OPTION", "KW_OR", "KW_ORCFILE", "KW_ORDER", "KW_OUT", "KW_OUTER", 
		"KW_OUTPUTDRIVER", "KW_OUTPUTFORMAT", "KW_OVER", "KW_OVERWRITE", "KW_PARTIALSCAN", 
		"KW_PARTITION", "KW_PARTITIONED", "KW_PARTITIONS", "KW_PERCENT", "KW_PLUS", 
		"KW_PRECEDING", "KW_PRESERVE", "KW_PRETTY", "KW_PROCEDURE", "KW_PROTECTION", 
		"KW_PURGE", "KW_RANGE", "KW_RCFILE", "KW_READ", "KW_READONLY", "KW_READS", 
		"KW_REBUILD", "KW_RECORDREADER", "KW_RECORDWRITER", "KW_REDUCE", "KW_REGEXP", 
		"KW_RENAME", "KW_REPAIR", "KW_REPLACE", "KW_RESTRICT", "KW_REVOKE", "KW_RIGHT", 
		"KW_RLIKE", "KW_ROLE", "KW_ROLLUP", "KW_ROW", "KW_ROWS", "KW_SCHEMA", 
		"KW_SCHEMAS", "KW_SECOND", "KW_SELECT", "KW_SEMI", "KW_SEQUENCEFILE", 
		"KW_SERDE", "KW_SERDEPROPERTIES", "KW_SET", "KW_SETS", "KW_SHARED", "KW_SHOW", 
		"KW_SHOW_DATABASE", "KW_SKEWED", "KW_SMALLINT", "KW_SORT", "KW_SORTED", 
		"KW_SSL", "KW_STATISTICS", "KW_STORED", "KW_STREAMTABLE", "KW_STRING", 
		"KW_STRUCT", "KW_TABLE", "KW_TABLES", "KW_TABLESAMPLE", "KW_TBLPROPERTIES", 
		"KW_TEMPORARY", "KW_TERMINATED", "KW_TEXTFILE", "KW_THEN", "KW_TIMESTAMP", 
		"KW_TINYINT", "KW_TO", "KW_TOUCH", "KW_TRANSFORM", "KW_TRIGGER", "KW_TRUE", 
		"KW_TRUNCATE", "KW_UNARCHIVE", "KW_UNBOUNDED", "KW_UNDO", "KW_UNION", 
		"KW_UNIONTYPE", "KW_UNIQUEJOIN", "KW_UNLOCK", "KW_UNSET", "KW_UNSIGNED", 
		"KW_UPDATE", "KW_USE", "KW_USER", "KW_USING", "KW_UTC", "KW_UTCTIMESTAMP", 
		"KW_VALUE_TYPE", "KW_VARCHAR", "KW_VIEW", "KW_WHEN", "KW_WHERE", "KW_WHILE", 
		"KW_WINDOW", "KW_WITH", "LCURLY", "LESSTHAN", "LESSTHANOREQUALTO", "LPAREN", 
		"LSQUARE", "Letter", "MARCH", "MAY", "MINUS", "MINUTE", "MOD", "MONDAY", 
		"MONTH", "NOTEQUAL", "NOVEMBER", "Number", "OCTOBER", "PLUS", "QUESTION", 
		"RCURLY", "RPAREN", "RSQUARE", "RegexComponent", "SATURDAY", "SEMICOLON", 
		"SEPTEMBER", "STAR", "SUNDAY", "SmallintLiteral", "StringLiteral", "THURSDAY", 
		"TILDE", "TODAY", "TOMORROW", "TONIGHT", "TUESDAY", "TimeUnit", "TinyintLiteral", 
		"WEDNESDAY", "WEEK", "WS", "YEAR", "YESTERDAY", "INT", "TOK_ALIASLIST", 
		"TOK_ALLCOLREF", "TOK_ALTERDATABASE_PROPERTIES", "TOK_ALTERINDEX_PROPERTIES", 
		"TOK_ALTERINDEX_REBUILD", "TOK_ALTERTABLE_ADDCOLS", "TOK_ALTERTABLE_ADDPARTS", 
		"TOK_ALTERTABLE_ALTERPARTS", "TOK_ALTERTABLE_ALTERPARTS_MERGEFILES", "TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE", 
		"TOK_ALTERTABLE_ARCHIVE", "TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION", "TOK_ALTERTABLE_CLUSTER_SORT", 
		"TOK_ALTERTABLE_DROPPARTS", "TOK_ALTERTABLE_FILEFORMAT", "TOK_ALTERTABLE_LOCATION", 
		"TOK_ALTERTABLE_PARTITION", "TOK_ALTERTABLE_PROPERTIES", "TOK_ALTERTABLE_RENAME", 
		"TOK_ALTERTABLE_RENAMECOL", "TOK_ALTERTABLE_RENAMEPART", "TOK_ALTERTABLE_REPLACECOLS", 
		"TOK_ALTERTABLE_SERDEPROPERTIES", "TOK_ALTERTABLE_SERIALIZER", "TOK_ALTERTABLE_SKEWED", 
		"TOK_ALTERTABLE_TOUCH", "TOK_ALTERTABLE_UNARCHIVE", "TOK_ALTERTBLPART_SKEWED_LOCATION", 
		"TOK_ALTERVIEW_ADDPARTS", "TOK_ALTERVIEW_AS", "TOK_ALTERVIEW_DROPPARTS", 
		"TOK_ALTERVIEW_PROPERTIES", "TOK_ALTERVIEW_RENAME", "TOK_ANALYZE", "TOK_BIGINT", 
		"TOK_BINARY", "TOK_BOOLEAN", "TOK_CASCADE", "TOK_CHARSETLITERAL", "TOK_CLUSTERBY", 
		"TOK_COLTYPELIST", "TOK_CONSTANT", "TOK_CREATEDATABASE", "TOK_CREATEFUNCTION", 
		"TOK_CREATEINDEX", "TOK_CREATEINDEX_INDEXTBLNAME", "TOK_CREATEMACRO", 
		"TOK_CREATEROLE", "TOK_CREATETABLE", "TOK_CREATEVIEW", "TOK_CROSSJOIN", 
		"TOK_CUBE_GROUPBY", "TOK_DATABASECOMMENT", "TOK_DATABASELOCATION", "TOK_DATABASEPROPERTIES", 
		"TOK_DATE", "TOK_DATELITERAL", "TOK_DATETIME", "TOK_DBPROPLIST", "TOK_DECIMAL", 
		"TOK_DEFERRED_REBUILDINDEX", "TOK_DESCDATABASE", "TOK_DESCFUNCTION", "TOK_DESCTABLE", 
		"TOK_DESTINATION", "TOK_DIR", "TOK_DISABLE", "TOK_DISTRIBUTEBY", "TOK_DOUBLE", 
		"TOK_DROPDATABASE", "TOK_DROPFUNCTION", "TOK_DROPINDEX", "TOK_DROPMACRO", 
		"TOK_DROPROLE", "TOK_DROPTABLE", "TOK_DROPTABLE_PROPERTIES", "TOK_DROPVIEW", 
		"TOK_DROPVIEW_PROPERTIES", "TOK_ENABLE", "TOK_EXCHANGEPARTITION", "TOK_EXPLAIN", 
		"TOK_EXPLIST", "TOK_EXPORT", "TOK_FALSE", "TOK_FILEFORMAT_GENERIC", "TOK_FLOAT", 
		"TOK_FROM", "TOK_FULLOUTERJOIN", "TOK_FUNCTION", "TOK_FUNCTIONDI", "TOK_FUNCTIONSTAR", 
		"TOK_GRANT", "TOK_GRANT_ROLE", "TOK_GRANT_WITH_OPTION", "TOK_GROUP", "TOK_GROUPBY", 
		"TOK_GROUPING_SETS", "TOK_GROUPING_SETS_EXPRESSION", "TOK_HAVING", "TOK_HINT", 
		"TOK_HINTARGLIST", "TOK_HINTLIST", "TOK_HOLD_DDLTIME", "TOK_IFEXISTS", 
		"TOK_IFNOTEXISTS", "TOK_IGNOREPROTECTION", "TOK_IMPORT", "TOK_INCRE", 
		"TOK_INDEXCOMMENT", "TOK_INDEXPROPERTIES", "TOK_INDEXPROPLIST", "TOK_INSERT", 
		"TOK_INSERT_INTO", "TOK_INT", "TOK_INTERVAL", "TOK_ISNOTNULL", "TOK_ISNULL", 
		"TOK_JOIN", "TOK_LATERAL_VIEW", "TOK_LATERAL_VIEW_OUTER", "TOK_LEFTOUTERJOIN", 
		"TOK_LEFTSEMIJOIN", "TOK_LENGTH", "TOK_LIKETABLE", "TOK_LIMIT", "TOK_LIST", 
		"TOK_LOAD", "TOK_LOCAL_DIR", "TOK_LOCKTABLE", "TOK_MAP", "TOK_MAPJOIN", 
		"TOK_MSCK", "TOK_NOT_CLUSTERED", "TOK_NOT_SORTED", "TOK_NO_DROP", "TOK_NULL", 
		"TOK_OFFLINE", "TOK_OP_ADD", "TOK_OP_AND", "TOK_OP_BITAND", "TOK_OP_BITNOT", 
		"TOK_OP_BITOR", "TOK_OP_BITXOR", "TOK_OP_DIV", "TOK_OP_EQ", "TOK_OP_GE", 
		"TOK_OP_GT", "TOK_OP_LE", "TOK_OP_LIKE", "TOK_OP_LT", "TOK_OP_MOD", "TOK_OP_MUL", 
		"TOK_OP_NE", "TOK_OP_NOT", "TOK_OP_OR", "TOK_OP_SUB", "TOK_ORDERBY", "TOK_ORREPLACE", 
		"TOK_PARTITIONINGSPEC", "TOK_PARTITIONLOCATION", "TOK_PARTSPEC", "TOK_PARTVAL", 
		"TOK_PERCENT", "TOK_PRINCIPAL_NAME", "TOK_PRIVILEGE", "TOK_PRIVILEGE_LIST", 
		"TOK_PRIV_ALL", "TOK_PRIV_ALTER_DATA", "TOK_PRIV_ALTER_METADATA", "TOK_PRIV_CREATE", 
		"TOK_PRIV_DROP", "TOK_PRIV_INDEX", "TOK_PRIV_LOCK", "TOK_PRIV_OBJECT", 
		"TOK_PRIV_OBJECT_COL", "TOK_PRIV_SELECT", "TOK_PRIV_SHOW_DATABASE", "TOK_PTBLFUNCTION", 
		"TOK_QUERY", "TOK_READONLY", "TOK_RECORDREADER", "TOK_RECORDWRITER", "TOK_RESTRICT", 
		"TOK_REVOKE", "TOK_REVOKE_ROLE", "TOK_RIGHTOUTERJOIN", "TOK_ROLE", "TOK_ROLLUP_GROUPBY", 
		"TOK_ROWCOUNT", "TOK_SELECT", "TOK_SELECTDI", "TOK_SELEXPR", "TOK_SERDE", 
		"TOK_SERDENAME", "TOK_SERDEPROPS", "TOK_SHOWCOLUMNS", "TOK_SHOWDATABASES", 
		"TOK_SHOWFUNCTIONS", "TOK_SHOWINDEXES", "TOK_SHOWLOCKS", "TOK_SHOWPARTITIONS", 
		"TOK_SHOWTABLES", "TOK_SHOW_CREATETABLE", "TOK_SHOW_GRANT", "TOK_SHOW_ROLE_GRANT", 
		"TOK_SHOW_TABLESTATUS", "TOK_SHOW_TBLPROPERTIES", "TOK_SKEWED_LOCATIONS", 
		"TOK_SKEWED_LOCATION_LIST", "TOK_SKEWED_LOCATION_MAP", "TOK_SMALLINT", 
		"TOK_SORTBY", "TOK_STARTTIME", "TOK_STOPTIME", "TOK_STORAGEHANDLER", "TOK_STOREDASDIRS", 
		"TOK_STREAMTABLE", "TOK_STRING", "TOK_STRINGLITERALSEQUENCE", "TOK_STRUCT", 
		"TOK_SUBQUERY", "TOK_SWITCHDATABASE", "TOK_TAB", "TOK_TABALIAS", "TOK_TABCOL", 
		"TOK_TABCOLLIST", "TOK_TABCOLNAME", "TOK_TABCOLVALUE", "TOK_TABCOLVALUES", 
		"TOK_TABCOLVALUE_PAIR", "TOK_TABLEBUCKETS", "TOK_TABLEBUCKETSAMPLE", "TOK_TABLECOMMENT", 
		"TOK_TABLEFILEFORMAT", "TOK_TABLELOCATION", "TOK_TABLEPARTCOLS", "TOK_TABLEPROPERTIES", 
		"TOK_TABLEPROPERTY", "TOK_TABLEPROPLIST", "TOK_TABLEROWFORMAT", "TOK_TABLEROWFORMATCOLLITEMS", 
		"TOK_TABLEROWFORMATFIELD", "TOK_TABLEROWFORMATLINES", "TOK_TABLEROWFORMATMAPKEYS", 
		"TOK_TABLESERIALIZER", "TOK_TABLESKEWED", "TOK_TABLESPLITSAMPLE", "TOK_TABLE_OR_COL", 
		"TOK_TABLE_PARTITION", "TOK_TABNAME", "TOK_TABREF", "TOK_TABSORTCOLNAMEASC", 
		"TOK_TABSORTCOLNAMEDESC", "TOK_TABSRC", "TOK_TABTYPE", "TOK_TBLORCFILE", 
		"TOK_TBLRCFILE", "TOK_TBLSEQUENCEFILE", "TOK_TBLTEXTFILE", "TOK_TIME", 
		"TOK_TIMESTAMP", "TOK_TINYINT", "TOK_TMP_FILE", "TOK_TRANSFORM", "TOK_TRUE", 
		"TOK_TRUNCATETABLE", "TOK_UNION", "TOK_UNIONTYPE", "TOK_UNIQUEJOIN", "TOK_UNLOCKTABLE", 
		"TOK_USER", "TOK_USERSCRIPTCOLNAMES", "TOK_USERSCRIPTCOLSCHEMA", "TOK_VARCHAR", 
		"TOK_VIEWPARTCOLS", "TOK_WHERE", "TOK_WINDOWDEF", "TOK_WINDOWRANGE", "TOK_WINDOWSPEC", 
		"TOK_WINDOWVALUES", "878", "879"
	};
	public static final int EOF=-1;
	public static final int AMPERSAND=4;
	public static final int APRIL=5;
	public static final int AUGUST=6;
	public static final int BITWISEOR=7;
	public static final int BITWISEXOR=8;
	public static final int BigintLiteral=9;
	public static final int ByteLengthLiteral=10;
	public static final int COLON=11;
	public static final int COMMA=12;
	public static final int COMMENT=13;
	public static final int CharSetLiteral=14;
	public static final int CharSetName=15;
	public static final int DAY=16;
	public static final int DECEMBER=17;
	public static final int DIV=18;
	public static final int DIVIDE=19;
	public static final int DOLLAR=20;
	public static final int DOT=21;
	public static final int DecimalLiteral=22;
	public static final int Digit=23;
	public static final int EQUAL=24;
	public static final int EQUAL_NS=25;
	public static final int Exponent=26;
	public static final int FEBRUARY=27;
	public static final int FRIDAY=28;
	public static final int GREATERTHAN=29;
	public static final int GREATERTHANOREQUALTO=30;
	public static final int HOUR=31;
	public static final int HexDigit=32;
	public static final int Identifier=33;
	public static final int JANUARY=34;
	public static final int JULY=35;
	public static final int JUNE=36;
	public static final int KW_ADD=37;
	public static final int KW_AFTER=38;
	public static final int KW_ALL=39;
	public static final int KW_ALTER=40;
	public static final int KW_ANALYZE=41;
	public static final int KW_AND=42;
	public static final int KW_ARCHIVE=43;
	public static final int KW_ARRAY=44;
	public static final int KW_AS=45;
	public static final int KW_ASC=46;
	public static final int KW_BEFORE=47;
	public static final int KW_BETWEEN=48;
	public static final int KW_BIGINT=49;
	public static final int KW_BINARY=50;
	public static final int KW_BOOLEAN=51;
	public static final int KW_BOTH=52;
	public static final int KW_BUCKET=53;
	public static final int KW_BUCKETS=54;
	public static final int KW_BY=55;
	public static final int KW_CASCADE=56;
	public static final int KW_CASE=57;
	public static final int KW_CAST=58;
	public static final int KW_CHANGE=59;
	public static final int KW_CLUSTER=60;
	public static final int KW_CLUSTERED=61;
	public static final int KW_CLUSTERSTATUS=62;
	public static final int KW_COLLECTION=63;
	public static final int KW_COLUMN=64;
	public static final int KW_COLUMNS=65;
	public static final int KW_COMMENT=66;
	public static final int KW_COMPUTE=67;
	public static final int KW_CONCATENATE=68;
	public static final int KW_CONSTANT=69;
	public static final int KW_CONTINUE=70;
	public static final int KW_CREATE=71;
	public static final int KW_CROSS=72;
	public static final int KW_CUBE=73;
	public static final int KW_CURRENT=74;
	public static final int KW_CURSOR=75;
	public static final int KW_DATA=76;
	public static final int KW_DATABASE=77;
	public static final int KW_DATABASES=78;
	public static final int KW_DATE=79;
	public static final int KW_DATETIME=80;
	public static final int KW_DAY=81;
	public static final int KW_DBPROPERTIES=82;
	public static final int KW_DECIMAL=83;
	public static final int KW_DEFERRED=84;
	public static final int KW_DELETE=85;
	public static final int KW_DELIMITED=86;
	public static final int KW_DEPENDENCY=87;
	public static final int KW_DESC=88;
	public static final int KW_DESCRIBE=89;
	public static final int KW_DIRECTORIES=90;
	public static final int KW_DIRECTORY=91;
	public static final int KW_DISABLE=92;
	public static final int KW_DISTINCT=93;
	public static final int KW_DISTRIBUTE=94;
	public static final int KW_DOUBLE=95;
	public static final int KW_DROP=96;
	public static final int KW_ELEM_TYPE=97;
	public static final int KW_ELSE=98;
	public static final int KW_ENABLE=99;
	public static final int KW_END=100;
	public static final int KW_ESCAPED=101;
	public static final int KW_EXCHANGE=102;
	public static final int KW_EXCLUSIVE=103;
	public static final int KW_EXISTS=104;
	public static final int KW_EXPLAIN=105;
	public static final int KW_EXPORT=106;
	public static final int KW_EXTENDED=107;
	public static final int KW_EXTERNAL=108;
	public static final int KW_FALSE=109;
	public static final int KW_FETCH=110;
	public static final int KW_FIELDS=111;
	public static final int KW_FILEFORMAT=112;
	public static final int KW_FIRST=113;
	public static final int KW_FLOAT=114;
	public static final int KW_FOLLOWING=115;
	public static final int KW_FOR=116;
	public static final int KW_FORMAT=117;
	public static final int KW_FORMATTED=118;
	public static final int KW_FROM=119;
	public static final int KW_FULL=120;
	public static final int KW_FUNCTION=121;
	public static final int KW_FUNCTIONS=122;
	public static final int KW_GRANT=123;
	public static final int KW_GROUP=124;
	public static final int KW_GROUPING=125;
	public static final int KW_HAVING=126;
	public static final int KW_HOLD_DDLTIME=127;
	public static final int KW_HOUR=128;
	public static final int KW_IDXPROPERTIES=129;
	public static final int KW_IF=130;
	public static final int KW_IGNORE=131;
	public static final int KW_IMPORT=132;
	public static final int KW_IN=133;
	public static final int KW_INCRE=134;
	public static final int KW_INDEX=135;
	public static final int KW_INDEXES=136;
	public static final int KW_INNER=137;
	public static final int KW_INPATH=138;
	public static final int KW_INPUTDRIVER=139;
	public static final int KW_INPUTFORMAT=140;
	public static final int KW_INSERT=141;
	public static final int KW_INT=142;
	public static final int KW_INTERSECT=143;
	public static final int KW_INTERVAL=144;
	public static final int KW_INTO=145;
	public static final int KW_IS=146;
	public static final int KW_ITEMS=147;
	public static final int KW_JOIN=148;
	public static final int KW_KEYS=149;
	public static final int KW_KEY_TYPE=150;
	public static final int KW_LATERAL=151;
	public static final int KW_LEFT=152;
	public static final int KW_LESS=153;
	public static final int KW_LIKE=154;
	public static final int KW_LIMIT=155;
	public static final int KW_LINES=156;
	public static final int KW_LOAD=157;
	public static final int KW_LOCAL=158;
	public static final int KW_LOCATION=159;
	public static final int KW_LOCK=160;
	public static final int KW_LOCKS=161;
	public static final int KW_LOGICAL=162;
	public static final int KW_LONG=163;
	public static final int KW_MACRO=164;
	public static final int KW_MAP=165;
	public static final int KW_MAPJOIN=166;
	public static final int KW_MATERIALIZED=167;
	public static final int KW_MINUS=168;
	public static final int KW_MINUTE=169;
	public static final int KW_MORE=170;
	public static final int KW_MSCK=171;
	public static final int KW_NOSCAN=172;
	public static final int KW_NOT=173;
	public static final int KW_NO_DROP=174;
	public static final int KW_NULL=175;
	public static final int KW_OF=176;
	public static final int KW_OFFLINE=177;
	public static final int KW_ON=178;
	public static final int KW_OPTION=179;
	public static final int KW_OR=180;
	public static final int KW_ORCFILE=181;
	public static final int KW_ORDER=182;
	public static final int KW_OUT=183;
	public static final int KW_OUTER=184;
	public static final int KW_OUTPUTDRIVER=185;
	public static final int KW_OUTPUTFORMAT=186;
	public static final int KW_OVER=187;
	public static final int KW_OVERWRITE=188;
	public static final int KW_PARTIALSCAN=189;
	public static final int KW_PARTITION=190;
	public static final int KW_PARTITIONED=191;
	public static final int KW_PARTITIONS=192;
	public static final int KW_PERCENT=193;
	public static final int KW_PLUS=194;
	public static final int KW_PRECEDING=195;
	public static final int KW_PRESERVE=196;
	public static final int KW_PRETTY=197;
	public static final int KW_PROCEDURE=198;
	public static final int KW_PROTECTION=199;
	public static final int KW_PURGE=200;
	public static final int KW_RANGE=201;
	public static final int KW_RCFILE=202;
	public static final int KW_READ=203;
	public static final int KW_READONLY=204;
	public static final int KW_READS=205;
	public static final int KW_REBUILD=206;
	public static final int KW_RECORDREADER=207;
	public static final int KW_RECORDWRITER=208;
	public static final int KW_REDUCE=209;
	public static final int KW_REGEXP=210;
	public static final int KW_RENAME=211;
	public static final int KW_REPAIR=212;
	public static final int KW_REPLACE=213;
	public static final int KW_RESTRICT=214;
	public static final int KW_REVOKE=215;
	public static final int KW_RIGHT=216;
	public static final int KW_RLIKE=217;
	public static final int KW_ROLE=218;
	public static final int KW_ROLLUP=219;
	public static final int KW_ROW=220;
	public static final int KW_ROWS=221;
	public static final int KW_SCHEMA=222;
	public static final int KW_SCHEMAS=223;
	public static final int KW_SECOND=224;
	public static final int KW_SELECT=225;
	public static final int KW_SEMI=226;
	public static final int KW_SEQUENCEFILE=227;
	public static final int KW_SERDE=228;
	public static final int KW_SERDEPROPERTIES=229;
	public static final int KW_SET=230;
	public static final int KW_SETS=231;
	public static final int KW_SHARED=232;
	public static final int KW_SHOW=233;
	public static final int KW_SHOW_DATABASE=234;
	public static final int KW_SKEWED=235;
	public static final int KW_SMALLINT=236;
	public static final int KW_SORT=237;
	public static final int KW_SORTED=238;
	public static final int KW_SSL=239;
	public static final int KW_STATISTICS=240;
	public static final int KW_STORED=241;
	public static final int KW_STREAMTABLE=242;
	public static final int KW_STRING=243;
	public static final int KW_STRUCT=244;
	public static final int KW_TABLE=245;
	public static final int KW_TABLES=246;
	public static final int KW_TABLESAMPLE=247;
	public static final int KW_TBLPROPERTIES=248;
	public static final int KW_TEMPORARY=249;
	public static final int KW_TERMINATED=250;
	public static final int KW_TEXTFILE=251;
	public static final int KW_THEN=252;
	public static final int KW_TIMESTAMP=253;
	public static final int KW_TINYINT=254;
	public static final int KW_TO=255;
	public static final int KW_TOUCH=256;
	public static final int KW_TRANSFORM=257;
	public static final int KW_TRIGGER=258;
	public static final int KW_TRUE=259;
	public static final int KW_TRUNCATE=260;
	public static final int KW_UNARCHIVE=261;
	public static final int KW_UNBOUNDED=262;
	public static final int KW_UNDO=263;
	public static final int KW_UNION=264;
	public static final int KW_UNIONTYPE=265;
	public static final int KW_UNIQUEJOIN=266;
	public static final int KW_UNLOCK=267;
	public static final int KW_UNSET=268;
	public static final int KW_UNSIGNED=269;
	public static final int KW_UPDATE=270;
	public static final int KW_USE=271;
	public static final int KW_USER=272;
	public static final int KW_USING=273;
	public static final int KW_UTC=274;
	public static final int KW_UTCTIMESTAMP=275;
	public static final int KW_VALUE_TYPE=276;
	public static final int KW_VARCHAR=277;
	public static final int KW_VIEW=278;
	public static final int KW_WHEN=279;
	public static final int KW_WHERE=280;
	public static final int KW_WHILE=281;
	public static final int KW_WINDOW=282;
	public static final int KW_WITH=283;
	public static final int LCURLY=284;
	public static final int LESSTHAN=285;
	public static final int LESSTHANOREQUALTO=286;
	public static final int LPAREN=287;
	public static final int LSQUARE=288;
	public static final int Letter=289;
	public static final int MARCH=290;
	public static final int MAY=291;
	public static final int MINUS=292;
	public static final int MINUTE=293;
	public static final int MOD=294;
	public static final int MONDAY=295;
	public static final int MONTH=296;
	public static final int NOTEQUAL=297;
	public static final int NOVEMBER=298;
	public static final int Number=299;
	public static final int OCTOBER=300;
	public static final int PLUS=301;
	public static final int QUESTION=302;
	public static final int RCURLY=303;
	public static final int RPAREN=304;
	public static final int RSQUARE=305;
	public static final int RegexComponent=306;
	public static final int SATURDAY=307;
	public static final int SEMICOLON=308;
	public static final int SEPTEMBER=309;
	public static final int STAR=310;
	public static final int SUNDAY=311;
	public static final int SmallintLiteral=312;
	public static final int StringLiteral=313;
	public static final int THURSDAY=314;
	public static final int TILDE=315;
	public static final int TODAY=316;
	public static final int TOMORROW=317;
	public static final int TONIGHT=318;
	public static final int TUESDAY=319;
	public static final int TimeUnit=320;
	public static final int TinyintLiteral=321;
	public static final int WEDNESDAY=322;
	public static final int WEEK=323;
	public static final int WS=324;
	public static final int YEAR=325;
	public static final int YESTERDAY=326;
	public static final int INT=344;
	public static final int TOK_ALIASLIST=598;
	public static final int TOK_ALLCOLREF=599;
	public static final int TOK_ALTERDATABASE_PROPERTIES=600;
	public static final int TOK_ALTERINDEX_PROPERTIES=601;
	public static final int TOK_ALTERINDEX_REBUILD=602;
	public static final int TOK_ALTERTABLE_ADDCOLS=603;
	public static final int TOK_ALTERTABLE_ADDPARTS=604;
	public static final int TOK_ALTERTABLE_ALTERPARTS=605;
	public static final int TOK_ALTERTABLE_ALTERPARTS_MERGEFILES=606;
	public static final int TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE=607;
	public static final int TOK_ALTERTABLE_ARCHIVE=608;
	public static final int TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION=609;
	public static final int TOK_ALTERTABLE_CLUSTER_SORT=610;
	public static final int TOK_ALTERTABLE_DROPPARTS=611;
	public static final int TOK_ALTERTABLE_FILEFORMAT=612;
	public static final int TOK_ALTERTABLE_LOCATION=613;
	public static final int TOK_ALTERTABLE_PARTITION=614;
	public static final int TOK_ALTERTABLE_PROPERTIES=615;
	public static final int TOK_ALTERTABLE_RENAME=616;
	public static final int TOK_ALTERTABLE_RENAMECOL=617;
	public static final int TOK_ALTERTABLE_RENAMEPART=618;
	public static final int TOK_ALTERTABLE_REPLACECOLS=619;
	public static final int TOK_ALTERTABLE_SERDEPROPERTIES=620;
	public static final int TOK_ALTERTABLE_SERIALIZER=621;
	public static final int TOK_ALTERTABLE_SKEWED=622;
	public static final int TOK_ALTERTABLE_TOUCH=623;
	public static final int TOK_ALTERTABLE_UNARCHIVE=624;
	public static final int TOK_ALTERTBLPART_SKEWED_LOCATION=625;
	public static final int TOK_ALTERVIEW_ADDPARTS=626;
	public static final int TOK_ALTERVIEW_AS=627;
	public static final int TOK_ALTERVIEW_DROPPARTS=628;
	public static final int TOK_ALTERVIEW_PROPERTIES=629;
	public static final int TOK_ALTERVIEW_RENAME=630;
	public static final int TOK_ANALYZE=631;
	public static final int TOK_BIGINT=632;
	public static final int TOK_BINARY=633;
	public static final int TOK_BOOLEAN=634;
	public static final int TOK_CASCADE=635;
	public static final int TOK_CHARSETLITERAL=636;
	public static final int TOK_CLUSTERBY=637;
	public static final int TOK_COLTYPELIST=638;
	public static final int TOK_CONSTANT=639;
	public static final int TOK_CREATEDATABASE=640;
	public static final int TOK_CREATEFUNCTION=641;
	public static final int TOK_CREATEINDEX=642;
	public static final int TOK_CREATEINDEX_INDEXTBLNAME=643;
	public static final int TOK_CREATEMACRO=644;
	public static final int TOK_CREATEROLE=645;
	public static final int TOK_CREATETABLE=646;
	public static final int TOK_CREATEVIEW=647;
	public static final int TOK_CROSSJOIN=648;
	public static final int TOK_CUBE_GROUPBY=649;
	public static final int TOK_DATABASECOMMENT=650;
	public static final int TOK_DATABASELOCATION=651;
	public static final int TOK_DATABASEPROPERTIES=652;
	public static final int TOK_DATE=653;
	public static final int TOK_DATELITERAL=654;
	public static final int TOK_DATETIME=655;
	public static final int TOK_DBPROPLIST=656;
	public static final int TOK_DECIMAL=657;
	public static final int TOK_DEFERRED_REBUILDINDEX=658;
	public static final int TOK_DESCDATABASE=659;
	public static final int TOK_DESCFUNCTION=660;
	public static final int TOK_DESCTABLE=661;
	public static final int TOK_DESTINATION=662;
	public static final int TOK_DIR=663;
	public static final int TOK_DISABLE=664;
	public static final int TOK_DISTRIBUTEBY=665;
	public static final int TOK_DOUBLE=666;
	public static final int TOK_DROPDATABASE=667;
	public static final int TOK_DROPFUNCTION=668;
	public static final int TOK_DROPINDEX=669;
	public static final int TOK_DROPMACRO=670;
	public static final int TOK_DROPROLE=671;
	public static final int TOK_DROPTABLE=672;
	public static final int TOK_DROPTABLE_PROPERTIES=673;
	public static final int TOK_DROPVIEW=674;
	public static final int TOK_DROPVIEW_PROPERTIES=675;
	public static final int TOK_ENABLE=676;
	public static final int TOK_EXCHANGEPARTITION=677;
	public static final int TOK_EXPLAIN=678;
	public static final int TOK_EXPLIST=679;
	public static final int TOK_EXPORT=680;
	public static final int TOK_FALSE=681;
	public static final int TOK_FILEFORMAT_GENERIC=682;
	public static final int TOK_FLOAT=683;
	public static final int TOK_FROM=684;
	public static final int TOK_FULLOUTERJOIN=685;
	public static final int TOK_FUNCTION=686;
	public static final int TOK_FUNCTIONDI=687;
	public static final int TOK_FUNCTIONSTAR=688;
	public static final int TOK_GRANT=689;
	public static final int TOK_GRANT_ROLE=690;
	public static final int TOK_GRANT_WITH_OPTION=691;
	public static final int TOK_GROUP=692;
	public static final int TOK_GROUPBY=693;
	public static final int TOK_GROUPING_SETS=694;
	public static final int TOK_GROUPING_SETS_EXPRESSION=695;
	public static final int TOK_HAVING=696;
	public static final int TOK_HINT=697;
	public static final int TOK_HINTARGLIST=698;
	public static final int TOK_HINTLIST=699;
	public static final int TOK_HOLD_DDLTIME=700;
	public static final int TOK_IFEXISTS=701;
	public static final int TOK_IFNOTEXISTS=702;
	public static final int TOK_IGNOREPROTECTION=703;
	public static final int TOK_IMPORT=704;
	public static final int TOK_INCRE=705;
	public static final int TOK_INDEXCOMMENT=706;
	public static final int TOK_INDEXPROPERTIES=707;
	public static final int TOK_INDEXPROPLIST=708;
	public static final int TOK_INSERT=709;
	public static final int TOK_INSERT_INTO=710;
	public static final int TOK_INT=711;
	public static final int TOK_INTERVAL=712;
	public static final int TOK_ISNOTNULL=713;
	public static final int TOK_ISNULL=714;
	public static final int TOK_JOIN=715;
	public static final int TOK_LATERAL_VIEW=716;
	public static final int TOK_LATERAL_VIEW_OUTER=717;
	public static final int TOK_LEFTOUTERJOIN=718;
	public static final int TOK_LEFTSEMIJOIN=719;
	public static final int TOK_LENGTH=720;
	public static final int TOK_LIKETABLE=721;
	public static final int TOK_LIMIT=722;
	public static final int TOK_LIST=723;
	public static final int TOK_LOAD=724;
	public static final int TOK_LOCAL_DIR=725;
	public static final int TOK_LOCKTABLE=726;
	public static final int TOK_MAP=727;
	public static final int TOK_MAPJOIN=728;
	public static final int TOK_MSCK=729;
	public static final int TOK_NOT_CLUSTERED=730;
	public static final int TOK_NOT_SORTED=731;
	public static final int TOK_NO_DROP=732;
	public static final int TOK_NULL=733;
	public static final int TOK_OFFLINE=734;
	public static final int TOK_OP_ADD=735;
	public static final int TOK_OP_AND=736;
	public static final int TOK_OP_BITAND=737;
	public static final int TOK_OP_BITNOT=738;
	public static final int TOK_OP_BITOR=739;
	public static final int TOK_OP_BITXOR=740;
	public static final int TOK_OP_DIV=741;
	public static final int TOK_OP_EQ=742;
	public static final int TOK_OP_GE=743;
	public static final int TOK_OP_GT=744;
	public static final int TOK_OP_LE=745;
	public static final int TOK_OP_LIKE=746;
	public static final int TOK_OP_LT=747;
	public static final int TOK_OP_MOD=748;
	public static final int TOK_OP_MUL=749;
	public static final int TOK_OP_NE=750;
	public static final int TOK_OP_NOT=751;
	public static final int TOK_OP_OR=752;
	public static final int TOK_OP_SUB=753;
	public static final int TOK_ORDERBY=754;
	public static final int TOK_ORREPLACE=755;
	public static final int TOK_PARTITIONINGSPEC=756;
	public static final int TOK_PARTITIONLOCATION=757;
	public static final int TOK_PARTSPEC=758;
	public static final int TOK_PARTVAL=759;
	public static final int TOK_PERCENT=760;
	public static final int TOK_PRINCIPAL_NAME=761;
	public static final int TOK_PRIVILEGE=762;
	public static final int TOK_PRIVILEGE_LIST=763;
	public static final int TOK_PRIV_ALL=764;
	public static final int TOK_PRIV_ALTER_DATA=765;
	public static final int TOK_PRIV_ALTER_METADATA=766;
	public static final int TOK_PRIV_CREATE=767;
	public static final int TOK_PRIV_DROP=768;
	public static final int TOK_PRIV_INDEX=769;
	public static final int TOK_PRIV_LOCK=770;
	public static final int TOK_PRIV_OBJECT=771;
	public static final int TOK_PRIV_OBJECT_COL=772;
	public static final int TOK_PRIV_SELECT=773;
	public static final int TOK_PRIV_SHOW_DATABASE=774;
	public static final int TOK_PTBLFUNCTION=775;
	public static final int TOK_QUERY=776;
	public static final int TOK_READONLY=777;
	public static final int TOK_RECORDREADER=778;
	public static final int TOK_RECORDWRITER=779;
	public static final int TOK_RESTRICT=780;
	public static final int TOK_REVOKE=781;
	public static final int TOK_REVOKE_ROLE=782;
	public static final int TOK_RIGHTOUTERJOIN=783;
	public static final int TOK_ROLE=784;
	public static final int TOK_ROLLUP_GROUPBY=785;
	public static final int TOK_ROWCOUNT=786;
	public static final int TOK_SELECT=787;
	public static final int TOK_SELECTDI=788;
	public static final int TOK_SELEXPR=789;
	public static final int TOK_SERDE=790;
	public static final int TOK_SERDENAME=791;
	public static final int TOK_SERDEPROPS=792;
	public static final int TOK_SHOWCOLUMNS=793;
	public static final int TOK_SHOWDATABASES=794;
	public static final int TOK_SHOWFUNCTIONS=795;
	public static final int TOK_SHOWINDEXES=796;
	public static final int TOK_SHOWLOCKS=797;
	public static final int TOK_SHOWPARTITIONS=798;
	public static final int TOK_SHOWTABLES=799;
	public static final int TOK_SHOW_CREATETABLE=800;
	public static final int TOK_SHOW_GRANT=801;
	public static final int TOK_SHOW_ROLE_GRANT=802;
	public static final int TOK_SHOW_TABLESTATUS=803;
	public static final int TOK_SHOW_TBLPROPERTIES=804;
	public static final int TOK_SKEWED_LOCATIONS=805;
	public static final int TOK_SKEWED_LOCATION_LIST=806;
	public static final int TOK_SKEWED_LOCATION_MAP=807;
	public static final int TOK_SMALLINT=808;
	public static final int TOK_SORTBY=809;
	public static final int TOK_STARTTIME=810;
	public static final int TOK_STOPTIME=811;
	public static final int TOK_STORAGEHANDLER=812;
	public static final int TOK_STOREDASDIRS=813;
	public static final int TOK_STREAMTABLE=814;
	public static final int TOK_STRING=815;
	public static final int TOK_STRINGLITERALSEQUENCE=816;
	public static final int TOK_STRUCT=817;
	public static final int TOK_SUBQUERY=818;
	public static final int TOK_SWITCHDATABASE=819;
	public static final int TOK_TAB=820;
	public static final int TOK_TABALIAS=821;
	public static final int TOK_TABCOL=822;
	public static final int TOK_TABCOLLIST=823;
	public static final int TOK_TABCOLNAME=824;
	public static final int TOK_TABCOLVALUE=825;
	public static final int TOK_TABCOLVALUES=826;
	public static final int TOK_TABCOLVALUE_PAIR=827;
	public static final int TOK_TABLEBUCKETS=828;
	public static final int TOK_TABLEBUCKETSAMPLE=829;
	public static final int TOK_TABLECOMMENT=830;
	public static final int TOK_TABLEFILEFORMAT=831;
	public static final int TOK_TABLELOCATION=832;
	public static final int TOK_TABLEPARTCOLS=833;
	public static final int TOK_TABLEPROPERTIES=834;
	public static final int TOK_TABLEPROPERTY=835;
	public static final int TOK_TABLEPROPLIST=836;
	public static final int TOK_TABLEROWFORMAT=837;
	public static final int TOK_TABLEROWFORMATCOLLITEMS=838;
	public static final int TOK_TABLEROWFORMATFIELD=839;
	public static final int TOK_TABLEROWFORMATLINES=840;
	public static final int TOK_TABLEROWFORMATMAPKEYS=841;
	public static final int TOK_TABLESERIALIZER=842;
	public static final int TOK_TABLESKEWED=843;
	public static final int TOK_TABLESPLITSAMPLE=844;
	public static final int TOK_TABLE_OR_COL=845;
	public static final int TOK_TABLE_PARTITION=846;
	public static final int TOK_TABNAME=847;
	public static final int TOK_TABREF=848;
	public static final int TOK_TABSORTCOLNAMEASC=849;
	public static final int TOK_TABSORTCOLNAMEDESC=850;
	public static final int TOK_TABSRC=851;
	public static final int TOK_TABTYPE=852;
	public static final int TOK_TBLORCFILE=853;
	public static final int TOK_TBLRCFILE=854;
	public static final int TOK_TBLSEQUENCEFILE=855;
	public static final int TOK_TBLTEXTFILE=856;
	public static final int TOK_TIME=857;
	public static final int TOK_TIMESTAMP=858;
	public static final int TOK_TINYINT=859;
	public static final int TOK_TMP_FILE=860;
	public static final int TOK_TRANSFORM=861;
	public static final int TOK_TRUE=862;
	public static final int TOK_TRUNCATETABLE=863;
	public static final int TOK_UNION=864;
	public static final int TOK_UNIONTYPE=865;
	public static final int TOK_UNIQUEJOIN=866;
	public static final int TOK_UNLOCKTABLE=867;
	public static final int TOK_USER=868;
	public static final int TOK_USERSCRIPTCOLNAMES=869;
	public static final int TOK_USERSCRIPTCOLSCHEMA=870;
	public static final int TOK_VARCHAR=871;
	public static final int TOK_VIEWPARTCOLS=872;
	public static final int TOK_WHERE=873;
	public static final int TOK_WINDOWDEF=874;
	public static final int TOK_WINDOWRANGE=875;
	public static final int TOK_WINDOWSPEC=876;
	public static final int TOK_WINDOWVALUES=877;

	// delegates
	public HiveParser_IdentifiersParser gIdentifiersParser;
	public HiveParser_SelectClauseParser gSelectClauseParser;
	public HiveParser_FromClauseParser gFromClauseParser;
	public Parser[] getDelegates() {
		return new Parser[] {gIdentifiersParser, gSelectClauseParser, gFromClauseParser};
	}

	// delegators


	public HiveParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}
	public HiveParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);
		gIdentifiersParser = new HiveParser_IdentifiersParser(input, state, this);
		gSelectClauseParser = new HiveParser_SelectClauseParser(input, state, this);
		gFromClauseParser = new HiveParser_FromClauseParser(input, state, this);
	}

	protected TreeAdaptor adaptor = new CommonTreeAdaptor();

	public void setTreeAdaptor(TreeAdaptor adaptor) {
		this.adaptor = adaptor;
		gIdentifiersParser.setTreeAdaptor(this.adaptor);gSelectClauseParser.setTreeAdaptor(this.adaptor);gFromClauseParser.setTreeAdaptor(this.adaptor);
	}
	public TreeAdaptor getTreeAdaptor() {
		return adaptor;
	}
	@Override public String[] getTokenNames() { return HiveParser.tokenNames; }
	@Override public String getGrammarFileName() { return "HiveParser.g"; }


	  ArrayList<ParseError> errors = new ArrayList<ParseError>();
	  Stack msgs = new Stack<String>();

	  private static HashMap<String, String> xlateMap;
	  static {
	    xlateMap = new HashMap<String, String>();

	    // Keywords
	    xlateMap.put("KW_TRUE", "TRUE");
	    xlateMap.put("KW_FALSE", "FALSE");
	    xlateMap.put("KW_ALL", "ALL");
	    xlateMap.put("KW_AND", "AND");
	    xlateMap.put("KW_OR", "OR");
	    xlateMap.put("KW_NOT", "NOT");
	    xlateMap.put("KW_LIKE", "LIKE");

	    xlateMap.put("KW_ASC", "ASC");
	    xlateMap.put("KW_DESC", "DESC");
	    xlateMap.put("KW_ORDER", "ORDER");
	    xlateMap.put("KW_BY", "BY");
	    xlateMap.put("KW_GROUP", "GROUP");
	    xlateMap.put("KW_WHERE", "WHERE");
	    xlateMap.put("KW_FROM", "FROM");
	    xlateMap.put("KW_AS", "AS");
	    xlateMap.put("KW_SELECT", "SELECT");
	    xlateMap.put("KW_DISTINCT", "DISTINCT");
	    xlateMap.put("KW_INSERT", "INSERT");
	    xlateMap.put("KW_OVERWRITE", "OVERWRITE");
	    xlateMap.put("KW_OUTER", "OUTER");
	    xlateMap.put("KW_JOIN", "JOIN");
	    xlateMap.put("KW_LEFT", "LEFT");
	    xlateMap.put("KW_RIGHT", "RIGHT");
	    xlateMap.put("KW_FULL", "FULL");
	    xlateMap.put("KW_ON", "ON");
	    xlateMap.put("KW_PARTITION", "PARTITION");
	    xlateMap.put("KW_PARTITIONS", "PARTITIONS");
	    xlateMap.put("KW_TABLE", "TABLE");
	    xlateMap.put("KW_TABLES", "TABLES");
	    xlateMap.put("KW_TBLPROPERTIES", "TBLPROPERTIES");
	    xlateMap.put("KW_SHOW", "SHOW");
	    xlateMap.put("KW_MSCK", "MSCK");
	    xlateMap.put("KW_DIRECTORY", "DIRECTORY");
	    xlateMap.put("KW_LOCAL", "LOCAL");
	    xlateMap.put("KW_TRANSFORM", "TRANSFORM");
	    xlateMap.put("KW_USING", "USING");
	    xlateMap.put("KW_CLUSTER", "CLUSTER");
	    xlateMap.put("KW_DISTRIBUTE", "DISTRIBUTE");
	    xlateMap.put("KW_SORT", "SORT");
	    xlateMap.put("KW_UNION", "UNION");
	    xlateMap.put("KW_LOAD", "LOAD");
	    xlateMap.put("KW_DATA", "DATA");
	    xlateMap.put("KW_INPATH", "INPATH");
	    xlateMap.put("KW_IS", "IS");
	    xlateMap.put("KW_NULL", "NULL");
	    xlateMap.put("KW_CREATE", "CREATE");
	    xlateMap.put("KW_EXTERNAL", "EXTERNAL");
	    xlateMap.put("KW_ALTER", "ALTER");
	    xlateMap.put("KW_DESCRIBE", "DESCRIBE");
	    xlateMap.put("KW_DROP", "DROP");
	    xlateMap.put("KW_REANME", "REANME");
	    xlateMap.put("KW_TO", "TO");
	    xlateMap.put("KW_COMMENT", "COMMENT");
	    xlateMap.put("KW_BOOLEAN", "BOOLEAN");
	    xlateMap.put("KW_TINYINT", "TINYINT");
	    xlateMap.put("KW_SMALLINT", "SMALLINT");
	    xlateMap.put("KW_INT", "INT");
	    xlateMap.put("KW_BIGINT", "BIGINT");
	    xlateMap.put("KW_FLOAT", "FLOAT");
	    xlateMap.put("KW_DOUBLE", "DOUBLE");
	    xlateMap.put("KW_DATE", "DATE");
	    xlateMap.put("KW_DATETIME", "DATETIME");
	    xlateMap.put("KW_TIMESTAMP", "TIMESTAMP");
	    xlateMap.put("KW_STRING", "STRING");
	    xlateMap.put("KW_BINARY", "BINARY");
	    xlateMap.put("KW_ARRAY", "ARRAY");
	    xlateMap.put("KW_MAP", "MAP");
	    xlateMap.put("KW_REDUCE", "REDUCE");
	    xlateMap.put("KW_PARTITIONED", "PARTITIONED");
	    xlateMap.put("KW_CLUSTERED", "CLUSTERED");
	    xlateMap.put("KW_SORTED", "SORTED");
	    xlateMap.put("KW_INTO", "INTO");
	    xlateMap.put("KW_BUCKETS", "BUCKETS");
	    xlateMap.put("KW_ROW", "ROW");
	    xlateMap.put("KW_FORMAT", "FORMAT");
	    xlateMap.put("KW_DELIMITED", "DELIMITED");
	    xlateMap.put("KW_FIELDS", "FIELDS");
	    xlateMap.put("KW_TERMINATED", "TERMINATED");
	    xlateMap.put("KW_COLLECTION", "COLLECTION");
	    xlateMap.put("KW_ITEMS", "ITEMS");
	    xlateMap.put("KW_KEYS", "KEYS");
	    xlateMap.put("KW_KEY_TYPE", "$KEY$");
	    xlateMap.put("KW_LINES", "LINES");
	    xlateMap.put("KW_STORED", "STORED");
	    xlateMap.put("KW_SEQUENCEFILE", "SEQUENCEFILE");
	    xlateMap.put("KW_TEXTFILE", "TEXTFILE");
	    xlateMap.put("KW_INPUTFORMAT", "INPUTFORMAT");
	    xlateMap.put("KW_OUTPUTFORMAT", "OUTPUTFORMAT");
	    xlateMap.put("KW_LOCATION", "LOCATION");
	    xlateMap.put("KW_TABLESAMPLE", "TABLESAMPLE");
	    xlateMap.put("KW_BUCKET", "BUCKET");
	    xlateMap.put("KW_OUT", "OUT");
	    xlateMap.put("KW_OF", "OF");
	    xlateMap.put("KW_CAST", "CAST");
	    xlateMap.put("KW_ADD", "ADD");
	    xlateMap.put("KW_REPLACE", "REPLACE");
	    xlateMap.put("KW_COLUMNS", "COLUMNS");
	    xlateMap.put("KW_RLIKE", "RLIKE");
	    xlateMap.put("KW_REGEXP", "REGEXP");
	    xlateMap.put("KW_TEMPORARY", "TEMPORARY");
	    xlateMap.put("KW_FUNCTION", "FUNCTION");
	    xlateMap.put("KW_EXPLAIN", "EXPLAIN");
	    xlateMap.put("KW_EXTENDED", "EXTENDED");
	    xlateMap.put("KW_SERDE", "SERDE");
	    xlateMap.put("KW_WITH", "WITH");
	    xlateMap.put("KW_SERDEPROPERTIES", "SERDEPROPERTIES");
	    xlateMap.put("KW_LIMIT", "LIMIT");
	    xlateMap.put("KW_SET", "SET");
	    xlateMap.put("KW_PROPERTIES", "TBLPROPERTIES");
	    xlateMap.put("KW_VALUE_TYPE", "$VALUE$");
	    xlateMap.put("KW_ELEM_TYPE", "$ELEM$");

	    // Operators
	    xlateMap.put("DOT", ".");
	    xlateMap.put("COLON", ":");
	    xlateMap.put("COMMA", ",");
	    xlateMap.put("SEMICOLON", ");");

	    xlateMap.put("LPAREN", "(");
	    xlateMap.put("RPAREN", ")");
	    xlateMap.put("LSQUARE", "[");
	    xlateMap.put("RSQUARE", "]");

	    xlateMap.put("EQUAL", "=");
	    xlateMap.put("NOTEQUAL", "<>");
	    xlateMap.put("EQUAL_NS", "<=>");
	    xlateMap.put("LESSTHANOREQUALTO", "<=");
	    xlateMap.put("LESSTHAN", "<");
	    xlateMap.put("GREATERTHANOREQUALTO", ">=");
	    xlateMap.put("GREATERTHAN", ">");

	    xlateMap.put("DIVIDE", "/");
	    xlateMap.put("PLUS", "+");
	    xlateMap.put("MINUS", "-");
	    xlateMap.put("STAR", "*");
	    xlateMap.put("MOD", "%");

	    xlateMap.put("AMPERSAND", "&");
	    xlateMap.put("TILDE", "~");
	    xlateMap.put("BITWISEOR", "|");
	    xlateMap.put("BITWISEXOR", "^");
	    xlateMap.put("CharSetLiteral", "\\'");
	  }

	  public static Collection<String> getKeywords() {
	    return xlateMap.values();
	  }

	  private static String xlate(String name) {

	    String ret = xlateMap.get(name);
	    if (ret == null) {
	      ret = name;
	    }

	    return ret;
	  }

	  @Override
	  public Object recoverFromMismatchedSet(IntStream input,
	      RecognitionException re, BitSet follow) throws RecognitionException {
	    throw re;
	  }

	  @Override
	  public void displayRecognitionError(String[] tokenNames,
	      RecognitionException e) {
	    errors.add(new ParseError(this, e, tokenNames));
	  }

	  @Override
	  public String getErrorHeader(RecognitionException e) {
	    String header = null;
	    if (e.charPositionInLine < 0 && input.LT(-1) != null) {
	      Token t = input.LT(-1);
	      header = "line " + t.getLine() + ":" + t.getCharPositionInLine();
	    } else {
	      header = super.getErrorHeader(e);
	    }

	    return header;
	  }
	  
	  @Override
	  public String getErrorMessage(RecognitionException e, String[] tokenNames) {
	    String msg = null;

	    // Translate the token names to something that the user can understand
	    String[] xlateNames = new String[tokenNames.length];
	    for (int i = 0; i < tokenNames.length; ++i) {
	      xlateNames[i] = HiveParser.xlate(tokenNames[i]);
	    }

	    if (e instanceof NoViableAltException) {
	      @SuppressWarnings("unused")
	      NoViableAltException nvae = (NoViableAltException) e;
	      // for development, can add
	      // "decision=<<"+nvae.grammarDecisionDescription+">>"
	      // and "(decision="+nvae.decisionNumber+") and
	      // "state "+nvae.stateNumber
	      msg = "cannot recognize input near"
	              + (input.LT(1) != null ? " " + getTokenErrorDisplay(input.LT(1)) : "")
	              + (input.LT(2) != null ? " " + getTokenErrorDisplay(input.LT(2)) : "")
	              + (input.LT(3) != null ? " " + getTokenErrorDisplay(input.LT(3)) : "");
	    } else if (e instanceof MismatchedTokenException) {
	      MismatchedTokenException mte = (MismatchedTokenException) e;
	      msg = super.getErrorMessage(e, xlateNames) + (input.LT(-1) == null ? "":" near '" + input.LT(-1).getText()) + "'";
	    } else if (e instanceof FailedPredicateException) {
	      FailedPredicateException fpe = (FailedPredicateException) e;
	      msg = "Failed to recognize predicate '" + fpe.token.getText() + "'. Failed rule: '" + fpe.ruleName + "'";
	    } else {
	      msg = super.getErrorMessage(e, xlateNames);
	    }

	    if (msgs.size() > 0) {
	      msg = msg + " in " + msgs.peek();
	    }
	    return msg;
	  }


	public static class statement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "statement"
	// HiveParser.g:564:1: statement : ( explainStatement EOF | execStatement EOF );
	public final HiveParser.statement_return statement() throws RecognitionException {
		HiveParser.statement_return retval = new HiveParser.statement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token EOF2=null;
		Token EOF4=null;
		ParserRuleReturnScope explainStatement1 =null;
		ParserRuleReturnScope execStatement3 =null;

		CommonTree EOF2_tree=null;
		CommonTree EOF4_tree=null;

		try {
			// HiveParser.g:565:2: ( explainStatement EOF | execStatement EOF )
			int alt1=2;
			int LA1_0 = input.LA(1);
			if ( (LA1_0==KW_EXPLAIN) ) {
				alt1=1;
			}
			else if ( ((LA1_0 >= KW_ALTER && LA1_0 <= KW_ANALYZE)||LA1_0==KW_CREATE||(LA1_0 >= KW_DESC && LA1_0 <= KW_DESCRIBE)||LA1_0==KW_DROP||LA1_0==KW_EXPORT||LA1_0==KW_FROM||LA1_0==KW_GRANT||LA1_0==KW_IMPORT||LA1_0==KW_INSERT||LA1_0==KW_LOAD||LA1_0==KW_LOCK||LA1_0==KW_MAP||LA1_0==KW_MSCK||LA1_0==KW_REDUCE||LA1_0==KW_REVOKE||LA1_0==KW_SELECT||LA1_0==KW_SHOW||LA1_0==KW_TRUNCATE||LA1_0==KW_UNLOCK||LA1_0==KW_USE) ) {
				alt1=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 1, 0, input);
				throw nvae;
			}

			switch (alt1) {
				case 1 :
					// HiveParser.g:565:4: explainStatement EOF
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_explainStatement_in_statement925);
					explainStatement1=explainStatement();
					state._fsp--;

					adaptor.addChild(root_0, explainStatement1.getTree());

					EOF2=(Token)match(input,EOF,FOLLOW_EOF_in_statement927); 
					EOF2_tree = (CommonTree)adaptor.create(EOF2);
					adaptor.addChild(root_0, EOF2_tree);

					}
					break;
				case 2 :
					// HiveParser.g:566:4: execStatement EOF
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_execStatement_in_statement932);
					execStatement3=execStatement();
					state._fsp--;

					adaptor.addChild(root_0, execStatement3.getTree());

					EOF4=(Token)match(input,EOF,FOLLOW_EOF_in_statement934); 
					EOF4_tree = (CommonTree)adaptor.create(EOF4);
					adaptor.addChild(root_0, EOF4_tree);

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "statement"


	public static class explainStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "explainStatement"
	// HiveParser.g:569:1: explainStatement : KW_EXPLAIN (explainOptions= KW_EXTENDED |explainOptions= KW_FORMATTED |explainOptions= KW_DEPENDENCY |explainOptions= KW_LOGICAL )? execStatement -> ^( TOK_EXPLAIN execStatement ( $explainOptions)? ) ;
	public final HiveParser.explainStatement_return explainStatement() throws RecognitionException {
		HiveParser.explainStatement_return retval = new HiveParser.explainStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token explainOptions=null;
		Token KW_EXPLAIN5=null;
		ParserRuleReturnScope execStatement6 =null;

		CommonTree explainOptions_tree=null;
		CommonTree KW_EXPLAIN5_tree=null;
		RewriteRuleTokenStream stream_KW_FORMATTED=new RewriteRuleTokenStream(adaptor,"token KW_FORMATTED");
		RewriteRuleTokenStream stream_KW_DEPENDENCY=new RewriteRuleTokenStream(adaptor,"token KW_DEPENDENCY");
		RewriteRuleTokenStream stream_KW_EXTENDED=new RewriteRuleTokenStream(adaptor,"token KW_EXTENDED");
		RewriteRuleTokenStream stream_KW_EXPLAIN=new RewriteRuleTokenStream(adaptor,"token KW_EXPLAIN");
		RewriteRuleTokenStream stream_KW_LOGICAL=new RewriteRuleTokenStream(adaptor,"token KW_LOGICAL");
		RewriteRuleSubtreeStream stream_execStatement=new RewriteRuleSubtreeStream(adaptor,"rule execStatement");

		 msgs.push("explain statement"); 
		try {
			// HiveParser.g:572:2: ( KW_EXPLAIN (explainOptions= KW_EXTENDED |explainOptions= KW_FORMATTED |explainOptions= KW_DEPENDENCY |explainOptions= KW_LOGICAL )? execStatement -> ^( TOK_EXPLAIN execStatement ( $explainOptions)? ) )
			// HiveParser.g:572:4: KW_EXPLAIN (explainOptions= KW_EXTENDED |explainOptions= KW_FORMATTED |explainOptions= KW_DEPENDENCY |explainOptions= KW_LOGICAL )? execStatement
			{
			KW_EXPLAIN5=(Token)match(input,KW_EXPLAIN,FOLLOW_KW_EXPLAIN_in_explainStatement955);  
			stream_KW_EXPLAIN.add(KW_EXPLAIN5);

			// HiveParser.g:572:15: (explainOptions= KW_EXTENDED |explainOptions= KW_FORMATTED |explainOptions= KW_DEPENDENCY |explainOptions= KW_LOGICAL )?
			int alt2=5;
			switch ( input.LA(1) ) {
				case KW_EXTENDED:
					{
					alt2=1;
					}
					break;
				case KW_FORMATTED:
					{
					alt2=2;
					}
					break;
				case KW_DEPENDENCY:
					{
					alt2=3;
					}
					break;
				case KW_LOGICAL:
					{
					alt2=4;
					}
					break;
			}
			switch (alt2) {
				case 1 :
					// HiveParser.g:572:16: explainOptions= KW_EXTENDED
					{
					explainOptions=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_explainStatement960);  
					stream_KW_EXTENDED.add(explainOptions);

					}
					break;
				case 2 :
					// HiveParser.g:572:43: explainOptions= KW_FORMATTED
					{
					explainOptions=(Token)match(input,KW_FORMATTED,FOLLOW_KW_FORMATTED_in_explainStatement964);  
					stream_KW_FORMATTED.add(explainOptions);

					}
					break;
				case 3 :
					// HiveParser.g:572:71: explainOptions= KW_DEPENDENCY
					{
					explainOptions=(Token)match(input,KW_DEPENDENCY,FOLLOW_KW_DEPENDENCY_in_explainStatement968);  
					stream_KW_DEPENDENCY.add(explainOptions);

					}
					break;
				case 4 :
					// HiveParser.g:572:100: explainOptions= KW_LOGICAL
					{
					explainOptions=(Token)match(input,KW_LOGICAL,FOLLOW_KW_LOGICAL_in_explainStatement972);  
					stream_KW_LOGICAL.add(explainOptions);

					}
					break;

			}

			pushFollow(FOLLOW_execStatement_in_explainStatement976);
			execStatement6=execStatement();
			state._fsp--;

			stream_execStatement.add(execStatement6.getTree());
			// AST REWRITE
			// elements: explainOptions, execStatement
			// token labels: explainOptions
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_explainOptions=new RewriteRuleTokenStream(adaptor,"token explainOptions",explainOptions);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 573:7: -> ^( TOK_EXPLAIN execStatement ( $explainOptions)? )
			{
				// HiveParser.g:573:10: ^( TOK_EXPLAIN execStatement ( $explainOptions)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_EXPLAIN, "TOK_EXPLAIN"), root_1);
				adaptor.addChild(root_1, stream_execStatement.nextTree());
				// HiveParser.g:573:39: ( $explainOptions)?
				if ( stream_explainOptions.hasNext() ) {
					adaptor.addChild(root_1, stream_explainOptions.nextNode());
				}
				stream_explainOptions.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "explainStatement"


	public static class execStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "execStatement"
	// HiveParser.g:576:1: execStatement : ( queryStatementExpression | loadStatement | exportStatement | importStatement | ddlStatement );
	public final HiveParser.execStatement_return execStatement() throws RecognitionException {
		HiveParser.execStatement_return retval = new HiveParser.execStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope queryStatementExpression7 =null;
		ParserRuleReturnScope loadStatement8 =null;
		ParserRuleReturnScope exportStatement9 =null;
		ParserRuleReturnScope importStatement10 =null;
		ParserRuleReturnScope ddlStatement11 =null;


		 msgs.push("statement"); 
		try {
			// HiveParser.g:579:5: ( queryStatementExpression | loadStatement | exportStatement | importStatement | ddlStatement )
			int alt3=5;
			switch ( input.LA(1) ) {
			case KW_FROM:
			case KW_INSERT:
			case KW_MAP:
			case KW_REDUCE:
			case KW_SELECT:
				{
				alt3=1;
				}
				break;
			case KW_LOAD:
				{
				alt3=2;
				}
				break;
			case KW_EXPORT:
				{
				alt3=3;
				}
				break;
			case KW_IMPORT:
				{
				alt3=4;
				}
				break;
			case KW_ALTER:
			case KW_ANALYZE:
			case KW_CREATE:
			case KW_DESC:
			case KW_DESCRIBE:
			case KW_DROP:
			case KW_GRANT:
			case KW_LOCK:
			case KW_MSCK:
			case KW_REVOKE:
			case KW_SHOW:
			case KW_TRUNCATE:
			case KW_UNLOCK:
			case KW_USE:
				{
				alt3=5;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 3, 0, input);
				throw nvae;
			}
			switch (alt3) {
				case 1 :
					// HiveParser.g:579:7: queryStatementExpression
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_queryStatementExpression_in_execStatement1018);
					queryStatementExpression7=queryStatementExpression();
					state._fsp--;

					adaptor.addChild(root_0, queryStatementExpression7.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:580:7: loadStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_loadStatement_in_execStatement1026);
					loadStatement8=loadStatement();
					state._fsp--;

					adaptor.addChild(root_0, loadStatement8.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:581:7: exportStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_exportStatement_in_execStatement1034);
					exportStatement9=exportStatement();
					state._fsp--;

					adaptor.addChild(root_0, exportStatement9.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:582:7: importStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_importStatement_in_execStatement1042);
					importStatement10=importStatement();
					state._fsp--;

					adaptor.addChild(root_0, importStatement10.getTree());

					}
					break;
				case 5 :
					// HiveParser.g:583:7: ddlStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_ddlStatement_in_execStatement1050);
					ddlStatement11=ddlStatement();
					state._fsp--;

					adaptor.addChild(root_0, ddlStatement11.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "execStatement"


	public static class loadStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "loadStatement"
	// HiveParser.g:586:1: loadStatement : KW_LOAD KW_DATA (islocal= KW_LOCAL )? KW_INPATH (path= StringLiteral ) (isoverwrite= KW_OVERWRITE )? KW_INTO KW_TABLE (tab= tableOrPartition ) -> ^( TOK_LOAD $path $tab ( $islocal)? ( $isoverwrite)? ) ;
	public final HiveParser.loadStatement_return loadStatement() throws RecognitionException {
		HiveParser.loadStatement_return retval = new HiveParser.loadStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token islocal=null;
		Token path=null;
		Token isoverwrite=null;
		Token KW_LOAD12=null;
		Token KW_DATA13=null;
		Token KW_INPATH14=null;
		Token KW_INTO15=null;
		Token KW_TABLE16=null;
		ParserRuleReturnScope tab =null;

		CommonTree islocal_tree=null;
		CommonTree path_tree=null;
		CommonTree isoverwrite_tree=null;
		CommonTree KW_LOAD12_tree=null;
		CommonTree KW_DATA13_tree=null;
		CommonTree KW_INPATH14_tree=null;
		CommonTree KW_INTO15_tree=null;
		CommonTree KW_TABLE16_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_INPATH=new RewriteRuleTokenStream(adaptor,"token KW_INPATH");
		RewriteRuleTokenStream stream_KW_INTO=new RewriteRuleTokenStream(adaptor,"token KW_INTO");
		RewriteRuleTokenStream stream_KW_LOCAL=new RewriteRuleTokenStream(adaptor,"token KW_LOCAL");
		RewriteRuleTokenStream stream_KW_OVERWRITE=new RewriteRuleTokenStream(adaptor,"token KW_OVERWRITE");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_LOAD=new RewriteRuleTokenStream(adaptor,"token KW_LOAD");
		RewriteRuleTokenStream stream_KW_DATA=new RewriteRuleTokenStream(adaptor,"token KW_DATA");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");

		 msgs.push("load statement"); 
		try {
			// HiveParser.g:589:5: ( KW_LOAD KW_DATA (islocal= KW_LOCAL )? KW_INPATH (path= StringLiteral ) (isoverwrite= KW_OVERWRITE )? KW_INTO KW_TABLE (tab= tableOrPartition ) -> ^( TOK_LOAD $path $tab ( $islocal)? ( $isoverwrite)? ) )
			// HiveParser.g:589:7: KW_LOAD KW_DATA (islocal= KW_LOCAL )? KW_INPATH (path= StringLiteral ) (isoverwrite= KW_OVERWRITE )? KW_INTO KW_TABLE (tab= tableOrPartition )
			{
			KW_LOAD12=(Token)match(input,KW_LOAD,FOLLOW_KW_LOAD_in_loadStatement1077);  
			stream_KW_LOAD.add(KW_LOAD12);

			KW_DATA13=(Token)match(input,KW_DATA,FOLLOW_KW_DATA_in_loadStatement1079);  
			stream_KW_DATA.add(KW_DATA13);

			// HiveParser.g:589:23: (islocal= KW_LOCAL )?
			int alt4=2;
			int LA4_0 = input.LA(1);
			if ( (LA4_0==KW_LOCAL) ) {
				alt4=1;
			}
			switch (alt4) {
				case 1 :
					// HiveParser.g:589:24: islocal= KW_LOCAL
					{
					islocal=(Token)match(input,KW_LOCAL,FOLLOW_KW_LOCAL_in_loadStatement1084);  
					stream_KW_LOCAL.add(islocal);

					}
					break;

			}

			KW_INPATH14=(Token)match(input,KW_INPATH,FOLLOW_KW_INPATH_in_loadStatement1088);  
			stream_KW_INPATH.add(KW_INPATH14);

			// HiveParser.g:589:53: (path= StringLiteral )
			// HiveParser.g:589:54: path= StringLiteral
			{
			path=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_loadStatement1093);  
			stream_StringLiteral.add(path);

			}

			// HiveParser.g:589:74: (isoverwrite= KW_OVERWRITE )?
			int alt5=2;
			int LA5_0 = input.LA(1);
			if ( (LA5_0==KW_OVERWRITE) ) {
				alt5=1;
			}
			switch (alt5) {
				case 1 :
					// HiveParser.g:589:75: isoverwrite= KW_OVERWRITE
					{
					isoverwrite=(Token)match(input,KW_OVERWRITE,FOLLOW_KW_OVERWRITE_in_loadStatement1099);  
					stream_KW_OVERWRITE.add(isoverwrite);

					}
					break;

			}

			KW_INTO15=(Token)match(input,KW_INTO,FOLLOW_KW_INTO_in_loadStatement1103);  
			stream_KW_INTO.add(KW_INTO15);

			KW_TABLE16=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_loadStatement1105);  
			stream_KW_TABLE.add(KW_TABLE16);

			// HiveParser.g:589:119: (tab= tableOrPartition )
			// HiveParser.g:589:120: tab= tableOrPartition
			{
			pushFollow(FOLLOW_tableOrPartition_in_loadStatement1110);
			tab=tableOrPartition();
			state._fsp--;

			stream_tableOrPartition.add(tab.getTree());
			}

			// AST REWRITE
			// elements: islocal, path, isoverwrite, tab
			// token labels: islocal, isoverwrite, path
			// rule labels: retval, tab
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_islocal=new RewriteRuleTokenStream(adaptor,"token islocal",islocal);
			RewriteRuleTokenStream stream_isoverwrite=new RewriteRuleTokenStream(adaptor,"token isoverwrite",isoverwrite);
			RewriteRuleTokenStream stream_path=new RewriteRuleTokenStream(adaptor,"token path",path);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_tab=new RewriteRuleSubtreeStream(adaptor,"rule tab",tab!=null?tab.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 590:5: -> ^( TOK_LOAD $path $tab ( $islocal)? ( $isoverwrite)? )
			{
				// HiveParser.g:590:8: ^( TOK_LOAD $path $tab ( $islocal)? ( $isoverwrite)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LOAD, "TOK_LOAD"), root_1);
				adaptor.addChild(root_1, stream_path.nextNode());
				adaptor.addChild(root_1, stream_tab.nextTree());
				// HiveParser.g:590:31: ( $islocal)?
				if ( stream_islocal.hasNext() ) {
					adaptor.addChild(root_1, stream_islocal.nextNode());
				}
				stream_islocal.reset();

				// HiveParser.g:590:41: ( $isoverwrite)?
				if ( stream_isoverwrite.hasNext() ) {
					adaptor.addChild(root_1, stream_isoverwrite.nextNode());
				}
				stream_isoverwrite.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "loadStatement"


	public static class exportStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "exportStatement"
	// HiveParser.g:593:1: exportStatement : KW_EXPORT KW_TABLE (tab= tableOrPartition ) KW_TO (path= StringLiteral ) -> ^( TOK_EXPORT $tab $path) ;
	public final HiveParser.exportStatement_return exportStatement() throws RecognitionException {
		HiveParser.exportStatement_return retval = new HiveParser.exportStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token path=null;
		Token KW_EXPORT17=null;
		Token KW_TABLE18=null;
		Token KW_TO19=null;
		ParserRuleReturnScope tab =null;

		CommonTree path_tree=null;
		CommonTree KW_EXPORT17_tree=null;
		CommonTree KW_TABLE18_tree=null;
		CommonTree KW_TO19_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_EXPORT=new RewriteRuleTokenStream(adaptor,"token KW_EXPORT");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_TO=new RewriteRuleTokenStream(adaptor,"token KW_TO");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");

		 msgs.push("export statement"); 
		try {
			// HiveParser.g:596:5: ( KW_EXPORT KW_TABLE (tab= tableOrPartition ) KW_TO (path= StringLiteral ) -> ^( TOK_EXPORT $tab $path) )
			// HiveParser.g:596:7: KW_EXPORT KW_TABLE (tab= tableOrPartition ) KW_TO (path= StringLiteral )
			{
			KW_EXPORT17=(Token)match(input,KW_EXPORT,FOLLOW_KW_EXPORT_in_exportStatement1162);  
			stream_KW_EXPORT.add(KW_EXPORT17);

			KW_TABLE18=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_exportStatement1164);  
			stream_KW_TABLE.add(KW_TABLE18);

			// HiveParser.g:596:26: (tab= tableOrPartition )
			// HiveParser.g:596:27: tab= tableOrPartition
			{
			pushFollow(FOLLOW_tableOrPartition_in_exportStatement1169);
			tab=tableOrPartition();
			state._fsp--;

			stream_tableOrPartition.add(tab.getTree());
			}

			KW_TO19=(Token)match(input,KW_TO,FOLLOW_KW_TO_in_exportStatement1172);  
			stream_KW_TO.add(KW_TO19);

			// HiveParser.g:596:55: (path= StringLiteral )
			// HiveParser.g:596:56: path= StringLiteral
			{
			path=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_exportStatement1177);  
			stream_StringLiteral.add(path);

			}

			// AST REWRITE
			// elements: path, tab
			// token labels: path
			// rule labels: retval, tab
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_path=new RewriteRuleTokenStream(adaptor,"token path",path);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_tab=new RewriteRuleSubtreeStream(adaptor,"rule tab",tab!=null?tab.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 597:5: -> ^( TOK_EXPORT $tab $path)
			{
				// HiveParser.g:597:8: ^( TOK_EXPORT $tab $path)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_EXPORT, "TOK_EXPORT"), root_1);
				adaptor.addChild(root_1, stream_tab.nextTree());
				adaptor.addChild(root_1, stream_path.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "exportStatement"


	public static class importStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "importStatement"
	// HiveParser.g:600:1: importStatement : KW_IMPORT ( (ext= KW_EXTERNAL )? KW_TABLE (tab= tableOrPartition ) )? KW_FROM (path= StringLiteral ) ( tableLocation )? -> ^( TOK_IMPORT $path ( $tab)? ( $ext)? ( tableLocation )? ) ;
	public final HiveParser.importStatement_return importStatement() throws RecognitionException {
		HiveParser.importStatement_return retval = new HiveParser.importStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token ext=null;
		Token path=null;
		Token KW_IMPORT20=null;
		Token KW_TABLE21=null;
		Token KW_FROM22=null;
		ParserRuleReturnScope tab =null;
		ParserRuleReturnScope tableLocation23 =null;

		CommonTree ext_tree=null;
		CommonTree path_tree=null;
		CommonTree KW_IMPORT20_tree=null;
		CommonTree KW_TABLE21_tree=null;
		CommonTree KW_FROM22_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_IMPORT=new RewriteRuleTokenStream(adaptor,"token KW_IMPORT");
		RewriteRuleTokenStream stream_KW_EXTERNAL=new RewriteRuleTokenStream(adaptor,"token KW_EXTERNAL");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_FROM=new RewriteRuleTokenStream(adaptor,"token KW_FROM");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");
		RewriteRuleSubtreeStream stream_tableLocation=new RewriteRuleSubtreeStream(adaptor,"rule tableLocation");

		 msgs.push("import statement"); 
		try {
			// HiveParser.g:603:2: ( KW_IMPORT ( (ext= KW_EXTERNAL )? KW_TABLE (tab= tableOrPartition ) )? KW_FROM (path= StringLiteral ) ( tableLocation )? -> ^( TOK_IMPORT $path ( $tab)? ( $ext)? ( tableLocation )? ) )
			// HiveParser.g:603:4: KW_IMPORT ( (ext= KW_EXTERNAL )? KW_TABLE (tab= tableOrPartition ) )? KW_FROM (path= StringLiteral ) ( tableLocation )?
			{
			KW_IMPORT20=(Token)match(input,KW_IMPORT,FOLLOW_KW_IMPORT_in_importStatement1218);  
			stream_KW_IMPORT.add(KW_IMPORT20);

			// HiveParser.g:603:14: ( (ext= KW_EXTERNAL )? KW_TABLE (tab= tableOrPartition ) )?
			int alt7=2;
			int LA7_0 = input.LA(1);
			if ( (LA7_0==KW_EXTERNAL||LA7_0==KW_TABLE) ) {
				alt7=1;
			}
			switch (alt7) {
				case 1 :
					// HiveParser.g:603:15: (ext= KW_EXTERNAL )? KW_TABLE (tab= tableOrPartition )
					{
					// HiveParser.g:603:15: (ext= KW_EXTERNAL )?
					int alt6=2;
					int LA6_0 = input.LA(1);
					if ( (LA6_0==KW_EXTERNAL) ) {
						alt6=1;
					}
					switch (alt6) {
						case 1 :
							// HiveParser.g:603:16: ext= KW_EXTERNAL
							{
							ext=(Token)match(input,KW_EXTERNAL,FOLLOW_KW_EXTERNAL_in_importStatement1224);  
							stream_KW_EXTERNAL.add(ext);

							}
							break;

					}

					KW_TABLE21=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_importStatement1228);  
					stream_KW_TABLE.add(KW_TABLE21);

					// HiveParser.g:603:43: (tab= tableOrPartition )
					// HiveParser.g:603:44: tab= tableOrPartition
					{
					pushFollow(FOLLOW_tableOrPartition_in_importStatement1233);
					tab=tableOrPartition();
					state._fsp--;

					stream_tableOrPartition.add(tab.getTree());
					}

					}
					break;

			}

			KW_FROM22=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_importStatement1238);  
			stream_KW_FROM.add(KW_FROM22);

			// HiveParser.g:603:76: (path= StringLiteral )
			// HiveParser.g:603:77: path= StringLiteral
			{
			path=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_importStatement1243);  
			stream_StringLiteral.add(path);

			}

			// HiveParser.g:603:97: ( tableLocation )?
			int alt8=2;
			int LA8_0 = input.LA(1);
			if ( (LA8_0==KW_LOCATION) ) {
				alt8=1;
			}
			switch (alt8) {
				case 1 :
					// HiveParser.g:603:97: tableLocation
					{
					pushFollow(FOLLOW_tableLocation_in_importStatement1246);
					tableLocation23=tableLocation();
					state._fsp--;

					stream_tableLocation.add(tableLocation23.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: tab, path, ext, tableLocation
			// token labels: path, ext
			// rule labels: retval, tab
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_path=new RewriteRuleTokenStream(adaptor,"token path",path);
			RewriteRuleTokenStream stream_ext=new RewriteRuleTokenStream(adaptor,"token ext",ext);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_tab=new RewriteRuleSubtreeStream(adaptor,"rule tab",tab!=null?tab.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 604:5: -> ^( TOK_IMPORT $path ( $tab)? ( $ext)? ( tableLocation )? )
			{
				// HiveParser.g:604:8: ^( TOK_IMPORT $path ( $tab)? ( $ext)? ( tableLocation )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_IMPORT, "TOK_IMPORT"), root_1);
				adaptor.addChild(root_1, stream_path.nextNode());
				// HiveParser.g:604:28: ( $tab)?
				if ( stream_tab.hasNext() ) {
					adaptor.addChild(root_1, stream_tab.nextTree());
				}
				stream_tab.reset();

				// HiveParser.g:604:34: ( $ext)?
				if ( stream_ext.hasNext() ) {
					adaptor.addChild(root_1, stream_ext.nextNode());
				}
				stream_ext.reset();

				// HiveParser.g:604:39: ( tableLocation )?
				if ( stream_tableLocation.hasNext() ) {
					adaptor.addChild(root_1, stream_tableLocation.nextTree());
				}
				stream_tableLocation.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "importStatement"


	public static class ddlStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "ddlStatement"
	// HiveParser.g:607:1: ddlStatement : ( createDatabaseStatement | switchDatabaseStatement | dropDatabaseStatement | createTableStatement | dropTableStatement | truncateTableStatement | alterStatement | descStatement | showStatement | metastoreCheck | createViewStatement | dropViewStatement | createFunctionStatement | createMacroStatement | createIndexStatement | dropIndexStatement | dropFunctionStatement | dropMacroStatement | analyzeStatement | lockStatement | unlockStatement | createRoleStatement | dropRoleStatement | grantPrivileges | revokePrivileges | showGrants | showRoleGrants | grantRole | revokeRole );
	public final HiveParser.ddlStatement_return ddlStatement() throws RecognitionException {
		HiveParser.ddlStatement_return retval = new HiveParser.ddlStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope createDatabaseStatement24 =null;
		ParserRuleReturnScope switchDatabaseStatement25 =null;
		ParserRuleReturnScope dropDatabaseStatement26 =null;
		ParserRuleReturnScope createTableStatement27 =null;
		ParserRuleReturnScope dropTableStatement28 =null;
		ParserRuleReturnScope truncateTableStatement29 =null;
		ParserRuleReturnScope alterStatement30 =null;
		ParserRuleReturnScope descStatement31 =null;
		ParserRuleReturnScope showStatement32 =null;
		ParserRuleReturnScope metastoreCheck33 =null;
		ParserRuleReturnScope createViewStatement34 =null;
		ParserRuleReturnScope dropViewStatement35 =null;
		ParserRuleReturnScope createFunctionStatement36 =null;
		ParserRuleReturnScope createMacroStatement37 =null;
		ParserRuleReturnScope createIndexStatement38 =null;
		ParserRuleReturnScope dropIndexStatement39 =null;
		ParserRuleReturnScope dropFunctionStatement40 =null;
		ParserRuleReturnScope dropMacroStatement41 =null;
		ParserRuleReturnScope analyzeStatement42 =null;
		ParserRuleReturnScope lockStatement43 =null;
		ParserRuleReturnScope unlockStatement44 =null;
		ParserRuleReturnScope createRoleStatement45 =null;
		ParserRuleReturnScope dropRoleStatement46 =null;
		ParserRuleReturnScope grantPrivileges47 =null;
		ParserRuleReturnScope revokePrivileges48 =null;
		ParserRuleReturnScope showGrants49 =null;
		ParserRuleReturnScope showRoleGrants50 =null;
		ParserRuleReturnScope grantRole51 =null;
		ParserRuleReturnScope revokeRole52 =null;


		 msgs.push("ddl statement"); 
		try {
			// HiveParser.g:610:5: ( createDatabaseStatement | switchDatabaseStatement | dropDatabaseStatement | createTableStatement | dropTableStatement | truncateTableStatement | alterStatement | descStatement | showStatement | metastoreCheck | createViewStatement | dropViewStatement | createFunctionStatement | createMacroStatement | createIndexStatement | dropIndexStatement | dropFunctionStatement | dropMacroStatement | analyzeStatement | lockStatement | unlockStatement | createRoleStatement | dropRoleStatement | grantPrivileges | revokePrivileges | showGrants | showRoleGrants | grantRole | revokeRole )
			int alt9=29;
			alt9 = dfa9.predict(input);
			switch (alt9) {
				case 1 :
					// HiveParser.g:610:7: createDatabaseStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createDatabaseStatement_in_ddlStatement1298);
					createDatabaseStatement24=createDatabaseStatement();
					state._fsp--;

					adaptor.addChild(root_0, createDatabaseStatement24.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:611:7: switchDatabaseStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_switchDatabaseStatement_in_ddlStatement1306);
					switchDatabaseStatement25=switchDatabaseStatement();
					state._fsp--;

					adaptor.addChild(root_0, switchDatabaseStatement25.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:612:7: dropDatabaseStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropDatabaseStatement_in_ddlStatement1314);
					dropDatabaseStatement26=dropDatabaseStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropDatabaseStatement26.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:613:7: createTableStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createTableStatement_in_ddlStatement1322);
					createTableStatement27=createTableStatement();
					state._fsp--;

					adaptor.addChild(root_0, createTableStatement27.getTree());

					}
					break;
				case 5 :
					// HiveParser.g:614:7: dropTableStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropTableStatement_in_ddlStatement1330);
					dropTableStatement28=dropTableStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropTableStatement28.getTree());

					}
					break;
				case 6 :
					// HiveParser.g:615:7: truncateTableStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_truncateTableStatement_in_ddlStatement1338);
					truncateTableStatement29=truncateTableStatement();
					state._fsp--;

					adaptor.addChild(root_0, truncateTableStatement29.getTree());

					}
					break;
				case 7 :
					// HiveParser.g:616:7: alterStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatement_in_ddlStatement1346);
					alterStatement30=alterStatement();
					state._fsp--;

					adaptor.addChild(root_0, alterStatement30.getTree());

					}
					break;
				case 8 :
					// HiveParser.g:617:7: descStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_descStatement_in_ddlStatement1354);
					descStatement31=descStatement();
					state._fsp--;

					adaptor.addChild(root_0, descStatement31.getTree());

					}
					break;
				case 9 :
					// HiveParser.g:618:7: showStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_showStatement_in_ddlStatement1362);
					showStatement32=showStatement();
					state._fsp--;

					adaptor.addChild(root_0, showStatement32.getTree());

					}
					break;
				case 10 :
					// HiveParser.g:619:7: metastoreCheck
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_metastoreCheck_in_ddlStatement1370);
					metastoreCheck33=metastoreCheck();
					state._fsp--;

					adaptor.addChild(root_0, metastoreCheck33.getTree());

					}
					break;
				case 11 :
					// HiveParser.g:620:7: createViewStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createViewStatement_in_ddlStatement1378);
					createViewStatement34=createViewStatement();
					state._fsp--;

					adaptor.addChild(root_0, createViewStatement34.getTree());

					}
					break;
				case 12 :
					// HiveParser.g:621:7: dropViewStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropViewStatement_in_ddlStatement1386);
					dropViewStatement35=dropViewStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropViewStatement35.getTree());

					}
					break;
				case 13 :
					// HiveParser.g:622:7: createFunctionStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createFunctionStatement_in_ddlStatement1394);
					createFunctionStatement36=createFunctionStatement();
					state._fsp--;

					adaptor.addChild(root_0, createFunctionStatement36.getTree());

					}
					break;
				case 14 :
					// HiveParser.g:623:7: createMacroStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createMacroStatement_in_ddlStatement1402);
					createMacroStatement37=createMacroStatement();
					state._fsp--;

					adaptor.addChild(root_0, createMacroStatement37.getTree());

					}
					break;
				case 15 :
					// HiveParser.g:624:7: createIndexStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createIndexStatement_in_ddlStatement1410);
					createIndexStatement38=createIndexStatement();
					state._fsp--;

					adaptor.addChild(root_0, createIndexStatement38.getTree());

					}
					break;
				case 16 :
					// HiveParser.g:625:7: dropIndexStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropIndexStatement_in_ddlStatement1418);
					dropIndexStatement39=dropIndexStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropIndexStatement39.getTree());

					}
					break;
				case 17 :
					// HiveParser.g:626:7: dropFunctionStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropFunctionStatement_in_ddlStatement1426);
					dropFunctionStatement40=dropFunctionStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropFunctionStatement40.getTree());

					}
					break;
				case 18 :
					// HiveParser.g:627:7: dropMacroStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropMacroStatement_in_ddlStatement1434);
					dropMacroStatement41=dropMacroStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropMacroStatement41.getTree());

					}
					break;
				case 19 :
					// HiveParser.g:628:7: analyzeStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_analyzeStatement_in_ddlStatement1442);
					analyzeStatement42=analyzeStatement();
					state._fsp--;

					adaptor.addChild(root_0, analyzeStatement42.getTree());

					}
					break;
				case 20 :
					// HiveParser.g:629:7: lockStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_lockStatement_in_ddlStatement1450);
					lockStatement43=lockStatement();
					state._fsp--;

					adaptor.addChild(root_0, lockStatement43.getTree());

					}
					break;
				case 21 :
					// HiveParser.g:630:7: unlockStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_unlockStatement_in_ddlStatement1458);
					unlockStatement44=unlockStatement();
					state._fsp--;

					adaptor.addChild(root_0, unlockStatement44.getTree());

					}
					break;
				case 22 :
					// HiveParser.g:631:7: createRoleStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_createRoleStatement_in_ddlStatement1466);
					createRoleStatement45=createRoleStatement();
					state._fsp--;

					adaptor.addChild(root_0, createRoleStatement45.getTree());

					}
					break;
				case 23 :
					// HiveParser.g:632:7: dropRoleStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_dropRoleStatement_in_ddlStatement1474);
					dropRoleStatement46=dropRoleStatement();
					state._fsp--;

					adaptor.addChild(root_0, dropRoleStatement46.getTree());

					}
					break;
				case 24 :
					// HiveParser.g:633:7: grantPrivileges
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_grantPrivileges_in_ddlStatement1482);
					grantPrivileges47=grantPrivileges();
					state._fsp--;

					adaptor.addChild(root_0, grantPrivileges47.getTree());

					}
					break;
				case 25 :
					// HiveParser.g:634:7: revokePrivileges
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_revokePrivileges_in_ddlStatement1490);
					revokePrivileges48=revokePrivileges();
					state._fsp--;

					adaptor.addChild(root_0, revokePrivileges48.getTree());

					}
					break;
				case 26 :
					// HiveParser.g:635:7: showGrants
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_showGrants_in_ddlStatement1498);
					showGrants49=showGrants();
					state._fsp--;

					adaptor.addChild(root_0, showGrants49.getTree());

					}
					break;
				case 27 :
					// HiveParser.g:636:7: showRoleGrants
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_showRoleGrants_in_ddlStatement1506);
					showRoleGrants50=showRoleGrants();
					state._fsp--;

					adaptor.addChild(root_0, showRoleGrants50.getTree());

					}
					break;
				case 28 :
					// HiveParser.g:637:7: grantRole
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_grantRole_in_ddlStatement1514);
					grantRole51=grantRole();
					state._fsp--;

					adaptor.addChild(root_0, grantRole51.getTree());

					}
					break;
				case 29 :
					// HiveParser.g:638:7: revokeRole
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_revokeRole_in_ddlStatement1522);
					revokeRole52=revokeRole();
					state._fsp--;

					adaptor.addChild(root_0, revokeRole52.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "ddlStatement"


	public static class ifExists_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "ifExists"
	// HiveParser.g:641:1: ifExists : KW_IF KW_EXISTS -> ^( TOK_IFEXISTS ) ;
	public final HiveParser.ifExists_return ifExists() throws RecognitionException {
		HiveParser.ifExists_return retval = new HiveParser.ifExists_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_IF53=null;
		Token KW_EXISTS54=null;

		CommonTree KW_IF53_tree=null;
		CommonTree KW_EXISTS54_tree=null;
		RewriteRuleTokenStream stream_KW_IF=new RewriteRuleTokenStream(adaptor,"token KW_IF");
		RewriteRuleTokenStream stream_KW_EXISTS=new RewriteRuleTokenStream(adaptor,"token KW_EXISTS");

		 msgs.push("if exists clause"); 
		try {
			// HiveParser.g:644:5: ( KW_IF KW_EXISTS -> ^( TOK_IFEXISTS ) )
			// HiveParser.g:644:7: KW_IF KW_EXISTS
			{
			KW_IF53=(Token)match(input,KW_IF,FOLLOW_KW_IF_in_ifExists1549);  
			stream_KW_IF.add(KW_IF53);

			KW_EXISTS54=(Token)match(input,KW_EXISTS,FOLLOW_KW_EXISTS_in_ifExists1551);  
			stream_KW_EXISTS.add(KW_EXISTS54);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 645:5: -> ^( TOK_IFEXISTS )
			{
				// HiveParser.g:645:8: ^( TOK_IFEXISTS )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_IFEXISTS, "TOK_IFEXISTS"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "ifExists"


	public static class restrictOrCascade_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "restrictOrCascade"
	// HiveParser.g:648:1: restrictOrCascade : ( KW_RESTRICT -> ^( TOK_RESTRICT ) | KW_CASCADE -> ^( TOK_CASCADE ) );
	public final HiveParser.restrictOrCascade_return restrictOrCascade() throws RecognitionException {
		HiveParser.restrictOrCascade_return retval = new HiveParser.restrictOrCascade_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_RESTRICT55=null;
		Token KW_CASCADE56=null;

		CommonTree KW_RESTRICT55_tree=null;
		CommonTree KW_CASCADE56_tree=null;
		RewriteRuleTokenStream stream_KW_CASCADE=new RewriteRuleTokenStream(adaptor,"token KW_CASCADE");
		RewriteRuleTokenStream stream_KW_RESTRICT=new RewriteRuleTokenStream(adaptor,"token KW_RESTRICT");

		 msgs.push("restrict or cascade clause"); 
		try {
			// HiveParser.g:651:5: ( KW_RESTRICT -> ^( TOK_RESTRICT ) | KW_CASCADE -> ^( TOK_CASCADE ) )
			int alt10=2;
			int LA10_0 = input.LA(1);
			if ( (LA10_0==KW_RESTRICT) ) {
				alt10=1;
			}
			else if ( (LA10_0==KW_CASCADE) ) {
				alt10=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 10, 0, input);
				throw nvae;
			}

			switch (alt10) {
				case 1 :
					// HiveParser.g:651:7: KW_RESTRICT
					{
					KW_RESTRICT55=(Token)match(input,KW_RESTRICT,FOLLOW_KW_RESTRICT_in_restrictOrCascade1588);  
					stream_KW_RESTRICT.add(KW_RESTRICT55);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 652:5: -> ^( TOK_RESTRICT )
					{
						// HiveParser.g:652:8: ^( TOK_RESTRICT )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_RESTRICT, "TOK_RESTRICT"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:653:7: KW_CASCADE
					{
					KW_CASCADE56=(Token)match(input,KW_CASCADE,FOLLOW_KW_CASCADE_in_restrictOrCascade1606);  
					stream_KW_CASCADE.add(KW_CASCADE56);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 654:5: -> ^( TOK_CASCADE )
					{
						// HiveParser.g:654:8: ^( TOK_CASCADE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CASCADE, "TOK_CASCADE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "restrictOrCascade"


	public static class ifNotExists_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "ifNotExists"
	// HiveParser.g:657:1: ifNotExists : KW_IF KW_NOT KW_EXISTS -> ^( TOK_IFNOTEXISTS ) ;
	public final HiveParser.ifNotExists_return ifNotExists() throws RecognitionException {
		HiveParser.ifNotExists_return retval = new HiveParser.ifNotExists_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_IF57=null;
		Token KW_NOT58=null;
		Token KW_EXISTS59=null;

		CommonTree KW_IF57_tree=null;
		CommonTree KW_NOT58_tree=null;
		CommonTree KW_EXISTS59_tree=null;
		RewriteRuleTokenStream stream_KW_IF=new RewriteRuleTokenStream(adaptor,"token KW_IF");
		RewriteRuleTokenStream stream_KW_NOT=new RewriteRuleTokenStream(adaptor,"token KW_NOT");
		RewriteRuleTokenStream stream_KW_EXISTS=new RewriteRuleTokenStream(adaptor,"token KW_EXISTS");

		 msgs.push("if not exists clause"); 
		try {
			// HiveParser.g:660:5: ( KW_IF KW_NOT KW_EXISTS -> ^( TOK_IFNOTEXISTS ) )
			// HiveParser.g:660:7: KW_IF KW_NOT KW_EXISTS
			{
			KW_IF57=(Token)match(input,KW_IF,FOLLOW_KW_IF_in_ifNotExists1643);  
			stream_KW_IF.add(KW_IF57);

			KW_NOT58=(Token)match(input,KW_NOT,FOLLOW_KW_NOT_in_ifNotExists1645);  
			stream_KW_NOT.add(KW_NOT58);

			KW_EXISTS59=(Token)match(input,KW_EXISTS,FOLLOW_KW_EXISTS_in_ifNotExists1647);  
			stream_KW_EXISTS.add(KW_EXISTS59);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 661:5: -> ^( TOK_IFNOTEXISTS )
			{
				// HiveParser.g:661:8: ^( TOK_IFNOTEXISTS )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_IFNOTEXISTS, "TOK_IFNOTEXISTS"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "ifNotExists"


	public static class storedAsDirs_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "storedAsDirs"
	// HiveParser.g:664:1: storedAsDirs : KW_STORED KW_AS KW_DIRECTORIES -> ^( TOK_STOREDASDIRS ) ;
	public final HiveParser.storedAsDirs_return storedAsDirs() throws RecognitionException {
		HiveParser.storedAsDirs_return retval = new HiveParser.storedAsDirs_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_STORED60=null;
		Token KW_AS61=null;
		Token KW_DIRECTORIES62=null;

		CommonTree KW_STORED60_tree=null;
		CommonTree KW_AS61_tree=null;
		CommonTree KW_DIRECTORIES62_tree=null;
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_STORED=new RewriteRuleTokenStream(adaptor,"token KW_STORED");
		RewriteRuleTokenStream stream_KW_DIRECTORIES=new RewriteRuleTokenStream(adaptor,"token KW_DIRECTORIES");

		 msgs.push("stored as directories"); 
		try {
			// HiveParser.g:667:5: ( KW_STORED KW_AS KW_DIRECTORIES -> ^( TOK_STOREDASDIRS ) )
			// HiveParser.g:667:7: KW_STORED KW_AS KW_DIRECTORIES
			{
			KW_STORED60=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_storedAsDirs1684);  
			stream_KW_STORED.add(KW_STORED60);

			KW_AS61=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_storedAsDirs1686);  
			stream_KW_AS.add(KW_AS61);

			KW_DIRECTORIES62=(Token)match(input,KW_DIRECTORIES,FOLLOW_KW_DIRECTORIES_in_storedAsDirs1688);  
			stream_KW_DIRECTORIES.add(KW_DIRECTORIES62);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 668:5: -> ^( TOK_STOREDASDIRS )
			{
				// HiveParser.g:668:8: ^( TOK_STOREDASDIRS )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_STOREDASDIRS, "TOK_STOREDASDIRS"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "storedAsDirs"


	public static class orReplace_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "orReplace"
	// HiveParser.g:671:1: orReplace : KW_OR KW_REPLACE -> ^( TOK_ORREPLACE ) ;
	public final HiveParser.orReplace_return orReplace() throws RecognitionException {
		HiveParser.orReplace_return retval = new HiveParser.orReplace_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_OR63=null;
		Token KW_REPLACE64=null;

		CommonTree KW_OR63_tree=null;
		CommonTree KW_REPLACE64_tree=null;
		RewriteRuleTokenStream stream_KW_REPLACE=new RewriteRuleTokenStream(adaptor,"token KW_REPLACE");
		RewriteRuleTokenStream stream_KW_OR=new RewriteRuleTokenStream(adaptor,"token KW_OR");

		 msgs.push("or replace clause"); 
		try {
			// HiveParser.g:674:5: ( KW_OR KW_REPLACE -> ^( TOK_ORREPLACE ) )
			// HiveParser.g:674:7: KW_OR KW_REPLACE
			{
			KW_OR63=(Token)match(input,KW_OR,FOLLOW_KW_OR_in_orReplace1725);  
			stream_KW_OR.add(KW_OR63);

			KW_REPLACE64=(Token)match(input,KW_REPLACE,FOLLOW_KW_REPLACE_in_orReplace1727);  
			stream_KW_REPLACE.add(KW_REPLACE64);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 675:5: -> ^( TOK_ORREPLACE )
			{
				// HiveParser.g:675:8: ^( TOK_ORREPLACE )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ORREPLACE, "TOK_ORREPLACE"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "orReplace"


	public static class ignoreProtection_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "ignoreProtection"
	// HiveParser.g:678:1: ignoreProtection : KW_IGNORE KW_PROTECTION -> ^( TOK_IGNOREPROTECTION ) ;
	public final HiveParser.ignoreProtection_return ignoreProtection() throws RecognitionException {
		HiveParser.ignoreProtection_return retval = new HiveParser.ignoreProtection_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_IGNORE65=null;
		Token KW_PROTECTION66=null;

		CommonTree KW_IGNORE65_tree=null;
		CommonTree KW_PROTECTION66_tree=null;
		RewriteRuleTokenStream stream_KW_PROTECTION=new RewriteRuleTokenStream(adaptor,"token KW_PROTECTION");
		RewriteRuleTokenStream stream_KW_IGNORE=new RewriteRuleTokenStream(adaptor,"token KW_IGNORE");

		 msgs.push("ignore protection clause"); 
		try {
			// HiveParser.g:681:9: ( KW_IGNORE KW_PROTECTION -> ^( TOK_IGNOREPROTECTION ) )
			// HiveParser.g:681:11: KW_IGNORE KW_PROTECTION
			{
			KW_IGNORE65=(Token)match(input,KW_IGNORE,FOLLOW_KW_IGNORE_in_ignoreProtection1768);  
			stream_KW_IGNORE.add(KW_IGNORE65);

			KW_PROTECTION66=(Token)match(input,KW_PROTECTION,FOLLOW_KW_PROTECTION_in_ignoreProtection1770);  
			stream_KW_PROTECTION.add(KW_PROTECTION66);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 682:9: -> ^( TOK_IGNOREPROTECTION )
			{
				// HiveParser.g:682:12: ^( TOK_IGNOREPROTECTION )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_IGNOREPROTECTION, "TOK_IGNOREPROTECTION"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "ignoreProtection"


	public static class createDatabaseStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createDatabaseStatement"
	// HiveParser.g:685:1: createDatabaseStatement : KW_CREATE ( KW_DATABASE | KW_SCHEMA ) ( ifNotExists )? name= identifier ( databaseComment )? ( dbLocation )? ( KW_WITH KW_DBPROPERTIES dbprops= dbProperties )? -> ^( TOK_CREATEDATABASE $name ( ifNotExists )? ( dbLocation )? ( databaseComment )? ( $dbprops)? ) ;
	public final HiveParser.createDatabaseStatement_return createDatabaseStatement() throws RecognitionException {
		HiveParser.createDatabaseStatement_return retval = new HiveParser.createDatabaseStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CREATE67=null;
		Token KW_DATABASE68=null;
		Token KW_SCHEMA69=null;
		Token KW_WITH73=null;
		Token KW_DBPROPERTIES74=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope dbprops =null;
		ParserRuleReturnScope ifNotExists70 =null;
		ParserRuleReturnScope databaseComment71 =null;
		ParserRuleReturnScope dbLocation72 =null;

		CommonTree KW_CREATE67_tree=null;
		CommonTree KW_DATABASE68_tree=null;
		CommonTree KW_SCHEMA69_tree=null;
		CommonTree KW_WITH73_tree=null;
		CommonTree KW_DBPROPERTIES74_tree=null;
		RewriteRuleTokenStream stream_KW_SCHEMA=new RewriteRuleTokenStream(adaptor,"token KW_SCHEMA");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_KW_DBPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_DBPROPERTIES");
		RewriteRuleTokenStream stream_KW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_DATABASE");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleSubtreeStream stream_dbProperties=new RewriteRuleSubtreeStream(adaptor,"rule dbProperties");
		RewriteRuleSubtreeStream stream_dbLocation=new RewriteRuleSubtreeStream(adaptor,"rule dbLocation");
		RewriteRuleSubtreeStream stream_ifNotExists=new RewriteRuleSubtreeStream(adaptor,"rule ifNotExists");
		RewriteRuleSubtreeStream stream_databaseComment=new RewriteRuleSubtreeStream(adaptor,"rule databaseComment");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("create database statement"); 
		try {
			// HiveParser.g:688:5: ( KW_CREATE ( KW_DATABASE | KW_SCHEMA ) ( ifNotExists )? name= identifier ( databaseComment )? ( dbLocation )? ( KW_WITH KW_DBPROPERTIES dbprops= dbProperties )? -> ^( TOK_CREATEDATABASE $name ( ifNotExists )? ( dbLocation )? ( databaseComment )? ( $dbprops)? ) )
			// HiveParser.g:688:7: KW_CREATE ( KW_DATABASE | KW_SCHEMA ) ( ifNotExists )? name= identifier ( databaseComment )? ( dbLocation )? ( KW_WITH KW_DBPROPERTIES dbprops= dbProperties )?
			{
			KW_CREATE67=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createDatabaseStatement1815);  
			stream_KW_CREATE.add(KW_CREATE67);

			// HiveParser.g:688:17: ( KW_DATABASE | KW_SCHEMA )
			int alt11=2;
			int LA11_0 = input.LA(1);
			if ( (LA11_0==KW_DATABASE) ) {
				alt11=1;
			}
			else if ( (LA11_0==KW_SCHEMA) ) {
				alt11=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 11, 0, input);
				throw nvae;
			}

			switch (alt11) {
				case 1 :
					// HiveParser.g:688:18: KW_DATABASE
					{
					KW_DATABASE68=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_createDatabaseStatement1818);  
					stream_KW_DATABASE.add(KW_DATABASE68);

					}
					break;
				case 2 :
					// HiveParser.g:688:30: KW_SCHEMA
					{
					KW_SCHEMA69=(Token)match(input,KW_SCHEMA,FOLLOW_KW_SCHEMA_in_createDatabaseStatement1820);  
					stream_KW_SCHEMA.add(KW_SCHEMA69);

					}
					break;

			}

			// HiveParser.g:689:9: ( ifNotExists )?
			int alt12=2;
			int LA12_0 = input.LA(1);
			if ( (LA12_0==KW_IF) ) {
				alt12=1;
			}
			switch (alt12) {
				case 1 :
					// HiveParser.g:689:9: ifNotExists
					{
					pushFollow(FOLLOW_ifNotExists_in_createDatabaseStatement1831);
					ifNotExists70=ifNotExists();
					state._fsp--;

					stream_ifNotExists.add(ifNotExists70.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_createDatabaseStatement1844);
			name=identifier();
			state._fsp--;

			stream_identifier.add(name.getTree());
			// HiveParser.g:691:9: ( databaseComment )?
			int alt13=2;
			int LA13_0 = input.LA(1);
			if ( (LA13_0==KW_COMMENT) ) {
				alt13=1;
			}
			switch (alt13) {
				case 1 :
					// HiveParser.g:691:9: databaseComment
					{
					pushFollow(FOLLOW_databaseComment_in_createDatabaseStatement1854);
					databaseComment71=databaseComment();
					state._fsp--;

					stream_databaseComment.add(databaseComment71.getTree());
					}
					break;

			}

			// HiveParser.g:692:9: ( dbLocation )?
			int alt14=2;
			int LA14_0 = input.LA(1);
			if ( (LA14_0==KW_LOCATION) ) {
				alt14=1;
			}
			switch (alt14) {
				case 1 :
					// HiveParser.g:692:9: dbLocation
					{
					pushFollow(FOLLOW_dbLocation_in_createDatabaseStatement1865);
					dbLocation72=dbLocation();
					state._fsp--;

					stream_dbLocation.add(dbLocation72.getTree());
					}
					break;

			}

			// HiveParser.g:693:9: ( KW_WITH KW_DBPROPERTIES dbprops= dbProperties )?
			int alt15=2;
			int LA15_0 = input.LA(1);
			if ( (LA15_0==KW_WITH) ) {
				alt15=1;
			}
			switch (alt15) {
				case 1 :
					// HiveParser.g:693:10: KW_WITH KW_DBPROPERTIES dbprops= dbProperties
					{
					KW_WITH73=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_createDatabaseStatement1877);  
					stream_KW_WITH.add(KW_WITH73);

					KW_DBPROPERTIES74=(Token)match(input,KW_DBPROPERTIES,FOLLOW_KW_DBPROPERTIES_in_createDatabaseStatement1879);  
					stream_KW_DBPROPERTIES.add(KW_DBPROPERTIES74);

					pushFollow(FOLLOW_dbProperties_in_createDatabaseStatement1883);
					dbprops=dbProperties();
					state._fsp--;

					stream_dbProperties.add(dbprops.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: ifNotExists, name, databaseComment, dbprops, dbLocation
			// token labels: 
			// rule labels: retval, name, dbprops
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);
			RewriteRuleSubtreeStream stream_dbprops=new RewriteRuleSubtreeStream(adaptor,"rule dbprops",dbprops!=null?dbprops.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 694:5: -> ^( TOK_CREATEDATABASE $name ( ifNotExists )? ( dbLocation )? ( databaseComment )? ( $dbprops)? )
			{
				// HiveParser.g:694:8: ^( TOK_CREATEDATABASE $name ( ifNotExists )? ( dbLocation )? ( databaseComment )? ( $dbprops)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEDATABASE, "TOK_CREATEDATABASE"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				// HiveParser.g:694:35: ( ifNotExists )?
				if ( stream_ifNotExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifNotExists.nextTree());
				}
				stream_ifNotExists.reset();

				// HiveParser.g:694:48: ( dbLocation )?
				if ( stream_dbLocation.hasNext() ) {
					adaptor.addChild(root_1, stream_dbLocation.nextTree());
				}
				stream_dbLocation.reset();

				// HiveParser.g:694:60: ( databaseComment )?
				if ( stream_databaseComment.hasNext() ) {
					adaptor.addChild(root_1, stream_databaseComment.nextTree());
				}
				stream_databaseComment.reset();

				// HiveParser.g:694:78: ( $dbprops)?
				if ( stream_dbprops.hasNext() ) {
					adaptor.addChild(root_1, stream_dbprops.nextTree());
				}
				stream_dbprops.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createDatabaseStatement"


	public static class dbLocation_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dbLocation"
	// HiveParser.g:697:1: dbLocation : KW_LOCATION locn= StringLiteral -> ^( TOK_DATABASELOCATION $locn) ;
	public final HiveParser.dbLocation_return dbLocation() throws RecognitionException {
		HiveParser.dbLocation_return retval = new HiveParser.dbLocation_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token locn=null;
		Token KW_LOCATION75=null;

		CommonTree locn_tree=null;
		CommonTree KW_LOCATION75_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_LOCATION=new RewriteRuleTokenStream(adaptor,"token KW_LOCATION");

		 msgs.push("database location specification"); 
		try {
			// HiveParser.g:700:5: ( KW_LOCATION locn= StringLiteral -> ^( TOK_DATABASELOCATION $locn) )
			// HiveParser.g:701:7: KW_LOCATION locn= StringLiteral
			{
			KW_LOCATION75=(Token)match(input,KW_LOCATION,FOLLOW_KW_LOCATION_in_dbLocation1944);  
			stream_KW_LOCATION.add(KW_LOCATION75);

			locn=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_dbLocation1948);  
			stream_StringLiteral.add(locn);

			// AST REWRITE
			// elements: locn
			// token labels: locn
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_locn=new RewriteRuleTokenStream(adaptor,"token locn",locn);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 701:38: -> ^( TOK_DATABASELOCATION $locn)
			{
				// HiveParser.g:701:41: ^( TOK_DATABASELOCATION $locn)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DATABASELOCATION, "TOK_DATABASELOCATION"), root_1);
				adaptor.addChild(root_1, stream_locn.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dbLocation"


	public static class dbProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dbProperties"
	// HiveParser.g:704:1: dbProperties : LPAREN dbPropertiesList RPAREN -> ^( TOK_DATABASEPROPERTIES dbPropertiesList ) ;
	public final HiveParser.dbProperties_return dbProperties() throws RecognitionException {
		HiveParser.dbProperties_return retval = new HiveParser.dbProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN76=null;
		Token RPAREN78=null;
		ParserRuleReturnScope dbPropertiesList77 =null;

		CommonTree LPAREN76_tree=null;
		CommonTree RPAREN78_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_dbPropertiesList=new RewriteRuleSubtreeStream(adaptor,"rule dbPropertiesList");

		 msgs.push("dbproperties"); 
		try {
			// HiveParser.g:707:5: ( LPAREN dbPropertiesList RPAREN -> ^( TOK_DATABASEPROPERTIES dbPropertiesList ) )
			// HiveParser.g:708:7: LPAREN dbPropertiesList RPAREN
			{
			LPAREN76=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_dbProperties1990);  
			stream_LPAREN.add(LPAREN76);

			pushFollow(FOLLOW_dbPropertiesList_in_dbProperties1992);
			dbPropertiesList77=dbPropertiesList();
			state._fsp--;

			stream_dbPropertiesList.add(dbPropertiesList77.getTree());
			RPAREN78=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_dbProperties1994);  
			stream_RPAREN.add(RPAREN78);

			// AST REWRITE
			// elements: dbPropertiesList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 708:38: -> ^( TOK_DATABASEPROPERTIES dbPropertiesList )
			{
				// HiveParser.g:708:41: ^( TOK_DATABASEPROPERTIES dbPropertiesList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DATABASEPROPERTIES, "TOK_DATABASEPROPERTIES"), root_1);
				adaptor.addChild(root_1, stream_dbPropertiesList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dbProperties"


	public static class dbPropertiesList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dbPropertiesList"
	// HiveParser.g:711:1: dbPropertiesList : keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_DBPROPLIST ( keyValueProperty )+ ) ;
	public final HiveParser.dbPropertiesList_return dbPropertiesList() throws RecognitionException {
		HiveParser.dbPropertiesList_return retval = new HiveParser.dbPropertiesList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA80=null;
		ParserRuleReturnScope keyValueProperty79 =null;
		ParserRuleReturnScope keyValueProperty81 =null;

		CommonTree COMMA80_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_keyValueProperty=new RewriteRuleSubtreeStream(adaptor,"rule keyValueProperty");

		 msgs.push("database properties list"); 
		try {
			// HiveParser.g:714:5: ( keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_DBPROPLIST ( keyValueProperty )+ ) )
			// HiveParser.g:715:7: keyValueProperty ( COMMA keyValueProperty )*
			{
			pushFollow(FOLLOW_keyValueProperty_in_dbPropertiesList2035);
			keyValueProperty79=keyValueProperty();
			state._fsp--;

			stream_keyValueProperty.add(keyValueProperty79.getTree());
			// HiveParser.g:715:24: ( COMMA keyValueProperty )*
			loop16:
			while (true) {
				int alt16=2;
				int LA16_0 = input.LA(1);
				if ( (LA16_0==COMMA) ) {
					alt16=1;
				}

				switch (alt16) {
				case 1 :
					// HiveParser.g:715:25: COMMA keyValueProperty
					{
					COMMA80=(Token)match(input,COMMA,FOLLOW_COMMA_in_dbPropertiesList2038);  
					stream_COMMA.add(COMMA80);

					pushFollow(FOLLOW_keyValueProperty_in_dbPropertiesList2040);
					keyValueProperty81=keyValueProperty();
					state._fsp--;

					stream_keyValueProperty.add(keyValueProperty81.getTree());
					}
					break;

				default :
					break loop16;
				}
			}

			// AST REWRITE
			// elements: keyValueProperty
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 715:50: -> ^( TOK_DBPROPLIST ( keyValueProperty )+ )
			{
				// HiveParser.g:715:53: ^( TOK_DBPROPLIST ( keyValueProperty )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DBPROPLIST, "TOK_DBPROPLIST"), root_1);
				if ( !(stream_keyValueProperty.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_keyValueProperty.hasNext() ) {
					adaptor.addChild(root_1, stream_keyValueProperty.nextTree());
				}
				stream_keyValueProperty.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dbPropertiesList"


	public static class switchDatabaseStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "switchDatabaseStatement"
	// HiveParser.g:719:1: switchDatabaseStatement : KW_USE identifier -> ^( TOK_SWITCHDATABASE identifier ) ;
	public final HiveParser.switchDatabaseStatement_return switchDatabaseStatement() throws RecognitionException {
		HiveParser.switchDatabaseStatement_return retval = new HiveParser.switchDatabaseStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_USE82=null;
		ParserRuleReturnScope identifier83 =null;

		CommonTree KW_USE82_tree=null;
		RewriteRuleTokenStream stream_KW_USE=new RewriteRuleTokenStream(adaptor,"token KW_USE");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("switch database statement"); 
		try {
			// HiveParser.g:722:5: ( KW_USE identifier -> ^( TOK_SWITCHDATABASE identifier ) )
			// HiveParser.g:722:7: KW_USE identifier
			{
			KW_USE82=(Token)match(input,KW_USE,FOLLOW_KW_USE_in_switchDatabaseStatement2079);  
			stream_KW_USE.add(KW_USE82);

			pushFollow(FOLLOW_identifier_in_switchDatabaseStatement2081);
			identifier83=identifier();
			state._fsp--;

			stream_identifier.add(identifier83.getTree());
			// AST REWRITE
			// elements: identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 723:5: -> ^( TOK_SWITCHDATABASE identifier )
			{
				// HiveParser.g:723:8: ^( TOK_SWITCHDATABASE identifier )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SWITCHDATABASE, "TOK_SWITCHDATABASE"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "switchDatabaseStatement"


	public static class dropDatabaseStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropDatabaseStatement"
	// HiveParser.g:726:1: dropDatabaseStatement : KW_DROP ( KW_DATABASE | KW_SCHEMA ) ( ifExists )? identifier ( restrictOrCascade )? -> ^( TOK_DROPDATABASE identifier ( ifExists )? ( restrictOrCascade )? ) ;
	public final HiveParser.dropDatabaseStatement_return dropDatabaseStatement() throws RecognitionException {
		HiveParser.dropDatabaseStatement_return retval = new HiveParser.dropDatabaseStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP84=null;
		Token KW_DATABASE85=null;
		Token KW_SCHEMA86=null;
		ParserRuleReturnScope ifExists87 =null;
		ParserRuleReturnScope identifier88 =null;
		ParserRuleReturnScope restrictOrCascade89 =null;

		CommonTree KW_DROP84_tree=null;
		CommonTree KW_DATABASE85_tree=null;
		CommonTree KW_SCHEMA86_tree=null;
		RewriteRuleTokenStream stream_KW_SCHEMA=new RewriteRuleTokenStream(adaptor,"token KW_SCHEMA");
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_DATABASE");
		RewriteRuleSubtreeStream stream_restrictOrCascade=new RewriteRuleSubtreeStream(adaptor,"rule restrictOrCascade");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("drop database statement"); 
		try {
			// HiveParser.g:729:5: ( KW_DROP ( KW_DATABASE | KW_SCHEMA ) ( ifExists )? identifier ( restrictOrCascade )? -> ^( TOK_DROPDATABASE identifier ( ifExists )? ( restrictOrCascade )? ) )
			// HiveParser.g:729:7: KW_DROP ( KW_DATABASE | KW_SCHEMA ) ( ifExists )? identifier ( restrictOrCascade )?
			{
			KW_DROP84=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropDatabaseStatement2120);  
			stream_KW_DROP.add(KW_DROP84);

			// HiveParser.g:729:15: ( KW_DATABASE | KW_SCHEMA )
			int alt17=2;
			int LA17_0 = input.LA(1);
			if ( (LA17_0==KW_DATABASE) ) {
				alt17=1;
			}
			else if ( (LA17_0==KW_SCHEMA) ) {
				alt17=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 17, 0, input);
				throw nvae;
			}

			switch (alt17) {
				case 1 :
					// HiveParser.g:729:16: KW_DATABASE
					{
					KW_DATABASE85=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_dropDatabaseStatement2123);  
					stream_KW_DATABASE.add(KW_DATABASE85);

					}
					break;
				case 2 :
					// HiveParser.g:729:28: KW_SCHEMA
					{
					KW_SCHEMA86=(Token)match(input,KW_SCHEMA,FOLLOW_KW_SCHEMA_in_dropDatabaseStatement2125);  
					stream_KW_SCHEMA.add(KW_SCHEMA86);

					}
					break;

			}

			// HiveParser.g:729:39: ( ifExists )?
			int alt18=2;
			int LA18_0 = input.LA(1);
			if ( (LA18_0==KW_IF) ) {
				alt18=1;
			}
			switch (alt18) {
				case 1 :
					// HiveParser.g:729:39: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropDatabaseStatement2128);
					ifExists87=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists87.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_dropDatabaseStatement2131);
			identifier88=identifier();
			state._fsp--;

			stream_identifier.add(identifier88.getTree());
			// HiveParser.g:729:60: ( restrictOrCascade )?
			int alt19=2;
			int LA19_0 = input.LA(1);
			if ( (LA19_0==KW_CASCADE||LA19_0==KW_RESTRICT) ) {
				alt19=1;
			}
			switch (alt19) {
				case 1 :
					// HiveParser.g:729:60: restrictOrCascade
					{
					pushFollow(FOLLOW_restrictOrCascade_in_dropDatabaseStatement2133);
					restrictOrCascade89=restrictOrCascade();
					state._fsp--;

					stream_restrictOrCascade.add(restrictOrCascade89.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: restrictOrCascade, ifExists, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 730:5: -> ^( TOK_DROPDATABASE identifier ( ifExists )? ( restrictOrCascade )? )
			{
				// HiveParser.g:730:8: ^( TOK_DROPDATABASE identifier ( ifExists )? ( restrictOrCascade )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPDATABASE, "TOK_DROPDATABASE"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:730:38: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				// HiveParser.g:730:48: ( restrictOrCascade )?
				if ( stream_restrictOrCascade.hasNext() ) {
					adaptor.addChild(root_1, stream_restrictOrCascade.nextTree());
				}
				stream_restrictOrCascade.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropDatabaseStatement"


	public static class databaseComment_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "databaseComment"
	// HiveParser.g:733:1: databaseComment : KW_COMMENT comment= StringLiteral -> ^( TOK_DATABASECOMMENT $comment) ;
	public final HiveParser.databaseComment_return databaseComment() throws RecognitionException {
		HiveParser.databaseComment_return retval = new HiveParser.databaseComment_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_COMMENT90=null;

		CommonTree comment_tree=null;
		CommonTree KW_COMMENT90_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");

		 msgs.push("database's comment"); 
		try {
			// HiveParser.g:736:5: ( KW_COMMENT comment= StringLiteral -> ^( TOK_DATABASECOMMENT $comment) )
			// HiveParser.g:736:7: KW_COMMENT comment= StringLiteral
			{
			KW_COMMENT90=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_databaseComment2179);  
			stream_KW_COMMENT.add(KW_COMMENT90);

			comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_databaseComment2183);  
			stream_StringLiteral.add(comment);

			// AST REWRITE
			// elements: comment
			// token labels: comment
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 737:5: -> ^( TOK_DATABASECOMMENT $comment)
			{
				// HiveParser.g:737:8: ^( TOK_DATABASECOMMENT $comment)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DATABASECOMMENT, "TOK_DATABASECOMMENT"), root_1);
				adaptor.addChild(root_1, stream_comment.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "databaseComment"


	public static class createTableStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createTableStatement"
	// HiveParser.g:740:1: createTableStatement : KW_CREATE (ext= KW_EXTERNAL )? KW_TABLE ( ifNotExists )? name= tableName (like= KW_LIKE likeName= tableName ( tableLocation )? ( tablePropertiesPrefixed )? | ( LPAREN columnNameTypeList RPAREN )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( KW_AS selectStatement )? ) -> ^( TOK_CREATETABLE $name ( $ext)? ( ifNotExists )? ^( TOK_LIKETABLE ( $likeName)? ) ( columnNameTypeList )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( selectStatement )? ) ;
	public final HiveParser.createTableStatement_return createTableStatement() throws RecognitionException {
		HiveParser.createTableStatement_return retval = new HiveParser.createTableStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token ext=null;
		Token like=null;
		Token KW_CREATE91=null;
		Token KW_TABLE92=null;
		Token LPAREN96=null;
		Token RPAREN98=null;
		Token KW_AS107=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope likeName =null;
		ParserRuleReturnScope ifNotExists93 =null;
		ParserRuleReturnScope tableLocation94 =null;
		ParserRuleReturnScope tablePropertiesPrefixed95 =null;
		ParserRuleReturnScope columnNameTypeList97 =null;
		ParserRuleReturnScope tableComment99 =null;
		ParserRuleReturnScope tablePartition100 =null;
		ParserRuleReturnScope tableBuckets101 =null;
		ParserRuleReturnScope tableSkewed102 =null;
		ParserRuleReturnScope tableRowFormat103 =null;
		ParserRuleReturnScope tableFileFormat104 =null;
		ParserRuleReturnScope tableLocation105 =null;
		ParserRuleReturnScope tablePropertiesPrefixed106 =null;
		ParserRuleReturnScope selectStatement108 =null;

		CommonTree ext_tree=null;
		CommonTree like_tree=null;
		CommonTree KW_CREATE91_tree=null;
		CommonTree KW_TABLE92_tree=null;
		CommonTree LPAREN96_tree=null;
		CommonTree RPAREN98_tree=null;
		CommonTree KW_AS107_tree=null;
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_LIKE=new RewriteRuleTokenStream(adaptor,"token KW_LIKE");
		RewriteRuleTokenStream stream_KW_EXTERNAL=new RewriteRuleTokenStream(adaptor,"token KW_EXTERNAL");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_selectStatement=new RewriteRuleSubtreeStream(adaptor,"rule selectStatement");
		RewriteRuleSubtreeStream stream_columnNameTypeList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameTypeList");
		RewriteRuleSubtreeStream stream_tableBuckets=new RewriteRuleSubtreeStream(adaptor,"rule tableBuckets");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_tablePartition=new RewriteRuleSubtreeStream(adaptor,"rule tablePartition");
		RewriteRuleSubtreeStream stream_tablePropertiesPrefixed=new RewriteRuleSubtreeStream(adaptor,"rule tablePropertiesPrefixed");
		RewriteRuleSubtreeStream stream_tableComment=new RewriteRuleSubtreeStream(adaptor,"rule tableComment");
		RewriteRuleSubtreeStream stream_tableRowFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormat");
		RewriteRuleSubtreeStream stream_tableFileFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableFileFormat");
		RewriteRuleSubtreeStream stream_tableLocation=new RewriteRuleSubtreeStream(adaptor,"rule tableLocation");
		RewriteRuleSubtreeStream stream_ifNotExists=new RewriteRuleSubtreeStream(adaptor,"rule ifNotExists");
		RewriteRuleSubtreeStream stream_tableSkewed=new RewriteRuleSubtreeStream(adaptor,"rule tableSkewed");

		 msgs.push("create table statement"); 
		try {
			// HiveParser.g:743:5: ( KW_CREATE (ext= KW_EXTERNAL )? KW_TABLE ( ifNotExists )? name= tableName (like= KW_LIKE likeName= tableName ( tableLocation )? ( tablePropertiesPrefixed )? | ( LPAREN columnNameTypeList RPAREN )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( KW_AS selectStatement )? ) -> ^( TOK_CREATETABLE $name ( $ext)? ( ifNotExists )? ^( TOK_LIKETABLE ( $likeName)? ) ( columnNameTypeList )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( selectStatement )? ) )
			// HiveParser.g:743:7: KW_CREATE (ext= KW_EXTERNAL )? KW_TABLE ( ifNotExists )? name= tableName (like= KW_LIKE likeName= tableName ( tableLocation )? ( tablePropertiesPrefixed )? | ( LPAREN columnNameTypeList RPAREN )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( KW_AS selectStatement )? )
			{
			KW_CREATE91=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createTableStatement2223);  
			stream_KW_CREATE.add(KW_CREATE91);

			// HiveParser.g:743:17: (ext= KW_EXTERNAL )?
			int alt20=2;
			int LA20_0 = input.LA(1);
			if ( (LA20_0==KW_EXTERNAL) ) {
				alt20=1;
			}
			switch (alt20) {
				case 1 :
					// HiveParser.g:743:18: ext= KW_EXTERNAL
					{
					ext=(Token)match(input,KW_EXTERNAL,FOLLOW_KW_EXTERNAL_in_createTableStatement2228);  
					stream_KW_EXTERNAL.add(ext);

					}
					break;

			}

			KW_TABLE92=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_createTableStatement2232);  
			stream_KW_TABLE.add(KW_TABLE92);

			// HiveParser.g:743:45: ( ifNotExists )?
			int alt21=2;
			int LA21_0 = input.LA(1);
			if ( (LA21_0==KW_IF) ) {
				alt21=1;
			}
			switch (alt21) {
				case 1 :
					// HiveParser.g:743:45: ifNotExists
					{
					pushFollow(FOLLOW_ifNotExists_in_createTableStatement2234);
					ifNotExists93=ifNotExists();
					state._fsp--;

					stream_ifNotExists.add(ifNotExists93.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_tableName_in_createTableStatement2239);
			name=tableName();
			state._fsp--;

			stream_tableName.add(name.getTree());
			// HiveParser.g:744:7: (like= KW_LIKE likeName= tableName ( tableLocation )? ( tablePropertiesPrefixed )? | ( LPAREN columnNameTypeList RPAREN )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( KW_AS selectStatement )? )
			int alt34=2;
			int LA34_0 = input.LA(1);
			if ( (LA34_0==KW_LIKE) ) {
				alt34=1;
			}
			else if ( (LA34_0==EOF||LA34_0==KW_AS||LA34_0==KW_CLUSTERED||LA34_0==KW_COMMENT||LA34_0==KW_LOCATION||LA34_0==KW_PARTITIONED||LA34_0==KW_ROW||LA34_0==KW_SKEWED||LA34_0==KW_STORED||LA34_0==KW_TBLPROPERTIES||LA34_0==LPAREN) ) {
				alt34=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 34, 0, input);
				throw nvae;
			}

			switch (alt34) {
				case 1 :
					// HiveParser.g:744:10: like= KW_LIKE likeName= tableName ( tableLocation )? ( tablePropertiesPrefixed )?
					{
					like=(Token)match(input,KW_LIKE,FOLLOW_KW_LIKE_in_createTableStatement2252);  
					stream_KW_LIKE.add(like);

					pushFollow(FOLLOW_tableName_in_createTableStatement2256);
					likeName=tableName();
					state._fsp--;

					stream_tableName.add(likeName.getTree());
					// HiveParser.g:745:10: ( tableLocation )?
					int alt22=2;
					int LA22_0 = input.LA(1);
					if ( (LA22_0==KW_LOCATION) ) {
						alt22=1;
					}
					switch (alt22) {
						case 1 :
							// HiveParser.g:745:10: tableLocation
							{
							pushFollow(FOLLOW_tableLocation_in_createTableStatement2267);
							tableLocation94=tableLocation();
							state._fsp--;

							stream_tableLocation.add(tableLocation94.getTree());
							}
							break;

					}

					// HiveParser.g:746:10: ( tablePropertiesPrefixed )?
					int alt23=2;
					int LA23_0 = input.LA(1);
					if ( (LA23_0==KW_TBLPROPERTIES) ) {
						alt23=1;
					}
					switch (alt23) {
						case 1 :
							// HiveParser.g:746:10: tablePropertiesPrefixed
							{
							pushFollow(FOLLOW_tablePropertiesPrefixed_in_createTableStatement2279);
							tablePropertiesPrefixed95=tablePropertiesPrefixed();
							state._fsp--;

							stream_tablePropertiesPrefixed.add(tablePropertiesPrefixed95.getTree());
							}
							break;

					}

					}
					break;
				case 2 :
					// HiveParser.g:747:10: ( LPAREN columnNameTypeList RPAREN )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( KW_AS selectStatement )?
					{
					// HiveParser.g:747:10: ( LPAREN columnNameTypeList RPAREN )?
					int alt24=2;
					int LA24_0 = input.LA(1);
					if ( (LA24_0==LPAREN) ) {
						alt24=1;
					}
					switch (alt24) {
						case 1 :
							// HiveParser.g:747:11: LPAREN columnNameTypeList RPAREN
							{
							LPAREN96=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createTableStatement2292);  
							stream_LPAREN.add(LPAREN96);

							pushFollow(FOLLOW_columnNameTypeList_in_createTableStatement2294);
							columnNameTypeList97=columnNameTypeList();
							state._fsp--;

							stream_columnNameTypeList.add(columnNameTypeList97.getTree());
							RPAREN98=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createTableStatement2296);  
							stream_RPAREN.add(RPAREN98);

							}
							break;

					}

					// HiveParser.g:748:10: ( tableComment )?
					int alt25=2;
					int LA25_0 = input.LA(1);
					if ( (LA25_0==KW_COMMENT) ) {
						alt25=1;
					}
					switch (alt25) {
						case 1 :
							// HiveParser.g:748:10: tableComment
							{
							pushFollow(FOLLOW_tableComment_in_createTableStatement2309);
							tableComment99=tableComment();
							state._fsp--;

							stream_tableComment.add(tableComment99.getTree());
							}
							break;

					}

					// HiveParser.g:749:10: ( tablePartition )?
					int alt26=2;
					int LA26_0 = input.LA(1);
					if ( (LA26_0==KW_PARTITIONED) ) {
						alt26=1;
					}
					switch (alt26) {
						case 1 :
							// HiveParser.g:749:10: tablePartition
							{
							pushFollow(FOLLOW_tablePartition_in_createTableStatement2321);
							tablePartition100=tablePartition();
							state._fsp--;

							stream_tablePartition.add(tablePartition100.getTree());
							}
							break;

					}

					// HiveParser.g:750:10: ( tableBuckets )?
					int alt27=2;
					int LA27_0 = input.LA(1);
					if ( (LA27_0==KW_CLUSTERED) ) {
						alt27=1;
					}
					switch (alt27) {
						case 1 :
							// HiveParser.g:750:10: tableBuckets
							{
							pushFollow(FOLLOW_tableBuckets_in_createTableStatement2333);
							tableBuckets101=tableBuckets();
							state._fsp--;

							stream_tableBuckets.add(tableBuckets101.getTree());
							}
							break;

					}

					// HiveParser.g:751:10: ( tableSkewed )?
					int alt28=2;
					int LA28_0 = input.LA(1);
					if ( (LA28_0==KW_SKEWED) ) {
						alt28=1;
					}
					switch (alt28) {
						case 1 :
							// HiveParser.g:751:10: tableSkewed
							{
							pushFollow(FOLLOW_tableSkewed_in_createTableStatement2345);
							tableSkewed102=tableSkewed();
							state._fsp--;

							stream_tableSkewed.add(tableSkewed102.getTree());
							}
							break;

					}

					// HiveParser.g:752:10: ( tableRowFormat )?
					int alt29=2;
					int LA29_0 = input.LA(1);
					if ( (LA29_0==KW_ROW) ) {
						alt29=1;
					}
					switch (alt29) {
						case 1 :
							// HiveParser.g:752:10: tableRowFormat
							{
							pushFollow(FOLLOW_tableRowFormat_in_createTableStatement2357);
							tableRowFormat103=tableRowFormat();
							state._fsp--;

							stream_tableRowFormat.add(tableRowFormat103.getTree());
							}
							break;

					}

					// HiveParser.g:753:10: ( tableFileFormat )?
					int alt30=2;
					int LA30_0 = input.LA(1);
					if ( (LA30_0==KW_STORED) ) {
						alt30=1;
					}
					switch (alt30) {
						case 1 :
							// HiveParser.g:753:10: tableFileFormat
							{
							pushFollow(FOLLOW_tableFileFormat_in_createTableStatement2369);
							tableFileFormat104=tableFileFormat();
							state._fsp--;

							stream_tableFileFormat.add(tableFileFormat104.getTree());
							}
							break;

					}

					// HiveParser.g:754:10: ( tableLocation )?
					int alt31=2;
					int LA31_0 = input.LA(1);
					if ( (LA31_0==KW_LOCATION) ) {
						alt31=1;
					}
					switch (alt31) {
						case 1 :
							// HiveParser.g:754:10: tableLocation
							{
							pushFollow(FOLLOW_tableLocation_in_createTableStatement2381);
							tableLocation105=tableLocation();
							state._fsp--;

							stream_tableLocation.add(tableLocation105.getTree());
							}
							break;

					}

					// HiveParser.g:755:10: ( tablePropertiesPrefixed )?
					int alt32=2;
					int LA32_0 = input.LA(1);
					if ( (LA32_0==KW_TBLPROPERTIES) ) {
						alt32=1;
					}
					switch (alt32) {
						case 1 :
							// HiveParser.g:755:10: tablePropertiesPrefixed
							{
							pushFollow(FOLLOW_tablePropertiesPrefixed_in_createTableStatement2393);
							tablePropertiesPrefixed106=tablePropertiesPrefixed();
							state._fsp--;

							stream_tablePropertiesPrefixed.add(tablePropertiesPrefixed106.getTree());
							}
							break;

					}

					// HiveParser.g:756:10: ( KW_AS selectStatement )?
					int alt33=2;
					int LA33_0 = input.LA(1);
					if ( (LA33_0==KW_AS) ) {
						alt33=1;
					}
					switch (alt33) {
						case 1 :
							// HiveParser.g:756:11: KW_AS selectStatement
							{
							KW_AS107=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_createTableStatement2406);  
							stream_KW_AS.add(KW_AS107);

							pushFollow(FOLLOW_selectStatement_in_createTableStatement2408);
							selectStatement108=selectStatement();
							state._fsp--;

							stream_selectStatement.add(selectStatement108.getTree());
							}
							break;

					}

					}
					break;

			}

			// AST REWRITE
			// elements: tablePropertiesPrefixed, tableFileFormat, tableLocation, tablePartition, tableComment, selectStatement, columnNameTypeList, tableRowFormat, tableBuckets, ext, likeName, ifNotExists, name, tableSkewed
			// token labels: ext
			// rule labels: retval, name, likeName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_ext=new RewriteRuleTokenStream(adaptor,"token ext",ext);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);
			RewriteRuleSubtreeStream stream_likeName=new RewriteRuleSubtreeStream(adaptor,"rule likeName",likeName!=null?likeName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 758:5: -> ^( TOK_CREATETABLE $name ( $ext)? ( ifNotExists )? ^( TOK_LIKETABLE ( $likeName)? ) ( columnNameTypeList )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( selectStatement )? )
			{
				// HiveParser.g:758:8: ^( TOK_CREATETABLE $name ( $ext)? ( ifNotExists )? ^( TOK_LIKETABLE ( $likeName)? ) ( columnNameTypeList )? ( tableComment )? ( tablePartition )? ( tableBuckets )? ( tableSkewed )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( selectStatement )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATETABLE, "TOK_CREATETABLE"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				// HiveParser.g:758:33: ( $ext)?
				if ( stream_ext.hasNext() ) {
					adaptor.addChild(root_1, stream_ext.nextNode());
				}
				stream_ext.reset();

				// HiveParser.g:758:38: ( ifNotExists )?
				if ( stream_ifNotExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifNotExists.nextTree());
				}
				stream_ifNotExists.reset();

				// HiveParser.g:759:10: ^( TOK_LIKETABLE ( $likeName)? )
				{
				CommonTree root_2 = (CommonTree)adaptor.nil();
				root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LIKETABLE, "TOK_LIKETABLE"), root_2);
				// HiveParser.g:759:27: ( $likeName)?
				if ( stream_likeName.hasNext() ) {
					adaptor.addChild(root_2, stream_likeName.nextTree());
				}
				stream_likeName.reset();

				adaptor.addChild(root_1, root_2);
				}

				// HiveParser.g:760:10: ( columnNameTypeList )?
				if ( stream_columnNameTypeList.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameTypeList.nextTree());
				}
				stream_columnNameTypeList.reset();

				// HiveParser.g:761:10: ( tableComment )?
				if ( stream_tableComment.hasNext() ) {
					adaptor.addChild(root_1, stream_tableComment.nextTree());
				}
				stream_tableComment.reset();

				// HiveParser.g:762:10: ( tablePartition )?
				if ( stream_tablePartition.hasNext() ) {
					adaptor.addChild(root_1, stream_tablePartition.nextTree());
				}
				stream_tablePartition.reset();

				// HiveParser.g:763:10: ( tableBuckets )?
				if ( stream_tableBuckets.hasNext() ) {
					adaptor.addChild(root_1, stream_tableBuckets.nextTree());
				}
				stream_tableBuckets.reset();

				// HiveParser.g:764:10: ( tableSkewed )?
				if ( stream_tableSkewed.hasNext() ) {
					adaptor.addChild(root_1, stream_tableSkewed.nextTree());
				}
				stream_tableSkewed.reset();

				// HiveParser.g:765:10: ( tableRowFormat )?
				if ( stream_tableRowFormat.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormat.nextTree());
				}
				stream_tableRowFormat.reset();

				// HiveParser.g:766:10: ( tableFileFormat )?
				if ( stream_tableFileFormat.hasNext() ) {
					adaptor.addChild(root_1, stream_tableFileFormat.nextTree());
				}
				stream_tableFileFormat.reset();

				// HiveParser.g:767:10: ( tableLocation )?
				if ( stream_tableLocation.hasNext() ) {
					adaptor.addChild(root_1, stream_tableLocation.nextTree());
				}
				stream_tableLocation.reset();

				// HiveParser.g:768:10: ( tablePropertiesPrefixed )?
				if ( stream_tablePropertiesPrefixed.hasNext() ) {
					adaptor.addChild(root_1, stream_tablePropertiesPrefixed.nextTree());
				}
				stream_tablePropertiesPrefixed.reset();

				// HiveParser.g:769:10: ( selectStatement )?
				if ( stream_selectStatement.hasNext() ) {
					adaptor.addChild(root_1, stream_selectStatement.nextTree());
				}
				stream_selectStatement.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createTableStatement"


	public static class truncateTableStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "truncateTableStatement"
	// HiveParser.g:773:1: truncateTableStatement : KW_TRUNCATE KW_TABLE tablePartitionPrefix ( KW_COLUMNS LPAREN columnNameList RPAREN )? -> ^( TOK_TRUNCATETABLE tablePartitionPrefix ( columnNameList )? ) ;
	public final HiveParser.truncateTableStatement_return truncateTableStatement() throws RecognitionException {
		HiveParser.truncateTableStatement_return retval = new HiveParser.truncateTableStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_TRUNCATE109=null;
		Token KW_TABLE110=null;
		Token KW_COLUMNS112=null;
		Token LPAREN113=null;
		Token RPAREN115=null;
		ParserRuleReturnScope tablePartitionPrefix111 =null;
		ParserRuleReturnScope columnNameList114 =null;

		CommonTree KW_TRUNCATE109_tree=null;
		CommonTree KW_TABLE110_tree=null;
		CommonTree KW_COLUMNS112_tree=null;
		CommonTree LPAREN113_tree=null;
		CommonTree RPAREN115_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_COLUMNS=new RewriteRuleTokenStream(adaptor,"token KW_COLUMNS");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_TRUNCATE=new RewriteRuleTokenStream(adaptor,"token KW_TRUNCATE");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");
		RewriteRuleSubtreeStream stream_tablePartitionPrefix=new RewriteRuleSubtreeStream(adaptor,"rule tablePartitionPrefix");

		 msgs.push("truncate table statement"); 
		try {
			// HiveParser.g:776:5: ( KW_TRUNCATE KW_TABLE tablePartitionPrefix ( KW_COLUMNS LPAREN columnNameList RPAREN )? -> ^( TOK_TRUNCATETABLE tablePartitionPrefix ( columnNameList )? ) )
			// HiveParser.g:776:7: KW_TRUNCATE KW_TABLE tablePartitionPrefix ( KW_COLUMNS LPAREN columnNameList RPAREN )?
			{
			KW_TRUNCATE109=(Token)match(input,KW_TRUNCATE,FOLLOW_KW_TRUNCATE_in_truncateTableStatement2611);  
			stream_KW_TRUNCATE.add(KW_TRUNCATE109);

			KW_TABLE110=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_truncateTableStatement2613);  
			stream_KW_TABLE.add(KW_TABLE110);

			pushFollow(FOLLOW_tablePartitionPrefix_in_truncateTableStatement2615);
			tablePartitionPrefix111=tablePartitionPrefix();
			state._fsp--;

			stream_tablePartitionPrefix.add(tablePartitionPrefix111.getTree());
			// HiveParser.g:776:49: ( KW_COLUMNS LPAREN columnNameList RPAREN )?
			int alt35=2;
			int LA35_0 = input.LA(1);
			if ( (LA35_0==KW_COLUMNS) ) {
				alt35=1;
			}
			switch (alt35) {
				case 1 :
					// HiveParser.g:776:50: KW_COLUMNS LPAREN columnNameList RPAREN
					{
					KW_COLUMNS112=(Token)match(input,KW_COLUMNS,FOLLOW_KW_COLUMNS_in_truncateTableStatement2618);  
					stream_KW_COLUMNS.add(KW_COLUMNS112);

					LPAREN113=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_truncateTableStatement2620);  
					stream_LPAREN.add(LPAREN113);

					pushFollow(FOLLOW_columnNameList_in_truncateTableStatement2622);
					columnNameList114=columnNameList();
					state._fsp--;

					stream_columnNameList.add(columnNameList114.getTree());
					RPAREN115=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_truncateTableStatement2624);  
					stream_RPAREN.add(RPAREN115);

					}
					break;

			}

			// AST REWRITE
			// elements: columnNameList, tablePartitionPrefix
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 776:92: -> ^( TOK_TRUNCATETABLE tablePartitionPrefix ( columnNameList )? )
			{
				// HiveParser.g:776:95: ^( TOK_TRUNCATETABLE tablePartitionPrefix ( columnNameList )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TRUNCATETABLE, "TOK_TRUNCATETABLE"), root_1);
				adaptor.addChild(root_1, stream_tablePartitionPrefix.nextTree());
				// HiveParser.g:776:136: ( columnNameList )?
				if ( stream_columnNameList.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameList.nextTree());
				}
				stream_columnNameList.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "truncateTableStatement"


	public static class createIndexStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createIndexStatement"
	// HiveParser.g:778:1: createIndexStatement : KW_CREATE KW_INDEX indexName= identifier KW_ON KW_TABLE tab= tableName LPAREN indexedCols= columnNameList RPAREN KW_AS typeName= StringLiteral ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? -> ^( TOK_CREATEINDEX $indexName $typeName $tab $indexedCols ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? ) ;
	public final HiveParser.createIndexStatement_return createIndexStatement() throws RecognitionException {
		HiveParser.createIndexStatement_return retval = new HiveParser.createIndexStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token typeName=null;
		Token KW_CREATE116=null;
		Token KW_INDEX117=null;
		Token KW_ON118=null;
		Token KW_TABLE119=null;
		Token LPAREN120=null;
		Token RPAREN121=null;
		Token KW_AS122=null;
		ParserRuleReturnScope indexName =null;
		ParserRuleReturnScope tab =null;
		ParserRuleReturnScope indexedCols =null;
		ParserRuleReturnScope autoRebuild123 =null;
		ParserRuleReturnScope indexPropertiesPrefixed124 =null;
		ParserRuleReturnScope indexTblName125 =null;
		ParserRuleReturnScope tableRowFormat126 =null;
		ParserRuleReturnScope tableFileFormat127 =null;
		ParserRuleReturnScope tableLocation128 =null;
		ParserRuleReturnScope tablePropertiesPrefixed129 =null;
		ParserRuleReturnScope indexComment130 =null;

		CommonTree typeName_tree=null;
		CommonTree KW_CREATE116_tree=null;
		CommonTree KW_INDEX117_tree=null;
		CommonTree KW_ON118_tree=null;
		CommonTree KW_TABLE119_tree=null;
		CommonTree LPAREN120_tree=null;
		CommonTree RPAREN121_tree=null;
		CommonTree KW_AS122_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_INDEX=new RewriteRuleTokenStream(adaptor,"token KW_INDEX");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_indexPropertiesPrefixed=new RewriteRuleSubtreeStream(adaptor,"rule indexPropertiesPrefixed");
		RewriteRuleSubtreeStream stream_tableRowFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormat");
		RewriteRuleSubtreeStream stream_tableFileFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableFileFormat");
		RewriteRuleSubtreeStream stream_tablePropertiesPrefixed=new RewriteRuleSubtreeStream(adaptor,"rule tablePropertiesPrefixed");
		RewriteRuleSubtreeStream stream_autoRebuild=new RewriteRuleSubtreeStream(adaptor,"rule autoRebuild");
		RewriteRuleSubtreeStream stream_tableLocation=new RewriteRuleSubtreeStream(adaptor,"rule tableLocation");
		RewriteRuleSubtreeStream stream_indexTblName=new RewriteRuleSubtreeStream(adaptor,"rule indexTblName");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");
		RewriteRuleSubtreeStream stream_indexComment=new RewriteRuleSubtreeStream(adaptor,"rule indexComment");

		 msgs.push("create index statement");
		try {
			// HiveParser.g:781:5: ( KW_CREATE KW_INDEX indexName= identifier KW_ON KW_TABLE tab= tableName LPAREN indexedCols= columnNameList RPAREN KW_AS typeName= StringLiteral ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? -> ^( TOK_CREATEINDEX $indexName $typeName $tab $indexedCols ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? ) )
			// HiveParser.g:781:7: KW_CREATE KW_INDEX indexName= identifier KW_ON KW_TABLE tab= tableName LPAREN indexedCols= columnNameList RPAREN KW_AS typeName= StringLiteral ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )?
			{
			KW_CREATE116=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createIndexStatement2659);  
			stream_KW_CREATE.add(KW_CREATE116);

			KW_INDEX117=(Token)match(input,KW_INDEX,FOLLOW_KW_INDEX_in_createIndexStatement2661);  
			stream_KW_INDEX.add(KW_INDEX117);

			pushFollow(FOLLOW_identifier_in_createIndexStatement2665);
			indexName=identifier();
			state._fsp--;

			stream_identifier.add(indexName.getTree());
			KW_ON118=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_createIndexStatement2673);  
			stream_KW_ON.add(KW_ON118);

			KW_TABLE119=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_createIndexStatement2675);  
			stream_KW_TABLE.add(KW_TABLE119);

			pushFollow(FOLLOW_tableName_in_createIndexStatement2679);
			tab=tableName();
			state._fsp--;

			stream_tableName.add(tab.getTree());
			LPAREN120=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createIndexStatement2681);  
			stream_LPAREN.add(LPAREN120);

			pushFollow(FOLLOW_columnNameList_in_createIndexStatement2685);
			indexedCols=columnNameList();
			state._fsp--;

			stream_columnNameList.add(indexedCols.getTree());
			RPAREN121=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createIndexStatement2687);  
			stream_RPAREN.add(RPAREN121);

			KW_AS122=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_createIndexStatement2695);  
			stream_KW_AS.add(KW_AS122);

			typeName=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_createIndexStatement2699);  
			stream_StringLiteral.add(typeName);

			// HiveParser.g:784:7: ( autoRebuild )?
			int alt36=2;
			int LA36_0 = input.LA(1);
			if ( (LA36_0==KW_WITH) ) {
				alt36=1;
			}
			switch (alt36) {
				case 1 :
					// HiveParser.g:784:7: autoRebuild
					{
					pushFollow(FOLLOW_autoRebuild_in_createIndexStatement2707);
					autoRebuild123=autoRebuild();
					state._fsp--;

					stream_autoRebuild.add(autoRebuild123.getTree());
					}
					break;

			}

			// HiveParser.g:785:7: ( indexPropertiesPrefixed )?
			int alt37=2;
			int LA37_0 = input.LA(1);
			if ( (LA37_0==KW_IDXPROPERTIES) ) {
				alt37=1;
			}
			switch (alt37) {
				case 1 :
					// HiveParser.g:785:7: indexPropertiesPrefixed
					{
					pushFollow(FOLLOW_indexPropertiesPrefixed_in_createIndexStatement2716);
					indexPropertiesPrefixed124=indexPropertiesPrefixed();
					state._fsp--;

					stream_indexPropertiesPrefixed.add(indexPropertiesPrefixed124.getTree());
					}
					break;

			}

			// HiveParser.g:786:7: ( indexTblName )?
			int alt38=2;
			int LA38_0 = input.LA(1);
			if ( (LA38_0==KW_IN) ) {
				alt38=1;
			}
			switch (alt38) {
				case 1 :
					// HiveParser.g:786:7: indexTblName
					{
					pushFollow(FOLLOW_indexTblName_in_createIndexStatement2725);
					indexTblName125=indexTblName();
					state._fsp--;

					stream_indexTblName.add(indexTblName125.getTree());
					}
					break;

			}

			// HiveParser.g:787:7: ( tableRowFormat )?
			int alt39=2;
			int LA39_0 = input.LA(1);
			if ( (LA39_0==KW_ROW) ) {
				alt39=1;
			}
			switch (alt39) {
				case 1 :
					// HiveParser.g:787:7: tableRowFormat
					{
					pushFollow(FOLLOW_tableRowFormat_in_createIndexStatement2734);
					tableRowFormat126=tableRowFormat();
					state._fsp--;

					stream_tableRowFormat.add(tableRowFormat126.getTree());
					}
					break;

			}

			// HiveParser.g:788:7: ( tableFileFormat )?
			int alt40=2;
			int LA40_0 = input.LA(1);
			if ( (LA40_0==KW_STORED) ) {
				alt40=1;
			}
			switch (alt40) {
				case 1 :
					// HiveParser.g:788:7: tableFileFormat
					{
					pushFollow(FOLLOW_tableFileFormat_in_createIndexStatement2743);
					tableFileFormat127=tableFileFormat();
					state._fsp--;

					stream_tableFileFormat.add(tableFileFormat127.getTree());
					}
					break;

			}

			// HiveParser.g:789:7: ( tableLocation )?
			int alt41=2;
			int LA41_0 = input.LA(1);
			if ( (LA41_0==KW_LOCATION) ) {
				alt41=1;
			}
			switch (alt41) {
				case 1 :
					// HiveParser.g:789:7: tableLocation
					{
					pushFollow(FOLLOW_tableLocation_in_createIndexStatement2752);
					tableLocation128=tableLocation();
					state._fsp--;

					stream_tableLocation.add(tableLocation128.getTree());
					}
					break;

			}

			// HiveParser.g:790:7: ( tablePropertiesPrefixed )?
			int alt42=2;
			int LA42_0 = input.LA(1);
			if ( (LA42_0==KW_TBLPROPERTIES) ) {
				alt42=1;
			}
			switch (alt42) {
				case 1 :
					// HiveParser.g:790:7: tablePropertiesPrefixed
					{
					pushFollow(FOLLOW_tablePropertiesPrefixed_in_createIndexStatement2761);
					tablePropertiesPrefixed129=tablePropertiesPrefixed();
					state._fsp--;

					stream_tablePropertiesPrefixed.add(tablePropertiesPrefixed129.getTree());
					}
					break;

			}

			// HiveParser.g:791:7: ( indexComment )?
			int alt43=2;
			int LA43_0 = input.LA(1);
			if ( (LA43_0==KW_COMMENT) ) {
				alt43=1;
			}
			switch (alt43) {
				case 1 :
					// HiveParser.g:791:7: indexComment
					{
					pushFollow(FOLLOW_indexComment_in_createIndexStatement2770);
					indexComment130=indexComment();
					state._fsp--;

					stream_indexComment.add(indexComment130.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: tableLocation, tableRowFormat, indexPropertiesPrefixed, indexTblName, typeName, indexComment, tableFileFormat, indexName, tab, tablePropertiesPrefixed, autoRebuild, indexedCols
			// token labels: typeName
			// rule labels: indexedCols, retval, indexName, tab
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_typeName=new RewriteRuleTokenStream(adaptor,"token typeName",typeName);
			RewriteRuleSubtreeStream stream_indexedCols=new RewriteRuleSubtreeStream(adaptor,"rule indexedCols",indexedCols!=null?indexedCols.getTree():null);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_indexName=new RewriteRuleSubtreeStream(adaptor,"rule indexName",indexName!=null?indexName.getTree():null);
			RewriteRuleSubtreeStream stream_tab=new RewriteRuleSubtreeStream(adaptor,"rule tab",tab!=null?tab.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 792:5: -> ^( TOK_CREATEINDEX $indexName $typeName $tab $indexedCols ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? )
			{
				// HiveParser.g:792:7: ^( TOK_CREATEINDEX $indexName $typeName $tab $indexedCols ( autoRebuild )? ( indexPropertiesPrefixed )? ( indexTblName )? ( tableRowFormat )? ( tableFileFormat )? ( tableLocation )? ( tablePropertiesPrefixed )? ( indexComment )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEINDEX, "TOK_CREATEINDEX"), root_1);
				adaptor.addChild(root_1, stream_indexName.nextTree());
				adaptor.addChild(root_1, stream_typeName.nextNode());
				adaptor.addChild(root_1, stream_tab.nextTree());
				adaptor.addChild(root_1, stream_indexedCols.nextTree());
				// HiveParser.g:793:9: ( autoRebuild )?
				if ( stream_autoRebuild.hasNext() ) {
					adaptor.addChild(root_1, stream_autoRebuild.nextTree());
				}
				stream_autoRebuild.reset();

				// HiveParser.g:794:9: ( indexPropertiesPrefixed )?
				if ( stream_indexPropertiesPrefixed.hasNext() ) {
					adaptor.addChild(root_1, stream_indexPropertiesPrefixed.nextTree());
				}
				stream_indexPropertiesPrefixed.reset();

				// HiveParser.g:795:9: ( indexTblName )?
				if ( stream_indexTblName.hasNext() ) {
					adaptor.addChild(root_1, stream_indexTblName.nextTree());
				}
				stream_indexTblName.reset();

				// HiveParser.g:796:9: ( tableRowFormat )?
				if ( stream_tableRowFormat.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormat.nextTree());
				}
				stream_tableRowFormat.reset();

				// HiveParser.g:797:9: ( tableFileFormat )?
				if ( stream_tableFileFormat.hasNext() ) {
					adaptor.addChild(root_1, stream_tableFileFormat.nextTree());
				}
				stream_tableFileFormat.reset();

				// HiveParser.g:798:9: ( tableLocation )?
				if ( stream_tableLocation.hasNext() ) {
					adaptor.addChild(root_1, stream_tableLocation.nextTree());
				}
				stream_tableLocation.reset();

				// HiveParser.g:799:9: ( tablePropertiesPrefixed )?
				if ( stream_tablePropertiesPrefixed.hasNext() ) {
					adaptor.addChild(root_1, stream_tablePropertiesPrefixed.nextTree());
				}
				stream_tablePropertiesPrefixed.reset();

				// HiveParser.g:800:9: ( indexComment )?
				if ( stream_indexComment.hasNext() ) {
					adaptor.addChild(root_1, stream_indexComment.nextTree());
				}
				stream_indexComment.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createIndexStatement"


	public static class indexComment_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "indexComment"
	// HiveParser.g:803:1: indexComment : KW_COMMENT comment= StringLiteral -> ^( TOK_INDEXCOMMENT $comment) ;
	public final HiveParser.indexComment_return indexComment() throws RecognitionException {
		HiveParser.indexComment_return retval = new HiveParser.indexComment_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_COMMENT131=null;

		CommonTree comment_tree=null;
		CommonTree KW_COMMENT131_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");

		 msgs.push("comment on an index");
		try {
			// HiveParser.g:806:9: ( KW_COMMENT comment= StringLiteral -> ^( TOK_INDEXCOMMENT $comment) )
			// HiveParser.g:807:17: KW_COMMENT comment= StringLiteral
			{
			KW_COMMENT131=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_indexComment2927);  
			stream_KW_COMMENT.add(KW_COMMENT131);

			comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_indexComment2931);  
			stream_StringLiteral.add(comment);

			// AST REWRITE
			// elements: comment
			// token labels: comment
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 807:51: -> ^( TOK_INDEXCOMMENT $comment)
			{
				// HiveParser.g:807:54: ^( TOK_INDEXCOMMENT $comment)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INDEXCOMMENT, "TOK_INDEXCOMMENT"), root_1);
				adaptor.addChild(root_1, stream_comment.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "indexComment"


	public static class autoRebuild_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "autoRebuild"
	// HiveParser.g:810:1: autoRebuild : KW_WITH KW_DEFERRED KW_REBUILD -> ^( TOK_DEFERRED_REBUILDINDEX ) ;
	public final HiveParser.autoRebuild_return autoRebuild() throws RecognitionException {
		HiveParser.autoRebuild_return retval = new HiveParser.autoRebuild_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_WITH132=null;
		Token KW_DEFERRED133=null;
		Token KW_REBUILD134=null;

		CommonTree KW_WITH132_tree=null;
		CommonTree KW_DEFERRED133_tree=null;
		CommonTree KW_REBUILD134_tree=null;
		RewriteRuleTokenStream stream_KW_REBUILD=new RewriteRuleTokenStream(adaptor,"token KW_REBUILD");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_DEFERRED=new RewriteRuleTokenStream(adaptor,"token KW_DEFERRED");

		 msgs.push("auto rebuild index");
		try {
			// HiveParser.g:813:5: ( KW_WITH KW_DEFERRED KW_REBUILD -> ^( TOK_DEFERRED_REBUILDINDEX ) )
			// HiveParser.g:813:7: KW_WITH KW_DEFERRED KW_REBUILD
			{
			KW_WITH132=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_autoRebuild2972);  
			stream_KW_WITH.add(KW_WITH132);

			KW_DEFERRED133=(Token)match(input,KW_DEFERRED,FOLLOW_KW_DEFERRED_in_autoRebuild2974);  
			stream_KW_DEFERRED.add(KW_DEFERRED133);

			KW_REBUILD134=(Token)match(input,KW_REBUILD,FOLLOW_KW_REBUILD_in_autoRebuild2976);  
			stream_KW_REBUILD.add(KW_REBUILD134);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 814:5: -> ^( TOK_DEFERRED_REBUILDINDEX )
			{
				// HiveParser.g:814:7: ^( TOK_DEFERRED_REBUILDINDEX )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DEFERRED_REBUILDINDEX, "TOK_DEFERRED_REBUILDINDEX"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "autoRebuild"


	public static class indexTblName_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "indexTblName"
	// HiveParser.g:817:1: indexTblName : KW_IN KW_TABLE indexTbl= tableName -> ^( TOK_CREATEINDEX_INDEXTBLNAME $indexTbl) ;
	public final HiveParser.indexTblName_return indexTblName() throws RecognitionException {
		HiveParser.indexTblName_return retval = new HiveParser.indexTblName_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_IN135=null;
		Token KW_TABLE136=null;
		ParserRuleReturnScope indexTbl =null;

		CommonTree KW_IN135_tree=null;
		CommonTree KW_TABLE136_tree=null;
		RewriteRuleTokenStream stream_KW_IN=new RewriteRuleTokenStream(adaptor,"token KW_IN");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");

		 msgs.push("index table name");
		try {
			// HiveParser.g:820:5: ( KW_IN KW_TABLE indexTbl= tableName -> ^( TOK_CREATEINDEX_INDEXTBLNAME $indexTbl) )
			// HiveParser.g:820:7: KW_IN KW_TABLE indexTbl= tableName
			{
			KW_IN135=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_indexTblName3012);  
			stream_KW_IN.add(KW_IN135);

			KW_TABLE136=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_indexTblName3014);  
			stream_KW_TABLE.add(KW_TABLE136);

			pushFollow(FOLLOW_tableName_in_indexTblName3018);
			indexTbl=tableName();
			state._fsp--;

			stream_tableName.add(indexTbl.getTree());
			// AST REWRITE
			// elements: indexTbl
			// token labels: 
			// rule labels: retval, indexTbl
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_indexTbl=new RewriteRuleSubtreeStream(adaptor,"rule indexTbl",indexTbl!=null?indexTbl.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 821:5: -> ^( TOK_CREATEINDEX_INDEXTBLNAME $indexTbl)
			{
				// HiveParser.g:821:7: ^( TOK_CREATEINDEX_INDEXTBLNAME $indexTbl)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEINDEX_INDEXTBLNAME, "TOK_CREATEINDEX_INDEXTBLNAME"), root_1);
				adaptor.addChild(root_1, stream_indexTbl.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "indexTblName"


	public static class indexPropertiesPrefixed_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "indexPropertiesPrefixed"
	// HiveParser.g:824:1: indexPropertiesPrefixed : KW_IDXPROPERTIES ! indexProperties ;
	public final HiveParser.indexPropertiesPrefixed_return indexPropertiesPrefixed() throws RecognitionException {
		HiveParser.indexPropertiesPrefixed_return retval = new HiveParser.indexPropertiesPrefixed_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_IDXPROPERTIES137=null;
		ParserRuleReturnScope indexProperties138 =null;

		CommonTree KW_IDXPROPERTIES137_tree=null;

		 msgs.push("table properties with prefix"); 
		try {
			// HiveParser.g:827:5: ( KW_IDXPROPERTIES ! indexProperties )
			// HiveParser.g:828:9: KW_IDXPROPERTIES ! indexProperties
			{
			root_0 = (CommonTree)adaptor.nil();


			KW_IDXPROPERTIES137=(Token)match(input,KW_IDXPROPERTIES,FOLLOW_KW_IDXPROPERTIES_in_indexPropertiesPrefixed3065); 
			pushFollow(FOLLOW_indexProperties_in_indexPropertiesPrefixed3068);
			indexProperties138=indexProperties();
			state._fsp--;

			adaptor.addChild(root_0, indexProperties138.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "indexPropertiesPrefixed"


	public static class indexProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "indexProperties"
	// HiveParser.g:831:1: indexProperties : LPAREN indexPropertiesList RPAREN -> ^( TOK_INDEXPROPERTIES indexPropertiesList ) ;
	public final HiveParser.indexProperties_return indexProperties() throws RecognitionException {
		HiveParser.indexProperties_return retval = new HiveParser.indexProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN139=null;
		Token RPAREN141=null;
		ParserRuleReturnScope indexPropertiesList140 =null;

		CommonTree LPAREN139_tree=null;
		CommonTree RPAREN141_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_indexPropertiesList=new RewriteRuleSubtreeStream(adaptor,"rule indexPropertiesList");

		 msgs.push("index properties"); 
		try {
			// HiveParser.g:834:5: ( LPAREN indexPropertiesList RPAREN -> ^( TOK_INDEXPROPERTIES indexPropertiesList ) )
			// HiveParser.g:835:7: LPAREN indexPropertiesList RPAREN
			{
			LPAREN139=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_indexProperties3101);  
			stream_LPAREN.add(LPAREN139);

			pushFollow(FOLLOW_indexPropertiesList_in_indexProperties3103);
			indexPropertiesList140=indexPropertiesList();
			state._fsp--;

			stream_indexPropertiesList.add(indexPropertiesList140.getTree());
			RPAREN141=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_indexProperties3105);  
			stream_RPAREN.add(RPAREN141);

			// AST REWRITE
			// elements: indexPropertiesList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 835:41: -> ^( TOK_INDEXPROPERTIES indexPropertiesList )
			{
				// HiveParser.g:835:44: ^( TOK_INDEXPROPERTIES indexPropertiesList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INDEXPROPERTIES, "TOK_INDEXPROPERTIES"), root_1);
				adaptor.addChild(root_1, stream_indexPropertiesList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "indexProperties"


	public static class indexPropertiesList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "indexPropertiesList"
	// HiveParser.g:838:1: indexPropertiesList : keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_INDEXPROPLIST ( keyValueProperty )+ ) ;
	public final HiveParser.indexPropertiesList_return indexPropertiesList() throws RecognitionException {
		HiveParser.indexPropertiesList_return retval = new HiveParser.indexPropertiesList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA143=null;
		ParserRuleReturnScope keyValueProperty142 =null;
		ParserRuleReturnScope keyValueProperty144 =null;

		CommonTree COMMA143_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_keyValueProperty=new RewriteRuleSubtreeStream(adaptor,"rule keyValueProperty");

		 msgs.push("index properties list"); 
		try {
			// HiveParser.g:841:5: ( keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_INDEXPROPLIST ( keyValueProperty )+ ) )
			// HiveParser.g:842:7: keyValueProperty ( COMMA keyValueProperty )*
			{
			pushFollow(FOLLOW_keyValueProperty_in_indexPropertiesList3146);
			keyValueProperty142=keyValueProperty();
			state._fsp--;

			stream_keyValueProperty.add(keyValueProperty142.getTree());
			// HiveParser.g:842:24: ( COMMA keyValueProperty )*
			loop44:
			while (true) {
				int alt44=2;
				int LA44_0 = input.LA(1);
				if ( (LA44_0==COMMA) ) {
					alt44=1;
				}

				switch (alt44) {
				case 1 :
					// HiveParser.g:842:25: COMMA keyValueProperty
					{
					COMMA143=(Token)match(input,COMMA,FOLLOW_COMMA_in_indexPropertiesList3149);  
					stream_COMMA.add(COMMA143);

					pushFollow(FOLLOW_keyValueProperty_in_indexPropertiesList3151);
					keyValueProperty144=keyValueProperty();
					state._fsp--;

					stream_keyValueProperty.add(keyValueProperty144.getTree());
					}
					break;

				default :
					break loop44;
				}
			}

			// AST REWRITE
			// elements: keyValueProperty
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 842:50: -> ^( TOK_INDEXPROPLIST ( keyValueProperty )+ )
			{
				// HiveParser.g:842:53: ^( TOK_INDEXPROPLIST ( keyValueProperty )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INDEXPROPLIST, "TOK_INDEXPROPLIST"), root_1);
				if ( !(stream_keyValueProperty.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_keyValueProperty.hasNext() ) {
					adaptor.addChild(root_1, stream_keyValueProperty.nextTree());
				}
				stream_keyValueProperty.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "indexPropertiesList"


	public static class dropIndexStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropIndexStatement"
	// HiveParser.g:845:1: dropIndexStatement : KW_DROP KW_INDEX ( ifExists )? indexName= identifier KW_ON tab= tableName -> ^( TOK_DROPINDEX $indexName $tab ( ifExists )? ) ;
	public final HiveParser.dropIndexStatement_return dropIndexStatement() throws RecognitionException {
		HiveParser.dropIndexStatement_return retval = new HiveParser.dropIndexStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP145=null;
		Token KW_INDEX146=null;
		Token KW_ON148=null;
		ParserRuleReturnScope indexName =null;
		ParserRuleReturnScope tab =null;
		ParserRuleReturnScope ifExists147 =null;

		CommonTree KW_DROP145_tree=null;
		CommonTree KW_INDEX146_tree=null;
		CommonTree KW_ON148_tree=null;
		RewriteRuleTokenStream stream_KW_INDEX=new RewriteRuleTokenStream(adaptor,"token KW_INDEX");
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("drop index statement");
		try {
			// HiveParser.g:848:5: ( KW_DROP KW_INDEX ( ifExists )? indexName= identifier KW_ON tab= tableName -> ^( TOK_DROPINDEX $indexName $tab ( ifExists )? ) )
			// HiveParser.g:848:7: KW_DROP KW_INDEX ( ifExists )? indexName= identifier KW_ON tab= tableName
			{
			KW_DROP145=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropIndexStatement3189);  
			stream_KW_DROP.add(KW_DROP145);

			KW_INDEX146=(Token)match(input,KW_INDEX,FOLLOW_KW_INDEX_in_dropIndexStatement3191);  
			stream_KW_INDEX.add(KW_INDEX146);

			// HiveParser.g:848:24: ( ifExists )?
			int alt45=2;
			int LA45_0 = input.LA(1);
			if ( (LA45_0==KW_IF) ) {
				alt45=1;
			}
			switch (alt45) {
				case 1 :
					// HiveParser.g:848:24: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropIndexStatement3193);
					ifExists147=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists147.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_dropIndexStatement3198);
			indexName=identifier();
			state._fsp--;

			stream_identifier.add(indexName.getTree());
			KW_ON148=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_dropIndexStatement3200);  
			stream_KW_ON.add(KW_ON148);

			pushFollow(FOLLOW_tableName_in_dropIndexStatement3204);
			tab=tableName();
			state._fsp--;

			stream_tableName.add(tab.getTree());
			// AST REWRITE
			// elements: ifExists, tab, indexName
			// token labels: 
			// rule labels: retval, indexName, tab
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_indexName=new RewriteRuleSubtreeStream(adaptor,"rule indexName",indexName!=null?indexName.getTree():null);
			RewriteRuleSubtreeStream stream_tab=new RewriteRuleSubtreeStream(adaptor,"rule tab",tab!=null?tab.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 849:5: -> ^( TOK_DROPINDEX $indexName $tab ( ifExists )? )
			{
				// HiveParser.g:849:7: ^( TOK_DROPINDEX $indexName $tab ( ifExists )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPINDEX, "TOK_DROPINDEX"), root_1);
				adaptor.addChild(root_1, stream_indexName.nextTree());
				adaptor.addChild(root_1, stream_tab.nextTree());
				// HiveParser.g:849:39: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropIndexStatement"


	public static class dropTableStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropTableStatement"
	// HiveParser.g:852:1: dropTableStatement : KW_DROP KW_TABLE ( ifExists )? tableName -> ^( TOK_DROPTABLE tableName ( ifExists )? ) ;
	public final HiveParser.dropTableStatement_return dropTableStatement() throws RecognitionException {
		HiveParser.dropTableStatement_return retval = new HiveParser.dropTableStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP149=null;
		Token KW_TABLE150=null;
		ParserRuleReturnScope ifExists151 =null;
		ParserRuleReturnScope tableName152 =null;

		CommonTree KW_DROP149_tree=null;
		CommonTree KW_TABLE150_tree=null;
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");

		 msgs.push("drop statement"); 
		try {
			// HiveParser.g:855:5: ( KW_DROP KW_TABLE ( ifExists )? tableName -> ^( TOK_DROPTABLE tableName ( ifExists )? ) )
			// HiveParser.g:855:7: KW_DROP KW_TABLE ( ifExists )? tableName
			{
			KW_DROP149=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropTableStatement3249);  
			stream_KW_DROP.add(KW_DROP149);

			KW_TABLE150=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_dropTableStatement3251);  
			stream_KW_TABLE.add(KW_TABLE150);

			// HiveParser.g:855:24: ( ifExists )?
			int alt46=2;
			int LA46_0 = input.LA(1);
			if ( (LA46_0==KW_IF) ) {
				alt46=1;
			}
			switch (alt46) {
				case 1 :
					// HiveParser.g:855:24: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropTableStatement3253);
					ifExists151=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists151.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_tableName_in_dropTableStatement3256);
			tableName152=tableName();
			state._fsp--;

			stream_tableName.add(tableName152.getTree());
			// AST REWRITE
			// elements: tableName, ifExists
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 855:44: -> ^( TOK_DROPTABLE tableName ( ifExists )? )
			{
				// HiveParser.g:855:47: ^( TOK_DROPTABLE tableName ( ifExists )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPTABLE, "TOK_DROPTABLE"), root_1);
				adaptor.addChild(root_1, stream_tableName.nextTree());
				// HiveParser.g:855:73: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropTableStatement"


	public static class alterStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatement"
	// HiveParser.g:858:1: alterStatement : KW_ALTER ! ( KW_TABLE ! alterTableStatementSuffix | KW_VIEW ! alterViewStatementSuffix | KW_INDEX ! alterIndexStatementSuffix | KW_DATABASE ! alterDatabaseStatementSuffix ) ;
	public final HiveParser.alterStatement_return alterStatement() throws RecognitionException {
		HiveParser.alterStatement_return retval = new HiveParser.alterStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ALTER153=null;
		Token KW_TABLE154=null;
		Token KW_VIEW156=null;
		Token KW_INDEX158=null;
		Token KW_DATABASE160=null;
		ParserRuleReturnScope alterTableStatementSuffix155 =null;
		ParserRuleReturnScope alterViewStatementSuffix157 =null;
		ParserRuleReturnScope alterIndexStatementSuffix159 =null;
		ParserRuleReturnScope alterDatabaseStatementSuffix161 =null;

		CommonTree KW_ALTER153_tree=null;
		CommonTree KW_TABLE154_tree=null;
		CommonTree KW_VIEW156_tree=null;
		CommonTree KW_INDEX158_tree=null;
		CommonTree KW_DATABASE160_tree=null;

		 msgs.push("alter statement"); 
		try {
			// HiveParser.g:861:5: ( KW_ALTER ! ( KW_TABLE ! alterTableStatementSuffix | KW_VIEW ! alterViewStatementSuffix | KW_INDEX ! alterIndexStatementSuffix | KW_DATABASE ! alterDatabaseStatementSuffix ) )
			// HiveParser.g:861:7: KW_ALTER ! ( KW_TABLE ! alterTableStatementSuffix | KW_VIEW ! alterViewStatementSuffix | KW_INDEX ! alterIndexStatementSuffix | KW_DATABASE ! alterDatabaseStatementSuffix )
			{
			root_0 = (CommonTree)adaptor.nil();


			KW_ALTER153=(Token)match(input,KW_ALTER,FOLLOW_KW_ALTER_in_alterStatement3294); 
			// HiveParser.g:862:9: ( KW_TABLE ! alterTableStatementSuffix | KW_VIEW ! alterViewStatementSuffix | KW_INDEX ! alterIndexStatementSuffix | KW_DATABASE ! alterDatabaseStatementSuffix )
			int alt47=4;
			switch ( input.LA(1) ) {
			case KW_TABLE:
				{
				alt47=1;
				}
				break;
			case KW_VIEW:
				{
				alt47=2;
				}
				break;
			case KW_INDEX:
				{
				alt47=3;
				}
				break;
			case KW_DATABASE:
				{
				alt47=4;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 47, 0, input);
				throw nvae;
			}
			switch (alt47) {
				case 1 :
					// HiveParser.g:863:13: KW_TABLE ! alterTableStatementSuffix
					{
					KW_TABLE154=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_alterStatement3319); 
					pushFollow(FOLLOW_alterTableStatementSuffix_in_alterStatement3322);
					alterTableStatementSuffix155=alterTableStatementSuffix();
					state._fsp--;

					adaptor.addChild(root_0, alterTableStatementSuffix155.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:865:13: KW_VIEW ! alterViewStatementSuffix
					{
					KW_VIEW156=(Token)match(input,KW_VIEW,FOLLOW_KW_VIEW_in_alterStatement3346); 
					pushFollow(FOLLOW_alterViewStatementSuffix_in_alterStatement3349);
					alterViewStatementSuffix157=alterViewStatementSuffix();
					state._fsp--;

					adaptor.addChild(root_0, alterViewStatementSuffix157.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:867:13: KW_INDEX ! alterIndexStatementSuffix
					{
					KW_INDEX158=(Token)match(input,KW_INDEX,FOLLOW_KW_INDEX_in_alterStatement3373); 
					pushFollow(FOLLOW_alterIndexStatementSuffix_in_alterStatement3376);
					alterIndexStatementSuffix159=alterIndexStatementSuffix();
					state._fsp--;

					adaptor.addChild(root_0, alterIndexStatementSuffix159.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:869:13: KW_DATABASE ! alterDatabaseStatementSuffix
					{
					KW_DATABASE160=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_alterStatement3400); 
					pushFollow(FOLLOW_alterDatabaseStatementSuffix_in_alterStatement3403);
					alterDatabaseStatementSuffix161=alterDatabaseStatementSuffix();
					state._fsp--;

					adaptor.addChild(root_0, alterDatabaseStatementSuffix161.getTree());

					}
					break;

			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatement"


	public static class alterTableStatementSuffix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterTableStatementSuffix"
	// HiveParser.g:873:1: alterTableStatementSuffix : ( alterStatementSuffixRename | alterStatementSuffixAddCol | alterStatementSuffixRenameCol | alterStatementSuffixDropPartitions | alterStatementSuffixAddPartitions | alterStatementSuffixTouch | alterStatementSuffixArchive | alterStatementSuffixUnArchive | alterStatementSuffixProperties | alterTblPartitionStatement | alterStatementSuffixSkewedby | alterStatementSuffixExchangePartition );
	public final HiveParser.alterTableStatementSuffix_return alterTableStatementSuffix() throws RecognitionException {
		HiveParser.alterTableStatementSuffix_return retval = new HiveParser.alterTableStatementSuffix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope alterStatementSuffixRename162 =null;
		ParserRuleReturnScope alterStatementSuffixAddCol163 =null;
		ParserRuleReturnScope alterStatementSuffixRenameCol164 =null;
		ParserRuleReturnScope alterStatementSuffixDropPartitions165 =null;
		ParserRuleReturnScope alterStatementSuffixAddPartitions166 =null;
		ParserRuleReturnScope alterStatementSuffixTouch167 =null;
		ParserRuleReturnScope alterStatementSuffixArchive168 =null;
		ParserRuleReturnScope alterStatementSuffixUnArchive169 =null;
		ParserRuleReturnScope alterStatementSuffixProperties170 =null;
		ParserRuleReturnScope alterTblPartitionStatement171 =null;
		ParserRuleReturnScope alterStatementSuffixSkewedby172 =null;
		ParserRuleReturnScope alterStatementSuffixExchangePartition173 =null;


		 msgs.push("alter table statement"); 
		try {
			// HiveParser.g:876:5: ( alterStatementSuffixRename | alterStatementSuffixAddCol | alterStatementSuffixRenameCol | alterStatementSuffixDropPartitions | alterStatementSuffixAddPartitions | alterStatementSuffixTouch | alterStatementSuffixArchive | alterStatementSuffixUnArchive | alterStatementSuffixProperties | alterTblPartitionStatement | alterStatementSuffixSkewedby | alterStatementSuffixExchangePartition )
			int alt48=12;
			alt48 = dfa48.predict(input);
			switch (alt48) {
				case 1 :
					// HiveParser.g:876:7: alterStatementSuffixRename
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixRename_in_alterTableStatementSuffix3440);
					alterStatementSuffixRename162=alterStatementSuffixRename();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixRename162.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:877:7: alterStatementSuffixAddCol
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixAddCol_in_alterTableStatementSuffix3448);
					alterStatementSuffixAddCol163=alterStatementSuffixAddCol();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixAddCol163.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:878:7: alterStatementSuffixRenameCol
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixRenameCol_in_alterTableStatementSuffix3456);
					alterStatementSuffixRenameCol164=alterStatementSuffixRenameCol();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixRenameCol164.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:879:7: alterStatementSuffixDropPartitions
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixDropPartitions_in_alterTableStatementSuffix3464);
					alterStatementSuffixDropPartitions165=alterStatementSuffixDropPartitions();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixDropPartitions165.getTree());

					}
					break;
				case 5 :
					// HiveParser.g:880:7: alterStatementSuffixAddPartitions
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixAddPartitions_in_alterTableStatementSuffix3472);
					alterStatementSuffixAddPartitions166=alterStatementSuffixAddPartitions();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixAddPartitions166.getTree());

					}
					break;
				case 6 :
					// HiveParser.g:881:7: alterStatementSuffixTouch
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixTouch_in_alterTableStatementSuffix3480);
					alterStatementSuffixTouch167=alterStatementSuffixTouch();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixTouch167.getTree());

					}
					break;
				case 7 :
					// HiveParser.g:882:7: alterStatementSuffixArchive
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixArchive_in_alterTableStatementSuffix3488);
					alterStatementSuffixArchive168=alterStatementSuffixArchive();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixArchive168.getTree());

					}
					break;
				case 8 :
					// HiveParser.g:883:7: alterStatementSuffixUnArchive
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixUnArchive_in_alterTableStatementSuffix3496);
					alterStatementSuffixUnArchive169=alterStatementSuffixUnArchive();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixUnArchive169.getTree());

					}
					break;
				case 9 :
					// HiveParser.g:884:7: alterStatementSuffixProperties
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixProperties_in_alterTableStatementSuffix3504);
					alterStatementSuffixProperties170=alterStatementSuffixProperties();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixProperties170.getTree());

					}
					break;
				case 10 :
					// HiveParser.g:885:7: alterTblPartitionStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterTblPartitionStatement_in_alterTableStatementSuffix3512);
					alterTblPartitionStatement171=alterTblPartitionStatement();
					state._fsp--;

					adaptor.addChild(root_0, alterTblPartitionStatement171.getTree());

					}
					break;
				case 11 :
					// HiveParser.g:886:7: alterStatementSuffixSkewedby
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixSkewedby_in_alterTableStatementSuffix3520);
					alterStatementSuffixSkewedby172=alterStatementSuffixSkewedby();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixSkewedby172.getTree());

					}
					break;
				case 12 :
					// HiveParser.g:887:7: alterStatementSuffixExchangePartition
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixExchangePartition_in_alterTableStatementSuffix3528);
					alterStatementSuffixExchangePartition173=alterStatementSuffixExchangePartition();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixExchangePartition173.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterTableStatementSuffix"


	public static class alterViewStatementSuffix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterViewStatementSuffix"
	// HiveParser.g:890:1: alterViewStatementSuffix : ( alterViewSuffixProperties | alterStatementSuffixRename -> ^( TOK_ALTERVIEW_RENAME alterStatementSuffixRename ) | alterStatementSuffixAddPartitions -> ^( TOK_ALTERVIEW_ADDPARTS alterStatementSuffixAddPartitions ) | alterStatementSuffixDropPartitions -> ^( TOK_ALTERVIEW_DROPPARTS alterStatementSuffixDropPartitions ) |name= tableName KW_AS selectStatement -> ^( TOK_ALTERVIEW_AS $name selectStatement ) );
	public final HiveParser.alterViewStatementSuffix_return alterViewStatementSuffix() throws RecognitionException {
		HiveParser.alterViewStatementSuffix_return retval = new HiveParser.alterViewStatementSuffix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_AS178=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope alterViewSuffixProperties174 =null;
		ParserRuleReturnScope alterStatementSuffixRename175 =null;
		ParserRuleReturnScope alterStatementSuffixAddPartitions176 =null;
		ParserRuleReturnScope alterStatementSuffixDropPartitions177 =null;
		ParserRuleReturnScope selectStatement179 =null;

		CommonTree KW_AS178_tree=null;
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleSubtreeStream stream_selectStatement=new RewriteRuleSubtreeStream(adaptor,"rule selectStatement");
		RewriteRuleSubtreeStream stream_alterStatementSuffixAddPartitions=new RewriteRuleSubtreeStream(adaptor,"rule alterStatementSuffixAddPartitions");
		RewriteRuleSubtreeStream stream_alterStatementSuffixRename=new RewriteRuleSubtreeStream(adaptor,"rule alterStatementSuffixRename");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_alterStatementSuffixDropPartitions=new RewriteRuleSubtreeStream(adaptor,"rule alterStatementSuffixDropPartitions");

		 msgs.push("alter view statement"); 
		try {
			// HiveParser.g:893:5: ( alterViewSuffixProperties | alterStatementSuffixRename -> ^( TOK_ALTERVIEW_RENAME alterStatementSuffixRename ) | alterStatementSuffixAddPartitions -> ^( TOK_ALTERVIEW_ADDPARTS alterStatementSuffixAddPartitions ) | alterStatementSuffixDropPartitions -> ^( TOK_ALTERVIEW_DROPPARTS alterStatementSuffixDropPartitions ) |name= tableName KW_AS selectStatement -> ^( TOK_ALTERVIEW_AS $name selectStatement ) )
			int alt49=5;
			int LA49_0 = input.LA(1);
			if ( (LA49_0==Identifier) ) {
				switch ( input.LA(2) ) {
				case KW_SET:
				case KW_UNSET:
					{
					alt49=1;
					}
					break;
				case KW_RENAME:
					{
					alt49=2;
					}
					break;
				case KW_ADD:
					{
					alt49=3;
					}
					break;
				case KW_DROP:
					{
					alt49=4;
					}
					break;
				case DOT:
				case KW_AS:
					{
					alt49=5;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 49, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
			}
			else if ( ((LA49_0 >= KW_ADD && LA49_0 <= KW_AFTER)||(LA49_0 >= KW_ALTER && LA49_0 <= KW_ANALYZE)||(LA49_0 >= KW_ARCHIVE && LA49_0 <= KW_CASCADE)||(LA49_0 >= KW_CHANGE && LA49_0 <= KW_COLLECTION)||(LA49_0 >= KW_COLUMNS && LA49_0 <= KW_CONCATENATE)||(LA49_0 >= KW_CONTINUE && LA49_0 <= KW_CREATE)||LA49_0==KW_CUBE||(LA49_0 >= KW_CURSOR && LA49_0 <= KW_DATA)||(LA49_0 >= KW_DATABASES && LA49_0 <= KW_DATETIME)||(LA49_0 >= KW_DBPROPERTIES && LA49_0 <= KW_DISABLE)||(LA49_0 >= KW_DISTRIBUTE && LA49_0 <= KW_ELEM_TYPE)||LA49_0==KW_ENABLE||LA49_0==KW_ESCAPED||(LA49_0 >= KW_EXCLUSIVE && LA49_0 <= KW_EXPORT)||(LA49_0 >= KW_EXTERNAL && LA49_0 <= KW_FLOAT)||(LA49_0 >= KW_FOR && LA49_0 <= KW_FORMATTED)||LA49_0==KW_FULL||(LA49_0 >= KW_FUNCTIONS && LA49_0 <= KW_GROUPING)||LA49_0==KW_HOLD_DDLTIME||LA49_0==KW_IDXPROPERTIES||(LA49_0 >= KW_IGNORE && LA49_0 <= KW_INTERSECT)||(LA49_0 >= KW_INTO && LA49_0 <= KW_ITEMS)||(LA49_0 >= KW_KEYS && LA49_0 <= KW_LEFT)||(LA49_0 >= KW_LIKE && LA49_0 <= KW_LONG)||(LA49_0 >= KW_MAPJOIN && LA49_0 <= KW_MINUS)||(LA49_0 >= KW_MSCK && LA49_0 <= KW_NOSCAN)||(LA49_0 >= KW_NO_DROP && LA49_0 <= KW_OFFLINE)||LA49_0==KW_OPTION||(LA49_0 >= KW_ORCFILE && LA49_0 <= KW_OUTPUTFORMAT)||LA49_0==KW_OVERWRITE||(LA49_0 >= KW_PARTITION && LA49_0 <= KW_PLUS)||(LA49_0 >= KW_PRETTY && LA49_0 <= KW_RECORDWRITER)||(LA49_0 >= KW_REGEXP && LA49_0 <= KW_SCHEMAS)||(LA49_0 >= KW_SEMI && LA49_0 <= KW_TABLES)||(LA49_0 >= KW_TBLPROPERTIES && LA49_0 <= KW_TEXTFILE)||(LA49_0 >= KW_TIMESTAMP && LA49_0 <= KW_TOUCH)||(LA49_0 >= KW_TRIGGER && LA49_0 <= KW_UNARCHIVE)||(LA49_0 >= KW_UNDO && LA49_0 <= KW_UNIONTYPE)||(LA49_0 >= KW_UNLOCK && LA49_0 <= KW_VALUE_TYPE)||LA49_0==KW_VIEW||LA49_0==KW_WHILE||LA49_0==KW_WITH) ) {
				switch ( input.LA(2) ) {
				case KW_SET:
				case KW_UNSET:
					{
					alt49=1;
					}
					break;
				case KW_RENAME:
					{
					alt49=2;
					}
					break;
				case KW_ADD:
					{
					alt49=3;
					}
					break;
				case KW_DROP:
					{
					alt49=4;
					}
					break;
				case DOT:
				case KW_AS:
					{
					alt49=5;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 49, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 49, 0, input);
				throw nvae;
			}

			switch (alt49) {
				case 1 :
					// HiveParser.g:893:7: alterViewSuffixProperties
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterViewSuffixProperties_in_alterViewStatementSuffix3555);
					alterViewSuffixProperties174=alterViewSuffixProperties();
					state._fsp--;

					adaptor.addChild(root_0, alterViewSuffixProperties174.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:894:7: alterStatementSuffixRename
					{
					pushFollow(FOLLOW_alterStatementSuffixRename_in_alterViewStatementSuffix3563);
					alterStatementSuffixRename175=alterStatementSuffixRename();
					state._fsp--;

					stream_alterStatementSuffixRename.add(alterStatementSuffixRename175.getTree());
					// AST REWRITE
					// elements: alterStatementSuffixRename
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 895:9: -> ^( TOK_ALTERVIEW_RENAME alterStatementSuffixRename )
					{
						// HiveParser.g:895:12: ^( TOK_ALTERVIEW_RENAME alterStatementSuffixRename )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERVIEW_RENAME, "TOK_ALTERVIEW_RENAME"), root_1);
						adaptor.addChild(root_1, stream_alterStatementSuffixRename.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:896:7: alterStatementSuffixAddPartitions
					{
					pushFollow(FOLLOW_alterStatementSuffixAddPartitions_in_alterViewStatementSuffix3587);
					alterStatementSuffixAddPartitions176=alterStatementSuffixAddPartitions();
					state._fsp--;

					stream_alterStatementSuffixAddPartitions.add(alterStatementSuffixAddPartitions176.getTree());
					// AST REWRITE
					// elements: alterStatementSuffixAddPartitions
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 897:9: -> ^( TOK_ALTERVIEW_ADDPARTS alterStatementSuffixAddPartitions )
					{
						// HiveParser.g:897:12: ^( TOK_ALTERVIEW_ADDPARTS alterStatementSuffixAddPartitions )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERVIEW_ADDPARTS, "TOK_ALTERVIEW_ADDPARTS"), root_1);
						adaptor.addChild(root_1, stream_alterStatementSuffixAddPartitions.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:898:7: alterStatementSuffixDropPartitions
					{
					pushFollow(FOLLOW_alterStatementSuffixDropPartitions_in_alterViewStatementSuffix3611);
					alterStatementSuffixDropPartitions177=alterStatementSuffixDropPartitions();
					state._fsp--;

					stream_alterStatementSuffixDropPartitions.add(alterStatementSuffixDropPartitions177.getTree());
					// AST REWRITE
					// elements: alterStatementSuffixDropPartitions
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 899:9: -> ^( TOK_ALTERVIEW_DROPPARTS alterStatementSuffixDropPartitions )
					{
						// HiveParser.g:899:12: ^( TOK_ALTERVIEW_DROPPARTS alterStatementSuffixDropPartitions )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERVIEW_DROPPARTS, "TOK_ALTERVIEW_DROPPARTS"), root_1);
						adaptor.addChild(root_1, stream_alterStatementSuffixDropPartitions.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:900:7: name= tableName KW_AS selectStatement
					{
					pushFollow(FOLLOW_tableName_in_alterViewStatementSuffix3637);
					name=tableName();
					state._fsp--;

					stream_tableName.add(name.getTree());
					KW_AS178=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_alterViewStatementSuffix3639);  
					stream_KW_AS.add(KW_AS178);

					pushFollow(FOLLOW_selectStatement_in_alterViewStatementSuffix3641);
					selectStatement179=selectStatement();
					state._fsp--;

					stream_selectStatement.add(selectStatement179.getTree());
					// AST REWRITE
					// elements: selectStatement, name
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 901:9: -> ^( TOK_ALTERVIEW_AS $name selectStatement )
					{
						// HiveParser.g:901:12: ^( TOK_ALTERVIEW_AS $name selectStatement )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERVIEW_AS, "TOK_ALTERVIEW_AS"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_selectStatement.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterViewStatementSuffix"


	public static class alterIndexStatementSuffix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterIndexStatementSuffix"
	// HiveParser.g:904:1: alterIndexStatementSuffix : indexName= identifier ( KW_ON tableNameId= identifier ) ( partitionSpec )? ( KW_REBUILD -> ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? ) | KW_SET KW_IDXPROPERTIES indexProperties -> ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties ) ) ;
	public final HiveParser.alterIndexStatementSuffix_return alterIndexStatementSuffix() throws RecognitionException {
		HiveParser.alterIndexStatementSuffix_return retval = new HiveParser.alterIndexStatementSuffix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ON180=null;
		Token KW_REBUILD182=null;
		Token KW_SET183=null;
		Token KW_IDXPROPERTIES184=null;
		ParserRuleReturnScope indexName =null;
		ParserRuleReturnScope tableNameId =null;
		ParserRuleReturnScope partitionSpec181 =null;
		ParserRuleReturnScope indexProperties185 =null;

		CommonTree KW_ON180_tree=null;
		CommonTree KW_REBUILD182_tree=null;
		CommonTree KW_SET183_tree=null;
		CommonTree KW_IDXPROPERTIES184_tree=null;
		RewriteRuleTokenStream stream_KW_REBUILD=new RewriteRuleTokenStream(adaptor,"token KW_REBUILD");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_IDXPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_IDXPROPERTIES");
		RewriteRuleSubtreeStream stream_indexProperties=new RewriteRuleSubtreeStream(adaptor,"rule indexProperties");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("alter index statement"); 
		try {
			// HiveParser.g:907:5: (indexName= identifier ( KW_ON tableNameId= identifier ) ( partitionSpec )? ( KW_REBUILD -> ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? ) | KW_SET KW_IDXPROPERTIES indexProperties -> ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties ) ) )
			// HiveParser.g:907:7: indexName= identifier ( KW_ON tableNameId= identifier ) ( partitionSpec )? ( KW_REBUILD -> ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? ) | KW_SET KW_IDXPROPERTIES indexProperties -> ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties ) )
			{
			pushFollow(FOLLOW_identifier_in_alterIndexStatementSuffix3689);
			indexName=identifier();
			state._fsp--;

			stream_identifier.add(indexName.getTree());
			// HiveParser.g:908:7: ( KW_ON tableNameId= identifier )
			// HiveParser.g:908:8: KW_ON tableNameId= identifier
			{
			KW_ON180=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_alterIndexStatementSuffix3698);  
			stream_KW_ON.add(KW_ON180);

			pushFollow(FOLLOW_identifier_in_alterIndexStatementSuffix3702);
			tableNameId=identifier();
			state._fsp--;

			stream_identifier.add(tableNameId.getTree());
			}

			// HiveParser.g:909:7: ( partitionSpec )?
			int alt50=2;
			int LA50_0 = input.LA(1);
			if ( (LA50_0==KW_PARTITION) ) {
				alt50=1;
			}
			switch (alt50) {
				case 1 :
					// HiveParser.g:909:7: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_alterIndexStatementSuffix3711);
					partitionSpec181=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec181.getTree());
					}
					break;

			}

			// HiveParser.g:910:5: ( KW_REBUILD -> ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? ) | KW_SET KW_IDXPROPERTIES indexProperties -> ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties ) )
			int alt51=2;
			int LA51_0 = input.LA(1);
			if ( (LA51_0==KW_REBUILD) ) {
				alt51=1;
			}
			else if ( (LA51_0==KW_SET) ) {
				alt51=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 51, 0, input);
				throw nvae;
			}

			switch (alt51) {
				case 1 :
					// HiveParser.g:911:7: KW_REBUILD
					{
					KW_REBUILD182=(Token)match(input,KW_REBUILD,FOLLOW_KW_REBUILD_in_alterIndexStatementSuffix3726);  
					stream_KW_REBUILD.add(KW_REBUILD182);

					// AST REWRITE
					// elements: tableNameId, partitionSpec, indexName
					// token labels: 
					// rule labels: retval, tableNameId, indexName
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_tableNameId=new RewriteRuleSubtreeStream(adaptor,"rule tableNameId",tableNameId!=null?tableNameId.getTree():null);
					RewriteRuleSubtreeStream stream_indexName=new RewriteRuleSubtreeStream(adaptor,"rule indexName",indexName!=null?indexName.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 912:7: -> ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? )
					{
						// HiveParser.g:912:9: ^( TOK_ALTERINDEX_REBUILD $tableNameId $indexName ( partitionSpec )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERINDEX_REBUILD, "TOK_ALTERINDEX_REBUILD"), root_1);
						adaptor.addChild(root_1, stream_tableNameId.nextTree());
						adaptor.addChild(root_1, stream_indexName.nextTree());
						// HiveParser.g:912:58: ( partitionSpec )?
						if ( stream_partitionSpec.hasNext() ) {
							adaptor.addChild(root_1, stream_partitionSpec.nextTree());
						}
						stream_partitionSpec.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:914:7: KW_SET KW_IDXPROPERTIES indexProperties
					{
					KW_SET183=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterIndexStatementSuffix3760);  
					stream_KW_SET.add(KW_SET183);

					KW_IDXPROPERTIES184=(Token)match(input,KW_IDXPROPERTIES,FOLLOW_KW_IDXPROPERTIES_in_alterIndexStatementSuffix3762);  
					stream_KW_IDXPROPERTIES.add(KW_IDXPROPERTIES184);

					pushFollow(FOLLOW_indexProperties_in_alterIndexStatementSuffix3770);
					indexProperties185=indexProperties();
					state._fsp--;

					stream_indexProperties.add(indexProperties185.getTree());
					// AST REWRITE
					// elements: indexProperties, indexName, tableNameId
					// token labels: 
					// rule labels: retval, tableNameId, indexName
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_tableNameId=new RewriteRuleSubtreeStream(adaptor,"rule tableNameId",tableNameId!=null?tableNameId.getTree():null);
					RewriteRuleSubtreeStream stream_indexName=new RewriteRuleSubtreeStream(adaptor,"rule indexName",indexName!=null?indexName.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 916:7: -> ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties )
					{
						// HiveParser.g:916:9: ^( TOK_ALTERINDEX_PROPERTIES $tableNameId $indexName indexProperties )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERINDEX_PROPERTIES, "TOK_ALTERINDEX_PROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_tableNameId.nextTree());
						adaptor.addChild(root_1, stream_indexName.nextTree());
						adaptor.addChild(root_1, stream_indexProperties.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterIndexStatementSuffix"


	public static class alterDatabaseStatementSuffix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterDatabaseStatementSuffix"
	// HiveParser.g:920:1: alterDatabaseStatementSuffix : alterDatabaseSuffixProperties ;
	public final HiveParser.alterDatabaseStatementSuffix_return alterDatabaseStatementSuffix() throws RecognitionException {
		HiveParser.alterDatabaseStatementSuffix_return retval = new HiveParser.alterDatabaseStatementSuffix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope alterDatabaseSuffixProperties186 =null;


		 msgs.push("alter database statement"); 
		try {
			// HiveParser.g:923:5: ( alterDatabaseSuffixProperties )
			// HiveParser.g:923:7: alterDatabaseSuffixProperties
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_alterDatabaseSuffixProperties_in_alterDatabaseStatementSuffix3822);
			alterDatabaseSuffixProperties186=alterDatabaseSuffixProperties();
			state._fsp--;

			adaptor.addChild(root_0, alterDatabaseSuffixProperties186.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterDatabaseStatementSuffix"


	public static class alterDatabaseSuffixProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterDatabaseSuffixProperties"
	// HiveParser.g:926:1: alterDatabaseSuffixProperties : name= identifier KW_SET KW_DBPROPERTIES dbProperties -> ^( TOK_ALTERDATABASE_PROPERTIES $name dbProperties ) ;
	public final HiveParser.alterDatabaseSuffixProperties_return alterDatabaseSuffixProperties() throws RecognitionException {
		HiveParser.alterDatabaseSuffixProperties_return retval = new HiveParser.alterDatabaseSuffixProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SET187=null;
		Token KW_DBPROPERTIES188=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope dbProperties189 =null;

		CommonTree KW_SET187_tree=null;
		CommonTree KW_DBPROPERTIES188_tree=null;
		RewriteRuleTokenStream stream_KW_DBPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_DBPROPERTIES");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleSubtreeStream stream_dbProperties=new RewriteRuleSubtreeStream(adaptor,"rule dbProperties");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("alter database properties statement"); 
		try {
			// HiveParser.g:929:5: (name= identifier KW_SET KW_DBPROPERTIES dbProperties -> ^( TOK_ALTERDATABASE_PROPERTIES $name dbProperties ) )
			// HiveParser.g:929:7: name= identifier KW_SET KW_DBPROPERTIES dbProperties
			{
			pushFollow(FOLLOW_identifier_in_alterDatabaseSuffixProperties3851);
			name=identifier();
			state._fsp--;

			stream_identifier.add(name.getTree());
			KW_SET187=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterDatabaseSuffixProperties3853);  
			stream_KW_SET.add(KW_SET187);

			KW_DBPROPERTIES188=(Token)match(input,KW_DBPROPERTIES,FOLLOW_KW_DBPROPERTIES_in_alterDatabaseSuffixProperties3855);  
			stream_KW_DBPROPERTIES.add(KW_DBPROPERTIES188);

			pushFollow(FOLLOW_dbProperties_in_alterDatabaseSuffixProperties3857);
			dbProperties189=dbProperties();
			state._fsp--;

			stream_dbProperties.add(dbProperties189.getTree());
			// AST REWRITE
			// elements: dbProperties, name
			// token labels: 
			// rule labels: retval, name
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 930:5: -> ^( TOK_ALTERDATABASE_PROPERTIES $name dbProperties )
			{
				// HiveParser.g:930:8: ^( TOK_ALTERDATABASE_PROPERTIES $name dbProperties )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERDATABASE_PROPERTIES, "TOK_ALTERDATABASE_PROPERTIES"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				adaptor.addChild(root_1, stream_dbProperties.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterDatabaseSuffixProperties"


	public static class alterStatementSuffixRename_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixRename"
	// HiveParser.g:933:1: alterStatementSuffixRename : oldName= identifier KW_RENAME KW_TO newName= identifier -> ^( TOK_ALTERTABLE_RENAME $oldName $newName) ;
	public final HiveParser.alterStatementSuffixRename_return alterStatementSuffixRename() throws RecognitionException {
		HiveParser.alterStatementSuffixRename_return retval = new HiveParser.alterStatementSuffixRename_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_RENAME190=null;
		Token KW_TO191=null;
		ParserRuleReturnScope oldName =null;
		ParserRuleReturnScope newName =null;

		CommonTree KW_RENAME190_tree=null;
		CommonTree KW_TO191_tree=null;
		RewriteRuleTokenStream stream_KW_RENAME=new RewriteRuleTokenStream(adaptor,"token KW_RENAME");
		RewriteRuleTokenStream stream_KW_TO=new RewriteRuleTokenStream(adaptor,"token KW_TO");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("rename statement"); 
		try {
			// HiveParser.g:936:5: (oldName= identifier KW_RENAME KW_TO newName= identifier -> ^( TOK_ALTERTABLE_RENAME $oldName $newName) )
			// HiveParser.g:936:7: oldName= identifier KW_RENAME KW_TO newName= identifier
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixRename3901);
			oldName=identifier();
			state._fsp--;

			stream_identifier.add(oldName.getTree());
			KW_RENAME190=(Token)match(input,KW_RENAME,FOLLOW_KW_RENAME_in_alterStatementSuffixRename3903);  
			stream_KW_RENAME.add(KW_RENAME190);

			KW_TO191=(Token)match(input,KW_TO,FOLLOW_KW_TO_in_alterStatementSuffixRename3905);  
			stream_KW_TO.add(KW_TO191);

			pushFollow(FOLLOW_identifier_in_alterStatementSuffixRename3909);
			newName=identifier();
			state._fsp--;

			stream_identifier.add(newName.getTree());
			// AST REWRITE
			// elements: newName, oldName
			// token labels: 
			// rule labels: retval, newName, oldName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_newName=new RewriteRuleSubtreeStream(adaptor,"rule newName",newName!=null?newName.getTree():null);
			RewriteRuleSubtreeStream stream_oldName=new RewriteRuleSubtreeStream(adaptor,"rule oldName",oldName!=null?oldName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 937:5: -> ^( TOK_ALTERTABLE_RENAME $oldName $newName)
			{
				// HiveParser.g:937:8: ^( TOK_ALTERTABLE_RENAME $oldName $newName)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_RENAME, "TOK_ALTERTABLE_RENAME"), root_1);
				adaptor.addChild(root_1, stream_oldName.nextTree());
				adaptor.addChild(root_1, stream_newName.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixRename"


	public static class alterStatementSuffixAddCol_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixAddCol"
	// HiveParser.g:940:1: alterStatementSuffixAddCol : identifier (add= KW_ADD |replace= KW_REPLACE ) KW_COLUMNS LPAREN columnNameTypeList RPAREN -> {$add != null}? ^( TOK_ALTERTABLE_ADDCOLS identifier columnNameTypeList ) -> ^( TOK_ALTERTABLE_REPLACECOLS identifier columnNameTypeList ) ;
	public final HiveParser.alterStatementSuffixAddCol_return alterStatementSuffixAddCol() throws RecognitionException {
		HiveParser.alterStatementSuffixAddCol_return retval = new HiveParser.alterStatementSuffixAddCol_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token add=null;
		Token replace=null;
		Token KW_COLUMNS193=null;
		Token LPAREN194=null;
		Token RPAREN196=null;
		ParserRuleReturnScope identifier192 =null;
		ParserRuleReturnScope columnNameTypeList195 =null;

		CommonTree add_tree=null;
		CommonTree replace_tree=null;
		CommonTree KW_COLUMNS193_tree=null;
		CommonTree LPAREN194_tree=null;
		CommonTree RPAREN196_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_REPLACE=new RewriteRuleTokenStream(adaptor,"token KW_REPLACE");
		RewriteRuleTokenStream stream_KW_COLUMNS=new RewriteRuleTokenStream(adaptor,"token KW_COLUMNS");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_ADD=new RewriteRuleTokenStream(adaptor,"token KW_ADD");
		RewriteRuleSubtreeStream stream_columnNameTypeList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameTypeList");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("add column statement"); 
		try {
			// HiveParser.g:943:5: ( identifier (add= KW_ADD |replace= KW_REPLACE ) KW_COLUMNS LPAREN columnNameTypeList RPAREN -> {$add != null}? ^( TOK_ALTERTABLE_ADDCOLS identifier columnNameTypeList ) -> ^( TOK_ALTERTABLE_REPLACECOLS identifier columnNameTypeList ) )
			// HiveParser.g:943:7: identifier (add= KW_ADD |replace= KW_REPLACE ) KW_COLUMNS LPAREN columnNameTypeList RPAREN
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixAddCol3952);
			identifier192=identifier();
			state._fsp--;

			stream_identifier.add(identifier192.getTree());
			// HiveParser.g:943:18: (add= KW_ADD |replace= KW_REPLACE )
			int alt52=2;
			int LA52_0 = input.LA(1);
			if ( (LA52_0==KW_ADD) ) {
				alt52=1;
			}
			else if ( (LA52_0==KW_REPLACE) ) {
				alt52=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 52, 0, input);
				throw nvae;
			}

			switch (alt52) {
				case 1 :
					// HiveParser.g:943:19: add= KW_ADD
					{
					add=(Token)match(input,KW_ADD,FOLLOW_KW_ADD_in_alterStatementSuffixAddCol3957);  
					stream_KW_ADD.add(add);

					}
					break;
				case 2 :
					// HiveParser.g:943:32: replace= KW_REPLACE
					{
					replace=(Token)match(input,KW_REPLACE,FOLLOW_KW_REPLACE_in_alterStatementSuffixAddCol3963);  
					stream_KW_REPLACE.add(replace);

					}
					break;

			}

			KW_COLUMNS193=(Token)match(input,KW_COLUMNS,FOLLOW_KW_COLUMNS_in_alterStatementSuffixAddCol3966);  
			stream_KW_COLUMNS.add(KW_COLUMNS193);

			LPAREN194=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_alterStatementSuffixAddCol3968);  
			stream_LPAREN.add(LPAREN194);

			pushFollow(FOLLOW_columnNameTypeList_in_alterStatementSuffixAddCol3970);
			columnNameTypeList195=columnNameTypeList();
			state._fsp--;

			stream_columnNameTypeList.add(columnNameTypeList195.getTree());
			RPAREN196=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_alterStatementSuffixAddCol3972);  
			stream_RPAREN.add(RPAREN196);

			// AST REWRITE
			// elements: identifier, columnNameTypeList, identifier, columnNameTypeList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 944:5: -> {$add != null}? ^( TOK_ALTERTABLE_ADDCOLS identifier columnNameTypeList )
			if (add != null) {
				// HiveParser.g:944:24: ^( TOK_ALTERTABLE_ADDCOLS identifier columnNameTypeList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ADDCOLS, "TOK_ALTERTABLE_ADDCOLS"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_1, stream_columnNameTypeList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}

			else // 945:5: -> ^( TOK_ALTERTABLE_REPLACECOLS identifier columnNameTypeList )
			{
				// HiveParser.g:945:24: ^( TOK_ALTERTABLE_REPLACECOLS identifier columnNameTypeList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_REPLACECOLS, "TOK_ALTERTABLE_REPLACECOLS"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_1, stream_columnNameTypeList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixAddCol"


	public static class alterStatementSuffixRenameCol_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixRenameCol"
	// HiveParser.g:948:1: alterStatementSuffixRenameCol : identifier KW_CHANGE ( KW_COLUMN )? oldName= identifier newName= identifier colType ( KW_COMMENT comment= StringLiteral )? ( alterStatementChangeColPosition )? -> ^( TOK_ALTERTABLE_RENAMECOL identifier $oldName $newName colType ( $comment)? ( alterStatementChangeColPosition )? ) ;
	public final HiveParser.alterStatementSuffixRenameCol_return alterStatementSuffixRenameCol() throws RecognitionException {
		HiveParser.alterStatementSuffixRenameCol_return retval = new HiveParser.alterStatementSuffixRenameCol_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_CHANGE198=null;
		Token KW_COLUMN199=null;
		Token KW_COMMENT201=null;
		ParserRuleReturnScope oldName =null;
		ParserRuleReturnScope newName =null;
		ParserRuleReturnScope identifier197 =null;
		ParserRuleReturnScope colType200 =null;
		ParserRuleReturnScope alterStatementChangeColPosition202 =null;

		CommonTree comment_tree=null;
		CommonTree KW_CHANGE198_tree=null;
		CommonTree KW_COLUMN199_tree=null;
		CommonTree KW_COMMENT201_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");
		RewriteRuleTokenStream stream_KW_COLUMN=new RewriteRuleTokenStream(adaptor,"token KW_COLUMN");
		RewriteRuleTokenStream stream_KW_CHANGE=new RewriteRuleTokenStream(adaptor,"token KW_CHANGE");
		RewriteRuleSubtreeStream stream_alterStatementChangeColPosition=new RewriteRuleSubtreeStream(adaptor,"rule alterStatementChangeColPosition");
		RewriteRuleSubtreeStream stream_colType=new RewriteRuleSubtreeStream(adaptor,"rule colType");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("rename column name"); 
		try {
			// HiveParser.g:951:5: ( identifier KW_CHANGE ( KW_COLUMN )? oldName= identifier newName= identifier colType ( KW_COMMENT comment= StringLiteral )? ( alterStatementChangeColPosition )? -> ^( TOK_ALTERTABLE_RENAMECOL identifier $oldName $newName colType ( $comment)? ( alterStatementChangeColPosition )? ) )
			// HiveParser.g:951:7: identifier KW_CHANGE ( KW_COLUMN )? oldName= identifier newName= identifier colType ( KW_COMMENT comment= StringLiteral )? ( alterStatementChangeColPosition )?
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixRenameCol4045);
			identifier197=identifier();
			state._fsp--;

			stream_identifier.add(identifier197.getTree());
			KW_CHANGE198=(Token)match(input,KW_CHANGE,FOLLOW_KW_CHANGE_in_alterStatementSuffixRenameCol4047);  
			stream_KW_CHANGE.add(KW_CHANGE198);

			// HiveParser.g:951:28: ( KW_COLUMN )?
			int alt53=2;
			int LA53_0 = input.LA(1);
			if ( (LA53_0==KW_COLUMN) ) {
				alt53=1;
			}
			switch (alt53) {
				case 1 :
					// HiveParser.g:951:28: KW_COLUMN
					{
					KW_COLUMN199=(Token)match(input,KW_COLUMN,FOLLOW_KW_COLUMN_in_alterStatementSuffixRenameCol4049);  
					stream_KW_COLUMN.add(KW_COLUMN199);

					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_alterStatementSuffixRenameCol4054);
			oldName=identifier();
			state._fsp--;

			stream_identifier.add(oldName.getTree());
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixRenameCol4058);
			newName=identifier();
			state._fsp--;

			stream_identifier.add(newName.getTree());
			pushFollow(FOLLOW_colType_in_alterStatementSuffixRenameCol4060);
			colType200=colType();
			state._fsp--;

			stream_colType.add(colType200.getTree());
			// HiveParser.g:951:85: ( KW_COMMENT comment= StringLiteral )?
			int alt54=2;
			int LA54_0 = input.LA(1);
			if ( (LA54_0==KW_COMMENT) ) {
				alt54=1;
			}
			switch (alt54) {
				case 1 :
					// HiveParser.g:951:86: KW_COMMENT comment= StringLiteral
					{
					KW_COMMENT201=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_alterStatementSuffixRenameCol4063);  
					stream_KW_COMMENT.add(KW_COMMENT201);

					comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_alterStatementSuffixRenameCol4067);  
					stream_StringLiteral.add(comment);

					}
					break;

			}

			// HiveParser.g:951:121: ( alterStatementChangeColPosition )?
			int alt55=2;
			int LA55_0 = input.LA(1);
			if ( (LA55_0==KW_AFTER||LA55_0==KW_FIRST) ) {
				alt55=1;
			}
			switch (alt55) {
				case 1 :
					// HiveParser.g:951:121: alterStatementChangeColPosition
					{
					pushFollow(FOLLOW_alterStatementChangeColPosition_in_alterStatementSuffixRenameCol4071);
					alterStatementChangeColPosition202=alterStatementChangeColPosition();
					state._fsp--;

					stream_alterStatementChangeColPosition.add(alterStatementChangeColPosition202.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: identifier, comment, oldName, alterStatementChangeColPosition, newName, colType
			// token labels: comment
			// rule labels: retval, newName, oldName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_newName=new RewriteRuleSubtreeStream(adaptor,"rule newName",newName!=null?newName.getTree():null);
			RewriteRuleSubtreeStream stream_oldName=new RewriteRuleSubtreeStream(adaptor,"rule oldName",oldName!=null?oldName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 952:5: -> ^( TOK_ALTERTABLE_RENAMECOL identifier $oldName $newName colType ( $comment)? ( alterStatementChangeColPosition )? )
			{
				// HiveParser.g:952:7: ^( TOK_ALTERTABLE_RENAMECOL identifier $oldName $newName colType ( $comment)? ( alterStatementChangeColPosition )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_RENAMECOL, "TOK_ALTERTABLE_RENAMECOL"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_1, stream_oldName.nextTree());
				adaptor.addChild(root_1, stream_newName.nextTree());
				adaptor.addChild(root_1, stream_colType.nextTree());
				// HiveParser.g:952:72: ( $comment)?
				if ( stream_comment.hasNext() ) {
					adaptor.addChild(root_1, stream_comment.nextNode());
				}
				stream_comment.reset();

				// HiveParser.g:952:81: ( alterStatementChangeColPosition )?
				if ( stream_alterStatementChangeColPosition.hasNext() ) {
					adaptor.addChild(root_1, stream_alterStatementChangeColPosition.nextTree());
				}
				stream_alterStatementChangeColPosition.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixRenameCol"


	public static class alterStatementChangeColPosition_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementChangeColPosition"
	// HiveParser.g:955:1: alterStatementChangeColPosition : (first= KW_FIRST | KW_AFTER afterCol= identifier -> {$first != null}? ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION ) -> ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION $afterCol) );
	public final HiveParser.alterStatementChangeColPosition_return alterStatementChangeColPosition() throws RecognitionException {
		HiveParser.alterStatementChangeColPosition_return retval = new HiveParser.alterStatementChangeColPosition_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token first=null;
		Token KW_AFTER203=null;
		ParserRuleReturnScope afterCol =null;

		CommonTree first_tree=null;
		CommonTree KW_AFTER203_tree=null;
		RewriteRuleTokenStream stream_KW_AFTER=new RewriteRuleTokenStream(adaptor,"token KW_AFTER");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		try {
			// HiveParser.g:956:5: (first= KW_FIRST | KW_AFTER afterCol= identifier -> {$first != null}? ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION ) -> ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION $afterCol) )
			int alt56=2;
			int LA56_0 = input.LA(1);
			if ( (LA56_0==KW_FIRST) ) {
				alt56=1;
			}
			else if ( (LA56_0==KW_AFTER) ) {
				alt56=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 56, 0, input);
				throw nvae;
			}

			switch (alt56) {
				case 1 :
					// HiveParser.g:956:7: first= KW_FIRST
					{
					root_0 = (CommonTree)adaptor.nil();


					first=(Token)match(input,KW_FIRST,FOLLOW_KW_FIRST_in_alterStatementChangeColPosition4117); 
					first_tree = (CommonTree)adaptor.create(first);
					adaptor.addChild(root_0, first_tree);

					}
					break;
				case 2 :
					// HiveParser.g:956:22: KW_AFTER afterCol= identifier
					{
					KW_AFTER203=(Token)match(input,KW_AFTER,FOLLOW_KW_AFTER_in_alterStatementChangeColPosition4119);  
					stream_KW_AFTER.add(KW_AFTER203);

					pushFollow(FOLLOW_identifier_in_alterStatementChangeColPosition4123);
					afterCol=identifier();
					state._fsp--;

					stream_identifier.add(afterCol.getTree());
					// AST REWRITE
					// elements: afterCol
					// token labels: 
					// rule labels: retval, afterCol
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_afterCol=new RewriteRuleSubtreeStream(adaptor,"rule afterCol",afterCol!=null?afterCol.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 957:5: -> {$first != null}? ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION )
					if (first != null) {
						// HiveParser.g:957:25: ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION, "TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}

					else // 958:5: -> ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION $afterCol)
					{
						// HiveParser.g:958:8: ^( TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION $afterCol)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION, "TOK_ALTERTABLE_CHANGECOL_AFTER_POSITION"), root_1);
						adaptor.addChild(root_1, stream_afterCol.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementChangeColPosition"


	public static class alterStatementSuffixAddPartitions_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixAddPartitions"
	// HiveParser.g:961:1: alterStatementSuffixAddPartitions : identifier KW_ADD ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ -> ^( TOK_ALTERTABLE_ADDPARTS identifier ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ ) ;
	public final HiveParser.alterStatementSuffixAddPartitions_return alterStatementSuffixAddPartitions() throws RecognitionException {
		HiveParser.alterStatementSuffixAddPartitions_return retval = new HiveParser.alterStatementSuffixAddPartitions_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ADD205=null;
		ParserRuleReturnScope identifier204 =null;
		ParserRuleReturnScope ifNotExists206 =null;
		ParserRuleReturnScope alterStatementSuffixAddPartitionsElement207 =null;

		CommonTree KW_ADD205_tree=null;
		RewriteRuleTokenStream stream_KW_ADD=new RewriteRuleTokenStream(adaptor,"token KW_ADD");
		RewriteRuleSubtreeStream stream_alterStatementSuffixAddPartitionsElement=new RewriteRuleSubtreeStream(adaptor,"rule alterStatementSuffixAddPartitionsElement");
		RewriteRuleSubtreeStream stream_ifNotExists=new RewriteRuleSubtreeStream(adaptor,"rule ifNotExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("add partition statement"); 
		try {
			// HiveParser.g:964:5: ( identifier KW_ADD ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ -> ^( TOK_ALTERTABLE_ADDPARTS identifier ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ ) )
			// HiveParser.g:964:7: identifier KW_ADD ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixAddPartitions4175);
			identifier204=identifier();
			state._fsp--;

			stream_identifier.add(identifier204.getTree());
			KW_ADD205=(Token)match(input,KW_ADD,FOLLOW_KW_ADD_in_alterStatementSuffixAddPartitions4177);  
			stream_KW_ADD.add(KW_ADD205);

			// HiveParser.g:964:25: ( ifNotExists )?
			int alt57=2;
			int LA57_0 = input.LA(1);
			if ( (LA57_0==KW_IF) ) {
				alt57=1;
			}
			switch (alt57) {
				case 1 :
					// HiveParser.g:964:25: ifNotExists
					{
					pushFollow(FOLLOW_ifNotExists_in_alterStatementSuffixAddPartitions4179);
					ifNotExists206=ifNotExists();
					state._fsp--;

					stream_ifNotExists.add(ifNotExists206.getTree());
					}
					break;

			}

			// HiveParser.g:964:38: ( alterStatementSuffixAddPartitionsElement )+
			int cnt58=0;
			loop58:
			while (true) {
				int alt58=2;
				int LA58_0 = input.LA(1);
				if ( (LA58_0==KW_PARTITION) ) {
					alt58=1;
				}

				switch (alt58) {
				case 1 :
					// HiveParser.g:964:38: alterStatementSuffixAddPartitionsElement
					{
					pushFollow(FOLLOW_alterStatementSuffixAddPartitionsElement_in_alterStatementSuffixAddPartitions4182);
					alterStatementSuffixAddPartitionsElement207=alterStatementSuffixAddPartitionsElement();
					state._fsp--;

					stream_alterStatementSuffixAddPartitionsElement.add(alterStatementSuffixAddPartitionsElement207.getTree());
					}
					break;

				default :
					if ( cnt58 >= 1 ) break loop58;
					EarlyExitException eee = new EarlyExitException(58, input);
					throw eee;
				}
				cnt58++;
			}

			// AST REWRITE
			// elements: alterStatementSuffixAddPartitionsElement, ifNotExists, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 965:5: -> ^( TOK_ALTERTABLE_ADDPARTS identifier ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ )
			{
				// HiveParser.g:965:8: ^( TOK_ALTERTABLE_ADDPARTS identifier ( ifNotExists )? ( alterStatementSuffixAddPartitionsElement )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ADDPARTS, "TOK_ALTERTABLE_ADDPARTS"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:965:45: ( ifNotExists )?
				if ( stream_ifNotExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifNotExists.nextTree());
				}
				stream_ifNotExists.reset();

				if ( !(stream_alterStatementSuffixAddPartitionsElement.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_alterStatementSuffixAddPartitionsElement.hasNext() ) {
					adaptor.addChild(root_1, stream_alterStatementSuffixAddPartitionsElement.nextTree());
				}
				stream_alterStatementSuffixAddPartitionsElement.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixAddPartitions"


	public static class alterStatementSuffixAddPartitionsElement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixAddPartitionsElement"
	// HiveParser.g:968:1: alterStatementSuffixAddPartitionsElement : partitionSpec ( partitionLocation )? ;
	public final HiveParser.alterStatementSuffixAddPartitionsElement_return alterStatementSuffixAddPartitionsElement() throws RecognitionException {
		HiveParser.alterStatementSuffixAddPartitionsElement_return retval = new HiveParser.alterStatementSuffixAddPartitionsElement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope partitionSpec208 =null;
		ParserRuleReturnScope partitionLocation209 =null;


		try {
			// HiveParser.g:969:5: ( partitionSpec ( partitionLocation )? )
			// HiveParser.g:969:7: partitionSpec ( partitionLocation )?
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixAddPartitionsElement4218);
			partitionSpec208=partitionSpec();
			state._fsp--;

			adaptor.addChild(root_0, partitionSpec208.getTree());

			// HiveParser.g:969:21: ( partitionLocation )?
			int alt59=2;
			int LA59_0 = input.LA(1);
			if ( (LA59_0==KW_LOCATION) ) {
				alt59=1;
			}
			switch (alt59) {
				case 1 :
					// HiveParser.g:969:21: partitionLocation
					{
					pushFollow(FOLLOW_partitionLocation_in_alterStatementSuffixAddPartitionsElement4220);
					partitionLocation209=partitionLocation();
					state._fsp--;

					adaptor.addChild(root_0, partitionLocation209.getTree());

					}
					break;

			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixAddPartitionsElement"


	public static class alterStatementSuffixTouch_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixTouch"
	// HiveParser.g:972:1: alterStatementSuffixTouch : identifier KW_TOUCH ( partitionSpec )* -> ^( TOK_ALTERTABLE_TOUCH identifier ( partitionSpec )* ) ;
	public final HiveParser.alterStatementSuffixTouch_return alterStatementSuffixTouch() throws RecognitionException {
		HiveParser.alterStatementSuffixTouch_return retval = new HiveParser.alterStatementSuffixTouch_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_TOUCH211=null;
		ParserRuleReturnScope identifier210 =null;
		ParserRuleReturnScope partitionSpec212 =null;

		CommonTree KW_TOUCH211_tree=null;
		RewriteRuleTokenStream stream_KW_TOUCH=new RewriteRuleTokenStream(adaptor,"token KW_TOUCH");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("touch statement"); 
		try {
			// HiveParser.g:975:5: ( identifier KW_TOUCH ( partitionSpec )* -> ^( TOK_ALTERTABLE_TOUCH identifier ( partitionSpec )* ) )
			// HiveParser.g:975:7: identifier KW_TOUCH ( partitionSpec )*
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixTouch4248);
			identifier210=identifier();
			state._fsp--;

			stream_identifier.add(identifier210.getTree());
			KW_TOUCH211=(Token)match(input,KW_TOUCH,FOLLOW_KW_TOUCH_in_alterStatementSuffixTouch4250);  
			stream_KW_TOUCH.add(KW_TOUCH211);

			// HiveParser.g:975:27: ( partitionSpec )*
			loop60:
			while (true) {
				int alt60=2;
				int LA60_0 = input.LA(1);
				if ( (LA60_0==KW_PARTITION) ) {
					alt60=1;
				}

				switch (alt60) {
				case 1 :
					// HiveParser.g:975:28: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixTouch4253);
					partitionSpec212=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec212.getTree());
					}
					break;

				default :
					break loop60;
				}
			}

			// AST REWRITE
			// elements: identifier, partitionSpec
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 976:5: -> ^( TOK_ALTERTABLE_TOUCH identifier ( partitionSpec )* )
			{
				// HiveParser.g:976:8: ^( TOK_ALTERTABLE_TOUCH identifier ( partitionSpec )* )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_TOUCH, "TOK_ALTERTABLE_TOUCH"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:976:42: ( partitionSpec )*
				while ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixTouch"


	public static class alterStatementSuffixArchive_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixArchive"
	// HiveParser.g:979:1: alterStatementSuffixArchive : identifier KW_ARCHIVE ( partitionSpec )* -> ^( TOK_ALTERTABLE_ARCHIVE identifier ( partitionSpec )* ) ;
	public final HiveParser.alterStatementSuffixArchive_return alterStatementSuffixArchive() throws RecognitionException {
		HiveParser.alterStatementSuffixArchive_return retval = new HiveParser.alterStatementSuffixArchive_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ARCHIVE214=null;
		ParserRuleReturnScope identifier213 =null;
		ParserRuleReturnScope partitionSpec215 =null;

		CommonTree KW_ARCHIVE214_tree=null;
		RewriteRuleTokenStream stream_KW_ARCHIVE=new RewriteRuleTokenStream(adaptor,"token KW_ARCHIVE");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("archive statement"); 
		try {
			// HiveParser.g:982:5: ( identifier KW_ARCHIVE ( partitionSpec )* -> ^( TOK_ALTERTABLE_ARCHIVE identifier ( partitionSpec )* ) )
			// HiveParser.g:982:7: identifier KW_ARCHIVE ( partitionSpec )*
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixArchive4299);
			identifier213=identifier();
			state._fsp--;

			stream_identifier.add(identifier213.getTree());
			KW_ARCHIVE214=(Token)match(input,KW_ARCHIVE,FOLLOW_KW_ARCHIVE_in_alterStatementSuffixArchive4301);  
			stream_KW_ARCHIVE.add(KW_ARCHIVE214);

			// HiveParser.g:982:29: ( partitionSpec )*
			loop61:
			while (true) {
				int alt61=2;
				int LA61_0 = input.LA(1);
				if ( (LA61_0==KW_PARTITION) ) {
					alt61=1;
				}

				switch (alt61) {
				case 1 :
					// HiveParser.g:982:30: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixArchive4304);
					partitionSpec215=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec215.getTree());
					}
					break;

				default :
					break loop61;
				}
			}

			// AST REWRITE
			// elements: identifier, partitionSpec
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 983:5: -> ^( TOK_ALTERTABLE_ARCHIVE identifier ( partitionSpec )* )
			{
				// HiveParser.g:983:8: ^( TOK_ALTERTABLE_ARCHIVE identifier ( partitionSpec )* )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ARCHIVE, "TOK_ALTERTABLE_ARCHIVE"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:983:44: ( partitionSpec )*
				while ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixArchive"


	public static class alterStatementSuffixUnArchive_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixUnArchive"
	// HiveParser.g:986:1: alterStatementSuffixUnArchive : identifier KW_UNARCHIVE ( partitionSpec )* -> ^( TOK_ALTERTABLE_UNARCHIVE identifier ( partitionSpec )* ) ;
	public final HiveParser.alterStatementSuffixUnArchive_return alterStatementSuffixUnArchive() throws RecognitionException {
		HiveParser.alterStatementSuffixUnArchive_return retval = new HiveParser.alterStatementSuffixUnArchive_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_UNARCHIVE217=null;
		ParserRuleReturnScope identifier216 =null;
		ParserRuleReturnScope partitionSpec218 =null;

		CommonTree KW_UNARCHIVE217_tree=null;
		RewriteRuleTokenStream stream_KW_UNARCHIVE=new RewriteRuleTokenStream(adaptor,"token KW_UNARCHIVE");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("unarchive statement"); 
		try {
			// HiveParser.g:989:5: ( identifier KW_UNARCHIVE ( partitionSpec )* -> ^( TOK_ALTERTABLE_UNARCHIVE identifier ( partitionSpec )* ) )
			// HiveParser.g:989:7: identifier KW_UNARCHIVE ( partitionSpec )*
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixUnArchive4350);
			identifier216=identifier();
			state._fsp--;

			stream_identifier.add(identifier216.getTree());
			KW_UNARCHIVE217=(Token)match(input,KW_UNARCHIVE,FOLLOW_KW_UNARCHIVE_in_alterStatementSuffixUnArchive4352);  
			stream_KW_UNARCHIVE.add(KW_UNARCHIVE217);

			// HiveParser.g:989:31: ( partitionSpec )*
			loop62:
			while (true) {
				int alt62=2;
				int LA62_0 = input.LA(1);
				if ( (LA62_0==KW_PARTITION) ) {
					alt62=1;
				}

				switch (alt62) {
				case 1 :
					// HiveParser.g:989:32: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixUnArchive4355);
					partitionSpec218=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec218.getTree());
					}
					break;

				default :
					break loop62;
				}
			}

			// AST REWRITE
			// elements: partitionSpec, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 990:5: -> ^( TOK_ALTERTABLE_UNARCHIVE identifier ( partitionSpec )* )
			{
				// HiveParser.g:990:8: ^( TOK_ALTERTABLE_UNARCHIVE identifier ( partitionSpec )* )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_UNARCHIVE, "TOK_ALTERTABLE_UNARCHIVE"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:990:46: ( partitionSpec )*
				while ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixUnArchive"


	public static class partitionLocation_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "partitionLocation"
	// HiveParser.g:993:1: partitionLocation : KW_LOCATION locn= StringLiteral -> ^( TOK_PARTITIONLOCATION $locn) ;
	public final HiveParser.partitionLocation_return partitionLocation() throws RecognitionException {
		HiveParser.partitionLocation_return retval = new HiveParser.partitionLocation_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token locn=null;
		Token KW_LOCATION219=null;

		CommonTree locn_tree=null;
		CommonTree KW_LOCATION219_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_LOCATION=new RewriteRuleTokenStream(adaptor,"token KW_LOCATION");

		 msgs.push("partition location"); 
		try {
			// HiveParser.g:996:5: ( KW_LOCATION locn= StringLiteral -> ^( TOK_PARTITIONLOCATION $locn) )
			// HiveParser.g:997:7: KW_LOCATION locn= StringLiteral
			{
			KW_LOCATION219=(Token)match(input,KW_LOCATION,FOLLOW_KW_LOCATION_in_partitionLocation4407);  
			stream_KW_LOCATION.add(KW_LOCATION219);

			locn=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_partitionLocation4411);  
			stream_StringLiteral.add(locn);

			// AST REWRITE
			// elements: locn
			// token labels: locn
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_locn=new RewriteRuleTokenStream(adaptor,"token locn",locn);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 997:38: -> ^( TOK_PARTITIONLOCATION $locn)
			{
				// HiveParser.g:997:41: ^( TOK_PARTITIONLOCATION $locn)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PARTITIONLOCATION, "TOK_PARTITIONLOCATION"), root_1);
				adaptor.addChild(root_1, stream_locn.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "partitionLocation"


	public static class alterStatementSuffixDropPartitions_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixDropPartitions"
	// HiveParser.g:1000:1: alterStatementSuffixDropPartitions : identifier KW_DROP ( ifExists )? dropPartitionSpec ( COMMA dropPartitionSpec )* ( ignoreProtection )? -> ^( TOK_ALTERTABLE_DROPPARTS identifier ( dropPartitionSpec )+ ( ifExists )? ( ignoreProtection )? ) ;
	public final HiveParser.alterStatementSuffixDropPartitions_return alterStatementSuffixDropPartitions() throws RecognitionException {
		HiveParser.alterStatementSuffixDropPartitions_return retval = new HiveParser.alterStatementSuffixDropPartitions_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP221=null;
		Token COMMA224=null;
		ParserRuleReturnScope identifier220 =null;
		ParserRuleReturnScope ifExists222 =null;
		ParserRuleReturnScope dropPartitionSpec223 =null;
		ParserRuleReturnScope dropPartitionSpec225 =null;
		ParserRuleReturnScope ignoreProtection226 =null;

		CommonTree KW_DROP221_tree=null;
		CommonTree COMMA224_tree=null;
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_dropPartitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule dropPartitionSpec");
		RewriteRuleSubtreeStream stream_ignoreProtection=new RewriteRuleSubtreeStream(adaptor,"rule ignoreProtection");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("drop partition statement"); 
		try {
			// HiveParser.g:1003:5: ( identifier KW_DROP ( ifExists )? dropPartitionSpec ( COMMA dropPartitionSpec )* ( ignoreProtection )? -> ^( TOK_ALTERTABLE_DROPPARTS identifier ( dropPartitionSpec )+ ( ifExists )? ( ignoreProtection )? ) )
			// HiveParser.g:1003:7: identifier KW_DROP ( ifExists )? dropPartitionSpec ( COMMA dropPartitionSpec )* ( ignoreProtection )?
			{
			pushFollow(FOLLOW_identifier_in_alterStatementSuffixDropPartitions4447);
			identifier220=identifier();
			state._fsp--;

			stream_identifier.add(identifier220.getTree());
			KW_DROP221=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_alterStatementSuffixDropPartitions4449);  
			stream_KW_DROP.add(KW_DROP221);

			// HiveParser.g:1003:26: ( ifExists )?
			int alt63=2;
			int LA63_0 = input.LA(1);
			if ( (LA63_0==KW_IF) ) {
				alt63=1;
			}
			switch (alt63) {
				case 1 :
					// HiveParser.g:1003:26: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_alterStatementSuffixDropPartitions4451);
					ifExists222=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists222.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_dropPartitionSpec_in_alterStatementSuffixDropPartitions4454);
			dropPartitionSpec223=dropPartitionSpec();
			state._fsp--;

			stream_dropPartitionSpec.add(dropPartitionSpec223.getTree());
			// HiveParser.g:1003:54: ( COMMA dropPartitionSpec )*
			loop64:
			while (true) {
				int alt64=2;
				int LA64_0 = input.LA(1);
				if ( (LA64_0==COMMA) ) {
					alt64=1;
				}

				switch (alt64) {
				case 1 :
					// HiveParser.g:1003:55: COMMA dropPartitionSpec
					{
					COMMA224=(Token)match(input,COMMA,FOLLOW_COMMA_in_alterStatementSuffixDropPartitions4457);  
					stream_COMMA.add(COMMA224);

					pushFollow(FOLLOW_dropPartitionSpec_in_alterStatementSuffixDropPartitions4459);
					dropPartitionSpec225=dropPartitionSpec();
					state._fsp--;

					stream_dropPartitionSpec.add(dropPartitionSpec225.getTree());
					}
					break;

				default :
					break loop64;
				}
			}

			// HiveParser.g:1003:81: ( ignoreProtection )?
			int alt65=2;
			int LA65_0 = input.LA(1);
			if ( (LA65_0==KW_IGNORE) ) {
				alt65=1;
			}
			switch (alt65) {
				case 1 :
					// HiveParser.g:1003:81: ignoreProtection
					{
					pushFollow(FOLLOW_ignoreProtection_in_alterStatementSuffixDropPartitions4463);
					ignoreProtection226=ignoreProtection();
					state._fsp--;

					stream_ignoreProtection.add(ignoreProtection226.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: ifExists, ignoreProtection, dropPartitionSpec, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1004:5: -> ^( TOK_ALTERTABLE_DROPPARTS identifier ( dropPartitionSpec )+ ( ifExists )? ( ignoreProtection )? )
			{
				// HiveParser.g:1004:8: ^( TOK_ALTERTABLE_DROPPARTS identifier ( dropPartitionSpec )+ ( ifExists )? ( ignoreProtection )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_DROPPARTS, "TOK_ALTERTABLE_DROPPARTS"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				if ( !(stream_dropPartitionSpec.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_dropPartitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_dropPartitionSpec.nextTree());
				}
				stream_dropPartitionSpec.reset();

				// HiveParser.g:1004:65: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				// HiveParser.g:1004:75: ( ignoreProtection )?
				if ( stream_ignoreProtection.hasNext() ) {
					adaptor.addChild(root_1, stream_ignoreProtection.nextTree());
				}
				stream_ignoreProtection.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixDropPartitions"


	public static class alterStatementSuffixProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixProperties"
	// HiveParser.g:1007:1: alterStatementSuffixProperties : (name= identifier KW_SET KW_TBLPROPERTIES tableProperties -> ^( TOK_ALTERTABLE_PROPERTIES $name tableProperties ) |name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties -> ^( TOK_DROPTABLE_PROPERTIES $name tableProperties ( ifExists )? ) );
	public final HiveParser.alterStatementSuffixProperties_return alterStatementSuffixProperties() throws RecognitionException {
		HiveParser.alterStatementSuffixProperties_return retval = new HiveParser.alterStatementSuffixProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SET227=null;
		Token KW_TBLPROPERTIES228=null;
		Token KW_UNSET230=null;
		Token KW_TBLPROPERTIES231=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope tableProperties229 =null;
		ParserRuleReturnScope ifExists232 =null;
		ParserRuleReturnScope tableProperties233 =null;

		CommonTree KW_SET227_tree=null;
		CommonTree KW_TBLPROPERTIES228_tree=null;
		CommonTree KW_UNSET230_tree=null;
		CommonTree KW_TBLPROPERTIES231_tree=null;
		RewriteRuleTokenStream stream_KW_UNSET=new RewriteRuleTokenStream(adaptor,"token KW_UNSET");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_TBLPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_TBLPROPERTIES");
		RewriteRuleSubtreeStream stream_tableProperties=new RewriteRuleSubtreeStream(adaptor,"rule tableProperties");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("alter properties statement"); 
		try {
			// HiveParser.g:1010:5: (name= identifier KW_SET KW_TBLPROPERTIES tableProperties -> ^( TOK_ALTERTABLE_PROPERTIES $name tableProperties ) |name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties -> ^( TOK_DROPTABLE_PROPERTIES $name tableProperties ( ifExists )? ) )
			int alt67=2;
			int LA67_0 = input.LA(1);
			if ( (LA67_0==Identifier) ) {
				int LA67_1 = input.LA(2);
				if ( (LA67_1==KW_SET) ) {
					alt67=1;
				}
				else if ( (LA67_1==KW_UNSET) ) {
					alt67=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 67, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( ((LA67_0 >= KW_ADD && LA67_0 <= KW_AFTER)||(LA67_0 >= KW_ALTER && LA67_0 <= KW_ANALYZE)||(LA67_0 >= KW_ARCHIVE && LA67_0 <= KW_CASCADE)||(LA67_0 >= KW_CHANGE && LA67_0 <= KW_COLLECTION)||(LA67_0 >= KW_COLUMNS && LA67_0 <= KW_CONCATENATE)||(LA67_0 >= KW_CONTINUE && LA67_0 <= KW_CREATE)||LA67_0==KW_CUBE||(LA67_0 >= KW_CURSOR && LA67_0 <= KW_DATA)||(LA67_0 >= KW_DATABASES && LA67_0 <= KW_DATETIME)||(LA67_0 >= KW_DBPROPERTIES && LA67_0 <= KW_DISABLE)||(LA67_0 >= KW_DISTRIBUTE && LA67_0 <= KW_ELEM_TYPE)||LA67_0==KW_ENABLE||LA67_0==KW_ESCAPED||(LA67_0 >= KW_EXCLUSIVE && LA67_0 <= KW_EXPORT)||(LA67_0 >= KW_EXTERNAL && LA67_0 <= KW_FLOAT)||(LA67_0 >= KW_FOR && LA67_0 <= KW_FORMATTED)||LA67_0==KW_FULL||(LA67_0 >= KW_FUNCTIONS && LA67_0 <= KW_GROUPING)||LA67_0==KW_HOLD_DDLTIME||LA67_0==KW_IDXPROPERTIES||(LA67_0 >= KW_IGNORE && LA67_0 <= KW_INTERSECT)||(LA67_0 >= KW_INTO && LA67_0 <= KW_ITEMS)||(LA67_0 >= KW_KEYS && LA67_0 <= KW_LEFT)||(LA67_0 >= KW_LIKE && LA67_0 <= KW_LONG)||(LA67_0 >= KW_MAPJOIN && LA67_0 <= KW_MINUS)||(LA67_0 >= KW_MSCK && LA67_0 <= KW_NOSCAN)||(LA67_0 >= KW_NO_DROP && LA67_0 <= KW_OFFLINE)||LA67_0==KW_OPTION||(LA67_0 >= KW_ORCFILE && LA67_0 <= KW_OUTPUTFORMAT)||LA67_0==KW_OVERWRITE||(LA67_0 >= KW_PARTITION && LA67_0 <= KW_PLUS)||(LA67_0 >= KW_PRETTY && LA67_0 <= KW_RECORDWRITER)||(LA67_0 >= KW_REGEXP && LA67_0 <= KW_SCHEMAS)||(LA67_0 >= KW_SEMI && LA67_0 <= KW_TABLES)||(LA67_0 >= KW_TBLPROPERTIES && LA67_0 <= KW_TEXTFILE)||(LA67_0 >= KW_TIMESTAMP && LA67_0 <= KW_TOUCH)||(LA67_0 >= KW_TRIGGER && LA67_0 <= KW_UNARCHIVE)||(LA67_0 >= KW_UNDO && LA67_0 <= KW_UNIONTYPE)||(LA67_0 >= KW_UNLOCK && LA67_0 <= KW_VALUE_TYPE)||LA67_0==KW_VIEW||LA67_0==KW_WHILE||LA67_0==KW_WITH) ) {
				int LA67_2 = input.LA(2);
				if ( (LA67_2==KW_SET) ) {
					alt67=1;
				}
				else if ( (LA67_2==KW_UNSET) ) {
					alt67=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 67, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 67, 0, input);
				throw nvae;
			}

			switch (alt67) {
				case 1 :
					// HiveParser.g:1010:7: name= identifier KW_SET KW_TBLPROPERTIES tableProperties
					{
					pushFollow(FOLLOW_identifier_in_alterStatementSuffixProperties4514);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_SET227=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterStatementSuffixProperties4516);  
					stream_KW_SET.add(KW_SET227);

					KW_TBLPROPERTIES228=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_alterStatementSuffixProperties4518);  
					stream_KW_TBLPROPERTIES.add(KW_TBLPROPERTIES228);

					pushFollow(FOLLOW_tableProperties_in_alterStatementSuffixProperties4520);
					tableProperties229=tableProperties();
					state._fsp--;

					stream_tableProperties.add(tableProperties229.getTree());
					// AST REWRITE
					// elements: tableProperties, name
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1011:5: -> ^( TOK_ALTERTABLE_PROPERTIES $name tableProperties )
					{
						// HiveParser.g:1011:8: ^( TOK_ALTERTABLE_PROPERTIES $name tableProperties )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_PROPERTIES, "TOK_ALTERTABLE_PROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_tableProperties.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1012:7: name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties
					{
					pushFollow(FOLLOW_identifier_in_alterStatementSuffixProperties4545);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_UNSET230=(Token)match(input,KW_UNSET,FOLLOW_KW_UNSET_in_alterStatementSuffixProperties4547);  
					stream_KW_UNSET.add(KW_UNSET230);

					KW_TBLPROPERTIES231=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_alterStatementSuffixProperties4549);  
					stream_KW_TBLPROPERTIES.add(KW_TBLPROPERTIES231);

					// HiveParser.g:1012:49: ( ifExists )?
					int alt66=2;
					int LA66_0 = input.LA(1);
					if ( (LA66_0==KW_IF) ) {
						alt66=1;
					}
					switch (alt66) {
						case 1 :
							// HiveParser.g:1012:49: ifExists
							{
							pushFollow(FOLLOW_ifExists_in_alterStatementSuffixProperties4551);
							ifExists232=ifExists();
							state._fsp--;

							stream_ifExists.add(ifExists232.getTree());
							}
							break;

					}

					pushFollow(FOLLOW_tableProperties_in_alterStatementSuffixProperties4554);
					tableProperties233=tableProperties();
					state._fsp--;

					stream_tableProperties.add(tableProperties233.getTree());
					// AST REWRITE
					// elements: name, tableProperties, ifExists
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1013:5: -> ^( TOK_DROPTABLE_PROPERTIES $name tableProperties ( ifExists )? )
					{
						// HiveParser.g:1013:8: ^( TOK_DROPTABLE_PROPERTIES $name tableProperties ( ifExists )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPTABLE_PROPERTIES, "TOK_DROPTABLE_PROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_tableProperties.nextTree());
						// HiveParser.g:1013:57: ( ifExists )?
						if ( stream_ifExists.hasNext() ) {
							adaptor.addChild(root_1, stream_ifExists.nextTree());
						}
						stream_ifExists.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixProperties"


	public static class alterViewSuffixProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterViewSuffixProperties"
	// HiveParser.g:1016:1: alterViewSuffixProperties : (name= identifier KW_SET KW_TBLPROPERTIES tableProperties -> ^( TOK_ALTERVIEW_PROPERTIES $name tableProperties ) |name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties -> ^( TOK_DROPVIEW_PROPERTIES $name tableProperties ( ifExists )? ) );
	public final HiveParser.alterViewSuffixProperties_return alterViewSuffixProperties() throws RecognitionException {
		HiveParser.alterViewSuffixProperties_return retval = new HiveParser.alterViewSuffixProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SET234=null;
		Token KW_TBLPROPERTIES235=null;
		Token KW_UNSET237=null;
		Token KW_TBLPROPERTIES238=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope tableProperties236 =null;
		ParserRuleReturnScope ifExists239 =null;
		ParserRuleReturnScope tableProperties240 =null;

		CommonTree KW_SET234_tree=null;
		CommonTree KW_TBLPROPERTIES235_tree=null;
		CommonTree KW_UNSET237_tree=null;
		CommonTree KW_TBLPROPERTIES238_tree=null;
		RewriteRuleTokenStream stream_KW_UNSET=new RewriteRuleTokenStream(adaptor,"token KW_UNSET");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_TBLPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_TBLPROPERTIES");
		RewriteRuleSubtreeStream stream_tableProperties=new RewriteRuleSubtreeStream(adaptor,"rule tableProperties");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("alter view properties statement"); 
		try {
			// HiveParser.g:1019:5: (name= identifier KW_SET KW_TBLPROPERTIES tableProperties -> ^( TOK_ALTERVIEW_PROPERTIES $name tableProperties ) |name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties -> ^( TOK_DROPVIEW_PROPERTIES $name tableProperties ( ifExists )? ) )
			int alt69=2;
			int LA69_0 = input.LA(1);
			if ( (LA69_0==Identifier) ) {
				int LA69_1 = input.LA(2);
				if ( (LA69_1==KW_SET) ) {
					alt69=1;
				}
				else if ( (LA69_1==KW_UNSET) ) {
					alt69=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 69, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( ((LA69_0 >= KW_ADD && LA69_0 <= KW_AFTER)||(LA69_0 >= KW_ALTER && LA69_0 <= KW_ANALYZE)||(LA69_0 >= KW_ARCHIVE && LA69_0 <= KW_CASCADE)||(LA69_0 >= KW_CHANGE && LA69_0 <= KW_COLLECTION)||(LA69_0 >= KW_COLUMNS && LA69_0 <= KW_CONCATENATE)||(LA69_0 >= KW_CONTINUE && LA69_0 <= KW_CREATE)||LA69_0==KW_CUBE||(LA69_0 >= KW_CURSOR && LA69_0 <= KW_DATA)||(LA69_0 >= KW_DATABASES && LA69_0 <= KW_DATETIME)||(LA69_0 >= KW_DBPROPERTIES && LA69_0 <= KW_DISABLE)||(LA69_0 >= KW_DISTRIBUTE && LA69_0 <= KW_ELEM_TYPE)||LA69_0==KW_ENABLE||LA69_0==KW_ESCAPED||(LA69_0 >= KW_EXCLUSIVE && LA69_0 <= KW_EXPORT)||(LA69_0 >= KW_EXTERNAL && LA69_0 <= KW_FLOAT)||(LA69_0 >= KW_FOR && LA69_0 <= KW_FORMATTED)||LA69_0==KW_FULL||(LA69_0 >= KW_FUNCTIONS && LA69_0 <= KW_GROUPING)||LA69_0==KW_HOLD_DDLTIME||LA69_0==KW_IDXPROPERTIES||(LA69_0 >= KW_IGNORE && LA69_0 <= KW_INTERSECT)||(LA69_0 >= KW_INTO && LA69_0 <= KW_ITEMS)||(LA69_0 >= KW_KEYS && LA69_0 <= KW_LEFT)||(LA69_0 >= KW_LIKE && LA69_0 <= KW_LONG)||(LA69_0 >= KW_MAPJOIN && LA69_0 <= KW_MINUS)||(LA69_0 >= KW_MSCK && LA69_0 <= KW_NOSCAN)||(LA69_0 >= KW_NO_DROP && LA69_0 <= KW_OFFLINE)||LA69_0==KW_OPTION||(LA69_0 >= KW_ORCFILE && LA69_0 <= KW_OUTPUTFORMAT)||LA69_0==KW_OVERWRITE||(LA69_0 >= KW_PARTITION && LA69_0 <= KW_PLUS)||(LA69_0 >= KW_PRETTY && LA69_0 <= KW_RECORDWRITER)||(LA69_0 >= KW_REGEXP && LA69_0 <= KW_SCHEMAS)||(LA69_0 >= KW_SEMI && LA69_0 <= KW_TABLES)||(LA69_0 >= KW_TBLPROPERTIES && LA69_0 <= KW_TEXTFILE)||(LA69_0 >= KW_TIMESTAMP && LA69_0 <= KW_TOUCH)||(LA69_0 >= KW_TRIGGER && LA69_0 <= KW_UNARCHIVE)||(LA69_0 >= KW_UNDO && LA69_0 <= KW_UNIONTYPE)||(LA69_0 >= KW_UNLOCK && LA69_0 <= KW_VALUE_TYPE)||LA69_0==KW_VIEW||LA69_0==KW_WHILE||LA69_0==KW_WITH) ) {
				int LA69_2 = input.LA(2);
				if ( (LA69_2==KW_SET) ) {
					alt69=1;
				}
				else if ( (LA69_2==KW_UNSET) ) {
					alt69=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 69, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 69, 0, input);
				throw nvae;
			}

			switch (alt69) {
				case 1 :
					// HiveParser.g:1019:7: name= identifier KW_SET KW_TBLPROPERTIES tableProperties
					{
					pushFollow(FOLLOW_identifier_in_alterViewSuffixProperties4601);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_SET234=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterViewSuffixProperties4603);  
					stream_KW_SET.add(KW_SET234);

					KW_TBLPROPERTIES235=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_alterViewSuffixProperties4605);  
					stream_KW_TBLPROPERTIES.add(KW_TBLPROPERTIES235);

					pushFollow(FOLLOW_tableProperties_in_alterViewSuffixProperties4607);
					tableProperties236=tableProperties();
					state._fsp--;

					stream_tableProperties.add(tableProperties236.getTree());
					// AST REWRITE
					// elements: name, tableProperties
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1020:5: -> ^( TOK_ALTERVIEW_PROPERTIES $name tableProperties )
					{
						// HiveParser.g:1020:8: ^( TOK_ALTERVIEW_PROPERTIES $name tableProperties )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERVIEW_PROPERTIES, "TOK_ALTERVIEW_PROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_tableProperties.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1021:7: name= identifier KW_UNSET KW_TBLPROPERTIES ( ifExists )? tableProperties
					{
					pushFollow(FOLLOW_identifier_in_alterViewSuffixProperties4632);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_UNSET237=(Token)match(input,KW_UNSET,FOLLOW_KW_UNSET_in_alterViewSuffixProperties4634);  
					stream_KW_UNSET.add(KW_UNSET237);

					KW_TBLPROPERTIES238=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_alterViewSuffixProperties4636);  
					stream_KW_TBLPROPERTIES.add(KW_TBLPROPERTIES238);

					// HiveParser.g:1021:49: ( ifExists )?
					int alt68=2;
					int LA68_0 = input.LA(1);
					if ( (LA68_0==KW_IF) ) {
						alt68=1;
					}
					switch (alt68) {
						case 1 :
							// HiveParser.g:1021:49: ifExists
							{
							pushFollow(FOLLOW_ifExists_in_alterViewSuffixProperties4638);
							ifExists239=ifExists();
							state._fsp--;

							stream_ifExists.add(ifExists239.getTree());
							}
							break;

					}

					pushFollow(FOLLOW_tableProperties_in_alterViewSuffixProperties4641);
					tableProperties240=tableProperties();
					state._fsp--;

					stream_tableProperties.add(tableProperties240.getTree());
					// AST REWRITE
					// elements: tableProperties, ifExists, name
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1022:5: -> ^( TOK_DROPVIEW_PROPERTIES $name tableProperties ( ifExists )? )
					{
						// HiveParser.g:1022:8: ^( TOK_DROPVIEW_PROPERTIES $name tableProperties ( ifExists )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPVIEW_PROPERTIES, "TOK_DROPVIEW_PROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_tableProperties.nextTree());
						// HiveParser.g:1022:56: ( ifExists )?
						if ( stream_ifExists.hasNext() ) {
							adaptor.addChild(root_1, stream_ifExists.nextTree());
						}
						stream_ifExists.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterViewSuffixProperties"


	public static class alterStatementSuffixSerdeProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixSerdeProperties"
	// HiveParser.g:1025:1: alterStatementSuffixSerdeProperties : ( KW_SET KW_SERDE serdeName= StringLiteral ( KW_WITH KW_SERDEPROPERTIES tableProperties )? -> ^( TOK_ALTERTABLE_SERIALIZER $serdeName ( tableProperties )? ) | KW_SET KW_SERDEPROPERTIES tableProperties -> ^( TOK_ALTERTABLE_SERDEPROPERTIES tableProperties ) );
	public final HiveParser.alterStatementSuffixSerdeProperties_return alterStatementSuffixSerdeProperties() throws RecognitionException {
		HiveParser.alterStatementSuffixSerdeProperties_return retval = new HiveParser.alterStatementSuffixSerdeProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token serdeName=null;
		Token KW_SET241=null;
		Token KW_SERDE242=null;
		Token KW_WITH243=null;
		Token KW_SERDEPROPERTIES244=null;
		Token KW_SET246=null;
		Token KW_SERDEPROPERTIES247=null;
		ParserRuleReturnScope tableProperties245 =null;
		ParserRuleReturnScope tableProperties248 =null;

		CommonTree serdeName_tree=null;
		CommonTree KW_SET241_tree=null;
		CommonTree KW_SERDE242_tree=null;
		CommonTree KW_WITH243_tree=null;
		CommonTree KW_SERDEPROPERTIES244_tree=null;
		CommonTree KW_SET246_tree=null;
		CommonTree KW_SERDEPROPERTIES247_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_SERDE=new RewriteRuleTokenStream(adaptor,"token KW_SERDE");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_SERDEPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_SERDEPROPERTIES");
		RewriteRuleSubtreeStream stream_tableProperties=new RewriteRuleSubtreeStream(adaptor,"rule tableProperties");

		 msgs.push("alter serdes statement"); 
		try {
			// HiveParser.g:1028:5: ( KW_SET KW_SERDE serdeName= StringLiteral ( KW_WITH KW_SERDEPROPERTIES tableProperties )? -> ^( TOK_ALTERTABLE_SERIALIZER $serdeName ( tableProperties )? ) | KW_SET KW_SERDEPROPERTIES tableProperties -> ^( TOK_ALTERTABLE_SERDEPROPERTIES tableProperties ) )
			int alt71=2;
			int LA71_0 = input.LA(1);
			if ( (LA71_0==KW_SET) ) {
				int LA71_1 = input.LA(2);
				if ( (LA71_1==KW_SERDE) ) {
					alt71=1;
				}
				else if ( (LA71_1==KW_SERDEPROPERTIES) ) {
					alt71=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 71, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 71, 0, input);
				throw nvae;
			}

			switch (alt71) {
				case 1 :
					// HiveParser.g:1028:7: KW_SET KW_SERDE serdeName= StringLiteral ( KW_WITH KW_SERDEPROPERTIES tableProperties )?
					{
					KW_SET241=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterStatementSuffixSerdeProperties4686);  
					stream_KW_SET.add(KW_SET241);

					KW_SERDE242=(Token)match(input,KW_SERDE,FOLLOW_KW_SERDE_in_alterStatementSuffixSerdeProperties4688);  
					stream_KW_SERDE.add(KW_SERDE242);

					serdeName=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_alterStatementSuffixSerdeProperties4692);  
					stream_StringLiteral.add(serdeName);

					// HiveParser.g:1028:47: ( KW_WITH KW_SERDEPROPERTIES tableProperties )?
					int alt70=2;
					int LA70_0 = input.LA(1);
					if ( (LA70_0==KW_WITH) ) {
						alt70=1;
					}
					switch (alt70) {
						case 1 :
							// HiveParser.g:1028:48: KW_WITH KW_SERDEPROPERTIES tableProperties
							{
							KW_WITH243=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_alterStatementSuffixSerdeProperties4695);  
							stream_KW_WITH.add(KW_WITH243);

							KW_SERDEPROPERTIES244=(Token)match(input,KW_SERDEPROPERTIES,FOLLOW_KW_SERDEPROPERTIES_in_alterStatementSuffixSerdeProperties4697);  
							stream_KW_SERDEPROPERTIES.add(KW_SERDEPROPERTIES244);

							pushFollow(FOLLOW_tableProperties_in_alterStatementSuffixSerdeProperties4699);
							tableProperties245=tableProperties();
							state._fsp--;

							stream_tableProperties.add(tableProperties245.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: tableProperties, serdeName
					// token labels: serdeName
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_serdeName=new RewriteRuleTokenStream(adaptor,"token serdeName",serdeName);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1029:5: -> ^( TOK_ALTERTABLE_SERIALIZER $serdeName ( tableProperties )? )
					{
						// HiveParser.g:1029:8: ^( TOK_ALTERTABLE_SERIALIZER $serdeName ( tableProperties )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_SERIALIZER, "TOK_ALTERTABLE_SERIALIZER"), root_1);
						adaptor.addChild(root_1, stream_serdeName.nextNode());
						// HiveParser.g:1029:47: ( tableProperties )?
						if ( stream_tableProperties.hasNext() ) {
							adaptor.addChild(root_1, stream_tableProperties.nextTree());
						}
						stream_tableProperties.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1030:7: KW_SET KW_SERDEPROPERTIES tableProperties
					{
					KW_SET246=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterStatementSuffixSerdeProperties4725);  
					stream_KW_SET.add(KW_SET246);

					KW_SERDEPROPERTIES247=(Token)match(input,KW_SERDEPROPERTIES,FOLLOW_KW_SERDEPROPERTIES_in_alterStatementSuffixSerdeProperties4727);  
					stream_KW_SERDEPROPERTIES.add(KW_SERDEPROPERTIES247);

					pushFollow(FOLLOW_tableProperties_in_alterStatementSuffixSerdeProperties4729);
					tableProperties248=tableProperties();
					state._fsp--;

					stream_tableProperties.add(tableProperties248.getTree());
					// AST REWRITE
					// elements: tableProperties
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1031:5: -> ^( TOK_ALTERTABLE_SERDEPROPERTIES tableProperties )
					{
						// HiveParser.g:1031:8: ^( TOK_ALTERTABLE_SERDEPROPERTIES tableProperties )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_SERDEPROPERTIES, "TOK_ALTERTABLE_SERDEPROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_tableProperties.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixSerdeProperties"


	public static class tablePartitionPrefix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tablePartitionPrefix"
	// HiveParser.g:1034:1: tablePartitionPrefix : name= identifier ( partitionSpec )? -> ^( TOK_TABLE_PARTITION $name ( partitionSpec )? ) ;
	public final HiveParser.tablePartitionPrefix_return tablePartitionPrefix() throws RecognitionException {
		HiveParser.tablePartitionPrefix_return retval = new HiveParser.tablePartitionPrefix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope name =null;
		ParserRuleReturnScope partitionSpec249 =null;

		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("table partition prefix");
		try {
			// HiveParser.g:1037:3: (name= identifier ( partitionSpec )? -> ^( TOK_TABLE_PARTITION $name ( partitionSpec )? ) )
			// HiveParser.g:1037:4: name= identifier ( partitionSpec )?
			{
			pushFollow(FOLLOW_identifier_in_tablePartitionPrefix4767);
			name=identifier();
			state._fsp--;

			stream_identifier.add(name.getTree());
			// HiveParser.g:1037:20: ( partitionSpec )?
			int alt72=2;
			int LA72_0 = input.LA(1);
			if ( (LA72_0==KW_PARTITION) ) {
				alt72=1;
			}
			switch (alt72) {
				case 1 :
					// HiveParser.g:1037:20: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_tablePartitionPrefix4769);
					partitionSpec249=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec249.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: name, partitionSpec
			// token labels: 
			// rule labels: retval, name
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1038:3: -> ^( TOK_TABLE_PARTITION $name ( partitionSpec )? )
			{
				// HiveParser.g:1038:5: ^( TOK_TABLE_PARTITION $name ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLE_PARTITION, "TOK_TABLE_PARTITION"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				// HiveParser.g:1038:33: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tablePartitionPrefix"


	public static class alterTblPartitionStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterTblPartitionStatement"
	// HiveParser.g:1041:1: alterTblPartitionStatement : ( tablePartitionPrefix alterTblPartitionStatementSuffix -> ^( TOK_ALTERTABLE_PARTITION tablePartitionPrefix alterTblPartitionStatementSuffix ) | Identifier KW_PARTITION KW_COLUMN LPAREN columnNameType RPAREN -> ^( TOK_ALTERTABLE_ALTERPARTS Identifier columnNameType ) );
	public final HiveParser.alterTblPartitionStatement_return alterTblPartitionStatement() throws RecognitionException {
		HiveParser.alterTblPartitionStatement_return retval = new HiveParser.alterTblPartitionStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token Identifier252=null;
		Token KW_PARTITION253=null;
		Token KW_COLUMN254=null;
		Token LPAREN255=null;
		Token RPAREN257=null;
		ParserRuleReturnScope tablePartitionPrefix250 =null;
		ParserRuleReturnScope alterTblPartitionStatementSuffix251 =null;
		ParserRuleReturnScope columnNameType256 =null;

		CommonTree Identifier252_tree=null;
		CommonTree KW_PARTITION253_tree=null;
		CommonTree KW_COLUMN254_tree=null;
		CommonTree LPAREN255_tree=null;
		CommonTree RPAREN257_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_COLUMN=new RewriteRuleTokenStream(adaptor,"token KW_COLUMN");
		RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
		RewriteRuleTokenStream stream_KW_PARTITION=new RewriteRuleTokenStream(adaptor,"token KW_PARTITION");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_columnNameType=new RewriteRuleSubtreeStream(adaptor,"rule columnNameType");
		RewriteRuleSubtreeStream stream_alterTblPartitionStatementSuffix=new RewriteRuleSubtreeStream(adaptor,"rule alterTblPartitionStatementSuffix");
		RewriteRuleSubtreeStream stream_tablePartitionPrefix=new RewriteRuleSubtreeStream(adaptor,"rule tablePartitionPrefix");

		msgs.push("alter table partition statement");
		try {
			// HiveParser.g:1044:3: ( tablePartitionPrefix alterTblPartitionStatementSuffix -> ^( TOK_ALTERTABLE_PARTITION tablePartitionPrefix alterTblPartitionStatementSuffix ) | Identifier KW_PARTITION KW_COLUMN LPAREN columnNameType RPAREN -> ^( TOK_ALTERTABLE_ALTERPARTS Identifier columnNameType ) )
			int alt73=2;
			int LA73_0 = input.LA(1);
			if ( (LA73_0==Identifier) ) {
				int LA73_1 = input.LA(2);
				if ( (LA73_1==KW_PARTITION) ) {
					int LA73_3 = input.LA(3);
					if ( (LA73_3==KW_COLUMN) ) {
						alt73=2;
					}
					else if ( (LA73_3==LPAREN) ) {
						alt73=1;
					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 73, 3, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}
				else if ( (LA73_1==KW_CLUSTERED||LA73_1==KW_CONCATENATE||LA73_1==KW_DISABLE||LA73_1==KW_ENABLE||LA73_1==KW_INTO||LA73_1==KW_NOT||LA73_1==KW_RENAME||LA73_1==KW_SET) ) {
					alt73=1;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 73, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( ((LA73_0 >= KW_ADD && LA73_0 <= KW_AFTER)||(LA73_0 >= KW_ALTER && LA73_0 <= KW_ANALYZE)||(LA73_0 >= KW_ARCHIVE && LA73_0 <= KW_CASCADE)||(LA73_0 >= KW_CHANGE && LA73_0 <= KW_COLLECTION)||(LA73_0 >= KW_COLUMNS && LA73_0 <= KW_CONCATENATE)||(LA73_0 >= KW_CONTINUE && LA73_0 <= KW_CREATE)||LA73_0==KW_CUBE||(LA73_0 >= KW_CURSOR && LA73_0 <= KW_DATA)||(LA73_0 >= KW_DATABASES && LA73_0 <= KW_DATETIME)||(LA73_0 >= KW_DBPROPERTIES && LA73_0 <= KW_DISABLE)||(LA73_0 >= KW_DISTRIBUTE && LA73_0 <= KW_ELEM_TYPE)||LA73_0==KW_ENABLE||LA73_0==KW_ESCAPED||(LA73_0 >= KW_EXCLUSIVE && LA73_0 <= KW_EXPORT)||(LA73_0 >= KW_EXTERNAL && LA73_0 <= KW_FLOAT)||(LA73_0 >= KW_FOR && LA73_0 <= KW_FORMATTED)||LA73_0==KW_FULL||(LA73_0 >= KW_FUNCTIONS && LA73_0 <= KW_GROUPING)||LA73_0==KW_HOLD_DDLTIME||LA73_0==KW_IDXPROPERTIES||(LA73_0 >= KW_IGNORE && LA73_0 <= KW_INTERSECT)||(LA73_0 >= KW_INTO && LA73_0 <= KW_ITEMS)||(LA73_0 >= KW_KEYS && LA73_0 <= KW_LEFT)||(LA73_0 >= KW_LIKE && LA73_0 <= KW_LONG)||(LA73_0 >= KW_MAPJOIN && LA73_0 <= KW_MINUS)||(LA73_0 >= KW_MSCK && LA73_0 <= KW_NOSCAN)||(LA73_0 >= KW_NO_DROP && LA73_0 <= KW_OFFLINE)||LA73_0==KW_OPTION||(LA73_0 >= KW_ORCFILE && LA73_0 <= KW_OUTPUTFORMAT)||LA73_0==KW_OVERWRITE||(LA73_0 >= KW_PARTITION && LA73_0 <= KW_PLUS)||(LA73_0 >= KW_PRETTY && LA73_0 <= KW_RECORDWRITER)||(LA73_0 >= KW_REGEXP && LA73_0 <= KW_SCHEMAS)||(LA73_0 >= KW_SEMI && LA73_0 <= KW_TABLES)||(LA73_0 >= KW_TBLPROPERTIES && LA73_0 <= KW_TEXTFILE)||(LA73_0 >= KW_TIMESTAMP && LA73_0 <= KW_TOUCH)||(LA73_0 >= KW_TRIGGER && LA73_0 <= KW_UNARCHIVE)||(LA73_0 >= KW_UNDO && LA73_0 <= KW_UNIONTYPE)||(LA73_0 >= KW_UNLOCK && LA73_0 <= KW_VALUE_TYPE)||LA73_0==KW_VIEW||LA73_0==KW_WHILE||LA73_0==KW_WITH) ) {
				alt73=1;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 73, 0, input);
				throw nvae;
			}

			switch (alt73) {
				case 1 :
					// HiveParser.g:1044:5: tablePartitionPrefix alterTblPartitionStatementSuffix
					{
					pushFollow(FOLLOW_tablePartitionPrefix_in_alterTblPartitionStatement4806);
					tablePartitionPrefix250=tablePartitionPrefix();
					state._fsp--;

					stream_tablePartitionPrefix.add(tablePartitionPrefix250.getTree());
					pushFollow(FOLLOW_alterTblPartitionStatementSuffix_in_alterTblPartitionStatement4808);
					alterTblPartitionStatementSuffix251=alterTblPartitionStatementSuffix();
					state._fsp--;

					stream_alterTblPartitionStatementSuffix.add(alterTblPartitionStatementSuffix251.getTree());
					// AST REWRITE
					// elements: tablePartitionPrefix, alterTblPartitionStatementSuffix
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1045:3: -> ^( TOK_ALTERTABLE_PARTITION tablePartitionPrefix alterTblPartitionStatementSuffix )
					{
						// HiveParser.g:1045:6: ^( TOK_ALTERTABLE_PARTITION tablePartitionPrefix alterTblPartitionStatementSuffix )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_PARTITION, "TOK_ALTERTABLE_PARTITION"), root_1);
						adaptor.addChild(root_1, stream_tablePartitionPrefix.nextTree());
						adaptor.addChild(root_1, stream_alterTblPartitionStatementSuffix.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1046:4: Identifier KW_PARTITION KW_COLUMN LPAREN columnNameType RPAREN
					{
					Identifier252=(Token)match(input,Identifier,FOLLOW_Identifier_in_alterTblPartitionStatement4825);  
					stream_Identifier.add(Identifier252);

					KW_PARTITION253=(Token)match(input,KW_PARTITION,FOLLOW_KW_PARTITION_in_alterTblPartitionStatement4827);  
					stream_KW_PARTITION.add(KW_PARTITION253);

					KW_COLUMN254=(Token)match(input,KW_COLUMN,FOLLOW_KW_COLUMN_in_alterTblPartitionStatement4829);  
					stream_KW_COLUMN.add(KW_COLUMN254);

					LPAREN255=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_alterTblPartitionStatement4831);  
					stream_LPAREN.add(LPAREN255);

					pushFollow(FOLLOW_columnNameType_in_alterTblPartitionStatement4833);
					columnNameType256=columnNameType();
					state._fsp--;

					stream_columnNameType.add(columnNameType256.getTree());
					RPAREN257=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_alterTblPartitionStatement4835);  
					stream_RPAREN.add(RPAREN257);

					// AST REWRITE
					// elements: columnNameType, Identifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1047:3: -> ^( TOK_ALTERTABLE_ALTERPARTS Identifier columnNameType )
					{
						// HiveParser.g:1047:6: ^( TOK_ALTERTABLE_ALTERPARTS Identifier columnNameType )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ALTERPARTS, "TOK_ALTERTABLE_ALTERPARTS"), root_1);
						adaptor.addChild(root_1, stream_Identifier.nextNode());
						adaptor.addChild(root_1, stream_columnNameType.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterTblPartitionStatement"


	public static class alterTblPartitionStatementSuffix_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterTblPartitionStatementSuffix"
	// HiveParser.g:1050:1: alterTblPartitionStatementSuffix : ( alterStatementSuffixFileFormat | alterStatementSuffixLocation | alterStatementSuffixProtectMode | alterStatementSuffixMergeFiles | alterStatementSuffixSerdeProperties | alterStatementSuffixRenamePart | alterStatementSuffixBucketNum | alterTblPartitionStatementSuffixSkewedLocation | alterStatementSuffixClusterbySortby );
	public final HiveParser.alterTblPartitionStatementSuffix_return alterTblPartitionStatementSuffix() throws RecognitionException {
		HiveParser.alterTblPartitionStatementSuffix_return retval = new HiveParser.alterTblPartitionStatementSuffix_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope alterStatementSuffixFileFormat258 =null;
		ParserRuleReturnScope alterStatementSuffixLocation259 =null;
		ParserRuleReturnScope alterStatementSuffixProtectMode260 =null;
		ParserRuleReturnScope alterStatementSuffixMergeFiles261 =null;
		ParserRuleReturnScope alterStatementSuffixSerdeProperties262 =null;
		ParserRuleReturnScope alterStatementSuffixRenamePart263 =null;
		ParserRuleReturnScope alterStatementSuffixBucketNum264 =null;
		ParserRuleReturnScope alterTblPartitionStatementSuffixSkewedLocation265 =null;
		ParserRuleReturnScope alterStatementSuffixClusterbySortby266 =null;


		msgs.push("alter table partition statement suffix");
		try {
			// HiveParser.g:1053:3: ( alterStatementSuffixFileFormat | alterStatementSuffixLocation | alterStatementSuffixProtectMode | alterStatementSuffixMergeFiles | alterStatementSuffixSerdeProperties | alterStatementSuffixRenamePart | alterStatementSuffixBucketNum | alterTblPartitionStatementSuffixSkewedLocation | alterStatementSuffixClusterbySortby )
			int alt74=9;
			switch ( input.LA(1) ) {
			case KW_SET:
				{
				switch ( input.LA(2) ) {
				case KW_FILEFORMAT:
					{
					alt74=1;
					}
					break;
				case KW_LOCATION:
					{
					alt74=2;
					}
					break;
				case KW_SERDE:
				case KW_SERDEPROPERTIES:
					{
					alt74=5;
					}
					break;
				case KW_SKEWED:
					{
					alt74=8;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 74, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
				}
				break;
			case KW_DISABLE:
			case KW_ENABLE:
				{
				alt74=3;
				}
				break;
			case KW_CONCATENATE:
				{
				alt74=4;
				}
				break;
			case KW_RENAME:
				{
				alt74=6;
				}
				break;
			case KW_INTO:
				{
				alt74=7;
				}
				break;
			case KW_CLUSTERED:
			case KW_NOT:
				{
				alt74=9;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 74, 0, input);
				throw nvae;
			}
			switch (alt74) {
				case 1 :
					// HiveParser.g:1053:5: alterStatementSuffixFileFormat
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixFileFormat_in_alterTblPartitionStatementSuffix4870);
					alterStatementSuffixFileFormat258=alterStatementSuffixFileFormat();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixFileFormat258.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:1054:5: alterStatementSuffixLocation
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixLocation_in_alterTblPartitionStatementSuffix4876);
					alterStatementSuffixLocation259=alterStatementSuffixLocation();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixLocation259.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:1055:5: alterStatementSuffixProtectMode
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixProtectMode_in_alterTblPartitionStatementSuffix4882);
					alterStatementSuffixProtectMode260=alterStatementSuffixProtectMode();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixProtectMode260.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:1056:5: alterStatementSuffixMergeFiles
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixMergeFiles_in_alterTblPartitionStatementSuffix4888);
					alterStatementSuffixMergeFiles261=alterStatementSuffixMergeFiles();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixMergeFiles261.getTree());

					}
					break;
				case 5 :
					// HiveParser.g:1057:5: alterStatementSuffixSerdeProperties
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixSerdeProperties_in_alterTblPartitionStatementSuffix4894);
					alterStatementSuffixSerdeProperties262=alterStatementSuffixSerdeProperties();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixSerdeProperties262.getTree());

					}
					break;
				case 6 :
					// HiveParser.g:1058:5: alterStatementSuffixRenamePart
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixRenamePart_in_alterTblPartitionStatementSuffix4900);
					alterStatementSuffixRenamePart263=alterStatementSuffixRenamePart();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixRenamePart263.getTree());

					}
					break;
				case 7 :
					// HiveParser.g:1059:5: alterStatementSuffixBucketNum
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixBucketNum_in_alterTblPartitionStatementSuffix4906);
					alterStatementSuffixBucketNum264=alterStatementSuffixBucketNum();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixBucketNum264.getTree());

					}
					break;
				case 8 :
					// HiveParser.g:1060:5: alterTblPartitionStatementSuffixSkewedLocation
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterTblPartitionStatementSuffixSkewedLocation_in_alterTblPartitionStatementSuffix4912);
					alterTblPartitionStatementSuffixSkewedLocation265=alterTblPartitionStatementSuffixSkewedLocation();
					state._fsp--;

					adaptor.addChild(root_0, alterTblPartitionStatementSuffixSkewedLocation265.getTree());

					}
					break;
				case 9 :
					// HiveParser.g:1061:5: alterStatementSuffixClusterbySortby
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_alterStatementSuffixClusterbySortby_in_alterTblPartitionStatementSuffix4918);
					alterStatementSuffixClusterbySortby266=alterStatementSuffixClusterbySortby();
					state._fsp--;

					adaptor.addChild(root_0, alterStatementSuffixClusterbySortby266.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterTblPartitionStatementSuffix"


	public static class alterStatementSuffixFileFormat_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixFileFormat"
	// HiveParser.g:1064:1: alterStatementSuffixFileFormat : KW_SET KW_FILEFORMAT fileFormat -> ^( TOK_ALTERTABLE_FILEFORMAT fileFormat ) ;
	public final HiveParser.alterStatementSuffixFileFormat_return alterStatementSuffixFileFormat() throws RecognitionException {
		HiveParser.alterStatementSuffixFileFormat_return retval = new HiveParser.alterStatementSuffixFileFormat_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SET267=null;
		Token KW_FILEFORMAT268=null;
		ParserRuleReturnScope fileFormat269 =null;

		CommonTree KW_SET267_tree=null;
		CommonTree KW_FILEFORMAT268_tree=null;
		RewriteRuleTokenStream stream_KW_FILEFORMAT=new RewriteRuleTokenStream(adaptor,"token KW_FILEFORMAT");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleSubtreeStream stream_fileFormat=new RewriteRuleSubtreeStream(adaptor,"rule fileFormat");

		msgs.push("alter fileformat statement"); 
		try {
			// HiveParser.g:1067:2: ( KW_SET KW_FILEFORMAT fileFormat -> ^( TOK_ALTERTABLE_FILEFORMAT fileFormat ) )
			// HiveParser.g:1067:4: KW_SET KW_FILEFORMAT fileFormat
			{
			KW_SET267=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterStatementSuffixFileFormat4940);  
			stream_KW_SET.add(KW_SET267);

			KW_FILEFORMAT268=(Token)match(input,KW_FILEFORMAT,FOLLOW_KW_FILEFORMAT_in_alterStatementSuffixFileFormat4942);  
			stream_KW_FILEFORMAT.add(KW_FILEFORMAT268);

			pushFollow(FOLLOW_fileFormat_in_alterStatementSuffixFileFormat4944);
			fileFormat269=fileFormat();
			state._fsp--;

			stream_fileFormat.add(fileFormat269.getTree());
			// AST REWRITE
			// elements: fileFormat
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1068:2: -> ^( TOK_ALTERTABLE_FILEFORMAT fileFormat )
			{
				// HiveParser.g:1068:5: ^( TOK_ALTERTABLE_FILEFORMAT fileFormat )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_FILEFORMAT, "TOK_ALTERTABLE_FILEFORMAT"), root_1);
				adaptor.addChild(root_1, stream_fileFormat.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixFileFormat"


	public static class alterStatementSuffixClusterbySortby_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixClusterbySortby"
	// HiveParser.g:1071:1: alterStatementSuffixClusterbySortby : ( KW_NOT KW_CLUSTERED -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_CLUSTERED ) | KW_NOT KW_SORTED -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_SORTED ) | tableBuckets -> ^( TOK_ALTERTABLE_CLUSTER_SORT tableBuckets ) );
	public final HiveParser.alterStatementSuffixClusterbySortby_return alterStatementSuffixClusterbySortby() throws RecognitionException {
		HiveParser.alterStatementSuffixClusterbySortby_return retval = new HiveParser.alterStatementSuffixClusterbySortby_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_NOT270=null;
		Token KW_CLUSTERED271=null;
		Token KW_NOT272=null;
		Token KW_SORTED273=null;
		ParserRuleReturnScope tableBuckets274 =null;

		CommonTree KW_NOT270_tree=null;
		CommonTree KW_CLUSTERED271_tree=null;
		CommonTree KW_NOT272_tree=null;
		CommonTree KW_SORTED273_tree=null;
		RewriteRuleTokenStream stream_KW_CLUSTERED=new RewriteRuleTokenStream(adaptor,"token KW_CLUSTERED");
		RewriteRuleTokenStream stream_KW_NOT=new RewriteRuleTokenStream(adaptor,"token KW_NOT");
		RewriteRuleTokenStream stream_KW_SORTED=new RewriteRuleTokenStream(adaptor,"token KW_SORTED");
		RewriteRuleSubtreeStream stream_tableBuckets=new RewriteRuleSubtreeStream(adaptor,"rule tableBuckets");

		msgs.push("alter partition cluster by sort by statement");
		try {
			// HiveParser.g:1074:3: ( KW_NOT KW_CLUSTERED -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_CLUSTERED ) | KW_NOT KW_SORTED -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_SORTED ) | tableBuckets -> ^( TOK_ALTERTABLE_CLUSTER_SORT tableBuckets ) )
			int alt75=3;
			int LA75_0 = input.LA(1);
			if ( (LA75_0==KW_NOT) ) {
				int LA75_1 = input.LA(2);
				if ( (LA75_1==KW_CLUSTERED) ) {
					alt75=1;
				}
				else if ( (LA75_1==KW_SORTED) ) {
					alt75=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 75, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( (LA75_0==KW_CLUSTERED) ) {
				alt75=3;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 75, 0, input);
				throw nvae;
			}

			switch (alt75) {
				case 1 :
					// HiveParser.g:1074:5: KW_NOT KW_CLUSTERED
					{
					KW_NOT270=(Token)match(input,KW_NOT,FOLLOW_KW_NOT_in_alterStatementSuffixClusterbySortby4975);  
					stream_KW_NOT.add(KW_NOT270);

					KW_CLUSTERED271=(Token)match(input,KW_CLUSTERED,FOLLOW_KW_CLUSTERED_in_alterStatementSuffixClusterbySortby4977);  
					stream_KW_CLUSTERED.add(KW_CLUSTERED271);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1074:25: -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_CLUSTERED )
					{
						// HiveParser.g:1074:28: ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_CLUSTERED )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_CLUSTER_SORT, "TOK_ALTERTABLE_CLUSTER_SORT"), root_1);
						adaptor.addChild(root_1, (CommonTree)adaptor.create(TOK_NOT_CLUSTERED, "TOK_NOT_CLUSTERED"));
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1075:5: KW_NOT KW_SORTED
					{
					KW_NOT272=(Token)match(input,KW_NOT,FOLLOW_KW_NOT_in_alterStatementSuffixClusterbySortby4991);  
					stream_KW_NOT.add(KW_NOT272);

					KW_SORTED273=(Token)match(input,KW_SORTED,FOLLOW_KW_SORTED_in_alterStatementSuffixClusterbySortby4993);  
					stream_KW_SORTED.add(KW_SORTED273);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1075:22: -> ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_SORTED )
					{
						// HiveParser.g:1075:25: ^( TOK_ALTERTABLE_CLUSTER_SORT TOK_NOT_SORTED )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_CLUSTER_SORT, "TOK_ALTERTABLE_CLUSTER_SORT"), root_1);
						adaptor.addChild(root_1, (CommonTree)adaptor.create(TOK_NOT_SORTED, "TOK_NOT_SORTED"));
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1076:5: tableBuckets
					{
					pushFollow(FOLLOW_tableBuckets_in_alterStatementSuffixClusterbySortby5007);
					tableBuckets274=tableBuckets();
					state._fsp--;

					stream_tableBuckets.add(tableBuckets274.getTree());
					// AST REWRITE
					// elements: tableBuckets
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1076:18: -> ^( TOK_ALTERTABLE_CLUSTER_SORT tableBuckets )
					{
						// HiveParser.g:1076:21: ^( TOK_ALTERTABLE_CLUSTER_SORT tableBuckets )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_CLUSTER_SORT, "TOK_ALTERTABLE_CLUSTER_SORT"), root_1);
						adaptor.addChild(root_1, stream_tableBuckets.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixClusterbySortby"


	public static class alterTblPartitionStatementSuffixSkewedLocation_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterTblPartitionStatementSuffixSkewedLocation"
	// HiveParser.g:1079:1: alterTblPartitionStatementSuffixSkewedLocation : KW_SET KW_SKEWED KW_LOCATION skewedLocations -> ^( TOK_ALTERTBLPART_SKEWED_LOCATION skewedLocations ) ;
	public final HiveParser.alterTblPartitionStatementSuffixSkewedLocation_return alterTblPartitionStatementSuffixSkewedLocation() throws RecognitionException {
		HiveParser.alterTblPartitionStatementSuffixSkewedLocation_return retval = new HiveParser.alterTblPartitionStatementSuffixSkewedLocation_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SET275=null;
		Token KW_SKEWED276=null;
		Token KW_LOCATION277=null;
		ParserRuleReturnScope skewedLocations278 =null;

		CommonTree KW_SET275_tree=null;
		CommonTree KW_SKEWED276_tree=null;
		CommonTree KW_LOCATION277_tree=null;
		RewriteRuleTokenStream stream_KW_SKEWED=new RewriteRuleTokenStream(adaptor,"token KW_SKEWED");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_LOCATION=new RewriteRuleTokenStream(adaptor,"token KW_LOCATION");
		RewriteRuleSubtreeStream stream_skewedLocations=new RewriteRuleSubtreeStream(adaptor,"rule skewedLocations");

		msgs.push("alter partition skewed location");
		try {
			// HiveParser.g:1082:3: ( KW_SET KW_SKEWED KW_LOCATION skewedLocations -> ^( TOK_ALTERTBLPART_SKEWED_LOCATION skewedLocations ) )
			// HiveParser.g:1082:5: KW_SET KW_SKEWED KW_LOCATION skewedLocations
			{
			KW_SET275=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterTblPartitionStatementSuffixSkewedLocation5038);  
			stream_KW_SET.add(KW_SET275);

			KW_SKEWED276=(Token)match(input,KW_SKEWED,FOLLOW_KW_SKEWED_in_alterTblPartitionStatementSuffixSkewedLocation5040);  
			stream_KW_SKEWED.add(KW_SKEWED276);

			KW_LOCATION277=(Token)match(input,KW_LOCATION,FOLLOW_KW_LOCATION_in_alterTblPartitionStatementSuffixSkewedLocation5042);  
			stream_KW_LOCATION.add(KW_LOCATION277);

			pushFollow(FOLLOW_skewedLocations_in_alterTblPartitionStatementSuffixSkewedLocation5044);
			skewedLocations278=skewedLocations();
			state._fsp--;

			stream_skewedLocations.add(skewedLocations278.getTree());
			// AST REWRITE
			// elements: skewedLocations
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1083:3: -> ^( TOK_ALTERTBLPART_SKEWED_LOCATION skewedLocations )
			{
				// HiveParser.g:1083:6: ^( TOK_ALTERTBLPART_SKEWED_LOCATION skewedLocations )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTBLPART_SKEWED_LOCATION, "TOK_ALTERTBLPART_SKEWED_LOCATION"), root_1);
				adaptor.addChild(root_1, stream_skewedLocations.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterTblPartitionStatementSuffixSkewedLocation"


	public static class skewedLocations_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedLocations"
	// HiveParser.g:1086:1: skewedLocations : LPAREN skewedLocationsList RPAREN -> ^( TOK_SKEWED_LOCATIONS skewedLocationsList ) ;
	public final HiveParser.skewedLocations_return skewedLocations() throws RecognitionException {
		HiveParser.skewedLocations_return retval = new HiveParser.skewedLocations_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN279=null;
		Token RPAREN281=null;
		ParserRuleReturnScope skewedLocationsList280 =null;

		CommonTree LPAREN279_tree=null;
		CommonTree RPAREN281_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_skewedLocationsList=new RewriteRuleSubtreeStream(adaptor,"rule skewedLocationsList");

		 msgs.push("skewed locations"); 
		try {
			// HiveParser.g:1089:5: ( LPAREN skewedLocationsList RPAREN -> ^( TOK_SKEWED_LOCATIONS skewedLocationsList ) )
			// HiveParser.g:1090:7: LPAREN skewedLocationsList RPAREN
			{
			LPAREN279=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_skewedLocations5087);  
			stream_LPAREN.add(LPAREN279);

			pushFollow(FOLLOW_skewedLocationsList_in_skewedLocations5089);
			skewedLocationsList280=skewedLocationsList();
			state._fsp--;

			stream_skewedLocationsList.add(skewedLocationsList280.getTree());
			RPAREN281=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_skewedLocations5091);  
			stream_RPAREN.add(RPAREN281);

			// AST REWRITE
			// elements: skewedLocationsList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1090:41: -> ^( TOK_SKEWED_LOCATIONS skewedLocationsList )
			{
				// HiveParser.g:1090:44: ^( TOK_SKEWED_LOCATIONS skewedLocationsList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SKEWED_LOCATIONS, "TOK_SKEWED_LOCATIONS"), root_1);
				adaptor.addChild(root_1, stream_skewedLocationsList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedLocations"


	public static class skewedLocationsList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedLocationsList"
	// HiveParser.g:1093:1: skewedLocationsList : skewedLocationMap ( COMMA skewedLocationMap )* -> ^( TOK_SKEWED_LOCATION_LIST ( skewedLocationMap )+ ) ;
	public final HiveParser.skewedLocationsList_return skewedLocationsList() throws RecognitionException {
		HiveParser.skewedLocationsList_return retval = new HiveParser.skewedLocationsList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA283=null;
		ParserRuleReturnScope skewedLocationMap282 =null;
		ParserRuleReturnScope skewedLocationMap284 =null;

		CommonTree COMMA283_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_skewedLocationMap=new RewriteRuleSubtreeStream(adaptor,"rule skewedLocationMap");

		 msgs.push("skewed locations list"); 
		try {
			// HiveParser.g:1096:5: ( skewedLocationMap ( COMMA skewedLocationMap )* -> ^( TOK_SKEWED_LOCATION_LIST ( skewedLocationMap )+ ) )
			// HiveParser.g:1097:7: skewedLocationMap ( COMMA skewedLocationMap )*
			{
			pushFollow(FOLLOW_skewedLocationMap_in_skewedLocationsList5132);
			skewedLocationMap282=skewedLocationMap();
			state._fsp--;

			stream_skewedLocationMap.add(skewedLocationMap282.getTree());
			// HiveParser.g:1097:25: ( COMMA skewedLocationMap )*
			loop76:
			while (true) {
				int alt76=2;
				int LA76_0 = input.LA(1);
				if ( (LA76_0==COMMA) ) {
					alt76=1;
				}

				switch (alt76) {
				case 1 :
					// HiveParser.g:1097:26: COMMA skewedLocationMap
					{
					COMMA283=(Token)match(input,COMMA,FOLLOW_COMMA_in_skewedLocationsList5135);  
					stream_COMMA.add(COMMA283);

					pushFollow(FOLLOW_skewedLocationMap_in_skewedLocationsList5137);
					skewedLocationMap284=skewedLocationMap();
					state._fsp--;

					stream_skewedLocationMap.add(skewedLocationMap284.getTree());
					}
					break;

				default :
					break loop76;
				}
			}

			// AST REWRITE
			// elements: skewedLocationMap
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1097:52: -> ^( TOK_SKEWED_LOCATION_LIST ( skewedLocationMap )+ )
			{
				// HiveParser.g:1097:55: ^( TOK_SKEWED_LOCATION_LIST ( skewedLocationMap )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SKEWED_LOCATION_LIST, "TOK_SKEWED_LOCATION_LIST"), root_1);
				if ( !(stream_skewedLocationMap.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_skewedLocationMap.hasNext() ) {
					adaptor.addChild(root_1, stream_skewedLocationMap.nextTree());
				}
				stream_skewedLocationMap.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedLocationsList"


	public static class skewedLocationMap_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedLocationMap"
	// HiveParser.g:1100:1: skewedLocationMap : key= skewedValueLocationElement EQUAL value= StringLiteral -> ^( TOK_SKEWED_LOCATION_MAP $key $value) ;
	public final HiveParser.skewedLocationMap_return skewedLocationMap() throws RecognitionException {
		HiveParser.skewedLocationMap_return retval = new HiveParser.skewedLocationMap_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token value=null;
		Token EQUAL285=null;
		ParserRuleReturnScope key =null;

		CommonTree value_tree=null;
		CommonTree EQUAL285_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_EQUAL=new RewriteRuleTokenStream(adaptor,"token EQUAL");
		RewriteRuleSubtreeStream stream_skewedValueLocationElement=new RewriteRuleSubtreeStream(adaptor,"rule skewedValueLocationElement");

		 msgs.push("specifying skewed location map"); 
		try {
			// HiveParser.g:1103:5: (key= skewedValueLocationElement EQUAL value= StringLiteral -> ^( TOK_SKEWED_LOCATION_MAP $key $value) )
			// HiveParser.g:1104:7: key= skewedValueLocationElement EQUAL value= StringLiteral
			{
			pushFollow(FOLLOW_skewedValueLocationElement_in_skewedLocationMap5183);
			key=skewedValueLocationElement();
			state._fsp--;

			stream_skewedValueLocationElement.add(key.getTree());
			EQUAL285=(Token)match(input,EQUAL,FOLLOW_EQUAL_in_skewedLocationMap5185);  
			stream_EQUAL.add(EQUAL285);

			value=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_skewedLocationMap5189);  
			stream_StringLiteral.add(value);

			// AST REWRITE
			// elements: value, key
			// token labels: value
			// rule labels: retval, key
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_value=new RewriteRuleTokenStream(adaptor,"token value",value);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_key=new RewriteRuleSubtreeStream(adaptor,"rule key",key!=null?key.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1104:64: -> ^( TOK_SKEWED_LOCATION_MAP $key $value)
			{
				// HiveParser.g:1104:67: ^( TOK_SKEWED_LOCATION_MAP $key $value)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SKEWED_LOCATION_MAP, "TOK_SKEWED_LOCATION_MAP"), root_1);
				adaptor.addChild(root_1, stream_key.nextTree());
				adaptor.addChild(root_1, stream_value.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedLocationMap"


	public static class alterStatementSuffixLocation_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixLocation"
	// HiveParser.g:1107:1: alterStatementSuffixLocation : KW_SET KW_LOCATION newLoc= StringLiteral -> ^( TOK_ALTERTABLE_LOCATION $newLoc) ;
	public final HiveParser.alterStatementSuffixLocation_return alterStatementSuffixLocation() throws RecognitionException {
		HiveParser.alterStatementSuffixLocation_return retval = new HiveParser.alterStatementSuffixLocation_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token newLoc=null;
		Token KW_SET286=null;
		Token KW_LOCATION287=null;

		CommonTree newLoc_tree=null;
		CommonTree KW_SET286_tree=null;
		CommonTree KW_LOCATION287_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_SET=new RewriteRuleTokenStream(adaptor,"token KW_SET");
		RewriteRuleTokenStream stream_KW_LOCATION=new RewriteRuleTokenStream(adaptor,"token KW_LOCATION");

		msgs.push("alter location");
		try {
			// HiveParser.g:1110:3: ( KW_SET KW_LOCATION newLoc= StringLiteral -> ^( TOK_ALTERTABLE_LOCATION $newLoc) )
			// HiveParser.g:1110:5: KW_SET KW_LOCATION newLoc= StringLiteral
			{
			KW_SET286=(Token)match(input,KW_SET,FOLLOW_KW_SET_in_alterStatementSuffixLocation5226);  
			stream_KW_SET.add(KW_SET286);

			KW_LOCATION287=(Token)match(input,KW_LOCATION,FOLLOW_KW_LOCATION_in_alterStatementSuffixLocation5228);  
			stream_KW_LOCATION.add(KW_LOCATION287);

			newLoc=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_alterStatementSuffixLocation5232);  
			stream_StringLiteral.add(newLoc);

			// AST REWRITE
			// elements: newLoc
			// token labels: newLoc
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_newLoc=new RewriteRuleTokenStream(adaptor,"token newLoc",newLoc);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1111:3: -> ^( TOK_ALTERTABLE_LOCATION $newLoc)
			{
				// HiveParser.g:1111:6: ^( TOK_ALTERTABLE_LOCATION $newLoc)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_LOCATION, "TOK_ALTERTABLE_LOCATION"), root_1);
				adaptor.addChild(root_1, stream_newLoc.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixLocation"


	public static class alterStatementSuffixSkewedby_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixSkewedby"
	// HiveParser.g:1115:1: alterStatementSuffixSkewedby : (name= identifier tableSkewed -> ^( TOK_ALTERTABLE_SKEWED $name tableSkewed ) |name= identifier KW_NOT KW_SKEWED -> ^( TOK_ALTERTABLE_SKEWED $name) |name= identifier KW_NOT storedAsDirs -> ^( TOK_ALTERTABLE_SKEWED $name storedAsDirs ) );
	public final HiveParser.alterStatementSuffixSkewedby_return alterStatementSuffixSkewedby() throws RecognitionException {
		HiveParser.alterStatementSuffixSkewedby_return retval = new HiveParser.alterStatementSuffixSkewedby_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_NOT289=null;
		Token KW_SKEWED290=null;
		Token KW_NOT291=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope tableSkewed288 =null;
		ParserRuleReturnScope storedAsDirs292 =null;

		CommonTree KW_NOT289_tree=null;
		CommonTree KW_SKEWED290_tree=null;
		CommonTree KW_NOT291_tree=null;
		RewriteRuleTokenStream stream_KW_SKEWED=new RewriteRuleTokenStream(adaptor,"token KW_SKEWED");
		RewriteRuleTokenStream stream_KW_NOT=new RewriteRuleTokenStream(adaptor,"token KW_NOT");
		RewriteRuleSubtreeStream stream_storedAsDirs=new RewriteRuleSubtreeStream(adaptor,"rule storedAsDirs");
		RewriteRuleSubtreeStream stream_tableSkewed=new RewriteRuleSubtreeStream(adaptor,"rule tableSkewed");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("alter skewed by statement");
		try {
			// HiveParser.g:1118:2: (name= identifier tableSkewed -> ^( TOK_ALTERTABLE_SKEWED $name tableSkewed ) |name= identifier KW_NOT KW_SKEWED -> ^( TOK_ALTERTABLE_SKEWED $name) |name= identifier KW_NOT storedAsDirs -> ^( TOK_ALTERTABLE_SKEWED $name storedAsDirs ) )
			int alt77=3;
			int LA77_0 = input.LA(1);
			if ( (LA77_0==Identifier) ) {
				int LA77_1 = input.LA(2);
				if ( (LA77_1==KW_SKEWED) ) {
					alt77=1;
				}
				else if ( (LA77_1==KW_NOT) ) {
					int LA77_4 = input.LA(3);
					if ( (LA77_4==KW_SKEWED) ) {
						alt77=2;
					}
					else if ( (LA77_4==KW_STORED) ) {
						alt77=3;
					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 77, 4, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 77, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( ((LA77_0 >= KW_ADD && LA77_0 <= KW_AFTER)||(LA77_0 >= KW_ALTER && LA77_0 <= KW_ANALYZE)||(LA77_0 >= KW_ARCHIVE && LA77_0 <= KW_CASCADE)||(LA77_0 >= KW_CHANGE && LA77_0 <= KW_COLLECTION)||(LA77_0 >= KW_COLUMNS && LA77_0 <= KW_CONCATENATE)||(LA77_0 >= KW_CONTINUE && LA77_0 <= KW_CREATE)||LA77_0==KW_CUBE||(LA77_0 >= KW_CURSOR && LA77_0 <= KW_DATA)||(LA77_0 >= KW_DATABASES && LA77_0 <= KW_DATETIME)||(LA77_0 >= KW_DBPROPERTIES && LA77_0 <= KW_DISABLE)||(LA77_0 >= KW_DISTRIBUTE && LA77_0 <= KW_ELEM_TYPE)||LA77_0==KW_ENABLE||LA77_0==KW_ESCAPED||(LA77_0 >= KW_EXCLUSIVE && LA77_0 <= KW_EXPORT)||(LA77_0 >= KW_EXTERNAL && LA77_0 <= KW_FLOAT)||(LA77_0 >= KW_FOR && LA77_0 <= KW_FORMATTED)||LA77_0==KW_FULL||(LA77_0 >= KW_FUNCTIONS && LA77_0 <= KW_GROUPING)||LA77_0==KW_HOLD_DDLTIME||LA77_0==KW_IDXPROPERTIES||(LA77_0 >= KW_IGNORE && LA77_0 <= KW_INTERSECT)||(LA77_0 >= KW_INTO && LA77_0 <= KW_ITEMS)||(LA77_0 >= KW_KEYS && LA77_0 <= KW_LEFT)||(LA77_0 >= KW_LIKE && LA77_0 <= KW_LONG)||(LA77_0 >= KW_MAPJOIN && LA77_0 <= KW_MINUS)||(LA77_0 >= KW_MSCK && LA77_0 <= KW_NOSCAN)||(LA77_0 >= KW_NO_DROP && LA77_0 <= KW_OFFLINE)||LA77_0==KW_OPTION||(LA77_0 >= KW_ORCFILE && LA77_0 <= KW_OUTPUTFORMAT)||LA77_0==KW_OVERWRITE||(LA77_0 >= KW_PARTITION && LA77_0 <= KW_PLUS)||(LA77_0 >= KW_PRETTY && LA77_0 <= KW_RECORDWRITER)||(LA77_0 >= KW_REGEXP && LA77_0 <= KW_SCHEMAS)||(LA77_0 >= KW_SEMI && LA77_0 <= KW_TABLES)||(LA77_0 >= KW_TBLPROPERTIES && LA77_0 <= KW_TEXTFILE)||(LA77_0 >= KW_TIMESTAMP && LA77_0 <= KW_TOUCH)||(LA77_0 >= KW_TRIGGER && LA77_0 <= KW_UNARCHIVE)||(LA77_0 >= KW_UNDO && LA77_0 <= KW_UNIONTYPE)||(LA77_0 >= KW_UNLOCK && LA77_0 <= KW_VALUE_TYPE)||LA77_0==KW_VIEW||LA77_0==KW_WHILE||LA77_0==KW_WITH) ) {
				int LA77_2 = input.LA(2);
				if ( (LA77_2==KW_SKEWED) ) {
					alt77=1;
				}
				else if ( (LA77_2==KW_NOT) ) {
					int LA77_6 = input.LA(3);
					if ( (LA77_6==KW_SKEWED) ) {
						alt77=2;
					}
					else if ( (LA77_6==KW_STORED) ) {
						alt77=3;
					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 77, 6, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 77, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 77, 0, input);
				throw nvae;
			}

			switch (alt77) {
				case 1 :
					// HiveParser.g:1118:3: name= identifier tableSkewed
					{
					pushFollow(FOLLOW_identifier_in_alterStatementSuffixSkewedby5267);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					pushFollow(FOLLOW_tableSkewed_in_alterStatementSuffixSkewedby5269);
					tableSkewed288=tableSkewed();
					state._fsp--;

					stream_tableSkewed.add(tableSkewed288.getTree());
					// AST REWRITE
					// elements: name, tableSkewed
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1119:2: -> ^( TOK_ALTERTABLE_SKEWED $name tableSkewed )
					{
						// HiveParser.g:1119:4: ^( TOK_ALTERTABLE_SKEWED $name tableSkewed )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_SKEWED, "TOK_ALTERTABLE_SKEWED"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_tableSkewed.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1121:2: name= identifier KW_NOT KW_SKEWED
					{
					pushFollow(FOLLOW_identifier_in_alterStatementSuffixSkewedby5288);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_NOT289=(Token)match(input,KW_NOT,FOLLOW_KW_NOT_in_alterStatementSuffixSkewedby5290);  
					stream_KW_NOT.add(KW_NOT289);

					KW_SKEWED290=(Token)match(input,KW_SKEWED,FOLLOW_KW_SKEWED_in_alterStatementSuffixSkewedby5292);  
					stream_KW_SKEWED.add(KW_SKEWED290);

					// AST REWRITE
					// elements: name
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1122:2: -> ^( TOK_ALTERTABLE_SKEWED $name)
					{
						// HiveParser.g:1122:4: ^( TOK_ALTERTABLE_SKEWED $name)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_SKEWED, "TOK_ALTERTABLE_SKEWED"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1124:2: name= identifier KW_NOT storedAsDirs
					{
					pushFollow(FOLLOW_identifier_in_alterStatementSuffixSkewedby5309);
					name=identifier();
					state._fsp--;

					stream_identifier.add(name.getTree());
					KW_NOT291=(Token)match(input,KW_NOT,FOLLOW_KW_NOT_in_alterStatementSuffixSkewedby5311);  
					stream_KW_NOT.add(KW_NOT291);

					pushFollow(FOLLOW_storedAsDirs_in_alterStatementSuffixSkewedby5313);
					storedAsDirs292=storedAsDirs();
					state._fsp--;

					stream_storedAsDirs.add(storedAsDirs292.getTree());
					// AST REWRITE
					// elements: name, storedAsDirs
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1125:2: -> ^( TOK_ALTERTABLE_SKEWED $name storedAsDirs )
					{
						// HiveParser.g:1125:4: ^( TOK_ALTERTABLE_SKEWED $name storedAsDirs )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_SKEWED, "TOK_ALTERTABLE_SKEWED"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						adaptor.addChild(root_1, stream_storedAsDirs.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixSkewedby"


	public static class alterStatementSuffixExchangePartition_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixExchangePartition"
	// HiveParser.g:1128:1: alterStatementSuffixExchangePartition : name= tableName KW_EXCHANGE partitionSpec KW_WITH KW_TABLE exchangename= tableName -> ^( TOK_EXCHANGEPARTITION $name partitionSpec $exchangename) ;
	public final HiveParser.alterStatementSuffixExchangePartition_return alterStatementSuffixExchangePartition() throws RecognitionException {
		HiveParser.alterStatementSuffixExchangePartition_return retval = new HiveParser.alterStatementSuffixExchangePartition_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_EXCHANGE293=null;
		Token KW_WITH295=null;
		Token KW_TABLE296=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope exchangename =null;
		ParserRuleReturnScope partitionSpec294 =null;

		CommonTree KW_EXCHANGE293_tree=null;
		CommonTree KW_WITH295_tree=null;
		CommonTree KW_TABLE296_tree=null;
		RewriteRuleTokenStream stream_KW_EXCHANGE=new RewriteRuleTokenStream(adaptor,"token KW_EXCHANGE");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");

		msgs.push("alter exchange partition");
		try {
			// HiveParser.g:1131:5: (name= tableName KW_EXCHANGE partitionSpec KW_WITH KW_TABLE exchangename= tableName -> ^( TOK_EXCHANGEPARTITION $name partitionSpec $exchangename) )
			// HiveParser.g:1131:7: name= tableName KW_EXCHANGE partitionSpec KW_WITH KW_TABLE exchangename= tableName
			{
			pushFollow(FOLLOW_tableName_in_alterStatementSuffixExchangePartition5349);
			name=tableName();
			state._fsp--;

			stream_tableName.add(name.getTree());
			KW_EXCHANGE293=(Token)match(input,KW_EXCHANGE,FOLLOW_KW_EXCHANGE_in_alterStatementSuffixExchangePartition5351);  
			stream_KW_EXCHANGE.add(KW_EXCHANGE293);

			pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixExchangePartition5353);
			partitionSpec294=partitionSpec();
			state._fsp--;

			stream_partitionSpec.add(partitionSpec294.getTree());
			KW_WITH295=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_alterStatementSuffixExchangePartition5355);  
			stream_KW_WITH.add(KW_WITH295);

			KW_TABLE296=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_alterStatementSuffixExchangePartition5357);  
			stream_KW_TABLE.add(KW_TABLE296);

			pushFollow(FOLLOW_tableName_in_alterStatementSuffixExchangePartition5361);
			exchangename=tableName();
			state._fsp--;

			stream_tableName.add(exchangename.getTree());
			// AST REWRITE
			// elements: exchangename, name, partitionSpec
			// token labels: 
			// rule labels: exchangename, retval, name
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_exchangename=new RewriteRuleSubtreeStream(adaptor,"rule exchangename",exchangename!=null?exchangename.getTree():null);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1132:5: -> ^( TOK_EXCHANGEPARTITION $name partitionSpec $exchangename)
			{
				// HiveParser.g:1132:8: ^( TOK_EXCHANGEPARTITION $name partitionSpec $exchangename)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_EXCHANGEPARTITION, "TOK_EXCHANGEPARTITION"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				adaptor.addChild(root_1, stream_exchangename.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixExchangePartition"


	public static class alterStatementSuffixProtectMode_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixProtectMode"
	// HiveParser.g:1135:1: alterStatementSuffixProtectMode : alterProtectMode -> ^( TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE alterProtectMode ) ;
	public final HiveParser.alterStatementSuffixProtectMode_return alterStatementSuffixProtectMode() throws RecognitionException {
		HiveParser.alterStatementSuffixProtectMode_return retval = new HiveParser.alterStatementSuffixProtectMode_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope alterProtectMode297 =null;

		RewriteRuleSubtreeStream stream_alterProtectMode=new RewriteRuleSubtreeStream(adaptor,"rule alterProtectMode");

		 msgs.push("alter partition protect mode statement"); 
		try {
			// HiveParser.g:1138:5: ( alterProtectMode -> ^( TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE alterProtectMode ) )
			// HiveParser.g:1138:7: alterProtectMode
			{
			pushFollow(FOLLOW_alterProtectMode_in_alterStatementSuffixProtectMode5406);
			alterProtectMode297=alterProtectMode();
			state._fsp--;

			stream_alterProtectMode.add(alterProtectMode297.getTree());
			// AST REWRITE
			// elements: alterProtectMode
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1139:5: -> ^( TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE alterProtectMode )
			{
				// HiveParser.g:1139:8: ^( TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE alterProtectMode )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE, "TOK_ALTERTABLE_ALTERPARTS_PROTECTMODE"), root_1);
				adaptor.addChild(root_1, stream_alterProtectMode.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixProtectMode"


	public static class alterStatementSuffixRenamePart_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixRenamePart"
	// HiveParser.g:1142:1: alterStatementSuffixRenamePart : KW_RENAME KW_TO partitionSpec -> ^( TOK_ALTERTABLE_RENAMEPART partitionSpec ) ;
	public final HiveParser.alterStatementSuffixRenamePart_return alterStatementSuffixRenamePart() throws RecognitionException {
		HiveParser.alterStatementSuffixRenamePart_return retval = new HiveParser.alterStatementSuffixRenamePart_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_RENAME298=null;
		Token KW_TO299=null;
		ParserRuleReturnScope partitionSpec300 =null;

		CommonTree KW_RENAME298_tree=null;
		CommonTree KW_TO299_tree=null;
		RewriteRuleTokenStream stream_KW_RENAME=new RewriteRuleTokenStream(adaptor,"token KW_RENAME");
		RewriteRuleTokenStream stream_KW_TO=new RewriteRuleTokenStream(adaptor,"token KW_TO");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");

		 msgs.push("alter table rename partition statement"); 
		try {
			// HiveParser.g:1145:5: ( KW_RENAME KW_TO partitionSpec -> ^( TOK_ALTERTABLE_RENAMEPART partitionSpec ) )
			// HiveParser.g:1145:7: KW_RENAME KW_TO partitionSpec
			{
			KW_RENAME298=(Token)match(input,KW_RENAME,FOLLOW_KW_RENAME_in_alterStatementSuffixRenamePart5445);  
			stream_KW_RENAME.add(KW_RENAME298);

			KW_TO299=(Token)match(input,KW_TO,FOLLOW_KW_TO_in_alterStatementSuffixRenamePart5447);  
			stream_KW_TO.add(KW_TO299);

			pushFollow(FOLLOW_partitionSpec_in_alterStatementSuffixRenamePart5449);
			partitionSpec300=partitionSpec();
			state._fsp--;

			stream_partitionSpec.add(partitionSpec300.getTree());
			// AST REWRITE
			// elements: partitionSpec
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1146:5: -> ^( TOK_ALTERTABLE_RENAMEPART partitionSpec )
			{
				// HiveParser.g:1146:7: ^( TOK_ALTERTABLE_RENAMEPART partitionSpec )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_RENAMEPART, "TOK_ALTERTABLE_RENAMEPART"), root_1);
				adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixRenamePart"


	public static class alterStatementSuffixMergeFiles_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixMergeFiles"
	// HiveParser.g:1149:1: alterStatementSuffixMergeFiles : KW_CONCATENATE -> ^( TOK_ALTERTABLE_ALTERPARTS_MERGEFILES ) ;
	public final HiveParser.alterStatementSuffixMergeFiles_return alterStatementSuffixMergeFiles() throws RecognitionException {
		HiveParser.alterStatementSuffixMergeFiles_return retval = new HiveParser.alterStatementSuffixMergeFiles_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CONCATENATE301=null;

		CommonTree KW_CONCATENATE301_tree=null;
		RewriteRuleTokenStream stream_KW_CONCATENATE=new RewriteRuleTokenStream(adaptor,"token KW_CONCATENATE");

		 msgs.push(""); 
		try {
			// HiveParser.g:1152:5: ( KW_CONCATENATE -> ^( TOK_ALTERTABLE_ALTERPARTS_MERGEFILES ) )
			// HiveParser.g:1152:7: KW_CONCATENATE
			{
			KW_CONCATENATE301=(Token)match(input,KW_CONCATENATE,FOLLOW_KW_CONCATENATE_in_alterStatementSuffixMergeFiles5487);  
			stream_KW_CONCATENATE.add(KW_CONCATENATE301);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1153:5: -> ^( TOK_ALTERTABLE_ALTERPARTS_MERGEFILES )
			{
				// HiveParser.g:1153:8: ^( TOK_ALTERTABLE_ALTERPARTS_MERGEFILES )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ALTERTABLE_ALTERPARTS_MERGEFILES, "TOK_ALTERTABLE_ALTERPARTS_MERGEFILES"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixMergeFiles"


	public static class alterProtectMode_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterProtectMode"
	// HiveParser.g:1156:1: alterProtectMode : ( KW_ENABLE alterProtectModeMode -> ^( TOK_ENABLE alterProtectModeMode ) | KW_DISABLE alterProtectModeMode -> ^( TOK_DISABLE alterProtectModeMode ) );
	public final HiveParser.alterProtectMode_return alterProtectMode() throws RecognitionException {
		HiveParser.alterProtectMode_return retval = new HiveParser.alterProtectMode_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ENABLE302=null;
		Token KW_DISABLE304=null;
		ParserRuleReturnScope alterProtectModeMode303 =null;
		ParserRuleReturnScope alterProtectModeMode305 =null;

		CommonTree KW_ENABLE302_tree=null;
		CommonTree KW_DISABLE304_tree=null;
		RewriteRuleTokenStream stream_KW_DISABLE=new RewriteRuleTokenStream(adaptor,"token KW_DISABLE");
		RewriteRuleTokenStream stream_KW_ENABLE=new RewriteRuleTokenStream(adaptor,"token KW_ENABLE");
		RewriteRuleSubtreeStream stream_alterProtectModeMode=new RewriteRuleSubtreeStream(adaptor,"rule alterProtectModeMode");

		 msgs.push("protect mode specification enable"); 
		try {
			// HiveParser.g:1159:5: ( KW_ENABLE alterProtectModeMode -> ^( TOK_ENABLE alterProtectModeMode ) | KW_DISABLE alterProtectModeMode -> ^( TOK_DISABLE alterProtectModeMode ) )
			int alt78=2;
			int LA78_0 = input.LA(1);
			if ( (LA78_0==KW_ENABLE) ) {
				alt78=1;
			}
			else if ( (LA78_0==KW_DISABLE) ) {
				alt78=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 78, 0, input);
				throw nvae;
			}

			switch (alt78) {
				case 1 :
					// HiveParser.g:1159:7: KW_ENABLE alterProtectModeMode
					{
					KW_ENABLE302=(Token)match(input,KW_ENABLE,FOLLOW_KW_ENABLE_in_alterProtectMode5524);  
					stream_KW_ENABLE.add(KW_ENABLE302);

					pushFollow(FOLLOW_alterProtectModeMode_in_alterProtectMode5526);
					alterProtectModeMode303=alterProtectModeMode();
					state._fsp--;

					stream_alterProtectModeMode.add(alterProtectModeMode303.getTree());
					// AST REWRITE
					// elements: alterProtectModeMode
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1159:39: -> ^( TOK_ENABLE alterProtectModeMode )
					{
						// HiveParser.g:1159:42: ^( TOK_ENABLE alterProtectModeMode )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ENABLE, "TOK_ENABLE"), root_1);
						adaptor.addChild(root_1, stream_alterProtectModeMode.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1160:7: KW_DISABLE alterProtectModeMode
					{
					KW_DISABLE304=(Token)match(input,KW_DISABLE,FOLLOW_KW_DISABLE_in_alterProtectMode5543);  
					stream_KW_DISABLE.add(KW_DISABLE304);

					pushFollow(FOLLOW_alterProtectModeMode_in_alterProtectMode5545);
					alterProtectModeMode305=alterProtectModeMode();
					state._fsp--;

					stream_alterProtectModeMode.add(alterProtectModeMode305.getTree());
					// AST REWRITE
					// elements: alterProtectModeMode
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1160:40: -> ^( TOK_DISABLE alterProtectModeMode )
					{
						// HiveParser.g:1160:43: ^( TOK_DISABLE alterProtectModeMode )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DISABLE, "TOK_DISABLE"), root_1);
						adaptor.addChild(root_1, stream_alterProtectModeMode.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterProtectMode"


	public static class alterProtectModeMode_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterProtectModeMode"
	// HiveParser.g:1163:1: alterProtectModeMode : ( KW_OFFLINE -> ^( TOK_OFFLINE ) | KW_NO_DROP ( KW_CASCADE )? -> ^( TOK_NO_DROP ( KW_CASCADE )? ) | KW_READONLY -> ^( TOK_READONLY ) );
	public final HiveParser.alterProtectModeMode_return alterProtectModeMode() throws RecognitionException {
		HiveParser.alterProtectModeMode_return retval = new HiveParser.alterProtectModeMode_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_OFFLINE306=null;
		Token KW_NO_DROP307=null;
		Token KW_CASCADE308=null;
		Token KW_READONLY309=null;

		CommonTree KW_OFFLINE306_tree=null;
		CommonTree KW_NO_DROP307_tree=null;
		CommonTree KW_CASCADE308_tree=null;
		CommonTree KW_READONLY309_tree=null;
		RewriteRuleTokenStream stream_KW_READONLY=new RewriteRuleTokenStream(adaptor,"token KW_READONLY");
		RewriteRuleTokenStream stream_KW_NO_DROP=new RewriteRuleTokenStream(adaptor,"token KW_NO_DROP");
		RewriteRuleTokenStream stream_KW_CASCADE=new RewriteRuleTokenStream(adaptor,"token KW_CASCADE");
		RewriteRuleTokenStream stream_KW_OFFLINE=new RewriteRuleTokenStream(adaptor,"token KW_OFFLINE");

		 msgs.push("protect mode specification enable"); 
		try {
			// HiveParser.g:1166:5: ( KW_OFFLINE -> ^( TOK_OFFLINE ) | KW_NO_DROP ( KW_CASCADE )? -> ^( TOK_NO_DROP ( KW_CASCADE )? ) | KW_READONLY -> ^( TOK_READONLY ) )
			int alt80=3;
			switch ( input.LA(1) ) {
			case KW_OFFLINE:
				{
				alt80=1;
				}
				break;
			case KW_NO_DROP:
				{
				alt80=2;
				}
				break;
			case KW_READONLY:
				{
				alt80=3;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 80, 0, input);
				throw nvae;
			}
			switch (alt80) {
				case 1 :
					// HiveParser.g:1166:7: KW_OFFLINE
					{
					KW_OFFLINE306=(Token)match(input,KW_OFFLINE,FOLLOW_KW_OFFLINE_in_alterProtectModeMode5581);  
					stream_KW_OFFLINE.add(KW_OFFLINE306);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1166:19: -> ^( TOK_OFFLINE )
					{
						// HiveParser.g:1166:22: ^( TOK_OFFLINE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_OFFLINE, "TOK_OFFLINE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1167:7: KW_NO_DROP ( KW_CASCADE )?
					{
					KW_NO_DROP307=(Token)match(input,KW_NO_DROP,FOLLOW_KW_NO_DROP_in_alterProtectModeMode5596);  
					stream_KW_NO_DROP.add(KW_NO_DROP307);

					// HiveParser.g:1167:18: ( KW_CASCADE )?
					int alt79=2;
					int LA79_0 = input.LA(1);
					if ( (LA79_0==KW_CASCADE) ) {
						alt79=1;
					}
					switch (alt79) {
						case 1 :
							// HiveParser.g:1167:18: KW_CASCADE
							{
							KW_CASCADE308=(Token)match(input,KW_CASCADE,FOLLOW_KW_CASCADE_in_alterProtectModeMode5598);  
							stream_KW_CASCADE.add(KW_CASCADE308);

							}
							break;

					}

					// AST REWRITE
					// elements: KW_CASCADE
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1167:30: -> ^( TOK_NO_DROP ( KW_CASCADE )? )
					{
						// HiveParser.g:1167:33: ^( TOK_NO_DROP ( KW_CASCADE )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_NO_DROP, "TOK_NO_DROP"), root_1);
						// HiveParser.g:1167:47: ( KW_CASCADE )?
						if ( stream_KW_CASCADE.hasNext() ) {
							adaptor.addChild(root_1, stream_KW_CASCADE.nextNode());
						}
						stream_KW_CASCADE.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1168:7: KW_READONLY
					{
					KW_READONLY309=(Token)match(input,KW_READONLY,FOLLOW_KW_READONLY_in_alterProtectModeMode5616);  
					stream_KW_READONLY.add(KW_READONLY309);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1168:20: -> ^( TOK_READONLY )
					{
						// HiveParser.g:1168:23: ^( TOK_READONLY )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_READONLY, "TOK_READONLY"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterProtectModeMode"


	public static class alterStatementSuffixBucketNum_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "alterStatementSuffixBucketNum"
	// HiveParser.g:1171:1: alterStatementSuffixBucketNum : KW_INTO num= Number KW_BUCKETS -> ^( TOK_TABLEBUCKETS $num) ;
	public final HiveParser.alterStatementSuffixBucketNum_return alterStatementSuffixBucketNum() throws RecognitionException {
		HiveParser.alterStatementSuffixBucketNum_return retval = new HiveParser.alterStatementSuffixBucketNum_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token num=null;
		Token KW_INTO310=null;
		Token KW_BUCKETS311=null;

		CommonTree num_tree=null;
		CommonTree KW_INTO310_tree=null;
		CommonTree KW_BUCKETS311_tree=null;
		RewriteRuleTokenStream stream_KW_INTO=new RewriteRuleTokenStream(adaptor,"token KW_INTO");
		RewriteRuleTokenStream stream_Number=new RewriteRuleTokenStream(adaptor,"token Number");
		RewriteRuleTokenStream stream_KW_BUCKETS=new RewriteRuleTokenStream(adaptor,"token KW_BUCKETS");

		 msgs.push(""); 
		try {
			// HiveParser.g:1174:5: ( KW_INTO num= Number KW_BUCKETS -> ^( TOK_TABLEBUCKETS $num) )
			// HiveParser.g:1174:7: KW_INTO num= Number KW_BUCKETS
			{
			KW_INTO310=(Token)match(input,KW_INTO,FOLLOW_KW_INTO_in_alterStatementSuffixBucketNum5650);  
			stream_KW_INTO.add(KW_INTO310);

			num=(Token)match(input,Number,FOLLOW_Number_in_alterStatementSuffixBucketNum5654);  
			stream_Number.add(num);

			KW_BUCKETS311=(Token)match(input,KW_BUCKETS,FOLLOW_KW_BUCKETS_in_alterStatementSuffixBucketNum5656);  
			stream_KW_BUCKETS.add(KW_BUCKETS311);

			// AST REWRITE
			// elements: num
			// token labels: num
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_num=new RewriteRuleTokenStream(adaptor,"token num",num);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1175:5: -> ^( TOK_TABLEBUCKETS $num)
			{
				// HiveParser.g:1175:8: ^( TOK_TABLEBUCKETS $num)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEBUCKETS, "TOK_TABLEBUCKETS"), root_1);
				adaptor.addChild(root_1, stream_num.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "alterStatementSuffixBucketNum"


	public static class fileFormat_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "fileFormat"
	// HiveParser.g:1178:1: fileFormat : ( KW_SEQUENCEFILE -> ^( TOK_TBLSEQUENCEFILE ) | KW_TEXTFILE -> ^( TOK_TBLTEXTFILE ) | KW_RCFILE -> ^( TOK_TBLRCFILE ) | KW_ORCFILE -> ^( TOK_TBLORCFILE ) | KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )? -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? ) |genericSpec= identifier -> ^( TOK_FILEFORMAT_GENERIC $genericSpec) );
	public final HiveParser.fileFormat_return fileFormat() throws RecognitionException {
		HiveParser.fileFormat_return retval = new HiveParser.fileFormat_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token inFmt=null;
		Token outFmt=null;
		Token inDriver=null;
		Token outDriver=null;
		Token KW_SEQUENCEFILE312=null;
		Token KW_TEXTFILE313=null;
		Token KW_RCFILE314=null;
		Token KW_ORCFILE315=null;
		Token KW_INPUTFORMAT316=null;
		Token KW_OUTPUTFORMAT317=null;
		Token KW_INPUTDRIVER318=null;
		Token KW_OUTPUTDRIVER319=null;
		ParserRuleReturnScope genericSpec =null;

		CommonTree inFmt_tree=null;
		CommonTree outFmt_tree=null;
		CommonTree inDriver_tree=null;
		CommonTree outDriver_tree=null;
		CommonTree KW_SEQUENCEFILE312_tree=null;
		CommonTree KW_TEXTFILE313_tree=null;
		CommonTree KW_RCFILE314_tree=null;
		CommonTree KW_ORCFILE315_tree=null;
		CommonTree KW_INPUTFORMAT316_tree=null;
		CommonTree KW_OUTPUTFORMAT317_tree=null;
		CommonTree KW_INPUTDRIVER318_tree=null;
		CommonTree KW_OUTPUTDRIVER319_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_INPUTDRIVER=new RewriteRuleTokenStream(adaptor,"token KW_INPUTDRIVER");
		RewriteRuleTokenStream stream_KW_RCFILE=new RewriteRuleTokenStream(adaptor,"token KW_RCFILE");
		RewriteRuleTokenStream stream_KW_INPUTFORMAT=new RewriteRuleTokenStream(adaptor,"token KW_INPUTFORMAT");
		RewriteRuleTokenStream stream_KW_OUTPUTFORMAT=new RewriteRuleTokenStream(adaptor,"token KW_OUTPUTFORMAT");
		RewriteRuleTokenStream stream_KW_OUTPUTDRIVER=new RewriteRuleTokenStream(adaptor,"token KW_OUTPUTDRIVER");
		RewriteRuleTokenStream stream_KW_SEQUENCEFILE=new RewriteRuleTokenStream(adaptor,"token KW_SEQUENCEFILE");
		RewriteRuleTokenStream stream_KW_ORCFILE=new RewriteRuleTokenStream(adaptor,"token KW_ORCFILE");
		RewriteRuleTokenStream stream_KW_TEXTFILE=new RewriteRuleTokenStream(adaptor,"token KW_TEXTFILE");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("file format specification"); 
		try {
			// HiveParser.g:1181:5: ( KW_SEQUENCEFILE -> ^( TOK_TBLSEQUENCEFILE ) | KW_TEXTFILE -> ^( TOK_TBLTEXTFILE ) | KW_RCFILE -> ^( TOK_TBLRCFILE ) | KW_ORCFILE -> ^( TOK_TBLORCFILE ) | KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )? -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? ) |genericSpec= identifier -> ^( TOK_FILEFORMAT_GENERIC $genericSpec) )
			int alt82=6;
			switch ( input.LA(1) ) {
			case KW_SEQUENCEFILE:
				{
				alt82=1;
				}
				break;
			case KW_TEXTFILE:
				{
				alt82=2;
				}
				break;
			case KW_RCFILE:
				{
				alt82=3;
				}
				break;
			case KW_ORCFILE:
				{
				alt82=4;
				}
				break;
			case KW_INPUTFORMAT:
				{
				int LA82_5 = input.LA(2);
				if ( (LA82_5==StringLiteral) ) {
					alt82=5;
				}
				else if ( (LA82_5==EOF) ) {
					alt82=6;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 82, 5, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

				}
				break;
			case Identifier:
			case KW_ADD:
			case KW_AFTER:
			case KW_ALTER:
			case KW_ANALYZE:
			case KW_ARCHIVE:
			case KW_ARRAY:
			case KW_AS:
			case KW_ASC:
			case KW_BEFORE:
			case KW_BETWEEN:
			case KW_BIGINT:
			case KW_BINARY:
			case KW_BOOLEAN:
			case KW_BOTH:
			case KW_BUCKET:
			case KW_BUCKETS:
			case KW_BY:
			case KW_CASCADE:
			case KW_CHANGE:
			case KW_CLUSTER:
			case KW_CLUSTERED:
			case KW_CLUSTERSTATUS:
			case KW_COLLECTION:
			case KW_COLUMNS:
			case KW_COMMENT:
			case KW_COMPUTE:
			case KW_CONCATENATE:
			case KW_CONTINUE:
			case KW_CREATE:
			case KW_CUBE:
			case KW_CURSOR:
			case KW_DATA:
			case KW_DATABASES:
			case KW_DATE:
			case KW_DATETIME:
			case KW_DBPROPERTIES:
			case KW_DECIMAL:
			case KW_DEFERRED:
			case KW_DELETE:
			case KW_DELIMITED:
			case KW_DEPENDENCY:
			case KW_DESC:
			case KW_DESCRIBE:
			case KW_DIRECTORIES:
			case KW_DIRECTORY:
			case KW_DISABLE:
			case KW_DISTRIBUTE:
			case KW_DOUBLE:
			case KW_DROP:
			case KW_ELEM_TYPE:
			case KW_ENABLE:
			case KW_ESCAPED:
			case KW_EXCLUSIVE:
			case KW_EXISTS:
			case KW_EXPLAIN:
			case KW_EXPORT:
			case KW_EXTERNAL:
			case KW_FALSE:
			case KW_FETCH:
			case KW_FIELDS:
			case KW_FILEFORMAT:
			case KW_FIRST:
			case KW_FLOAT:
			case KW_FOR:
			case KW_FORMAT:
			case KW_FORMATTED:
			case KW_FULL:
			case KW_FUNCTIONS:
			case KW_GRANT:
			case KW_GROUP:
			case KW_GROUPING:
			case KW_HOLD_DDLTIME:
			case KW_IDXPROPERTIES:
			case KW_IGNORE:
			case KW_IMPORT:
			case KW_IN:
			case KW_INCRE:
			case KW_INDEX:
			case KW_INDEXES:
			case KW_INNER:
			case KW_INPATH:
			case KW_INPUTDRIVER:
			case KW_INSERT:
			case KW_INT:
			case KW_INTERSECT:
			case KW_INTO:
			case KW_IS:
			case KW_ITEMS:
			case KW_KEYS:
			case KW_KEY_TYPE:
			case KW_LATERAL:
			case KW_LEFT:
			case KW_LIKE:
			case KW_LIMIT:
			case KW_LINES:
			case KW_LOAD:
			case KW_LOCAL:
			case KW_LOCATION:
			case KW_LOCK:
			case KW_LOCKS:
			case KW_LOGICAL:
			case KW_LONG:
			case KW_MAPJOIN:
			case KW_MATERIALIZED:
			case KW_MINUS:
			case KW_MSCK:
			case KW_NOSCAN:
			case KW_NO_DROP:
			case KW_NULL:
			case KW_OF:
			case KW_OFFLINE:
			case KW_OPTION:
			case KW_ORDER:
			case KW_OUT:
			case KW_OUTER:
			case KW_OUTPUTDRIVER:
			case KW_OUTPUTFORMAT:
			case KW_OVERWRITE:
			case KW_PARTITION:
			case KW_PARTITIONED:
			case KW_PARTITIONS:
			case KW_PERCENT:
			case KW_PLUS:
			case KW_PRETTY:
			case KW_PROCEDURE:
			case KW_PROTECTION:
			case KW_PURGE:
			case KW_RANGE:
			case KW_READ:
			case KW_READONLY:
			case KW_READS:
			case KW_REBUILD:
			case KW_RECORDREADER:
			case KW_RECORDWRITER:
			case KW_REGEXP:
			case KW_RENAME:
			case KW_REPAIR:
			case KW_REPLACE:
			case KW_RESTRICT:
			case KW_REVOKE:
			case KW_RIGHT:
			case KW_RLIKE:
			case KW_ROLE:
			case KW_ROLLUP:
			case KW_ROW:
			case KW_ROWS:
			case KW_SCHEMA:
			case KW_SCHEMAS:
			case KW_SEMI:
			case KW_SERDE:
			case KW_SERDEPROPERTIES:
			case KW_SET:
			case KW_SETS:
			case KW_SHARED:
			case KW_SHOW:
			case KW_SHOW_DATABASE:
			case KW_SKEWED:
			case KW_SMALLINT:
			case KW_SORT:
			case KW_SORTED:
			case KW_SSL:
			case KW_STATISTICS:
			case KW_STORED:
			case KW_STREAMTABLE:
			case KW_STRING:
			case KW_STRUCT:
			case KW_TABLE:
			case KW_TABLES:
			case KW_TBLPROPERTIES:
			case KW_TEMPORARY:
			case KW_TERMINATED:
			case KW_TIMESTAMP:
			case KW_TINYINT:
			case KW_TO:
			case KW_TOUCH:
			case KW_TRIGGER:
			case KW_TRUE:
			case KW_TRUNCATE:
			case KW_UNARCHIVE:
			case KW_UNDO:
			case KW_UNION:
			case KW_UNIONTYPE:
			case KW_UNLOCK:
			case KW_UNSET:
			case KW_UNSIGNED:
			case KW_UPDATE:
			case KW_USE:
			case KW_USER:
			case KW_USING:
			case KW_UTC:
			case KW_UTCTIMESTAMP:
			case KW_VALUE_TYPE:
			case KW_VIEW:
			case KW_WHILE:
			case KW_WITH:
				{
				alt82=6;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 82, 0, input);
				throw nvae;
			}
			switch (alt82) {
				case 1 :
					// HiveParser.g:1181:7: KW_SEQUENCEFILE
					{
					KW_SEQUENCEFILE312=(Token)match(input,KW_SEQUENCEFILE,FOLLOW_KW_SEQUENCEFILE_in_fileFormat5696);  
					stream_KW_SEQUENCEFILE.add(KW_SEQUENCEFILE312);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1181:24: -> ^( TOK_TBLSEQUENCEFILE )
					{
						// HiveParser.g:1181:27: ^( TOK_TBLSEQUENCEFILE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TBLSEQUENCEFILE, "TOK_TBLSEQUENCEFILE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1182:7: KW_TEXTFILE
					{
					KW_TEXTFILE313=(Token)match(input,KW_TEXTFILE,FOLLOW_KW_TEXTFILE_in_fileFormat5711);  
					stream_KW_TEXTFILE.add(KW_TEXTFILE313);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1182:20: -> ^( TOK_TBLTEXTFILE )
					{
						// HiveParser.g:1182:23: ^( TOK_TBLTEXTFILE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TBLTEXTFILE, "TOK_TBLTEXTFILE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1183:7: KW_RCFILE
					{
					KW_RCFILE314=(Token)match(input,KW_RCFILE,FOLLOW_KW_RCFILE_in_fileFormat5726);  
					stream_KW_RCFILE.add(KW_RCFILE314);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1183:18: -> ^( TOK_TBLRCFILE )
					{
						// HiveParser.g:1183:21: ^( TOK_TBLRCFILE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TBLRCFILE, "TOK_TBLRCFILE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:1184:7: KW_ORCFILE
					{
					KW_ORCFILE315=(Token)match(input,KW_ORCFILE,FOLLOW_KW_ORCFILE_in_fileFormat5741);  
					stream_KW_ORCFILE.add(KW_ORCFILE315);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1184:18: -> ^( TOK_TBLORCFILE )
					{
						// HiveParser.g:1184:21: ^( TOK_TBLORCFILE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TBLORCFILE, "TOK_TBLORCFILE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:1185:7: KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )?
					{
					KW_INPUTFORMAT316=(Token)match(input,KW_INPUTFORMAT,FOLLOW_KW_INPUTFORMAT_in_fileFormat5755);  
					stream_KW_INPUTFORMAT.add(KW_INPUTFORMAT316);

					inFmt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_fileFormat5759);  
					stream_StringLiteral.add(inFmt);

					KW_OUTPUTFORMAT317=(Token)match(input,KW_OUTPUTFORMAT,FOLLOW_KW_OUTPUTFORMAT_in_fileFormat5761);  
					stream_KW_OUTPUTFORMAT.add(KW_OUTPUTFORMAT317);

					outFmt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_fileFormat5765);  
					stream_StringLiteral.add(outFmt);

					// HiveParser.g:1185:79: ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )?
					int alt81=2;
					int LA81_0 = input.LA(1);
					if ( (LA81_0==KW_INPUTDRIVER) ) {
						alt81=1;
					}
					switch (alt81) {
						case 1 :
							// HiveParser.g:1185:80: KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral
							{
							KW_INPUTDRIVER318=(Token)match(input,KW_INPUTDRIVER,FOLLOW_KW_INPUTDRIVER_in_fileFormat5768);  
							stream_KW_INPUTDRIVER.add(KW_INPUTDRIVER318);

							inDriver=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_fileFormat5772);  
							stream_StringLiteral.add(inDriver);

							KW_OUTPUTDRIVER319=(Token)match(input,KW_OUTPUTDRIVER,FOLLOW_KW_OUTPUTDRIVER_in_fileFormat5774);  
							stream_KW_OUTPUTDRIVER.add(KW_OUTPUTDRIVER319);

							outDriver=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_fileFormat5778);  
							stream_StringLiteral.add(outDriver);

							}
							break;

					}

					// AST REWRITE
					// elements: inFmt, outDriver, inDriver, outFmt
					// token labels: outDriver, outFmt, inDriver, inFmt
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_outDriver=new RewriteRuleTokenStream(adaptor,"token outDriver",outDriver);
					RewriteRuleTokenStream stream_outFmt=new RewriteRuleTokenStream(adaptor,"token outFmt",outFmt);
					RewriteRuleTokenStream stream_inDriver=new RewriteRuleTokenStream(adaptor,"token inDriver",inDriver);
					RewriteRuleTokenStream stream_inFmt=new RewriteRuleTokenStream(adaptor,"token inFmt",inFmt);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1186:7: -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? )
					{
						// HiveParser.g:1186:10: ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEFILEFORMAT, "TOK_TABLEFILEFORMAT"), root_1);
						adaptor.addChild(root_1, stream_inFmt.nextNode());
						adaptor.addChild(root_1, stream_outFmt.nextNode());
						// HiveParser.g:1186:48: ( $inDriver)?
						if ( stream_inDriver.hasNext() ) {
							adaptor.addChild(root_1, stream_inDriver.nextNode());
						}
						stream_inDriver.reset();

						// HiveParser.g:1186:59: ( $outDriver)?
						if ( stream_outDriver.hasNext() ) {
							adaptor.addChild(root_1, stream_outDriver.nextNode());
						}
						stream_outDriver.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 6 :
					// HiveParser.g:1187:7: genericSpec= identifier
					{
					pushFollow(FOLLOW_identifier_in_fileFormat5816);
					genericSpec=identifier();
					state._fsp--;

					stream_identifier.add(genericSpec.getTree());
					// AST REWRITE
					// elements: genericSpec
					// token labels: 
					// rule labels: retval, genericSpec
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_genericSpec=new RewriteRuleSubtreeStream(adaptor,"rule genericSpec",genericSpec!=null?genericSpec.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1187:30: -> ^( TOK_FILEFORMAT_GENERIC $genericSpec)
					{
						// HiveParser.g:1187:33: ^( TOK_FILEFORMAT_GENERIC $genericSpec)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_FILEFORMAT_GENERIC, "TOK_FILEFORMAT_GENERIC"), root_1);
						adaptor.addChild(root_1, stream_genericSpec.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "fileFormat"


	public static class tabTypeExpr_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tabTypeExpr"
	// HiveParser.g:1190:1: tabTypeExpr : identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )* ;
	public final HiveParser.tabTypeExpr_return tabTypeExpr() throws RecognitionException {
		HiveParser.tabTypeExpr_return retval = new HiveParser.tabTypeExpr_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token DOT321=null;
		Token KW_ELEM_TYPE322=null;
		Token KW_KEY_TYPE323=null;
		Token KW_VALUE_TYPE324=null;
		ParserRuleReturnScope identifier320 =null;
		ParserRuleReturnScope identifier325 =null;

		CommonTree DOT321_tree=null;
		CommonTree KW_ELEM_TYPE322_tree=null;
		CommonTree KW_KEY_TYPE323_tree=null;
		CommonTree KW_VALUE_TYPE324_tree=null;

		 msgs.push("specifying table types"); 
		try {
			// HiveParser.g:1194:4: ( identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )* )
			// HiveParser.g:1194:6: identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )*
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_identifier_in_tabTypeExpr5852);
			identifier320=identifier();
			state._fsp--;

			adaptor.addChild(root_0, identifier320.getTree());

			// HiveParser.g:1194:17: ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )*
			loop84:
			while (true) {
				int alt84=2;
				int LA84_0 = input.LA(1);
				if ( (LA84_0==DOT) ) {
					alt84=1;
				}

				switch (alt84) {
				case 1 :
					// HiveParser.g:1194:18: DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier )
					{
					DOT321=(Token)match(input,DOT,FOLLOW_DOT_in_tabTypeExpr5855); 
					DOT321_tree = (CommonTree)adaptor.create(DOT321);
					root_0 = (CommonTree)adaptor.becomeRoot(DOT321_tree, root_0);

					// HiveParser.g:1194:23: ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier )
					int alt83=4;
					switch ( input.LA(1) ) {
					case KW_ELEM_TYPE:
						{
						alt83=1;
						}
						break;
					case KW_KEY_TYPE:
						{
						alt83=2;
						}
						break;
					case KW_VALUE_TYPE:
						{
						alt83=3;
						}
						break;
					case Identifier:
					case KW_ADD:
					case KW_AFTER:
					case KW_ALTER:
					case KW_ANALYZE:
					case KW_ARCHIVE:
					case KW_ARRAY:
					case KW_AS:
					case KW_ASC:
					case KW_BEFORE:
					case KW_BETWEEN:
					case KW_BIGINT:
					case KW_BINARY:
					case KW_BOOLEAN:
					case KW_BOTH:
					case KW_BUCKET:
					case KW_BUCKETS:
					case KW_BY:
					case KW_CASCADE:
					case KW_CHANGE:
					case KW_CLUSTER:
					case KW_CLUSTERED:
					case KW_CLUSTERSTATUS:
					case KW_COLLECTION:
					case KW_COLUMNS:
					case KW_COMMENT:
					case KW_COMPUTE:
					case KW_CONCATENATE:
					case KW_CONTINUE:
					case KW_CREATE:
					case KW_CUBE:
					case KW_CURSOR:
					case KW_DATA:
					case KW_DATABASES:
					case KW_DATE:
					case KW_DATETIME:
					case KW_DBPROPERTIES:
					case KW_DECIMAL:
					case KW_DEFERRED:
					case KW_DELETE:
					case KW_DELIMITED:
					case KW_DEPENDENCY:
					case KW_DESC:
					case KW_DESCRIBE:
					case KW_DIRECTORIES:
					case KW_DIRECTORY:
					case KW_DISABLE:
					case KW_DISTRIBUTE:
					case KW_DOUBLE:
					case KW_DROP:
					case KW_ENABLE:
					case KW_ESCAPED:
					case KW_EXCLUSIVE:
					case KW_EXISTS:
					case KW_EXPLAIN:
					case KW_EXPORT:
					case KW_EXTERNAL:
					case KW_FALSE:
					case KW_FETCH:
					case KW_FIELDS:
					case KW_FILEFORMAT:
					case KW_FIRST:
					case KW_FLOAT:
					case KW_FOR:
					case KW_FORMAT:
					case KW_FORMATTED:
					case KW_FULL:
					case KW_FUNCTIONS:
					case KW_GRANT:
					case KW_GROUP:
					case KW_GROUPING:
					case KW_HOLD_DDLTIME:
					case KW_IDXPROPERTIES:
					case KW_IGNORE:
					case KW_IMPORT:
					case KW_IN:
					case KW_INCRE:
					case KW_INDEX:
					case KW_INDEXES:
					case KW_INNER:
					case KW_INPATH:
					case KW_INPUTDRIVER:
					case KW_INPUTFORMAT:
					case KW_INSERT:
					case KW_INT:
					case KW_INTERSECT:
					case KW_INTO:
					case KW_IS:
					case KW_ITEMS:
					case KW_KEYS:
					case KW_LATERAL:
					case KW_LEFT:
					case KW_LIKE:
					case KW_LIMIT:
					case KW_LINES:
					case KW_LOAD:
					case KW_LOCAL:
					case KW_LOCATION:
					case KW_LOCK:
					case KW_LOCKS:
					case KW_LOGICAL:
					case KW_LONG:
					case KW_MAPJOIN:
					case KW_MATERIALIZED:
					case KW_MINUS:
					case KW_MSCK:
					case KW_NOSCAN:
					case KW_NO_DROP:
					case KW_NULL:
					case KW_OF:
					case KW_OFFLINE:
					case KW_OPTION:
					case KW_ORCFILE:
					case KW_ORDER:
					case KW_OUT:
					case KW_OUTER:
					case KW_OUTPUTDRIVER:
					case KW_OUTPUTFORMAT:
					case KW_OVERWRITE:
					case KW_PARTITION:
					case KW_PARTITIONED:
					case KW_PARTITIONS:
					case KW_PERCENT:
					case KW_PLUS:
					case KW_PRETTY:
					case KW_PROCEDURE:
					case KW_PROTECTION:
					case KW_PURGE:
					case KW_RANGE:
					case KW_RCFILE:
					case KW_READ:
					case KW_READONLY:
					case KW_READS:
					case KW_REBUILD:
					case KW_RECORDREADER:
					case KW_RECORDWRITER:
					case KW_REGEXP:
					case KW_RENAME:
					case KW_REPAIR:
					case KW_REPLACE:
					case KW_RESTRICT:
					case KW_REVOKE:
					case KW_RIGHT:
					case KW_RLIKE:
					case KW_ROLE:
					case KW_ROLLUP:
					case KW_ROW:
					case KW_ROWS:
					case KW_SCHEMA:
					case KW_SCHEMAS:
					case KW_SEMI:
					case KW_SEQUENCEFILE:
					case KW_SERDE:
					case KW_SERDEPROPERTIES:
					case KW_SET:
					case KW_SETS:
					case KW_SHARED:
					case KW_SHOW:
					case KW_SHOW_DATABASE:
					case KW_SKEWED:
					case KW_SMALLINT:
					case KW_SORT:
					case KW_SORTED:
					case KW_SSL:
					case KW_STATISTICS:
					case KW_STORED:
					case KW_STREAMTABLE:
					case KW_STRING:
					case KW_STRUCT:
					case KW_TABLE:
					case KW_TABLES:
					case KW_TBLPROPERTIES:
					case KW_TEMPORARY:
					case KW_TERMINATED:
					case KW_TEXTFILE:
					case KW_TIMESTAMP:
					case KW_TINYINT:
					case KW_TO:
					case KW_TOUCH:
					case KW_TRIGGER:
					case KW_TRUE:
					case KW_TRUNCATE:
					case KW_UNARCHIVE:
					case KW_UNDO:
					case KW_UNION:
					case KW_UNIONTYPE:
					case KW_UNLOCK:
					case KW_UNSET:
					case KW_UNSIGNED:
					case KW_UPDATE:
					case KW_USE:
					case KW_USER:
					case KW_USING:
					case KW_UTC:
					case KW_UTCTIMESTAMP:
					case KW_VIEW:
					case KW_WHILE:
					case KW_WITH:
						{
						alt83=4;
						}
						break;
					default:
						NoViableAltException nvae =
							new NoViableAltException("", 83, 0, input);
						throw nvae;
					}
					switch (alt83) {
						case 1 :
							// HiveParser.g:1194:24: KW_ELEM_TYPE
							{
							KW_ELEM_TYPE322=(Token)match(input,KW_ELEM_TYPE,FOLLOW_KW_ELEM_TYPE_in_tabTypeExpr5859); 
							KW_ELEM_TYPE322_tree = (CommonTree)adaptor.create(KW_ELEM_TYPE322);
							adaptor.addChild(root_0, KW_ELEM_TYPE322_tree);

							}
							break;
						case 2 :
							// HiveParser.g:1194:39: KW_KEY_TYPE
							{
							KW_KEY_TYPE323=(Token)match(input,KW_KEY_TYPE,FOLLOW_KW_KEY_TYPE_in_tabTypeExpr5863); 
							KW_KEY_TYPE323_tree = (CommonTree)adaptor.create(KW_KEY_TYPE323);
							adaptor.addChild(root_0, KW_KEY_TYPE323_tree);

							}
							break;
						case 3 :
							// HiveParser.g:1194:53: KW_VALUE_TYPE
							{
							KW_VALUE_TYPE324=(Token)match(input,KW_VALUE_TYPE,FOLLOW_KW_VALUE_TYPE_in_tabTypeExpr5867); 
							KW_VALUE_TYPE324_tree = (CommonTree)adaptor.create(KW_VALUE_TYPE324);
							adaptor.addChild(root_0, KW_VALUE_TYPE324_tree);

							}
							break;
						case 4 :
							// HiveParser.g:1194:69: identifier
							{
							pushFollow(FOLLOW_identifier_in_tabTypeExpr5871);
							identifier325=identifier();
							state._fsp--;

							adaptor.addChild(root_0, identifier325.getTree());

							}
							break;

					}

					}
					break;

				default :
					break loop84;
				}
			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tabTypeExpr"


	public static class descTabTypeExpr_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "descTabTypeExpr"
	// HiveParser.g:1197:1: descTabTypeExpr : identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )* ( identifier )? ;
	public final HiveParser.descTabTypeExpr_return descTabTypeExpr() throws RecognitionException {
		HiveParser.descTabTypeExpr_return retval = new HiveParser.descTabTypeExpr_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token DOT327=null;
		Token KW_ELEM_TYPE328=null;
		Token KW_KEY_TYPE329=null;
		Token KW_VALUE_TYPE330=null;
		ParserRuleReturnScope identifier326 =null;
		ParserRuleReturnScope identifier331 =null;
		ParserRuleReturnScope identifier332 =null;

		CommonTree DOT327_tree=null;
		CommonTree KW_ELEM_TYPE328_tree=null;
		CommonTree KW_KEY_TYPE329_tree=null;
		CommonTree KW_VALUE_TYPE330_tree=null;

		 msgs.push("specifying describe table types"); 
		try {
			// HiveParser.g:1201:4: ( identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )* ( identifier )? )
			// HiveParser.g:1201:6: identifier ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )* ( identifier )?
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_identifier_in_descTabTypeExpr5900);
			identifier326=identifier();
			state._fsp--;

			adaptor.addChild(root_0, identifier326.getTree());

			// HiveParser.g:1201:17: ( DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier ) )*
			loop86:
			while (true) {
				int alt86=2;
				int LA86_0 = input.LA(1);
				if ( (LA86_0==DOT) ) {
					alt86=1;
				}

				switch (alt86) {
				case 1 :
					// HiveParser.g:1201:18: DOT ^ ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier )
					{
					DOT327=(Token)match(input,DOT,FOLLOW_DOT_in_descTabTypeExpr5903); 
					DOT327_tree = (CommonTree)adaptor.create(DOT327);
					root_0 = (CommonTree)adaptor.becomeRoot(DOT327_tree, root_0);

					// HiveParser.g:1201:23: ( KW_ELEM_TYPE | KW_KEY_TYPE | KW_VALUE_TYPE | identifier )
					int alt85=4;
					switch ( input.LA(1) ) {
					case KW_ELEM_TYPE:
						{
						alt85=1;
						}
						break;
					case KW_KEY_TYPE:
						{
						alt85=2;
						}
						break;
					case KW_VALUE_TYPE:
						{
						alt85=3;
						}
						break;
					case Identifier:
					case KW_ADD:
					case KW_AFTER:
					case KW_ALTER:
					case KW_ANALYZE:
					case KW_ARCHIVE:
					case KW_ARRAY:
					case KW_AS:
					case KW_ASC:
					case KW_BEFORE:
					case KW_BETWEEN:
					case KW_BIGINT:
					case KW_BINARY:
					case KW_BOOLEAN:
					case KW_BOTH:
					case KW_BUCKET:
					case KW_BUCKETS:
					case KW_BY:
					case KW_CASCADE:
					case KW_CHANGE:
					case KW_CLUSTER:
					case KW_CLUSTERED:
					case KW_CLUSTERSTATUS:
					case KW_COLLECTION:
					case KW_COLUMNS:
					case KW_COMMENT:
					case KW_COMPUTE:
					case KW_CONCATENATE:
					case KW_CONTINUE:
					case KW_CREATE:
					case KW_CUBE:
					case KW_CURSOR:
					case KW_DATA:
					case KW_DATABASES:
					case KW_DATE:
					case KW_DATETIME:
					case KW_DBPROPERTIES:
					case KW_DECIMAL:
					case KW_DEFERRED:
					case KW_DELETE:
					case KW_DELIMITED:
					case KW_DEPENDENCY:
					case KW_DESC:
					case KW_DESCRIBE:
					case KW_DIRECTORIES:
					case KW_DIRECTORY:
					case KW_DISABLE:
					case KW_DISTRIBUTE:
					case KW_DOUBLE:
					case KW_DROP:
					case KW_ENABLE:
					case KW_ESCAPED:
					case KW_EXCLUSIVE:
					case KW_EXISTS:
					case KW_EXPLAIN:
					case KW_EXPORT:
					case KW_EXTERNAL:
					case KW_FALSE:
					case KW_FETCH:
					case KW_FIELDS:
					case KW_FILEFORMAT:
					case KW_FIRST:
					case KW_FLOAT:
					case KW_FOR:
					case KW_FORMAT:
					case KW_FORMATTED:
					case KW_FULL:
					case KW_FUNCTIONS:
					case KW_GRANT:
					case KW_GROUP:
					case KW_GROUPING:
					case KW_HOLD_DDLTIME:
					case KW_IDXPROPERTIES:
					case KW_IGNORE:
					case KW_IMPORT:
					case KW_IN:
					case KW_INCRE:
					case KW_INDEX:
					case KW_INDEXES:
					case KW_INNER:
					case KW_INPATH:
					case KW_INPUTDRIVER:
					case KW_INPUTFORMAT:
					case KW_INSERT:
					case KW_INT:
					case KW_INTERSECT:
					case KW_INTO:
					case KW_IS:
					case KW_ITEMS:
					case KW_KEYS:
					case KW_LATERAL:
					case KW_LEFT:
					case KW_LIKE:
					case KW_LIMIT:
					case KW_LINES:
					case KW_LOAD:
					case KW_LOCAL:
					case KW_LOCATION:
					case KW_LOCK:
					case KW_LOCKS:
					case KW_LOGICAL:
					case KW_LONG:
					case KW_MAPJOIN:
					case KW_MATERIALIZED:
					case KW_MINUS:
					case KW_MSCK:
					case KW_NOSCAN:
					case KW_NO_DROP:
					case KW_NULL:
					case KW_OF:
					case KW_OFFLINE:
					case KW_OPTION:
					case KW_ORCFILE:
					case KW_ORDER:
					case KW_OUT:
					case KW_OUTER:
					case KW_OUTPUTDRIVER:
					case KW_OUTPUTFORMAT:
					case KW_OVERWRITE:
					case KW_PARTITION:
					case KW_PARTITIONED:
					case KW_PARTITIONS:
					case KW_PERCENT:
					case KW_PLUS:
					case KW_PRETTY:
					case KW_PROCEDURE:
					case KW_PROTECTION:
					case KW_PURGE:
					case KW_RANGE:
					case KW_RCFILE:
					case KW_READ:
					case KW_READONLY:
					case KW_READS:
					case KW_REBUILD:
					case KW_RECORDREADER:
					case KW_RECORDWRITER:
					case KW_REGEXP:
					case KW_RENAME:
					case KW_REPAIR:
					case KW_REPLACE:
					case KW_RESTRICT:
					case KW_REVOKE:
					case KW_RIGHT:
					case KW_RLIKE:
					case KW_ROLE:
					case KW_ROLLUP:
					case KW_ROW:
					case KW_ROWS:
					case KW_SCHEMA:
					case KW_SCHEMAS:
					case KW_SEMI:
					case KW_SEQUENCEFILE:
					case KW_SERDE:
					case KW_SERDEPROPERTIES:
					case KW_SET:
					case KW_SETS:
					case KW_SHARED:
					case KW_SHOW:
					case KW_SHOW_DATABASE:
					case KW_SKEWED:
					case KW_SMALLINT:
					case KW_SORT:
					case KW_SORTED:
					case KW_SSL:
					case KW_STATISTICS:
					case KW_STORED:
					case KW_STREAMTABLE:
					case KW_STRING:
					case KW_STRUCT:
					case KW_TABLE:
					case KW_TABLES:
					case KW_TBLPROPERTIES:
					case KW_TEMPORARY:
					case KW_TERMINATED:
					case KW_TEXTFILE:
					case KW_TIMESTAMP:
					case KW_TINYINT:
					case KW_TO:
					case KW_TOUCH:
					case KW_TRIGGER:
					case KW_TRUE:
					case KW_TRUNCATE:
					case KW_UNARCHIVE:
					case KW_UNDO:
					case KW_UNION:
					case KW_UNIONTYPE:
					case KW_UNLOCK:
					case KW_UNSET:
					case KW_UNSIGNED:
					case KW_UPDATE:
					case KW_USE:
					case KW_USER:
					case KW_USING:
					case KW_UTC:
					case KW_UTCTIMESTAMP:
					case KW_VIEW:
					case KW_WHILE:
					case KW_WITH:
						{
						alt85=4;
						}
						break;
					default:
						NoViableAltException nvae =
							new NoViableAltException("", 85, 0, input);
						throw nvae;
					}
					switch (alt85) {
						case 1 :
							// HiveParser.g:1201:24: KW_ELEM_TYPE
							{
							KW_ELEM_TYPE328=(Token)match(input,KW_ELEM_TYPE,FOLLOW_KW_ELEM_TYPE_in_descTabTypeExpr5907); 
							KW_ELEM_TYPE328_tree = (CommonTree)adaptor.create(KW_ELEM_TYPE328);
							adaptor.addChild(root_0, KW_ELEM_TYPE328_tree);

							}
							break;
						case 2 :
							// HiveParser.g:1201:39: KW_KEY_TYPE
							{
							KW_KEY_TYPE329=(Token)match(input,KW_KEY_TYPE,FOLLOW_KW_KEY_TYPE_in_descTabTypeExpr5911); 
							KW_KEY_TYPE329_tree = (CommonTree)adaptor.create(KW_KEY_TYPE329);
							adaptor.addChild(root_0, KW_KEY_TYPE329_tree);

							}
							break;
						case 3 :
							// HiveParser.g:1201:53: KW_VALUE_TYPE
							{
							KW_VALUE_TYPE330=(Token)match(input,KW_VALUE_TYPE,FOLLOW_KW_VALUE_TYPE_in_descTabTypeExpr5915); 
							KW_VALUE_TYPE330_tree = (CommonTree)adaptor.create(KW_VALUE_TYPE330);
							adaptor.addChild(root_0, KW_VALUE_TYPE330_tree);

							}
							break;
						case 4 :
							// HiveParser.g:1201:69: identifier
							{
							pushFollow(FOLLOW_identifier_in_descTabTypeExpr5919);
							identifier331=identifier();
							state._fsp--;

							adaptor.addChild(root_0, identifier331.getTree());

							}
							break;

					}

					}
					break;

				default :
					break loop86;
				}
			}

			// HiveParser.g:1201:83: ( identifier )?
			int alt87=2;
			int LA87_0 = input.LA(1);
			if ( (LA87_0==Identifier||(LA87_0 >= KW_ADD && LA87_0 <= KW_AFTER)||(LA87_0 >= KW_ALTER && LA87_0 <= KW_ANALYZE)||(LA87_0 >= KW_ARCHIVE && LA87_0 <= KW_CASCADE)||(LA87_0 >= KW_CHANGE && LA87_0 <= KW_COLLECTION)||(LA87_0 >= KW_COLUMNS && LA87_0 <= KW_CONCATENATE)||(LA87_0 >= KW_CONTINUE && LA87_0 <= KW_CREATE)||LA87_0==KW_CUBE||(LA87_0 >= KW_CURSOR && LA87_0 <= KW_DATA)||(LA87_0 >= KW_DATABASES && LA87_0 <= KW_DATETIME)||(LA87_0 >= KW_DBPROPERTIES && LA87_0 <= KW_DISABLE)||(LA87_0 >= KW_DISTRIBUTE && LA87_0 <= KW_ELEM_TYPE)||LA87_0==KW_ENABLE||LA87_0==KW_ESCAPED||(LA87_0 >= KW_EXCLUSIVE && LA87_0 <= KW_EXPORT)||(LA87_0 >= KW_EXTERNAL && LA87_0 <= KW_FLOAT)||(LA87_0 >= KW_FOR && LA87_0 <= KW_FORMATTED)||LA87_0==KW_FULL||(LA87_0 >= KW_FUNCTIONS && LA87_0 <= KW_GROUPING)||LA87_0==KW_HOLD_DDLTIME||LA87_0==KW_IDXPROPERTIES||(LA87_0 >= KW_IGNORE && LA87_0 <= KW_INTERSECT)||(LA87_0 >= KW_INTO && LA87_0 <= KW_ITEMS)||(LA87_0 >= KW_KEYS && LA87_0 <= KW_LEFT)||(LA87_0 >= KW_LIKE && LA87_0 <= KW_LONG)||(LA87_0 >= KW_MAPJOIN && LA87_0 <= KW_MINUS)||(LA87_0 >= KW_MSCK && LA87_0 <= KW_NOSCAN)||(LA87_0 >= KW_NO_DROP && LA87_0 <= KW_OFFLINE)||LA87_0==KW_OPTION||(LA87_0 >= KW_ORCFILE && LA87_0 <= KW_OUTPUTFORMAT)||LA87_0==KW_OVERWRITE||(LA87_0 >= KW_PARTITIONED && LA87_0 <= KW_PLUS)||(LA87_0 >= KW_PRETTY && LA87_0 <= KW_RECORDWRITER)||(LA87_0 >= KW_REGEXP && LA87_0 <= KW_SCHEMAS)||(LA87_0 >= KW_SEMI && LA87_0 <= KW_TABLES)||(LA87_0 >= KW_TBLPROPERTIES && LA87_0 <= KW_TEXTFILE)||(LA87_0 >= KW_TIMESTAMP && LA87_0 <= KW_TOUCH)||(LA87_0 >= KW_TRIGGER && LA87_0 <= KW_UNARCHIVE)||(LA87_0 >= KW_UNDO && LA87_0 <= KW_UNIONTYPE)||(LA87_0 >= KW_UNLOCK && LA87_0 <= KW_VALUE_TYPE)||LA87_0==KW_VIEW||LA87_0==KW_WHILE||LA87_0==KW_WITH) ) {
				alt87=1;
			}
			else if ( (LA87_0==KW_PARTITION) ) {
				int LA87_2 = input.LA(2);
				if ( (LA87_2==EOF||LA87_2==KW_PARTITION) ) {
					alt87=1;
				}
			}
			switch (alt87) {
				case 1 :
					// HiveParser.g:1201:83: identifier
					{
					pushFollow(FOLLOW_identifier_in_descTabTypeExpr5924);
					identifier332=identifier();
					state._fsp--;

					adaptor.addChild(root_0, identifier332.getTree());

					}
					break;

			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "descTabTypeExpr"


	public static class partTypeExpr_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "partTypeExpr"
	// HiveParser.g:1204:1: partTypeExpr : tabTypeExpr ( partitionSpec )? -> ^( TOK_TABTYPE tabTypeExpr ( partitionSpec )? ) ;
	public final HiveParser.partTypeExpr_return partTypeExpr() throws RecognitionException {
		HiveParser.partTypeExpr_return retval = new HiveParser.partTypeExpr_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope tabTypeExpr333 =null;
		ParserRuleReturnScope partitionSpec334 =null;

		RewriteRuleSubtreeStream stream_tabTypeExpr=new RewriteRuleSubtreeStream(adaptor,"rule tabTypeExpr");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");

		 msgs.push("specifying table partitions"); 
		try {
			// HiveParser.g:1207:5: ( tabTypeExpr ( partitionSpec )? -> ^( TOK_TABTYPE tabTypeExpr ( partitionSpec )? ) )
			// HiveParser.g:1207:8: tabTypeExpr ( partitionSpec )?
			{
			pushFollow(FOLLOW_tabTypeExpr_in_partTypeExpr5952);
			tabTypeExpr333=tabTypeExpr();
			state._fsp--;

			stream_tabTypeExpr.add(tabTypeExpr333.getTree());
			// HiveParser.g:1207:20: ( partitionSpec )?
			int alt88=2;
			int LA88_0 = input.LA(1);
			if ( (LA88_0==KW_PARTITION) ) {
				alt88=1;
			}
			switch (alt88) {
				case 1 :
					// HiveParser.g:1207:20: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_partTypeExpr5954);
					partitionSpec334=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec334.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: tabTypeExpr, partitionSpec
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1207:35: -> ^( TOK_TABTYPE tabTypeExpr ( partitionSpec )? )
			{
				// HiveParser.g:1207:38: ^( TOK_TABTYPE tabTypeExpr ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABTYPE, "TOK_TABTYPE"), root_1);
				adaptor.addChild(root_1, stream_tabTypeExpr.nextTree());
				// HiveParser.g:1207:64: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "partTypeExpr"


	public static class descPartTypeExpr_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "descPartTypeExpr"
	// HiveParser.g:1210:1: descPartTypeExpr : descTabTypeExpr ( partitionSpec )? -> ^( TOK_TABTYPE descTabTypeExpr ( partitionSpec )? ) ;
	public final HiveParser.descPartTypeExpr_return descPartTypeExpr() throws RecognitionException {
		HiveParser.descPartTypeExpr_return retval = new HiveParser.descPartTypeExpr_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope descTabTypeExpr335 =null;
		ParserRuleReturnScope partitionSpec336 =null;

		RewriteRuleSubtreeStream stream_descTabTypeExpr=new RewriteRuleSubtreeStream(adaptor,"rule descTabTypeExpr");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");

		 msgs.push("specifying describe table partitions"); 
		try {
			// HiveParser.g:1213:5: ( descTabTypeExpr ( partitionSpec )? -> ^( TOK_TABTYPE descTabTypeExpr ( partitionSpec )? ) )
			// HiveParser.g:1213:8: descTabTypeExpr ( partitionSpec )?
			{
			pushFollow(FOLLOW_descTabTypeExpr_in_descPartTypeExpr5994);
			descTabTypeExpr335=descTabTypeExpr();
			state._fsp--;

			stream_descTabTypeExpr.add(descTabTypeExpr335.getTree());
			// HiveParser.g:1213:24: ( partitionSpec )?
			int alt89=2;
			int LA89_0 = input.LA(1);
			if ( (LA89_0==KW_PARTITION) ) {
				alt89=1;
			}
			switch (alt89) {
				case 1 :
					// HiveParser.g:1213:24: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_descPartTypeExpr5996);
					partitionSpec336=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec336.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: partitionSpec, descTabTypeExpr
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1213:39: -> ^( TOK_TABTYPE descTabTypeExpr ( partitionSpec )? )
			{
				// HiveParser.g:1213:42: ^( TOK_TABTYPE descTabTypeExpr ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABTYPE, "TOK_TABTYPE"), root_1);
				adaptor.addChild(root_1, stream_descTabTypeExpr.nextTree());
				// HiveParser.g:1213:72: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "descPartTypeExpr"


	public static class descStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "descStatement"
	// HiveParser.g:1216:1: descStatement : ( ( KW_DESCRIBE | KW_DESC ) (descOptions= KW_FORMATTED |descOptions= KW_EXTENDED |descOptions= KW_PRETTY )? (parttype= descPartTypeExpr ) -> ^( TOK_DESCTABLE $parttype ( $descOptions)? ) | ( KW_DESCRIBE | KW_DESC ) KW_FUNCTION ( KW_EXTENDED )? (name= descFuncNames ) -> ^( TOK_DESCFUNCTION $name ( KW_EXTENDED )? ) | ( KW_DESCRIBE | KW_DESC ) KW_DATABASE ( KW_EXTENDED )? (dbName= identifier ) -> ^( TOK_DESCDATABASE $dbName ( KW_EXTENDED )? ) );
	public final HiveParser.descStatement_return descStatement() throws RecognitionException {
		HiveParser.descStatement_return retval = new HiveParser.descStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token descOptions=null;
		Token KW_DESCRIBE337=null;
		Token KW_DESC338=null;
		Token KW_DESCRIBE339=null;
		Token KW_DESC340=null;
		Token KW_FUNCTION341=null;
		Token KW_EXTENDED342=null;
		Token KW_DESCRIBE343=null;
		Token KW_DESC344=null;
		Token KW_DATABASE345=null;
		Token KW_EXTENDED346=null;
		ParserRuleReturnScope parttype =null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope dbName =null;

		CommonTree descOptions_tree=null;
		CommonTree KW_DESCRIBE337_tree=null;
		CommonTree KW_DESC338_tree=null;
		CommonTree KW_DESCRIBE339_tree=null;
		CommonTree KW_DESC340_tree=null;
		CommonTree KW_FUNCTION341_tree=null;
		CommonTree KW_EXTENDED342_tree=null;
		CommonTree KW_DESCRIBE343_tree=null;
		CommonTree KW_DESC344_tree=null;
		CommonTree KW_DATABASE345_tree=null;
		CommonTree KW_EXTENDED346_tree=null;
		RewriteRuleTokenStream stream_KW_DESC=new RewriteRuleTokenStream(adaptor,"token KW_DESC");
		RewriteRuleTokenStream stream_KW_FUNCTION=new RewriteRuleTokenStream(adaptor,"token KW_FUNCTION");
		RewriteRuleTokenStream stream_KW_FORMATTED=new RewriteRuleTokenStream(adaptor,"token KW_FORMATTED");
		RewriteRuleTokenStream stream_KW_EXTENDED=new RewriteRuleTokenStream(adaptor,"token KW_EXTENDED");
		RewriteRuleTokenStream stream_KW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_DATABASE");
		RewriteRuleTokenStream stream_KW_PRETTY=new RewriteRuleTokenStream(adaptor,"token KW_PRETTY");
		RewriteRuleTokenStream stream_KW_DESCRIBE=new RewriteRuleTokenStream(adaptor,"token KW_DESCRIBE");
		RewriteRuleSubtreeStream stream_descPartTypeExpr=new RewriteRuleSubtreeStream(adaptor,"rule descPartTypeExpr");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");
		RewriteRuleSubtreeStream stream_descFuncNames=new RewriteRuleSubtreeStream(adaptor,"rule descFuncNames");

		 msgs.push("describe statement"); 
		try {
			// HiveParser.g:1219:5: ( ( KW_DESCRIBE | KW_DESC ) (descOptions= KW_FORMATTED |descOptions= KW_EXTENDED |descOptions= KW_PRETTY )? (parttype= descPartTypeExpr ) -> ^( TOK_DESCTABLE $parttype ( $descOptions)? ) | ( KW_DESCRIBE | KW_DESC ) KW_FUNCTION ( KW_EXTENDED )? (name= descFuncNames ) -> ^( TOK_DESCFUNCTION $name ( KW_EXTENDED )? ) | ( KW_DESCRIBE | KW_DESC ) KW_DATABASE ( KW_EXTENDED )? (dbName= identifier ) -> ^( TOK_DESCDATABASE $dbName ( KW_EXTENDED )? ) )
			int alt96=3;
			int LA96_0 = input.LA(1);
			if ( (LA96_0==KW_DESCRIBE) ) {
				switch ( input.LA(2) ) {
				case Identifier:
				case KW_ADD:
				case KW_AFTER:
				case KW_ALTER:
				case KW_ANALYZE:
				case KW_ARCHIVE:
				case KW_ARRAY:
				case KW_AS:
				case KW_ASC:
				case KW_BEFORE:
				case KW_BETWEEN:
				case KW_BIGINT:
				case KW_BINARY:
				case KW_BOOLEAN:
				case KW_BOTH:
				case KW_BUCKET:
				case KW_BUCKETS:
				case KW_BY:
				case KW_CASCADE:
				case KW_CHANGE:
				case KW_CLUSTER:
				case KW_CLUSTERED:
				case KW_CLUSTERSTATUS:
				case KW_COLLECTION:
				case KW_COLUMNS:
				case KW_COMMENT:
				case KW_COMPUTE:
				case KW_CONCATENATE:
				case KW_CONTINUE:
				case KW_CREATE:
				case KW_CUBE:
				case KW_CURSOR:
				case KW_DATA:
				case KW_DATABASES:
				case KW_DATE:
				case KW_DATETIME:
				case KW_DBPROPERTIES:
				case KW_DECIMAL:
				case KW_DEFERRED:
				case KW_DELETE:
				case KW_DELIMITED:
				case KW_DEPENDENCY:
				case KW_DESC:
				case KW_DESCRIBE:
				case KW_DIRECTORIES:
				case KW_DIRECTORY:
				case KW_DISABLE:
				case KW_DISTRIBUTE:
				case KW_DOUBLE:
				case KW_DROP:
				case KW_ELEM_TYPE:
				case KW_ENABLE:
				case KW_ESCAPED:
				case KW_EXCLUSIVE:
				case KW_EXISTS:
				case KW_EXPLAIN:
				case KW_EXPORT:
				case KW_EXTENDED:
				case KW_EXTERNAL:
				case KW_FALSE:
				case KW_FETCH:
				case KW_FIELDS:
				case KW_FILEFORMAT:
				case KW_FIRST:
				case KW_FLOAT:
				case KW_FOR:
				case KW_FORMAT:
				case KW_FORMATTED:
				case KW_FULL:
				case KW_FUNCTIONS:
				case KW_GRANT:
				case KW_GROUP:
				case KW_GROUPING:
				case KW_HOLD_DDLTIME:
				case KW_IDXPROPERTIES:
				case KW_IGNORE:
				case KW_IMPORT:
				case KW_IN:
				case KW_INCRE:
				case KW_INDEX:
				case KW_INDEXES:
				case KW_INNER:
				case KW_INPATH:
				case KW_INPUTDRIVER:
				case KW_INPUTFORMAT:
				case KW_INSERT:
				case KW_INT:
				case KW_INTERSECT:
				case KW_INTO:
				case KW_IS:
				case KW_ITEMS:
				case KW_KEYS:
				case KW_KEY_TYPE:
				case KW_LATERAL:
				case KW_LEFT:
				case KW_LIKE:
				case KW_LIMIT:
				case KW_LINES:
				case KW_LOAD:
				case KW_LOCAL:
				case KW_LOCATION:
				case KW_LOCK:
				case KW_LOCKS:
				case KW_LOGICAL:
				case KW_LONG:
				case KW_MAPJOIN:
				case KW_MATERIALIZED:
				case KW_MINUS:
				case KW_MSCK:
				case KW_NOSCAN:
				case KW_NO_DROP:
				case KW_NULL:
				case KW_OF:
				case KW_OFFLINE:
				case KW_OPTION:
				case KW_ORCFILE:
				case KW_ORDER:
				case KW_OUT:
				case KW_OUTER:
				case KW_OUTPUTDRIVER:
				case KW_OUTPUTFORMAT:
				case KW_OVERWRITE:
				case KW_PARTITION:
				case KW_PARTITIONED:
				case KW_PARTITIONS:
				case KW_PERCENT:
				case KW_PLUS:
				case KW_PRETTY:
				case KW_PROCEDURE:
				case KW_PROTECTION:
				case KW_PURGE:
				case KW_RANGE:
				case KW_RCFILE:
				case KW_READ:
				case KW_READONLY:
				case KW_READS:
				case KW_REBUILD:
				case KW_RECORDREADER:
				case KW_RECORDWRITER:
				case KW_REGEXP:
				case KW_RENAME:
				case KW_REPAIR:
				case KW_REPLACE:
				case KW_RESTRICT:
				case KW_REVOKE:
				case KW_RIGHT:
				case KW_RLIKE:
				case KW_ROLE:
				case KW_ROLLUP:
				case KW_ROW:
				case KW_ROWS:
				case KW_SCHEMA:
				case KW_SCHEMAS:
				case KW_SEMI:
				case KW_SEQUENCEFILE:
				case KW_SERDE:
				case KW_SERDEPROPERTIES:
				case KW_SET:
				case KW_SETS:
				case KW_SHARED:
				case KW_SHOW:
				case KW_SHOW_DATABASE:
				case KW_SKEWED:
				case KW_SMALLINT:
				case KW_SORT:
				case KW_SORTED:
				case KW_SSL:
				case KW_STATISTICS:
				case KW_STORED:
				case KW_STREAMTABLE:
				case KW_STRING:
				case KW_STRUCT:
				case KW_TABLE:
				case KW_TABLES:
				case KW_TBLPROPERTIES:
				case KW_TEMPORARY:
				case KW_TERMINATED:
				case KW_TEXTFILE:
				case KW_TIMESTAMP:
				case KW_TINYINT:
				case KW_TO:
				case KW_TOUCH:
				case KW_TRIGGER:
				case KW_TRUE:
				case KW_TRUNCATE:
				case KW_UNARCHIVE:
				case KW_UNDO:
				case KW_UNION:
				case KW_UNIONTYPE:
				case KW_UNLOCK:
				case KW_UNSET:
				case KW_UNSIGNED:
				case KW_UPDATE:
				case KW_USE:
				case KW_USER:
				case KW_USING:
				case KW_UTC:
				case KW_UTCTIMESTAMP:
				case KW_VALUE_TYPE:
				case KW_VIEW:
				case KW_WHILE:
				case KW_WITH:
					{
					alt96=1;
					}
					break;
				case KW_FUNCTION:
					{
					alt96=2;
					}
					break;
				case KW_DATABASE:
					{
					alt96=3;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 96, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
			}
			else if ( (LA96_0==KW_DESC) ) {
				switch ( input.LA(2) ) {
				case Identifier:
				case KW_ADD:
				case KW_AFTER:
				case KW_ALTER:
				case KW_ANALYZE:
				case KW_ARCHIVE:
				case KW_ARRAY:
				case KW_AS:
				case KW_ASC:
				case KW_BEFORE:
				case KW_BETWEEN:
				case KW_BIGINT:
				case KW_BINARY:
				case KW_BOOLEAN:
				case KW_BOTH:
				case KW_BUCKET:
				case KW_BUCKETS:
				case KW_BY:
				case KW_CASCADE:
				case KW_CHANGE:
				case KW_CLUSTER:
				case KW_CLUSTERED:
				case KW_CLUSTERSTATUS:
				case KW_COLLECTION:
				case KW_COLUMNS:
				case KW_COMMENT:
				case KW_COMPUTE:
				case KW_CONCATENATE:
				case KW_CONTINUE:
				case KW_CREATE:
				case KW_CUBE:
				case KW_CURSOR:
				case KW_DATA:
				case KW_DATABASES:
				case KW_DATE:
				case KW_DATETIME:
				case KW_DBPROPERTIES:
				case KW_DECIMAL:
				case KW_DEFERRED:
				case KW_DELETE:
				case KW_DELIMITED:
				case KW_DEPENDENCY:
				case KW_DESC:
				case KW_DESCRIBE:
				case KW_DIRECTORIES:
				case KW_DIRECTORY:
				case KW_DISABLE:
				case KW_DISTRIBUTE:
				case KW_DOUBLE:
				case KW_DROP:
				case KW_ELEM_TYPE:
				case KW_ENABLE:
				case KW_ESCAPED:
				case KW_EXCLUSIVE:
				case KW_EXISTS:
				case KW_EXPLAIN:
				case KW_EXPORT:
				case KW_EXTENDED:
				case KW_EXTERNAL:
				case KW_FALSE:
				case KW_FETCH:
				case KW_FIELDS:
				case KW_FILEFORMAT:
				case KW_FIRST:
				case KW_FLOAT:
				case KW_FOR:
				case KW_FORMAT:
				case KW_FORMATTED:
				case KW_FULL:
				case KW_FUNCTIONS:
				case KW_GRANT:
				case KW_GROUP:
				case KW_GROUPING:
				case KW_HOLD_DDLTIME:
				case KW_IDXPROPERTIES:
				case KW_IGNORE:
				case KW_IMPORT:
				case KW_IN:
				case KW_INCRE:
				case KW_INDEX:
				case KW_INDEXES:
				case KW_INNER:
				case KW_INPATH:
				case KW_INPUTDRIVER:
				case KW_INPUTFORMAT:
				case KW_INSERT:
				case KW_INT:
				case KW_INTERSECT:
				case KW_INTO:
				case KW_IS:
				case KW_ITEMS:
				case KW_KEYS:
				case KW_KEY_TYPE:
				case KW_LATERAL:
				case KW_LEFT:
				case KW_LIKE:
				case KW_LIMIT:
				case KW_LINES:
				case KW_LOAD:
				case KW_LOCAL:
				case KW_LOCATION:
				case KW_LOCK:
				case KW_LOCKS:
				case KW_LOGICAL:
				case KW_LONG:
				case KW_MAPJOIN:
				case KW_MATERIALIZED:
				case KW_MINUS:
				case KW_MSCK:
				case KW_NOSCAN:
				case KW_NO_DROP:
				case KW_NULL:
				case KW_OF:
				case KW_OFFLINE:
				case KW_OPTION:
				case KW_ORCFILE:
				case KW_ORDER:
				case KW_OUT:
				case KW_OUTER:
				case KW_OUTPUTDRIVER:
				case KW_OUTPUTFORMAT:
				case KW_OVERWRITE:
				case KW_PARTITION:
				case KW_PARTITIONED:
				case KW_PARTITIONS:
				case KW_PERCENT:
				case KW_PLUS:
				case KW_PRETTY:
				case KW_PROCEDURE:
				case KW_PROTECTION:
				case KW_PURGE:
				case KW_RANGE:
				case KW_RCFILE:
				case KW_READ:
				case KW_READONLY:
				case KW_READS:
				case KW_REBUILD:
				case KW_RECORDREADER:
				case KW_RECORDWRITER:
				case KW_REGEXP:
				case KW_RENAME:
				case KW_REPAIR:
				case KW_REPLACE:
				case KW_RESTRICT:
				case KW_REVOKE:
				case KW_RIGHT:
				case KW_RLIKE:
				case KW_ROLE:
				case KW_ROLLUP:
				case KW_ROW:
				case KW_ROWS:
				case KW_SCHEMA:
				case KW_SCHEMAS:
				case KW_SEMI:
				case KW_SEQUENCEFILE:
				case KW_SERDE:
				case KW_SERDEPROPERTIES:
				case KW_SET:
				case KW_SETS:
				case KW_SHARED:
				case KW_SHOW:
				case KW_SHOW_DATABASE:
				case KW_SKEWED:
				case KW_SMALLINT:
				case KW_SORT:
				case KW_SORTED:
				case KW_SSL:
				case KW_STATISTICS:
				case KW_STORED:
				case KW_STREAMTABLE:
				case KW_STRING:
				case KW_STRUCT:
				case KW_TABLE:
				case KW_TABLES:
				case KW_TBLPROPERTIES:
				case KW_TEMPORARY:
				case KW_TERMINATED:
				case KW_TEXTFILE:
				case KW_TIMESTAMP:
				case KW_TINYINT:
				case KW_TO:
				case KW_TOUCH:
				case KW_TRIGGER:
				case KW_TRUE:
				case KW_TRUNCATE:
				case KW_UNARCHIVE:
				case KW_UNDO:
				case KW_UNION:
				case KW_UNIONTYPE:
				case KW_UNLOCK:
				case KW_UNSET:
				case KW_UNSIGNED:
				case KW_UPDATE:
				case KW_USE:
				case KW_USER:
				case KW_USING:
				case KW_UTC:
				case KW_UTCTIMESTAMP:
				case KW_VALUE_TYPE:
				case KW_VIEW:
				case KW_WHILE:
				case KW_WITH:
					{
					alt96=1;
					}
					break;
				case KW_FUNCTION:
					{
					alt96=2;
					}
					break;
				case KW_DATABASE:
					{
					alt96=3;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 96, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 96, 0, input);
				throw nvae;
			}

			switch (alt96) {
				case 1 :
					// HiveParser.g:1219:7: ( KW_DESCRIBE | KW_DESC ) (descOptions= KW_FORMATTED |descOptions= KW_EXTENDED |descOptions= KW_PRETTY )? (parttype= descPartTypeExpr )
					{
					// HiveParser.g:1219:7: ( KW_DESCRIBE | KW_DESC )
					int alt90=2;
					int LA90_0 = input.LA(1);
					if ( (LA90_0==KW_DESCRIBE) ) {
						alt90=1;
					}
					else if ( (LA90_0==KW_DESC) ) {
						alt90=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 90, 0, input);
						throw nvae;
					}

					switch (alt90) {
						case 1 :
							// HiveParser.g:1219:8: KW_DESCRIBE
							{
							KW_DESCRIBE337=(Token)match(input,KW_DESCRIBE,FOLLOW_KW_DESCRIBE_in_descStatement6036);  
							stream_KW_DESCRIBE.add(KW_DESCRIBE337);

							}
							break;
						case 2 :
							// HiveParser.g:1219:20: KW_DESC
							{
							KW_DESC338=(Token)match(input,KW_DESC,FOLLOW_KW_DESC_in_descStatement6038);  
							stream_KW_DESC.add(KW_DESC338);

							}
							break;

					}

					// HiveParser.g:1219:29: (descOptions= KW_FORMATTED |descOptions= KW_EXTENDED |descOptions= KW_PRETTY )?
					int alt91=4;
					switch ( input.LA(1) ) {
						case KW_FORMATTED:
							{
							switch ( input.LA(2) ) {
								case Identifier:
									{
									alt91=1;
									}
									break;
								case KW_PARTITION:
									{
									alt91=1;
									}
									break;
								case KW_ADD:
								case KW_AFTER:
								case KW_ALTER:
								case KW_ANALYZE:
								case KW_ARCHIVE:
								case KW_ARRAY:
								case KW_AS:
								case KW_ASC:
								case KW_BEFORE:
								case KW_BETWEEN:
								case KW_BIGINT:
								case KW_BINARY:
								case KW_BOOLEAN:
								case KW_BOTH:
								case KW_BUCKET:
								case KW_BUCKETS:
								case KW_BY:
								case KW_CASCADE:
								case KW_CHANGE:
								case KW_CLUSTER:
								case KW_CLUSTERED:
								case KW_CLUSTERSTATUS:
								case KW_COLLECTION:
								case KW_COLUMNS:
								case KW_COMMENT:
								case KW_COMPUTE:
								case KW_CONCATENATE:
								case KW_CONTINUE:
								case KW_CREATE:
								case KW_CUBE:
								case KW_CURSOR:
								case KW_DATA:
								case KW_DATABASES:
								case KW_DATE:
								case KW_DATETIME:
								case KW_DBPROPERTIES:
								case KW_DECIMAL:
								case KW_DEFERRED:
								case KW_DELETE:
								case KW_DELIMITED:
								case KW_DEPENDENCY:
								case KW_DESC:
								case KW_DESCRIBE:
								case KW_DIRECTORIES:
								case KW_DIRECTORY:
								case KW_DISABLE:
								case KW_DISTRIBUTE:
								case KW_DOUBLE:
								case KW_DROP:
								case KW_ELEM_TYPE:
								case KW_ENABLE:
								case KW_ESCAPED:
								case KW_EXCLUSIVE:
								case KW_EXISTS:
								case KW_EXPLAIN:
								case KW_EXPORT:
								case KW_EXTERNAL:
								case KW_FALSE:
								case KW_FETCH:
								case KW_FIELDS:
								case KW_FILEFORMAT:
								case KW_FIRST:
								case KW_FLOAT:
								case KW_FOR:
								case KW_FORMAT:
								case KW_FORMATTED:
								case KW_FULL:
								case KW_FUNCTIONS:
								case KW_GRANT:
								case KW_GROUP:
								case KW_GROUPING:
								case KW_HOLD_DDLTIME:
								case KW_IDXPROPERTIES:
								case KW_IGNORE:
								case KW_IMPORT:
								case KW_IN:
								case KW_INCRE:
								case KW_INDEX:
								case KW_INDEXES:
								case KW_INNER:
								case KW_INPATH:
								case KW_INPUTDRIVER:
								case KW_INPUTFORMAT:
								case KW_INSERT:
								case KW_INT:
								case KW_INTERSECT:
								case KW_INTO:
								case KW_IS:
								case KW_ITEMS:
								case KW_KEYS:
								case KW_KEY_TYPE:
								case KW_LATERAL:
								case KW_LEFT:
								case KW_LIKE:
								case KW_LIMIT:
								case KW_LINES:
								case KW_LOAD:
								case KW_LOCAL:
								case KW_LOCATION:
								case KW_LOCK:
								case KW_LOCKS:
								case KW_LOGICAL:
								case KW_LONG:
								case KW_MAPJOIN:
								case KW_MATERIALIZED:
								case KW_MINUS:
								case KW_MSCK:
								case KW_NOSCAN:
								case KW_NO_DROP:
								case KW_NULL:
								case KW_OF:
								case KW_OFFLINE:
								case KW_OPTION:
								case KW_ORCFILE:
								case KW_ORDER:
								case KW_OUT:
								case KW_OUTER:
								case KW_OUTPUTDRIVER:
								case KW_OUTPUTFORMAT:
								case KW_OVERWRITE:
								case KW_PARTITIONED:
								case KW_PARTITIONS:
								case KW_PERCENT:
								case KW_PLUS:
								case KW_PRETTY:
								case KW_PROCEDURE:
								case KW_PROTECTION:
								case KW_PURGE:
								case KW_RANGE:
								case KW_RCFILE:
								case KW_READ:
								case KW_READONLY:
								case KW_READS:
								case KW_REBUILD:
								case KW_RECORDREADER:
								case KW_RECORDWRITER:
								case KW_REGEXP:
								case KW_RENAME:
								case KW_REPAIR:
								case KW_REPLACE:
								case KW_RESTRICT:
								case KW_REVOKE:
								case KW_RIGHT:
								case KW_RLIKE:
								case KW_ROLE:
								case KW_ROLLUP:
								case KW_ROW:
								case KW_ROWS:
								case KW_SCHEMA:
								case KW_SCHEMAS:
								case KW_SEMI:
								case KW_SEQUENCEFILE:
								case KW_SERDE:
								case KW_SERDEPROPERTIES:
								case KW_SET:
								case KW_SETS:
								case KW_SHARED:
								case KW_SHOW:
								case KW_SHOW_DATABASE:
								case KW_SKEWED:
								case KW_SMALLINT:
								case KW_SORT:
								case KW_SORTED:
								case KW_SSL:
								case KW_STATISTICS:
								case KW_STORED:
								case KW_STREAMTABLE:
								case KW_STRING:
								case KW_STRUCT:
								case KW_TABLE:
								case KW_TABLES:
								case KW_TBLPROPERTIES:
								case KW_TEMPORARY:
								case KW_TERMINATED:
								case KW_TEXTFILE:
								case KW_TIMESTAMP:
								case KW_TINYINT:
								case KW_TO:
								case KW_TOUCH:
								case KW_TRIGGER:
								case KW_TRUE:
								case KW_TRUNCATE:
								case KW_UNARCHIVE:
								case KW_UNDO:
								case KW_UNION:
								case KW_UNIONTYPE:
								case KW_UNLOCK:
								case KW_UNSET:
								case KW_UNSIGNED:
								case KW_UPDATE:
								case KW_USE:
								case KW_USER:
								case KW_USING:
								case KW_UTC:
								case KW_UTCTIMESTAMP:
								case KW_VALUE_TYPE:
								case KW_VIEW:
								case KW_WHILE:
								case KW_WITH:
									{
									alt91=1;
									}
									break;
							}
							}
							break;
						case KW_EXTENDED:
							{
							alt91=2;
							}
							break;
						case KW_PRETTY:
							{
							switch ( input.LA(2) ) {
								case Identifier:
									{
									alt91=3;
									}
									break;
								case KW_PARTITION:
									{
									alt91=3;
									}
									break;
								case KW_ADD:
								case KW_AFTER:
								case KW_ALTER:
								case KW_ANALYZE:
								case KW_ARCHIVE:
								case KW_ARRAY:
								case KW_AS:
								case KW_ASC:
								case KW_BEFORE:
								case KW_BETWEEN:
								case KW_BIGINT:
								case KW_BINARY:
								case KW_BOOLEAN:
								case KW_BOTH:
								case KW_BUCKET:
								case KW_BUCKETS:
								case KW_BY:
								case KW_CASCADE:
								case KW_CHANGE:
								case KW_CLUSTER:
								case KW_CLUSTERED:
								case KW_CLUSTERSTATUS:
								case KW_COLLECTION:
								case KW_COLUMNS:
								case KW_COMMENT:
								case KW_COMPUTE:
								case KW_CONCATENATE:
								case KW_CONTINUE:
								case KW_CREATE:
								case KW_CUBE:
								case KW_CURSOR:
								case KW_DATA:
								case KW_DATABASES:
								case KW_DATE:
								case KW_DATETIME:
								case KW_DBPROPERTIES:
								case KW_DECIMAL:
								case KW_DEFERRED:
								case KW_DELETE:
								case KW_DELIMITED:
								case KW_DEPENDENCY:
								case KW_DESC:
								case KW_DESCRIBE:
								case KW_DIRECTORIES:
								case KW_DIRECTORY:
								case KW_DISABLE:
								case KW_DISTRIBUTE:
								case KW_DOUBLE:
								case KW_DROP:
								case KW_ELEM_TYPE:
								case KW_ENABLE:
								case KW_ESCAPED:
								case KW_EXCLUSIVE:
								case KW_EXISTS:
								case KW_EXPLAIN:
								case KW_EXPORT:
								case KW_EXTERNAL:
								case KW_FALSE:
								case KW_FETCH:
								case KW_FIELDS:
								case KW_FILEFORMAT:
								case KW_FIRST:
								case KW_FLOAT:
								case KW_FOR:
								case KW_FORMAT:
								case KW_FORMATTED:
								case KW_FULL:
								case KW_FUNCTIONS:
								case KW_GRANT:
								case KW_GROUP:
								case KW_GROUPING:
								case KW_HOLD_DDLTIME:
								case KW_IDXPROPERTIES:
								case KW_IGNORE:
								case KW_IMPORT:
								case KW_IN:
								case KW_INCRE:
								case KW_INDEX:
								case KW_INDEXES:
								case KW_INNER:
								case KW_INPATH:
								case KW_INPUTDRIVER:
								case KW_INPUTFORMAT:
								case KW_INSERT:
								case KW_INT:
								case KW_INTERSECT:
								case KW_INTO:
								case KW_IS:
								case KW_ITEMS:
								case KW_KEYS:
								case KW_KEY_TYPE:
								case KW_LATERAL:
								case KW_LEFT:
								case KW_LIKE:
								case KW_LIMIT:
								case KW_LINES:
								case KW_LOAD:
								case KW_LOCAL:
								case KW_LOCATION:
								case KW_LOCK:
								case KW_LOCKS:
								case KW_LOGICAL:
								case KW_LONG:
								case KW_MAPJOIN:
								case KW_MATERIALIZED:
								case KW_MINUS:
								case KW_MSCK:
								case KW_NOSCAN:
								case KW_NO_DROP:
								case KW_NULL:
								case KW_OF:
								case KW_OFFLINE:
								case KW_OPTION:
								case KW_ORCFILE:
								case KW_ORDER:
								case KW_OUT:
								case KW_OUTER:
								case KW_OUTPUTDRIVER:
								case KW_OUTPUTFORMAT:
								case KW_OVERWRITE:
								case KW_PARTITIONED:
								case KW_PARTITIONS:
								case KW_PERCENT:
								case KW_PLUS:
								case KW_PRETTY:
								case KW_PROCEDURE:
								case KW_PROTECTION:
								case KW_PURGE:
								case KW_RANGE:
								case KW_RCFILE:
								case KW_READ:
								case KW_READONLY:
								case KW_READS:
								case KW_REBUILD:
								case KW_RECORDREADER:
								case KW_RECORDWRITER:
								case KW_REGEXP:
								case KW_RENAME:
								case KW_REPAIR:
								case KW_REPLACE:
								case KW_RESTRICT:
								case KW_REVOKE:
								case KW_RIGHT:
								case KW_RLIKE:
								case KW_ROLE:
								case KW_ROLLUP:
								case KW_ROW:
								case KW_ROWS:
								case KW_SCHEMA:
								case KW_SCHEMAS:
								case KW_SEMI:
								case KW_SEQUENCEFILE:
								case KW_SERDE:
								case KW_SERDEPROPERTIES:
								case KW_SET:
								case KW_SETS:
								case KW_SHARED:
								case KW_SHOW:
								case KW_SHOW_DATABASE:
								case KW_SKEWED:
								case KW_SMALLINT:
								case KW_SORT:
								case KW_SORTED:
								case KW_SSL:
								case KW_STATISTICS:
								case KW_STORED:
								case KW_STREAMTABLE:
								case KW_STRING:
								case KW_STRUCT:
								case KW_TABLE:
								case KW_TABLES:
								case KW_TBLPROPERTIES:
								case KW_TEMPORARY:
								case KW_TERMINATED:
								case KW_TEXTFILE:
								case KW_TIMESTAMP:
								case KW_TINYINT:
								case KW_TO:
								case KW_TOUCH:
								case KW_TRIGGER:
								case KW_TRUE:
								case KW_TRUNCATE:
								case KW_UNARCHIVE:
								case KW_UNDO:
								case KW_UNION:
								case KW_UNIONTYPE:
								case KW_UNLOCK:
								case KW_UNSET:
								case KW_UNSIGNED:
								case KW_UPDATE:
								case KW_USE:
								case KW_USER:
								case KW_USING:
								case KW_UTC:
								case KW_UTCTIMESTAMP:
								case KW_VALUE_TYPE:
								case KW_VIEW:
								case KW_WHILE:
								case KW_WITH:
									{
									alt91=3;
									}
									break;
							}
							}
							break;
					}
					switch (alt91) {
						case 1 :
							// HiveParser.g:1219:30: descOptions= KW_FORMATTED
							{
							descOptions=(Token)match(input,KW_FORMATTED,FOLLOW_KW_FORMATTED_in_descStatement6044);  
							stream_KW_FORMATTED.add(descOptions);

							}
							break;
						case 2 :
							// HiveParser.g:1219:55: descOptions= KW_EXTENDED
							{
							descOptions=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_descStatement6048);  
							stream_KW_EXTENDED.add(descOptions);

							}
							break;
						case 3 :
							// HiveParser.g:1219:79: descOptions= KW_PRETTY
							{
							descOptions=(Token)match(input,KW_PRETTY,FOLLOW_KW_PRETTY_in_descStatement6052);  
							stream_KW_PRETTY.add(descOptions);

							}
							break;

					}

					// HiveParser.g:1219:103: (parttype= descPartTypeExpr )
					// HiveParser.g:1219:104: parttype= descPartTypeExpr
					{
					pushFollow(FOLLOW_descPartTypeExpr_in_descStatement6059);
					parttype=descPartTypeExpr();
					state._fsp--;

					stream_descPartTypeExpr.add(parttype.getTree());
					}

					// AST REWRITE
					// elements: parttype, descOptions
					// token labels: descOptions
					// rule labels: retval, parttype
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_descOptions=new RewriteRuleTokenStream(adaptor,"token descOptions",descOptions);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_parttype=new RewriteRuleSubtreeStream(adaptor,"rule parttype",parttype!=null?parttype.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1219:131: -> ^( TOK_DESCTABLE $parttype ( $descOptions)? )
					{
						// HiveParser.g:1219:134: ^( TOK_DESCTABLE $parttype ( $descOptions)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESCTABLE, "TOK_DESCTABLE"), root_1);
						adaptor.addChild(root_1, stream_parttype.nextTree());
						// HiveParser.g:1219:161: ( $descOptions)?
						if ( stream_descOptions.hasNext() ) {
							adaptor.addChild(root_1, stream_descOptions.nextNode());
						}
						stream_descOptions.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1220:7: ( KW_DESCRIBE | KW_DESC ) KW_FUNCTION ( KW_EXTENDED )? (name= descFuncNames )
					{
					// HiveParser.g:1220:7: ( KW_DESCRIBE | KW_DESC )
					int alt92=2;
					int LA92_0 = input.LA(1);
					if ( (LA92_0==KW_DESCRIBE) ) {
						alt92=1;
					}
					else if ( (LA92_0==KW_DESC) ) {
						alt92=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 92, 0, input);
						throw nvae;
					}

					switch (alt92) {
						case 1 :
							// HiveParser.g:1220:8: KW_DESCRIBE
							{
							KW_DESCRIBE339=(Token)match(input,KW_DESCRIBE,FOLLOW_KW_DESCRIBE_in_descStatement6082);  
							stream_KW_DESCRIBE.add(KW_DESCRIBE339);

							}
							break;
						case 2 :
							// HiveParser.g:1220:20: KW_DESC
							{
							KW_DESC340=(Token)match(input,KW_DESC,FOLLOW_KW_DESC_in_descStatement6084);  
							stream_KW_DESC.add(KW_DESC340);

							}
							break;

					}

					KW_FUNCTION341=(Token)match(input,KW_FUNCTION,FOLLOW_KW_FUNCTION_in_descStatement6087);  
					stream_KW_FUNCTION.add(KW_FUNCTION341);

					// HiveParser.g:1220:41: ( KW_EXTENDED )?
					int alt93=2;
					int LA93_0 = input.LA(1);
					if ( (LA93_0==KW_EXTENDED) ) {
						alt93=1;
					}
					switch (alt93) {
						case 1 :
							// HiveParser.g:1220:41: KW_EXTENDED
							{
							KW_EXTENDED342=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_descStatement6089);  
							stream_KW_EXTENDED.add(KW_EXTENDED342);

							}
							break;

					}

					// HiveParser.g:1220:54: (name= descFuncNames )
					// HiveParser.g:1220:55: name= descFuncNames
					{
					pushFollow(FOLLOW_descFuncNames_in_descStatement6095);
					name=descFuncNames();
					state._fsp--;

					stream_descFuncNames.add(name.getTree());
					}

					// AST REWRITE
					// elements: name, KW_EXTENDED
					// token labels: 
					// rule labels: retval, name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1220:75: -> ^( TOK_DESCFUNCTION $name ( KW_EXTENDED )? )
					{
						// HiveParser.g:1220:78: ^( TOK_DESCFUNCTION $name ( KW_EXTENDED )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESCFUNCTION, "TOK_DESCFUNCTION"), root_1);
						adaptor.addChild(root_1, stream_name.nextTree());
						// HiveParser.g:1220:103: ( KW_EXTENDED )?
						if ( stream_KW_EXTENDED.hasNext() ) {
							adaptor.addChild(root_1, stream_KW_EXTENDED.nextNode());
						}
						stream_KW_EXTENDED.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1221:7: ( KW_DESCRIBE | KW_DESC ) KW_DATABASE ( KW_EXTENDED )? (dbName= identifier )
					{
					// HiveParser.g:1221:7: ( KW_DESCRIBE | KW_DESC )
					int alt94=2;
					int LA94_0 = input.LA(1);
					if ( (LA94_0==KW_DESCRIBE) ) {
						alt94=1;
					}
					else if ( (LA94_0==KW_DESC) ) {
						alt94=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 94, 0, input);
						throw nvae;
					}

					switch (alt94) {
						case 1 :
							// HiveParser.g:1221:8: KW_DESCRIBE
							{
							KW_DESCRIBE343=(Token)match(input,KW_DESCRIBE,FOLLOW_KW_DESCRIBE_in_descStatement6117);  
							stream_KW_DESCRIBE.add(KW_DESCRIBE343);

							}
							break;
						case 2 :
							// HiveParser.g:1221:20: KW_DESC
							{
							KW_DESC344=(Token)match(input,KW_DESC,FOLLOW_KW_DESC_in_descStatement6119);  
							stream_KW_DESC.add(KW_DESC344);

							}
							break;

					}

					KW_DATABASE345=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_descStatement6122);  
					stream_KW_DATABASE.add(KW_DATABASE345);

					// HiveParser.g:1221:41: ( KW_EXTENDED )?
					int alt95=2;
					int LA95_0 = input.LA(1);
					if ( (LA95_0==KW_EXTENDED) ) {
						alt95=1;
					}
					switch (alt95) {
						case 1 :
							// HiveParser.g:1221:41: KW_EXTENDED
							{
							KW_EXTENDED346=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_descStatement6124);  
							stream_KW_EXTENDED.add(KW_EXTENDED346);

							}
							break;

					}

					// HiveParser.g:1221:54: (dbName= identifier )
					// HiveParser.g:1221:55: dbName= identifier
					{
					pushFollow(FOLLOW_identifier_in_descStatement6130);
					dbName=identifier();
					state._fsp--;

					stream_identifier.add(dbName.getTree());
					}

					// AST REWRITE
					// elements: dbName, KW_EXTENDED
					// token labels: 
					// rule labels: retval, dbName
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_dbName=new RewriteRuleSubtreeStream(adaptor,"rule dbName",dbName!=null?dbName.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1221:74: -> ^( TOK_DESCDATABASE $dbName ( KW_EXTENDED )? )
					{
						// HiveParser.g:1221:77: ^( TOK_DESCDATABASE $dbName ( KW_EXTENDED )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESCDATABASE, "TOK_DESCDATABASE"), root_1);
						adaptor.addChild(root_1, stream_dbName.nextTree());
						// HiveParser.g:1221:104: ( KW_EXTENDED )?
						if ( stream_KW_EXTENDED.hasNext() ) {
							adaptor.addChild(root_1, stream_KW_EXTENDED.nextNode());
						}
						stream_KW_EXTENDED.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "descStatement"


	public static class analyzeStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "analyzeStatement"
	// HiveParser.g:1224:1: analyzeStatement : KW_ANALYZE KW_TABLE (parttype= tableOrPartition ) KW_COMPUTE KW_STATISTICS ( (noscan= KW_NOSCAN ) | (partialscan= KW_PARTIALSCAN ) | ( KW_FOR KW_COLUMNS statsColumnName= columnNameList ) )? -> ^( TOK_ANALYZE $parttype ( $noscan)? ( $partialscan)? ( $statsColumnName)? ) ;
	public final HiveParser.analyzeStatement_return analyzeStatement() throws RecognitionException {
		HiveParser.analyzeStatement_return retval = new HiveParser.analyzeStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token noscan=null;
		Token partialscan=null;
		Token KW_ANALYZE347=null;
		Token KW_TABLE348=null;
		Token KW_COMPUTE349=null;
		Token KW_STATISTICS350=null;
		Token KW_FOR351=null;
		Token KW_COLUMNS352=null;
		ParserRuleReturnScope parttype =null;
		ParserRuleReturnScope statsColumnName =null;

		CommonTree noscan_tree=null;
		CommonTree partialscan_tree=null;
		CommonTree KW_ANALYZE347_tree=null;
		CommonTree KW_TABLE348_tree=null;
		CommonTree KW_COMPUTE349_tree=null;
		CommonTree KW_STATISTICS350_tree=null;
		CommonTree KW_FOR351_tree=null;
		CommonTree KW_COLUMNS352_tree=null;
		RewriteRuleTokenStream stream_KW_ANALYZE=new RewriteRuleTokenStream(adaptor,"token KW_ANALYZE");
		RewriteRuleTokenStream stream_KW_NOSCAN=new RewriteRuleTokenStream(adaptor,"token KW_NOSCAN");
		RewriteRuleTokenStream stream_KW_COLUMNS=new RewriteRuleTokenStream(adaptor,"token KW_COLUMNS");
		RewriteRuleTokenStream stream_KW_STATISTICS=new RewriteRuleTokenStream(adaptor,"token KW_STATISTICS");
		RewriteRuleTokenStream stream_KW_FOR=new RewriteRuleTokenStream(adaptor,"token KW_FOR");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_COMPUTE=new RewriteRuleTokenStream(adaptor,"token KW_COMPUTE");
		RewriteRuleTokenStream stream_KW_PARTIALSCAN=new RewriteRuleTokenStream(adaptor,"token KW_PARTIALSCAN");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");

		 msgs.push("analyze statement"); 
		try {
			// HiveParser.g:1227:5: ( KW_ANALYZE KW_TABLE (parttype= tableOrPartition ) KW_COMPUTE KW_STATISTICS ( (noscan= KW_NOSCAN ) | (partialscan= KW_PARTIALSCAN ) | ( KW_FOR KW_COLUMNS statsColumnName= columnNameList ) )? -> ^( TOK_ANALYZE $parttype ( $noscan)? ( $partialscan)? ( $statsColumnName)? ) )
			// HiveParser.g:1227:7: KW_ANALYZE KW_TABLE (parttype= tableOrPartition ) KW_COMPUTE KW_STATISTICS ( (noscan= KW_NOSCAN ) | (partialscan= KW_PARTIALSCAN ) | ( KW_FOR KW_COLUMNS statsColumnName= columnNameList ) )?
			{
			KW_ANALYZE347=(Token)match(input,KW_ANALYZE,FOLLOW_KW_ANALYZE_in_analyzeStatement6170);  
			stream_KW_ANALYZE.add(KW_ANALYZE347);

			KW_TABLE348=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_analyzeStatement6172);  
			stream_KW_TABLE.add(KW_TABLE348);

			// HiveParser.g:1227:27: (parttype= tableOrPartition )
			// HiveParser.g:1227:28: parttype= tableOrPartition
			{
			pushFollow(FOLLOW_tableOrPartition_in_analyzeStatement6177);
			parttype=tableOrPartition();
			state._fsp--;

			stream_tableOrPartition.add(parttype.getTree());
			}

			KW_COMPUTE349=(Token)match(input,KW_COMPUTE,FOLLOW_KW_COMPUTE_in_analyzeStatement6180);  
			stream_KW_COMPUTE.add(KW_COMPUTE349);

			KW_STATISTICS350=(Token)match(input,KW_STATISTICS,FOLLOW_KW_STATISTICS_in_analyzeStatement6182);  
			stream_KW_STATISTICS.add(KW_STATISTICS350);

			// HiveParser.g:1227:80: ( (noscan= KW_NOSCAN ) | (partialscan= KW_PARTIALSCAN ) | ( KW_FOR KW_COLUMNS statsColumnName= columnNameList ) )?
			int alt97=4;
			switch ( input.LA(1) ) {
				case KW_NOSCAN:
					{
					alt97=1;
					}
					break;
				case KW_PARTIALSCAN:
					{
					alt97=2;
					}
					break;
				case KW_FOR:
					{
					alt97=3;
					}
					break;
			}
			switch (alt97) {
				case 1 :
					// HiveParser.g:1227:81: (noscan= KW_NOSCAN )
					{
					// HiveParser.g:1227:81: (noscan= KW_NOSCAN )
					// HiveParser.g:1227:82: noscan= KW_NOSCAN
					{
					noscan=(Token)match(input,KW_NOSCAN,FOLLOW_KW_NOSCAN_in_analyzeStatement6188);  
					stream_KW_NOSCAN.add(noscan);

					}

					}
					break;
				case 2 :
					// HiveParser.g:1227:102: (partialscan= KW_PARTIALSCAN )
					{
					// HiveParser.g:1227:102: (partialscan= KW_PARTIALSCAN )
					// HiveParser.g:1227:103: partialscan= KW_PARTIALSCAN
					{
					partialscan=(Token)match(input,KW_PARTIALSCAN,FOLLOW_KW_PARTIALSCAN_in_analyzeStatement6196);  
					stream_KW_PARTIALSCAN.add(partialscan);

					}

					}
					break;
				case 3 :
					// HiveParser.g:1227:133: ( KW_FOR KW_COLUMNS statsColumnName= columnNameList )
					{
					// HiveParser.g:1227:133: ( KW_FOR KW_COLUMNS statsColumnName= columnNameList )
					// HiveParser.g:1227:134: KW_FOR KW_COLUMNS statsColumnName= columnNameList
					{
					KW_FOR351=(Token)match(input,KW_FOR,FOLLOW_KW_FOR_in_analyzeStatement6202);  
					stream_KW_FOR.add(KW_FOR351);

					KW_COLUMNS352=(Token)match(input,KW_COLUMNS,FOLLOW_KW_COLUMNS_in_analyzeStatement6204);  
					stream_KW_COLUMNS.add(KW_COLUMNS352);

					pushFollow(FOLLOW_columnNameList_in_analyzeStatement6208);
					statsColumnName=columnNameList();
					state._fsp--;

					stream_columnNameList.add(statsColumnName.getTree());
					}

					}
					break;

			}

			// AST REWRITE
			// elements: parttype, noscan, partialscan, statsColumnName
			// token labels: partialscan, noscan
			// rule labels: retval, parttype, statsColumnName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_partialscan=new RewriteRuleTokenStream(adaptor,"token partialscan",partialscan);
			RewriteRuleTokenStream stream_noscan=new RewriteRuleTokenStream(adaptor,"token noscan",noscan);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_parttype=new RewriteRuleSubtreeStream(adaptor,"rule parttype",parttype!=null?parttype.getTree():null);
			RewriteRuleSubtreeStream stream_statsColumnName=new RewriteRuleSubtreeStream(adaptor,"rule statsColumnName",statsColumnName!=null?statsColumnName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1227:186: -> ^( TOK_ANALYZE $parttype ( $noscan)? ( $partialscan)? ( $statsColumnName)? )
			{
				// HiveParser.g:1227:189: ^( TOK_ANALYZE $parttype ( $noscan)? ( $partialscan)? ( $statsColumnName)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ANALYZE, "TOK_ANALYZE"), root_1);
				adaptor.addChild(root_1, stream_parttype.nextTree());
				// HiveParser.g:1227:214: ( $noscan)?
				if ( stream_noscan.hasNext() ) {
					adaptor.addChild(root_1, stream_noscan.nextNode());
				}
				stream_noscan.reset();

				// HiveParser.g:1227:223: ( $partialscan)?
				if ( stream_partialscan.hasNext() ) {
					adaptor.addChild(root_1, stream_partialscan.nextNode());
				}
				stream_partialscan.reset();

				// HiveParser.g:1227:237: ( $statsColumnName)?
				if ( stream_statsColumnName.hasNext() ) {
					adaptor.addChild(root_1, stream_statsColumnName.nextTree());
				}
				stream_statsColumnName.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "analyzeStatement"


	public static class showStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "showStatement"
	// HiveParser.g:1230:1: showStatement : ( KW_SHOW ( KW_DATABASES | KW_SCHEMAS ) ( KW_LIKE showStmtIdentifier )? -> ^( TOK_SHOWDATABASES ( showStmtIdentifier )? ) | KW_SHOW KW_TABLES ( ( KW_FROM | KW_IN ) db_name= identifier )? ( KW_LIKE showStmtIdentifier | showStmtIdentifier )? -> ^( TOK_SHOWTABLES ( TOK_FROM $db_name)? ( showStmtIdentifier )? ) | KW_SHOW KW_COLUMNS ( KW_FROM | KW_IN ) tabname= tableName ( ( KW_FROM | KW_IN ) db_name= identifier )? -> ^( TOK_SHOWCOLUMNS ( $db_name)? $tabname) | KW_SHOW KW_FUNCTIONS ( showStmtIdentifier )? -> ^( TOK_SHOWFUNCTIONS ( showStmtIdentifier )? ) | KW_SHOW KW_PARTITIONS identifier ( partitionSpec )? -> ^( TOK_SHOWPARTITIONS identifier ( partitionSpec )? ) | KW_SHOW KW_CREATE KW_TABLE tabName= tableName -> ^( TOK_SHOW_CREATETABLE $tabName) | KW_SHOW KW_TABLE KW_EXTENDED ( ( KW_FROM | KW_IN ) db_name= identifier )? KW_LIKE showStmtIdentifier ( partitionSpec )? -> ^( TOK_SHOW_TABLESTATUS showStmtIdentifier ( $db_name)? ( partitionSpec )? ) | KW_SHOW KW_TBLPROPERTIES tblName= identifier ( LPAREN prptyName= StringLiteral RPAREN )? -> ^( TOK_SHOW_TBLPROPERTIES $tblName ( $prptyName)? ) | KW_SHOW KW_LOCKS (parttype= partTypeExpr )? (isExtended= KW_EXTENDED )? -> ^( TOK_SHOWLOCKS ( $parttype)? ( $isExtended)? ) | KW_SHOW (showOptions= KW_FORMATTED )? ( KW_INDEX | KW_INDEXES ) KW_ON showStmtIdentifier ( ( KW_FROM | KW_IN ) db_name= identifier )? -> ^( TOK_SHOWINDEXES showStmtIdentifier ( $showOptions)? ( $db_name)? ) );
	public final HiveParser.showStatement_return showStatement() throws RecognitionException {
		HiveParser.showStatement_return retval = new HiveParser.showStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token prptyName=null;
		Token isExtended=null;
		Token showOptions=null;
		Token KW_SHOW353=null;
		Token KW_DATABASES354=null;
		Token KW_SCHEMAS355=null;
		Token KW_LIKE356=null;
		Token KW_SHOW358=null;
		Token KW_TABLES359=null;
		Token KW_FROM360=null;
		Token KW_IN361=null;
		Token KW_LIKE362=null;
		Token KW_SHOW365=null;
		Token KW_COLUMNS366=null;
		Token KW_FROM367=null;
		Token KW_IN368=null;
		Token KW_FROM369=null;
		Token KW_IN370=null;
		Token KW_SHOW371=null;
		Token KW_FUNCTIONS372=null;
		Token KW_SHOW374=null;
		Token KW_PARTITIONS375=null;
		Token KW_SHOW378=null;
		Token KW_CREATE379=null;
		Token KW_TABLE380=null;
		Token KW_SHOW381=null;
		Token KW_TABLE382=null;
		Token KW_EXTENDED383=null;
		Token KW_FROM384=null;
		Token KW_IN385=null;
		Token KW_LIKE386=null;
		Token KW_SHOW389=null;
		Token KW_TBLPROPERTIES390=null;
		Token LPAREN391=null;
		Token RPAREN392=null;
		Token KW_SHOW393=null;
		Token KW_LOCKS394=null;
		Token KW_SHOW395=null;
		Token KW_INDEX396=null;
		Token KW_INDEXES397=null;
		Token KW_ON398=null;
		Token KW_FROM400=null;
		Token KW_IN401=null;
		ParserRuleReturnScope db_name =null;
		ParserRuleReturnScope tabname =null;
		ParserRuleReturnScope tabName =null;
		ParserRuleReturnScope tblName =null;
		ParserRuleReturnScope parttype =null;
		ParserRuleReturnScope showStmtIdentifier357 =null;
		ParserRuleReturnScope showStmtIdentifier363 =null;
		ParserRuleReturnScope showStmtIdentifier364 =null;
		ParserRuleReturnScope showStmtIdentifier373 =null;
		ParserRuleReturnScope identifier376 =null;
		ParserRuleReturnScope partitionSpec377 =null;
		ParserRuleReturnScope showStmtIdentifier387 =null;
		ParserRuleReturnScope partitionSpec388 =null;
		ParserRuleReturnScope showStmtIdentifier399 =null;

		CommonTree prptyName_tree=null;
		CommonTree isExtended_tree=null;
		CommonTree showOptions_tree=null;
		CommonTree KW_SHOW353_tree=null;
		CommonTree KW_DATABASES354_tree=null;
		CommonTree KW_SCHEMAS355_tree=null;
		CommonTree KW_LIKE356_tree=null;
		CommonTree KW_SHOW358_tree=null;
		CommonTree KW_TABLES359_tree=null;
		CommonTree KW_FROM360_tree=null;
		CommonTree KW_IN361_tree=null;
		CommonTree KW_LIKE362_tree=null;
		CommonTree KW_SHOW365_tree=null;
		CommonTree KW_COLUMNS366_tree=null;
		CommonTree KW_FROM367_tree=null;
		CommonTree KW_IN368_tree=null;
		CommonTree KW_FROM369_tree=null;
		CommonTree KW_IN370_tree=null;
		CommonTree KW_SHOW371_tree=null;
		CommonTree KW_FUNCTIONS372_tree=null;
		CommonTree KW_SHOW374_tree=null;
		CommonTree KW_PARTITIONS375_tree=null;
		CommonTree KW_SHOW378_tree=null;
		CommonTree KW_CREATE379_tree=null;
		CommonTree KW_TABLE380_tree=null;
		CommonTree KW_SHOW381_tree=null;
		CommonTree KW_TABLE382_tree=null;
		CommonTree KW_EXTENDED383_tree=null;
		CommonTree KW_FROM384_tree=null;
		CommonTree KW_IN385_tree=null;
		CommonTree KW_LIKE386_tree=null;
		CommonTree KW_SHOW389_tree=null;
		CommonTree KW_TBLPROPERTIES390_tree=null;
		CommonTree LPAREN391_tree=null;
		CommonTree RPAREN392_tree=null;
		CommonTree KW_SHOW393_tree=null;
		CommonTree KW_LOCKS394_tree=null;
		CommonTree KW_SHOW395_tree=null;
		CommonTree KW_INDEX396_tree=null;
		CommonTree KW_INDEXES397_tree=null;
		CommonTree KW_ON398_tree=null;
		CommonTree KW_FROM400_tree=null;
		CommonTree KW_IN401_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_SHOW=new RewriteRuleTokenStream(adaptor,"token KW_SHOW");
		RewriteRuleTokenStream stream_KW_LOCKS=new RewriteRuleTokenStream(adaptor,"token KW_LOCKS");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_LIKE=new RewriteRuleTokenStream(adaptor,"token KW_LIKE");
		RewriteRuleTokenStream stream_KW_FORMATTED=new RewriteRuleTokenStream(adaptor,"token KW_FORMATTED");
		RewriteRuleTokenStream stream_KW_COLUMNS=new RewriteRuleTokenStream(adaptor,"token KW_COLUMNS");
		RewriteRuleTokenStream stream_KW_PARTITIONS=new RewriteRuleTokenStream(adaptor,"token KW_PARTITIONS");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_KW_FUNCTIONS=new RewriteRuleTokenStream(adaptor,"token KW_FUNCTIONS");
		RewriteRuleTokenStream stream_KW_IN=new RewriteRuleTokenStream(adaptor,"token KW_IN");
		RewriteRuleTokenStream stream_KW_INDEXES=new RewriteRuleTokenStream(adaptor,"token KW_INDEXES");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_KW_SCHEMAS=new RewriteRuleTokenStream(adaptor,"token KW_SCHEMAS");
		RewriteRuleTokenStream stream_KW_INDEX=new RewriteRuleTokenStream(adaptor,"token KW_INDEX");
		RewriteRuleTokenStream stream_KW_TABLES=new RewriteRuleTokenStream(adaptor,"token KW_TABLES");
		RewriteRuleTokenStream stream_KW_EXTENDED=new RewriteRuleTokenStream(adaptor,"token KW_EXTENDED");
		RewriteRuleTokenStream stream_KW_DATABASES=new RewriteRuleTokenStream(adaptor,"token KW_DATABASES");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_TBLPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_TBLPROPERTIES");
		RewriteRuleTokenStream stream_KW_FROM=new RewriteRuleTokenStream(adaptor,"token KW_FROM");
		RewriteRuleSubtreeStream stream_showStmtIdentifier=new RewriteRuleSubtreeStream(adaptor,"rule showStmtIdentifier");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_partTypeExpr=new RewriteRuleSubtreeStream(adaptor,"rule partTypeExpr");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("show statement"); 
		try {
			// HiveParser.g:1233:5: ( KW_SHOW ( KW_DATABASES | KW_SCHEMAS ) ( KW_LIKE showStmtIdentifier )? -> ^( TOK_SHOWDATABASES ( showStmtIdentifier )? ) | KW_SHOW KW_TABLES ( ( KW_FROM | KW_IN ) db_name= identifier )? ( KW_LIKE showStmtIdentifier | showStmtIdentifier )? -> ^( TOK_SHOWTABLES ( TOK_FROM $db_name)? ( showStmtIdentifier )? ) | KW_SHOW KW_COLUMNS ( KW_FROM | KW_IN ) tabname= tableName ( ( KW_FROM | KW_IN ) db_name= identifier )? -> ^( TOK_SHOWCOLUMNS ( $db_name)? $tabname) | KW_SHOW KW_FUNCTIONS ( showStmtIdentifier )? -> ^( TOK_SHOWFUNCTIONS ( showStmtIdentifier )? ) | KW_SHOW KW_PARTITIONS identifier ( partitionSpec )? -> ^( TOK_SHOWPARTITIONS identifier ( partitionSpec )? ) | KW_SHOW KW_CREATE KW_TABLE tabName= tableName -> ^( TOK_SHOW_CREATETABLE $tabName) | KW_SHOW KW_TABLE KW_EXTENDED ( ( KW_FROM | KW_IN ) db_name= identifier )? KW_LIKE showStmtIdentifier ( partitionSpec )? -> ^( TOK_SHOW_TABLESTATUS showStmtIdentifier ( $db_name)? ( partitionSpec )? ) | KW_SHOW KW_TBLPROPERTIES tblName= identifier ( LPAREN prptyName= StringLiteral RPAREN )? -> ^( TOK_SHOW_TBLPROPERTIES $tblName ( $prptyName)? ) | KW_SHOW KW_LOCKS (parttype= partTypeExpr )? (isExtended= KW_EXTENDED )? -> ^( TOK_SHOWLOCKS ( $parttype)? ( $isExtended)? ) | KW_SHOW (showOptions= KW_FORMATTED )? ( KW_INDEX | KW_INDEXES ) KW_ON showStmtIdentifier ( ( KW_FROM | KW_IN ) db_name= identifier )? -> ^( TOK_SHOWINDEXES showStmtIdentifier ( $showOptions)? ( $db_name)? ) )
			int alt118=10;
			int LA118_0 = input.LA(1);
			if ( (LA118_0==KW_SHOW) ) {
				switch ( input.LA(2) ) {
				case KW_TABLES:
					{
					alt118=2;
					}
					break;
				case KW_COLUMNS:
					{
					alt118=3;
					}
					break;
				case KW_FUNCTIONS:
					{
					alt118=4;
					}
					break;
				case KW_PARTITIONS:
					{
					alt118=5;
					}
					break;
				case KW_CREATE:
					{
					alt118=6;
					}
					break;
				case KW_TABLE:
					{
					alt118=7;
					}
					break;
				case KW_TBLPROPERTIES:
					{
					alt118=8;
					}
					break;
				case KW_LOCKS:
					{
					alt118=9;
					}
					break;
				case KW_DATABASES:
				case KW_SCHEMAS:
					{
					alt118=1;
					}
					break;
				case KW_FORMATTED:
				case KW_INDEX:
				case KW_INDEXES:
					{
					alt118=10;
					}
					break;
				default:
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 118, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 118, 0, input);
				throw nvae;
			}

			switch (alt118) {
				case 1 :
					// HiveParser.g:1233:7: KW_SHOW ( KW_DATABASES | KW_SCHEMAS ) ( KW_LIKE showStmtIdentifier )?
					{
					KW_SHOW353=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6259);  
					stream_KW_SHOW.add(KW_SHOW353);

					// HiveParser.g:1233:15: ( KW_DATABASES | KW_SCHEMAS )
					int alt98=2;
					int LA98_0 = input.LA(1);
					if ( (LA98_0==KW_DATABASES) ) {
						alt98=1;
					}
					else if ( (LA98_0==KW_SCHEMAS) ) {
						alt98=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 98, 0, input);
						throw nvae;
					}

					switch (alt98) {
						case 1 :
							// HiveParser.g:1233:16: KW_DATABASES
							{
							KW_DATABASES354=(Token)match(input,KW_DATABASES,FOLLOW_KW_DATABASES_in_showStatement6262);  
							stream_KW_DATABASES.add(KW_DATABASES354);

							}
							break;
						case 2 :
							// HiveParser.g:1233:29: KW_SCHEMAS
							{
							KW_SCHEMAS355=(Token)match(input,KW_SCHEMAS,FOLLOW_KW_SCHEMAS_in_showStatement6264);  
							stream_KW_SCHEMAS.add(KW_SCHEMAS355);

							}
							break;

					}

					// HiveParser.g:1233:41: ( KW_LIKE showStmtIdentifier )?
					int alt99=2;
					int LA99_0 = input.LA(1);
					if ( (LA99_0==KW_LIKE) ) {
						alt99=1;
					}
					switch (alt99) {
						case 1 :
							// HiveParser.g:1233:42: KW_LIKE showStmtIdentifier
							{
							KW_LIKE356=(Token)match(input,KW_LIKE,FOLLOW_KW_LIKE_in_showStatement6268);  
							stream_KW_LIKE.add(KW_LIKE356);

							pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6270);
							showStmtIdentifier357=showStmtIdentifier();
							state._fsp--;

							stream_showStmtIdentifier.add(showStmtIdentifier357.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: showStmtIdentifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1233:71: -> ^( TOK_SHOWDATABASES ( showStmtIdentifier )? )
					{
						// HiveParser.g:1233:74: ^( TOK_SHOWDATABASES ( showStmtIdentifier )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWDATABASES, "TOK_SHOWDATABASES"), root_1);
						// HiveParser.g:1233:94: ( showStmtIdentifier )?
						if ( stream_showStmtIdentifier.hasNext() ) {
							adaptor.addChild(root_1, stream_showStmtIdentifier.nextTree());
						}
						stream_showStmtIdentifier.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1234:7: KW_SHOW KW_TABLES ( ( KW_FROM | KW_IN ) db_name= identifier )? ( KW_LIKE showStmtIdentifier | showStmtIdentifier )?
					{
					KW_SHOW358=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6289);  
					stream_KW_SHOW.add(KW_SHOW358);

					KW_TABLES359=(Token)match(input,KW_TABLES,FOLLOW_KW_TABLES_in_showStatement6291);  
					stream_KW_TABLES.add(KW_TABLES359);

					// HiveParser.g:1234:25: ( ( KW_FROM | KW_IN ) db_name= identifier )?
					int alt101=2;
					int LA101_0 = input.LA(1);
					if ( (LA101_0==KW_FROM) ) {
						alt101=1;
					}
					else if ( (LA101_0==KW_IN) ) {
						int LA101_2 = input.LA(2);
						if ( (LA101_2==Identifier||(LA101_2 >= KW_ADD && LA101_2 <= KW_AFTER)||(LA101_2 >= KW_ALTER && LA101_2 <= KW_ANALYZE)||(LA101_2 >= KW_ARCHIVE && LA101_2 <= KW_CASCADE)||(LA101_2 >= KW_CHANGE && LA101_2 <= KW_COLLECTION)||(LA101_2 >= KW_COLUMNS && LA101_2 <= KW_CONCATENATE)||(LA101_2 >= KW_CONTINUE && LA101_2 <= KW_CREATE)||LA101_2==KW_CUBE||(LA101_2 >= KW_CURSOR && LA101_2 <= KW_DATA)||(LA101_2 >= KW_DATABASES && LA101_2 <= KW_DATETIME)||(LA101_2 >= KW_DBPROPERTIES && LA101_2 <= KW_DISABLE)||(LA101_2 >= KW_DISTRIBUTE && LA101_2 <= KW_ELEM_TYPE)||LA101_2==KW_ENABLE||LA101_2==KW_ESCAPED||(LA101_2 >= KW_EXCLUSIVE && LA101_2 <= KW_EXPORT)||(LA101_2 >= KW_EXTERNAL && LA101_2 <= KW_FLOAT)||(LA101_2 >= KW_FOR && LA101_2 <= KW_FORMATTED)||LA101_2==KW_FULL||(LA101_2 >= KW_FUNCTIONS && LA101_2 <= KW_GROUPING)||LA101_2==KW_HOLD_DDLTIME||LA101_2==KW_IDXPROPERTIES||(LA101_2 >= KW_IGNORE && LA101_2 <= KW_INTERSECT)||(LA101_2 >= KW_INTO && LA101_2 <= KW_ITEMS)||(LA101_2 >= KW_KEYS && LA101_2 <= KW_LEFT)||(LA101_2 >= KW_LIKE && LA101_2 <= KW_LONG)||(LA101_2 >= KW_MAPJOIN && LA101_2 <= KW_MINUS)||(LA101_2 >= KW_MSCK && LA101_2 <= KW_NOSCAN)||(LA101_2 >= KW_NO_DROP && LA101_2 <= KW_OFFLINE)||LA101_2==KW_OPTION||(LA101_2 >= KW_ORCFILE && LA101_2 <= KW_OUTPUTFORMAT)||LA101_2==KW_OVERWRITE||(LA101_2 >= KW_PARTITION && LA101_2 <= KW_PLUS)||(LA101_2 >= KW_PRETTY && LA101_2 <= KW_RECORDWRITER)||(LA101_2 >= KW_REGEXP && LA101_2 <= KW_SCHEMAS)||(LA101_2 >= KW_SEMI && LA101_2 <= KW_TABLES)||(LA101_2 >= KW_TBLPROPERTIES && LA101_2 <= KW_TEXTFILE)||(LA101_2 >= KW_TIMESTAMP && LA101_2 <= KW_TOUCH)||(LA101_2 >= KW_TRIGGER && LA101_2 <= KW_UNARCHIVE)||(LA101_2 >= KW_UNDO && LA101_2 <= KW_UNIONTYPE)||(LA101_2 >= KW_UNLOCK && LA101_2 <= KW_VALUE_TYPE)||LA101_2==KW_VIEW||LA101_2==KW_WHILE||LA101_2==KW_WITH) ) {
							alt101=1;
						}
					}
					switch (alt101) {
						case 1 :
							// HiveParser.g:1234:26: ( KW_FROM | KW_IN ) db_name= identifier
							{
							// HiveParser.g:1234:26: ( KW_FROM | KW_IN )
							int alt100=2;
							int LA100_0 = input.LA(1);
							if ( (LA100_0==KW_FROM) ) {
								alt100=1;
							}
							else if ( (LA100_0==KW_IN) ) {
								alt100=2;
							}

							else {
								NoViableAltException nvae =
									new NoViableAltException("", 100, 0, input);
								throw nvae;
							}

							switch (alt100) {
								case 1 :
									// HiveParser.g:1234:27: KW_FROM
									{
									KW_FROM360=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_showStatement6295);  
									stream_KW_FROM.add(KW_FROM360);

									}
									break;
								case 2 :
									// HiveParser.g:1234:35: KW_IN
									{
									KW_IN361=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_showStatement6297);  
									stream_KW_IN.add(KW_IN361);

									}
									break;

							}

							pushFollow(FOLLOW_identifier_in_showStatement6302);
							db_name=identifier();
							state._fsp--;

							stream_identifier.add(db_name.getTree());
							}
							break;

					}

					// HiveParser.g:1234:63: ( KW_LIKE showStmtIdentifier | showStmtIdentifier )?
					int alt102=3;
					int LA102_0 = input.LA(1);
					if ( (LA102_0==KW_LIKE) ) {
						int LA102_1 = input.LA(2);
						if ( (LA102_1==Identifier||(LA102_1 >= KW_ADD && LA102_1 <= KW_AFTER)||(LA102_1 >= KW_ALTER && LA102_1 <= KW_ANALYZE)||(LA102_1 >= KW_ARCHIVE && LA102_1 <= KW_CASCADE)||(LA102_1 >= KW_CHANGE && LA102_1 <= KW_COLLECTION)||(LA102_1 >= KW_COLUMNS && LA102_1 <= KW_CONCATENATE)||(LA102_1 >= KW_CONTINUE && LA102_1 <= KW_CREATE)||LA102_1==KW_CUBE||(LA102_1 >= KW_CURSOR && LA102_1 <= KW_DATA)||(LA102_1 >= KW_DATABASES && LA102_1 <= KW_DATETIME)||(LA102_1 >= KW_DBPROPERTIES && LA102_1 <= KW_DISABLE)||(LA102_1 >= KW_DISTRIBUTE && LA102_1 <= KW_ELEM_TYPE)||LA102_1==KW_ENABLE||LA102_1==KW_ESCAPED||(LA102_1 >= KW_EXCLUSIVE && LA102_1 <= KW_EXPORT)||(LA102_1 >= KW_EXTERNAL && LA102_1 <= KW_FLOAT)||(LA102_1 >= KW_FOR && LA102_1 <= KW_FORMATTED)||LA102_1==KW_FULL||(LA102_1 >= KW_FUNCTIONS && LA102_1 <= KW_GROUPING)||LA102_1==KW_HOLD_DDLTIME||LA102_1==KW_IDXPROPERTIES||(LA102_1 >= KW_IGNORE && LA102_1 <= KW_INTERSECT)||(LA102_1 >= KW_INTO && LA102_1 <= KW_ITEMS)||(LA102_1 >= KW_KEYS && LA102_1 <= KW_LEFT)||(LA102_1 >= KW_LIKE && LA102_1 <= KW_LONG)||(LA102_1 >= KW_MAPJOIN && LA102_1 <= KW_MINUS)||(LA102_1 >= KW_MSCK && LA102_1 <= KW_NOSCAN)||(LA102_1 >= KW_NO_DROP && LA102_1 <= KW_OFFLINE)||LA102_1==KW_OPTION||(LA102_1 >= KW_ORCFILE && LA102_1 <= KW_OUTPUTFORMAT)||LA102_1==KW_OVERWRITE||(LA102_1 >= KW_PARTITION && LA102_1 <= KW_PLUS)||(LA102_1 >= KW_PRETTY && LA102_1 <= KW_RECORDWRITER)||(LA102_1 >= KW_REGEXP && LA102_1 <= KW_SCHEMAS)||(LA102_1 >= KW_SEMI && LA102_1 <= KW_TABLES)||(LA102_1 >= KW_TBLPROPERTIES && LA102_1 <= KW_TEXTFILE)||(LA102_1 >= KW_TIMESTAMP && LA102_1 <= KW_TOUCH)||(LA102_1 >= KW_TRIGGER && LA102_1 <= KW_UNARCHIVE)||(LA102_1 >= KW_UNDO && LA102_1 <= KW_UNIONTYPE)||(LA102_1 >= KW_UNLOCK && LA102_1 <= KW_VALUE_TYPE)||LA102_1==KW_VIEW||LA102_1==KW_WHILE||LA102_1==KW_WITH||LA102_1==StringLiteral) ) {
							alt102=1;
						}
						else if ( (LA102_1==EOF) ) {
							alt102=2;
						}
					}
					else if ( (LA102_0==Identifier||(LA102_0 >= KW_ADD && LA102_0 <= KW_AFTER)||(LA102_0 >= KW_ALTER && LA102_0 <= KW_ANALYZE)||(LA102_0 >= KW_ARCHIVE && LA102_0 <= KW_CASCADE)||(LA102_0 >= KW_CHANGE && LA102_0 <= KW_COLLECTION)||(LA102_0 >= KW_COLUMNS && LA102_0 <= KW_CONCATENATE)||(LA102_0 >= KW_CONTINUE && LA102_0 <= KW_CREATE)||LA102_0==KW_CUBE||(LA102_0 >= KW_CURSOR && LA102_0 <= KW_DATA)||(LA102_0 >= KW_DATABASES && LA102_0 <= KW_DATETIME)||(LA102_0 >= KW_DBPROPERTIES && LA102_0 <= KW_DISABLE)||(LA102_0 >= KW_DISTRIBUTE && LA102_0 <= KW_ELEM_TYPE)||LA102_0==KW_ENABLE||LA102_0==KW_ESCAPED||(LA102_0 >= KW_EXCLUSIVE && LA102_0 <= KW_EXPORT)||(LA102_0 >= KW_EXTERNAL && LA102_0 <= KW_FLOAT)||(LA102_0 >= KW_FOR && LA102_0 <= KW_FORMATTED)||LA102_0==KW_FULL||(LA102_0 >= KW_FUNCTIONS && LA102_0 <= KW_GROUPING)||LA102_0==KW_HOLD_DDLTIME||LA102_0==KW_IDXPROPERTIES||(LA102_0 >= KW_IGNORE && LA102_0 <= KW_INTERSECT)||(LA102_0 >= KW_INTO && LA102_0 <= KW_ITEMS)||(LA102_0 >= KW_KEYS && LA102_0 <= KW_LEFT)||(LA102_0 >= KW_LIMIT && LA102_0 <= KW_LONG)||(LA102_0 >= KW_MAPJOIN && LA102_0 <= KW_MINUS)||(LA102_0 >= KW_MSCK && LA102_0 <= KW_NOSCAN)||(LA102_0 >= KW_NO_DROP && LA102_0 <= KW_OFFLINE)||LA102_0==KW_OPTION||(LA102_0 >= KW_ORCFILE && LA102_0 <= KW_OUTPUTFORMAT)||LA102_0==KW_OVERWRITE||(LA102_0 >= KW_PARTITION && LA102_0 <= KW_PLUS)||(LA102_0 >= KW_PRETTY && LA102_0 <= KW_RECORDWRITER)||(LA102_0 >= KW_REGEXP && LA102_0 <= KW_SCHEMAS)||(LA102_0 >= KW_SEMI && LA102_0 <= KW_TABLES)||(LA102_0 >= KW_TBLPROPERTIES && LA102_0 <= KW_TEXTFILE)||(LA102_0 >= KW_TIMESTAMP && LA102_0 <= KW_TOUCH)||(LA102_0 >= KW_TRIGGER && LA102_0 <= KW_UNARCHIVE)||(LA102_0 >= KW_UNDO && LA102_0 <= KW_UNIONTYPE)||(LA102_0 >= KW_UNLOCK && LA102_0 <= KW_VALUE_TYPE)||LA102_0==KW_VIEW||LA102_0==KW_WHILE||LA102_0==KW_WITH||LA102_0==StringLiteral) ) {
						alt102=2;
					}
					switch (alt102) {
						case 1 :
							// HiveParser.g:1234:64: KW_LIKE showStmtIdentifier
							{
							KW_LIKE362=(Token)match(input,KW_LIKE,FOLLOW_KW_LIKE_in_showStatement6307);  
							stream_KW_LIKE.add(KW_LIKE362);

							pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6309);
							showStmtIdentifier363=showStmtIdentifier();
							state._fsp--;

							stream_showStmtIdentifier.add(showStmtIdentifier363.getTree());
							}
							break;
						case 2 :
							// HiveParser.g:1234:91: showStmtIdentifier
							{
							pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6311);
							showStmtIdentifier364=showStmtIdentifier();
							state._fsp--;

							stream_showStmtIdentifier.add(showStmtIdentifier364.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: db_name, showStmtIdentifier
					// token labels: 
					// rule labels: retval, db_name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_db_name=new RewriteRuleSubtreeStream(adaptor,"rule db_name",db_name!=null?db_name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1234:113: -> ^( TOK_SHOWTABLES ( TOK_FROM $db_name)? ( showStmtIdentifier )? )
					{
						// HiveParser.g:1234:116: ^( TOK_SHOWTABLES ( TOK_FROM $db_name)? ( showStmtIdentifier )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWTABLES, "TOK_SHOWTABLES"), root_1);
						// HiveParser.g:1234:133: ( TOK_FROM $db_name)?
						if ( stream_db_name.hasNext() ) {
							adaptor.addChild(root_1, (CommonTree)adaptor.create(TOK_FROM, "TOK_FROM"));
							adaptor.addChild(root_1, stream_db_name.nextTree());
						}
						stream_db_name.reset();

						// HiveParser.g:1234:154: ( showStmtIdentifier )?
						if ( stream_showStmtIdentifier.hasNext() ) {
							adaptor.addChild(root_1, stream_showStmtIdentifier.nextTree());
						}
						stream_showStmtIdentifier.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1235:7: KW_SHOW KW_COLUMNS ( KW_FROM | KW_IN ) tabname= tableName ( ( KW_FROM | KW_IN ) db_name= identifier )?
					{
					KW_SHOW365=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6339);  
					stream_KW_SHOW.add(KW_SHOW365);

					KW_COLUMNS366=(Token)match(input,KW_COLUMNS,FOLLOW_KW_COLUMNS_in_showStatement6341);  
					stream_KW_COLUMNS.add(KW_COLUMNS366);

					// HiveParser.g:1235:26: ( KW_FROM | KW_IN )
					int alt103=2;
					int LA103_0 = input.LA(1);
					if ( (LA103_0==KW_FROM) ) {
						alt103=1;
					}
					else if ( (LA103_0==KW_IN) ) {
						alt103=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 103, 0, input);
						throw nvae;
					}

					switch (alt103) {
						case 1 :
							// HiveParser.g:1235:27: KW_FROM
							{
							KW_FROM367=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_showStatement6344);  
							stream_KW_FROM.add(KW_FROM367);

							}
							break;
						case 2 :
							// HiveParser.g:1235:35: KW_IN
							{
							KW_IN368=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_showStatement6346);  
							stream_KW_IN.add(KW_IN368);

							}
							break;

					}

					pushFollow(FOLLOW_tableName_in_showStatement6351);
					tabname=tableName();
					state._fsp--;

					stream_tableName.add(tabname.getTree());
					// HiveParser.g:1235:60: ( ( KW_FROM | KW_IN ) db_name= identifier )?
					int alt105=2;
					int LA105_0 = input.LA(1);
					if ( (LA105_0==KW_FROM||LA105_0==KW_IN) ) {
						alt105=1;
					}
					switch (alt105) {
						case 1 :
							// HiveParser.g:1235:61: ( KW_FROM | KW_IN ) db_name= identifier
							{
							// HiveParser.g:1235:61: ( KW_FROM | KW_IN )
							int alt104=2;
							int LA104_0 = input.LA(1);
							if ( (LA104_0==KW_FROM) ) {
								alt104=1;
							}
							else if ( (LA104_0==KW_IN) ) {
								alt104=2;
							}

							else {
								NoViableAltException nvae =
									new NoViableAltException("", 104, 0, input);
								throw nvae;
							}

							switch (alt104) {
								case 1 :
									// HiveParser.g:1235:62: KW_FROM
									{
									KW_FROM369=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_showStatement6355);  
									stream_KW_FROM.add(KW_FROM369);

									}
									break;
								case 2 :
									// HiveParser.g:1235:70: KW_IN
									{
									KW_IN370=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_showStatement6357);  
									stream_KW_IN.add(KW_IN370);

									}
									break;

							}

							pushFollow(FOLLOW_identifier_in_showStatement6362);
							db_name=identifier();
							state._fsp--;

							stream_identifier.add(db_name.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: db_name, tabname
					// token labels: 
					// rule labels: retval, db_name, tabname
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_db_name=new RewriteRuleSubtreeStream(adaptor,"rule db_name",db_name!=null?db_name.getTree():null);
					RewriteRuleSubtreeStream stream_tabname=new RewriteRuleSubtreeStream(adaptor,"rule tabname",tabname!=null?tabname.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1236:5: -> ^( TOK_SHOWCOLUMNS ( $db_name)? $tabname)
					{
						// HiveParser.g:1236:8: ^( TOK_SHOWCOLUMNS ( $db_name)? $tabname)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWCOLUMNS, "TOK_SHOWCOLUMNS"), root_1);
						// HiveParser.g:1236:27: ( $db_name)?
						if ( stream_db_name.hasNext() ) {
							adaptor.addChild(root_1, stream_db_name.nextTree());
						}
						stream_db_name.reset();

						adaptor.addChild(root_1, stream_tabname.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:1237:7: KW_SHOW KW_FUNCTIONS ( showStmtIdentifier )?
					{
					KW_SHOW371=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6390);  
					stream_KW_SHOW.add(KW_SHOW371);

					KW_FUNCTIONS372=(Token)match(input,KW_FUNCTIONS,FOLLOW_KW_FUNCTIONS_in_showStatement6392);  
					stream_KW_FUNCTIONS.add(KW_FUNCTIONS372);

					// HiveParser.g:1237:28: ( showStmtIdentifier )?
					int alt106=2;
					int LA106_0 = input.LA(1);
					if ( (LA106_0==Identifier||(LA106_0 >= KW_ADD && LA106_0 <= KW_AFTER)||(LA106_0 >= KW_ALTER && LA106_0 <= KW_ANALYZE)||(LA106_0 >= KW_ARCHIVE && LA106_0 <= KW_CASCADE)||(LA106_0 >= KW_CHANGE && LA106_0 <= KW_COLLECTION)||(LA106_0 >= KW_COLUMNS && LA106_0 <= KW_CONCATENATE)||(LA106_0 >= KW_CONTINUE && LA106_0 <= KW_CREATE)||LA106_0==KW_CUBE||(LA106_0 >= KW_CURSOR && LA106_0 <= KW_DATA)||(LA106_0 >= KW_DATABASES && LA106_0 <= KW_DATETIME)||(LA106_0 >= KW_DBPROPERTIES && LA106_0 <= KW_DISABLE)||(LA106_0 >= KW_DISTRIBUTE && LA106_0 <= KW_ELEM_TYPE)||LA106_0==KW_ENABLE||LA106_0==KW_ESCAPED||(LA106_0 >= KW_EXCLUSIVE && LA106_0 <= KW_EXPORT)||(LA106_0 >= KW_EXTERNAL && LA106_0 <= KW_FLOAT)||(LA106_0 >= KW_FOR && LA106_0 <= KW_FORMATTED)||LA106_0==KW_FULL||(LA106_0 >= KW_FUNCTIONS && LA106_0 <= KW_GROUPING)||LA106_0==KW_HOLD_DDLTIME||LA106_0==KW_IDXPROPERTIES||(LA106_0 >= KW_IGNORE && LA106_0 <= KW_INTERSECT)||(LA106_0 >= KW_INTO && LA106_0 <= KW_ITEMS)||(LA106_0 >= KW_KEYS && LA106_0 <= KW_LEFT)||(LA106_0 >= KW_LIKE && LA106_0 <= KW_LONG)||(LA106_0 >= KW_MAPJOIN && LA106_0 <= KW_MINUS)||(LA106_0 >= KW_MSCK && LA106_0 <= KW_NOSCAN)||(LA106_0 >= KW_NO_DROP && LA106_0 <= KW_OFFLINE)||LA106_0==KW_OPTION||(LA106_0 >= KW_ORCFILE && LA106_0 <= KW_OUTPUTFORMAT)||LA106_0==KW_OVERWRITE||(LA106_0 >= KW_PARTITION && LA106_0 <= KW_PLUS)||(LA106_0 >= KW_PRETTY && LA106_0 <= KW_RECORDWRITER)||(LA106_0 >= KW_REGEXP && LA106_0 <= KW_SCHEMAS)||(LA106_0 >= KW_SEMI && LA106_0 <= KW_TABLES)||(LA106_0 >= KW_TBLPROPERTIES && LA106_0 <= KW_TEXTFILE)||(LA106_0 >= KW_TIMESTAMP && LA106_0 <= KW_TOUCH)||(LA106_0 >= KW_TRIGGER && LA106_0 <= KW_UNARCHIVE)||(LA106_0 >= KW_UNDO && LA106_0 <= KW_UNIONTYPE)||(LA106_0 >= KW_UNLOCK && LA106_0 <= KW_VALUE_TYPE)||LA106_0==KW_VIEW||LA106_0==KW_WHILE||LA106_0==KW_WITH||LA106_0==StringLiteral) ) {
						alt106=1;
					}
					switch (alt106) {
						case 1 :
							// HiveParser.g:1237:28: showStmtIdentifier
							{
							pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6394);
							showStmtIdentifier373=showStmtIdentifier();
							state._fsp--;

							stream_showStmtIdentifier.add(showStmtIdentifier373.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: showStmtIdentifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1237:49: -> ^( TOK_SHOWFUNCTIONS ( showStmtIdentifier )? )
					{
						// HiveParser.g:1237:52: ^( TOK_SHOWFUNCTIONS ( showStmtIdentifier )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWFUNCTIONS, "TOK_SHOWFUNCTIONS"), root_1);
						// HiveParser.g:1237:72: ( showStmtIdentifier )?
						if ( stream_showStmtIdentifier.hasNext() ) {
							adaptor.addChild(root_1, stream_showStmtIdentifier.nextTree());
						}
						stream_showStmtIdentifier.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:1238:7: KW_SHOW KW_PARTITIONS identifier ( partitionSpec )?
					{
					KW_SHOW374=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6413);  
					stream_KW_SHOW.add(KW_SHOW374);

					KW_PARTITIONS375=(Token)match(input,KW_PARTITIONS,FOLLOW_KW_PARTITIONS_in_showStatement6415);  
					stream_KW_PARTITIONS.add(KW_PARTITIONS375);

					pushFollow(FOLLOW_identifier_in_showStatement6417);
					identifier376=identifier();
					state._fsp--;

					stream_identifier.add(identifier376.getTree());
					// HiveParser.g:1238:40: ( partitionSpec )?
					int alt107=2;
					int LA107_0 = input.LA(1);
					if ( (LA107_0==KW_PARTITION) ) {
						alt107=1;
					}
					switch (alt107) {
						case 1 :
							// HiveParser.g:1238:40: partitionSpec
							{
							pushFollow(FOLLOW_partitionSpec_in_showStatement6419);
							partitionSpec377=partitionSpec();
							state._fsp--;

							stream_partitionSpec.add(partitionSpec377.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: partitionSpec, identifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1238:55: -> ^( TOK_SHOWPARTITIONS identifier ( partitionSpec )? )
					{
						// HiveParser.g:1238:58: ^( TOK_SHOWPARTITIONS identifier ( partitionSpec )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWPARTITIONS, "TOK_SHOWPARTITIONS"), root_1);
						adaptor.addChild(root_1, stream_identifier.nextTree());
						// HiveParser.g:1238:90: ( partitionSpec )?
						if ( stream_partitionSpec.hasNext() ) {
							adaptor.addChild(root_1, stream_partitionSpec.nextTree());
						}
						stream_partitionSpec.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 6 :
					// HiveParser.g:1239:7: KW_SHOW KW_CREATE KW_TABLE tabName= tableName
					{
					KW_SHOW378=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6439);  
					stream_KW_SHOW.add(KW_SHOW378);

					KW_CREATE379=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_showStatement6441);  
					stream_KW_CREATE.add(KW_CREATE379);

					KW_TABLE380=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_showStatement6443);  
					stream_KW_TABLE.add(KW_TABLE380);

					pushFollow(FOLLOW_tableName_in_showStatement6447);
					tabName=tableName();
					state._fsp--;

					stream_tableName.add(tabName.getTree());
					// AST REWRITE
					// elements: tabName
					// token labels: 
					// rule labels: retval, tabName
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_tabName=new RewriteRuleSubtreeStream(adaptor,"rule tabName",tabName!=null?tabName.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1239:52: -> ^( TOK_SHOW_CREATETABLE $tabName)
					{
						// HiveParser.g:1239:55: ^( TOK_SHOW_CREATETABLE $tabName)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOW_CREATETABLE, "TOK_SHOW_CREATETABLE"), root_1);
						adaptor.addChild(root_1, stream_tabName.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 7 :
					// HiveParser.g:1240:7: KW_SHOW KW_TABLE KW_EXTENDED ( ( KW_FROM | KW_IN ) db_name= identifier )? KW_LIKE showStmtIdentifier ( partitionSpec )?
					{
					KW_SHOW381=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6464);  
					stream_KW_SHOW.add(KW_SHOW381);

					KW_TABLE382=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_showStatement6466);  
					stream_KW_TABLE.add(KW_TABLE382);

					KW_EXTENDED383=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_showStatement6468);  
					stream_KW_EXTENDED.add(KW_EXTENDED383);

					// HiveParser.g:1240:36: ( ( KW_FROM | KW_IN ) db_name= identifier )?
					int alt109=2;
					int LA109_0 = input.LA(1);
					if ( (LA109_0==KW_FROM||LA109_0==KW_IN) ) {
						alt109=1;
					}
					switch (alt109) {
						case 1 :
							// HiveParser.g:1240:37: ( KW_FROM | KW_IN ) db_name= identifier
							{
							// HiveParser.g:1240:37: ( KW_FROM | KW_IN )
							int alt108=2;
							int LA108_0 = input.LA(1);
							if ( (LA108_0==KW_FROM) ) {
								alt108=1;
							}
							else if ( (LA108_0==KW_IN) ) {
								alt108=2;
							}

							else {
								NoViableAltException nvae =
									new NoViableAltException("", 108, 0, input);
								throw nvae;
							}

							switch (alt108) {
								case 1 :
									// HiveParser.g:1240:38: KW_FROM
									{
									KW_FROM384=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_showStatement6472);  
									stream_KW_FROM.add(KW_FROM384);

									}
									break;
								case 2 :
									// HiveParser.g:1240:46: KW_IN
									{
									KW_IN385=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_showStatement6474);  
									stream_KW_IN.add(KW_IN385);

									}
									break;

							}

							pushFollow(FOLLOW_identifier_in_showStatement6479);
							db_name=identifier();
							state._fsp--;

							stream_identifier.add(db_name.getTree());
							}
							break;

					}

					KW_LIKE386=(Token)match(input,KW_LIKE,FOLLOW_KW_LIKE_in_showStatement6483);  
					stream_KW_LIKE.add(KW_LIKE386);

					pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6485);
					showStmtIdentifier387=showStmtIdentifier();
					state._fsp--;

					stream_showStmtIdentifier.add(showStmtIdentifier387.getTree());
					// HiveParser.g:1240:101: ( partitionSpec )?
					int alt110=2;
					int LA110_0 = input.LA(1);
					if ( (LA110_0==KW_PARTITION) ) {
						alt110=1;
					}
					switch (alt110) {
						case 1 :
							// HiveParser.g:1240:101: partitionSpec
							{
							pushFollow(FOLLOW_partitionSpec_in_showStatement6487);
							partitionSpec388=partitionSpec();
							state._fsp--;

							stream_partitionSpec.add(partitionSpec388.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: partitionSpec, db_name, showStmtIdentifier
					// token labels: 
					// rule labels: retval, db_name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_db_name=new RewriteRuleSubtreeStream(adaptor,"rule db_name",db_name!=null?db_name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1241:5: -> ^( TOK_SHOW_TABLESTATUS showStmtIdentifier ( $db_name)? ( partitionSpec )? )
					{
						// HiveParser.g:1241:8: ^( TOK_SHOW_TABLESTATUS showStmtIdentifier ( $db_name)? ( partitionSpec )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOW_TABLESTATUS, "TOK_SHOW_TABLESTATUS"), root_1);
						adaptor.addChild(root_1, stream_showStmtIdentifier.nextTree());
						// HiveParser.g:1241:51: ( $db_name)?
						if ( stream_db_name.hasNext() ) {
							adaptor.addChild(root_1, stream_db_name.nextTree());
						}
						stream_db_name.reset();

						// HiveParser.g:1241:60: ( partitionSpec )?
						if ( stream_partitionSpec.hasNext() ) {
							adaptor.addChild(root_1, stream_partitionSpec.nextTree());
						}
						stream_partitionSpec.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 8 :
					// HiveParser.g:1242:7: KW_SHOW KW_TBLPROPERTIES tblName= identifier ( LPAREN prptyName= StringLiteral RPAREN )?
					{
					KW_SHOW389=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6515);  
					stream_KW_SHOW.add(KW_SHOW389);

					KW_TBLPROPERTIES390=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_showStatement6517);  
					stream_KW_TBLPROPERTIES.add(KW_TBLPROPERTIES390);

					pushFollow(FOLLOW_identifier_in_showStatement6521);
					tblName=identifier();
					state._fsp--;

					stream_identifier.add(tblName.getTree());
					// HiveParser.g:1242:51: ( LPAREN prptyName= StringLiteral RPAREN )?
					int alt111=2;
					int LA111_0 = input.LA(1);
					if ( (LA111_0==LPAREN) ) {
						alt111=1;
					}
					switch (alt111) {
						case 1 :
							// HiveParser.g:1242:52: LPAREN prptyName= StringLiteral RPAREN
							{
							LPAREN391=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_showStatement6524);  
							stream_LPAREN.add(LPAREN391);

							prptyName=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_showStatement6528);  
							stream_StringLiteral.add(prptyName);

							RPAREN392=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_showStatement6530);  
							stream_RPAREN.add(RPAREN392);

							}
							break;

					}

					// AST REWRITE
					// elements: tblName, prptyName
					// token labels: prptyName
					// rule labels: retval, tblName
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_prptyName=new RewriteRuleTokenStream(adaptor,"token prptyName",prptyName);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_tblName=new RewriteRuleSubtreeStream(adaptor,"rule tblName",tblName!=null?tblName.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1242:92: -> ^( TOK_SHOW_TBLPROPERTIES $tblName ( $prptyName)? )
					{
						// HiveParser.g:1242:95: ^( TOK_SHOW_TBLPROPERTIES $tblName ( $prptyName)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOW_TBLPROPERTIES, "TOK_SHOW_TBLPROPERTIES"), root_1);
						adaptor.addChild(root_1, stream_tblName.nextTree());
						// HiveParser.g:1242:130: ( $prptyName)?
						if ( stream_prptyName.hasNext() ) {
							adaptor.addChild(root_1, stream_prptyName.nextNode());
						}
						stream_prptyName.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 9 :
					// HiveParser.g:1243:7: KW_SHOW KW_LOCKS (parttype= partTypeExpr )? (isExtended= KW_EXTENDED )?
					{
					KW_SHOW393=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6553);  
					stream_KW_SHOW.add(KW_SHOW393);

					KW_LOCKS394=(Token)match(input,KW_LOCKS,FOLLOW_KW_LOCKS_in_showStatement6555);  
					stream_KW_LOCKS.add(KW_LOCKS394);

					// HiveParser.g:1243:24: (parttype= partTypeExpr )?
					int alt112=2;
					int LA112_0 = input.LA(1);
					if ( (LA112_0==Identifier||(LA112_0 >= KW_ADD && LA112_0 <= KW_AFTER)||(LA112_0 >= KW_ALTER && LA112_0 <= KW_ANALYZE)||(LA112_0 >= KW_ARCHIVE && LA112_0 <= KW_CASCADE)||(LA112_0 >= KW_CHANGE && LA112_0 <= KW_COLLECTION)||(LA112_0 >= KW_COLUMNS && LA112_0 <= KW_CONCATENATE)||(LA112_0 >= KW_CONTINUE && LA112_0 <= KW_CREATE)||LA112_0==KW_CUBE||(LA112_0 >= KW_CURSOR && LA112_0 <= KW_DATA)||(LA112_0 >= KW_DATABASES && LA112_0 <= KW_DATETIME)||(LA112_0 >= KW_DBPROPERTIES && LA112_0 <= KW_DISABLE)||(LA112_0 >= KW_DISTRIBUTE && LA112_0 <= KW_ELEM_TYPE)||LA112_0==KW_ENABLE||LA112_0==KW_ESCAPED||(LA112_0 >= KW_EXCLUSIVE && LA112_0 <= KW_EXPORT)||(LA112_0 >= KW_EXTERNAL && LA112_0 <= KW_FLOAT)||(LA112_0 >= KW_FOR && LA112_0 <= KW_FORMATTED)||LA112_0==KW_FULL||(LA112_0 >= KW_FUNCTIONS && LA112_0 <= KW_GROUPING)||LA112_0==KW_HOLD_DDLTIME||LA112_0==KW_IDXPROPERTIES||(LA112_0 >= KW_IGNORE && LA112_0 <= KW_INTERSECT)||(LA112_0 >= KW_INTO && LA112_0 <= KW_ITEMS)||(LA112_0 >= KW_KEYS && LA112_0 <= KW_LEFT)||(LA112_0 >= KW_LIKE && LA112_0 <= KW_LONG)||(LA112_0 >= KW_MAPJOIN && LA112_0 <= KW_MINUS)||(LA112_0 >= KW_MSCK && LA112_0 <= KW_NOSCAN)||(LA112_0 >= KW_NO_DROP && LA112_0 <= KW_OFFLINE)||LA112_0==KW_OPTION||(LA112_0 >= KW_ORCFILE && LA112_0 <= KW_OUTPUTFORMAT)||LA112_0==KW_OVERWRITE||(LA112_0 >= KW_PARTITION && LA112_0 <= KW_PLUS)||(LA112_0 >= KW_PRETTY && LA112_0 <= KW_RECORDWRITER)||(LA112_0 >= KW_REGEXP && LA112_0 <= KW_SCHEMAS)||(LA112_0 >= KW_SEMI && LA112_0 <= KW_TABLES)||(LA112_0 >= KW_TBLPROPERTIES && LA112_0 <= KW_TEXTFILE)||(LA112_0 >= KW_TIMESTAMP && LA112_0 <= KW_TOUCH)||(LA112_0 >= KW_TRIGGER && LA112_0 <= KW_UNARCHIVE)||(LA112_0 >= KW_UNDO && LA112_0 <= KW_UNIONTYPE)||(LA112_0 >= KW_UNLOCK && LA112_0 <= KW_VALUE_TYPE)||LA112_0==KW_VIEW||LA112_0==KW_WHILE||LA112_0==KW_WITH) ) {
						alt112=1;
					}
					switch (alt112) {
						case 1 :
							// HiveParser.g:1243:25: parttype= partTypeExpr
							{
							pushFollow(FOLLOW_partTypeExpr_in_showStatement6560);
							parttype=partTypeExpr();
							state._fsp--;

							stream_partTypeExpr.add(parttype.getTree());
							}
							break;

					}

					// HiveParser.g:1243:49: (isExtended= KW_EXTENDED )?
					int alt113=2;
					int LA113_0 = input.LA(1);
					if ( (LA113_0==KW_EXTENDED) ) {
						alt113=1;
					}
					switch (alt113) {
						case 1 :
							// HiveParser.g:1243:50: isExtended= KW_EXTENDED
							{
							isExtended=(Token)match(input,KW_EXTENDED,FOLLOW_KW_EXTENDED_in_showStatement6567);  
							stream_KW_EXTENDED.add(isExtended);

							}
							break;

					}

					// AST REWRITE
					// elements: isExtended, parttype
					// token labels: isExtended
					// rule labels: retval, parttype
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_isExtended=new RewriteRuleTokenStream(adaptor,"token isExtended",isExtended);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_parttype=new RewriteRuleSubtreeStream(adaptor,"rule parttype",parttype!=null?parttype.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1243:75: -> ^( TOK_SHOWLOCKS ( $parttype)? ( $isExtended)? )
					{
						// HiveParser.g:1243:78: ^( TOK_SHOWLOCKS ( $parttype)? ( $isExtended)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWLOCKS, "TOK_SHOWLOCKS"), root_1);
						// HiveParser.g:1243:95: ( $parttype)?
						if ( stream_parttype.hasNext() ) {
							adaptor.addChild(root_1, stream_parttype.nextTree());
						}
						stream_parttype.reset();

						// HiveParser.g:1243:106: ( $isExtended)?
						if ( stream_isExtended.hasNext() ) {
							adaptor.addChild(root_1, stream_isExtended.nextNode());
						}
						stream_isExtended.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 10 :
					// HiveParser.g:1244:7: KW_SHOW (showOptions= KW_FORMATTED )? ( KW_INDEX | KW_INDEXES ) KW_ON showStmtIdentifier ( ( KW_FROM | KW_IN ) db_name= identifier )?
					{
					KW_SHOW395=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showStatement6591);  
					stream_KW_SHOW.add(KW_SHOW395);

					// HiveParser.g:1244:15: (showOptions= KW_FORMATTED )?
					int alt114=2;
					int LA114_0 = input.LA(1);
					if ( (LA114_0==KW_FORMATTED) ) {
						alt114=1;
					}
					switch (alt114) {
						case 1 :
							// HiveParser.g:1244:16: showOptions= KW_FORMATTED
							{
							showOptions=(Token)match(input,KW_FORMATTED,FOLLOW_KW_FORMATTED_in_showStatement6596);  
							stream_KW_FORMATTED.add(showOptions);

							}
							break;

					}

					// HiveParser.g:1244:43: ( KW_INDEX | KW_INDEXES )
					int alt115=2;
					int LA115_0 = input.LA(1);
					if ( (LA115_0==KW_INDEX) ) {
						alt115=1;
					}
					else if ( (LA115_0==KW_INDEXES) ) {
						alt115=2;
					}

					else {
						NoViableAltException nvae =
							new NoViableAltException("", 115, 0, input);
						throw nvae;
					}

					switch (alt115) {
						case 1 :
							// HiveParser.g:1244:44: KW_INDEX
							{
							KW_INDEX396=(Token)match(input,KW_INDEX,FOLLOW_KW_INDEX_in_showStatement6601);  
							stream_KW_INDEX.add(KW_INDEX396);

							}
							break;
						case 2 :
							// HiveParser.g:1244:53: KW_INDEXES
							{
							KW_INDEXES397=(Token)match(input,KW_INDEXES,FOLLOW_KW_INDEXES_in_showStatement6603);  
							stream_KW_INDEXES.add(KW_INDEXES397);

							}
							break;

					}

					KW_ON398=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_showStatement6606);  
					stream_KW_ON.add(KW_ON398);

					pushFollow(FOLLOW_showStmtIdentifier_in_showStatement6608);
					showStmtIdentifier399=showStmtIdentifier();
					state._fsp--;

					stream_showStmtIdentifier.add(showStmtIdentifier399.getTree());
					// HiveParser.g:1244:90: ( ( KW_FROM | KW_IN ) db_name= identifier )?
					int alt117=2;
					int LA117_0 = input.LA(1);
					if ( (LA117_0==KW_FROM||LA117_0==KW_IN) ) {
						alt117=1;
					}
					switch (alt117) {
						case 1 :
							// HiveParser.g:1244:91: ( KW_FROM | KW_IN ) db_name= identifier
							{
							// HiveParser.g:1244:91: ( KW_FROM | KW_IN )
							int alt116=2;
							int LA116_0 = input.LA(1);
							if ( (LA116_0==KW_FROM) ) {
								alt116=1;
							}
							else if ( (LA116_0==KW_IN) ) {
								alt116=2;
							}

							else {
								NoViableAltException nvae =
									new NoViableAltException("", 116, 0, input);
								throw nvae;
							}

							switch (alt116) {
								case 1 :
									// HiveParser.g:1244:92: KW_FROM
									{
									KW_FROM400=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_showStatement6612);  
									stream_KW_FROM.add(KW_FROM400);

									}
									break;
								case 2 :
									// HiveParser.g:1244:100: KW_IN
									{
									KW_IN401=(Token)match(input,KW_IN,FOLLOW_KW_IN_in_showStatement6614);  
									stream_KW_IN.add(KW_IN401);

									}
									break;

							}

							pushFollow(FOLLOW_identifier_in_showStatement6619);
							db_name=identifier();
							state._fsp--;

							stream_identifier.add(db_name.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: db_name, showOptions, showStmtIdentifier
					// token labels: showOptions
					// rule labels: retval, db_name
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_showOptions=new RewriteRuleTokenStream(adaptor,"token showOptions",showOptions);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_db_name=new RewriteRuleSubtreeStream(adaptor,"rule db_name",db_name!=null?db_name.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1245:5: -> ^( TOK_SHOWINDEXES showStmtIdentifier ( $showOptions)? ( $db_name)? )
					{
						// HiveParser.g:1245:8: ^( TOK_SHOWINDEXES showStmtIdentifier ( $showOptions)? ( $db_name)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOWINDEXES, "TOK_SHOWINDEXES"), root_1);
						adaptor.addChild(root_1, stream_showStmtIdentifier.nextTree());
						// HiveParser.g:1245:46: ( $showOptions)?
						if ( stream_showOptions.hasNext() ) {
							adaptor.addChild(root_1, stream_showOptions.nextNode());
						}
						stream_showOptions.reset();

						// HiveParser.g:1245:60: ( $db_name)?
						if ( stream_db_name.hasNext() ) {
							adaptor.addChild(root_1, stream_db_name.nextTree());
						}
						stream_db_name.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "showStatement"


	public static class lockStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "lockStatement"
	// HiveParser.g:1248:1: lockStatement : KW_LOCK KW_TABLE tableName ( partitionSpec )? lockMode -> ^( TOK_LOCKTABLE tableName lockMode ( partitionSpec )? ) ;
	public final HiveParser.lockStatement_return lockStatement() throws RecognitionException {
		HiveParser.lockStatement_return retval = new HiveParser.lockStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_LOCK402=null;
		Token KW_TABLE403=null;
		ParserRuleReturnScope tableName404 =null;
		ParserRuleReturnScope partitionSpec405 =null;
		ParserRuleReturnScope lockMode406 =null;

		CommonTree KW_LOCK402_tree=null;
		CommonTree KW_TABLE403_tree=null;
		RewriteRuleTokenStream stream_KW_LOCK=new RewriteRuleTokenStream(adaptor,"token KW_LOCK");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_lockMode=new RewriteRuleSubtreeStream(adaptor,"rule lockMode");

		 msgs.push("lock statement"); 
		try {
			// HiveParser.g:1251:5: ( KW_LOCK KW_TABLE tableName ( partitionSpec )? lockMode -> ^( TOK_LOCKTABLE tableName lockMode ( partitionSpec )? ) )
			// HiveParser.g:1251:7: KW_LOCK KW_TABLE tableName ( partitionSpec )? lockMode
			{
			KW_LOCK402=(Token)match(input,KW_LOCK,FOLLOW_KW_LOCK_in_lockStatement6668);  
			stream_KW_LOCK.add(KW_LOCK402);

			KW_TABLE403=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_lockStatement6670);  
			stream_KW_TABLE.add(KW_TABLE403);

			pushFollow(FOLLOW_tableName_in_lockStatement6672);
			tableName404=tableName();
			state._fsp--;

			stream_tableName.add(tableName404.getTree());
			// HiveParser.g:1251:34: ( partitionSpec )?
			int alt119=2;
			int LA119_0 = input.LA(1);
			if ( (LA119_0==KW_PARTITION) ) {
				alt119=1;
			}
			switch (alt119) {
				case 1 :
					// HiveParser.g:1251:34: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_lockStatement6674);
					partitionSpec405=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec405.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_lockMode_in_lockStatement6677);
			lockMode406=lockMode();
			state._fsp--;

			stream_lockMode.add(lockMode406.getTree());
			// AST REWRITE
			// elements: tableName, partitionSpec, lockMode
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1251:58: -> ^( TOK_LOCKTABLE tableName lockMode ( partitionSpec )? )
			{
				// HiveParser.g:1251:61: ^( TOK_LOCKTABLE tableName lockMode ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LOCKTABLE, "TOK_LOCKTABLE"), root_1);
				adaptor.addChild(root_1, stream_tableName.nextTree());
				adaptor.addChild(root_1, stream_lockMode.nextTree());
				// HiveParser.g:1251:96: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "lockStatement"


	public static class lockMode_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "lockMode"
	// HiveParser.g:1254:1: lockMode : ( KW_SHARED | KW_EXCLUSIVE );
	public final HiveParser.lockMode_return lockMode() throws RecognitionException {
		HiveParser.lockMode_return retval = new HiveParser.lockMode_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token set407=null;

		CommonTree set407_tree=null;

		 msgs.push("lock mode"); 
		try {
			// HiveParser.g:1257:5: ( KW_SHARED | KW_EXCLUSIVE )
			// HiveParser.g:
			{
			root_0 = (CommonTree)adaptor.nil();


			set407=input.LT(1);
			if ( input.LA(1)==KW_EXCLUSIVE||input.LA(1)==KW_SHARED ) {
				input.consume();
				adaptor.addChild(root_0, (CommonTree)adaptor.create(set407));
				state.errorRecovery=false;
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "lockMode"


	public static class unlockStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "unlockStatement"
	// HiveParser.g:1260:1: unlockStatement : KW_UNLOCK KW_TABLE tableName ( partitionSpec )? -> ^( TOK_UNLOCKTABLE tableName ( partitionSpec )? ) ;
	public final HiveParser.unlockStatement_return unlockStatement() throws RecognitionException {
		HiveParser.unlockStatement_return retval = new HiveParser.unlockStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_UNLOCK408=null;
		Token KW_TABLE409=null;
		ParserRuleReturnScope tableName410 =null;
		ParserRuleReturnScope partitionSpec411 =null;

		CommonTree KW_UNLOCK408_tree=null;
		CommonTree KW_TABLE409_tree=null;
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_UNLOCK=new RewriteRuleTokenStream(adaptor,"token KW_UNLOCK");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");

		 msgs.push("unlock statement"); 
		try {
			// HiveParser.g:1263:5: ( KW_UNLOCK KW_TABLE tableName ( partitionSpec )? -> ^( TOK_UNLOCKTABLE tableName ( partitionSpec )? ) )
			// HiveParser.g:1263:7: KW_UNLOCK KW_TABLE tableName ( partitionSpec )?
			{
			KW_UNLOCK408=(Token)match(input,KW_UNLOCK,FOLLOW_KW_UNLOCK_in_unlockStatement6748);  
			stream_KW_UNLOCK.add(KW_UNLOCK408);

			KW_TABLE409=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_unlockStatement6750);  
			stream_KW_TABLE.add(KW_TABLE409);

			pushFollow(FOLLOW_tableName_in_unlockStatement6752);
			tableName410=tableName();
			state._fsp--;

			stream_tableName.add(tableName410.getTree());
			// HiveParser.g:1263:36: ( partitionSpec )?
			int alt120=2;
			int LA120_0 = input.LA(1);
			if ( (LA120_0==KW_PARTITION) ) {
				alt120=1;
			}
			switch (alt120) {
				case 1 :
					// HiveParser.g:1263:36: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_unlockStatement6754);
					partitionSpec411=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec411.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: partitionSpec, tableName
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1263:52: -> ^( TOK_UNLOCKTABLE tableName ( partitionSpec )? )
			{
				// HiveParser.g:1263:55: ^( TOK_UNLOCKTABLE tableName ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_UNLOCKTABLE, "TOK_UNLOCKTABLE"), root_1);
				adaptor.addChild(root_1, stream_tableName.nextTree());
				// HiveParser.g:1263:83: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "unlockStatement"


	public static class createRoleStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createRoleStatement"
	// HiveParser.g:1266:1: createRoleStatement : KW_CREATE KW_ROLE roleName= identifier -> ^( TOK_CREATEROLE $roleName) ;
	public final HiveParser.createRoleStatement_return createRoleStatement() throws RecognitionException {
		HiveParser.createRoleStatement_return retval = new HiveParser.createRoleStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CREATE412=null;
		Token KW_ROLE413=null;
		ParserRuleReturnScope roleName =null;

		CommonTree KW_CREATE412_tree=null;
		CommonTree KW_ROLE413_tree=null;
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("create role"); 
		try {
			// HiveParser.g:1269:5: ( KW_CREATE KW_ROLE roleName= identifier -> ^( TOK_CREATEROLE $roleName) )
			// HiveParser.g:1269:7: KW_CREATE KW_ROLE roleName= identifier
			{
			KW_CREATE412=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createRoleStatement6794);  
			stream_KW_CREATE.add(KW_CREATE412);

			KW_ROLE413=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_createRoleStatement6796);  
			stream_KW_ROLE.add(KW_ROLE413);

			pushFollow(FOLLOW_identifier_in_createRoleStatement6800);
			roleName=identifier();
			state._fsp--;

			stream_identifier.add(roleName.getTree());
			// AST REWRITE
			// elements: roleName
			// token labels: 
			// rule labels: retval, roleName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_roleName=new RewriteRuleSubtreeStream(adaptor,"rule roleName",roleName!=null?roleName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1270:5: -> ^( TOK_CREATEROLE $roleName)
			{
				// HiveParser.g:1270:8: ^( TOK_CREATEROLE $roleName)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEROLE, "TOK_CREATEROLE"), root_1);
				adaptor.addChild(root_1, stream_roleName.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createRoleStatement"


	public static class dropRoleStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropRoleStatement"
	// HiveParser.g:1273:1: dropRoleStatement : KW_DROP KW_ROLE roleName= identifier -> ^( TOK_DROPROLE $roleName) ;
	public final HiveParser.dropRoleStatement_return dropRoleStatement() throws RecognitionException {
		HiveParser.dropRoleStatement_return retval = new HiveParser.dropRoleStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP414=null;
		Token KW_ROLE415=null;
		ParserRuleReturnScope roleName =null;

		CommonTree KW_DROP414_tree=null;
		CommonTree KW_ROLE415_tree=null;
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("drop role");
		try {
			// HiveParser.g:1276:5: ( KW_DROP KW_ROLE roleName= identifier -> ^( TOK_DROPROLE $roleName) )
			// HiveParser.g:1276:7: KW_DROP KW_ROLE roleName= identifier
			{
			KW_DROP414=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropRoleStatement6840);  
			stream_KW_DROP.add(KW_DROP414);

			KW_ROLE415=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_dropRoleStatement6842);  
			stream_KW_ROLE.add(KW_ROLE415);

			pushFollow(FOLLOW_identifier_in_dropRoleStatement6846);
			roleName=identifier();
			state._fsp--;

			stream_identifier.add(roleName.getTree());
			// AST REWRITE
			// elements: roleName
			// token labels: 
			// rule labels: retval, roleName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_roleName=new RewriteRuleSubtreeStream(adaptor,"rule roleName",roleName!=null?roleName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1277:5: -> ^( TOK_DROPROLE $roleName)
			{
				// HiveParser.g:1277:8: ^( TOK_DROPROLE $roleName)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPROLE, "TOK_DROPROLE"), root_1);
				adaptor.addChild(root_1, stream_roleName.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropRoleStatement"


	public static class grantPrivileges_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "grantPrivileges"
	// HiveParser.g:1280:1: grantPrivileges : KW_GRANT privList= privilegeList ( privilegeObject )? KW_TO principalSpecification ( KW_WITH withOption )? -> ^( TOK_GRANT $privList principalSpecification ( privilegeObject )? ( withOption )? ) ;
	public final HiveParser.grantPrivileges_return grantPrivileges() throws RecognitionException {
		HiveParser.grantPrivileges_return retval = new HiveParser.grantPrivileges_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_GRANT416=null;
		Token KW_TO418=null;
		Token KW_WITH420=null;
		ParserRuleReturnScope privList =null;
		ParserRuleReturnScope privilegeObject417 =null;
		ParserRuleReturnScope principalSpecification419 =null;
		ParserRuleReturnScope withOption421 =null;

		CommonTree KW_GRANT416_tree=null;
		CommonTree KW_TO418_tree=null;
		CommonTree KW_WITH420_tree=null;
		RewriteRuleTokenStream stream_KW_GRANT=new RewriteRuleTokenStream(adaptor,"token KW_GRANT");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_TO=new RewriteRuleTokenStream(adaptor,"token KW_TO");
		RewriteRuleSubtreeStream stream_privilegeList=new RewriteRuleSubtreeStream(adaptor,"rule privilegeList");
		RewriteRuleSubtreeStream stream_privilegeObject=new RewriteRuleSubtreeStream(adaptor,"rule privilegeObject");
		RewriteRuleSubtreeStream stream_principalSpecification=new RewriteRuleSubtreeStream(adaptor,"rule principalSpecification");
		RewriteRuleSubtreeStream stream_withOption=new RewriteRuleSubtreeStream(adaptor,"rule withOption");

		msgs.push("grant privileges");
		try {
			// HiveParser.g:1283:5: ( KW_GRANT privList= privilegeList ( privilegeObject )? KW_TO principalSpecification ( KW_WITH withOption )? -> ^( TOK_GRANT $privList principalSpecification ( privilegeObject )? ( withOption )? ) )
			// HiveParser.g:1283:7: KW_GRANT privList= privilegeList ( privilegeObject )? KW_TO principalSpecification ( KW_WITH withOption )?
			{
			KW_GRANT416=(Token)match(input,KW_GRANT,FOLLOW_KW_GRANT_in_grantPrivileges6886);  
			stream_KW_GRANT.add(KW_GRANT416);

			pushFollow(FOLLOW_privilegeList_in_grantPrivileges6890);
			privList=privilegeList();
			state._fsp--;

			stream_privilegeList.add(privList.getTree());
			// HiveParser.g:1284:7: ( privilegeObject )?
			int alt121=2;
			int LA121_0 = input.LA(1);
			if ( (LA121_0==KW_ON) ) {
				alt121=1;
			}
			switch (alt121) {
				case 1 :
					// HiveParser.g:1284:7: privilegeObject
					{
					pushFollow(FOLLOW_privilegeObject_in_grantPrivileges6898);
					privilegeObject417=privilegeObject();
					state._fsp--;

					stream_privilegeObject.add(privilegeObject417.getTree());
					}
					break;

			}

			KW_TO418=(Token)match(input,KW_TO,FOLLOW_KW_TO_in_grantPrivileges6907);  
			stream_KW_TO.add(KW_TO418);

			pushFollow(FOLLOW_principalSpecification_in_grantPrivileges6909);
			principalSpecification419=principalSpecification();
			state._fsp--;

			stream_principalSpecification.add(principalSpecification419.getTree());
			// HiveParser.g:1286:7: ( KW_WITH withOption )?
			int alt122=2;
			int LA122_0 = input.LA(1);
			if ( (LA122_0==KW_WITH) ) {
				alt122=1;
			}
			switch (alt122) {
				case 1 :
					// HiveParser.g:1286:8: KW_WITH withOption
					{
					KW_WITH420=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_grantPrivileges6918);  
					stream_KW_WITH.add(KW_WITH420);

					pushFollow(FOLLOW_withOption_in_grantPrivileges6920);
					withOption421=withOption();
					state._fsp--;

					stream_withOption.add(withOption421.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: withOption, principalSpecification, privList, privilegeObject
			// token labels: 
			// rule labels: retval, privList
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_privList=new RewriteRuleSubtreeStream(adaptor,"rule privList",privList!=null?privList.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1287:5: -> ^( TOK_GRANT $privList principalSpecification ( privilegeObject )? ( withOption )? )
			{
				// HiveParser.g:1287:8: ^( TOK_GRANT $privList principalSpecification ( privilegeObject )? ( withOption )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_GRANT, "TOK_GRANT"), root_1);
				adaptor.addChild(root_1, stream_privList.nextTree());
				adaptor.addChild(root_1, stream_principalSpecification.nextTree());
				// HiveParser.g:1287:53: ( privilegeObject )?
				if ( stream_privilegeObject.hasNext() ) {
					adaptor.addChild(root_1, stream_privilegeObject.nextTree());
				}
				stream_privilegeObject.reset();

				// HiveParser.g:1287:70: ( withOption )?
				if ( stream_withOption.hasNext() ) {
					adaptor.addChild(root_1, stream_withOption.nextTree());
				}
				stream_withOption.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "grantPrivileges"


	public static class revokePrivileges_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "revokePrivileges"
	// HiveParser.g:1290:1: revokePrivileges : KW_REVOKE privilegeList ( privilegeObject )? KW_FROM principalSpecification -> ^( TOK_REVOKE privilegeList principalSpecification ( privilegeObject )? ) ;
	public final HiveParser.revokePrivileges_return revokePrivileges() throws RecognitionException {
		HiveParser.revokePrivileges_return retval = new HiveParser.revokePrivileges_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_REVOKE422=null;
		Token KW_FROM425=null;
		ParserRuleReturnScope privilegeList423 =null;
		ParserRuleReturnScope privilegeObject424 =null;
		ParserRuleReturnScope principalSpecification426 =null;

		CommonTree KW_REVOKE422_tree=null;
		CommonTree KW_FROM425_tree=null;
		RewriteRuleTokenStream stream_KW_REVOKE=new RewriteRuleTokenStream(adaptor,"token KW_REVOKE");
		RewriteRuleTokenStream stream_KW_FROM=new RewriteRuleTokenStream(adaptor,"token KW_FROM");
		RewriteRuleSubtreeStream stream_privilegeList=new RewriteRuleSubtreeStream(adaptor,"rule privilegeList");
		RewriteRuleSubtreeStream stream_privilegeObject=new RewriteRuleSubtreeStream(adaptor,"rule privilegeObject");
		RewriteRuleSubtreeStream stream_principalSpecification=new RewriteRuleSubtreeStream(adaptor,"rule principalSpecification");

		msgs.push("revoke privileges");
		try {
			// HiveParser.g:1293:5: ( KW_REVOKE privilegeList ( privilegeObject )? KW_FROM principalSpecification -> ^( TOK_REVOKE privilegeList principalSpecification ( privilegeObject )? ) )
			// HiveParser.g:1293:7: KW_REVOKE privilegeList ( privilegeObject )? KW_FROM principalSpecification
			{
			KW_REVOKE422=(Token)match(input,KW_REVOKE,FOLLOW_KW_REVOKE_in_revokePrivileges6970);  
			stream_KW_REVOKE.add(KW_REVOKE422);

			pushFollow(FOLLOW_privilegeList_in_revokePrivileges6972);
			privilegeList423=privilegeList();
			state._fsp--;

			stream_privilegeList.add(privilegeList423.getTree());
			// HiveParser.g:1293:31: ( privilegeObject )?
			int alt123=2;
			int LA123_0 = input.LA(1);
			if ( (LA123_0==KW_ON) ) {
				alt123=1;
			}
			switch (alt123) {
				case 1 :
					// HiveParser.g:1293:31: privilegeObject
					{
					pushFollow(FOLLOW_privilegeObject_in_revokePrivileges6974);
					privilegeObject424=privilegeObject();
					state._fsp--;

					stream_privilegeObject.add(privilegeObject424.getTree());
					}
					break;

			}

			KW_FROM425=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_revokePrivileges6977);  
			stream_KW_FROM.add(KW_FROM425);

			pushFollow(FOLLOW_principalSpecification_in_revokePrivileges6979);
			principalSpecification426=principalSpecification();
			state._fsp--;

			stream_principalSpecification.add(principalSpecification426.getTree());
			// AST REWRITE
			// elements: privilegeList, principalSpecification, privilegeObject
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1294:5: -> ^( TOK_REVOKE privilegeList principalSpecification ( privilegeObject )? )
			{
				// HiveParser.g:1294:8: ^( TOK_REVOKE privilegeList principalSpecification ( privilegeObject )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_REVOKE, "TOK_REVOKE"), root_1);
				adaptor.addChild(root_1, stream_privilegeList.nextTree());
				adaptor.addChild(root_1, stream_principalSpecification.nextTree());
				// HiveParser.g:1294:58: ( privilegeObject )?
				if ( stream_privilegeObject.hasNext() ) {
					adaptor.addChild(root_1, stream_privilegeObject.nextTree());
				}
				stream_privilegeObject.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "revokePrivileges"


	public static class grantRole_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "grantRole"
	// HiveParser.g:1297:1: grantRole : KW_GRANT KW_ROLE identifier ( COMMA identifier )* KW_TO principalSpecification -> ^( TOK_GRANT_ROLE principalSpecification ( identifier )+ ) ;
	public final HiveParser.grantRole_return grantRole() throws RecognitionException {
		HiveParser.grantRole_return retval = new HiveParser.grantRole_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_GRANT427=null;
		Token KW_ROLE428=null;
		Token COMMA430=null;
		Token KW_TO432=null;
		ParserRuleReturnScope identifier429 =null;
		ParserRuleReturnScope identifier431 =null;
		ParserRuleReturnScope principalSpecification433 =null;

		CommonTree KW_GRANT427_tree=null;
		CommonTree KW_ROLE428_tree=null;
		CommonTree COMMA430_tree=null;
		CommonTree KW_TO432_tree=null;
		RewriteRuleTokenStream stream_KW_GRANT=new RewriteRuleTokenStream(adaptor,"token KW_GRANT");
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleTokenStream stream_KW_TO=new RewriteRuleTokenStream(adaptor,"token KW_TO");
		RewriteRuleSubtreeStream stream_principalSpecification=new RewriteRuleSubtreeStream(adaptor,"rule principalSpecification");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("grant role");
		try {
			// HiveParser.g:1300:5: ( KW_GRANT KW_ROLE identifier ( COMMA identifier )* KW_TO principalSpecification -> ^( TOK_GRANT_ROLE principalSpecification ( identifier )+ ) )
			// HiveParser.g:1300:7: KW_GRANT KW_ROLE identifier ( COMMA identifier )* KW_TO principalSpecification
			{
			KW_GRANT427=(Token)match(input,KW_GRANT,FOLLOW_KW_GRANT_in_grantRole7023);  
			stream_KW_GRANT.add(KW_GRANT427);

			KW_ROLE428=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_grantRole7025);  
			stream_KW_ROLE.add(KW_ROLE428);

			pushFollow(FOLLOW_identifier_in_grantRole7027);
			identifier429=identifier();
			state._fsp--;

			stream_identifier.add(identifier429.getTree());
			// HiveParser.g:1300:35: ( COMMA identifier )*
			loop124:
			while (true) {
				int alt124=2;
				int LA124_0 = input.LA(1);
				if ( (LA124_0==COMMA) ) {
					alt124=1;
				}

				switch (alt124) {
				case 1 :
					// HiveParser.g:1300:36: COMMA identifier
					{
					COMMA430=(Token)match(input,COMMA,FOLLOW_COMMA_in_grantRole7030);  
					stream_COMMA.add(COMMA430);

					pushFollow(FOLLOW_identifier_in_grantRole7032);
					identifier431=identifier();
					state._fsp--;

					stream_identifier.add(identifier431.getTree());
					}
					break;

				default :
					break loop124;
				}
			}

			KW_TO432=(Token)match(input,KW_TO,FOLLOW_KW_TO_in_grantRole7036);  
			stream_KW_TO.add(KW_TO432);

			pushFollow(FOLLOW_principalSpecification_in_grantRole7038);
			principalSpecification433=principalSpecification();
			state._fsp--;

			stream_principalSpecification.add(principalSpecification433.getTree());
			// AST REWRITE
			// elements: principalSpecification, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1301:5: -> ^( TOK_GRANT_ROLE principalSpecification ( identifier )+ )
			{
				// HiveParser.g:1301:8: ^( TOK_GRANT_ROLE principalSpecification ( identifier )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_GRANT_ROLE, "TOK_GRANT_ROLE"), root_1);
				adaptor.addChild(root_1, stream_principalSpecification.nextTree());
				if ( !(stream_identifier.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_identifier.hasNext() ) {
					adaptor.addChild(root_1, stream_identifier.nextTree());
				}
				stream_identifier.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "grantRole"


	public static class revokeRole_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "revokeRole"
	// HiveParser.g:1304:1: revokeRole : KW_REVOKE KW_ROLE identifier ( COMMA identifier )* KW_FROM principalSpecification -> ^( TOK_REVOKE_ROLE principalSpecification ( identifier )+ ) ;
	public final HiveParser.revokeRole_return revokeRole() throws RecognitionException {
		HiveParser.revokeRole_return retval = new HiveParser.revokeRole_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_REVOKE434=null;
		Token KW_ROLE435=null;
		Token COMMA437=null;
		Token KW_FROM439=null;
		ParserRuleReturnScope identifier436 =null;
		ParserRuleReturnScope identifier438 =null;
		ParserRuleReturnScope principalSpecification440 =null;

		CommonTree KW_REVOKE434_tree=null;
		CommonTree KW_ROLE435_tree=null;
		CommonTree COMMA437_tree=null;
		CommonTree KW_FROM439_tree=null;
		RewriteRuleTokenStream stream_KW_REVOKE=new RewriteRuleTokenStream(adaptor,"token KW_REVOKE");
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleTokenStream stream_KW_FROM=new RewriteRuleTokenStream(adaptor,"token KW_FROM");
		RewriteRuleSubtreeStream stream_principalSpecification=new RewriteRuleSubtreeStream(adaptor,"rule principalSpecification");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("revoke role");
		try {
			// HiveParser.g:1307:5: ( KW_REVOKE KW_ROLE identifier ( COMMA identifier )* KW_FROM principalSpecification -> ^( TOK_REVOKE_ROLE principalSpecification ( identifier )+ ) )
			// HiveParser.g:1307:7: KW_REVOKE KW_ROLE identifier ( COMMA identifier )* KW_FROM principalSpecification
			{
			KW_REVOKE434=(Token)match(input,KW_REVOKE,FOLLOW_KW_REVOKE_in_revokeRole7080);  
			stream_KW_REVOKE.add(KW_REVOKE434);

			KW_ROLE435=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_revokeRole7082);  
			stream_KW_ROLE.add(KW_ROLE435);

			pushFollow(FOLLOW_identifier_in_revokeRole7084);
			identifier436=identifier();
			state._fsp--;

			stream_identifier.add(identifier436.getTree());
			// HiveParser.g:1307:36: ( COMMA identifier )*
			loop125:
			while (true) {
				int alt125=2;
				int LA125_0 = input.LA(1);
				if ( (LA125_0==COMMA) ) {
					alt125=1;
				}

				switch (alt125) {
				case 1 :
					// HiveParser.g:1307:37: COMMA identifier
					{
					COMMA437=(Token)match(input,COMMA,FOLLOW_COMMA_in_revokeRole7087);  
					stream_COMMA.add(COMMA437);

					pushFollow(FOLLOW_identifier_in_revokeRole7089);
					identifier438=identifier();
					state._fsp--;

					stream_identifier.add(identifier438.getTree());
					}
					break;

				default :
					break loop125;
				}
			}

			KW_FROM439=(Token)match(input,KW_FROM,FOLLOW_KW_FROM_in_revokeRole7093);  
			stream_KW_FROM.add(KW_FROM439);

			pushFollow(FOLLOW_principalSpecification_in_revokeRole7095);
			principalSpecification440=principalSpecification();
			state._fsp--;

			stream_principalSpecification.add(principalSpecification440.getTree());
			// AST REWRITE
			// elements: identifier, principalSpecification
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1308:5: -> ^( TOK_REVOKE_ROLE principalSpecification ( identifier )+ )
			{
				// HiveParser.g:1308:8: ^( TOK_REVOKE_ROLE principalSpecification ( identifier )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_REVOKE_ROLE, "TOK_REVOKE_ROLE"), root_1);
				adaptor.addChild(root_1, stream_principalSpecification.nextTree());
				if ( !(stream_identifier.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_identifier.hasNext() ) {
					adaptor.addChild(root_1, stream_identifier.nextTree());
				}
				stream_identifier.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "revokeRole"


	public static class showRoleGrants_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "showRoleGrants"
	// HiveParser.g:1311:1: showRoleGrants : KW_SHOW KW_ROLE KW_GRANT principalName -> ^( TOK_SHOW_ROLE_GRANT principalName ) ;
	public final HiveParser.showRoleGrants_return showRoleGrants() throws RecognitionException {
		HiveParser.showRoleGrants_return retval = new HiveParser.showRoleGrants_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SHOW441=null;
		Token KW_ROLE442=null;
		Token KW_GRANT443=null;
		ParserRuleReturnScope principalName444 =null;

		CommonTree KW_SHOW441_tree=null;
		CommonTree KW_ROLE442_tree=null;
		CommonTree KW_GRANT443_tree=null;
		RewriteRuleTokenStream stream_KW_SHOW=new RewriteRuleTokenStream(adaptor,"token KW_SHOW");
		RewriteRuleTokenStream stream_KW_GRANT=new RewriteRuleTokenStream(adaptor,"token KW_GRANT");
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleSubtreeStream stream_principalName=new RewriteRuleSubtreeStream(adaptor,"rule principalName");

		msgs.push("show role grants");
		try {
			// HiveParser.g:1314:5: ( KW_SHOW KW_ROLE KW_GRANT principalName -> ^( TOK_SHOW_ROLE_GRANT principalName ) )
			// HiveParser.g:1314:7: KW_SHOW KW_ROLE KW_GRANT principalName
			{
			KW_SHOW441=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showRoleGrants7137);  
			stream_KW_SHOW.add(KW_SHOW441);

			KW_ROLE442=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_showRoleGrants7139);  
			stream_KW_ROLE.add(KW_ROLE442);

			KW_GRANT443=(Token)match(input,KW_GRANT,FOLLOW_KW_GRANT_in_showRoleGrants7141);  
			stream_KW_GRANT.add(KW_GRANT443);

			pushFollow(FOLLOW_principalName_in_showRoleGrants7143);
			principalName444=principalName();
			state._fsp--;

			stream_principalName.add(principalName444.getTree());
			// AST REWRITE
			// elements: principalName
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1315:5: -> ^( TOK_SHOW_ROLE_GRANT principalName )
			{
				// HiveParser.g:1315:8: ^( TOK_SHOW_ROLE_GRANT principalName )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOW_ROLE_GRANT, "TOK_SHOW_ROLE_GRANT"), root_1);
				adaptor.addChild(root_1, stream_principalName.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "showRoleGrants"


	public static class showGrants_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "showGrants"
	// HiveParser.g:1318:1: showGrants : KW_SHOW KW_GRANT principalName ( privilegeIncludeColObject )? -> ^( TOK_SHOW_GRANT principalName ( privilegeIncludeColObject )? ) ;
	public final HiveParser.showGrants_return showGrants() throws RecognitionException {
		HiveParser.showGrants_return retval = new HiveParser.showGrants_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SHOW445=null;
		Token KW_GRANT446=null;
		ParserRuleReturnScope principalName447 =null;
		ParserRuleReturnScope privilegeIncludeColObject448 =null;

		CommonTree KW_SHOW445_tree=null;
		CommonTree KW_GRANT446_tree=null;
		RewriteRuleTokenStream stream_KW_SHOW=new RewriteRuleTokenStream(adaptor,"token KW_SHOW");
		RewriteRuleTokenStream stream_KW_GRANT=new RewriteRuleTokenStream(adaptor,"token KW_GRANT");
		RewriteRuleSubtreeStream stream_principalName=new RewriteRuleSubtreeStream(adaptor,"rule principalName");
		RewriteRuleSubtreeStream stream_privilegeIncludeColObject=new RewriteRuleSubtreeStream(adaptor,"rule privilegeIncludeColObject");

		msgs.push("show grants");
		try {
			// HiveParser.g:1321:5: ( KW_SHOW KW_GRANT principalName ( privilegeIncludeColObject )? -> ^( TOK_SHOW_GRANT principalName ( privilegeIncludeColObject )? ) )
			// HiveParser.g:1321:7: KW_SHOW KW_GRANT principalName ( privilegeIncludeColObject )?
			{
			KW_SHOW445=(Token)match(input,KW_SHOW,FOLLOW_KW_SHOW_in_showGrants7182);  
			stream_KW_SHOW.add(KW_SHOW445);

			KW_GRANT446=(Token)match(input,KW_GRANT,FOLLOW_KW_GRANT_in_showGrants7184);  
			stream_KW_GRANT.add(KW_GRANT446);

			pushFollow(FOLLOW_principalName_in_showGrants7186);
			principalName447=principalName();
			state._fsp--;

			stream_principalName.add(principalName447.getTree());
			// HiveParser.g:1321:38: ( privilegeIncludeColObject )?
			int alt126=2;
			int LA126_0 = input.LA(1);
			if ( (LA126_0==KW_ON) ) {
				alt126=1;
			}
			switch (alt126) {
				case 1 :
					// HiveParser.g:1321:38: privilegeIncludeColObject
					{
					pushFollow(FOLLOW_privilegeIncludeColObject_in_showGrants7188);
					privilegeIncludeColObject448=privilegeIncludeColObject();
					state._fsp--;

					stream_privilegeIncludeColObject.add(privilegeIncludeColObject448.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: privilegeIncludeColObject, principalName
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1322:5: -> ^( TOK_SHOW_GRANT principalName ( privilegeIncludeColObject )? )
			{
				// HiveParser.g:1322:8: ^( TOK_SHOW_GRANT principalName ( privilegeIncludeColObject )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SHOW_GRANT, "TOK_SHOW_GRANT"), root_1);
				adaptor.addChild(root_1, stream_principalName.nextTree());
				// HiveParser.g:1322:39: ( privilegeIncludeColObject )?
				if ( stream_privilegeIncludeColObject.hasNext() ) {
					adaptor.addChild(root_1, stream_privilegeIncludeColObject.nextTree());
				}
				stream_privilegeIncludeColObject.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "showGrants"


	public static class privilegeIncludeColObject_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "privilegeIncludeColObject"
	// HiveParser.g:1325:1: privilegeIncludeColObject : KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( LPAREN cols= columnNameList RPAREN )? ( partitionSpec )? -> ^( TOK_PRIV_OBJECT_COL identifier ( $table)? ( $cols)? ( partitionSpec )? ) ;
	public final HiveParser.privilegeIncludeColObject_return privilegeIncludeColObject() throws RecognitionException {
		HiveParser.privilegeIncludeColObject_return retval = new HiveParser.privilegeIncludeColObject_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token table=null;
		Token KW_ON449=null;
		Token KW_DATABASE450=null;
		Token LPAREN452=null;
		Token RPAREN453=null;
		ParserRuleReturnScope cols =null;
		ParserRuleReturnScope identifier451 =null;
		ParserRuleReturnScope partitionSpec454 =null;

		CommonTree table_tree=null;
		CommonTree KW_ON449_tree=null;
		CommonTree KW_DATABASE450_tree=null;
		CommonTree LPAREN452_tree=null;
		CommonTree RPAREN453_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_DATABASE");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("privilege object including columns");
		try {
			// HiveParser.g:1328:5: ( KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( LPAREN cols= columnNameList RPAREN )? ( partitionSpec )? -> ^( TOK_PRIV_OBJECT_COL identifier ( $table)? ( $cols)? ( partitionSpec )? ) )
			// HiveParser.g:1328:7: KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( LPAREN cols= columnNameList RPAREN )? ( partitionSpec )?
			{
			KW_ON449=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_privilegeIncludeColObject7231);  
			stream_KW_ON.add(KW_ON449);

			// HiveParser.g:1328:13: (table= KW_TABLE | KW_DATABASE )
			int alt127=2;
			int LA127_0 = input.LA(1);
			if ( (LA127_0==KW_TABLE) ) {
				alt127=1;
			}
			else if ( (LA127_0==KW_DATABASE) ) {
				alt127=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 127, 0, input);
				throw nvae;
			}

			switch (alt127) {
				case 1 :
					// HiveParser.g:1328:14: table= KW_TABLE
					{
					table=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_privilegeIncludeColObject7236);  
					stream_KW_TABLE.add(table);

					}
					break;
				case 2 :
					// HiveParser.g:1328:29: KW_DATABASE
					{
					KW_DATABASE450=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_privilegeIncludeColObject7238);  
					stream_KW_DATABASE.add(KW_DATABASE450);

					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_privilegeIncludeColObject7241);
			identifier451=identifier();
			state._fsp--;

			stream_identifier.add(identifier451.getTree());
			// HiveParser.g:1328:53: ( LPAREN cols= columnNameList RPAREN )?
			int alt128=2;
			int LA128_0 = input.LA(1);
			if ( (LA128_0==LPAREN) ) {
				alt128=1;
			}
			switch (alt128) {
				case 1 :
					// HiveParser.g:1328:54: LPAREN cols= columnNameList RPAREN
					{
					LPAREN452=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_privilegeIncludeColObject7244);  
					stream_LPAREN.add(LPAREN452);

					pushFollow(FOLLOW_columnNameList_in_privilegeIncludeColObject7248);
					cols=columnNameList();
					state._fsp--;

					stream_columnNameList.add(cols.getTree());
					RPAREN453=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_privilegeIncludeColObject7250);  
					stream_RPAREN.add(RPAREN453);

					}
					break;

			}

			// HiveParser.g:1328:90: ( partitionSpec )?
			int alt129=2;
			int LA129_0 = input.LA(1);
			if ( (LA129_0==KW_PARTITION) ) {
				alt129=1;
			}
			switch (alt129) {
				case 1 :
					// HiveParser.g:1328:90: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_privilegeIncludeColObject7254);
					partitionSpec454=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec454.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: identifier, partitionSpec, cols, table
			// token labels: table
			// rule labels: retval, cols
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_table=new RewriteRuleTokenStream(adaptor,"token table",table);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_cols=new RewriteRuleSubtreeStream(adaptor,"rule cols",cols!=null?cols.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1329:5: -> ^( TOK_PRIV_OBJECT_COL identifier ( $table)? ( $cols)? ( partitionSpec )? )
			{
				// HiveParser.g:1329:8: ^( TOK_PRIV_OBJECT_COL identifier ( $table)? ( $cols)? ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_OBJECT_COL, "TOK_PRIV_OBJECT_COL"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:1329:42: ( $table)?
				if ( stream_table.hasNext() ) {
					adaptor.addChild(root_1, stream_table.nextNode());
				}
				stream_table.reset();

				// HiveParser.g:1329:50: ( $cols)?
				if ( stream_cols.hasNext() ) {
					adaptor.addChild(root_1, stream_cols.nextTree());
				}
				stream_cols.reset();

				// HiveParser.g:1329:56: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "privilegeIncludeColObject"


	public static class privilegeObject_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "privilegeObject"
	// HiveParser.g:1332:1: privilegeObject : KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( partitionSpec )? -> ^( TOK_PRIV_OBJECT identifier ( $table)? ( partitionSpec )? ) ;
	public final HiveParser.privilegeObject_return privilegeObject() throws RecognitionException {
		HiveParser.privilegeObject_return retval = new HiveParser.privilegeObject_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token table=null;
		Token KW_ON455=null;
		Token KW_DATABASE456=null;
		ParserRuleReturnScope identifier457 =null;
		ParserRuleReturnScope partitionSpec458 =null;

		CommonTree table_tree=null;
		CommonTree KW_ON455_tree=null;
		CommonTree KW_DATABASE456_tree=null;
		RewriteRuleTokenStream stream_KW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_DATABASE");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("privilege subject");
		try {
			// HiveParser.g:1335:5: ( KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( partitionSpec )? -> ^( TOK_PRIV_OBJECT identifier ( $table)? ( partitionSpec )? ) )
			// HiveParser.g:1335:7: KW_ON (table= KW_TABLE | KW_DATABASE ) identifier ( partitionSpec )?
			{
			KW_ON455=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_privilegeObject7305);  
			stream_KW_ON.add(KW_ON455);

			// HiveParser.g:1335:13: (table= KW_TABLE | KW_DATABASE )
			int alt130=2;
			int LA130_0 = input.LA(1);
			if ( (LA130_0==KW_TABLE) ) {
				alt130=1;
			}
			else if ( (LA130_0==KW_DATABASE) ) {
				alt130=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 130, 0, input);
				throw nvae;
			}

			switch (alt130) {
				case 1 :
					// HiveParser.g:1335:14: table= KW_TABLE
					{
					table=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_privilegeObject7310);  
					stream_KW_TABLE.add(table);

					}
					break;
				case 2 :
					// HiveParser.g:1335:29: KW_DATABASE
					{
					KW_DATABASE456=(Token)match(input,KW_DATABASE,FOLLOW_KW_DATABASE_in_privilegeObject7312);  
					stream_KW_DATABASE.add(KW_DATABASE456);

					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_privilegeObject7315);
			identifier457=identifier();
			state._fsp--;

			stream_identifier.add(identifier457.getTree());
			// HiveParser.g:1335:53: ( partitionSpec )?
			int alt131=2;
			int LA131_0 = input.LA(1);
			if ( (LA131_0==KW_PARTITION) ) {
				alt131=1;
			}
			switch (alt131) {
				case 1 :
					// HiveParser.g:1335:53: partitionSpec
					{
					pushFollow(FOLLOW_partitionSpec_in_privilegeObject7317);
					partitionSpec458=partitionSpec();
					state._fsp--;

					stream_partitionSpec.add(partitionSpec458.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: identifier, partitionSpec, table
			// token labels: table
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_table=new RewriteRuleTokenStream(adaptor,"token table",table);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1336:5: -> ^( TOK_PRIV_OBJECT identifier ( $table)? ( partitionSpec )? )
			{
				// HiveParser.g:1336:8: ^( TOK_PRIV_OBJECT identifier ( $table)? ( partitionSpec )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_OBJECT, "TOK_PRIV_OBJECT"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:1336:38: ( $table)?
				if ( stream_table.hasNext() ) {
					adaptor.addChild(root_1, stream_table.nextNode());
				}
				stream_table.reset();

				// HiveParser.g:1336:45: ( partitionSpec )?
				if ( stream_partitionSpec.hasNext() ) {
					adaptor.addChild(root_1, stream_partitionSpec.nextTree());
				}
				stream_partitionSpec.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "privilegeObject"


	public static class privilegeList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "privilegeList"
	// HiveParser.g:1339:1: privilegeList : privlegeDef ( COMMA privlegeDef )* -> ^( TOK_PRIVILEGE_LIST ( privlegeDef )+ ) ;
	public final HiveParser.privilegeList_return privilegeList() throws RecognitionException {
		HiveParser.privilegeList_return retval = new HiveParser.privilegeList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA460=null;
		ParserRuleReturnScope privlegeDef459 =null;
		ParserRuleReturnScope privlegeDef461 =null;

		CommonTree COMMA460_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_privlegeDef=new RewriteRuleSubtreeStream(adaptor,"rule privlegeDef");

		msgs.push("grant privilege list");
		try {
			// HiveParser.g:1342:5: ( privlegeDef ( COMMA privlegeDef )* -> ^( TOK_PRIVILEGE_LIST ( privlegeDef )+ ) )
			// HiveParser.g:1342:7: privlegeDef ( COMMA privlegeDef )*
			{
			pushFollow(FOLLOW_privlegeDef_in_privilegeList7364);
			privlegeDef459=privlegeDef();
			state._fsp--;

			stream_privlegeDef.add(privlegeDef459.getTree());
			// HiveParser.g:1342:19: ( COMMA privlegeDef )*
			loop132:
			while (true) {
				int alt132=2;
				int LA132_0 = input.LA(1);
				if ( (LA132_0==COMMA) ) {
					alt132=1;
				}

				switch (alt132) {
				case 1 :
					// HiveParser.g:1342:20: COMMA privlegeDef
					{
					COMMA460=(Token)match(input,COMMA,FOLLOW_COMMA_in_privilegeList7367);  
					stream_COMMA.add(COMMA460);

					pushFollow(FOLLOW_privlegeDef_in_privilegeList7369);
					privlegeDef461=privlegeDef();
					state._fsp--;

					stream_privlegeDef.add(privlegeDef461.getTree());
					}
					break;

				default :
					break loop132;
				}
			}

			// AST REWRITE
			// elements: privlegeDef
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1343:5: -> ^( TOK_PRIVILEGE_LIST ( privlegeDef )+ )
			{
				// HiveParser.g:1343:8: ^( TOK_PRIVILEGE_LIST ( privlegeDef )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIVILEGE_LIST, "TOK_PRIVILEGE_LIST"), root_1);
				if ( !(stream_privlegeDef.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_privlegeDef.hasNext() ) {
					adaptor.addChild(root_1, stream_privlegeDef.nextTree());
				}
				stream_privlegeDef.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "privilegeList"


	public static class privlegeDef_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "privlegeDef"
	// HiveParser.g:1346:1: privlegeDef : privilegeType ( LPAREN cols= columnNameList RPAREN )? -> ^( TOK_PRIVILEGE privilegeType ( $cols)? ) ;
	public final HiveParser.privlegeDef_return privlegeDef() throws RecognitionException {
		HiveParser.privlegeDef_return retval = new HiveParser.privlegeDef_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN463=null;
		Token RPAREN464=null;
		ParserRuleReturnScope cols =null;
		ParserRuleReturnScope privilegeType462 =null;

		CommonTree LPAREN463_tree=null;
		CommonTree RPAREN464_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_privilegeType=new RewriteRuleSubtreeStream(adaptor,"rule privilegeType");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");

		msgs.push("grant privilege");
		try {
			// HiveParser.g:1349:5: ( privilegeType ( LPAREN cols= columnNameList RPAREN )? -> ^( TOK_PRIVILEGE privilegeType ( $cols)? ) )
			// HiveParser.g:1349:7: privilegeType ( LPAREN cols= columnNameList RPAREN )?
			{
			pushFollow(FOLLOW_privilegeType_in_privlegeDef7411);
			privilegeType462=privilegeType();
			state._fsp--;

			stream_privilegeType.add(privilegeType462.getTree());
			// HiveParser.g:1349:21: ( LPAREN cols= columnNameList RPAREN )?
			int alt133=2;
			int LA133_0 = input.LA(1);
			if ( (LA133_0==LPAREN) ) {
				alt133=1;
			}
			switch (alt133) {
				case 1 :
					// HiveParser.g:1349:22: LPAREN cols= columnNameList RPAREN
					{
					LPAREN463=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_privlegeDef7414);  
					stream_LPAREN.add(LPAREN463);

					pushFollow(FOLLOW_columnNameList_in_privlegeDef7418);
					cols=columnNameList();
					state._fsp--;

					stream_columnNameList.add(cols.getTree());
					RPAREN464=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_privlegeDef7420);  
					stream_RPAREN.add(RPAREN464);

					}
					break;

			}

			// AST REWRITE
			// elements: privilegeType, cols
			// token labels: 
			// rule labels: retval, cols
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_cols=new RewriteRuleSubtreeStream(adaptor,"rule cols",cols!=null?cols.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1350:5: -> ^( TOK_PRIVILEGE privilegeType ( $cols)? )
			{
				// HiveParser.g:1350:8: ^( TOK_PRIVILEGE privilegeType ( $cols)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIVILEGE, "TOK_PRIVILEGE"), root_1);
				adaptor.addChild(root_1, stream_privilegeType.nextTree());
				// HiveParser.g:1350:39: ( $cols)?
				if ( stream_cols.hasNext() ) {
					adaptor.addChild(root_1, stream_cols.nextTree());
				}
				stream_cols.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "privlegeDef"


	public static class privilegeType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "privilegeType"
	// HiveParser.g:1353:1: privilegeType : ( KW_ALL -> ^( TOK_PRIV_ALL ) | KW_ALTER -> ^( TOK_PRIV_ALTER_METADATA ) | KW_UPDATE -> ^( TOK_PRIV_ALTER_DATA ) | KW_CREATE -> ^( TOK_PRIV_CREATE ) | KW_DROP -> ^( TOK_PRIV_DROP ) | KW_INDEX -> ^( TOK_PRIV_INDEX ) | KW_LOCK -> ^( TOK_PRIV_LOCK ) | KW_SELECT -> ^( TOK_PRIV_SELECT ) | KW_SHOW_DATABASE -> ^( TOK_PRIV_SHOW_DATABASE ) );
	public final HiveParser.privilegeType_return privilegeType() throws RecognitionException {
		HiveParser.privilegeType_return retval = new HiveParser.privilegeType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ALL465=null;
		Token KW_ALTER466=null;
		Token KW_UPDATE467=null;
		Token KW_CREATE468=null;
		Token KW_DROP469=null;
		Token KW_INDEX470=null;
		Token KW_LOCK471=null;
		Token KW_SELECT472=null;
		Token KW_SHOW_DATABASE473=null;

		CommonTree KW_ALL465_tree=null;
		CommonTree KW_ALTER466_tree=null;
		CommonTree KW_UPDATE467_tree=null;
		CommonTree KW_CREATE468_tree=null;
		CommonTree KW_DROP469_tree=null;
		CommonTree KW_INDEX470_tree=null;
		CommonTree KW_LOCK471_tree=null;
		CommonTree KW_SELECT472_tree=null;
		CommonTree KW_SHOW_DATABASE473_tree=null;
		RewriteRuleTokenStream stream_KW_ALTER=new RewriteRuleTokenStream(adaptor,"token KW_ALTER");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_KW_ALL=new RewriteRuleTokenStream(adaptor,"token KW_ALL");
		RewriteRuleTokenStream stream_KW_SELECT=new RewriteRuleTokenStream(adaptor,"token KW_SELECT");
		RewriteRuleTokenStream stream_KW_UPDATE=new RewriteRuleTokenStream(adaptor,"token KW_UPDATE");
		RewriteRuleTokenStream stream_KW_SHOW_DATABASE=new RewriteRuleTokenStream(adaptor,"token KW_SHOW_DATABASE");
		RewriteRuleTokenStream stream_KW_INDEX=new RewriteRuleTokenStream(adaptor,"token KW_INDEX");
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_LOCK=new RewriteRuleTokenStream(adaptor,"token KW_LOCK");

		msgs.push("privilege type");
		try {
			// HiveParser.g:1356:5: ( KW_ALL -> ^( TOK_PRIV_ALL ) | KW_ALTER -> ^( TOK_PRIV_ALTER_METADATA ) | KW_UPDATE -> ^( TOK_PRIV_ALTER_DATA ) | KW_CREATE -> ^( TOK_PRIV_CREATE ) | KW_DROP -> ^( TOK_PRIV_DROP ) | KW_INDEX -> ^( TOK_PRIV_INDEX ) | KW_LOCK -> ^( TOK_PRIV_LOCK ) | KW_SELECT -> ^( TOK_PRIV_SELECT ) | KW_SHOW_DATABASE -> ^( TOK_PRIV_SHOW_DATABASE ) )
			int alt134=9;
			switch ( input.LA(1) ) {
			case KW_ALL:
				{
				alt134=1;
				}
				break;
			case KW_ALTER:
				{
				alt134=2;
				}
				break;
			case KW_UPDATE:
				{
				alt134=3;
				}
				break;
			case KW_CREATE:
				{
				alt134=4;
				}
				break;
			case KW_DROP:
				{
				alt134=5;
				}
				break;
			case KW_INDEX:
				{
				alt134=6;
				}
				break;
			case KW_LOCK:
				{
				alt134=7;
				}
				break;
			case KW_SELECT:
				{
				alt134=8;
				}
				break;
			case KW_SHOW_DATABASE:
				{
				alt134=9;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 134, 0, input);
				throw nvae;
			}
			switch (alt134) {
				case 1 :
					// HiveParser.g:1356:7: KW_ALL
					{
					KW_ALL465=(Token)match(input,KW_ALL,FOLLOW_KW_ALL_in_privilegeType7465);  
					stream_KW_ALL.add(KW_ALL465);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1356:14: -> ^( TOK_PRIV_ALL )
					{
						// HiveParser.g:1356:17: ^( TOK_PRIV_ALL )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_ALL, "TOK_PRIV_ALL"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1357:7: KW_ALTER
					{
					KW_ALTER466=(Token)match(input,KW_ALTER,FOLLOW_KW_ALTER_in_privilegeType7479);  
					stream_KW_ALTER.add(KW_ALTER466);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1357:16: -> ^( TOK_PRIV_ALTER_METADATA )
					{
						// HiveParser.g:1357:19: ^( TOK_PRIV_ALTER_METADATA )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_ALTER_METADATA, "TOK_PRIV_ALTER_METADATA"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1358:7: KW_UPDATE
					{
					KW_UPDATE467=(Token)match(input,KW_UPDATE,FOLLOW_KW_UPDATE_in_privilegeType7493);  
					stream_KW_UPDATE.add(KW_UPDATE467);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1358:17: -> ^( TOK_PRIV_ALTER_DATA )
					{
						// HiveParser.g:1358:20: ^( TOK_PRIV_ALTER_DATA )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_ALTER_DATA, "TOK_PRIV_ALTER_DATA"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:1359:7: KW_CREATE
					{
					KW_CREATE468=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_privilegeType7507);  
					stream_KW_CREATE.add(KW_CREATE468);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1359:17: -> ^( TOK_PRIV_CREATE )
					{
						// HiveParser.g:1359:20: ^( TOK_PRIV_CREATE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_CREATE, "TOK_PRIV_CREATE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:1360:7: KW_DROP
					{
					KW_DROP469=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_privilegeType7521);  
					stream_KW_DROP.add(KW_DROP469);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1360:15: -> ^( TOK_PRIV_DROP )
					{
						// HiveParser.g:1360:18: ^( TOK_PRIV_DROP )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_DROP, "TOK_PRIV_DROP"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 6 :
					// HiveParser.g:1361:7: KW_INDEX
					{
					KW_INDEX470=(Token)match(input,KW_INDEX,FOLLOW_KW_INDEX_in_privilegeType7535);  
					stream_KW_INDEX.add(KW_INDEX470);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1361:16: -> ^( TOK_PRIV_INDEX )
					{
						// HiveParser.g:1361:19: ^( TOK_PRIV_INDEX )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_INDEX, "TOK_PRIV_INDEX"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 7 :
					// HiveParser.g:1362:7: KW_LOCK
					{
					KW_LOCK471=(Token)match(input,KW_LOCK,FOLLOW_KW_LOCK_in_privilegeType7549);  
					stream_KW_LOCK.add(KW_LOCK471);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1362:15: -> ^( TOK_PRIV_LOCK )
					{
						// HiveParser.g:1362:18: ^( TOK_PRIV_LOCK )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_LOCK, "TOK_PRIV_LOCK"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 8 :
					// HiveParser.g:1363:7: KW_SELECT
					{
					KW_SELECT472=(Token)match(input,KW_SELECT,FOLLOW_KW_SELECT_in_privilegeType7563);  
					stream_KW_SELECT.add(KW_SELECT472);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1363:17: -> ^( TOK_PRIV_SELECT )
					{
						// HiveParser.g:1363:20: ^( TOK_PRIV_SELECT )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_SELECT, "TOK_PRIV_SELECT"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 9 :
					// HiveParser.g:1364:7: KW_SHOW_DATABASE
					{
					KW_SHOW_DATABASE473=(Token)match(input,KW_SHOW_DATABASE,FOLLOW_KW_SHOW_DATABASE_in_privilegeType7577);  
					stream_KW_SHOW_DATABASE.add(KW_SHOW_DATABASE473);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1364:24: -> ^( TOK_PRIV_SHOW_DATABASE )
					{
						// HiveParser.g:1364:27: ^( TOK_PRIV_SHOW_DATABASE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRIV_SHOW_DATABASE, "TOK_PRIV_SHOW_DATABASE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "privilegeType"


	public static class principalSpecification_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "principalSpecification"
	// HiveParser.g:1367:1: principalSpecification : principalName ( COMMA principalName )* -> ^( TOK_PRINCIPAL_NAME ( principalName )+ ) ;
	public final HiveParser.principalSpecification_return principalSpecification() throws RecognitionException {
		HiveParser.principalSpecification_return retval = new HiveParser.principalSpecification_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA475=null;
		ParserRuleReturnScope principalName474 =null;
		ParserRuleReturnScope principalName476 =null;

		CommonTree COMMA475_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_principalName=new RewriteRuleSubtreeStream(adaptor,"rule principalName");

		 msgs.push("user/group/role name list"); 
		try {
			// HiveParser.g:1370:5: ( principalName ( COMMA principalName )* -> ^( TOK_PRINCIPAL_NAME ( principalName )+ ) )
			// HiveParser.g:1370:7: principalName ( COMMA principalName )*
			{
			pushFollow(FOLLOW_principalName_in_principalSpecification7610);
			principalName474=principalName();
			state._fsp--;

			stream_principalName.add(principalName474.getTree());
			// HiveParser.g:1370:21: ( COMMA principalName )*
			loop135:
			while (true) {
				int alt135=2;
				int LA135_0 = input.LA(1);
				if ( (LA135_0==COMMA) ) {
					alt135=1;
				}

				switch (alt135) {
				case 1 :
					// HiveParser.g:1370:22: COMMA principalName
					{
					COMMA475=(Token)match(input,COMMA,FOLLOW_COMMA_in_principalSpecification7613);  
					stream_COMMA.add(COMMA475);

					pushFollow(FOLLOW_principalName_in_principalSpecification7615);
					principalName476=principalName();
					state._fsp--;

					stream_principalName.add(principalName476.getTree());
					}
					break;

				default :
					break loop135;
				}
			}

			// AST REWRITE
			// elements: principalName
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1370:44: -> ^( TOK_PRINCIPAL_NAME ( principalName )+ )
			{
				// HiveParser.g:1370:47: ^( TOK_PRINCIPAL_NAME ( principalName )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_PRINCIPAL_NAME, "TOK_PRINCIPAL_NAME"), root_1);
				if ( !(stream_principalName.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_principalName.hasNext() ) {
					adaptor.addChild(root_1, stream_principalName.nextTree());
				}
				stream_principalName.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "principalSpecification"


	public static class principalName_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "principalName"
	// HiveParser.g:1373:1: principalName : ( KW_USER identifier -> ^( TOK_USER identifier ) | KW_GROUP identifier -> ^( TOK_GROUP identifier ) | KW_ROLE identifier -> ^( TOK_ROLE identifier ) );
	public final HiveParser.principalName_return principalName() throws RecognitionException {
		HiveParser.principalName_return retval = new HiveParser.principalName_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_USER477=null;
		Token KW_GROUP479=null;
		Token KW_ROLE481=null;
		ParserRuleReturnScope identifier478 =null;
		ParserRuleReturnScope identifier480 =null;
		ParserRuleReturnScope identifier482 =null;

		CommonTree KW_USER477_tree=null;
		CommonTree KW_GROUP479_tree=null;
		CommonTree KW_ROLE481_tree=null;
		RewriteRuleTokenStream stream_KW_ROLE=new RewriteRuleTokenStream(adaptor,"token KW_ROLE");
		RewriteRuleTokenStream stream_KW_GROUP=new RewriteRuleTokenStream(adaptor,"token KW_GROUP");
		RewriteRuleTokenStream stream_KW_USER=new RewriteRuleTokenStream(adaptor,"token KW_USER");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		msgs.push("user|group|role name");
		try {
			// HiveParser.g:1376:5: ( KW_USER identifier -> ^( TOK_USER identifier ) | KW_GROUP identifier -> ^( TOK_GROUP identifier ) | KW_ROLE identifier -> ^( TOK_ROLE identifier ) )
			int alt136=3;
			switch ( input.LA(1) ) {
			case KW_USER:
				{
				alt136=1;
				}
				break;
			case KW_GROUP:
				{
				alt136=2;
				}
				break;
			case KW_ROLE:
				{
				alt136=3;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 136, 0, input);
				throw nvae;
			}
			switch (alt136) {
				case 1 :
					// HiveParser.g:1376:7: KW_USER identifier
					{
					KW_USER477=(Token)match(input,KW_USER,FOLLOW_KW_USER_in_principalName7653);  
					stream_KW_USER.add(KW_USER477);

					pushFollow(FOLLOW_identifier_in_principalName7655);
					identifier478=identifier();
					state._fsp--;

					stream_identifier.add(identifier478.getTree());
					// AST REWRITE
					// elements: identifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1376:26: -> ^( TOK_USER identifier )
					{
						// HiveParser.g:1376:29: ^( TOK_USER identifier )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_USER, "TOK_USER"), root_1);
						adaptor.addChild(root_1, stream_identifier.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1377:7: KW_GROUP identifier
					{
					KW_GROUP479=(Token)match(input,KW_GROUP,FOLLOW_KW_GROUP_in_principalName7671);  
					stream_KW_GROUP.add(KW_GROUP479);

					pushFollow(FOLLOW_identifier_in_principalName7673);
					identifier480=identifier();
					state._fsp--;

					stream_identifier.add(identifier480.getTree());
					// AST REWRITE
					// elements: identifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1377:27: -> ^( TOK_GROUP identifier )
					{
						// HiveParser.g:1377:30: ^( TOK_GROUP identifier )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_GROUP, "TOK_GROUP"), root_1);
						adaptor.addChild(root_1, stream_identifier.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1378:7: KW_ROLE identifier
					{
					KW_ROLE481=(Token)match(input,KW_ROLE,FOLLOW_KW_ROLE_in_principalName7689);  
					stream_KW_ROLE.add(KW_ROLE481);

					pushFollow(FOLLOW_identifier_in_principalName7691);
					identifier482=identifier();
					state._fsp--;

					stream_identifier.add(identifier482.getTree());
					// AST REWRITE
					// elements: identifier
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1378:26: -> ^( TOK_ROLE identifier )
					{
						// HiveParser.g:1378:29: ^( TOK_ROLE identifier )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_ROLE, "TOK_ROLE"), root_1);
						adaptor.addChild(root_1, stream_identifier.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "principalName"


	public static class withOption_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "withOption"
	// HiveParser.g:1381:1: withOption : KW_GRANT KW_OPTION -> ^( TOK_GRANT_WITH_OPTION ) ;
	public final HiveParser.withOption_return withOption() throws RecognitionException {
		HiveParser.withOption_return retval = new HiveParser.withOption_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_GRANT483=null;
		Token KW_OPTION484=null;

		CommonTree KW_GRANT483_tree=null;
		CommonTree KW_OPTION484_tree=null;
		RewriteRuleTokenStream stream_KW_OPTION=new RewriteRuleTokenStream(adaptor,"token KW_OPTION");
		RewriteRuleTokenStream stream_KW_GRANT=new RewriteRuleTokenStream(adaptor,"token KW_GRANT");

		msgs.push("grant with option");
		try {
			// HiveParser.g:1384:5: ( KW_GRANT KW_OPTION -> ^( TOK_GRANT_WITH_OPTION ) )
			// HiveParser.g:1384:7: KW_GRANT KW_OPTION
			{
			KW_GRANT483=(Token)match(input,KW_GRANT,FOLLOW_KW_GRANT_in_withOption7726);  
			stream_KW_GRANT.add(KW_GRANT483);

			KW_OPTION484=(Token)match(input,KW_OPTION,FOLLOW_KW_OPTION_in_withOption7728);  
			stream_KW_OPTION.add(KW_OPTION484);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1385:5: -> ^( TOK_GRANT_WITH_OPTION )
			{
				// HiveParser.g:1385:8: ^( TOK_GRANT_WITH_OPTION )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_GRANT_WITH_OPTION, "TOK_GRANT_WITH_OPTION"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			msgs.pop();
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "withOption"


	public static class metastoreCheck_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "metastoreCheck"
	// HiveParser.g:1388:1: metastoreCheck : KW_MSCK (repair= KW_REPAIR )? ( KW_TABLE table= identifier ( partitionSpec )? ( COMMA partitionSpec )* )? -> ^( TOK_MSCK ( $repair)? ( $table ( partitionSpec )* )? ) ;
	public final HiveParser.metastoreCheck_return metastoreCheck() throws RecognitionException {
		HiveParser.metastoreCheck_return retval = new HiveParser.metastoreCheck_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token repair=null;
		Token KW_MSCK485=null;
		Token KW_TABLE486=null;
		Token COMMA488=null;
		ParserRuleReturnScope table =null;
		ParserRuleReturnScope partitionSpec487 =null;
		ParserRuleReturnScope partitionSpec489 =null;

		CommonTree repair_tree=null;
		CommonTree KW_MSCK485_tree=null;
		CommonTree KW_TABLE486_tree=null;
		CommonTree COMMA488_tree=null;
		RewriteRuleTokenStream stream_KW_MSCK=new RewriteRuleTokenStream(adaptor,"token KW_MSCK");
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleTokenStream stream_KW_REPAIR=new RewriteRuleTokenStream(adaptor,"token KW_REPAIR");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_partitionSpec=new RewriteRuleSubtreeStream(adaptor,"rule partitionSpec");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("metastore check statement"); 
		try {
			// HiveParser.g:1391:5: ( KW_MSCK (repair= KW_REPAIR )? ( KW_TABLE table= identifier ( partitionSpec )? ( COMMA partitionSpec )* )? -> ^( TOK_MSCK ( $repair)? ( $table ( partitionSpec )* )? ) )
			// HiveParser.g:1391:7: KW_MSCK (repair= KW_REPAIR )? ( KW_TABLE table= identifier ( partitionSpec )? ( COMMA partitionSpec )* )?
			{
			KW_MSCK485=(Token)match(input,KW_MSCK,FOLLOW_KW_MSCK_in_metastoreCheck7765);  
			stream_KW_MSCK.add(KW_MSCK485);

			// HiveParser.g:1391:15: (repair= KW_REPAIR )?
			int alt137=2;
			int LA137_0 = input.LA(1);
			if ( (LA137_0==KW_REPAIR) ) {
				alt137=1;
			}
			switch (alt137) {
				case 1 :
					// HiveParser.g:1391:16: repair= KW_REPAIR
					{
					repair=(Token)match(input,KW_REPAIR,FOLLOW_KW_REPAIR_in_metastoreCheck7770);  
					stream_KW_REPAIR.add(repair);

					}
					break;

			}

			// HiveParser.g:1391:35: ( KW_TABLE table= identifier ( partitionSpec )? ( COMMA partitionSpec )* )?
			int alt140=2;
			int LA140_0 = input.LA(1);
			if ( (LA140_0==KW_TABLE) ) {
				alt140=1;
			}
			switch (alt140) {
				case 1 :
					// HiveParser.g:1391:36: KW_TABLE table= identifier ( partitionSpec )? ( COMMA partitionSpec )*
					{
					KW_TABLE486=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_metastoreCheck7775);  
					stream_KW_TABLE.add(KW_TABLE486);

					pushFollow(FOLLOW_identifier_in_metastoreCheck7779);
					table=identifier();
					state._fsp--;

					stream_identifier.add(table.getTree());
					// HiveParser.g:1391:62: ( partitionSpec )?
					int alt138=2;
					int LA138_0 = input.LA(1);
					if ( (LA138_0==KW_PARTITION) ) {
						alt138=1;
					}
					switch (alt138) {
						case 1 :
							// HiveParser.g:1391:62: partitionSpec
							{
							pushFollow(FOLLOW_partitionSpec_in_metastoreCheck7781);
							partitionSpec487=partitionSpec();
							state._fsp--;

							stream_partitionSpec.add(partitionSpec487.getTree());
							}
							break;

					}

					// HiveParser.g:1391:77: ( COMMA partitionSpec )*
					loop139:
					while (true) {
						int alt139=2;
						int LA139_0 = input.LA(1);
						if ( (LA139_0==COMMA) ) {
							alt139=1;
						}

						switch (alt139) {
						case 1 :
							// HiveParser.g:1391:78: COMMA partitionSpec
							{
							COMMA488=(Token)match(input,COMMA,FOLLOW_COMMA_in_metastoreCheck7785);  
							stream_COMMA.add(COMMA488);

							pushFollow(FOLLOW_partitionSpec_in_metastoreCheck7787);
							partitionSpec489=partitionSpec();
							state._fsp--;

							stream_partitionSpec.add(partitionSpec489.getTree());
							}
							break;

						default :
							break loop139;
						}
					}

					}
					break;

			}

			// AST REWRITE
			// elements: partitionSpec, table, repair
			// token labels: repair
			// rule labels: retval, table
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_repair=new RewriteRuleTokenStream(adaptor,"token repair",repair);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_table=new RewriteRuleSubtreeStream(adaptor,"rule table",table!=null?table.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1392:5: -> ^( TOK_MSCK ( $repair)? ( $table ( partitionSpec )* )? )
			{
				// HiveParser.g:1392:8: ^( TOK_MSCK ( $repair)? ( $table ( partitionSpec )* )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_MSCK, "TOK_MSCK"), root_1);
				// HiveParser.g:1392:20: ( $repair)?
				if ( stream_repair.hasNext() ) {
					adaptor.addChild(root_1, stream_repair.nextNode());
				}
				stream_repair.reset();

				// HiveParser.g:1392:28: ( $table ( partitionSpec )* )?
				if ( stream_partitionSpec.hasNext()||stream_table.hasNext() ) {
					adaptor.addChild(root_1, stream_table.nextTree());
					// HiveParser.g:1392:36: ( partitionSpec )*
					while ( stream_partitionSpec.hasNext() ) {
						adaptor.addChild(root_1, stream_partitionSpec.nextTree());
					}
					stream_partitionSpec.reset();

				}
				stream_partitionSpec.reset();
				stream_table.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "metastoreCheck"


	public static class createFunctionStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createFunctionStatement"
	// HiveParser.g:1395:1: createFunctionStatement : KW_CREATE KW_TEMPORARY KW_FUNCTION identifier KW_AS StringLiteral -> ^( TOK_CREATEFUNCTION identifier StringLiteral ) ;
	public final HiveParser.createFunctionStatement_return createFunctionStatement() throws RecognitionException {
		HiveParser.createFunctionStatement_return retval = new HiveParser.createFunctionStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CREATE490=null;
		Token KW_TEMPORARY491=null;
		Token KW_FUNCTION492=null;
		Token KW_AS494=null;
		Token StringLiteral495=null;
		ParserRuleReturnScope identifier493 =null;

		CommonTree KW_CREATE490_tree=null;
		CommonTree KW_TEMPORARY491_tree=null;
		CommonTree KW_FUNCTION492_tree=null;
		CommonTree KW_AS494_tree=null;
		CommonTree StringLiteral495_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_KW_FUNCTION=new RewriteRuleTokenStream(adaptor,"token KW_FUNCTION");
		RewriteRuleTokenStream stream_KW_TEMPORARY=new RewriteRuleTokenStream(adaptor,"token KW_TEMPORARY");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("create function statement"); 
		try {
			// HiveParser.g:1398:5: ( KW_CREATE KW_TEMPORARY KW_FUNCTION identifier KW_AS StringLiteral -> ^( TOK_CREATEFUNCTION identifier StringLiteral ) )
			// HiveParser.g:1398:7: KW_CREATE KW_TEMPORARY KW_FUNCTION identifier KW_AS StringLiteral
			{
			KW_CREATE490=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createFunctionStatement7841);  
			stream_KW_CREATE.add(KW_CREATE490);

			KW_TEMPORARY491=(Token)match(input,KW_TEMPORARY,FOLLOW_KW_TEMPORARY_in_createFunctionStatement7843);  
			stream_KW_TEMPORARY.add(KW_TEMPORARY491);

			KW_FUNCTION492=(Token)match(input,KW_FUNCTION,FOLLOW_KW_FUNCTION_in_createFunctionStatement7845);  
			stream_KW_FUNCTION.add(KW_FUNCTION492);

			pushFollow(FOLLOW_identifier_in_createFunctionStatement7847);
			identifier493=identifier();
			state._fsp--;

			stream_identifier.add(identifier493.getTree());
			KW_AS494=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_createFunctionStatement7849);  
			stream_KW_AS.add(KW_AS494);

			StringLiteral495=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_createFunctionStatement7851);  
			stream_StringLiteral.add(StringLiteral495);

			// AST REWRITE
			// elements: StringLiteral, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1399:5: -> ^( TOK_CREATEFUNCTION identifier StringLiteral )
			{
				// HiveParser.g:1399:8: ^( TOK_CREATEFUNCTION identifier StringLiteral )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEFUNCTION, "TOK_CREATEFUNCTION"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_1, stream_StringLiteral.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createFunctionStatement"


	public static class dropFunctionStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropFunctionStatement"
	// HiveParser.g:1402:1: dropFunctionStatement : KW_DROP KW_TEMPORARY KW_FUNCTION ( ifExists )? identifier -> ^( TOK_DROPFUNCTION identifier ( ifExists )? ) ;
	public final HiveParser.dropFunctionStatement_return dropFunctionStatement() throws RecognitionException {
		HiveParser.dropFunctionStatement_return retval = new HiveParser.dropFunctionStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP496=null;
		Token KW_TEMPORARY497=null;
		Token KW_FUNCTION498=null;
		ParserRuleReturnScope ifExists499 =null;
		ParserRuleReturnScope identifier500 =null;

		CommonTree KW_DROP496_tree=null;
		CommonTree KW_TEMPORARY497_tree=null;
		CommonTree KW_FUNCTION498_tree=null;
		RewriteRuleTokenStream stream_KW_FUNCTION=new RewriteRuleTokenStream(adaptor,"token KW_FUNCTION");
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_TEMPORARY=new RewriteRuleTokenStream(adaptor,"token KW_TEMPORARY");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("drop temporary function statement"); 
		try {
			// HiveParser.g:1405:5: ( KW_DROP KW_TEMPORARY KW_FUNCTION ( ifExists )? identifier -> ^( TOK_DROPFUNCTION identifier ( ifExists )? ) )
			// HiveParser.g:1405:7: KW_DROP KW_TEMPORARY KW_FUNCTION ( ifExists )? identifier
			{
			KW_DROP496=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropFunctionStatement7892);  
			stream_KW_DROP.add(KW_DROP496);

			KW_TEMPORARY497=(Token)match(input,KW_TEMPORARY,FOLLOW_KW_TEMPORARY_in_dropFunctionStatement7894);  
			stream_KW_TEMPORARY.add(KW_TEMPORARY497);

			KW_FUNCTION498=(Token)match(input,KW_FUNCTION,FOLLOW_KW_FUNCTION_in_dropFunctionStatement7896);  
			stream_KW_FUNCTION.add(KW_FUNCTION498);

			// HiveParser.g:1405:40: ( ifExists )?
			int alt141=2;
			int LA141_0 = input.LA(1);
			if ( (LA141_0==KW_IF) ) {
				alt141=1;
			}
			switch (alt141) {
				case 1 :
					// HiveParser.g:1405:40: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropFunctionStatement7898);
					ifExists499=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists499.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_identifier_in_dropFunctionStatement7901);
			identifier500=identifier();
			state._fsp--;

			stream_identifier.add(identifier500.getTree());
			// AST REWRITE
			// elements: ifExists, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1406:5: -> ^( TOK_DROPFUNCTION identifier ( ifExists )? )
			{
				// HiveParser.g:1406:8: ^( TOK_DROPFUNCTION identifier ( ifExists )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPFUNCTION, "TOK_DROPFUNCTION"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				// HiveParser.g:1406:38: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropFunctionStatement"


	public static class createMacroStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createMacroStatement"
	// HiveParser.g:1409:1: createMacroStatement : KW_CREATE KW_TEMPORARY KW_MACRO Identifier LPAREN ( columnNameTypeList )? RPAREN expression -> ^( TOK_CREATEMACRO Identifier ( columnNameTypeList )? expression ) ;
	public final HiveParser.createMacroStatement_return createMacroStatement() throws RecognitionException {
		HiveParser.createMacroStatement_return retval = new HiveParser.createMacroStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CREATE501=null;
		Token KW_TEMPORARY502=null;
		Token KW_MACRO503=null;
		Token Identifier504=null;
		Token LPAREN505=null;
		Token RPAREN507=null;
		ParserRuleReturnScope columnNameTypeList506 =null;
		ParserRuleReturnScope expression508 =null;

		CommonTree KW_CREATE501_tree=null;
		CommonTree KW_TEMPORARY502_tree=null;
		CommonTree KW_MACRO503_tree=null;
		CommonTree Identifier504_tree=null;
		CommonTree LPAREN505_tree=null;
		CommonTree RPAREN507_tree=null;
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_TEMPORARY=new RewriteRuleTokenStream(adaptor,"token KW_TEMPORARY");
		RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
		RewriteRuleTokenStream stream_KW_MACRO=new RewriteRuleTokenStream(adaptor,"token KW_MACRO");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
		RewriteRuleSubtreeStream stream_columnNameTypeList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameTypeList");

		 msgs.push("create macro statement"); 
		try {
			// HiveParser.g:1412:5: ( KW_CREATE KW_TEMPORARY KW_MACRO Identifier LPAREN ( columnNameTypeList )? RPAREN expression -> ^( TOK_CREATEMACRO Identifier ( columnNameTypeList )? expression ) )
			// HiveParser.g:1412:7: KW_CREATE KW_TEMPORARY KW_MACRO Identifier LPAREN ( columnNameTypeList )? RPAREN expression
			{
			KW_CREATE501=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createMacroStatement7943);  
			stream_KW_CREATE.add(KW_CREATE501);

			KW_TEMPORARY502=(Token)match(input,KW_TEMPORARY,FOLLOW_KW_TEMPORARY_in_createMacroStatement7945);  
			stream_KW_TEMPORARY.add(KW_TEMPORARY502);

			KW_MACRO503=(Token)match(input,KW_MACRO,FOLLOW_KW_MACRO_in_createMacroStatement7947);  
			stream_KW_MACRO.add(KW_MACRO503);

			Identifier504=(Token)match(input,Identifier,FOLLOW_Identifier_in_createMacroStatement7949);  
			stream_Identifier.add(Identifier504);

			LPAREN505=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createMacroStatement7957);  
			stream_LPAREN.add(LPAREN505);

			// HiveParser.g:1413:14: ( columnNameTypeList )?
			int alt142=2;
			int LA142_0 = input.LA(1);
			if ( (LA142_0==Identifier||(LA142_0 >= KW_ADD && LA142_0 <= KW_AFTER)||(LA142_0 >= KW_ALTER && LA142_0 <= KW_ANALYZE)||(LA142_0 >= KW_ARCHIVE && LA142_0 <= KW_CASCADE)||(LA142_0 >= KW_CHANGE && LA142_0 <= KW_COLLECTION)||(LA142_0 >= KW_COLUMNS && LA142_0 <= KW_CONCATENATE)||(LA142_0 >= KW_CONTINUE && LA142_0 <= KW_CREATE)||LA142_0==KW_CUBE||(LA142_0 >= KW_CURSOR && LA142_0 <= KW_DATA)||(LA142_0 >= KW_DATABASES && LA142_0 <= KW_DATETIME)||(LA142_0 >= KW_DBPROPERTIES && LA142_0 <= KW_DISABLE)||(LA142_0 >= KW_DISTRIBUTE && LA142_0 <= KW_ELEM_TYPE)||LA142_0==KW_ENABLE||LA142_0==KW_ESCAPED||(LA142_0 >= KW_EXCLUSIVE && LA142_0 <= KW_EXPORT)||(LA142_0 >= KW_EXTERNAL && LA142_0 <= KW_FLOAT)||(LA142_0 >= KW_FOR && LA142_0 <= KW_FORMATTED)||LA142_0==KW_FULL||(LA142_0 >= KW_FUNCTIONS && LA142_0 <= KW_GROUPING)||LA142_0==KW_HOLD_DDLTIME||LA142_0==KW_IDXPROPERTIES||(LA142_0 >= KW_IGNORE && LA142_0 <= KW_INTERSECT)||(LA142_0 >= KW_INTO && LA142_0 <= KW_ITEMS)||(LA142_0 >= KW_KEYS && LA142_0 <= KW_LEFT)||(LA142_0 >= KW_LIKE && LA142_0 <= KW_LONG)||(LA142_0 >= KW_MAPJOIN && LA142_0 <= KW_MINUS)||(LA142_0 >= KW_MSCK && LA142_0 <= KW_NOSCAN)||(LA142_0 >= KW_NO_DROP && LA142_0 <= KW_OFFLINE)||LA142_0==KW_OPTION||(LA142_0 >= KW_ORCFILE && LA142_0 <= KW_OUTPUTFORMAT)||LA142_0==KW_OVERWRITE||(LA142_0 >= KW_PARTITION && LA142_0 <= KW_PLUS)||(LA142_0 >= KW_PRETTY && LA142_0 <= KW_RECORDWRITER)||(LA142_0 >= KW_REGEXP && LA142_0 <= KW_SCHEMAS)||(LA142_0 >= KW_SEMI && LA142_0 <= KW_TABLES)||(LA142_0 >= KW_TBLPROPERTIES && LA142_0 <= KW_TEXTFILE)||(LA142_0 >= KW_TIMESTAMP && LA142_0 <= KW_TOUCH)||(LA142_0 >= KW_TRIGGER && LA142_0 <= KW_UNARCHIVE)||(LA142_0 >= KW_UNDO && LA142_0 <= KW_UNIONTYPE)||(LA142_0 >= KW_UNLOCK && LA142_0 <= KW_VALUE_TYPE)||LA142_0==KW_VIEW||LA142_0==KW_WHILE||LA142_0==KW_WITH) ) {
				alt142=1;
			}
			switch (alt142) {
				case 1 :
					// HiveParser.g:1413:14: columnNameTypeList
					{
					pushFollow(FOLLOW_columnNameTypeList_in_createMacroStatement7959);
					columnNameTypeList506=columnNameTypeList();
					state._fsp--;

					stream_columnNameTypeList.add(columnNameTypeList506.getTree());
					}
					break;

			}

			RPAREN507=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createMacroStatement7962);  
			stream_RPAREN.add(RPAREN507);

			pushFollow(FOLLOW_expression_in_createMacroStatement7964);
			expression508=expression();
			state._fsp--;

			stream_expression.add(expression508.getTree());
			// AST REWRITE
			// elements: expression, columnNameTypeList, Identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1414:5: -> ^( TOK_CREATEMACRO Identifier ( columnNameTypeList )? expression )
			{
				// HiveParser.g:1414:8: ^( TOK_CREATEMACRO Identifier ( columnNameTypeList )? expression )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEMACRO, "TOK_CREATEMACRO"), root_1);
				adaptor.addChild(root_1, stream_Identifier.nextNode());
				// HiveParser.g:1414:37: ( columnNameTypeList )?
				if ( stream_columnNameTypeList.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameTypeList.nextTree());
				}
				stream_columnNameTypeList.reset();

				adaptor.addChild(root_1, stream_expression.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createMacroStatement"


	public static class dropMacroStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropMacroStatement"
	// HiveParser.g:1417:1: dropMacroStatement : KW_DROP KW_TEMPORARY KW_MACRO ( ifExists )? Identifier -> ^( TOK_DROPMACRO Identifier ( ifExists )? ) ;
	public final HiveParser.dropMacroStatement_return dropMacroStatement() throws RecognitionException {
		HiveParser.dropMacroStatement_return retval = new HiveParser.dropMacroStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP509=null;
		Token KW_TEMPORARY510=null;
		Token KW_MACRO511=null;
		Token Identifier513=null;
		ParserRuleReturnScope ifExists512 =null;

		CommonTree KW_DROP509_tree=null;
		CommonTree KW_TEMPORARY510_tree=null;
		CommonTree KW_MACRO511_tree=null;
		CommonTree Identifier513_tree=null;
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_TEMPORARY=new RewriteRuleTokenStream(adaptor,"token KW_TEMPORARY");
		RewriteRuleTokenStream stream_Identifier=new RewriteRuleTokenStream(adaptor,"token Identifier");
		RewriteRuleTokenStream stream_KW_MACRO=new RewriteRuleTokenStream(adaptor,"token KW_MACRO");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");

		 msgs.push("drop macro statement"); 
		try {
			// HiveParser.g:1420:5: ( KW_DROP KW_TEMPORARY KW_MACRO ( ifExists )? Identifier -> ^( TOK_DROPMACRO Identifier ( ifExists )? ) )
			// HiveParser.g:1420:7: KW_DROP KW_TEMPORARY KW_MACRO ( ifExists )? Identifier
			{
			KW_DROP509=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropMacroStatement8008);  
			stream_KW_DROP.add(KW_DROP509);

			KW_TEMPORARY510=(Token)match(input,KW_TEMPORARY,FOLLOW_KW_TEMPORARY_in_dropMacroStatement8010);  
			stream_KW_TEMPORARY.add(KW_TEMPORARY510);

			KW_MACRO511=(Token)match(input,KW_MACRO,FOLLOW_KW_MACRO_in_dropMacroStatement8012);  
			stream_KW_MACRO.add(KW_MACRO511);

			// HiveParser.g:1420:37: ( ifExists )?
			int alt143=2;
			int LA143_0 = input.LA(1);
			if ( (LA143_0==KW_IF) ) {
				alt143=1;
			}
			switch (alt143) {
				case 1 :
					// HiveParser.g:1420:37: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropMacroStatement8014);
					ifExists512=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists512.getTree());
					}
					break;

			}

			Identifier513=(Token)match(input,Identifier,FOLLOW_Identifier_in_dropMacroStatement8017);  
			stream_Identifier.add(Identifier513);

			// AST REWRITE
			// elements: ifExists, Identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1421:5: -> ^( TOK_DROPMACRO Identifier ( ifExists )? )
			{
				// HiveParser.g:1421:8: ^( TOK_DROPMACRO Identifier ( ifExists )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPMACRO, "TOK_DROPMACRO"), root_1);
				adaptor.addChild(root_1, stream_Identifier.nextNode());
				// HiveParser.g:1421:35: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropMacroStatement"


	public static class createViewStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "createViewStatement"
	// HiveParser.g:1424:1: createViewStatement : KW_CREATE ( orReplace )? KW_VIEW ( ifNotExists )? name= tableName ( LPAREN columnNameCommentList RPAREN )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? KW_AS selectStatement -> ^( TOK_CREATEVIEW $name ( orReplace )? ( ifNotExists )? ( columnNameCommentList )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? selectStatement ) ;
	public final HiveParser.createViewStatement_return createViewStatement() throws RecognitionException {
		HiveParser.createViewStatement_return retval = new HiveParser.createViewStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_CREATE514=null;
		Token KW_VIEW516=null;
		Token LPAREN518=null;
		Token RPAREN520=null;
		Token KW_AS524=null;
		ParserRuleReturnScope name =null;
		ParserRuleReturnScope orReplace515 =null;
		ParserRuleReturnScope ifNotExists517 =null;
		ParserRuleReturnScope columnNameCommentList519 =null;
		ParserRuleReturnScope tableComment521 =null;
		ParserRuleReturnScope viewPartition522 =null;
		ParserRuleReturnScope tablePropertiesPrefixed523 =null;
		ParserRuleReturnScope selectStatement525 =null;

		CommonTree KW_CREATE514_tree=null;
		CommonTree KW_VIEW516_tree=null;
		CommonTree LPAREN518_tree=null;
		CommonTree RPAREN520_tree=null;
		CommonTree KW_AS524_tree=null;
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_CREATE=new RewriteRuleTokenStream(adaptor,"token KW_CREATE");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_VIEW=new RewriteRuleTokenStream(adaptor,"token KW_VIEW");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_selectStatement=new RewriteRuleSubtreeStream(adaptor,"rule selectStatement");
		RewriteRuleSubtreeStream stream_columnNameCommentList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameCommentList");
		RewriteRuleSubtreeStream stream_tableName=new RewriteRuleSubtreeStream(adaptor,"rule tableName");
		RewriteRuleSubtreeStream stream_orReplace=new RewriteRuleSubtreeStream(adaptor,"rule orReplace");
		RewriteRuleSubtreeStream stream_tableComment=new RewriteRuleSubtreeStream(adaptor,"rule tableComment");
		RewriteRuleSubtreeStream stream_tablePropertiesPrefixed=new RewriteRuleSubtreeStream(adaptor,"rule tablePropertiesPrefixed");
		RewriteRuleSubtreeStream stream_viewPartition=new RewriteRuleSubtreeStream(adaptor,"rule viewPartition");
		RewriteRuleSubtreeStream stream_ifNotExists=new RewriteRuleSubtreeStream(adaptor,"rule ifNotExists");


		    msgs.push("create view statement");

		try {
			// HiveParser.g:1429:5: ( KW_CREATE ( orReplace )? KW_VIEW ( ifNotExists )? name= tableName ( LPAREN columnNameCommentList RPAREN )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? KW_AS selectStatement -> ^( TOK_CREATEVIEW $name ( orReplace )? ( ifNotExists )? ( columnNameCommentList )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? selectStatement ) )
			// HiveParser.g:1429:7: KW_CREATE ( orReplace )? KW_VIEW ( ifNotExists )? name= tableName ( LPAREN columnNameCommentList RPAREN )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? KW_AS selectStatement
			{
			KW_CREATE514=(Token)match(input,KW_CREATE,FOLLOW_KW_CREATE_in_createViewStatement8059);  
			stream_KW_CREATE.add(KW_CREATE514);

			// HiveParser.g:1429:17: ( orReplace )?
			int alt144=2;
			int LA144_0 = input.LA(1);
			if ( (LA144_0==KW_OR) ) {
				alt144=1;
			}
			switch (alt144) {
				case 1 :
					// HiveParser.g:1429:18: orReplace
					{
					pushFollow(FOLLOW_orReplace_in_createViewStatement8062);
					orReplace515=orReplace();
					state._fsp--;

					stream_orReplace.add(orReplace515.getTree());
					}
					break;

			}

			KW_VIEW516=(Token)match(input,KW_VIEW,FOLLOW_KW_VIEW_in_createViewStatement8066);  
			stream_KW_VIEW.add(KW_VIEW516);

			// HiveParser.g:1429:38: ( ifNotExists )?
			int alt145=2;
			int LA145_0 = input.LA(1);
			if ( (LA145_0==KW_IF) ) {
				alt145=1;
			}
			switch (alt145) {
				case 1 :
					// HiveParser.g:1429:39: ifNotExists
					{
					pushFollow(FOLLOW_ifNotExists_in_createViewStatement8069);
					ifNotExists517=ifNotExists();
					state._fsp--;

					stream_ifNotExists.add(ifNotExists517.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_tableName_in_createViewStatement8075);
			name=tableName();
			state._fsp--;

			stream_tableName.add(name.getTree());
			// HiveParser.g:1430:9: ( LPAREN columnNameCommentList RPAREN )?
			int alt146=2;
			int LA146_0 = input.LA(1);
			if ( (LA146_0==LPAREN) ) {
				alt146=1;
			}
			switch (alt146) {
				case 1 :
					// HiveParser.g:1430:10: LPAREN columnNameCommentList RPAREN
					{
					LPAREN518=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createViewStatement8086);  
					stream_LPAREN.add(LPAREN518);

					pushFollow(FOLLOW_columnNameCommentList_in_createViewStatement8088);
					columnNameCommentList519=columnNameCommentList();
					state._fsp--;

					stream_columnNameCommentList.add(columnNameCommentList519.getTree());
					RPAREN520=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createViewStatement8090);  
					stream_RPAREN.add(RPAREN520);

					}
					break;

			}

			// HiveParser.g:1430:48: ( tableComment )?
			int alt147=2;
			int LA147_0 = input.LA(1);
			if ( (LA147_0==KW_COMMENT) ) {
				alt147=1;
			}
			switch (alt147) {
				case 1 :
					// HiveParser.g:1430:48: tableComment
					{
					pushFollow(FOLLOW_tableComment_in_createViewStatement8094);
					tableComment521=tableComment();
					state._fsp--;

					stream_tableComment.add(tableComment521.getTree());
					}
					break;

			}

			// HiveParser.g:1430:62: ( viewPartition )?
			int alt148=2;
			int LA148_0 = input.LA(1);
			if ( (LA148_0==KW_PARTITIONED) ) {
				alt148=1;
			}
			switch (alt148) {
				case 1 :
					// HiveParser.g:1430:62: viewPartition
					{
					pushFollow(FOLLOW_viewPartition_in_createViewStatement8097);
					viewPartition522=viewPartition();
					state._fsp--;

					stream_viewPartition.add(viewPartition522.getTree());
					}
					break;

			}

			// HiveParser.g:1431:9: ( tablePropertiesPrefixed )?
			int alt149=2;
			int LA149_0 = input.LA(1);
			if ( (LA149_0==KW_TBLPROPERTIES) ) {
				alt149=1;
			}
			switch (alt149) {
				case 1 :
					// HiveParser.g:1431:9: tablePropertiesPrefixed
					{
					pushFollow(FOLLOW_tablePropertiesPrefixed_in_createViewStatement8108);
					tablePropertiesPrefixed523=tablePropertiesPrefixed();
					state._fsp--;

					stream_tablePropertiesPrefixed.add(tablePropertiesPrefixed523.getTree());
					}
					break;

			}

			KW_AS524=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_createViewStatement8119);  
			stream_KW_AS.add(KW_AS524);

			pushFollow(FOLLOW_selectStatement_in_createViewStatement8129);
			selectStatement525=selectStatement();
			state._fsp--;

			stream_selectStatement.add(selectStatement525.getTree());
			// AST REWRITE
			// elements: viewPartition, selectStatement, columnNameCommentList, name, ifNotExists, orReplace, tableComment, tablePropertiesPrefixed
			// token labels: 
			// rule labels: retval, name
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_name=new RewriteRuleSubtreeStream(adaptor,"rule name",name!=null?name.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1434:5: -> ^( TOK_CREATEVIEW $name ( orReplace )? ( ifNotExists )? ( columnNameCommentList )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? selectStatement )
			{
				// HiveParser.g:1434:8: ^( TOK_CREATEVIEW $name ( orReplace )? ( ifNotExists )? ( columnNameCommentList )? ( tableComment )? ( viewPartition )? ( tablePropertiesPrefixed )? selectStatement )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_CREATEVIEW, "TOK_CREATEVIEW"), root_1);
				adaptor.addChild(root_1, stream_name.nextTree());
				// HiveParser.g:1434:31: ( orReplace )?
				if ( stream_orReplace.hasNext() ) {
					adaptor.addChild(root_1, stream_orReplace.nextTree());
				}
				stream_orReplace.reset();

				// HiveParser.g:1435:10: ( ifNotExists )?
				if ( stream_ifNotExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifNotExists.nextTree());
				}
				stream_ifNotExists.reset();

				// HiveParser.g:1436:10: ( columnNameCommentList )?
				if ( stream_columnNameCommentList.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameCommentList.nextTree());
				}
				stream_columnNameCommentList.reset();

				// HiveParser.g:1437:10: ( tableComment )?
				if ( stream_tableComment.hasNext() ) {
					adaptor.addChild(root_1, stream_tableComment.nextTree());
				}
				stream_tableComment.reset();

				// HiveParser.g:1438:10: ( viewPartition )?
				if ( stream_viewPartition.hasNext() ) {
					adaptor.addChild(root_1, stream_viewPartition.nextTree());
				}
				stream_viewPartition.reset();

				// HiveParser.g:1439:10: ( tablePropertiesPrefixed )?
				if ( stream_tablePropertiesPrefixed.hasNext() ) {
					adaptor.addChild(root_1, stream_tablePropertiesPrefixed.nextTree());
				}
				stream_tablePropertiesPrefixed.reset();

				adaptor.addChild(root_1, stream_selectStatement.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "createViewStatement"


	public static class viewPartition_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "viewPartition"
	// HiveParser.g:1444:1: viewPartition : KW_PARTITIONED KW_ON LPAREN columnNameList RPAREN -> ^( TOK_VIEWPARTCOLS columnNameList ) ;
	public final HiveParser.viewPartition_return viewPartition() throws RecognitionException {
		HiveParser.viewPartition_return retval = new HiveParser.viewPartition_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_PARTITIONED526=null;
		Token KW_ON527=null;
		Token LPAREN528=null;
		Token RPAREN530=null;
		ParserRuleReturnScope columnNameList529 =null;

		CommonTree KW_PARTITIONED526_tree=null;
		CommonTree KW_ON527_tree=null;
		CommonTree LPAREN528_tree=null;
		CommonTree RPAREN530_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_PARTITIONED=new RewriteRuleTokenStream(adaptor,"token KW_PARTITIONED");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");

		 msgs.push("view partition specification"); 
		try {
			// HiveParser.g:1447:5: ( KW_PARTITIONED KW_ON LPAREN columnNameList RPAREN -> ^( TOK_VIEWPARTCOLS columnNameList ) )
			// HiveParser.g:1447:7: KW_PARTITIONED KW_ON LPAREN columnNameList RPAREN
			{
			KW_PARTITIONED526=(Token)match(input,KW_PARTITIONED,FOLLOW_KW_PARTITIONED_in_viewPartition8252);  
			stream_KW_PARTITIONED.add(KW_PARTITIONED526);

			KW_ON527=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_viewPartition8254);  
			stream_KW_ON.add(KW_ON527);

			LPAREN528=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_viewPartition8256);  
			stream_LPAREN.add(LPAREN528);

			pushFollow(FOLLOW_columnNameList_in_viewPartition8258);
			columnNameList529=columnNameList();
			state._fsp--;

			stream_columnNameList.add(columnNameList529.getTree());
			RPAREN530=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_viewPartition8260);  
			stream_RPAREN.add(RPAREN530);

			// AST REWRITE
			// elements: columnNameList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1448:5: -> ^( TOK_VIEWPARTCOLS columnNameList )
			{
				// HiveParser.g:1448:8: ^( TOK_VIEWPARTCOLS columnNameList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_VIEWPARTCOLS, "TOK_VIEWPARTCOLS"), root_1);
				adaptor.addChild(root_1, stream_columnNameList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "viewPartition"


	public static class dropViewStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "dropViewStatement"
	// HiveParser.g:1451:1: dropViewStatement : KW_DROP KW_VIEW ( ifExists )? viewName -> ^( TOK_DROPVIEW viewName ( ifExists )? ) ;
	public final HiveParser.dropViewStatement_return dropViewStatement() throws RecognitionException {
		HiveParser.dropViewStatement_return retval = new HiveParser.dropViewStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_DROP531=null;
		Token KW_VIEW532=null;
		ParserRuleReturnScope ifExists533 =null;
		ParserRuleReturnScope viewName534 =null;

		CommonTree KW_DROP531_tree=null;
		CommonTree KW_VIEW532_tree=null;
		RewriteRuleTokenStream stream_KW_DROP=new RewriteRuleTokenStream(adaptor,"token KW_DROP");
		RewriteRuleTokenStream stream_KW_VIEW=new RewriteRuleTokenStream(adaptor,"token KW_VIEW");
		RewriteRuleSubtreeStream stream_viewName=new RewriteRuleSubtreeStream(adaptor,"rule viewName");
		RewriteRuleSubtreeStream stream_ifExists=new RewriteRuleSubtreeStream(adaptor,"rule ifExists");

		 msgs.push("drop view statement"); 
		try {
			// HiveParser.g:1454:5: ( KW_DROP KW_VIEW ( ifExists )? viewName -> ^( TOK_DROPVIEW viewName ( ifExists )? ) )
			// HiveParser.g:1454:7: KW_DROP KW_VIEW ( ifExists )? viewName
			{
			KW_DROP531=(Token)match(input,KW_DROP,FOLLOW_KW_DROP_in_dropViewStatement8299);  
			stream_KW_DROP.add(KW_DROP531);

			KW_VIEW532=(Token)match(input,KW_VIEW,FOLLOW_KW_VIEW_in_dropViewStatement8301);  
			stream_KW_VIEW.add(KW_VIEW532);

			// HiveParser.g:1454:23: ( ifExists )?
			int alt150=2;
			int LA150_0 = input.LA(1);
			if ( (LA150_0==KW_IF) ) {
				alt150=1;
			}
			switch (alt150) {
				case 1 :
					// HiveParser.g:1454:23: ifExists
					{
					pushFollow(FOLLOW_ifExists_in_dropViewStatement8303);
					ifExists533=ifExists();
					state._fsp--;

					stream_ifExists.add(ifExists533.getTree());
					}
					break;

			}

			pushFollow(FOLLOW_viewName_in_dropViewStatement8306);
			viewName534=viewName();
			state._fsp--;

			stream_viewName.add(viewName534.getTree());
			// AST REWRITE
			// elements: viewName, ifExists
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1454:42: -> ^( TOK_DROPVIEW viewName ( ifExists )? )
			{
				// HiveParser.g:1454:45: ^( TOK_DROPVIEW viewName ( ifExists )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DROPVIEW, "TOK_DROPVIEW"), root_1);
				adaptor.addChild(root_1, stream_viewName.nextTree());
				// HiveParser.g:1454:69: ( ifExists )?
				if ( stream_ifExists.hasNext() ) {
					adaptor.addChild(root_1, stream_ifExists.nextTree());
				}
				stream_ifExists.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "dropViewStatement"


	public static class showStmtIdentifier_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "showStmtIdentifier"
	// HiveParser.g:1457:1: showStmtIdentifier : ( identifier | StringLiteral );
	public final HiveParser.showStmtIdentifier_return showStmtIdentifier() throws RecognitionException {
		HiveParser.showStmtIdentifier_return retval = new HiveParser.showStmtIdentifier_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token StringLiteral536=null;
		ParserRuleReturnScope identifier535 =null;

		CommonTree StringLiteral536_tree=null;

		 msgs.push("identifier for show statement"); 
		try {
			// HiveParser.g:1460:5: ( identifier | StringLiteral )
			int alt151=2;
			int LA151_0 = input.LA(1);
			if ( (LA151_0==Identifier||(LA151_0 >= KW_ADD && LA151_0 <= KW_AFTER)||(LA151_0 >= KW_ALTER && LA151_0 <= KW_ANALYZE)||(LA151_0 >= KW_ARCHIVE && LA151_0 <= KW_CASCADE)||(LA151_0 >= KW_CHANGE && LA151_0 <= KW_COLLECTION)||(LA151_0 >= KW_COLUMNS && LA151_0 <= KW_CONCATENATE)||(LA151_0 >= KW_CONTINUE && LA151_0 <= KW_CREATE)||LA151_0==KW_CUBE||(LA151_0 >= KW_CURSOR && LA151_0 <= KW_DATA)||(LA151_0 >= KW_DATABASES && LA151_0 <= KW_DATETIME)||(LA151_0 >= KW_DBPROPERTIES && LA151_0 <= KW_DISABLE)||(LA151_0 >= KW_DISTRIBUTE && LA151_0 <= KW_ELEM_TYPE)||LA151_0==KW_ENABLE||LA151_0==KW_ESCAPED||(LA151_0 >= KW_EXCLUSIVE && LA151_0 <= KW_EXPORT)||(LA151_0 >= KW_EXTERNAL && LA151_0 <= KW_FLOAT)||(LA151_0 >= KW_FOR && LA151_0 <= KW_FORMATTED)||LA151_0==KW_FULL||(LA151_0 >= KW_FUNCTIONS && LA151_0 <= KW_GROUPING)||LA151_0==KW_HOLD_DDLTIME||LA151_0==KW_IDXPROPERTIES||(LA151_0 >= KW_IGNORE && LA151_0 <= KW_INTERSECT)||(LA151_0 >= KW_INTO && LA151_0 <= KW_ITEMS)||(LA151_0 >= KW_KEYS && LA151_0 <= KW_LEFT)||(LA151_0 >= KW_LIKE && LA151_0 <= KW_LONG)||(LA151_0 >= KW_MAPJOIN && LA151_0 <= KW_MINUS)||(LA151_0 >= KW_MSCK && LA151_0 <= KW_NOSCAN)||(LA151_0 >= KW_NO_DROP && LA151_0 <= KW_OFFLINE)||LA151_0==KW_OPTION||(LA151_0 >= KW_ORCFILE && LA151_0 <= KW_OUTPUTFORMAT)||LA151_0==KW_OVERWRITE||(LA151_0 >= KW_PARTITION && LA151_0 <= KW_PLUS)||(LA151_0 >= KW_PRETTY && LA151_0 <= KW_RECORDWRITER)||(LA151_0 >= KW_REGEXP && LA151_0 <= KW_SCHEMAS)||(LA151_0 >= KW_SEMI && LA151_0 <= KW_TABLES)||(LA151_0 >= KW_TBLPROPERTIES && LA151_0 <= KW_TEXTFILE)||(LA151_0 >= KW_TIMESTAMP && LA151_0 <= KW_TOUCH)||(LA151_0 >= KW_TRIGGER && LA151_0 <= KW_UNARCHIVE)||(LA151_0 >= KW_UNDO && LA151_0 <= KW_UNIONTYPE)||(LA151_0 >= KW_UNLOCK && LA151_0 <= KW_VALUE_TYPE)||LA151_0==KW_VIEW||LA151_0==KW_WHILE||LA151_0==KW_WITH) ) {
				alt151=1;
			}
			else if ( (LA151_0==StringLiteral) ) {
				alt151=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 151, 0, input);
				throw nvae;
			}

			switch (alt151) {
				case 1 :
					// HiveParser.g:1460:7: identifier
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_identifier_in_showStmtIdentifier8344);
					identifier535=identifier();
					state._fsp--;

					adaptor.addChild(root_0, identifier535.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:1461:7: StringLiteral
					{
					root_0 = (CommonTree)adaptor.nil();


					StringLiteral536=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_showStmtIdentifier8352); 
					StringLiteral536_tree = (CommonTree)adaptor.create(StringLiteral536);
					adaptor.addChild(root_0, StringLiteral536_tree);

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "showStmtIdentifier"


	public static class tableComment_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableComment"
	// HiveParser.g:1464:1: tableComment : KW_COMMENT comment= StringLiteral -> ^( TOK_TABLECOMMENT $comment) ;
	public final HiveParser.tableComment_return tableComment() throws RecognitionException {
		HiveParser.tableComment_return retval = new HiveParser.tableComment_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_COMMENT537=null;

		CommonTree comment_tree=null;
		CommonTree KW_COMMENT537_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");

		 msgs.push("table's comment"); 
		try {
			// HiveParser.g:1467:5: ( KW_COMMENT comment= StringLiteral -> ^( TOK_TABLECOMMENT $comment) )
			// HiveParser.g:1468:7: KW_COMMENT comment= StringLiteral
			{
			KW_COMMENT537=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_tableComment8385);  
			stream_KW_COMMENT.add(KW_COMMENT537);

			comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableComment8389);  
			stream_StringLiteral.add(comment);

			// AST REWRITE
			// elements: comment
			// token labels: comment
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1468:41: -> ^( TOK_TABLECOMMENT $comment)
			{
				// HiveParser.g:1468:44: ^( TOK_TABLECOMMENT $comment)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLECOMMENT, "TOK_TABLECOMMENT"), root_1);
				adaptor.addChild(root_1, stream_comment.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableComment"


	public static class tablePartition_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tablePartition"
	// HiveParser.g:1471:1: tablePartition : KW_PARTITIONED KW_BY LPAREN columnNameTypeList RPAREN -> ^( TOK_TABLEPARTCOLS columnNameTypeList ) ;
	public final HiveParser.tablePartition_return tablePartition() throws RecognitionException {
		HiveParser.tablePartition_return retval = new HiveParser.tablePartition_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_PARTITIONED538=null;
		Token KW_BY539=null;
		Token LPAREN540=null;
		Token RPAREN542=null;
		ParserRuleReturnScope columnNameTypeList541 =null;

		CommonTree KW_PARTITIONED538_tree=null;
		CommonTree KW_BY539_tree=null;
		CommonTree LPAREN540_tree=null;
		CommonTree RPAREN542_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_PARTITIONED=new RewriteRuleTokenStream(adaptor,"token KW_PARTITIONED");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");
		RewriteRuleSubtreeStream stream_columnNameTypeList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameTypeList");

		 msgs.push("table partition specification"); 
		try {
			// HiveParser.g:1474:5: ( KW_PARTITIONED KW_BY LPAREN columnNameTypeList RPAREN -> ^( TOK_TABLEPARTCOLS columnNameTypeList ) )
			// HiveParser.g:1474:7: KW_PARTITIONED KW_BY LPAREN columnNameTypeList RPAREN
			{
			KW_PARTITIONED538=(Token)match(input,KW_PARTITIONED,FOLLOW_KW_PARTITIONED_in_tablePartition8426);  
			stream_KW_PARTITIONED.add(KW_PARTITIONED538);

			KW_BY539=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tablePartition8428);  
			stream_KW_BY.add(KW_BY539);

			LPAREN540=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tablePartition8430);  
			stream_LPAREN.add(LPAREN540);

			pushFollow(FOLLOW_columnNameTypeList_in_tablePartition8432);
			columnNameTypeList541=columnNameTypeList();
			state._fsp--;

			stream_columnNameTypeList.add(columnNameTypeList541.getTree());
			RPAREN542=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tablePartition8434);  
			stream_RPAREN.add(RPAREN542);

			// AST REWRITE
			// elements: columnNameTypeList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1475:5: -> ^( TOK_TABLEPARTCOLS columnNameTypeList )
			{
				// HiveParser.g:1475:8: ^( TOK_TABLEPARTCOLS columnNameTypeList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPARTCOLS, "TOK_TABLEPARTCOLS"), root_1);
				adaptor.addChild(root_1, stream_columnNameTypeList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tablePartition"


	public static class tableBuckets_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableBuckets"
	// HiveParser.g:1478:1: tableBuckets : KW_CLUSTERED KW_BY LPAREN bucketCols= columnNameList RPAREN ( KW_SORTED KW_BY LPAREN sortCols= columnNameOrderList RPAREN )? KW_INTO num= Number KW_BUCKETS -> ^( TOK_TABLEBUCKETS $bucketCols ( $sortCols)? $num) ;
	public final HiveParser.tableBuckets_return tableBuckets() throws RecognitionException {
		HiveParser.tableBuckets_return retval = new HiveParser.tableBuckets_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token num=null;
		Token KW_CLUSTERED543=null;
		Token KW_BY544=null;
		Token LPAREN545=null;
		Token RPAREN546=null;
		Token KW_SORTED547=null;
		Token KW_BY548=null;
		Token LPAREN549=null;
		Token RPAREN550=null;
		Token KW_INTO551=null;
		Token KW_BUCKETS552=null;
		ParserRuleReturnScope bucketCols =null;
		ParserRuleReturnScope sortCols =null;

		CommonTree num_tree=null;
		CommonTree KW_CLUSTERED543_tree=null;
		CommonTree KW_BY544_tree=null;
		CommonTree LPAREN545_tree=null;
		CommonTree RPAREN546_tree=null;
		CommonTree KW_SORTED547_tree=null;
		CommonTree KW_BY548_tree=null;
		CommonTree LPAREN549_tree=null;
		CommonTree RPAREN550_tree=null;
		CommonTree KW_INTO551_tree=null;
		CommonTree KW_BUCKETS552_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_INTO=new RewriteRuleTokenStream(adaptor,"token KW_INTO");
		RewriteRuleTokenStream stream_Number=new RewriteRuleTokenStream(adaptor,"token Number");
		RewriteRuleTokenStream stream_KW_BUCKETS=new RewriteRuleTokenStream(adaptor,"token KW_BUCKETS");
		RewriteRuleTokenStream stream_KW_CLUSTERED=new RewriteRuleTokenStream(adaptor,"token KW_CLUSTERED");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");
		RewriteRuleTokenStream stream_KW_SORTED=new RewriteRuleTokenStream(adaptor,"token KW_SORTED");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");
		RewriteRuleSubtreeStream stream_columnNameOrderList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameOrderList");

		 msgs.push("table buckets specification"); 
		try {
			// HiveParser.g:1481:5: ( KW_CLUSTERED KW_BY LPAREN bucketCols= columnNameList RPAREN ( KW_SORTED KW_BY LPAREN sortCols= columnNameOrderList RPAREN )? KW_INTO num= Number KW_BUCKETS -> ^( TOK_TABLEBUCKETS $bucketCols ( $sortCols)? $num) )
			// HiveParser.g:1482:7: KW_CLUSTERED KW_BY LPAREN bucketCols= columnNameList RPAREN ( KW_SORTED KW_BY LPAREN sortCols= columnNameOrderList RPAREN )? KW_INTO num= Number KW_BUCKETS
			{
			KW_CLUSTERED543=(Token)match(input,KW_CLUSTERED,FOLLOW_KW_CLUSTERED_in_tableBuckets8479);  
			stream_KW_CLUSTERED.add(KW_CLUSTERED543);

			KW_BY544=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableBuckets8481);  
			stream_KW_BY.add(KW_BY544);

			LPAREN545=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tableBuckets8483);  
			stream_LPAREN.add(LPAREN545);

			pushFollow(FOLLOW_columnNameList_in_tableBuckets8487);
			bucketCols=columnNameList();
			state._fsp--;

			stream_columnNameList.add(bucketCols.getTree());
			RPAREN546=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tableBuckets8489);  
			stream_RPAREN.add(RPAREN546);

			// HiveParser.g:1482:66: ( KW_SORTED KW_BY LPAREN sortCols= columnNameOrderList RPAREN )?
			int alt152=2;
			int LA152_0 = input.LA(1);
			if ( (LA152_0==KW_SORTED) ) {
				alt152=1;
			}
			switch (alt152) {
				case 1 :
					// HiveParser.g:1482:67: KW_SORTED KW_BY LPAREN sortCols= columnNameOrderList RPAREN
					{
					KW_SORTED547=(Token)match(input,KW_SORTED,FOLLOW_KW_SORTED_in_tableBuckets8492);  
					stream_KW_SORTED.add(KW_SORTED547);

					KW_BY548=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableBuckets8494);  
					stream_KW_BY.add(KW_BY548);

					LPAREN549=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tableBuckets8496);  
					stream_LPAREN.add(LPAREN549);

					pushFollow(FOLLOW_columnNameOrderList_in_tableBuckets8500);
					sortCols=columnNameOrderList();
					state._fsp--;

					stream_columnNameOrderList.add(sortCols.getTree());
					RPAREN550=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tableBuckets8502);  
					stream_RPAREN.add(RPAREN550);

					}
					break;

			}

			KW_INTO551=(Token)match(input,KW_INTO,FOLLOW_KW_INTO_in_tableBuckets8506);  
			stream_KW_INTO.add(KW_INTO551);

			num=(Token)match(input,Number,FOLLOW_Number_in_tableBuckets8510);  
			stream_Number.add(num);

			KW_BUCKETS552=(Token)match(input,KW_BUCKETS,FOLLOW_KW_BUCKETS_in_tableBuckets8512);  
			stream_KW_BUCKETS.add(KW_BUCKETS552);

			// AST REWRITE
			// elements: sortCols, bucketCols, num
			// token labels: num
			// rule labels: sortCols, retval, bucketCols
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_num=new RewriteRuleTokenStream(adaptor,"token num",num);
			RewriteRuleSubtreeStream stream_sortCols=new RewriteRuleSubtreeStream(adaptor,"rule sortCols",sortCols!=null?sortCols.getTree():null);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_bucketCols=new RewriteRuleSubtreeStream(adaptor,"rule bucketCols",bucketCols!=null?bucketCols.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1483:5: -> ^( TOK_TABLEBUCKETS $bucketCols ( $sortCols)? $num)
			{
				// HiveParser.g:1483:8: ^( TOK_TABLEBUCKETS $bucketCols ( $sortCols)? $num)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEBUCKETS, "TOK_TABLEBUCKETS"), root_1);
				adaptor.addChild(root_1, stream_bucketCols.nextTree());
				// HiveParser.g:1483:40: ( $sortCols)?
				if ( stream_sortCols.hasNext() ) {
					adaptor.addChild(root_1, stream_sortCols.nextTree());
				}
				stream_sortCols.reset();

				adaptor.addChild(root_1, stream_num.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableBuckets"


	public static class tableSkewed_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableSkewed"
	// HiveParser.g:1486:1: tableSkewed : KW_SKEWED KW_BY LPAREN skewedCols= columnNameList RPAREN KW_ON LPAREN (skewedValues= skewedValueElement ) RPAREN ( storedAsDirs )? -> ^( TOK_TABLESKEWED $skewedCols $skewedValues ( storedAsDirs )? ) ;
	public final HiveParser.tableSkewed_return tableSkewed() throws RecognitionException {
		HiveParser.tableSkewed_return retval = new HiveParser.tableSkewed_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_SKEWED553=null;
		Token KW_BY554=null;
		Token LPAREN555=null;
		Token RPAREN556=null;
		Token KW_ON557=null;
		Token LPAREN558=null;
		Token RPAREN559=null;
		ParserRuleReturnScope skewedCols =null;
		ParserRuleReturnScope skewedValues =null;
		ParserRuleReturnScope storedAsDirs560 =null;

		CommonTree KW_SKEWED553_tree=null;
		CommonTree KW_BY554_tree=null;
		CommonTree LPAREN555_tree=null;
		CommonTree RPAREN556_tree=null;
		CommonTree KW_ON557_tree=null;
		CommonTree LPAREN558_tree=null;
		CommonTree RPAREN559_tree=null;
		RewriteRuleTokenStream stream_KW_SKEWED=new RewriteRuleTokenStream(adaptor,"token KW_SKEWED");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_ON=new RewriteRuleTokenStream(adaptor,"token KW_ON");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");
		RewriteRuleSubtreeStream stream_columnNameList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameList");
		RewriteRuleSubtreeStream stream_storedAsDirs=new RewriteRuleSubtreeStream(adaptor,"rule storedAsDirs");
		RewriteRuleSubtreeStream stream_skewedValueElement=new RewriteRuleSubtreeStream(adaptor,"rule skewedValueElement");

		 msgs.push("table skewed specification"); 
		try {
			// HiveParser.g:1489:5: ( KW_SKEWED KW_BY LPAREN skewedCols= columnNameList RPAREN KW_ON LPAREN (skewedValues= skewedValueElement ) RPAREN ( storedAsDirs )? -> ^( TOK_TABLESKEWED $skewedCols $skewedValues ( storedAsDirs )? ) )
			// HiveParser.g:1490:6: KW_SKEWED KW_BY LPAREN skewedCols= columnNameList RPAREN KW_ON LPAREN (skewedValues= skewedValueElement ) RPAREN ( storedAsDirs )?
			{
			KW_SKEWED553=(Token)match(input,KW_SKEWED,FOLLOW_KW_SKEWED_in_tableSkewed8564);  
			stream_KW_SKEWED.add(KW_SKEWED553);

			KW_BY554=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableSkewed8566);  
			stream_KW_BY.add(KW_BY554);

			LPAREN555=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tableSkewed8568);  
			stream_LPAREN.add(LPAREN555);

			pushFollow(FOLLOW_columnNameList_in_tableSkewed8572);
			skewedCols=columnNameList();
			state._fsp--;

			stream_columnNameList.add(skewedCols.getTree());
			RPAREN556=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tableSkewed8574);  
			stream_RPAREN.add(RPAREN556);

			KW_ON557=(Token)match(input,KW_ON,FOLLOW_KW_ON_in_tableSkewed8576);  
			stream_KW_ON.add(KW_ON557);

			LPAREN558=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tableSkewed8578);  
			stream_LPAREN.add(LPAREN558);

			// HiveParser.g:1490:75: (skewedValues= skewedValueElement )
			// HiveParser.g:1490:76: skewedValues= skewedValueElement
			{
			pushFollow(FOLLOW_skewedValueElement_in_tableSkewed8583);
			skewedValues=skewedValueElement();
			state._fsp--;

			stream_skewedValueElement.add(skewedValues.getTree());
			}

			RPAREN559=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tableSkewed8586);  
			stream_RPAREN.add(RPAREN559);

			// HiveParser.g:1490:116: ( storedAsDirs )?
			int alt153=2;
			int LA153_0 = input.LA(1);
			if ( (LA153_0==KW_STORED) ) {
				int LA153_1 = input.LA(2);
				if ( (LA153_1==KW_AS) ) {
					int LA153_7 = input.LA(3);
					if ( (LA153_7==KW_DIRECTORIES) ) {
						alt153=1;
					}
				}
			}
			switch (alt153) {
				case 1 :
					// HiveParser.g:1490:117: storedAsDirs
					{
					pushFollow(FOLLOW_storedAsDirs_in_tableSkewed8589);
					storedAsDirs560=storedAsDirs();
					state._fsp--;

					stream_storedAsDirs.add(storedAsDirs560.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: storedAsDirs, skewedCols, skewedValues
			// token labels: 
			// rule labels: retval, skewedValues, skewedCols
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_skewedValues=new RewriteRuleSubtreeStream(adaptor,"rule skewedValues",skewedValues!=null?skewedValues.getTree():null);
			RewriteRuleSubtreeStream stream_skewedCols=new RewriteRuleSubtreeStream(adaptor,"rule skewedCols",skewedCols!=null?skewedCols.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1491:5: -> ^( TOK_TABLESKEWED $skewedCols $skewedValues ( storedAsDirs )? )
			{
				// HiveParser.g:1491:8: ^( TOK_TABLESKEWED $skewedCols $skewedValues ( storedAsDirs )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLESKEWED, "TOK_TABLESKEWED"), root_1);
				adaptor.addChild(root_1, stream_skewedCols.nextTree());
				adaptor.addChild(root_1, stream_skewedValues.nextTree());
				// HiveParser.g:1491:52: ( storedAsDirs )?
				if ( stream_storedAsDirs.hasNext() ) {
					adaptor.addChild(root_1, stream_storedAsDirs.nextTree());
				}
				stream_storedAsDirs.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableSkewed"


	public static class rowFormat_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "rowFormat"
	// HiveParser.g:1494:1: rowFormat : ( rowFormatSerde -> ^( TOK_SERDE rowFormatSerde ) | rowFormatDelimited -> ^( TOK_SERDE rowFormatDelimited ) | -> ^( TOK_SERDE ) );
	public final HiveParser.rowFormat_return rowFormat() throws RecognitionException {
		HiveParser.rowFormat_return retval = new HiveParser.rowFormat_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope rowFormatSerde561 =null;
		ParserRuleReturnScope rowFormatDelimited562 =null;

		RewriteRuleSubtreeStream stream_rowFormatSerde=new RewriteRuleSubtreeStream(adaptor,"rule rowFormatSerde");
		RewriteRuleSubtreeStream stream_rowFormatDelimited=new RewriteRuleSubtreeStream(adaptor,"rule rowFormatDelimited");

		 msgs.push("serde specification"); 
		try {
			// HiveParser.g:1497:5: ( rowFormatSerde -> ^( TOK_SERDE rowFormatSerde ) | rowFormatDelimited -> ^( TOK_SERDE rowFormatDelimited ) | -> ^( TOK_SERDE ) )
			int alt154=3;
			int LA154_0 = input.LA(1);
			if ( (LA154_0==KW_ROW) ) {
				int LA154_1 = input.LA(2);
				if ( (LA154_1==KW_FORMAT) ) {
					int LA154_23 = input.LA(3);
					if ( (LA154_23==KW_SERDE) ) {
						alt154=1;
					}
					else if ( (LA154_23==KW_DELIMITED) ) {
						alt154=2;
					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 154, 23, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 154, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}
			else if ( (LA154_0==EOF||LA154_0==KW_CLUSTER||LA154_0==KW_DISTRIBUTE||LA154_0==KW_FROM||LA154_0==KW_GROUP||LA154_0==KW_HAVING||LA154_0==KW_INSERT||LA154_0==KW_LATERAL||LA154_0==KW_LIMIT||LA154_0==KW_MAP||LA154_0==KW_ORDER||(LA154_0 >= KW_RECORDREADER && LA154_0 <= KW_REDUCE)||LA154_0==KW_SELECT||LA154_0==KW_SORT||LA154_0==KW_UNION||LA154_0==KW_USING||LA154_0==KW_WHERE||LA154_0==KW_WINDOW||LA154_0==RPAREN) ) {
				alt154=3;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 154, 0, input);
				throw nvae;
			}

			switch (alt154) {
				case 1 :
					// HiveParser.g:1497:7: rowFormatSerde
					{
					pushFollow(FOLLOW_rowFormatSerde_in_rowFormat8637);
					rowFormatSerde561=rowFormatSerde();
					state._fsp--;

					stream_rowFormatSerde.add(rowFormatSerde561.getTree());
					// AST REWRITE
					// elements: rowFormatSerde
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1497:22: -> ^( TOK_SERDE rowFormatSerde )
					{
						// HiveParser.g:1497:25: ^( TOK_SERDE rowFormatSerde )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SERDE, "TOK_SERDE"), root_1);
						adaptor.addChild(root_1, stream_rowFormatSerde.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1498:7: rowFormatDelimited
					{
					pushFollow(FOLLOW_rowFormatDelimited_in_rowFormat8653);
					rowFormatDelimited562=rowFormatDelimited();
					state._fsp--;

					stream_rowFormatDelimited.add(rowFormatDelimited562.getTree());
					// AST REWRITE
					// elements: rowFormatDelimited
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1498:26: -> ^( TOK_SERDE rowFormatDelimited )
					{
						// HiveParser.g:1498:29: ^( TOK_SERDE rowFormatDelimited )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SERDE, "TOK_SERDE"), root_1);
						adaptor.addChild(root_1, stream_rowFormatDelimited.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1499:9: 
					{
					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1499:9: -> ^( TOK_SERDE )
					{
						// HiveParser.g:1499:12: ^( TOK_SERDE )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SERDE, "TOK_SERDE"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "rowFormat"


	public static class recordReader_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "recordReader"
	// HiveParser.g:1502:1: recordReader : ( KW_RECORDREADER StringLiteral -> ^( TOK_RECORDREADER StringLiteral ) | -> ^( TOK_RECORDREADER ) );
	public final HiveParser.recordReader_return recordReader() throws RecognitionException {
		HiveParser.recordReader_return retval = new HiveParser.recordReader_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_RECORDREADER563=null;
		Token StringLiteral564=null;

		CommonTree KW_RECORDREADER563_tree=null;
		CommonTree StringLiteral564_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_RECORDREADER=new RewriteRuleTokenStream(adaptor,"token KW_RECORDREADER");

		 msgs.push("record reader specification"); 
		try {
			// HiveParser.g:1505:5: ( KW_RECORDREADER StringLiteral -> ^( TOK_RECORDREADER StringLiteral ) | -> ^( TOK_RECORDREADER ) )
			int alt155=2;
			int LA155_0 = input.LA(1);
			if ( (LA155_0==KW_RECORDREADER) ) {
				alt155=1;
			}
			else if ( (LA155_0==EOF||LA155_0==KW_CLUSTER||LA155_0==KW_DISTRIBUTE||LA155_0==KW_FROM||LA155_0==KW_GROUP||LA155_0==KW_HAVING||LA155_0==KW_INSERT||LA155_0==KW_LATERAL||LA155_0==KW_LIMIT||LA155_0==KW_MAP||LA155_0==KW_ORDER||LA155_0==KW_REDUCE||LA155_0==KW_SELECT||LA155_0==KW_SORT||LA155_0==KW_UNION||LA155_0==KW_WHERE||LA155_0==KW_WINDOW||LA155_0==RPAREN) ) {
				alt155=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 155, 0, input);
				throw nvae;
			}

			switch (alt155) {
				case 1 :
					// HiveParser.g:1505:7: KW_RECORDREADER StringLiteral
					{
					KW_RECORDREADER563=(Token)match(input,KW_RECORDREADER,FOLLOW_KW_RECORDREADER_in_recordReader8702);  
					stream_KW_RECORDREADER.add(KW_RECORDREADER563);

					StringLiteral564=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_recordReader8704);  
					stream_StringLiteral.add(StringLiteral564);

					// AST REWRITE
					// elements: StringLiteral
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1505:37: -> ^( TOK_RECORDREADER StringLiteral )
					{
						// HiveParser.g:1505:40: ^( TOK_RECORDREADER StringLiteral )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_RECORDREADER, "TOK_RECORDREADER"), root_1);
						adaptor.addChild(root_1, stream_StringLiteral.nextNode());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1506:9: 
					{
					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1506:9: -> ^( TOK_RECORDREADER )
					{
						// HiveParser.g:1506:12: ^( TOK_RECORDREADER )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_RECORDREADER, "TOK_RECORDREADER"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "recordReader"


	public static class recordWriter_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "recordWriter"
	// HiveParser.g:1509:1: recordWriter : ( KW_RECORDWRITER StringLiteral -> ^( TOK_RECORDWRITER StringLiteral ) | -> ^( TOK_RECORDWRITER ) );
	public final HiveParser.recordWriter_return recordWriter() throws RecognitionException {
		HiveParser.recordWriter_return retval = new HiveParser.recordWriter_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_RECORDWRITER565=null;
		Token StringLiteral566=null;

		CommonTree KW_RECORDWRITER565_tree=null;
		CommonTree StringLiteral566_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_RECORDWRITER=new RewriteRuleTokenStream(adaptor,"token KW_RECORDWRITER");

		 msgs.push("record writer specification"); 
		try {
			// HiveParser.g:1512:5: ( KW_RECORDWRITER StringLiteral -> ^( TOK_RECORDWRITER StringLiteral ) | -> ^( TOK_RECORDWRITER ) )
			int alt156=2;
			int LA156_0 = input.LA(1);
			if ( (LA156_0==KW_RECORDWRITER) ) {
				alt156=1;
			}
			else if ( (LA156_0==KW_USING) ) {
				alt156=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 156, 0, input);
				throw nvae;
			}

			switch (alt156) {
				case 1 :
					// HiveParser.g:1512:7: KW_RECORDWRITER StringLiteral
					{
					KW_RECORDWRITER565=(Token)match(input,KW_RECORDWRITER,FOLLOW_KW_RECORDWRITER_in_recordWriter8753);  
					stream_KW_RECORDWRITER.add(KW_RECORDWRITER565);

					StringLiteral566=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_recordWriter8755);  
					stream_StringLiteral.add(StringLiteral566);

					// AST REWRITE
					// elements: StringLiteral
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1512:37: -> ^( TOK_RECORDWRITER StringLiteral )
					{
						// HiveParser.g:1512:40: ^( TOK_RECORDWRITER StringLiteral )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_RECORDWRITER, "TOK_RECORDWRITER"), root_1);
						adaptor.addChild(root_1, stream_StringLiteral.nextNode());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1513:9: 
					{
					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1513:9: -> ^( TOK_RECORDWRITER )
					{
						// HiveParser.g:1513:12: ^( TOK_RECORDWRITER )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_RECORDWRITER, "TOK_RECORDWRITER"), root_1);
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "recordWriter"


	public static class rowFormatSerde_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "rowFormatSerde"
	// HiveParser.g:1516:1: rowFormatSerde : KW_ROW KW_FORMAT KW_SERDE name= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )? -> ^( TOK_SERDENAME $name ( $serdeprops)? ) ;
	public final HiveParser.rowFormatSerde_return rowFormatSerde() throws RecognitionException {
		HiveParser.rowFormatSerde_return retval = new HiveParser.rowFormatSerde_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token name=null;
		Token KW_ROW567=null;
		Token KW_FORMAT568=null;
		Token KW_SERDE569=null;
		Token KW_WITH570=null;
		Token KW_SERDEPROPERTIES571=null;
		ParserRuleReturnScope serdeprops =null;

		CommonTree name_tree=null;
		CommonTree KW_ROW567_tree=null;
		CommonTree KW_FORMAT568_tree=null;
		CommonTree KW_SERDE569_tree=null;
		CommonTree KW_WITH570_tree=null;
		CommonTree KW_SERDEPROPERTIES571_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_ROW=new RewriteRuleTokenStream(adaptor,"token KW_ROW");
		RewriteRuleTokenStream stream_KW_FORMAT=new RewriteRuleTokenStream(adaptor,"token KW_FORMAT");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_SERDE=new RewriteRuleTokenStream(adaptor,"token KW_SERDE");
		RewriteRuleTokenStream stream_KW_SERDEPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_SERDEPROPERTIES");
		RewriteRuleSubtreeStream stream_tableProperties=new RewriteRuleSubtreeStream(adaptor,"rule tableProperties");

		 msgs.push("serde format specification"); 
		try {
			// HiveParser.g:1519:5: ( KW_ROW KW_FORMAT KW_SERDE name= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )? -> ^( TOK_SERDENAME $name ( $serdeprops)? ) )
			// HiveParser.g:1519:7: KW_ROW KW_FORMAT KW_SERDE name= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )?
			{
			KW_ROW567=(Token)match(input,KW_ROW,FOLLOW_KW_ROW_in_rowFormatSerde8804);  
			stream_KW_ROW.add(KW_ROW567);

			KW_FORMAT568=(Token)match(input,KW_FORMAT,FOLLOW_KW_FORMAT_in_rowFormatSerde8806);  
			stream_KW_FORMAT.add(KW_FORMAT568);

			KW_SERDE569=(Token)match(input,KW_SERDE,FOLLOW_KW_SERDE_in_rowFormatSerde8808);  
			stream_KW_SERDE.add(KW_SERDE569);

			name=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_rowFormatSerde8812);  
			stream_StringLiteral.add(name);

			// HiveParser.g:1519:52: ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )?
			int alt157=2;
			int LA157_0 = input.LA(1);
			if ( (LA157_0==KW_WITH) ) {
				alt157=1;
			}
			switch (alt157) {
				case 1 :
					// HiveParser.g:1519:53: KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties
					{
					KW_WITH570=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_rowFormatSerde8815);  
					stream_KW_WITH.add(KW_WITH570);

					KW_SERDEPROPERTIES571=(Token)match(input,KW_SERDEPROPERTIES,FOLLOW_KW_SERDEPROPERTIES_in_rowFormatSerde8817);  
					stream_KW_SERDEPROPERTIES.add(KW_SERDEPROPERTIES571);

					pushFollow(FOLLOW_tableProperties_in_rowFormatSerde8821);
					serdeprops=tableProperties();
					state._fsp--;

					stream_tableProperties.add(serdeprops.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: serdeprops, name
			// token labels: name
			// rule labels: serdeprops, retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_name=new RewriteRuleTokenStream(adaptor,"token name",name);
			RewriteRuleSubtreeStream stream_serdeprops=new RewriteRuleSubtreeStream(adaptor,"rule serdeprops",serdeprops!=null?serdeprops.getTree():null);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1520:5: -> ^( TOK_SERDENAME $name ( $serdeprops)? )
			{
				// HiveParser.g:1520:8: ^( TOK_SERDENAME $name ( $serdeprops)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SERDENAME, "TOK_SERDENAME"), root_1);
				adaptor.addChild(root_1, stream_name.nextNode());
				// HiveParser.g:1520:31: ( $serdeprops)?
				if ( stream_serdeprops.hasNext() ) {
					adaptor.addChild(root_1, stream_serdeprops.nextTree());
				}
				stream_serdeprops.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "rowFormatSerde"


	public static class rowFormatDelimited_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "rowFormatDelimited"
	// HiveParser.g:1523:1: rowFormatDelimited : KW_ROW KW_FORMAT KW_DELIMITED ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? -> ^( TOK_SERDEPROPS ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? ) ;
	public final HiveParser.rowFormatDelimited_return rowFormatDelimited() throws RecognitionException {
		HiveParser.rowFormatDelimited_return retval = new HiveParser.rowFormatDelimited_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ROW572=null;
		Token KW_FORMAT573=null;
		Token KW_DELIMITED574=null;
		ParserRuleReturnScope tableRowFormatFieldIdentifier575 =null;
		ParserRuleReturnScope tableRowFormatCollItemsIdentifier576 =null;
		ParserRuleReturnScope tableRowFormatMapKeysIdentifier577 =null;
		ParserRuleReturnScope tableRowFormatLinesIdentifier578 =null;

		CommonTree KW_ROW572_tree=null;
		CommonTree KW_FORMAT573_tree=null;
		CommonTree KW_DELIMITED574_tree=null;
		RewriteRuleTokenStream stream_KW_DELIMITED=new RewriteRuleTokenStream(adaptor,"token KW_DELIMITED");
		RewriteRuleTokenStream stream_KW_ROW=new RewriteRuleTokenStream(adaptor,"token KW_ROW");
		RewriteRuleTokenStream stream_KW_FORMAT=new RewriteRuleTokenStream(adaptor,"token KW_FORMAT");
		RewriteRuleSubtreeStream stream_tableRowFormatMapKeysIdentifier=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormatMapKeysIdentifier");
		RewriteRuleSubtreeStream stream_tableRowFormatFieldIdentifier=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormatFieldIdentifier");
		RewriteRuleSubtreeStream stream_tableRowFormatCollItemsIdentifier=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormatCollItemsIdentifier");
		RewriteRuleSubtreeStream stream_tableRowFormatLinesIdentifier=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormatLinesIdentifier");

		 msgs.push("serde properties specification"); 
		try {
			// HiveParser.g:1526:5: ( KW_ROW KW_FORMAT KW_DELIMITED ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? -> ^( TOK_SERDEPROPS ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? ) )
			// HiveParser.g:1527:7: KW_ROW KW_FORMAT KW_DELIMITED ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )?
			{
			KW_ROW572=(Token)match(input,KW_ROW,FOLLOW_KW_ROW_in_rowFormatDelimited8873);  
			stream_KW_ROW.add(KW_ROW572);

			KW_FORMAT573=(Token)match(input,KW_FORMAT,FOLLOW_KW_FORMAT_in_rowFormatDelimited8875);  
			stream_KW_FORMAT.add(KW_FORMAT573);

			KW_DELIMITED574=(Token)match(input,KW_DELIMITED,FOLLOW_KW_DELIMITED_in_rowFormatDelimited8877);  
			stream_KW_DELIMITED.add(KW_DELIMITED574);

			// HiveParser.g:1527:37: ( tableRowFormatFieldIdentifier )?
			int alt158=2;
			int LA158_0 = input.LA(1);
			if ( (LA158_0==KW_FIELDS) ) {
				alt158=1;
			}
			switch (alt158) {
				case 1 :
					// HiveParser.g:1527:37: tableRowFormatFieldIdentifier
					{
					pushFollow(FOLLOW_tableRowFormatFieldIdentifier_in_rowFormatDelimited8879);
					tableRowFormatFieldIdentifier575=tableRowFormatFieldIdentifier();
					state._fsp--;

					stream_tableRowFormatFieldIdentifier.add(tableRowFormatFieldIdentifier575.getTree());
					}
					break;

			}

			// HiveParser.g:1527:68: ( tableRowFormatCollItemsIdentifier )?
			int alt159=2;
			int LA159_0 = input.LA(1);
			if ( (LA159_0==KW_COLLECTION) ) {
				alt159=1;
			}
			switch (alt159) {
				case 1 :
					// HiveParser.g:1527:68: tableRowFormatCollItemsIdentifier
					{
					pushFollow(FOLLOW_tableRowFormatCollItemsIdentifier_in_rowFormatDelimited8882);
					tableRowFormatCollItemsIdentifier576=tableRowFormatCollItemsIdentifier();
					state._fsp--;

					stream_tableRowFormatCollItemsIdentifier.add(tableRowFormatCollItemsIdentifier576.getTree());
					}
					break;

			}

			// HiveParser.g:1527:103: ( tableRowFormatMapKeysIdentifier )?
			int alt160=2;
			alt160 = dfa160.predict(input);
			switch (alt160) {
				case 1 :
					// HiveParser.g:1527:103: tableRowFormatMapKeysIdentifier
					{
					pushFollow(FOLLOW_tableRowFormatMapKeysIdentifier_in_rowFormatDelimited8885);
					tableRowFormatMapKeysIdentifier577=tableRowFormatMapKeysIdentifier();
					state._fsp--;

					stream_tableRowFormatMapKeysIdentifier.add(tableRowFormatMapKeysIdentifier577.getTree());
					}
					break;

			}

			// HiveParser.g:1527:136: ( tableRowFormatLinesIdentifier )?
			int alt161=2;
			int LA161_0 = input.LA(1);
			if ( (LA161_0==KW_LINES) ) {
				alt161=1;
			}
			switch (alt161) {
				case 1 :
					// HiveParser.g:1527:136: tableRowFormatLinesIdentifier
					{
					pushFollow(FOLLOW_tableRowFormatLinesIdentifier_in_rowFormatDelimited8888);
					tableRowFormatLinesIdentifier578=tableRowFormatLinesIdentifier();
					state._fsp--;

					stream_tableRowFormatLinesIdentifier.add(tableRowFormatLinesIdentifier578.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: tableRowFormatLinesIdentifier, tableRowFormatMapKeysIdentifier, tableRowFormatCollItemsIdentifier, tableRowFormatFieldIdentifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1528:5: -> ^( TOK_SERDEPROPS ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? )
			{
				// HiveParser.g:1528:8: ^( TOK_SERDEPROPS ( tableRowFormatFieldIdentifier )? ( tableRowFormatCollItemsIdentifier )? ( tableRowFormatMapKeysIdentifier )? ( tableRowFormatLinesIdentifier )? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_SERDEPROPS, "TOK_SERDEPROPS"), root_1);
				// HiveParser.g:1528:25: ( tableRowFormatFieldIdentifier )?
				if ( stream_tableRowFormatFieldIdentifier.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormatFieldIdentifier.nextTree());
				}
				stream_tableRowFormatFieldIdentifier.reset();

				// HiveParser.g:1528:56: ( tableRowFormatCollItemsIdentifier )?
				if ( stream_tableRowFormatCollItemsIdentifier.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormatCollItemsIdentifier.nextTree());
				}
				stream_tableRowFormatCollItemsIdentifier.reset();

				// HiveParser.g:1528:91: ( tableRowFormatMapKeysIdentifier )?
				if ( stream_tableRowFormatMapKeysIdentifier.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormatMapKeysIdentifier.nextTree());
				}
				stream_tableRowFormatMapKeysIdentifier.reset();

				// HiveParser.g:1528:124: ( tableRowFormatLinesIdentifier )?
				if ( stream_tableRowFormatLinesIdentifier.hasNext() ) {
					adaptor.addChild(root_1, stream_tableRowFormatLinesIdentifier.nextTree());
				}
				stream_tableRowFormatLinesIdentifier.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "rowFormatDelimited"


	public static class tableRowFormat_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableRowFormat"
	// HiveParser.g:1531:1: tableRowFormat : ( rowFormatDelimited -> ^( TOK_TABLEROWFORMAT rowFormatDelimited ) | rowFormatSerde -> ^( TOK_TABLESERIALIZER rowFormatSerde ) );
	public final HiveParser.tableRowFormat_return tableRowFormat() throws RecognitionException {
		HiveParser.tableRowFormat_return retval = new HiveParser.tableRowFormat_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope rowFormatDelimited579 =null;
		ParserRuleReturnScope rowFormatSerde580 =null;

		RewriteRuleSubtreeStream stream_rowFormatSerde=new RewriteRuleSubtreeStream(adaptor,"rule rowFormatSerde");
		RewriteRuleSubtreeStream stream_rowFormatDelimited=new RewriteRuleSubtreeStream(adaptor,"rule rowFormatDelimited");

		 msgs.push("table row format specification"); 
		try {
			// HiveParser.g:1534:5: ( rowFormatDelimited -> ^( TOK_TABLEROWFORMAT rowFormatDelimited ) | rowFormatSerde -> ^( TOK_TABLESERIALIZER rowFormatSerde ) )
			int alt162=2;
			int LA162_0 = input.LA(1);
			if ( (LA162_0==KW_ROW) ) {
				int LA162_1 = input.LA(2);
				if ( (LA162_1==KW_FORMAT) ) {
					int LA162_2 = input.LA(3);
					if ( (LA162_2==KW_DELIMITED) ) {
						alt162=1;
					}
					else if ( (LA162_2==KW_SERDE) ) {
						alt162=2;
					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 162, 2, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 162, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 162, 0, input);
				throw nvae;
			}

			switch (alt162) {
				case 1 :
					// HiveParser.g:1535:7: rowFormatDelimited
					{
					pushFollow(FOLLOW_rowFormatDelimited_in_tableRowFormat8944);
					rowFormatDelimited579=rowFormatDelimited();
					state._fsp--;

					stream_rowFormatDelimited.add(rowFormatDelimited579.getTree());
					// AST REWRITE
					// elements: rowFormatDelimited
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1536:5: -> ^( TOK_TABLEROWFORMAT rowFormatDelimited )
					{
						// HiveParser.g:1536:8: ^( TOK_TABLEROWFORMAT rowFormatDelimited )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEROWFORMAT, "TOK_TABLEROWFORMAT"), root_1);
						adaptor.addChild(root_1, stream_rowFormatDelimited.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1537:7: rowFormatSerde
					{
					pushFollow(FOLLOW_rowFormatSerde_in_tableRowFormat8964);
					rowFormatSerde580=rowFormatSerde();
					state._fsp--;

					stream_rowFormatSerde.add(rowFormatSerde580.getTree());
					// AST REWRITE
					// elements: rowFormatSerde
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1538:5: -> ^( TOK_TABLESERIALIZER rowFormatSerde )
					{
						// HiveParser.g:1538:8: ^( TOK_TABLESERIALIZER rowFormatSerde )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLESERIALIZER, "TOK_TABLESERIALIZER"), root_1);
						adaptor.addChild(root_1, stream_rowFormatSerde.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableRowFormat"


	public static class tablePropertiesPrefixed_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tablePropertiesPrefixed"
	// HiveParser.g:1541:1: tablePropertiesPrefixed : KW_TBLPROPERTIES ! tableProperties ;
	public final HiveParser.tablePropertiesPrefixed_return tablePropertiesPrefixed() throws RecognitionException {
		HiveParser.tablePropertiesPrefixed_return retval = new HiveParser.tablePropertiesPrefixed_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_TBLPROPERTIES581=null;
		ParserRuleReturnScope tableProperties582 =null;

		CommonTree KW_TBLPROPERTIES581_tree=null;

		 msgs.push("table properties with prefix"); 
		try {
			// HiveParser.g:1544:5: ( KW_TBLPROPERTIES ! tableProperties )
			// HiveParser.g:1545:9: KW_TBLPROPERTIES ! tableProperties
			{
			root_0 = (CommonTree)adaptor.nil();


			KW_TBLPROPERTIES581=(Token)match(input,KW_TBLPROPERTIES,FOLLOW_KW_TBLPROPERTIES_in_tablePropertiesPrefixed9011); 
			pushFollow(FOLLOW_tableProperties_in_tablePropertiesPrefixed9014);
			tableProperties582=tableProperties();
			state._fsp--;

			adaptor.addChild(root_0, tableProperties582.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tablePropertiesPrefixed"


	public static class tableProperties_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableProperties"
	// HiveParser.g:1548:1: tableProperties : LPAREN tablePropertiesList RPAREN -> ^( TOK_TABLEPROPERTIES tablePropertiesList ) ;
	public final HiveParser.tableProperties_return tableProperties() throws RecognitionException {
		HiveParser.tableProperties_return retval = new HiveParser.tableProperties_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN583=null;
		Token RPAREN585=null;
		ParserRuleReturnScope tablePropertiesList584 =null;

		CommonTree LPAREN583_tree=null;
		CommonTree RPAREN585_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_tablePropertiesList=new RewriteRuleSubtreeStream(adaptor,"rule tablePropertiesList");

		 msgs.push("table properties"); 
		try {
			// HiveParser.g:1551:5: ( LPAREN tablePropertiesList RPAREN -> ^( TOK_TABLEPROPERTIES tablePropertiesList ) )
			// HiveParser.g:1552:7: LPAREN tablePropertiesList RPAREN
			{
			LPAREN583=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_tableProperties9047);  
			stream_LPAREN.add(LPAREN583);

			pushFollow(FOLLOW_tablePropertiesList_in_tableProperties9049);
			tablePropertiesList584=tablePropertiesList();
			state._fsp--;

			stream_tablePropertiesList.add(tablePropertiesList584.getTree());
			RPAREN585=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_tableProperties9051);  
			stream_RPAREN.add(RPAREN585);

			// AST REWRITE
			// elements: tablePropertiesList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1552:41: -> ^( TOK_TABLEPROPERTIES tablePropertiesList )
			{
				// HiveParser.g:1552:44: ^( TOK_TABLEPROPERTIES tablePropertiesList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPROPERTIES, "TOK_TABLEPROPERTIES"), root_1);
				adaptor.addChild(root_1, stream_tablePropertiesList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableProperties"


	public static class tablePropertiesList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tablePropertiesList"
	// HiveParser.g:1555:1: tablePropertiesList : ( keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_TABLEPROPLIST ( keyValueProperty )+ ) | keyProperty ( COMMA keyProperty )* -> ^( TOK_TABLEPROPLIST ( keyProperty )+ ) );
	public final HiveParser.tablePropertiesList_return tablePropertiesList() throws RecognitionException {
		HiveParser.tablePropertiesList_return retval = new HiveParser.tablePropertiesList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA587=null;
		Token COMMA590=null;
		ParserRuleReturnScope keyValueProperty586 =null;
		ParserRuleReturnScope keyValueProperty588 =null;
		ParserRuleReturnScope keyProperty589 =null;
		ParserRuleReturnScope keyProperty591 =null;

		CommonTree COMMA587_tree=null;
		CommonTree COMMA590_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_keyValueProperty=new RewriteRuleSubtreeStream(adaptor,"rule keyValueProperty");
		RewriteRuleSubtreeStream stream_keyProperty=new RewriteRuleSubtreeStream(adaptor,"rule keyProperty");

		 msgs.push("table properties list"); 
		try {
			// HiveParser.g:1558:5: ( keyValueProperty ( COMMA keyValueProperty )* -> ^( TOK_TABLEPROPLIST ( keyValueProperty )+ ) | keyProperty ( COMMA keyProperty )* -> ^( TOK_TABLEPROPLIST ( keyProperty )+ ) )
			int alt165=2;
			int LA165_0 = input.LA(1);
			if ( (LA165_0==StringLiteral) ) {
				int LA165_1 = input.LA(2);
				if ( (LA165_1==EQUAL) ) {
					alt165=1;
				}
				else if ( (LA165_1==COMMA||LA165_1==RPAREN) ) {
					alt165=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 165, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 165, 0, input);
				throw nvae;
			}

			switch (alt165) {
				case 1 :
					// HiveParser.g:1559:7: keyValueProperty ( COMMA keyValueProperty )*
					{
					pushFollow(FOLLOW_keyValueProperty_in_tablePropertiesList9092);
					keyValueProperty586=keyValueProperty();
					state._fsp--;

					stream_keyValueProperty.add(keyValueProperty586.getTree());
					// HiveParser.g:1559:24: ( COMMA keyValueProperty )*
					loop163:
					while (true) {
						int alt163=2;
						int LA163_0 = input.LA(1);
						if ( (LA163_0==COMMA) ) {
							alt163=1;
						}

						switch (alt163) {
						case 1 :
							// HiveParser.g:1559:25: COMMA keyValueProperty
							{
							COMMA587=(Token)match(input,COMMA,FOLLOW_COMMA_in_tablePropertiesList9095);  
							stream_COMMA.add(COMMA587);

							pushFollow(FOLLOW_keyValueProperty_in_tablePropertiesList9097);
							keyValueProperty588=keyValueProperty();
							state._fsp--;

							stream_keyValueProperty.add(keyValueProperty588.getTree());
							}
							break;

						default :
							break loop163;
						}
					}

					// AST REWRITE
					// elements: keyValueProperty
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1559:50: -> ^( TOK_TABLEPROPLIST ( keyValueProperty )+ )
					{
						// HiveParser.g:1559:53: ^( TOK_TABLEPROPLIST ( keyValueProperty )+ )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPROPLIST, "TOK_TABLEPROPLIST"), root_1);
						if ( !(stream_keyValueProperty.hasNext()) ) {
							throw new RewriteEarlyExitException();
						}
						while ( stream_keyValueProperty.hasNext() ) {
							adaptor.addChild(root_1, stream_keyValueProperty.nextTree());
						}
						stream_keyValueProperty.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1561:7: keyProperty ( COMMA keyProperty )*
					{
					pushFollow(FOLLOW_keyProperty_in_tablePropertiesList9122);
					keyProperty589=keyProperty();
					state._fsp--;

					stream_keyProperty.add(keyProperty589.getTree());
					// HiveParser.g:1561:19: ( COMMA keyProperty )*
					loop164:
					while (true) {
						int alt164=2;
						int LA164_0 = input.LA(1);
						if ( (LA164_0==COMMA) ) {
							alt164=1;
						}

						switch (alt164) {
						case 1 :
							// HiveParser.g:1561:20: COMMA keyProperty
							{
							COMMA590=(Token)match(input,COMMA,FOLLOW_COMMA_in_tablePropertiesList9125);  
							stream_COMMA.add(COMMA590);

							pushFollow(FOLLOW_keyProperty_in_tablePropertiesList9127);
							keyProperty591=keyProperty();
							state._fsp--;

							stream_keyProperty.add(keyProperty591.getTree());
							}
							break;

						default :
							break loop164;
						}
					}

					// AST REWRITE
					// elements: keyProperty
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1561:40: -> ^( TOK_TABLEPROPLIST ( keyProperty )+ )
					{
						// HiveParser.g:1561:43: ^( TOK_TABLEPROPLIST ( keyProperty )+ )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPROPLIST, "TOK_TABLEPROPLIST"), root_1);
						if ( !(stream_keyProperty.hasNext()) ) {
							throw new RewriteEarlyExitException();
						}
						while ( stream_keyProperty.hasNext() ) {
							adaptor.addChild(root_1, stream_keyProperty.nextTree());
						}
						stream_keyProperty.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tablePropertiesList"


	public static class keyValueProperty_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "keyValueProperty"
	// HiveParser.g:1564:1: keyValueProperty : key= StringLiteral EQUAL value= StringLiteral -> ^( TOK_TABLEPROPERTY $key $value) ;
	public final HiveParser.keyValueProperty_return keyValueProperty() throws RecognitionException {
		HiveParser.keyValueProperty_return retval = new HiveParser.keyValueProperty_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token key=null;
		Token value=null;
		Token EQUAL592=null;

		CommonTree key_tree=null;
		CommonTree value_tree=null;
		CommonTree EQUAL592_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_EQUAL=new RewriteRuleTokenStream(adaptor,"token EQUAL");

		 msgs.push("specifying key/value property"); 
		try {
			// HiveParser.g:1567:5: (key= StringLiteral EQUAL value= StringLiteral -> ^( TOK_TABLEPROPERTY $key $value) )
			// HiveParser.g:1568:7: key= StringLiteral EQUAL value= StringLiteral
			{
			key=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_keyValueProperty9173);  
			stream_StringLiteral.add(key);

			EQUAL592=(Token)match(input,EQUAL,FOLLOW_EQUAL_in_keyValueProperty9175);  
			stream_EQUAL.add(EQUAL592);

			value=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_keyValueProperty9179);  
			stream_StringLiteral.add(value);

			// AST REWRITE
			// elements: value, key
			// token labels: value, key
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_value=new RewriteRuleTokenStream(adaptor,"token value",value);
			RewriteRuleTokenStream stream_key=new RewriteRuleTokenStream(adaptor,"token key",key);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1568:51: -> ^( TOK_TABLEPROPERTY $key $value)
			{
				// HiveParser.g:1568:54: ^( TOK_TABLEPROPERTY $key $value)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPROPERTY, "TOK_TABLEPROPERTY"), root_1);
				adaptor.addChild(root_1, stream_key.nextNode());
				adaptor.addChild(root_1, stream_value.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "keyValueProperty"


	public static class keyProperty_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "keyProperty"
	// HiveParser.g:1571:1: keyProperty : key= StringLiteral -> ^( TOK_TABLEPROPERTY $key TOK_NULL ) ;
	public final HiveParser.keyProperty_return keyProperty() throws RecognitionException {
		HiveParser.keyProperty_return retval = new HiveParser.keyProperty_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token key=null;

		CommonTree key_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");

		 msgs.push("specifying key property"); 
		try {
			// HiveParser.g:1574:5: (key= StringLiteral -> ^( TOK_TABLEPROPERTY $key TOK_NULL ) )
			// HiveParser.g:1575:7: key= StringLiteral
			{
			key=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_keyProperty9226);  
			stream_StringLiteral.add(key);

			// AST REWRITE
			// elements: key
			// token labels: key
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_key=new RewriteRuleTokenStream(adaptor,"token key",key);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1575:25: -> ^( TOK_TABLEPROPERTY $key TOK_NULL )
			{
				// HiveParser.g:1575:28: ^( TOK_TABLEPROPERTY $key TOK_NULL )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEPROPERTY, "TOK_TABLEPROPERTY"), root_1);
				adaptor.addChild(root_1, stream_key.nextNode());
				adaptor.addChild(root_1, (CommonTree)adaptor.create(TOK_NULL, "TOK_NULL"));
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "keyProperty"


	public static class tableRowFormatFieldIdentifier_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableRowFormatFieldIdentifier"
	// HiveParser.g:1578:1: tableRowFormatFieldIdentifier : KW_FIELDS KW_TERMINATED KW_BY fldIdnt= StringLiteral ( KW_ESCAPED KW_BY fldEscape= StringLiteral )? -> ^( TOK_TABLEROWFORMATFIELD $fldIdnt ( $fldEscape)? ) ;
	public final HiveParser.tableRowFormatFieldIdentifier_return tableRowFormatFieldIdentifier() throws RecognitionException {
		HiveParser.tableRowFormatFieldIdentifier_return retval = new HiveParser.tableRowFormatFieldIdentifier_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token fldIdnt=null;
		Token fldEscape=null;
		Token KW_FIELDS593=null;
		Token KW_TERMINATED594=null;
		Token KW_BY595=null;
		Token KW_ESCAPED596=null;
		Token KW_BY597=null;

		CommonTree fldIdnt_tree=null;
		CommonTree fldEscape_tree=null;
		CommonTree KW_FIELDS593_tree=null;
		CommonTree KW_TERMINATED594_tree=null;
		CommonTree KW_BY595_tree=null;
		CommonTree KW_ESCAPED596_tree=null;
		CommonTree KW_BY597_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_ESCAPED=new RewriteRuleTokenStream(adaptor,"token KW_ESCAPED");
		RewriteRuleTokenStream stream_KW_FIELDS=new RewriteRuleTokenStream(adaptor,"token KW_FIELDS");
		RewriteRuleTokenStream stream_KW_TERMINATED=new RewriteRuleTokenStream(adaptor,"token KW_TERMINATED");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");

		 msgs.push("table row format's field separator"); 
		try {
			// HiveParser.g:1581:5: ( KW_FIELDS KW_TERMINATED KW_BY fldIdnt= StringLiteral ( KW_ESCAPED KW_BY fldEscape= StringLiteral )? -> ^( TOK_TABLEROWFORMATFIELD $fldIdnt ( $fldEscape)? ) )
			// HiveParser.g:1582:7: KW_FIELDS KW_TERMINATED KW_BY fldIdnt= StringLiteral ( KW_ESCAPED KW_BY fldEscape= StringLiteral )?
			{
			KW_FIELDS593=(Token)match(input,KW_FIELDS,FOLLOW_KW_FIELDS_in_tableRowFormatFieldIdentifier9270);  
			stream_KW_FIELDS.add(KW_FIELDS593);

			KW_TERMINATED594=(Token)match(input,KW_TERMINATED,FOLLOW_KW_TERMINATED_in_tableRowFormatFieldIdentifier9272);  
			stream_KW_TERMINATED.add(KW_TERMINATED594);

			KW_BY595=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableRowFormatFieldIdentifier9274);  
			stream_KW_BY.add(KW_BY595);

			fldIdnt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableRowFormatFieldIdentifier9278);  
			stream_StringLiteral.add(fldIdnt);

			// HiveParser.g:1582:59: ( KW_ESCAPED KW_BY fldEscape= StringLiteral )?
			int alt166=2;
			int LA166_0 = input.LA(1);
			if ( (LA166_0==KW_ESCAPED) ) {
				alt166=1;
			}
			switch (alt166) {
				case 1 :
					// HiveParser.g:1582:60: KW_ESCAPED KW_BY fldEscape= StringLiteral
					{
					KW_ESCAPED596=(Token)match(input,KW_ESCAPED,FOLLOW_KW_ESCAPED_in_tableRowFormatFieldIdentifier9281);  
					stream_KW_ESCAPED.add(KW_ESCAPED596);

					KW_BY597=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableRowFormatFieldIdentifier9283);  
					stream_KW_BY.add(KW_BY597);

					fldEscape=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableRowFormatFieldIdentifier9287);  
					stream_StringLiteral.add(fldEscape);

					}
					break;

			}

			// AST REWRITE
			// elements: fldEscape, fldIdnt
			// token labels: fldEscape, fldIdnt
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_fldEscape=new RewriteRuleTokenStream(adaptor,"token fldEscape",fldEscape);
			RewriteRuleTokenStream stream_fldIdnt=new RewriteRuleTokenStream(adaptor,"token fldIdnt",fldIdnt);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1583:5: -> ^( TOK_TABLEROWFORMATFIELD $fldIdnt ( $fldEscape)? )
			{
				// HiveParser.g:1583:8: ^( TOK_TABLEROWFORMATFIELD $fldIdnt ( $fldEscape)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEROWFORMATFIELD, "TOK_TABLEROWFORMATFIELD"), root_1);
				adaptor.addChild(root_1, stream_fldIdnt.nextNode());
				// HiveParser.g:1583:44: ( $fldEscape)?
				if ( stream_fldEscape.hasNext() ) {
					adaptor.addChild(root_1, stream_fldEscape.nextNode());
				}
				stream_fldEscape.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableRowFormatFieldIdentifier"


	public static class tableRowFormatCollItemsIdentifier_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableRowFormatCollItemsIdentifier"
	// HiveParser.g:1586:1: tableRowFormatCollItemsIdentifier : KW_COLLECTION KW_ITEMS KW_TERMINATED KW_BY collIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATCOLLITEMS $collIdnt) ;
	public final HiveParser.tableRowFormatCollItemsIdentifier_return tableRowFormatCollItemsIdentifier() throws RecognitionException {
		HiveParser.tableRowFormatCollItemsIdentifier_return retval = new HiveParser.tableRowFormatCollItemsIdentifier_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token collIdnt=null;
		Token KW_COLLECTION598=null;
		Token KW_ITEMS599=null;
		Token KW_TERMINATED600=null;
		Token KW_BY601=null;

		CommonTree collIdnt_tree=null;
		CommonTree KW_COLLECTION598_tree=null;
		CommonTree KW_ITEMS599_tree=null;
		CommonTree KW_TERMINATED600_tree=null;
		CommonTree KW_BY601_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_ITEMS=new RewriteRuleTokenStream(adaptor,"token KW_ITEMS");
		RewriteRuleTokenStream stream_KW_COLLECTION=new RewriteRuleTokenStream(adaptor,"token KW_COLLECTION");
		RewriteRuleTokenStream stream_KW_TERMINATED=new RewriteRuleTokenStream(adaptor,"token KW_TERMINATED");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");

		 msgs.push("table row format's column separator"); 
		try {
			// HiveParser.g:1589:5: ( KW_COLLECTION KW_ITEMS KW_TERMINATED KW_BY collIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATCOLLITEMS $collIdnt) )
			// HiveParser.g:1590:7: KW_COLLECTION KW_ITEMS KW_TERMINATED KW_BY collIdnt= StringLiteral
			{
			KW_COLLECTION598=(Token)match(input,KW_COLLECTION,FOLLOW_KW_COLLECTION_in_tableRowFormatCollItemsIdentifier9339);  
			stream_KW_COLLECTION.add(KW_COLLECTION598);

			KW_ITEMS599=(Token)match(input,KW_ITEMS,FOLLOW_KW_ITEMS_in_tableRowFormatCollItemsIdentifier9341);  
			stream_KW_ITEMS.add(KW_ITEMS599);

			KW_TERMINATED600=(Token)match(input,KW_TERMINATED,FOLLOW_KW_TERMINATED_in_tableRowFormatCollItemsIdentifier9343);  
			stream_KW_TERMINATED.add(KW_TERMINATED600);

			KW_BY601=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableRowFormatCollItemsIdentifier9345);  
			stream_KW_BY.add(KW_BY601);

			collIdnt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableRowFormatCollItemsIdentifier9349);  
			stream_StringLiteral.add(collIdnt);

			// AST REWRITE
			// elements: collIdnt
			// token labels: collIdnt
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_collIdnt=new RewriteRuleTokenStream(adaptor,"token collIdnt",collIdnt);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1591:5: -> ^( TOK_TABLEROWFORMATCOLLITEMS $collIdnt)
			{
				// HiveParser.g:1591:8: ^( TOK_TABLEROWFORMATCOLLITEMS $collIdnt)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEROWFORMATCOLLITEMS, "TOK_TABLEROWFORMATCOLLITEMS"), root_1);
				adaptor.addChild(root_1, stream_collIdnt.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableRowFormatCollItemsIdentifier"


	public static class tableRowFormatMapKeysIdentifier_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableRowFormatMapKeysIdentifier"
	// HiveParser.g:1594:1: tableRowFormatMapKeysIdentifier : KW_MAP KW_KEYS KW_TERMINATED KW_BY mapKeysIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATMAPKEYS $mapKeysIdnt) ;
	public final HiveParser.tableRowFormatMapKeysIdentifier_return tableRowFormatMapKeysIdentifier() throws RecognitionException {
		HiveParser.tableRowFormatMapKeysIdentifier_return retval = new HiveParser.tableRowFormatMapKeysIdentifier_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token mapKeysIdnt=null;
		Token KW_MAP602=null;
		Token KW_KEYS603=null;
		Token KW_TERMINATED604=null;
		Token KW_BY605=null;

		CommonTree mapKeysIdnt_tree=null;
		CommonTree KW_MAP602_tree=null;
		CommonTree KW_KEYS603_tree=null;
		CommonTree KW_TERMINATED604_tree=null;
		CommonTree KW_BY605_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_KEYS=new RewriteRuleTokenStream(adaptor,"token KW_KEYS");
		RewriteRuleTokenStream stream_KW_MAP=new RewriteRuleTokenStream(adaptor,"token KW_MAP");
		RewriteRuleTokenStream stream_KW_TERMINATED=new RewriteRuleTokenStream(adaptor,"token KW_TERMINATED");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");

		 msgs.push("table row format's map key separator"); 
		try {
			// HiveParser.g:1597:5: ( KW_MAP KW_KEYS KW_TERMINATED KW_BY mapKeysIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATMAPKEYS $mapKeysIdnt) )
			// HiveParser.g:1598:7: KW_MAP KW_KEYS KW_TERMINATED KW_BY mapKeysIdnt= StringLiteral
			{
			KW_MAP602=(Token)match(input,KW_MAP,FOLLOW_KW_MAP_in_tableRowFormatMapKeysIdentifier9395);  
			stream_KW_MAP.add(KW_MAP602);

			KW_KEYS603=(Token)match(input,KW_KEYS,FOLLOW_KW_KEYS_in_tableRowFormatMapKeysIdentifier9397);  
			stream_KW_KEYS.add(KW_KEYS603);

			KW_TERMINATED604=(Token)match(input,KW_TERMINATED,FOLLOW_KW_TERMINATED_in_tableRowFormatMapKeysIdentifier9399);  
			stream_KW_TERMINATED.add(KW_TERMINATED604);

			KW_BY605=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableRowFormatMapKeysIdentifier9401);  
			stream_KW_BY.add(KW_BY605);

			mapKeysIdnt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableRowFormatMapKeysIdentifier9405);  
			stream_StringLiteral.add(mapKeysIdnt);

			// AST REWRITE
			// elements: mapKeysIdnt
			// token labels: mapKeysIdnt
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_mapKeysIdnt=new RewriteRuleTokenStream(adaptor,"token mapKeysIdnt",mapKeysIdnt);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1599:5: -> ^( TOK_TABLEROWFORMATMAPKEYS $mapKeysIdnt)
			{
				// HiveParser.g:1599:8: ^( TOK_TABLEROWFORMATMAPKEYS $mapKeysIdnt)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEROWFORMATMAPKEYS, "TOK_TABLEROWFORMATMAPKEYS"), root_1);
				adaptor.addChild(root_1, stream_mapKeysIdnt.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableRowFormatMapKeysIdentifier"


	public static class tableRowFormatLinesIdentifier_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableRowFormatLinesIdentifier"
	// HiveParser.g:1602:1: tableRowFormatLinesIdentifier : KW_LINES KW_TERMINATED KW_BY linesIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATLINES $linesIdnt) ;
	public final HiveParser.tableRowFormatLinesIdentifier_return tableRowFormatLinesIdentifier() throws RecognitionException {
		HiveParser.tableRowFormatLinesIdentifier_return retval = new HiveParser.tableRowFormatLinesIdentifier_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token linesIdnt=null;
		Token KW_LINES606=null;
		Token KW_TERMINATED607=null;
		Token KW_BY608=null;

		CommonTree linesIdnt_tree=null;
		CommonTree KW_LINES606_tree=null;
		CommonTree KW_TERMINATED607_tree=null;
		CommonTree KW_BY608_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_LINES=new RewriteRuleTokenStream(adaptor,"token KW_LINES");
		RewriteRuleTokenStream stream_KW_TERMINATED=new RewriteRuleTokenStream(adaptor,"token KW_TERMINATED");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");

		 msgs.push("table row format's line separator"); 
		try {
			// HiveParser.g:1605:5: ( KW_LINES KW_TERMINATED KW_BY linesIdnt= StringLiteral -> ^( TOK_TABLEROWFORMATLINES $linesIdnt) )
			// HiveParser.g:1606:7: KW_LINES KW_TERMINATED KW_BY linesIdnt= StringLiteral
			{
			KW_LINES606=(Token)match(input,KW_LINES,FOLLOW_KW_LINES_in_tableRowFormatLinesIdentifier9451);  
			stream_KW_LINES.add(KW_LINES606);

			KW_TERMINATED607=(Token)match(input,KW_TERMINATED,FOLLOW_KW_TERMINATED_in_tableRowFormatLinesIdentifier9453);  
			stream_KW_TERMINATED.add(KW_TERMINATED607);

			KW_BY608=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableRowFormatLinesIdentifier9455);  
			stream_KW_BY.add(KW_BY608);

			linesIdnt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableRowFormatLinesIdentifier9459);  
			stream_StringLiteral.add(linesIdnt);

			// AST REWRITE
			// elements: linesIdnt
			// token labels: linesIdnt
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_linesIdnt=new RewriteRuleTokenStream(adaptor,"token linesIdnt",linesIdnt);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1607:5: -> ^( TOK_TABLEROWFORMATLINES $linesIdnt)
			{
				// HiveParser.g:1607:8: ^( TOK_TABLEROWFORMATLINES $linesIdnt)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEROWFORMATLINES, "TOK_TABLEROWFORMATLINES"), root_1);
				adaptor.addChild(root_1, stream_linesIdnt.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableRowFormatLinesIdentifier"


	public static class tableFileFormat_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableFileFormat"
	// HiveParser.g:1610:1: tableFileFormat : ( KW_STORED KW_AS KW_SEQUENCEFILE -> TOK_TBLSEQUENCEFILE | KW_STORED KW_AS KW_TEXTFILE -> TOK_TBLTEXTFILE | KW_STORED KW_AS KW_RCFILE -> TOK_TBLRCFILE | KW_STORED KW_AS KW_ORCFILE -> TOK_TBLORCFILE | KW_STORED KW_AS KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )? -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? ) | KW_STORED KW_BY storageHandler= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )? -> ^( TOK_STORAGEHANDLER $storageHandler ( $serdeprops)? ) | KW_STORED KW_AS genericSpec= identifier -> ^( TOK_FILEFORMAT_GENERIC $genericSpec) );
	public final HiveParser.tableFileFormat_return tableFileFormat() throws RecognitionException {
		HiveParser.tableFileFormat_return retval = new HiveParser.tableFileFormat_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token inFmt=null;
		Token outFmt=null;
		Token inDriver=null;
		Token outDriver=null;
		Token storageHandler=null;
		Token KW_STORED609=null;
		Token KW_AS610=null;
		Token KW_SEQUENCEFILE611=null;
		Token KW_STORED612=null;
		Token KW_AS613=null;
		Token KW_TEXTFILE614=null;
		Token KW_STORED615=null;
		Token KW_AS616=null;
		Token KW_RCFILE617=null;
		Token KW_STORED618=null;
		Token KW_AS619=null;
		Token KW_ORCFILE620=null;
		Token KW_STORED621=null;
		Token KW_AS622=null;
		Token KW_INPUTFORMAT623=null;
		Token KW_OUTPUTFORMAT624=null;
		Token KW_INPUTDRIVER625=null;
		Token KW_OUTPUTDRIVER626=null;
		Token KW_STORED627=null;
		Token KW_BY628=null;
		Token KW_WITH629=null;
		Token KW_SERDEPROPERTIES630=null;
		Token KW_STORED631=null;
		Token KW_AS632=null;
		ParserRuleReturnScope serdeprops =null;
		ParserRuleReturnScope genericSpec =null;

		CommonTree inFmt_tree=null;
		CommonTree outFmt_tree=null;
		CommonTree inDriver_tree=null;
		CommonTree outDriver_tree=null;
		CommonTree storageHandler_tree=null;
		CommonTree KW_STORED609_tree=null;
		CommonTree KW_AS610_tree=null;
		CommonTree KW_SEQUENCEFILE611_tree=null;
		CommonTree KW_STORED612_tree=null;
		CommonTree KW_AS613_tree=null;
		CommonTree KW_TEXTFILE614_tree=null;
		CommonTree KW_STORED615_tree=null;
		CommonTree KW_AS616_tree=null;
		CommonTree KW_RCFILE617_tree=null;
		CommonTree KW_STORED618_tree=null;
		CommonTree KW_AS619_tree=null;
		CommonTree KW_ORCFILE620_tree=null;
		CommonTree KW_STORED621_tree=null;
		CommonTree KW_AS622_tree=null;
		CommonTree KW_INPUTFORMAT623_tree=null;
		CommonTree KW_OUTPUTFORMAT624_tree=null;
		CommonTree KW_INPUTDRIVER625_tree=null;
		CommonTree KW_OUTPUTDRIVER626_tree=null;
		CommonTree KW_STORED627_tree=null;
		CommonTree KW_BY628_tree=null;
		CommonTree KW_WITH629_tree=null;
		CommonTree KW_SERDEPROPERTIES630_tree=null;
		CommonTree KW_STORED631_tree=null;
		CommonTree KW_AS632_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_INPUTDRIVER=new RewriteRuleTokenStream(adaptor,"token KW_INPUTDRIVER");
		RewriteRuleTokenStream stream_KW_OUTPUTFORMAT=new RewriteRuleTokenStream(adaptor,"token KW_OUTPUTFORMAT");
		RewriteRuleTokenStream stream_KW_ORCFILE=new RewriteRuleTokenStream(adaptor,"token KW_ORCFILE");
		RewriteRuleTokenStream stream_KW_TEXTFILE=new RewriteRuleTokenStream(adaptor,"token KW_TEXTFILE");
		RewriteRuleTokenStream stream_KW_BY=new RewriteRuleTokenStream(adaptor,"token KW_BY");
		RewriteRuleTokenStream stream_KW_AS=new RewriteRuleTokenStream(adaptor,"token KW_AS");
		RewriteRuleTokenStream stream_KW_RCFILE=new RewriteRuleTokenStream(adaptor,"token KW_RCFILE");
		RewriteRuleTokenStream stream_KW_INPUTFORMAT=new RewriteRuleTokenStream(adaptor,"token KW_INPUTFORMAT");
		RewriteRuleTokenStream stream_KW_STORED=new RewriteRuleTokenStream(adaptor,"token KW_STORED");
		RewriteRuleTokenStream stream_KW_OUTPUTDRIVER=new RewriteRuleTokenStream(adaptor,"token KW_OUTPUTDRIVER");
		RewriteRuleTokenStream stream_KW_SEQUENCEFILE=new RewriteRuleTokenStream(adaptor,"token KW_SEQUENCEFILE");
		RewriteRuleTokenStream stream_KW_WITH=new RewriteRuleTokenStream(adaptor,"token KW_WITH");
		RewriteRuleTokenStream stream_KW_SERDEPROPERTIES=new RewriteRuleTokenStream(adaptor,"token KW_SERDEPROPERTIES");
		RewriteRuleSubtreeStream stream_tableProperties=new RewriteRuleSubtreeStream(adaptor,"rule tableProperties");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("table file format specification"); 
		try {
			// HiveParser.g:1613:5: ( KW_STORED KW_AS KW_SEQUENCEFILE -> TOK_TBLSEQUENCEFILE | KW_STORED KW_AS KW_TEXTFILE -> TOK_TBLTEXTFILE | KW_STORED KW_AS KW_RCFILE -> TOK_TBLRCFILE | KW_STORED KW_AS KW_ORCFILE -> TOK_TBLORCFILE | KW_STORED KW_AS KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )? -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? ) | KW_STORED KW_BY storageHandler= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )? -> ^( TOK_STORAGEHANDLER $storageHandler ( $serdeprops)? ) | KW_STORED KW_AS genericSpec= identifier -> ^( TOK_FILEFORMAT_GENERIC $genericSpec) )
			int alt169=7;
			int LA169_0 = input.LA(1);
			if ( (LA169_0==KW_STORED) ) {
				int LA169_1 = input.LA(2);
				if ( (LA169_1==KW_AS) ) {
					switch ( input.LA(3) ) {
					case KW_SEQUENCEFILE:
						{
						alt169=1;
						}
						break;
					case KW_TEXTFILE:
						{
						alt169=2;
						}
						break;
					case KW_RCFILE:
						{
						alt169=3;
						}
						break;
					case KW_ORCFILE:
						{
						alt169=4;
						}
						break;
					case KW_INPUTFORMAT:
						{
						alt169=5;
						}
						break;
					case Identifier:
					case KW_ADD:
					case KW_AFTER:
					case KW_ALTER:
					case KW_ANALYZE:
					case KW_ARCHIVE:
					case KW_ARRAY:
					case KW_AS:
					case KW_ASC:
					case KW_BEFORE:
					case KW_BETWEEN:
					case KW_BIGINT:
					case KW_BINARY:
					case KW_BOOLEAN:
					case KW_BOTH:
					case KW_BUCKET:
					case KW_BUCKETS:
					case KW_BY:
					case KW_CASCADE:
					case KW_CHANGE:
					case KW_CLUSTER:
					case KW_CLUSTERED:
					case KW_CLUSTERSTATUS:
					case KW_COLLECTION:
					case KW_COLUMNS:
					case KW_COMMENT:
					case KW_COMPUTE:
					case KW_CONCATENATE:
					case KW_CONTINUE:
					case KW_CREATE:
					case KW_CUBE:
					case KW_CURSOR:
					case KW_DATA:
					case KW_DATABASES:
					case KW_DATE:
					case KW_DATETIME:
					case KW_DBPROPERTIES:
					case KW_DECIMAL:
					case KW_DEFERRED:
					case KW_DELETE:
					case KW_DELIMITED:
					case KW_DEPENDENCY:
					case KW_DESC:
					case KW_DESCRIBE:
					case KW_DIRECTORIES:
					case KW_DIRECTORY:
					case KW_DISABLE:
					case KW_DISTRIBUTE:
					case KW_DOUBLE:
					case KW_DROP:
					case KW_ELEM_TYPE:
					case KW_ENABLE:
					case KW_ESCAPED:
					case KW_EXCLUSIVE:
					case KW_EXISTS:
					case KW_EXPLAIN:
					case KW_EXPORT:
					case KW_EXTERNAL:
					case KW_FALSE:
					case KW_FETCH:
					case KW_FIELDS:
					case KW_FILEFORMAT:
					case KW_FIRST:
					case KW_FLOAT:
					case KW_FOR:
					case KW_FORMAT:
					case KW_FORMATTED:
					case KW_FULL:
					case KW_FUNCTIONS:
					case KW_GRANT:
					case KW_GROUP:
					case KW_GROUPING:
					case KW_HOLD_DDLTIME:
					case KW_IDXPROPERTIES:
					case KW_IGNORE:
					case KW_IMPORT:
					case KW_IN:
					case KW_INCRE:
					case KW_INDEX:
					case KW_INDEXES:
					case KW_INNER:
					case KW_INPATH:
					case KW_INPUTDRIVER:
					case KW_INSERT:
					case KW_INT:
					case KW_INTERSECT:
					case KW_INTO:
					case KW_IS:
					case KW_ITEMS:
					case KW_KEYS:
					case KW_KEY_TYPE:
					case KW_LATERAL:
					case KW_LEFT:
					case KW_LIKE:
					case KW_LIMIT:
					case KW_LINES:
					case KW_LOAD:
					case KW_LOCAL:
					case KW_LOCATION:
					case KW_LOCK:
					case KW_LOCKS:
					case KW_LOGICAL:
					case KW_LONG:
					case KW_MAPJOIN:
					case KW_MATERIALIZED:
					case KW_MINUS:
					case KW_MSCK:
					case KW_NOSCAN:
					case KW_NO_DROP:
					case KW_NULL:
					case KW_OF:
					case KW_OFFLINE:
					case KW_OPTION:
					case KW_ORDER:
					case KW_OUT:
					case KW_OUTER:
					case KW_OUTPUTDRIVER:
					case KW_OUTPUTFORMAT:
					case KW_OVERWRITE:
					case KW_PARTITION:
					case KW_PARTITIONED:
					case KW_PARTITIONS:
					case KW_PERCENT:
					case KW_PLUS:
					case KW_PRETTY:
					case KW_PROCEDURE:
					case KW_PROTECTION:
					case KW_PURGE:
					case KW_RANGE:
					case KW_READ:
					case KW_READONLY:
					case KW_READS:
					case KW_REBUILD:
					case KW_RECORDREADER:
					case KW_RECORDWRITER:
					case KW_REGEXP:
					case KW_RENAME:
					case KW_REPAIR:
					case KW_REPLACE:
					case KW_RESTRICT:
					case KW_REVOKE:
					case KW_RIGHT:
					case KW_RLIKE:
					case KW_ROLE:
					case KW_ROLLUP:
					case KW_ROW:
					case KW_ROWS:
					case KW_SCHEMA:
					case KW_SCHEMAS:
					case KW_SEMI:
					case KW_SERDE:
					case KW_SERDEPROPERTIES:
					case KW_SET:
					case KW_SETS:
					case KW_SHARED:
					case KW_SHOW:
					case KW_SHOW_DATABASE:
					case KW_SKEWED:
					case KW_SMALLINT:
					case KW_SORT:
					case KW_SORTED:
					case KW_SSL:
					case KW_STATISTICS:
					case KW_STORED:
					case KW_STREAMTABLE:
					case KW_STRING:
					case KW_STRUCT:
					case KW_TABLE:
					case KW_TABLES:
					case KW_TBLPROPERTIES:
					case KW_TEMPORARY:
					case KW_TERMINATED:
					case KW_TIMESTAMP:
					case KW_TINYINT:
					case KW_TO:
					case KW_TOUCH:
					case KW_TRIGGER:
					case KW_TRUE:
					case KW_TRUNCATE:
					case KW_UNARCHIVE:
					case KW_UNDO:
					case KW_UNION:
					case KW_UNIONTYPE:
					case KW_UNLOCK:
					case KW_UNSET:
					case KW_UNSIGNED:
					case KW_UPDATE:
					case KW_USE:
					case KW_USER:
					case KW_USING:
					case KW_UTC:
					case KW_UTCTIMESTAMP:
					case KW_VALUE_TYPE:
					case KW_VIEW:
					case KW_WHILE:
					case KW_WITH:
						{
						alt169=7;
						}
						break;
					default:
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 169, 2, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}
				}
				else if ( (LA169_1==KW_BY) ) {
					alt169=6;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 169, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 169, 0, input);
				throw nvae;
			}

			switch (alt169) {
				case 1 :
					// HiveParser.g:1614:7: KW_STORED KW_AS KW_SEQUENCEFILE
					{
					KW_STORED609=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9505);  
					stream_KW_STORED.add(KW_STORED609);

					KW_AS610=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9507);  
					stream_KW_AS.add(KW_AS610);

					KW_SEQUENCEFILE611=(Token)match(input,KW_SEQUENCEFILE,FOLLOW_KW_SEQUENCEFILE_in_tableFileFormat9509);  
					stream_KW_SEQUENCEFILE.add(KW_SEQUENCEFILE611);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1614:40: -> TOK_TBLSEQUENCEFILE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TBLSEQUENCEFILE, "TOK_TBLSEQUENCEFILE"));
					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1615:9: KW_STORED KW_AS KW_TEXTFILE
					{
					KW_STORED612=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9524);  
					stream_KW_STORED.add(KW_STORED612);

					KW_AS613=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9526);  
					stream_KW_AS.add(KW_AS613);

					KW_TEXTFILE614=(Token)match(input,KW_TEXTFILE,FOLLOW_KW_TEXTFILE_in_tableFileFormat9528);  
					stream_KW_TEXTFILE.add(KW_TEXTFILE614);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1615:38: -> TOK_TBLTEXTFILE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TBLTEXTFILE, "TOK_TBLTEXTFILE"));
					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1616:9: KW_STORED KW_AS KW_RCFILE
					{
					KW_STORED615=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9543);  
					stream_KW_STORED.add(KW_STORED615);

					KW_AS616=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9545);  
					stream_KW_AS.add(KW_AS616);

					KW_RCFILE617=(Token)match(input,KW_RCFILE,FOLLOW_KW_RCFILE_in_tableFileFormat9547);  
					stream_KW_RCFILE.add(KW_RCFILE617);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1616:36: -> TOK_TBLRCFILE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TBLRCFILE, "TOK_TBLRCFILE"));
					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:1617:9: KW_STORED KW_AS KW_ORCFILE
					{
					KW_STORED618=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9562);  
					stream_KW_STORED.add(KW_STORED618);

					KW_AS619=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9564);  
					stream_KW_AS.add(KW_AS619);

					KW_ORCFILE620=(Token)match(input,KW_ORCFILE,FOLLOW_KW_ORCFILE_in_tableFileFormat9566);  
					stream_KW_ORCFILE.add(KW_ORCFILE620);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1617:36: -> TOK_TBLORCFILE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TBLORCFILE, "TOK_TBLORCFILE"));
					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:1618:9: KW_STORED KW_AS KW_INPUTFORMAT inFmt= StringLiteral KW_OUTPUTFORMAT outFmt= StringLiteral ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )?
					{
					KW_STORED621=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9580);  
					stream_KW_STORED.add(KW_STORED621);

					KW_AS622=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9582);  
					stream_KW_AS.add(KW_AS622);

					KW_INPUTFORMAT623=(Token)match(input,KW_INPUTFORMAT,FOLLOW_KW_INPUTFORMAT_in_tableFileFormat9584);  
					stream_KW_INPUTFORMAT.add(KW_INPUTFORMAT623);

					inFmt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableFileFormat9588);  
					stream_StringLiteral.add(inFmt);

					KW_OUTPUTFORMAT624=(Token)match(input,KW_OUTPUTFORMAT,FOLLOW_KW_OUTPUTFORMAT_in_tableFileFormat9590);  
					stream_KW_OUTPUTFORMAT.add(KW_OUTPUTFORMAT624);

					outFmt=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableFileFormat9594);  
					stream_StringLiteral.add(outFmt);

					// HiveParser.g:1618:97: ( KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral )?
					int alt167=2;
					int LA167_0 = input.LA(1);
					if ( (LA167_0==KW_INPUTDRIVER) ) {
						alt167=1;
					}
					switch (alt167) {
						case 1 :
							// HiveParser.g:1618:98: KW_INPUTDRIVER inDriver= StringLiteral KW_OUTPUTDRIVER outDriver= StringLiteral
							{
							KW_INPUTDRIVER625=(Token)match(input,KW_INPUTDRIVER,FOLLOW_KW_INPUTDRIVER_in_tableFileFormat9597);  
							stream_KW_INPUTDRIVER.add(KW_INPUTDRIVER625);

							inDriver=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableFileFormat9601);  
							stream_StringLiteral.add(inDriver);

							KW_OUTPUTDRIVER626=(Token)match(input,KW_OUTPUTDRIVER,FOLLOW_KW_OUTPUTDRIVER_in_tableFileFormat9603);  
							stream_KW_OUTPUTDRIVER.add(KW_OUTPUTDRIVER626);

							outDriver=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableFileFormat9607);  
							stream_StringLiteral.add(outDriver);

							}
							break;

					}

					// AST REWRITE
					// elements: inDriver, outDriver, inFmt, outFmt
					// token labels: outDriver, outFmt, inDriver, inFmt
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_outDriver=new RewriteRuleTokenStream(adaptor,"token outDriver",outDriver);
					RewriteRuleTokenStream stream_outFmt=new RewriteRuleTokenStream(adaptor,"token outFmt",outFmt);
					RewriteRuleTokenStream stream_inDriver=new RewriteRuleTokenStream(adaptor,"token inDriver",inDriver);
					RewriteRuleTokenStream stream_inFmt=new RewriteRuleTokenStream(adaptor,"token inFmt",inFmt);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1619:7: -> ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? )
					{
						// HiveParser.g:1619:10: ^( TOK_TABLEFILEFORMAT $inFmt $outFmt ( $inDriver)? ( $outDriver)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLEFILEFORMAT, "TOK_TABLEFILEFORMAT"), root_1);
						adaptor.addChild(root_1, stream_inFmt.nextNode());
						adaptor.addChild(root_1, stream_outFmt.nextNode());
						// HiveParser.g:1619:48: ( $inDriver)?
						if ( stream_inDriver.hasNext() ) {
							adaptor.addChild(root_1, stream_inDriver.nextNode());
						}
						stream_inDriver.reset();

						// HiveParser.g:1619:59: ( $outDriver)?
						if ( stream_outDriver.hasNext() ) {
							adaptor.addChild(root_1, stream_outDriver.nextNode());
						}
						stream_outDriver.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 6 :
					// HiveParser.g:1620:9: KW_STORED KW_BY storageHandler= StringLiteral ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )?
					{
					KW_STORED627=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9645);  
					stream_KW_STORED.add(KW_STORED627);

					KW_BY628=(Token)match(input,KW_BY,FOLLOW_KW_BY_in_tableFileFormat9647);  
					stream_KW_BY.add(KW_BY628);

					storageHandler=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableFileFormat9651);  
					stream_StringLiteral.add(storageHandler);

					// HiveParser.g:1621:10: ( KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties )?
					int alt168=2;
					int LA168_0 = input.LA(1);
					if ( (LA168_0==KW_WITH) ) {
						alt168=1;
					}
					switch (alt168) {
						case 1 :
							// HiveParser.g:1621:11: KW_WITH KW_SERDEPROPERTIES serdeprops= tableProperties
							{
							KW_WITH629=(Token)match(input,KW_WITH,FOLLOW_KW_WITH_in_tableFileFormat9663);  
							stream_KW_WITH.add(KW_WITH629);

							KW_SERDEPROPERTIES630=(Token)match(input,KW_SERDEPROPERTIES,FOLLOW_KW_SERDEPROPERTIES_in_tableFileFormat9665);  
							stream_KW_SERDEPROPERTIES.add(KW_SERDEPROPERTIES630);

							pushFollow(FOLLOW_tableProperties_in_tableFileFormat9669);
							serdeprops=tableProperties();
							state._fsp--;

							stream_tableProperties.add(serdeprops.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: serdeprops, storageHandler
					// token labels: storageHandler
					// rule labels: serdeprops, retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_storageHandler=new RewriteRuleTokenStream(adaptor,"token storageHandler",storageHandler);
					RewriteRuleSubtreeStream stream_serdeprops=new RewriteRuleSubtreeStream(adaptor,"rule serdeprops",serdeprops!=null?serdeprops.getTree():null);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1622:7: -> ^( TOK_STORAGEHANDLER $storageHandler ( $serdeprops)? )
					{
						// HiveParser.g:1622:10: ^( TOK_STORAGEHANDLER $storageHandler ( $serdeprops)? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_STORAGEHANDLER, "TOK_STORAGEHANDLER"), root_1);
						adaptor.addChild(root_1, stream_storageHandler.nextNode());
						// HiveParser.g:1622:48: ( $serdeprops)?
						if ( stream_serdeprops.hasNext() ) {
							adaptor.addChild(root_1, stream_serdeprops.nextTree());
						}
						stream_serdeprops.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 7 :
					// HiveParser.g:1623:9: KW_STORED KW_AS genericSpec= identifier
					{
					KW_STORED631=(Token)match(input,KW_STORED,FOLLOW_KW_STORED_in_tableFileFormat9700);  
					stream_KW_STORED.add(KW_STORED631);

					KW_AS632=(Token)match(input,KW_AS,FOLLOW_KW_AS_in_tableFileFormat9702);  
					stream_KW_AS.add(KW_AS632);

					pushFollow(FOLLOW_identifier_in_tableFileFormat9706);
					genericSpec=identifier();
					state._fsp--;

					stream_identifier.add(genericSpec.getTree());
					// AST REWRITE
					// elements: genericSpec
					// token labels: 
					// rule labels: retval, genericSpec
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
					RewriteRuleSubtreeStream stream_genericSpec=new RewriteRuleSubtreeStream(adaptor,"rule genericSpec",genericSpec!=null?genericSpec.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1624:7: -> ^( TOK_FILEFORMAT_GENERIC $genericSpec)
					{
						// HiveParser.g:1624:10: ^( TOK_FILEFORMAT_GENERIC $genericSpec)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_FILEFORMAT_GENERIC, "TOK_FILEFORMAT_GENERIC"), root_1);
						adaptor.addChild(root_1, stream_genericSpec.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableFileFormat"


	public static class tableLocation_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "tableLocation"
	// HiveParser.g:1627:1: tableLocation : KW_LOCATION locn= StringLiteral -> ^( TOK_TABLELOCATION $locn) ;
	public final HiveParser.tableLocation_return tableLocation() throws RecognitionException {
		HiveParser.tableLocation_return retval = new HiveParser.tableLocation_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token locn=null;
		Token KW_LOCATION633=null;

		CommonTree locn_tree=null;
		CommonTree KW_LOCATION633_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_LOCATION=new RewriteRuleTokenStream(adaptor,"token KW_LOCATION");

		 msgs.push("table location specification"); 
		try {
			// HiveParser.g:1630:5: ( KW_LOCATION locn= StringLiteral -> ^( TOK_TABLELOCATION $locn) )
			// HiveParser.g:1631:7: KW_LOCATION locn= StringLiteral
			{
			KW_LOCATION633=(Token)match(input,KW_LOCATION,FOLLOW_KW_LOCATION_in_tableLocation9754);  
			stream_KW_LOCATION.add(KW_LOCATION633);

			locn=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_tableLocation9758);  
			stream_StringLiteral.add(locn);

			// AST REWRITE
			// elements: locn
			// token labels: locn
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_locn=new RewriteRuleTokenStream(adaptor,"token locn",locn);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1631:38: -> ^( TOK_TABLELOCATION $locn)
			{
				// HiveParser.g:1631:41: ^( TOK_TABLELOCATION $locn)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABLELOCATION, "TOK_TABLELOCATION"), root_1);
				adaptor.addChild(root_1, stream_locn.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "tableLocation"


	public static class columnNameTypeList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameTypeList"
	// HiveParser.g:1634:1: columnNameTypeList : columnNameType ( COMMA columnNameType )* -> ^( TOK_TABCOLLIST ( columnNameType )+ ) ;
	public final HiveParser.columnNameTypeList_return columnNameTypeList() throws RecognitionException {
		HiveParser.columnNameTypeList_return retval = new HiveParser.columnNameTypeList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA635=null;
		ParserRuleReturnScope columnNameType634 =null;
		ParserRuleReturnScope columnNameType636 =null;

		CommonTree COMMA635_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_columnNameType=new RewriteRuleSubtreeStream(adaptor,"rule columnNameType");

		 msgs.push("column name type list"); 
		try {
			// HiveParser.g:1637:5: ( columnNameType ( COMMA columnNameType )* -> ^( TOK_TABCOLLIST ( columnNameType )+ ) )
			// HiveParser.g:1637:7: columnNameType ( COMMA columnNameType )*
			{
			pushFollow(FOLLOW_columnNameType_in_columnNameTypeList9794);
			columnNameType634=columnNameType();
			state._fsp--;

			stream_columnNameType.add(columnNameType634.getTree());
			// HiveParser.g:1637:22: ( COMMA columnNameType )*
			loop170:
			while (true) {
				int alt170=2;
				int LA170_0 = input.LA(1);
				if ( (LA170_0==COMMA) ) {
					alt170=1;
				}

				switch (alt170) {
				case 1 :
					// HiveParser.g:1637:23: COMMA columnNameType
					{
					COMMA635=(Token)match(input,COMMA,FOLLOW_COMMA_in_columnNameTypeList9797);  
					stream_COMMA.add(COMMA635);

					pushFollow(FOLLOW_columnNameType_in_columnNameTypeList9799);
					columnNameType636=columnNameType();
					state._fsp--;

					stream_columnNameType.add(columnNameType636.getTree());
					}
					break;

				default :
					break loop170;
				}
			}

			// AST REWRITE
			// elements: columnNameType
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1637:46: -> ^( TOK_TABCOLLIST ( columnNameType )+ )
			{
				// HiveParser.g:1637:49: ^( TOK_TABCOLLIST ( columnNameType )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLLIST, "TOK_TABCOLLIST"), root_1);
				if ( !(stream_columnNameType.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_columnNameType.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameType.nextTree());
				}
				stream_columnNameType.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameTypeList"


	public static class columnNameColonTypeList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameColonTypeList"
	// HiveParser.g:1640:1: columnNameColonTypeList : columnNameColonType ( COMMA columnNameColonType )* -> ^( TOK_TABCOLLIST ( columnNameColonType )+ ) ;
	public final HiveParser.columnNameColonTypeList_return columnNameColonTypeList() throws RecognitionException {
		HiveParser.columnNameColonTypeList_return retval = new HiveParser.columnNameColonTypeList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA638=null;
		ParserRuleReturnScope columnNameColonType637 =null;
		ParserRuleReturnScope columnNameColonType639 =null;

		CommonTree COMMA638_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_columnNameColonType=new RewriteRuleSubtreeStream(adaptor,"rule columnNameColonType");

		 msgs.push("column name type list"); 
		try {
			// HiveParser.g:1643:5: ( columnNameColonType ( COMMA columnNameColonType )* -> ^( TOK_TABCOLLIST ( columnNameColonType )+ ) )
			// HiveParser.g:1643:7: columnNameColonType ( COMMA columnNameColonType )*
			{
			pushFollow(FOLLOW_columnNameColonType_in_columnNameColonTypeList9837);
			columnNameColonType637=columnNameColonType();
			state._fsp--;

			stream_columnNameColonType.add(columnNameColonType637.getTree());
			// HiveParser.g:1643:27: ( COMMA columnNameColonType )*
			loop171:
			while (true) {
				int alt171=2;
				int LA171_0 = input.LA(1);
				if ( (LA171_0==COMMA) ) {
					alt171=1;
				}

				switch (alt171) {
				case 1 :
					// HiveParser.g:1643:28: COMMA columnNameColonType
					{
					COMMA638=(Token)match(input,COMMA,FOLLOW_COMMA_in_columnNameColonTypeList9840);  
					stream_COMMA.add(COMMA638);

					pushFollow(FOLLOW_columnNameColonType_in_columnNameColonTypeList9842);
					columnNameColonType639=columnNameColonType();
					state._fsp--;

					stream_columnNameColonType.add(columnNameColonType639.getTree());
					}
					break;

				default :
					break loop171;
				}
			}

			// AST REWRITE
			// elements: columnNameColonType
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1643:56: -> ^( TOK_TABCOLLIST ( columnNameColonType )+ )
			{
				// HiveParser.g:1643:59: ^( TOK_TABCOLLIST ( columnNameColonType )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLLIST, "TOK_TABCOLLIST"), root_1);
				if ( !(stream_columnNameColonType.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_columnNameColonType.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameColonType.nextTree());
				}
				stream_columnNameColonType.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameColonTypeList"


	public static class columnNameList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameList"
	// HiveParser.g:1646:1: columnNameList : columnName ( COMMA columnName )* -> ^( TOK_TABCOLNAME ( columnName )+ ) ;
	public final HiveParser.columnNameList_return columnNameList() throws RecognitionException {
		HiveParser.columnNameList_return retval = new HiveParser.columnNameList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA641=null;
		ParserRuleReturnScope columnName640 =null;
		ParserRuleReturnScope columnName642 =null;

		CommonTree COMMA641_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_columnName=new RewriteRuleSubtreeStream(adaptor,"rule columnName");

		 msgs.push("column name list"); 
		try {
			// HiveParser.g:1649:5: ( columnName ( COMMA columnName )* -> ^( TOK_TABCOLNAME ( columnName )+ ) )
			// HiveParser.g:1649:7: columnName ( COMMA columnName )*
			{
			pushFollow(FOLLOW_columnName_in_columnNameList9880);
			columnName640=columnName();
			state._fsp--;

			stream_columnName.add(columnName640.getTree());
			// HiveParser.g:1649:18: ( COMMA columnName )*
			loop172:
			while (true) {
				int alt172=2;
				int LA172_0 = input.LA(1);
				if ( (LA172_0==COMMA) ) {
					alt172=1;
				}

				switch (alt172) {
				case 1 :
					// HiveParser.g:1649:19: COMMA columnName
					{
					COMMA641=(Token)match(input,COMMA,FOLLOW_COMMA_in_columnNameList9883);  
					stream_COMMA.add(COMMA641);

					pushFollow(FOLLOW_columnName_in_columnNameList9885);
					columnName642=columnName();
					state._fsp--;

					stream_columnName.add(columnName642.getTree());
					}
					break;

				default :
					break loop172;
				}
			}

			// AST REWRITE
			// elements: columnName
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1649:38: -> ^( TOK_TABCOLNAME ( columnName )+ )
			{
				// HiveParser.g:1649:41: ^( TOK_TABCOLNAME ( columnName )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLNAME, "TOK_TABCOLNAME"), root_1);
				if ( !(stream_columnName.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_columnName.hasNext() ) {
					adaptor.addChild(root_1, stream_columnName.nextTree());
				}
				stream_columnName.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameList"


	public static class columnName_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnName"
	// HiveParser.g:1652:1: columnName : identifier ;
	public final HiveParser.columnName_return columnName() throws RecognitionException {
		HiveParser.columnName_return retval = new HiveParser.columnName_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope identifier643 =null;


		 msgs.push("column name"); 
		try {
			// HiveParser.g:1655:5: ( identifier )
			// HiveParser.g:1656:7: identifier
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_identifier_in_columnName9929);
			identifier643=identifier();
			state._fsp--;

			adaptor.addChild(root_0, identifier643.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnName"


	public static class columnNameOrderList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameOrderList"
	// HiveParser.g:1659:1: columnNameOrderList : columnNameOrder ( COMMA columnNameOrder )* -> ^( TOK_TABCOLNAME ( columnNameOrder )+ ) ;
	public final HiveParser.columnNameOrderList_return columnNameOrderList() throws RecognitionException {
		HiveParser.columnNameOrderList_return retval = new HiveParser.columnNameOrderList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA645=null;
		ParserRuleReturnScope columnNameOrder644 =null;
		ParserRuleReturnScope columnNameOrder646 =null;

		CommonTree COMMA645_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_columnNameOrder=new RewriteRuleSubtreeStream(adaptor,"rule columnNameOrder");

		 msgs.push("column name order list"); 
		try {
			// HiveParser.g:1662:5: ( columnNameOrder ( COMMA columnNameOrder )* -> ^( TOK_TABCOLNAME ( columnNameOrder )+ ) )
			// HiveParser.g:1662:7: columnNameOrder ( COMMA columnNameOrder )*
			{
			pushFollow(FOLLOW_columnNameOrder_in_columnNameOrderList9956);
			columnNameOrder644=columnNameOrder();
			state._fsp--;

			stream_columnNameOrder.add(columnNameOrder644.getTree());
			// HiveParser.g:1662:23: ( COMMA columnNameOrder )*
			loop173:
			while (true) {
				int alt173=2;
				int LA173_0 = input.LA(1);
				if ( (LA173_0==COMMA) ) {
					alt173=1;
				}

				switch (alt173) {
				case 1 :
					// HiveParser.g:1662:24: COMMA columnNameOrder
					{
					COMMA645=(Token)match(input,COMMA,FOLLOW_COMMA_in_columnNameOrderList9959);  
					stream_COMMA.add(COMMA645);

					pushFollow(FOLLOW_columnNameOrder_in_columnNameOrderList9961);
					columnNameOrder646=columnNameOrder();
					state._fsp--;

					stream_columnNameOrder.add(columnNameOrder646.getTree());
					}
					break;

				default :
					break loop173;
				}
			}

			// AST REWRITE
			// elements: columnNameOrder
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1662:48: -> ^( TOK_TABCOLNAME ( columnNameOrder )+ )
			{
				// HiveParser.g:1662:51: ^( TOK_TABCOLNAME ( columnNameOrder )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLNAME, "TOK_TABCOLNAME"), root_1);
				if ( !(stream_columnNameOrder.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_columnNameOrder.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameOrder.nextTree());
				}
				stream_columnNameOrder.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameOrderList"


	public static class skewedValueElement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedValueElement"
	// HiveParser.g:1665:1: skewedValueElement : ( skewedColumnValues | skewedColumnValuePairList );
	public final HiveParser.skewedValueElement_return skewedValueElement() throws RecognitionException {
		HiveParser.skewedValueElement_return retval = new HiveParser.skewedValueElement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope skewedColumnValues647 =null;
		ParserRuleReturnScope skewedColumnValuePairList648 =null;


		 msgs.push("skewed value element"); 
		try {
			// HiveParser.g:1668:5: ( skewedColumnValues | skewedColumnValuePairList )
			int alt174=2;
			int LA174_0 = input.LA(1);
			if ( (LA174_0==BigintLiteral||LA174_0==CharSetName||LA174_0==DecimalLiteral||LA174_0==KW_DATE||LA174_0==KW_FALSE||LA174_0==KW_TRUE||LA174_0==Number||(LA174_0 >= SmallintLiteral && LA174_0 <= StringLiteral)||(LA174_0 >= TimeUnit && LA174_0 <= TinyintLiteral)) ) {
				alt174=1;
			}
			else if ( (LA174_0==LPAREN) ) {
				alt174=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 174, 0, input);
				throw nvae;
			}

			switch (alt174) {
				case 1 :
					// HiveParser.g:1669:7: skewedColumnValues
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_skewedColumnValues_in_skewedValueElement10006);
					skewedColumnValues647=skewedColumnValues();
					state._fsp--;

					adaptor.addChild(root_0, skewedColumnValues647.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:1670:8: skewedColumnValuePairList
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_skewedColumnValuePairList_in_skewedValueElement10015);
					skewedColumnValuePairList648=skewedColumnValuePairList();
					state._fsp--;

					adaptor.addChild(root_0, skewedColumnValuePairList648.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedValueElement"


	public static class skewedColumnValuePairList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedColumnValuePairList"
	// HiveParser.g:1673:1: skewedColumnValuePairList : skewedColumnValuePair ( COMMA skewedColumnValuePair )* -> ^( TOK_TABCOLVALUE_PAIR ( skewedColumnValuePair )+ ) ;
	public final HiveParser.skewedColumnValuePairList_return skewedColumnValuePairList() throws RecognitionException {
		HiveParser.skewedColumnValuePairList_return retval = new HiveParser.skewedColumnValuePairList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA650=null;
		ParserRuleReturnScope skewedColumnValuePair649 =null;
		ParserRuleReturnScope skewedColumnValuePair651 =null;

		CommonTree COMMA650_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_skewedColumnValuePair=new RewriteRuleSubtreeStream(adaptor,"rule skewedColumnValuePair");

		 msgs.push("column value pair list"); 
		try {
			// HiveParser.g:1676:5: ( skewedColumnValuePair ( COMMA skewedColumnValuePair )* -> ^( TOK_TABCOLVALUE_PAIR ( skewedColumnValuePair )+ ) )
			// HiveParser.g:1676:7: skewedColumnValuePair ( COMMA skewedColumnValuePair )*
			{
			pushFollow(FOLLOW_skewedColumnValuePair_in_skewedColumnValuePairList10042);
			skewedColumnValuePair649=skewedColumnValuePair();
			state._fsp--;

			stream_skewedColumnValuePair.add(skewedColumnValuePair649.getTree());
			// HiveParser.g:1676:29: ( COMMA skewedColumnValuePair )*
			loop175:
			while (true) {
				int alt175=2;
				int LA175_0 = input.LA(1);
				if ( (LA175_0==COMMA) ) {
					alt175=1;
				}

				switch (alt175) {
				case 1 :
					// HiveParser.g:1676:30: COMMA skewedColumnValuePair
					{
					COMMA650=(Token)match(input,COMMA,FOLLOW_COMMA_in_skewedColumnValuePairList10045);  
					stream_COMMA.add(COMMA650);

					pushFollow(FOLLOW_skewedColumnValuePair_in_skewedColumnValuePairList10047);
					skewedColumnValuePair651=skewedColumnValuePair();
					state._fsp--;

					stream_skewedColumnValuePair.add(skewedColumnValuePair651.getTree());
					}
					break;

				default :
					break loop175;
				}
			}

			// AST REWRITE
			// elements: skewedColumnValuePair
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1676:60: -> ^( TOK_TABCOLVALUE_PAIR ( skewedColumnValuePair )+ )
			{
				// HiveParser.g:1676:63: ^( TOK_TABCOLVALUE_PAIR ( skewedColumnValuePair )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLVALUE_PAIR, "TOK_TABCOLVALUE_PAIR"), root_1);
				if ( !(stream_skewedColumnValuePair.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_skewedColumnValuePair.hasNext() ) {
					adaptor.addChild(root_1, stream_skewedColumnValuePair.nextTree());
				}
				stream_skewedColumnValuePair.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedColumnValuePairList"


	public static class skewedColumnValuePair_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedColumnValuePair"
	// HiveParser.g:1679:1: skewedColumnValuePair : LPAREN colValues= skewedColumnValues RPAREN -> ^( TOK_TABCOLVALUES $colValues) ;
	public final HiveParser.skewedColumnValuePair_return skewedColumnValuePair() throws RecognitionException {
		HiveParser.skewedColumnValuePair_return retval = new HiveParser.skewedColumnValuePair_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token LPAREN652=null;
		Token RPAREN653=null;
		ParserRuleReturnScope colValues =null;

		CommonTree LPAREN652_tree=null;
		CommonTree RPAREN653_tree=null;
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleSubtreeStream stream_skewedColumnValues=new RewriteRuleSubtreeStream(adaptor,"rule skewedColumnValues");

		 msgs.push("column value pair"); 
		try {
			// HiveParser.g:1682:5: ( LPAREN colValues= skewedColumnValues RPAREN -> ^( TOK_TABCOLVALUES $colValues) )
			// HiveParser.g:1683:7: LPAREN colValues= skewedColumnValues RPAREN
			{
			LPAREN652=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_skewedColumnValuePair10092);  
			stream_LPAREN.add(LPAREN652);

			pushFollow(FOLLOW_skewedColumnValues_in_skewedColumnValuePair10096);
			colValues=skewedColumnValues();
			state._fsp--;

			stream_skewedColumnValues.add(colValues.getTree());
			RPAREN653=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_skewedColumnValuePair10098);  
			stream_RPAREN.add(RPAREN653);

			// AST REWRITE
			// elements: colValues
			// token labels: 
			// rule labels: retval, colValues
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_colValues=new RewriteRuleSubtreeStream(adaptor,"rule colValues",colValues!=null?colValues.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1684:7: -> ^( TOK_TABCOLVALUES $colValues)
			{
				// HiveParser.g:1684:10: ^( TOK_TABCOLVALUES $colValues)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLVALUES, "TOK_TABCOLVALUES"), root_1);
				adaptor.addChild(root_1, stream_colValues.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedColumnValuePair"


	public static class skewedColumnValues_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedColumnValues"
	// HiveParser.g:1687:1: skewedColumnValues : skewedColumnValue ( COMMA skewedColumnValue )* -> ^( TOK_TABCOLVALUE ( skewedColumnValue )+ ) ;
	public final HiveParser.skewedColumnValues_return skewedColumnValues() throws RecognitionException {
		HiveParser.skewedColumnValues_return retval = new HiveParser.skewedColumnValues_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA655=null;
		ParserRuleReturnScope skewedColumnValue654 =null;
		ParserRuleReturnScope skewedColumnValue656 =null;

		CommonTree COMMA655_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_skewedColumnValue=new RewriteRuleSubtreeStream(adaptor,"rule skewedColumnValue");

		 msgs.push("column values"); 
		try {
			// HiveParser.g:1690:5: ( skewedColumnValue ( COMMA skewedColumnValue )* -> ^( TOK_TABCOLVALUE ( skewedColumnValue )+ ) )
			// HiveParser.g:1690:7: skewedColumnValue ( COMMA skewedColumnValue )*
			{
			pushFollow(FOLLOW_skewedColumnValue_in_skewedColumnValues10141);
			skewedColumnValue654=skewedColumnValue();
			state._fsp--;

			stream_skewedColumnValue.add(skewedColumnValue654.getTree());
			// HiveParser.g:1690:25: ( COMMA skewedColumnValue )*
			loop176:
			while (true) {
				int alt176=2;
				int LA176_0 = input.LA(1);
				if ( (LA176_0==COMMA) ) {
					alt176=1;
				}

				switch (alt176) {
				case 1 :
					// HiveParser.g:1690:26: COMMA skewedColumnValue
					{
					COMMA655=(Token)match(input,COMMA,FOLLOW_COMMA_in_skewedColumnValues10144);  
					stream_COMMA.add(COMMA655);

					pushFollow(FOLLOW_skewedColumnValue_in_skewedColumnValues10146);
					skewedColumnValue656=skewedColumnValue();
					state._fsp--;

					stream_skewedColumnValue.add(skewedColumnValue656.getTree());
					}
					break;

				default :
					break loop176;
				}
			}

			// AST REWRITE
			// elements: skewedColumnValue
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1690:52: -> ^( TOK_TABCOLVALUE ( skewedColumnValue )+ )
			{
				// HiveParser.g:1690:55: ^( TOK_TABCOLVALUE ( skewedColumnValue )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLVALUE, "TOK_TABCOLVALUE"), root_1);
				if ( !(stream_skewedColumnValue.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_skewedColumnValue.hasNext() ) {
					adaptor.addChild(root_1, stream_skewedColumnValue.nextTree());
				}
				stream_skewedColumnValue.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedColumnValues"


	public static class skewedColumnValue_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedColumnValue"
	// HiveParser.g:1693:1: skewedColumnValue : constant ;
	public final HiveParser.skewedColumnValue_return skewedColumnValue() throws RecognitionException {
		HiveParser.skewedColumnValue_return retval = new HiveParser.skewedColumnValue_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope constant657 =null;


		 msgs.push("column value"); 
		try {
			// HiveParser.g:1696:5: ( constant )
			// HiveParser.g:1697:7: constant
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_constant_in_skewedColumnValue10190);
			constant657=constant();
			state._fsp--;

			adaptor.addChild(root_0, constant657.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedColumnValue"


	public static class skewedValueLocationElement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "skewedValueLocationElement"
	// HiveParser.g:1700:1: skewedValueLocationElement : ( skewedColumnValue | skewedColumnValuePair );
	public final HiveParser.skewedValueLocationElement_return skewedValueLocationElement() throws RecognitionException {
		HiveParser.skewedValueLocationElement_return retval = new HiveParser.skewedValueLocationElement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope skewedColumnValue658 =null;
		ParserRuleReturnScope skewedColumnValuePair659 =null;


		 msgs.push("skewed value location element"); 
		try {
			// HiveParser.g:1703:5: ( skewedColumnValue | skewedColumnValuePair )
			int alt177=2;
			int LA177_0 = input.LA(1);
			if ( (LA177_0==BigintLiteral||LA177_0==CharSetName||LA177_0==DecimalLiteral||LA177_0==KW_DATE||LA177_0==KW_FALSE||LA177_0==KW_TRUE||LA177_0==Number||(LA177_0 >= SmallintLiteral && LA177_0 <= StringLiteral)||(LA177_0 >= TimeUnit && LA177_0 <= TinyintLiteral)) ) {
				alt177=1;
			}
			else if ( (LA177_0==LPAREN) ) {
				alt177=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 177, 0, input);
				throw nvae;
			}

			switch (alt177) {
				case 1 :
					// HiveParser.g:1704:7: skewedColumnValue
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_skewedColumnValue_in_skewedValueLocationElement10224);
					skewedColumnValue658=skewedColumnValue();
					state._fsp--;

					adaptor.addChild(root_0, skewedColumnValue658.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:1705:8: skewedColumnValuePair
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_skewedColumnValuePair_in_skewedValueLocationElement10233);
					skewedColumnValuePair659=skewedColumnValuePair();
					state._fsp--;

					adaptor.addChild(root_0, skewedColumnValuePair659.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "skewedValueLocationElement"


	public static class columnNameOrder_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameOrder"
	// HiveParser.g:1708:1: columnNameOrder : identifier (asc= KW_ASC |desc= KW_DESC )? -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC identifier ) -> ^( TOK_TABSORTCOLNAMEDESC identifier ) ;
	public final HiveParser.columnNameOrder_return columnNameOrder() throws RecognitionException {
		HiveParser.columnNameOrder_return retval = new HiveParser.columnNameOrder_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token asc=null;
		Token desc=null;
		ParserRuleReturnScope identifier660 =null;

		CommonTree asc_tree=null;
		CommonTree desc_tree=null;
		RewriteRuleTokenStream stream_KW_DESC=new RewriteRuleTokenStream(adaptor,"token KW_DESC");
		RewriteRuleTokenStream stream_KW_ASC=new RewriteRuleTokenStream(adaptor,"token KW_ASC");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("column name order"); 
		try {
			// HiveParser.g:1711:5: ( identifier (asc= KW_ASC |desc= KW_DESC )? -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC identifier ) -> ^( TOK_TABSORTCOLNAMEDESC identifier ) )
			// HiveParser.g:1711:7: identifier (asc= KW_ASC |desc= KW_DESC )?
			{
			pushFollow(FOLLOW_identifier_in_columnNameOrder10264);
			identifier660=identifier();
			state._fsp--;

			stream_identifier.add(identifier660.getTree());
			// HiveParser.g:1711:18: (asc= KW_ASC |desc= KW_DESC )?
			int alt178=3;
			int LA178_0 = input.LA(1);
			if ( (LA178_0==KW_ASC) ) {
				alt178=1;
			}
			else if ( (LA178_0==KW_DESC) ) {
				alt178=2;
			}
			switch (alt178) {
				case 1 :
					// HiveParser.g:1711:19: asc= KW_ASC
					{
					asc=(Token)match(input,KW_ASC,FOLLOW_KW_ASC_in_columnNameOrder10269);  
					stream_KW_ASC.add(asc);

					}
					break;
				case 2 :
					// HiveParser.g:1711:32: desc= KW_DESC
					{
					desc=(Token)match(input,KW_DESC,FOLLOW_KW_DESC_in_columnNameOrder10275);  
					stream_KW_DESC.add(desc);

					}
					break;

			}

			// AST REWRITE
			// elements: identifier, identifier
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1712:5: -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC identifier )
			if (desc == null) {
				// HiveParser.g:1712:25: ^( TOK_TABSORTCOLNAMEASC identifier )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABSORTCOLNAMEASC, "TOK_TABSORTCOLNAMEASC"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}

			else // 1713:5: -> ^( TOK_TABSORTCOLNAMEDESC identifier )
			{
				// HiveParser.g:1713:25: ^( TOK_TABSORTCOLNAMEDESC identifier )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABSORTCOLNAMEDESC, "TOK_TABSORTCOLNAMEDESC"), root_1);
				adaptor.addChild(root_1, stream_identifier.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameOrder"


	public static class columnNameCommentList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameCommentList"
	// HiveParser.g:1716:1: columnNameCommentList : columnNameComment ( COMMA columnNameComment )* -> ^( TOK_TABCOLNAME ( columnNameComment )+ ) ;
	public final HiveParser.columnNameCommentList_return columnNameCommentList() throws RecognitionException {
		HiveParser.columnNameCommentList_return retval = new HiveParser.columnNameCommentList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA662=null;
		ParserRuleReturnScope columnNameComment661 =null;
		ParserRuleReturnScope columnNameComment663 =null;

		CommonTree COMMA662_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_columnNameComment=new RewriteRuleSubtreeStream(adaptor,"rule columnNameComment");

		 msgs.push("column name comment list"); 
		try {
			// HiveParser.g:1719:5: ( columnNameComment ( COMMA columnNameComment )* -> ^( TOK_TABCOLNAME ( columnNameComment )+ ) )
			// HiveParser.g:1719:7: columnNameComment ( COMMA columnNameComment )*
			{
			pushFollow(FOLLOW_columnNameComment_in_columnNameCommentList10347);
			columnNameComment661=columnNameComment();
			state._fsp--;

			stream_columnNameComment.add(columnNameComment661.getTree());
			// HiveParser.g:1719:25: ( COMMA columnNameComment )*
			loop179:
			while (true) {
				int alt179=2;
				int LA179_0 = input.LA(1);
				if ( (LA179_0==COMMA) ) {
					alt179=1;
				}

				switch (alt179) {
				case 1 :
					// HiveParser.g:1719:26: COMMA columnNameComment
					{
					COMMA662=(Token)match(input,COMMA,FOLLOW_COMMA_in_columnNameCommentList10350);  
					stream_COMMA.add(COMMA662);

					pushFollow(FOLLOW_columnNameComment_in_columnNameCommentList10352);
					columnNameComment663=columnNameComment();
					state._fsp--;

					stream_columnNameComment.add(columnNameComment663.getTree());
					}
					break;

				default :
					break loop179;
				}
			}

			// AST REWRITE
			// elements: columnNameComment
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1719:52: -> ^( TOK_TABCOLNAME ( columnNameComment )+ )
			{
				// HiveParser.g:1719:55: ^( TOK_TABCOLNAME ( columnNameComment )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOLNAME, "TOK_TABCOLNAME"), root_1);
				if ( !(stream_columnNameComment.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_columnNameComment.hasNext() ) {
					adaptor.addChild(root_1, stream_columnNameComment.nextTree());
				}
				stream_columnNameComment.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameCommentList"


	public static class columnNameComment_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameComment"
	// HiveParser.g:1722:1: columnNameComment : colName= identifier ( KW_COMMENT comment= StringLiteral )? -> ^( TOK_TABCOL $colName TOK_NULL ( $comment)? ) ;
	public final HiveParser.columnNameComment_return columnNameComment() throws RecognitionException {
		HiveParser.columnNameComment_return retval = new HiveParser.columnNameComment_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_COMMENT664=null;
		ParserRuleReturnScope colName =null;

		CommonTree comment_tree=null;
		CommonTree KW_COMMENT664_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("column name comment"); 
		try {
			// HiveParser.g:1725:5: (colName= identifier ( KW_COMMENT comment= StringLiteral )? -> ^( TOK_TABCOL $colName TOK_NULL ( $comment)? ) )
			// HiveParser.g:1725:7: colName= identifier ( KW_COMMENT comment= StringLiteral )?
			{
			pushFollow(FOLLOW_identifier_in_columnNameComment10392);
			colName=identifier();
			state._fsp--;

			stream_identifier.add(colName.getTree());
			// HiveParser.g:1725:26: ( KW_COMMENT comment= StringLiteral )?
			int alt180=2;
			int LA180_0 = input.LA(1);
			if ( (LA180_0==KW_COMMENT) ) {
				alt180=1;
			}
			switch (alt180) {
				case 1 :
					// HiveParser.g:1725:27: KW_COMMENT comment= StringLiteral
					{
					KW_COMMENT664=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_columnNameComment10395);  
					stream_KW_COMMENT.add(KW_COMMENT664);

					comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_columnNameComment10399);  
					stream_StringLiteral.add(comment);

					}
					break;

			}

			// AST REWRITE
			// elements: comment, colName
			// token labels: comment
			// rule labels: retval, colName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_colName=new RewriteRuleSubtreeStream(adaptor,"rule colName",colName!=null?colName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1726:5: -> ^( TOK_TABCOL $colName TOK_NULL ( $comment)? )
			{
				// HiveParser.g:1726:8: ^( TOK_TABCOL $colName TOK_NULL ( $comment)? )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOL, "TOK_TABCOL"), root_1);
				adaptor.addChild(root_1, stream_colName.nextTree());
				adaptor.addChild(root_1, (CommonTree)adaptor.create(TOK_NULL, "TOK_NULL"));
				// HiveParser.g:1726:40: ( $comment)?
				if ( stream_comment.hasNext() ) {
					adaptor.addChild(root_1, stream_comment.nextNode());
				}
				stream_comment.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameComment"


	public static class columnRefOrder_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnRefOrder"
	// HiveParser.g:1729:1: columnRefOrder : expression (asc= KW_ASC |desc= KW_DESC )? -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC expression ) -> ^( TOK_TABSORTCOLNAMEDESC expression ) ;
	public final HiveParser.columnRefOrder_return columnRefOrder() throws RecognitionException {
		HiveParser.columnRefOrder_return retval = new HiveParser.columnRefOrder_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token asc=null;
		Token desc=null;
		ParserRuleReturnScope expression665 =null;

		CommonTree asc_tree=null;
		CommonTree desc_tree=null;
		RewriteRuleTokenStream stream_KW_DESC=new RewriteRuleTokenStream(adaptor,"token KW_DESC");
		RewriteRuleTokenStream stream_KW_ASC=new RewriteRuleTokenStream(adaptor,"token KW_ASC");
		RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");

		 msgs.push("column order"); 
		try {
			// HiveParser.g:1732:5: ( expression (asc= KW_ASC |desc= KW_DESC )? -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC expression ) -> ^( TOK_TABSORTCOLNAMEDESC expression ) )
			// HiveParser.g:1732:7: expression (asc= KW_ASC |desc= KW_DESC )?
			{
			pushFollow(FOLLOW_expression_in_columnRefOrder10447);
			expression665=expression();
			state._fsp--;

			stream_expression.add(expression665.getTree());
			// HiveParser.g:1732:18: (asc= KW_ASC |desc= KW_DESC )?
			int alt181=3;
			int LA181_0 = input.LA(1);
			if ( (LA181_0==KW_ASC) ) {
				alt181=1;
			}
			else if ( (LA181_0==KW_DESC) ) {
				alt181=2;
			}
			switch (alt181) {
				case 1 :
					// HiveParser.g:1732:19: asc= KW_ASC
					{
					asc=(Token)match(input,KW_ASC,FOLLOW_KW_ASC_in_columnRefOrder10452);  
					stream_KW_ASC.add(asc);

					}
					break;
				case 2 :
					// HiveParser.g:1732:32: desc= KW_DESC
					{
					desc=(Token)match(input,KW_DESC,FOLLOW_KW_DESC_in_columnRefOrder10458);  
					stream_KW_DESC.add(desc);

					}
					break;

			}

			// AST REWRITE
			// elements: expression, expression
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1733:5: -> {$desc == null}? ^( TOK_TABSORTCOLNAMEASC expression )
			if (desc == null) {
				// HiveParser.g:1733:25: ^( TOK_TABSORTCOLNAMEASC expression )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABSORTCOLNAMEASC, "TOK_TABSORTCOLNAMEASC"), root_1);
				adaptor.addChild(root_1, stream_expression.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}

			else // 1734:5: -> ^( TOK_TABSORTCOLNAMEDESC expression )
			{
				// HiveParser.g:1734:25: ^( TOK_TABSORTCOLNAMEDESC expression )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABSORTCOLNAMEDESC, "TOK_TABSORTCOLNAMEDESC"), root_1);
				adaptor.addChild(root_1, stream_expression.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnRefOrder"


	public static class columnNameType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameType"
	// HiveParser.g:1737:1: columnNameType : colName= identifier colType ( KW_COMMENT comment= StringLiteral )? -> {$comment == null}? ^( TOK_TABCOL $colName colType ) -> ^( TOK_TABCOL $colName colType $comment) ;
	public final HiveParser.columnNameType_return columnNameType() throws RecognitionException {
		HiveParser.columnNameType_return retval = new HiveParser.columnNameType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token KW_COMMENT667=null;
		ParserRuleReturnScope colName =null;
		ParserRuleReturnScope colType666 =null;

		CommonTree comment_tree=null;
		CommonTree KW_COMMENT667_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");
		RewriteRuleSubtreeStream stream_colType=new RewriteRuleSubtreeStream(adaptor,"rule colType");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("column specification"); 
		try {
			// HiveParser.g:1740:5: (colName= identifier colType ( KW_COMMENT comment= StringLiteral )? -> {$comment == null}? ^( TOK_TABCOL $colName colType ) -> ^( TOK_TABCOL $colName colType $comment) )
			// HiveParser.g:1740:7: colName= identifier colType ( KW_COMMENT comment= StringLiteral )?
			{
			pushFollow(FOLLOW_identifier_in_columnNameType10532);
			colName=identifier();
			state._fsp--;

			stream_identifier.add(colName.getTree());
			pushFollow(FOLLOW_colType_in_columnNameType10534);
			colType666=colType();
			state._fsp--;

			stream_colType.add(colType666.getTree());
			// HiveParser.g:1740:34: ( KW_COMMENT comment= StringLiteral )?
			int alt182=2;
			int LA182_0 = input.LA(1);
			if ( (LA182_0==KW_COMMENT) ) {
				alt182=1;
			}
			switch (alt182) {
				case 1 :
					// HiveParser.g:1740:35: KW_COMMENT comment= StringLiteral
					{
					KW_COMMENT667=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_columnNameType10537);  
					stream_KW_COMMENT.add(KW_COMMENT667);

					comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_columnNameType10541);  
					stream_StringLiteral.add(comment);

					}
					break;

			}

			// AST REWRITE
			// elements: colType, comment, colName, colName, colType
			// token labels: comment
			// rule labels: retval, colName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_colName=new RewriteRuleSubtreeStream(adaptor,"rule colName",colName!=null?colName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1741:5: -> {$comment == null}? ^( TOK_TABCOL $colName colType )
			if (comment == null) {
				// HiveParser.g:1741:28: ^( TOK_TABCOL $colName colType )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOL, "TOK_TABCOL"), root_1);
				adaptor.addChild(root_1, stream_colName.nextTree());
				adaptor.addChild(root_1, stream_colType.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}

			else // 1742:5: -> ^( TOK_TABCOL $colName colType $comment)
			{
				// HiveParser.g:1742:28: ^( TOK_TABCOL $colName colType $comment)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOL, "TOK_TABCOL"), root_1);
				adaptor.addChild(root_1, stream_colName.nextTree());
				adaptor.addChild(root_1, stream_colType.nextTree());
				adaptor.addChild(root_1, stream_comment.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameType"


	public static class columnNameColonType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "columnNameColonType"
	// HiveParser.g:1745:1: columnNameColonType : colName= identifier COLON colType ( KW_COMMENT comment= StringLiteral )? -> {$comment == null}? ^( TOK_TABCOL $colName colType ) -> ^( TOK_TABCOL $colName colType $comment) ;
	public final HiveParser.columnNameColonType_return columnNameColonType() throws RecognitionException {
		HiveParser.columnNameColonType_return retval = new HiveParser.columnNameColonType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token comment=null;
		Token COLON668=null;
		Token KW_COMMENT670=null;
		ParserRuleReturnScope colName =null;
		ParserRuleReturnScope colType669 =null;

		CommonTree comment_tree=null;
		CommonTree COLON668_tree=null;
		CommonTree KW_COMMENT670_tree=null;
		RewriteRuleTokenStream stream_COLON=new RewriteRuleTokenStream(adaptor,"token COLON");
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_COMMENT=new RewriteRuleTokenStream(adaptor,"token KW_COMMENT");
		RewriteRuleSubtreeStream stream_colType=new RewriteRuleSubtreeStream(adaptor,"rule colType");
		RewriteRuleSubtreeStream stream_identifier=new RewriteRuleSubtreeStream(adaptor,"rule identifier");

		 msgs.push("column specification"); 
		try {
			// HiveParser.g:1748:5: (colName= identifier COLON colType ( KW_COMMENT comment= StringLiteral )? -> {$comment == null}? ^( TOK_TABCOL $colName colType ) -> ^( TOK_TABCOL $colName colType $comment) )
			// HiveParser.g:1748:7: colName= identifier COLON colType ( KW_COMMENT comment= StringLiteral )?
			{
			pushFollow(FOLLOW_identifier_in_columnNameColonType10627);
			colName=identifier();
			state._fsp--;

			stream_identifier.add(colName.getTree());
			COLON668=(Token)match(input,COLON,FOLLOW_COLON_in_columnNameColonType10629);  
			stream_COLON.add(COLON668);

			pushFollow(FOLLOW_colType_in_columnNameColonType10631);
			colType669=colType();
			state._fsp--;

			stream_colType.add(colType669.getTree());
			// HiveParser.g:1748:40: ( KW_COMMENT comment= StringLiteral )?
			int alt183=2;
			int LA183_0 = input.LA(1);
			if ( (LA183_0==KW_COMMENT) ) {
				alt183=1;
			}
			switch (alt183) {
				case 1 :
					// HiveParser.g:1748:41: KW_COMMENT comment= StringLiteral
					{
					KW_COMMENT670=(Token)match(input,KW_COMMENT,FOLLOW_KW_COMMENT_in_columnNameColonType10634);  
					stream_KW_COMMENT.add(KW_COMMENT670);

					comment=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_columnNameColonType10638);  
					stream_StringLiteral.add(comment);

					}
					break;

			}

			// AST REWRITE
			// elements: comment, colType, colType, colName, colName
			// token labels: comment
			// rule labels: retval, colName
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_comment=new RewriteRuleTokenStream(adaptor,"token comment",comment);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_colName=new RewriteRuleSubtreeStream(adaptor,"rule colName",colName!=null?colName.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1749:5: -> {$comment == null}? ^( TOK_TABCOL $colName colType )
			if (comment == null) {
				// HiveParser.g:1749:28: ^( TOK_TABCOL $colName colType )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOL, "TOK_TABCOL"), root_1);
				adaptor.addChild(root_1, stream_colName.nextTree());
				adaptor.addChild(root_1, stream_colType.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}

			else // 1750:5: -> ^( TOK_TABCOL $colName colType $comment)
			{
				// HiveParser.g:1750:28: ^( TOK_TABCOL $colName colType $comment)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_TABCOL, "TOK_TABCOL"), root_1);
				adaptor.addChild(root_1, stream_colName.nextTree());
				adaptor.addChild(root_1, stream_colType.nextTree());
				adaptor.addChild(root_1, stream_comment.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "columnNameColonType"


	public static class colType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "colType"
	// HiveParser.g:1753:1: colType : type ;
	public final HiveParser.colType_return colType() throws RecognitionException {
		HiveParser.colType_return retval = new HiveParser.colType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope type671 =null;


		 msgs.push("column type"); 
		try {
			// HiveParser.g:1756:5: ( type )
			// HiveParser.g:1756:7: type
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_type_in_colType10722);
			type671=type();
			state._fsp--;

			adaptor.addChild(root_0, type671.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "colType"


	public static class colTypeList_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "colTypeList"
	// HiveParser.g:1759:1: colTypeList : colType ( COMMA colType )* -> ^( TOK_COLTYPELIST ( colType )+ ) ;
	public final HiveParser.colTypeList_return colTypeList() throws RecognitionException {
		HiveParser.colTypeList_return retval = new HiveParser.colTypeList_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token COMMA673=null;
		ParserRuleReturnScope colType672 =null;
		ParserRuleReturnScope colType674 =null;

		CommonTree COMMA673_tree=null;
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleSubtreeStream stream_colType=new RewriteRuleSubtreeStream(adaptor,"rule colType");

		 msgs.push("column type list"); 
		try {
			// HiveParser.g:1762:5: ( colType ( COMMA colType )* -> ^( TOK_COLTYPELIST ( colType )+ ) )
			// HiveParser.g:1762:7: colType ( COMMA colType )*
			{
			pushFollow(FOLLOW_colType_in_colTypeList10749);
			colType672=colType();
			state._fsp--;

			stream_colType.add(colType672.getTree());
			// HiveParser.g:1762:15: ( COMMA colType )*
			loop184:
			while (true) {
				int alt184=2;
				int LA184_0 = input.LA(1);
				if ( (LA184_0==COMMA) ) {
					alt184=1;
				}

				switch (alt184) {
				case 1 :
					// HiveParser.g:1762:16: COMMA colType
					{
					COMMA673=(Token)match(input,COMMA,FOLLOW_COMMA_in_colTypeList10752);  
					stream_COMMA.add(COMMA673);

					pushFollow(FOLLOW_colType_in_colTypeList10754);
					colType674=colType();
					state._fsp--;

					stream_colType.add(colType674.getTree());
					}
					break;

				default :
					break loop184;
				}
			}

			// AST REWRITE
			// elements: colType
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1762:32: -> ^( TOK_COLTYPELIST ( colType )+ )
			{
				// HiveParser.g:1762:35: ^( TOK_COLTYPELIST ( colType )+ )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_COLTYPELIST, "TOK_COLTYPELIST"), root_1);
				if ( !(stream_colType.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_colType.hasNext() ) {
					adaptor.addChild(root_1, stream_colType.nextTree());
				}
				stream_colType.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "colTypeList"


	public static class type_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "type"
	// HiveParser.g:1765:1: type : ( primitiveType | listType | structType | mapType | unionType );
	public final HiveParser.type_return type() throws RecognitionException {
		HiveParser.type_return retval = new HiveParser.type_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope primitiveType675 =null;
		ParserRuleReturnScope listType676 =null;
		ParserRuleReturnScope structType677 =null;
		ParserRuleReturnScope mapType678 =null;
		ParserRuleReturnScope unionType679 =null;


		try {
			// HiveParser.g:1766:5: ( primitiveType | listType | structType | mapType | unionType )
			int alt185=5;
			switch ( input.LA(1) ) {
			case KW_BIGINT:
			case KW_BINARY:
			case KW_BOOLEAN:
			case KW_DATE:
			case KW_DATETIME:
			case KW_DECIMAL:
			case KW_DOUBLE:
			case KW_FLOAT:
			case KW_INT:
			case KW_SMALLINT:
			case KW_STRING:
			case KW_TIMESTAMP:
			case KW_TINYINT:
			case KW_VARCHAR:
				{
				alt185=1;
				}
				break;
			case KW_ARRAY:
				{
				alt185=2;
				}
				break;
			case KW_STRUCT:
				{
				alt185=3;
				}
				break;
			case KW_MAP:
				{
				alt185=4;
				}
				break;
			case KW_UNIONTYPE:
				{
				alt185=5;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 185, 0, input);
				throw nvae;
			}
			switch (alt185) {
				case 1 :
					// HiveParser.g:1766:7: primitiveType
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_primitiveType_in_type10782);
					primitiveType675=primitiveType();
					state._fsp--;

					adaptor.addChild(root_0, primitiveType675.getTree());

					}
					break;
				case 2 :
					// HiveParser.g:1767:7: listType
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_listType_in_type10790);
					listType676=listType();
					state._fsp--;

					adaptor.addChild(root_0, listType676.getTree());

					}
					break;
				case 3 :
					// HiveParser.g:1768:7: structType
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_structType_in_type10798);
					structType677=structType();
					state._fsp--;

					adaptor.addChild(root_0, structType677.getTree());

					}
					break;
				case 4 :
					// HiveParser.g:1769:7: mapType
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_mapType_in_type10806);
					mapType678=mapType();
					state._fsp--;

					adaptor.addChild(root_0, mapType678.getTree());

					}
					break;
				case 5 :
					// HiveParser.g:1770:7: unionType
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_unionType_in_type10814);
					unionType679=unionType();
					state._fsp--;

					adaptor.addChild(root_0, unionType679.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "type"


	public static class primitiveType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "primitiveType"
	// HiveParser.g:1772:1: primitiveType : ( KW_TINYINT -> TOK_TINYINT | KW_SMALLINT -> TOK_SMALLINT | KW_INT -> TOK_INT | KW_BIGINT -> TOK_BIGINT | KW_BOOLEAN -> TOK_BOOLEAN | KW_FLOAT -> TOK_FLOAT | KW_DOUBLE -> TOK_DOUBLE | KW_DATE -> TOK_DATE | KW_DATETIME -> TOK_DATETIME | KW_TIMESTAMP -> TOK_TIMESTAMP | KW_STRING -> TOK_STRING | KW_BINARY -> TOK_BINARY | KW_DECIMAL -> TOK_DECIMAL | KW_VARCHAR LPAREN length= Number RPAREN -> ^( TOK_VARCHAR $length) );
	public final HiveParser.primitiveType_return primitiveType() throws RecognitionException {
		HiveParser.primitiveType_return retval = new HiveParser.primitiveType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token length=null;
		Token KW_TINYINT680=null;
		Token KW_SMALLINT681=null;
		Token KW_INT682=null;
		Token KW_BIGINT683=null;
		Token KW_BOOLEAN684=null;
		Token KW_FLOAT685=null;
		Token KW_DOUBLE686=null;
		Token KW_DATE687=null;
		Token KW_DATETIME688=null;
		Token KW_TIMESTAMP689=null;
		Token KW_STRING690=null;
		Token KW_BINARY691=null;
		Token KW_DECIMAL692=null;
		Token KW_VARCHAR693=null;
		Token LPAREN694=null;
		Token RPAREN695=null;

		CommonTree length_tree=null;
		CommonTree KW_TINYINT680_tree=null;
		CommonTree KW_SMALLINT681_tree=null;
		CommonTree KW_INT682_tree=null;
		CommonTree KW_BIGINT683_tree=null;
		CommonTree KW_BOOLEAN684_tree=null;
		CommonTree KW_FLOAT685_tree=null;
		CommonTree KW_DOUBLE686_tree=null;
		CommonTree KW_DATE687_tree=null;
		CommonTree KW_DATETIME688_tree=null;
		CommonTree KW_TIMESTAMP689_tree=null;
		CommonTree KW_STRING690_tree=null;
		CommonTree KW_BINARY691_tree=null;
		CommonTree KW_DECIMAL692_tree=null;
		CommonTree KW_VARCHAR693_tree=null;
		CommonTree LPAREN694_tree=null;
		CommonTree RPAREN695_tree=null;
		RewriteRuleTokenStream stream_KW_DATETIME=new RewriteRuleTokenStream(adaptor,"token KW_DATETIME");
		RewriteRuleTokenStream stream_KW_VARCHAR=new RewriteRuleTokenStream(adaptor,"token KW_VARCHAR");
		RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
		RewriteRuleTokenStream stream_KW_DATE=new RewriteRuleTokenStream(adaptor,"token KW_DATE");
		RewriteRuleTokenStream stream_KW_TIMESTAMP=new RewriteRuleTokenStream(adaptor,"token KW_TIMESTAMP");
		RewriteRuleTokenStream stream_KW_STRING=new RewriteRuleTokenStream(adaptor,"token KW_STRING");
		RewriteRuleTokenStream stream_Number=new RewriteRuleTokenStream(adaptor,"token Number");
		RewriteRuleTokenStream stream_KW_SMALLINT=new RewriteRuleTokenStream(adaptor,"token KW_SMALLINT");
		RewriteRuleTokenStream stream_KW_INT=new RewriteRuleTokenStream(adaptor,"token KW_INT");
		RewriteRuleTokenStream stream_KW_BINARY=new RewriteRuleTokenStream(adaptor,"token KW_BINARY");
		RewriteRuleTokenStream stream_KW_DECIMAL=new RewriteRuleTokenStream(adaptor,"token KW_DECIMAL");
		RewriteRuleTokenStream stream_KW_BOOLEAN=new RewriteRuleTokenStream(adaptor,"token KW_BOOLEAN");
		RewriteRuleTokenStream stream_KW_FLOAT=new RewriteRuleTokenStream(adaptor,"token KW_FLOAT");
		RewriteRuleTokenStream stream_KW_DOUBLE=new RewriteRuleTokenStream(adaptor,"token KW_DOUBLE");
		RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
		RewriteRuleTokenStream stream_KW_BIGINT=new RewriteRuleTokenStream(adaptor,"token KW_BIGINT");
		RewriteRuleTokenStream stream_KW_TINYINT=new RewriteRuleTokenStream(adaptor,"token KW_TINYINT");

		 msgs.push("primitive type specification"); 
		try {
			// HiveParser.g:1775:5: ( KW_TINYINT -> TOK_TINYINT | KW_SMALLINT -> TOK_SMALLINT | KW_INT -> TOK_INT | KW_BIGINT -> TOK_BIGINT | KW_BOOLEAN -> TOK_BOOLEAN | KW_FLOAT -> TOK_FLOAT | KW_DOUBLE -> TOK_DOUBLE | KW_DATE -> TOK_DATE | KW_DATETIME -> TOK_DATETIME | KW_TIMESTAMP -> TOK_TIMESTAMP | KW_STRING -> TOK_STRING | KW_BINARY -> TOK_BINARY | KW_DECIMAL -> TOK_DECIMAL | KW_VARCHAR LPAREN length= Number RPAREN -> ^( TOK_VARCHAR $length) )
			int alt186=14;
			switch ( input.LA(1) ) {
			case KW_TINYINT:
				{
				alt186=1;
				}
				break;
			case KW_SMALLINT:
				{
				alt186=2;
				}
				break;
			case KW_INT:
				{
				alt186=3;
				}
				break;
			case KW_BIGINT:
				{
				alt186=4;
				}
				break;
			case KW_BOOLEAN:
				{
				alt186=5;
				}
				break;
			case KW_FLOAT:
				{
				alt186=6;
				}
				break;
			case KW_DOUBLE:
				{
				alt186=7;
				}
				break;
			case KW_DATE:
				{
				alt186=8;
				}
				break;
			case KW_DATETIME:
				{
				alt186=9;
				}
				break;
			case KW_TIMESTAMP:
				{
				alt186=10;
				}
				break;
			case KW_STRING:
				{
				alt186=11;
				}
				break;
			case KW_BINARY:
				{
				alt186=12;
				}
				break;
			case KW_DECIMAL:
				{
				alt186=13;
				}
				break;
			case KW_VARCHAR:
				{
				alt186=14;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 186, 0, input);
				throw nvae;
			}
			switch (alt186) {
				case 1 :
					// HiveParser.g:1775:7: KW_TINYINT
					{
					KW_TINYINT680=(Token)match(input,KW_TINYINT,FOLLOW_KW_TINYINT_in_primitiveType10836);  
					stream_KW_TINYINT.add(KW_TINYINT680);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1775:24: -> TOK_TINYINT
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TINYINT, "TOK_TINYINT"));
					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1776:7: KW_SMALLINT
					{
					KW_SMALLINT681=(Token)match(input,KW_SMALLINT,FOLLOW_KW_SMALLINT_in_primitiveType10857);  
					stream_KW_SMALLINT.add(KW_SMALLINT681);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1776:24: -> TOK_SMALLINT
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_SMALLINT, "TOK_SMALLINT"));
					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1777:7: KW_INT
					{
					KW_INT682=(Token)match(input,KW_INT,FOLLOW_KW_INT_in_primitiveType10877);  
					stream_KW_INT.add(KW_INT682);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1777:24: -> TOK_INT
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_INT, "TOK_INT"));
					}


					retval.tree = root_0;

					}
					break;
				case 4 :
					// HiveParser.g:1778:7: KW_BIGINT
					{
					KW_BIGINT683=(Token)match(input,KW_BIGINT,FOLLOW_KW_BIGINT_in_primitiveType10902);  
					stream_KW_BIGINT.add(KW_BIGINT683);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1778:24: -> TOK_BIGINT
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_BIGINT, "TOK_BIGINT"));
					}


					retval.tree = root_0;

					}
					break;
				case 5 :
					// HiveParser.g:1779:7: KW_BOOLEAN
					{
					KW_BOOLEAN684=(Token)match(input,KW_BOOLEAN,FOLLOW_KW_BOOLEAN_in_primitiveType10924);  
					stream_KW_BOOLEAN.add(KW_BOOLEAN684);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1779:24: -> TOK_BOOLEAN
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_BOOLEAN, "TOK_BOOLEAN"));
					}


					retval.tree = root_0;

					}
					break;
				case 6 :
					// HiveParser.g:1780:7: KW_FLOAT
					{
					KW_FLOAT685=(Token)match(input,KW_FLOAT,FOLLOW_KW_FLOAT_in_primitiveType10945);  
					stream_KW_FLOAT.add(KW_FLOAT685);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1780:24: -> TOK_FLOAT
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_FLOAT, "TOK_FLOAT"));
					}


					retval.tree = root_0;

					}
					break;
				case 7 :
					// HiveParser.g:1781:7: KW_DOUBLE
					{
					KW_DOUBLE686=(Token)match(input,KW_DOUBLE,FOLLOW_KW_DOUBLE_in_primitiveType10968);  
					stream_KW_DOUBLE.add(KW_DOUBLE686);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1781:24: -> TOK_DOUBLE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_DOUBLE, "TOK_DOUBLE"));
					}


					retval.tree = root_0;

					}
					break;
				case 8 :
					// HiveParser.g:1782:7: KW_DATE
					{
					KW_DATE687=(Token)match(input,KW_DATE,FOLLOW_KW_DATE_in_primitiveType10990);  
					stream_KW_DATE.add(KW_DATE687);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1782:24: -> TOK_DATE
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_DATE, "TOK_DATE"));
					}


					retval.tree = root_0;

					}
					break;
				case 9 :
					// HiveParser.g:1783:7: KW_DATETIME
					{
					KW_DATETIME688=(Token)match(input,KW_DATETIME,FOLLOW_KW_DATETIME_in_primitiveType11014);  
					stream_KW_DATETIME.add(KW_DATETIME688);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1783:24: -> TOK_DATETIME
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_DATETIME, "TOK_DATETIME"));
					}


					retval.tree = root_0;

					}
					break;
				case 10 :
					// HiveParser.g:1784:7: KW_TIMESTAMP
					{
					KW_TIMESTAMP689=(Token)match(input,KW_TIMESTAMP,FOLLOW_KW_TIMESTAMP_in_primitiveType11034);  
					stream_KW_TIMESTAMP.add(KW_TIMESTAMP689);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1784:24: -> TOK_TIMESTAMP
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_TIMESTAMP, "TOK_TIMESTAMP"));
					}


					retval.tree = root_0;

					}
					break;
				case 11 :
					// HiveParser.g:1785:7: KW_STRING
					{
					KW_STRING690=(Token)match(input,KW_STRING,FOLLOW_KW_STRING_in_primitiveType11053);  
					stream_KW_STRING.add(KW_STRING690);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1785:24: -> TOK_STRING
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_STRING, "TOK_STRING"));
					}


					retval.tree = root_0;

					}
					break;
				case 12 :
					// HiveParser.g:1786:7: KW_BINARY
					{
					KW_BINARY691=(Token)match(input,KW_BINARY,FOLLOW_KW_BINARY_in_primitiveType11075);  
					stream_KW_BINARY.add(KW_BINARY691);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1786:24: -> TOK_BINARY
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_BINARY, "TOK_BINARY"));
					}


					retval.tree = root_0;

					}
					break;
				case 13 :
					// HiveParser.g:1787:7: KW_DECIMAL
					{
					KW_DECIMAL692=(Token)match(input,KW_DECIMAL,FOLLOW_KW_DECIMAL_in_primitiveType11097);  
					stream_KW_DECIMAL.add(KW_DECIMAL692);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1787:24: -> TOK_DECIMAL
					{
						adaptor.addChild(root_0, (CommonTree)adaptor.create(TOK_DECIMAL, "TOK_DECIMAL"));
					}


					retval.tree = root_0;

					}
					break;
				case 14 :
					// HiveParser.g:1788:7: KW_VARCHAR LPAREN length= Number RPAREN
					{
					KW_VARCHAR693=(Token)match(input,KW_VARCHAR,FOLLOW_KW_VARCHAR_in_primitiveType11118);  
					stream_KW_VARCHAR.add(KW_VARCHAR693);

					LPAREN694=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_primitiveType11120);  
					stream_LPAREN.add(LPAREN694);

					length=(Token)match(input,Number,FOLLOW_Number_in_primitiveType11124);  
					stream_Number.add(length);

					RPAREN695=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_primitiveType11126);  
					stream_RPAREN.add(RPAREN695);

					// AST REWRITE
					// elements: length
					// token labels: length
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleTokenStream stream_length=new RewriteRuleTokenStream(adaptor,"token length",length);
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1788:51: -> ^( TOK_VARCHAR $length)
					{
						// HiveParser.g:1788:57: ^( TOK_VARCHAR $length)
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_VARCHAR, "TOK_VARCHAR"), root_1);
						adaptor.addChild(root_1, stream_length.nextNode());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "primitiveType"


	public static class listType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "listType"
	// HiveParser.g:1791:1: listType : KW_ARRAY LESSTHAN type GREATERTHAN -> ^( TOK_LIST type ) ;
	public final HiveParser.listType_return listType() throws RecognitionException {
		HiveParser.listType_return retval = new HiveParser.listType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_ARRAY696=null;
		Token LESSTHAN697=null;
		Token GREATERTHAN699=null;
		ParserRuleReturnScope type698 =null;

		CommonTree KW_ARRAY696_tree=null;
		CommonTree LESSTHAN697_tree=null;
		CommonTree GREATERTHAN699_tree=null;
		RewriteRuleTokenStream stream_LESSTHAN=new RewriteRuleTokenStream(adaptor,"token LESSTHAN");
		RewriteRuleTokenStream stream_KW_ARRAY=new RewriteRuleTokenStream(adaptor,"token KW_ARRAY");
		RewriteRuleTokenStream stream_GREATERTHAN=new RewriteRuleTokenStream(adaptor,"token GREATERTHAN");
		RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");

		 msgs.push("list type"); 
		try {
			// HiveParser.g:1794:5: ( KW_ARRAY LESSTHAN type GREATERTHAN -> ^( TOK_LIST type ) )
			// HiveParser.g:1794:7: KW_ARRAY LESSTHAN type GREATERTHAN
			{
			KW_ARRAY696=(Token)match(input,KW_ARRAY,FOLLOW_KW_ARRAY_in_listType11170);  
			stream_KW_ARRAY.add(KW_ARRAY696);

			LESSTHAN697=(Token)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_listType11172);  
			stream_LESSTHAN.add(LESSTHAN697);

			pushFollow(FOLLOW_type_in_listType11174);
			type698=type();
			state._fsp--;

			stream_type.add(type698.getTree());
			GREATERTHAN699=(Token)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_listType11176);  
			stream_GREATERTHAN.add(GREATERTHAN699);

			// AST REWRITE
			// elements: type
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1794:44: -> ^( TOK_LIST type )
			{
				// HiveParser.g:1794:47: ^( TOK_LIST type )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LIST, "TOK_LIST"), root_1);
				adaptor.addChild(root_1, stream_type.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "listType"


	public static class structType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "structType"
	// HiveParser.g:1797:1: structType : KW_STRUCT LESSTHAN columnNameColonTypeList GREATERTHAN -> ^( TOK_STRUCT columnNameColonTypeList ) ;
	public final HiveParser.structType_return structType() throws RecognitionException {
		HiveParser.structType_return retval = new HiveParser.structType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_STRUCT700=null;
		Token LESSTHAN701=null;
		Token GREATERTHAN703=null;
		ParserRuleReturnScope columnNameColonTypeList702 =null;

		CommonTree KW_STRUCT700_tree=null;
		CommonTree LESSTHAN701_tree=null;
		CommonTree GREATERTHAN703_tree=null;
		RewriteRuleTokenStream stream_LESSTHAN=new RewriteRuleTokenStream(adaptor,"token LESSTHAN");
		RewriteRuleTokenStream stream_KW_STRUCT=new RewriteRuleTokenStream(adaptor,"token KW_STRUCT");
		RewriteRuleTokenStream stream_GREATERTHAN=new RewriteRuleTokenStream(adaptor,"token GREATERTHAN");
		RewriteRuleSubtreeStream stream_columnNameColonTypeList=new RewriteRuleSubtreeStream(adaptor,"rule columnNameColonTypeList");

		 msgs.push("struct type"); 
		try {
			// HiveParser.g:1800:5: ( KW_STRUCT LESSTHAN columnNameColonTypeList GREATERTHAN -> ^( TOK_STRUCT columnNameColonTypeList ) )
			// HiveParser.g:1800:7: KW_STRUCT LESSTHAN columnNameColonTypeList GREATERTHAN
			{
			KW_STRUCT700=(Token)match(input,KW_STRUCT,FOLLOW_KW_STRUCT_in_structType11213);  
			stream_KW_STRUCT.add(KW_STRUCT700);

			LESSTHAN701=(Token)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_structType11215);  
			stream_LESSTHAN.add(LESSTHAN701);

			pushFollow(FOLLOW_columnNameColonTypeList_in_structType11217);
			columnNameColonTypeList702=columnNameColonTypeList();
			state._fsp--;

			stream_columnNameColonTypeList.add(columnNameColonTypeList702.getTree());
			GREATERTHAN703=(Token)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_structType11219);  
			stream_GREATERTHAN.add(GREATERTHAN703);

			// AST REWRITE
			// elements: columnNameColonTypeList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1800:62: -> ^( TOK_STRUCT columnNameColonTypeList )
			{
				// HiveParser.g:1800:65: ^( TOK_STRUCT columnNameColonTypeList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_STRUCT, "TOK_STRUCT"), root_1);
				adaptor.addChild(root_1, stream_columnNameColonTypeList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "structType"


	public static class mapType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "mapType"
	// HiveParser.g:1803:1: mapType : KW_MAP LESSTHAN left= primitiveType COMMA right= type GREATERTHAN -> ^( TOK_MAP $left $right) ;
	public final HiveParser.mapType_return mapType() throws RecognitionException {
		HiveParser.mapType_return retval = new HiveParser.mapType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_MAP704=null;
		Token LESSTHAN705=null;
		Token COMMA706=null;
		Token GREATERTHAN707=null;
		ParserRuleReturnScope left =null;
		ParserRuleReturnScope right =null;

		CommonTree KW_MAP704_tree=null;
		CommonTree LESSTHAN705_tree=null;
		CommonTree COMMA706_tree=null;
		CommonTree GREATERTHAN707_tree=null;
		RewriteRuleTokenStream stream_LESSTHAN=new RewriteRuleTokenStream(adaptor,"token LESSTHAN");
		RewriteRuleTokenStream stream_KW_MAP=new RewriteRuleTokenStream(adaptor,"token KW_MAP");
		RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
		RewriteRuleTokenStream stream_GREATERTHAN=new RewriteRuleTokenStream(adaptor,"token GREATERTHAN");
		RewriteRuleSubtreeStream stream_primitiveType=new RewriteRuleSubtreeStream(adaptor,"rule primitiveType");
		RewriteRuleSubtreeStream stream_type=new RewriteRuleSubtreeStream(adaptor,"rule type");

		 msgs.push("map type"); 
		try {
			// HiveParser.g:1806:5: ( KW_MAP LESSTHAN left= primitiveType COMMA right= type GREATERTHAN -> ^( TOK_MAP $left $right) )
			// HiveParser.g:1806:7: KW_MAP LESSTHAN left= primitiveType COMMA right= type GREATERTHAN
			{
			KW_MAP704=(Token)match(input,KW_MAP,FOLLOW_KW_MAP_in_mapType11254);  
			stream_KW_MAP.add(KW_MAP704);

			LESSTHAN705=(Token)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_mapType11256);  
			stream_LESSTHAN.add(LESSTHAN705);

			pushFollow(FOLLOW_primitiveType_in_mapType11260);
			left=primitiveType();
			state._fsp--;

			stream_primitiveType.add(left.getTree());
			COMMA706=(Token)match(input,COMMA,FOLLOW_COMMA_in_mapType11262);  
			stream_COMMA.add(COMMA706);

			pushFollow(FOLLOW_type_in_mapType11266);
			right=type();
			state._fsp--;

			stream_type.add(right.getTree());
			GREATERTHAN707=(Token)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_mapType11268);  
			stream_GREATERTHAN.add(GREATERTHAN707);

			// AST REWRITE
			// elements: left, right
			// token labels: 
			// rule labels: retval, left, right
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_left=new RewriteRuleSubtreeStream(adaptor,"rule left",left!=null?left.getTree():null);
			RewriteRuleSubtreeStream stream_right=new RewriteRuleSubtreeStream(adaptor,"rule right",right!=null?right.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1807:5: -> ^( TOK_MAP $left $right)
			{
				// HiveParser.g:1807:8: ^( TOK_MAP $left $right)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_MAP, "TOK_MAP"), root_1);
				adaptor.addChild(root_1, stream_left.nextTree());
				adaptor.addChild(root_1, stream_right.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "mapType"


	public static class unionType_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "unionType"
	// HiveParser.g:1810:1: unionType : KW_UNIONTYPE LESSTHAN colTypeList GREATERTHAN -> ^( TOK_UNIONTYPE colTypeList ) ;
	public final HiveParser.unionType_return unionType() throws RecognitionException {
		HiveParser.unionType_return retval = new HiveParser.unionType_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_UNIONTYPE708=null;
		Token LESSTHAN709=null;
		Token GREATERTHAN711=null;
		ParserRuleReturnScope colTypeList710 =null;

		CommonTree KW_UNIONTYPE708_tree=null;
		CommonTree LESSTHAN709_tree=null;
		CommonTree GREATERTHAN711_tree=null;
		RewriteRuleTokenStream stream_LESSTHAN=new RewriteRuleTokenStream(adaptor,"token LESSTHAN");
		RewriteRuleTokenStream stream_KW_UNIONTYPE=new RewriteRuleTokenStream(adaptor,"token KW_UNIONTYPE");
		RewriteRuleTokenStream stream_GREATERTHAN=new RewriteRuleTokenStream(adaptor,"token GREATERTHAN");
		RewriteRuleSubtreeStream stream_colTypeList=new RewriteRuleSubtreeStream(adaptor,"rule colTypeList");

		 msgs.push("uniontype type"); 
		try {
			// HiveParser.g:1813:5: ( KW_UNIONTYPE LESSTHAN colTypeList GREATERTHAN -> ^( TOK_UNIONTYPE colTypeList ) )
			// HiveParser.g:1813:7: KW_UNIONTYPE LESSTHAN colTypeList GREATERTHAN
			{
			KW_UNIONTYPE708=(Token)match(input,KW_UNIONTYPE,FOLLOW_KW_UNIONTYPE_in_unionType11311);  
			stream_KW_UNIONTYPE.add(KW_UNIONTYPE708);

			LESSTHAN709=(Token)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_unionType11313);  
			stream_LESSTHAN.add(LESSTHAN709);

			pushFollow(FOLLOW_colTypeList_in_unionType11315);
			colTypeList710=colTypeList();
			state._fsp--;

			stream_colTypeList.add(colTypeList710.getTree());
			GREATERTHAN711=(Token)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_unionType11317);  
			stream_GREATERTHAN.add(GREATERTHAN711);

			// AST REWRITE
			// elements: colTypeList
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1813:53: -> ^( TOK_UNIONTYPE colTypeList )
			{
				// HiveParser.g:1813:56: ^( TOK_UNIONTYPE colTypeList )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_UNIONTYPE, "TOK_UNIONTYPE"), root_1);
				adaptor.addChild(root_1, stream_colTypeList.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "unionType"


	public static class queryOperator_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "queryOperator"
	// HiveParser.g:1816:1: queryOperator : KW_UNION KW_ALL -> ^( TOK_UNION ) ;
	public final HiveParser.queryOperator_return queryOperator() throws RecognitionException {
		HiveParser.queryOperator_return retval = new HiveParser.queryOperator_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_UNION712=null;
		Token KW_ALL713=null;

		CommonTree KW_UNION712_tree=null;
		CommonTree KW_ALL713_tree=null;
		RewriteRuleTokenStream stream_KW_ALL=new RewriteRuleTokenStream(adaptor,"token KW_ALL");
		RewriteRuleTokenStream stream_KW_UNION=new RewriteRuleTokenStream(adaptor,"token KW_UNION");

		 msgs.push("query operator"); 
		try {
			// HiveParser.g:1819:5: ( KW_UNION KW_ALL -> ^( TOK_UNION ) )
			// HiveParser.g:1819:7: KW_UNION KW_ALL
			{
			KW_UNION712=(Token)match(input,KW_UNION,FOLLOW_KW_UNION_in_queryOperator11352);  
			stream_KW_UNION.add(KW_UNION712);

			KW_ALL713=(Token)match(input,KW_ALL,FOLLOW_KW_ALL_in_queryOperator11354);  
			stream_KW_ALL.add(KW_ALL713);

			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1819:23: -> ^( TOK_UNION )
			{
				// HiveParser.g:1819:26: ^( TOK_UNION )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_UNION, "TOK_UNION"), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "queryOperator"


	public static class queryStatementExpression_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "queryStatementExpression"
	// HiveParser.g:1823:1: queryStatementExpression : queryStatement ( queryOperator ^ queryStatement )* ;
	public final HiveParser.queryStatementExpression_return queryStatementExpression() throws RecognitionException {
		HiveParser.queryStatementExpression_return retval = new HiveParser.queryStatementExpression_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope queryStatement714 =null;
		ParserRuleReturnScope queryOperator715 =null;
		ParserRuleReturnScope queryStatement716 =null;


		try {
			// HiveParser.g:1824:5: ( queryStatement ( queryOperator ^ queryStatement )* )
			// HiveParser.g:1824:7: queryStatement ( queryOperator ^ queryStatement )*
			{
			root_0 = (CommonTree)adaptor.nil();


			pushFollow(FOLLOW_queryStatement_in_queryStatementExpression11378);
			queryStatement714=queryStatement();
			state._fsp--;

			adaptor.addChild(root_0, queryStatement714.getTree());

			// HiveParser.g:1824:22: ( queryOperator ^ queryStatement )*
			loop187:
			while (true) {
				int alt187=2;
				int LA187_0 = input.LA(1);
				if ( (LA187_0==KW_UNION) ) {
					alt187=1;
				}

				switch (alt187) {
				case 1 :
					// HiveParser.g:1824:23: queryOperator ^ queryStatement
					{
					pushFollow(FOLLOW_queryOperator_in_queryStatementExpression11381);
					queryOperator715=queryOperator();
					state._fsp--;

					root_0 = (CommonTree)adaptor.becomeRoot(queryOperator715.getTree(), root_0);
					pushFollow(FOLLOW_queryStatement_in_queryStatementExpression11384);
					queryStatement716=queryStatement();
					state._fsp--;

					adaptor.addChild(root_0, queryStatement716.getTree());

					}
					break;

				default :
					break loop187;
				}
			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "queryStatementExpression"


	public static class queryStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "queryStatement"
	// HiveParser.g:1827:1: queryStatement : ( fromClause (b+= body )+ -> ^( TOK_QUERY fromClause ( body )+ ) | regular_body );
	public final HiveParser.queryStatement_return queryStatement() throws RecognitionException {
		HiveParser.queryStatement_return retval = new HiveParser.queryStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		List<Object> list_b=null;
		ParserRuleReturnScope fromClause717 =null;
		ParserRuleReturnScope regular_body718 =null;
		RuleReturnScope b = null;
		RewriteRuleSubtreeStream stream_body=new RewriteRuleSubtreeStream(adaptor,"rule body");
		RewriteRuleSubtreeStream stream_fromClause=new RewriteRuleSubtreeStream(adaptor,"rule fromClause");

		try {
			// HiveParser.g:1828:5: ( fromClause (b+= body )+ -> ^( TOK_QUERY fromClause ( body )+ ) | regular_body )
			int alt189=2;
			int LA189_0 = input.LA(1);
			if ( (LA189_0==KW_FROM) ) {
				alt189=1;
			}
			else if ( (LA189_0==KW_INSERT||LA189_0==KW_MAP||LA189_0==KW_REDUCE||LA189_0==KW_SELECT) ) {
				alt189=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 189, 0, input);
				throw nvae;
			}

			switch (alt189) {
				case 1 :
					// HiveParser.g:1829:5: fromClause (b+= body )+
					{
					pushFollow(FOLLOW_fromClause_in_queryStatement11407);
					fromClause717=fromClause();
					state._fsp--;

					stream_fromClause.add(fromClause717.getTree());
					// HiveParser.g:1830:5: (b+= body )+
					int cnt188=0;
					loop188:
					while (true) {
						int alt188=2;
						int LA188_0 = input.LA(1);
						if ( (LA188_0==KW_INSERT||LA188_0==KW_MAP||LA188_0==KW_REDUCE||LA188_0==KW_SELECT) ) {
							alt188=1;
						}

						switch (alt188) {
						case 1 :
							// HiveParser.g:1830:7: b+= body
							{
							pushFollow(FOLLOW_body_in_queryStatement11417);
							b=body();
							state._fsp--;

							stream_body.add(b.getTree());
							if (list_b==null) list_b=new ArrayList<Object>();
							list_b.add(b.getTree());
							}
							break;

						default :
							if ( cnt188 >= 1 ) break loop188;
							EarlyExitException eee = new EarlyExitException(188, input);
							throw eee;
						}
						cnt188++;
					}

					// AST REWRITE
					// elements: body, fromClause
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1830:18: -> ^( TOK_QUERY fromClause ( body )+ )
					{
						// HiveParser.g:1830:21: ^( TOK_QUERY fromClause ( body )+ )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_QUERY, "TOK_QUERY"), root_1);
						adaptor.addChild(root_1, stream_fromClause.nextTree());
						if ( !(stream_body.hasNext()) ) {
							throw new RewriteEarlyExitException();
						}
						while ( stream_body.hasNext() ) {
							adaptor.addChild(root_1, stream_body.nextTree());
						}
						stream_body.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1831:7: regular_body
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_regular_body_in_queryStatement11439);
					regular_body718=regular_body();
					state._fsp--;

					adaptor.addChild(root_0, regular_body718.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "queryStatement"


	public static class regular_body_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "regular_body"
	// HiveParser.g:1834:1: regular_body : ( insertClause selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_QUERY fromClause ^( TOK_INSERT insertClause selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) ) | selectStatement );
	public final HiveParser.regular_body_return regular_body() throws RecognitionException {
		HiveParser.regular_body_return retval = new HiveParser.regular_body_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope insertClause719 =null;
		ParserRuleReturnScope selectClause720 =null;
		ParserRuleReturnScope fromClause721 =null;
		ParserRuleReturnScope whereClause722 =null;
		ParserRuleReturnScope groupByClause723 =null;
		ParserRuleReturnScope havingClause724 =null;
		ParserRuleReturnScope orderByClause725 =null;
		ParserRuleReturnScope clusterByClause726 =null;
		ParserRuleReturnScope distributeByClause727 =null;
		ParserRuleReturnScope sortByClause728 =null;
		ParserRuleReturnScope window_clause729 =null;
		ParserRuleReturnScope limitClause730 =null;
		ParserRuleReturnScope selectStatement731 =null;

		RewriteRuleSubtreeStream stream_whereClause=new RewriteRuleSubtreeStream(adaptor,"rule whereClause");
		RewriteRuleSubtreeStream stream_window_clause=new RewriteRuleSubtreeStream(adaptor,"rule window_clause");
		RewriteRuleSubtreeStream stream_clusterByClause=new RewriteRuleSubtreeStream(adaptor,"rule clusterByClause");
		RewriteRuleSubtreeStream stream_distributeByClause=new RewriteRuleSubtreeStream(adaptor,"rule distributeByClause");
		RewriteRuleSubtreeStream stream_limitClause=new RewriteRuleSubtreeStream(adaptor,"rule limitClause");
		RewriteRuleSubtreeStream stream_orderByClause=new RewriteRuleSubtreeStream(adaptor,"rule orderByClause");
		RewriteRuleSubtreeStream stream_sortByClause=new RewriteRuleSubtreeStream(adaptor,"rule sortByClause");
		RewriteRuleSubtreeStream stream_insertClause=new RewriteRuleSubtreeStream(adaptor,"rule insertClause");
		RewriteRuleSubtreeStream stream_groupByClause=new RewriteRuleSubtreeStream(adaptor,"rule groupByClause");
		RewriteRuleSubtreeStream stream_havingClause=new RewriteRuleSubtreeStream(adaptor,"rule havingClause");
		RewriteRuleSubtreeStream stream_selectClause=new RewriteRuleSubtreeStream(adaptor,"rule selectClause");
		RewriteRuleSubtreeStream stream_fromClause=new RewriteRuleSubtreeStream(adaptor,"rule fromClause");

		try {
			// HiveParser.g:1835:4: ( insertClause selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_QUERY fromClause ^( TOK_INSERT insertClause selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) ) | selectStatement )
			int alt199=2;
			int LA199_0 = input.LA(1);
			if ( (LA199_0==KW_INSERT) ) {
				alt199=1;
			}
			else if ( (LA199_0==KW_MAP||LA199_0==KW_REDUCE||LA199_0==KW_SELECT) ) {
				alt199=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 199, 0, input);
				throw nvae;
			}

			switch (alt199) {
				case 1 :
					// HiveParser.g:1836:4: insertClause selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )?
					{
					pushFollow(FOLLOW_insertClause_in_regular_body11458);
					insertClause719=insertClause();
					state._fsp--;

					stream_insertClause.add(insertClause719.getTree());
					pushFollow(FOLLOW_selectClause_in_regular_body11463);
					selectClause720=selectClause();
					state._fsp--;

					stream_selectClause.add(selectClause720.getTree());
					pushFollow(FOLLOW_fromClause_in_regular_body11468);
					fromClause721=fromClause();
					state._fsp--;

					stream_fromClause.add(fromClause721.getTree());
					// HiveParser.g:1839:4: ( whereClause )?
					int alt190=2;
					int LA190_0 = input.LA(1);
					if ( (LA190_0==KW_WHERE) ) {
						alt190=1;
					}
					switch (alt190) {
						case 1 :
							// HiveParser.g:1839:4: whereClause
							{
							pushFollow(FOLLOW_whereClause_in_regular_body11473);
							whereClause722=whereClause();
							state._fsp--;

							stream_whereClause.add(whereClause722.getTree());
							}
							break;

					}

					// HiveParser.g:1840:4: ( groupByClause )?
					int alt191=2;
					int LA191_0 = input.LA(1);
					if ( (LA191_0==KW_GROUP) ) {
						alt191=1;
					}
					switch (alt191) {
						case 1 :
							// HiveParser.g:1840:4: groupByClause
							{
							pushFollow(FOLLOW_groupByClause_in_regular_body11479);
							groupByClause723=groupByClause();
							state._fsp--;

							stream_groupByClause.add(groupByClause723.getTree());
							}
							break;

					}

					// HiveParser.g:1841:4: ( havingClause )?
					int alt192=2;
					int LA192_0 = input.LA(1);
					if ( (LA192_0==KW_HAVING) ) {
						alt192=1;
					}
					switch (alt192) {
						case 1 :
							// HiveParser.g:1841:4: havingClause
							{
							pushFollow(FOLLOW_havingClause_in_regular_body11485);
							havingClause724=havingClause();
							state._fsp--;

							stream_havingClause.add(havingClause724.getTree());
							}
							break;

					}

					// HiveParser.g:1842:4: ( orderByClause )?
					int alt193=2;
					int LA193_0 = input.LA(1);
					if ( (LA193_0==KW_ORDER) ) {
						alt193=1;
					}
					switch (alt193) {
						case 1 :
							// HiveParser.g:1842:4: orderByClause
							{
							pushFollow(FOLLOW_orderByClause_in_regular_body11491);
							orderByClause725=orderByClause();
							state._fsp--;

							stream_orderByClause.add(orderByClause725.getTree());
							}
							break;

					}

					// HiveParser.g:1843:4: ( clusterByClause )?
					int alt194=2;
					int LA194_0 = input.LA(1);
					if ( (LA194_0==KW_CLUSTER) ) {
						alt194=1;
					}
					switch (alt194) {
						case 1 :
							// HiveParser.g:1843:4: clusterByClause
							{
							pushFollow(FOLLOW_clusterByClause_in_regular_body11497);
							clusterByClause726=clusterByClause();
							state._fsp--;

							stream_clusterByClause.add(clusterByClause726.getTree());
							}
							break;

					}

					// HiveParser.g:1844:4: ( distributeByClause )?
					int alt195=2;
					int LA195_0 = input.LA(1);
					if ( (LA195_0==KW_DISTRIBUTE) ) {
						alt195=1;
					}
					switch (alt195) {
						case 1 :
							// HiveParser.g:1844:4: distributeByClause
							{
							pushFollow(FOLLOW_distributeByClause_in_regular_body11503);
							distributeByClause727=distributeByClause();
							state._fsp--;

							stream_distributeByClause.add(distributeByClause727.getTree());
							}
							break;

					}

					// HiveParser.g:1845:4: ( sortByClause )?
					int alt196=2;
					int LA196_0 = input.LA(1);
					if ( (LA196_0==KW_SORT) ) {
						alt196=1;
					}
					switch (alt196) {
						case 1 :
							// HiveParser.g:1845:4: sortByClause
							{
							pushFollow(FOLLOW_sortByClause_in_regular_body11509);
							sortByClause728=sortByClause();
							state._fsp--;

							stream_sortByClause.add(sortByClause728.getTree());
							}
							break;

					}

					// HiveParser.g:1846:4: ( window_clause )?
					int alt197=2;
					int LA197_0 = input.LA(1);
					if ( (LA197_0==KW_WINDOW) ) {
						alt197=1;
					}
					switch (alt197) {
						case 1 :
							// HiveParser.g:1846:4: window_clause
							{
							pushFollow(FOLLOW_window_clause_in_regular_body11515);
							window_clause729=window_clause();
							state._fsp--;

							stream_window_clause.add(window_clause729.getTree());
							}
							break;

					}

					// HiveParser.g:1847:4: ( limitClause )?
					int alt198=2;
					int LA198_0 = input.LA(1);
					if ( (LA198_0==KW_LIMIT) ) {
						alt198=1;
					}
					switch (alt198) {
						case 1 :
							// HiveParser.g:1847:4: limitClause
							{
							pushFollow(FOLLOW_limitClause_in_regular_body11521);
							limitClause730=limitClause();
							state._fsp--;

							stream_limitClause.add(limitClause730.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: whereClause, selectClause, insertClause, distributeByClause, orderByClause, window_clause, fromClause, groupByClause, sortByClause, limitClause, clusterByClause, havingClause
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1847:17: -> ^( TOK_QUERY fromClause ^( TOK_INSERT insertClause selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) )
					{
						// HiveParser.g:1847:20: ^( TOK_QUERY fromClause ^( TOK_INSERT insertClause selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_QUERY, "TOK_QUERY"), root_1);
						adaptor.addChild(root_1, stream_fromClause.nextTree());
						// HiveParser.g:1847:43: ^( TOK_INSERT insertClause selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
						{
						CommonTree root_2 = (CommonTree)adaptor.nil();
						root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INSERT, "TOK_INSERT"), root_2);
						adaptor.addChild(root_2, stream_insertClause.nextTree());
						adaptor.addChild(root_2, stream_selectClause.nextTree());
						// HiveParser.g:1848:35: ( whereClause )?
						if ( stream_whereClause.hasNext() ) {
							adaptor.addChild(root_2, stream_whereClause.nextTree());
						}
						stream_whereClause.reset();

						// HiveParser.g:1848:48: ( groupByClause )?
						if ( stream_groupByClause.hasNext() ) {
							adaptor.addChild(root_2, stream_groupByClause.nextTree());
						}
						stream_groupByClause.reset();

						// HiveParser.g:1848:63: ( havingClause )?
						if ( stream_havingClause.hasNext() ) {
							adaptor.addChild(root_2, stream_havingClause.nextTree());
						}
						stream_havingClause.reset();

						// HiveParser.g:1848:77: ( orderByClause )?
						if ( stream_orderByClause.hasNext() ) {
							adaptor.addChild(root_2, stream_orderByClause.nextTree());
						}
						stream_orderByClause.reset();

						// HiveParser.g:1848:92: ( clusterByClause )?
						if ( stream_clusterByClause.hasNext() ) {
							adaptor.addChild(root_2, stream_clusterByClause.nextTree());
						}
						stream_clusterByClause.reset();

						// HiveParser.g:1849:22: ( distributeByClause )?
						if ( stream_distributeByClause.hasNext() ) {
							adaptor.addChild(root_2, stream_distributeByClause.nextTree());
						}
						stream_distributeByClause.reset();

						// HiveParser.g:1849:42: ( sortByClause )?
						if ( stream_sortByClause.hasNext() ) {
							adaptor.addChild(root_2, stream_sortByClause.nextTree());
						}
						stream_sortByClause.reset();

						// HiveParser.g:1849:56: ( window_clause )?
						if ( stream_window_clause.hasNext() ) {
							adaptor.addChild(root_2, stream_window_clause.nextTree());
						}
						stream_window_clause.reset();

						// HiveParser.g:1849:71: ( limitClause )?
						if ( stream_limitClause.hasNext() ) {
							adaptor.addChild(root_2, stream_limitClause.nextTree());
						}
						stream_limitClause.reset();

						adaptor.addChild(root_1, root_2);
						}

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1851:4: selectStatement
					{
					root_0 = (CommonTree)adaptor.nil();


					pushFollow(FOLLOW_selectStatement_in_regular_body11617);
					selectStatement731=selectStatement();
					state._fsp--;

					adaptor.addChild(root_0, selectStatement731.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "regular_body"


	public static class selectStatement_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "selectStatement"
	// HiveParser.g:1854:1: selectStatement : selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_QUERY fromClause ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) ) ;
	public final HiveParser.selectStatement_return selectStatement() throws RecognitionException {
		HiveParser.selectStatement_return retval = new HiveParser.selectStatement_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope selectClause732 =null;
		ParserRuleReturnScope fromClause733 =null;
		ParserRuleReturnScope whereClause734 =null;
		ParserRuleReturnScope groupByClause735 =null;
		ParserRuleReturnScope havingClause736 =null;
		ParserRuleReturnScope orderByClause737 =null;
		ParserRuleReturnScope clusterByClause738 =null;
		ParserRuleReturnScope distributeByClause739 =null;
		ParserRuleReturnScope sortByClause740 =null;
		ParserRuleReturnScope window_clause741 =null;
		ParserRuleReturnScope limitClause742 =null;

		RewriteRuleSubtreeStream stream_whereClause=new RewriteRuleSubtreeStream(adaptor,"rule whereClause");
		RewriteRuleSubtreeStream stream_window_clause=new RewriteRuleSubtreeStream(adaptor,"rule window_clause");
		RewriteRuleSubtreeStream stream_clusterByClause=new RewriteRuleSubtreeStream(adaptor,"rule clusterByClause");
		RewriteRuleSubtreeStream stream_distributeByClause=new RewriteRuleSubtreeStream(adaptor,"rule distributeByClause");
		RewriteRuleSubtreeStream stream_limitClause=new RewriteRuleSubtreeStream(adaptor,"rule limitClause");
		RewriteRuleSubtreeStream stream_orderByClause=new RewriteRuleSubtreeStream(adaptor,"rule orderByClause");
		RewriteRuleSubtreeStream stream_sortByClause=new RewriteRuleSubtreeStream(adaptor,"rule sortByClause");
		RewriteRuleSubtreeStream stream_groupByClause=new RewriteRuleSubtreeStream(adaptor,"rule groupByClause");
		RewriteRuleSubtreeStream stream_havingClause=new RewriteRuleSubtreeStream(adaptor,"rule havingClause");
		RewriteRuleSubtreeStream stream_selectClause=new RewriteRuleSubtreeStream(adaptor,"rule selectClause");
		RewriteRuleSubtreeStream stream_fromClause=new RewriteRuleSubtreeStream(adaptor,"rule fromClause");

		try {
			// HiveParser.g:1855:4: ( selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_QUERY fromClause ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) ) )
			// HiveParser.g:1856:4: selectClause fromClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )?
			{
			pushFollow(FOLLOW_selectClause_in_selectStatement11635);
			selectClause732=selectClause();
			state._fsp--;

			stream_selectClause.add(selectClause732.getTree());
			pushFollow(FOLLOW_fromClause_in_selectStatement11640);
			fromClause733=fromClause();
			state._fsp--;

			stream_fromClause.add(fromClause733.getTree());
			// HiveParser.g:1858:4: ( whereClause )?
			int alt200=2;
			int LA200_0 = input.LA(1);
			if ( (LA200_0==KW_WHERE) ) {
				alt200=1;
			}
			switch (alt200) {
				case 1 :
					// HiveParser.g:1858:4: whereClause
					{
					pushFollow(FOLLOW_whereClause_in_selectStatement11645);
					whereClause734=whereClause();
					state._fsp--;

					stream_whereClause.add(whereClause734.getTree());
					}
					break;

			}

			// HiveParser.g:1859:4: ( groupByClause )?
			int alt201=2;
			int LA201_0 = input.LA(1);
			if ( (LA201_0==KW_GROUP) ) {
				alt201=1;
			}
			switch (alt201) {
				case 1 :
					// HiveParser.g:1859:4: groupByClause
					{
					pushFollow(FOLLOW_groupByClause_in_selectStatement11651);
					groupByClause735=groupByClause();
					state._fsp--;

					stream_groupByClause.add(groupByClause735.getTree());
					}
					break;

			}

			// HiveParser.g:1860:4: ( havingClause )?
			int alt202=2;
			int LA202_0 = input.LA(1);
			if ( (LA202_0==KW_HAVING) ) {
				alt202=1;
			}
			switch (alt202) {
				case 1 :
					// HiveParser.g:1860:4: havingClause
					{
					pushFollow(FOLLOW_havingClause_in_selectStatement11657);
					havingClause736=havingClause();
					state._fsp--;

					stream_havingClause.add(havingClause736.getTree());
					}
					break;

			}

			// HiveParser.g:1861:4: ( orderByClause )?
			int alt203=2;
			int LA203_0 = input.LA(1);
			if ( (LA203_0==KW_ORDER) ) {
				alt203=1;
			}
			switch (alt203) {
				case 1 :
					// HiveParser.g:1861:4: orderByClause
					{
					pushFollow(FOLLOW_orderByClause_in_selectStatement11663);
					orderByClause737=orderByClause();
					state._fsp--;

					stream_orderByClause.add(orderByClause737.getTree());
					}
					break;

			}

			// HiveParser.g:1862:4: ( clusterByClause )?
			int alt204=2;
			int LA204_0 = input.LA(1);
			if ( (LA204_0==KW_CLUSTER) ) {
				alt204=1;
			}
			switch (alt204) {
				case 1 :
					// HiveParser.g:1862:4: clusterByClause
					{
					pushFollow(FOLLOW_clusterByClause_in_selectStatement11669);
					clusterByClause738=clusterByClause();
					state._fsp--;

					stream_clusterByClause.add(clusterByClause738.getTree());
					}
					break;

			}

			// HiveParser.g:1863:4: ( distributeByClause )?
			int alt205=2;
			int LA205_0 = input.LA(1);
			if ( (LA205_0==KW_DISTRIBUTE) ) {
				alt205=1;
			}
			switch (alt205) {
				case 1 :
					// HiveParser.g:1863:4: distributeByClause
					{
					pushFollow(FOLLOW_distributeByClause_in_selectStatement11675);
					distributeByClause739=distributeByClause();
					state._fsp--;

					stream_distributeByClause.add(distributeByClause739.getTree());
					}
					break;

			}

			// HiveParser.g:1864:4: ( sortByClause )?
			int alt206=2;
			int LA206_0 = input.LA(1);
			if ( (LA206_0==KW_SORT) ) {
				alt206=1;
			}
			switch (alt206) {
				case 1 :
					// HiveParser.g:1864:4: sortByClause
					{
					pushFollow(FOLLOW_sortByClause_in_selectStatement11681);
					sortByClause740=sortByClause();
					state._fsp--;

					stream_sortByClause.add(sortByClause740.getTree());
					}
					break;

			}

			// HiveParser.g:1865:4: ( window_clause )?
			int alt207=2;
			int LA207_0 = input.LA(1);
			if ( (LA207_0==KW_WINDOW) ) {
				alt207=1;
			}
			switch (alt207) {
				case 1 :
					// HiveParser.g:1865:4: window_clause
					{
					pushFollow(FOLLOW_window_clause_in_selectStatement11687);
					window_clause741=window_clause();
					state._fsp--;

					stream_window_clause.add(window_clause741.getTree());
					}
					break;

			}

			// HiveParser.g:1866:4: ( limitClause )?
			int alt208=2;
			int LA208_0 = input.LA(1);
			if ( (LA208_0==KW_LIMIT) ) {
				alt208=1;
			}
			switch (alt208) {
				case 1 :
					// HiveParser.g:1866:4: limitClause
					{
					pushFollow(FOLLOW_limitClause_in_selectStatement11693);
					limitClause742=limitClause();
					state._fsp--;

					stream_limitClause.add(limitClause742.getTree());
					}
					break;

			}

			// AST REWRITE
			// elements: orderByClause, window_clause, whereClause, fromClause, distributeByClause, groupByClause, sortByClause, havingClause, selectClause, limitClause, clusterByClause
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1866:17: -> ^( TOK_QUERY fromClause ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) )
			{
				// HiveParser.g:1866:20: ^( TOK_QUERY fromClause ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) )
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_QUERY, "TOK_QUERY"), root_1);
				adaptor.addChild(root_1, stream_fromClause.nextTree());
				// HiveParser.g:1866:43: ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
				{
				CommonTree root_2 = (CommonTree)adaptor.nil();
				root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INSERT, "TOK_INSERT"), root_2);
				// HiveParser.g:1866:56: ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) )
				{
				CommonTree root_3 = (CommonTree)adaptor.nil();
				root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESTINATION, "TOK_DESTINATION"), root_3);
				// HiveParser.g:1866:74: ^( TOK_DIR TOK_TMP_FILE )
				{
				CommonTree root_4 = (CommonTree)adaptor.nil();
				root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DIR, "TOK_DIR"), root_4);
				adaptor.addChild(root_4, (CommonTree)adaptor.create(TOK_TMP_FILE, "TOK_TMP_FILE"));
				adaptor.addChild(root_3, root_4);
				}

				adaptor.addChild(root_2, root_3);
				}

				adaptor.addChild(root_2, stream_selectClause.nextTree());
				// HiveParser.g:1867:35: ( whereClause )?
				if ( stream_whereClause.hasNext() ) {
					adaptor.addChild(root_2, stream_whereClause.nextTree());
				}
				stream_whereClause.reset();

				// HiveParser.g:1867:48: ( groupByClause )?
				if ( stream_groupByClause.hasNext() ) {
					adaptor.addChild(root_2, stream_groupByClause.nextTree());
				}
				stream_groupByClause.reset();

				// HiveParser.g:1867:63: ( havingClause )?
				if ( stream_havingClause.hasNext() ) {
					adaptor.addChild(root_2, stream_havingClause.nextTree());
				}
				stream_havingClause.reset();

				// HiveParser.g:1867:77: ( orderByClause )?
				if ( stream_orderByClause.hasNext() ) {
					adaptor.addChild(root_2, stream_orderByClause.nextTree());
				}
				stream_orderByClause.reset();

				// HiveParser.g:1867:92: ( clusterByClause )?
				if ( stream_clusterByClause.hasNext() ) {
					adaptor.addChild(root_2, stream_clusterByClause.nextTree());
				}
				stream_clusterByClause.reset();

				// HiveParser.g:1868:22: ( distributeByClause )?
				if ( stream_distributeByClause.hasNext() ) {
					adaptor.addChild(root_2, stream_distributeByClause.nextTree());
				}
				stream_distributeByClause.reset();

				// HiveParser.g:1868:42: ( sortByClause )?
				if ( stream_sortByClause.hasNext() ) {
					adaptor.addChild(root_2, stream_sortByClause.nextTree());
				}
				stream_sortByClause.reset();

				// HiveParser.g:1868:56: ( window_clause )?
				if ( stream_window_clause.hasNext() ) {
					adaptor.addChild(root_2, stream_window_clause.nextTree());
				}
				stream_window_clause.reset();

				// HiveParser.g:1868:71: ( limitClause )?
				if ( stream_limitClause.hasNext() ) {
					adaptor.addChild(root_2, stream_limitClause.nextTree());
				}
				stream_limitClause.reset();

				adaptor.addChild(root_1, root_2);
				}

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "selectStatement"


	public static class body_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "body"
	// HiveParser.g:1872:1: body : ( insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_INSERT insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) | selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) );
	public final HiveParser.body_return body() throws RecognitionException {
		HiveParser.body_return retval = new HiveParser.body_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		ParserRuleReturnScope insertClause743 =null;
		ParserRuleReturnScope selectClause744 =null;
		ParserRuleReturnScope lateralView745 =null;
		ParserRuleReturnScope whereClause746 =null;
		ParserRuleReturnScope groupByClause747 =null;
		ParserRuleReturnScope havingClause748 =null;
		ParserRuleReturnScope orderByClause749 =null;
		ParserRuleReturnScope clusterByClause750 =null;
		ParserRuleReturnScope distributeByClause751 =null;
		ParserRuleReturnScope sortByClause752 =null;
		ParserRuleReturnScope window_clause753 =null;
		ParserRuleReturnScope limitClause754 =null;
		ParserRuleReturnScope selectClause755 =null;
		ParserRuleReturnScope lateralView756 =null;
		ParserRuleReturnScope whereClause757 =null;
		ParserRuleReturnScope groupByClause758 =null;
		ParserRuleReturnScope havingClause759 =null;
		ParserRuleReturnScope orderByClause760 =null;
		ParserRuleReturnScope clusterByClause761 =null;
		ParserRuleReturnScope distributeByClause762 =null;
		ParserRuleReturnScope sortByClause763 =null;
		ParserRuleReturnScope window_clause764 =null;
		ParserRuleReturnScope limitClause765 =null;

		RewriteRuleSubtreeStream stream_whereClause=new RewriteRuleSubtreeStream(adaptor,"rule whereClause");
		RewriteRuleSubtreeStream stream_window_clause=new RewriteRuleSubtreeStream(adaptor,"rule window_clause");
		RewriteRuleSubtreeStream stream_clusterByClause=new RewriteRuleSubtreeStream(adaptor,"rule clusterByClause");
		RewriteRuleSubtreeStream stream_distributeByClause=new RewriteRuleSubtreeStream(adaptor,"rule distributeByClause");
		RewriteRuleSubtreeStream stream_lateralView=new RewriteRuleSubtreeStream(adaptor,"rule lateralView");
		RewriteRuleSubtreeStream stream_limitClause=new RewriteRuleSubtreeStream(adaptor,"rule limitClause");
		RewriteRuleSubtreeStream stream_orderByClause=new RewriteRuleSubtreeStream(adaptor,"rule orderByClause");
		RewriteRuleSubtreeStream stream_sortByClause=new RewriteRuleSubtreeStream(adaptor,"rule sortByClause");
		RewriteRuleSubtreeStream stream_insertClause=new RewriteRuleSubtreeStream(adaptor,"rule insertClause");
		RewriteRuleSubtreeStream stream_groupByClause=new RewriteRuleSubtreeStream(adaptor,"rule groupByClause");
		RewriteRuleSubtreeStream stream_havingClause=new RewriteRuleSubtreeStream(adaptor,"rule havingClause");
		RewriteRuleSubtreeStream stream_selectClause=new RewriteRuleSubtreeStream(adaptor,"rule selectClause");

		try {
			// HiveParser.g:1873:4: ( insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_INSERT insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) | selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? -> ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? ) )
			int alt229=2;
			int LA229_0 = input.LA(1);
			if ( (LA229_0==KW_INSERT) ) {
				alt229=1;
			}
			else if ( (LA229_0==KW_MAP||LA229_0==KW_REDUCE||LA229_0==KW_SELECT) ) {
				alt229=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 229, 0, input);
				throw nvae;
			}

			switch (alt229) {
				case 1 :
					// HiveParser.g:1874:4: insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )?
					{
					pushFollow(FOLLOW_insertClause_in_body11806);
					insertClause743=insertClause();
					state._fsp--;

					stream_insertClause.add(insertClause743.getTree());
					pushFollow(FOLLOW_selectClause_in_body11811);
					selectClause744=selectClause();
					state._fsp--;

					stream_selectClause.add(selectClause744.getTree());
					// HiveParser.g:1876:4: ( lateralView )?
					int alt209=2;
					int LA209_0 = input.LA(1);
					if ( (LA209_0==KW_LATERAL) ) {
						alt209=1;
					}
					switch (alt209) {
						case 1 :
							// HiveParser.g:1876:4: lateralView
							{
							pushFollow(FOLLOW_lateralView_in_body11816);
							lateralView745=lateralView();
							state._fsp--;

							stream_lateralView.add(lateralView745.getTree());
							}
							break;

					}

					// HiveParser.g:1877:4: ( whereClause )?
					int alt210=2;
					int LA210_0 = input.LA(1);
					if ( (LA210_0==KW_WHERE) ) {
						alt210=1;
					}
					switch (alt210) {
						case 1 :
							// HiveParser.g:1877:4: whereClause
							{
							pushFollow(FOLLOW_whereClause_in_body11822);
							whereClause746=whereClause();
							state._fsp--;

							stream_whereClause.add(whereClause746.getTree());
							}
							break;

					}

					// HiveParser.g:1878:4: ( groupByClause )?
					int alt211=2;
					int LA211_0 = input.LA(1);
					if ( (LA211_0==KW_GROUP) ) {
						alt211=1;
					}
					switch (alt211) {
						case 1 :
							// HiveParser.g:1878:4: groupByClause
							{
							pushFollow(FOLLOW_groupByClause_in_body11828);
							groupByClause747=groupByClause();
							state._fsp--;

							stream_groupByClause.add(groupByClause747.getTree());
							}
							break;

					}

					// HiveParser.g:1879:4: ( havingClause )?
					int alt212=2;
					int LA212_0 = input.LA(1);
					if ( (LA212_0==KW_HAVING) ) {
						alt212=1;
					}
					switch (alt212) {
						case 1 :
							// HiveParser.g:1879:4: havingClause
							{
							pushFollow(FOLLOW_havingClause_in_body11834);
							havingClause748=havingClause();
							state._fsp--;

							stream_havingClause.add(havingClause748.getTree());
							}
							break;

					}

					// HiveParser.g:1880:4: ( orderByClause )?
					int alt213=2;
					int LA213_0 = input.LA(1);
					if ( (LA213_0==KW_ORDER) ) {
						alt213=1;
					}
					switch (alt213) {
						case 1 :
							// HiveParser.g:1880:4: orderByClause
							{
							pushFollow(FOLLOW_orderByClause_in_body11840);
							orderByClause749=orderByClause();
							state._fsp--;

							stream_orderByClause.add(orderByClause749.getTree());
							}
							break;

					}

					// HiveParser.g:1881:4: ( clusterByClause )?
					int alt214=2;
					int LA214_0 = input.LA(1);
					if ( (LA214_0==KW_CLUSTER) ) {
						alt214=1;
					}
					switch (alt214) {
						case 1 :
							// HiveParser.g:1881:4: clusterByClause
							{
							pushFollow(FOLLOW_clusterByClause_in_body11846);
							clusterByClause750=clusterByClause();
							state._fsp--;

							stream_clusterByClause.add(clusterByClause750.getTree());
							}
							break;

					}

					// HiveParser.g:1882:4: ( distributeByClause )?
					int alt215=2;
					int LA215_0 = input.LA(1);
					if ( (LA215_0==KW_DISTRIBUTE) ) {
						alt215=1;
					}
					switch (alt215) {
						case 1 :
							// HiveParser.g:1882:4: distributeByClause
							{
							pushFollow(FOLLOW_distributeByClause_in_body11852);
							distributeByClause751=distributeByClause();
							state._fsp--;

							stream_distributeByClause.add(distributeByClause751.getTree());
							}
							break;

					}

					// HiveParser.g:1883:4: ( sortByClause )?
					int alt216=2;
					int LA216_0 = input.LA(1);
					if ( (LA216_0==KW_SORT) ) {
						alt216=1;
					}
					switch (alt216) {
						case 1 :
							// HiveParser.g:1883:4: sortByClause
							{
							pushFollow(FOLLOW_sortByClause_in_body11858);
							sortByClause752=sortByClause();
							state._fsp--;

							stream_sortByClause.add(sortByClause752.getTree());
							}
							break;

					}

					// HiveParser.g:1884:4: ( window_clause )?
					int alt217=2;
					int LA217_0 = input.LA(1);
					if ( (LA217_0==KW_WINDOW) ) {
						alt217=1;
					}
					switch (alt217) {
						case 1 :
							// HiveParser.g:1884:4: window_clause
							{
							pushFollow(FOLLOW_window_clause_in_body11864);
							window_clause753=window_clause();
							state._fsp--;

							stream_window_clause.add(window_clause753.getTree());
							}
							break;

					}

					// HiveParser.g:1885:4: ( limitClause )?
					int alt218=2;
					int LA218_0 = input.LA(1);
					if ( (LA218_0==KW_LIMIT) ) {
						alt218=1;
					}
					switch (alt218) {
						case 1 :
							// HiveParser.g:1885:4: limitClause
							{
							pushFollow(FOLLOW_limitClause_in_body11870);
							limitClause754=limitClause();
							state._fsp--;

							stream_limitClause.add(limitClause754.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: sortByClause, distributeByClause, orderByClause, clusterByClause, window_clause, groupByClause, lateralView, whereClause, havingClause, selectClause, insertClause, limitClause
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1885:17: -> ^( TOK_INSERT insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
					{
						// HiveParser.g:1885:20: ^( TOK_INSERT insertClause selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INSERT, "TOK_INSERT"), root_1);
						adaptor.addChild(root_1, stream_insertClause.nextTree());
						adaptor.addChild(root_1, stream_selectClause.nextTree());
						// HiveParser.g:1886:35: ( lateralView )?
						if ( stream_lateralView.hasNext() ) {
							adaptor.addChild(root_1, stream_lateralView.nextTree());
						}
						stream_lateralView.reset();

						// HiveParser.g:1886:48: ( whereClause )?
						if ( stream_whereClause.hasNext() ) {
							adaptor.addChild(root_1, stream_whereClause.nextTree());
						}
						stream_whereClause.reset();

						// HiveParser.g:1886:61: ( groupByClause )?
						if ( stream_groupByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_groupByClause.nextTree());
						}
						stream_groupByClause.reset();

						// HiveParser.g:1886:76: ( havingClause )?
						if ( stream_havingClause.hasNext() ) {
							adaptor.addChild(root_1, stream_havingClause.nextTree());
						}
						stream_havingClause.reset();

						// HiveParser.g:1886:90: ( orderByClause )?
						if ( stream_orderByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_orderByClause.nextTree());
						}
						stream_orderByClause.reset();

						// HiveParser.g:1886:105: ( clusterByClause )?
						if ( stream_clusterByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_clusterByClause.nextTree());
						}
						stream_clusterByClause.reset();

						// HiveParser.g:1887:22: ( distributeByClause )?
						if ( stream_distributeByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_distributeByClause.nextTree());
						}
						stream_distributeByClause.reset();

						// HiveParser.g:1887:42: ( sortByClause )?
						if ( stream_sortByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_sortByClause.nextTree());
						}
						stream_sortByClause.reset();

						// HiveParser.g:1887:56: ( window_clause )?
						if ( stream_window_clause.hasNext() ) {
							adaptor.addChild(root_1, stream_window_clause.nextTree());
						}
						stream_window_clause.reset();

						// HiveParser.g:1887:71: ( limitClause )?
						if ( stream_limitClause.hasNext() ) {
							adaptor.addChild(root_1, stream_limitClause.nextTree());
						}
						stream_limitClause.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1889:4: selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )?
					{
					pushFollow(FOLLOW_selectClause_in_body11963);
					selectClause755=selectClause();
					state._fsp--;

					stream_selectClause.add(selectClause755.getTree());
					// HiveParser.g:1890:4: ( lateralView )?
					int alt219=2;
					int LA219_0 = input.LA(1);
					if ( (LA219_0==KW_LATERAL) ) {
						alt219=1;
					}
					switch (alt219) {
						case 1 :
							// HiveParser.g:1890:4: lateralView
							{
							pushFollow(FOLLOW_lateralView_in_body11968);
							lateralView756=lateralView();
							state._fsp--;

							stream_lateralView.add(lateralView756.getTree());
							}
							break;

					}

					// HiveParser.g:1891:4: ( whereClause )?
					int alt220=2;
					int LA220_0 = input.LA(1);
					if ( (LA220_0==KW_WHERE) ) {
						alt220=1;
					}
					switch (alt220) {
						case 1 :
							// HiveParser.g:1891:4: whereClause
							{
							pushFollow(FOLLOW_whereClause_in_body11974);
							whereClause757=whereClause();
							state._fsp--;

							stream_whereClause.add(whereClause757.getTree());
							}
							break;

					}

					// HiveParser.g:1892:4: ( groupByClause )?
					int alt221=2;
					int LA221_0 = input.LA(1);
					if ( (LA221_0==KW_GROUP) ) {
						alt221=1;
					}
					switch (alt221) {
						case 1 :
							// HiveParser.g:1892:4: groupByClause
							{
							pushFollow(FOLLOW_groupByClause_in_body11980);
							groupByClause758=groupByClause();
							state._fsp--;

							stream_groupByClause.add(groupByClause758.getTree());
							}
							break;

					}

					// HiveParser.g:1893:4: ( havingClause )?
					int alt222=2;
					int LA222_0 = input.LA(1);
					if ( (LA222_0==KW_HAVING) ) {
						alt222=1;
					}
					switch (alt222) {
						case 1 :
							// HiveParser.g:1893:4: havingClause
							{
							pushFollow(FOLLOW_havingClause_in_body11986);
							havingClause759=havingClause();
							state._fsp--;

							stream_havingClause.add(havingClause759.getTree());
							}
							break;

					}

					// HiveParser.g:1894:4: ( orderByClause )?
					int alt223=2;
					int LA223_0 = input.LA(1);
					if ( (LA223_0==KW_ORDER) ) {
						alt223=1;
					}
					switch (alt223) {
						case 1 :
							// HiveParser.g:1894:4: orderByClause
							{
							pushFollow(FOLLOW_orderByClause_in_body11992);
							orderByClause760=orderByClause();
							state._fsp--;

							stream_orderByClause.add(orderByClause760.getTree());
							}
							break;

					}

					// HiveParser.g:1895:4: ( clusterByClause )?
					int alt224=2;
					int LA224_0 = input.LA(1);
					if ( (LA224_0==KW_CLUSTER) ) {
						alt224=1;
					}
					switch (alt224) {
						case 1 :
							// HiveParser.g:1895:4: clusterByClause
							{
							pushFollow(FOLLOW_clusterByClause_in_body11998);
							clusterByClause761=clusterByClause();
							state._fsp--;

							stream_clusterByClause.add(clusterByClause761.getTree());
							}
							break;

					}

					// HiveParser.g:1896:4: ( distributeByClause )?
					int alt225=2;
					int LA225_0 = input.LA(1);
					if ( (LA225_0==KW_DISTRIBUTE) ) {
						alt225=1;
					}
					switch (alt225) {
						case 1 :
							// HiveParser.g:1896:4: distributeByClause
							{
							pushFollow(FOLLOW_distributeByClause_in_body12004);
							distributeByClause762=distributeByClause();
							state._fsp--;

							stream_distributeByClause.add(distributeByClause762.getTree());
							}
							break;

					}

					// HiveParser.g:1897:4: ( sortByClause )?
					int alt226=2;
					int LA226_0 = input.LA(1);
					if ( (LA226_0==KW_SORT) ) {
						alt226=1;
					}
					switch (alt226) {
						case 1 :
							// HiveParser.g:1897:4: sortByClause
							{
							pushFollow(FOLLOW_sortByClause_in_body12010);
							sortByClause763=sortByClause();
							state._fsp--;

							stream_sortByClause.add(sortByClause763.getTree());
							}
							break;

					}

					// HiveParser.g:1898:4: ( window_clause )?
					int alt227=2;
					int LA227_0 = input.LA(1);
					if ( (LA227_0==KW_WINDOW) ) {
						alt227=1;
					}
					switch (alt227) {
						case 1 :
							// HiveParser.g:1898:4: window_clause
							{
							pushFollow(FOLLOW_window_clause_in_body12016);
							window_clause764=window_clause();
							state._fsp--;

							stream_window_clause.add(window_clause764.getTree());
							}
							break;

					}

					// HiveParser.g:1899:4: ( limitClause )?
					int alt228=2;
					int LA228_0 = input.LA(1);
					if ( (LA228_0==KW_LIMIT) ) {
						alt228=1;
					}
					switch (alt228) {
						case 1 :
							// HiveParser.g:1899:4: limitClause
							{
							pushFollow(FOLLOW_limitClause_in_body12022);
							limitClause765=limitClause();
							state._fsp--;

							stream_limitClause.add(limitClause765.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: sortByClause, selectClause, whereClause, distributeByClause, clusterByClause, orderByClause, window_clause, limitClause, havingClause, lateralView, groupByClause
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1899:17: -> ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
					{
						// HiveParser.g:1899:20: ^( TOK_INSERT ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) ) selectClause ( lateralView )? ( whereClause )? ( groupByClause )? ( havingClause )? ( orderByClause )? ( clusterByClause )? ( distributeByClause )? ( sortByClause )? ( window_clause )? ( limitClause )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INSERT, "TOK_INSERT"), root_1);
						// HiveParser.g:1899:33: ^( TOK_DESTINATION ^( TOK_DIR TOK_TMP_FILE ) )
						{
						CommonTree root_2 = (CommonTree)adaptor.nil();
						root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESTINATION, "TOK_DESTINATION"), root_2);
						// HiveParser.g:1899:51: ^( TOK_DIR TOK_TMP_FILE )
						{
						CommonTree root_3 = (CommonTree)adaptor.nil();
						root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DIR, "TOK_DIR"), root_3);
						adaptor.addChild(root_3, (CommonTree)adaptor.create(TOK_TMP_FILE, "TOK_TMP_FILE"));
						adaptor.addChild(root_2, root_3);
						}

						adaptor.addChild(root_1, root_2);
						}

						adaptor.addChild(root_1, stream_selectClause.nextTree());
						// HiveParser.g:1900:35: ( lateralView )?
						if ( stream_lateralView.hasNext() ) {
							adaptor.addChild(root_1, stream_lateralView.nextTree());
						}
						stream_lateralView.reset();

						// HiveParser.g:1900:48: ( whereClause )?
						if ( stream_whereClause.hasNext() ) {
							adaptor.addChild(root_1, stream_whereClause.nextTree());
						}
						stream_whereClause.reset();

						// HiveParser.g:1900:61: ( groupByClause )?
						if ( stream_groupByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_groupByClause.nextTree());
						}
						stream_groupByClause.reset();

						// HiveParser.g:1900:76: ( havingClause )?
						if ( stream_havingClause.hasNext() ) {
							adaptor.addChild(root_1, stream_havingClause.nextTree());
						}
						stream_havingClause.reset();

						// HiveParser.g:1900:90: ( orderByClause )?
						if ( stream_orderByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_orderByClause.nextTree());
						}
						stream_orderByClause.reset();

						// HiveParser.g:1900:105: ( clusterByClause )?
						if ( stream_clusterByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_clusterByClause.nextTree());
						}
						stream_clusterByClause.reset();

						// HiveParser.g:1901:22: ( distributeByClause )?
						if ( stream_distributeByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_distributeByClause.nextTree());
						}
						stream_distributeByClause.reset();

						// HiveParser.g:1901:42: ( sortByClause )?
						if ( stream_sortByClause.hasNext() ) {
							adaptor.addChild(root_1, stream_sortByClause.nextTree());
						}
						stream_sortByClause.reset();

						// HiveParser.g:1901:56: ( window_clause )?
						if ( stream_window_clause.hasNext() ) {
							adaptor.addChild(root_1, stream_window_clause.nextTree());
						}
						stream_window_clause.reset();

						// HiveParser.g:1901:71: ( limitClause )?
						if ( stream_limitClause.hasNext() ) {
							adaptor.addChild(root_1, stream_limitClause.nextTree());
						}
						stream_limitClause.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "body"


	public static class insertClause_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "insertClause"
	// HiveParser.g:1904:1: insertClause : ( KW_INSERT KW_OVERWRITE destination ( ifNotExists )? -> ^( TOK_DESTINATION destination ( ifNotExists )? ) | KW_INSERT KW_INTO KW_TABLE tableOrPartition -> ^( TOK_INSERT_INTO tableOrPartition ) );
	public final HiveParser.insertClause_return insertClause() throws RecognitionException {
		HiveParser.insertClause_return retval = new HiveParser.insertClause_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_INSERT766=null;
		Token KW_OVERWRITE767=null;
		Token KW_INSERT770=null;
		Token KW_INTO771=null;
		Token KW_TABLE772=null;
		ParserRuleReturnScope destination768 =null;
		ParserRuleReturnScope ifNotExists769 =null;
		ParserRuleReturnScope tableOrPartition773 =null;

		CommonTree KW_INSERT766_tree=null;
		CommonTree KW_OVERWRITE767_tree=null;
		CommonTree KW_INSERT770_tree=null;
		CommonTree KW_INTO771_tree=null;
		CommonTree KW_TABLE772_tree=null;
		RewriteRuleTokenStream stream_KW_INTO=new RewriteRuleTokenStream(adaptor,"token KW_INTO");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleTokenStream stream_KW_OVERWRITE=new RewriteRuleTokenStream(adaptor,"token KW_OVERWRITE");
		RewriteRuleTokenStream stream_KW_INSERT=new RewriteRuleTokenStream(adaptor,"token KW_INSERT");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");
		RewriteRuleSubtreeStream stream_ifNotExists=new RewriteRuleSubtreeStream(adaptor,"rule ifNotExists");
		RewriteRuleSubtreeStream stream_destination=new RewriteRuleSubtreeStream(adaptor,"rule destination");

		 msgs.push("insert clause"); 
		try {
			// HiveParser.g:1907:4: ( KW_INSERT KW_OVERWRITE destination ( ifNotExists )? -> ^( TOK_DESTINATION destination ( ifNotExists )? ) | KW_INSERT KW_INTO KW_TABLE tableOrPartition -> ^( TOK_INSERT_INTO tableOrPartition ) )
			int alt231=2;
			int LA231_0 = input.LA(1);
			if ( (LA231_0==KW_INSERT) ) {
				int LA231_1 = input.LA(2);
				if ( (LA231_1==KW_OVERWRITE) ) {
					alt231=1;
				}
				else if ( (LA231_1==KW_INTO) ) {
					alt231=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 231, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 231, 0, input);
				throw nvae;
			}

			switch (alt231) {
				case 1 :
					// HiveParser.g:1908:6: KW_INSERT KW_OVERWRITE destination ( ifNotExists )?
					{
					KW_INSERT766=(Token)match(input,KW_INSERT,FOLLOW_KW_INSERT_in_insertClause12143);  
					stream_KW_INSERT.add(KW_INSERT766);

					KW_OVERWRITE767=(Token)match(input,KW_OVERWRITE,FOLLOW_KW_OVERWRITE_in_insertClause12145);  
					stream_KW_OVERWRITE.add(KW_OVERWRITE767);

					pushFollow(FOLLOW_destination_in_insertClause12147);
					destination768=destination();
					state._fsp--;

					stream_destination.add(destination768.getTree());
					// HiveParser.g:1908:41: ( ifNotExists )?
					int alt230=2;
					int LA230_0 = input.LA(1);
					if ( (LA230_0==KW_IF) ) {
						alt230=1;
					}
					switch (alt230) {
						case 1 :
							// HiveParser.g:1908:41: ifNotExists
							{
							pushFollow(FOLLOW_ifNotExists_in_insertClause12149);
							ifNotExists769=ifNotExists();
							state._fsp--;

							stream_ifNotExists.add(ifNotExists769.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: ifNotExists, destination
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1908:54: -> ^( TOK_DESTINATION destination ( ifNotExists )? )
					{
						// HiveParser.g:1908:57: ^( TOK_DESTINATION destination ( ifNotExists )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DESTINATION, "TOK_DESTINATION"), root_1);
						adaptor.addChild(root_1, stream_destination.nextTree());
						// HiveParser.g:1908:87: ( ifNotExists )?
						if ( stream_ifNotExists.hasNext() ) {
							adaptor.addChild(root_1, stream_ifNotExists.nextTree());
						}
						stream_ifNotExists.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1909:6: KW_INSERT KW_INTO KW_TABLE tableOrPartition
					{
					KW_INSERT770=(Token)match(input,KW_INSERT,FOLLOW_KW_INSERT_in_insertClause12168);  
					stream_KW_INSERT.add(KW_INSERT770);

					KW_INTO771=(Token)match(input,KW_INTO,FOLLOW_KW_INTO_in_insertClause12170);  
					stream_KW_INTO.add(KW_INTO771);

					KW_TABLE772=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_insertClause12172);  
					stream_KW_TABLE.add(KW_TABLE772);

					pushFollow(FOLLOW_tableOrPartition_in_insertClause12174);
					tableOrPartition773=tableOrPartition();
					state._fsp--;

					stream_tableOrPartition.add(tableOrPartition773.getTree());
					// AST REWRITE
					// elements: tableOrPartition
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1910:8: -> ^( TOK_INSERT_INTO tableOrPartition )
					{
						// HiveParser.g:1910:11: ^( TOK_INSERT_INTO tableOrPartition )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_INSERT_INTO, "TOK_INSERT_INTO"), root_1);
						adaptor.addChild(root_1, stream_tableOrPartition.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "insertClause"


	public static class destination_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "destination"
	// HiveParser.g:1913:1: destination : ( KW_LOCAL KW_DIRECTORY StringLiteral ( tableRowFormat )? ( tableFileFormat )? -> ^( TOK_LOCAL_DIR StringLiteral ( tableRowFormat )? ( tableFileFormat )? ) | KW_DIRECTORY StringLiteral -> ^( TOK_DIR StringLiteral ) | KW_TABLE tableOrPartition -> tableOrPartition );
	public final HiveParser.destination_return destination() throws RecognitionException {
		HiveParser.destination_return retval = new HiveParser.destination_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token KW_LOCAL774=null;
		Token KW_DIRECTORY775=null;
		Token StringLiteral776=null;
		Token KW_DIRECTORY779=null;
		Token StringLiteral780=null;
		Token KW_TABLE781=null;
		ParserRuleReturnScope tableRowFormat777 =null;
		ParserRuleReturnScope tableFileFormat778 =null;
		ParserRuleReturnScope tableOrPartition782 =null;

		CommonTree KW_LOCAL774_tree=null;
		CommonTree KW_DIRECTORY775_tree=null;
		CommonTree StringLiteral776_tree=null;
		CommonTree KW_DIRECTORY779_tree=null;
		CommonTree StringLiteral780_tree=null;
		CommonTree KW_TABLE781_tree=null;
		RewriteRuleTokenStream stream_StringLiteral=new RewriteRuleTokenStream(adaptor,"token StringLiteral");
		RewriteRuleTokenStream stream_KW_DIRECTORY=new RewriteRuleTokenStream(adaptor,"token KW_DIRECTORY");
		RewriteRuleTokenStream stream_KW_LOCAL=new RewriteRuleTokenStream(adaptor,"token KW_LOCAL");
		RewriteRuleTokenStream stream_KW_TABLE=new RewriteRuleTokenStream(adaptor,"token KW_TABLE");
		RewriteRuleSubtreeStream stream_tableOrPartition=new RewriteRuleSubtreeStream(adaptor,"rule tableOrPartition");
		RewriteRuleSubtreeStream stream_tableRowFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableRowFormat");
		RewriteRuleSubtreeStream stream_tableFileFormat=new RewriteRuleSubtreeStream(adaptor,"rule tableFileFormat");

		 msgs.push("destination specification"); 
		try {
			// HiveParser.g:1916:4: ( KW_LOCAL KW_DIRECTORY StringLiteral ( tableRowFormat )? ( tableFileFormat )? -> ^( TOK_LOCAL_DIR StringLiteral ( tableRowFormat )? ( tableFileFormat )? ) | KW_DIRECTORY StringLiteral -> ^( TOK_DIR StringLiteral ) | KW_TABLE tableOrPartition -> tableOrPartition )
			int alt234=3;
			switch ( input.LA(1) ) {
			case KW_LOCAL:
				{
				alt234=1;
				}
				break;
			case KW_DIRECTORY:
				{
				alt234=2;
				}
				break;
			case KW_TABLE:
				{
				alt234=3;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 234, 0, input);
				throw nvae;
			}
			switch (alt234) {
				case 1 :
					// HiveParser.g:1917:6: KW_LOCAL KW_DIRECTORY StringLiteral ( tableRowFormat )? ( tableFileFormat )?
					{
					KW_LOCAL774=(Token)match(input,KW_LOCAL,FOLLOW_KW_LOCAL_in_destination12219);  
					stream_KW_LOCAL.add(KW_LOCAL774);

					KW_DIRECTORY775=(Token)match(input,KW_DIRECTORY,FOLLOW_KW_DIRECTORY_in_destination12221);  
					stream_KW_DIRECTORY.add(KW_DIRECTORY775);

					StringLiteral776=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_destination12223);  
					stream_StringLiteral.add(StringLiteral776);

					// HiveParser.g:1917:42: ( tableRowFormat )?
					int alt232=2;
					int LA232_0 = input.LA(1);
					if ( (LA232_0==KW_ROW) ) {
						alt232=1;
					}
					switch (alt232) {
						case 1 :
							// HiveParser.g:1917:42: tableRowFormat
							{
							pushFollow(FOLLOW_tableRowFormat_in_destination12225);
							tableRowFormat777=tableRowFormat();
							state._fsp--;

							stream_tableRowFormat.add(tableRowFormat777.getTree());
							}
							break;

					}

					// HiveParser.g:1917:58: ( tableFileFormat )?
					int alt233=2;
					int LA233_0 = input.LA(1);
					if ( (LA233_0==KW_STORED) ) {
						alt233=1;
					}
					switch (alt233) {
						case 1 :
							// HiveParser.g:1917:58: tableFileFormat
							{
							pushFollow(FOLLOW_tableFileFormat_in_destination12228);
							tableFileFormat778=tableFileFormat();
							state._fsp--;

							stream_tableFileFormat.add(tableFileFormat778.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: tableRowFormat, tableFileFormat, StringLiteral
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1917:75: -> ^( TOK_LOCAL_DIR StringLiteral ( tableRowFormat )? ( tableFileFormat )? )
					{
						// HiveParser.g:1917:78: ^( TOK_LOCAL_DIR StringLiteral ( tableRowFormat )? ( tableFileFormat )? )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LOCAL_DIR, "TOK_LOCAL_DIR"), root_1);
						adaptor.addChild(root_1, stream_StringLiteral.nextNode());
						// HiveParser.g:1917:108: ( tableRowFormat )?
						if ( stream_tableRowFormat.hasNext() ) {
							adaptor.addChild(root_1, stream_tableRowFormat.nextTree());
						}
						stream_tableRowFormat.reset();

						// HiveParser.g:1917:124: ( tableFileFormat )?
						if ( stream_tableFileFormat.hasNext() ) {
							adaptor.addChild(root_1, stream_tableFileFormat.nextTree());
						}
						stream_tableFileFormat.reset();

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// HiveParser.g:1918:6: KW_DIRECTORY StringLiteral
					{
					KW_DIRECTORY779=(Token)match(input,KW_DIRECTORY,FOLLOW_KW_DIRECTORY_in_destination12250);  
					stream_KW_DIRECTORY.add(KW_DIRECTORY779);

					StringLiteral780=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_destination12252);  
					stream_StringLiteral.add(StringLiteral780);

					// AST REWRITE
					// elements: StringLiteral
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1918:33: -> ^( TOK_DIR StringLiteral )
					{
						// HiveParser.g:1918:36: ^( TOK_DIR StringLiteral )
						{
						CommonTree root_1 = (CommonTree)adaptor.nil();
						root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_DIR, "TOK_DIR"), root_1);
						adaptor.addChild(root_1, stream_StringLiteral.nextNode());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 3 :
					// HiveParser.g:1919:6: KW_TABLE tableOrPartition
					{
					KW_TABLE781=(Token)match(input,KW_TABLE,FOLLOW_KW_TABLE_in_destination12267);  
					stream_KW_TABLE.add(KW_TABLE781);

					pushFollow(FOLLOW_tableOrPartition_in_destination12269);
					tableOrPartition782=tableOrPartition();
					state._fsp--;

					stream_tableOrPartition.add(tableOrPartition782.getTree());
					// AST REWRITE
					// elements: tableOrPartition
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CommonTree)adaptor.nil();
					// 1919:32: -> tableOrPartition
					{
						adaptor.addChild(root_0, stream_tableOrPartition.nextTree());
					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "destination"


	public static class limitClause_return extends ParserRuleReturnScope {
		CommonTree tree;
		@Override
		public CommonTree getTree() { return tree; }
	};


	// $ANTLR start "limitClause"
	// HiveParser.g:1922:1: limitClause : KW_LIMIT num= Number -> ^( TOK_LIMIT $num) ;
	public final HiveParser.limitClause_return limitClause() throws RecognitionException {
		HiveParser.limitClause_return retval = new HiveParser.limitClause_return();
		retval.start = input.LT(1);

		CommonTree root_0 = null;

		Token num=null;
		Token KW_LIMIT783=null;

		CommonTree num_tree=null;
		CommonTree KW_LIMIT783_tree=null;
		RewriteRuleTokenStream stream_Number=new RewriteRuleTokenStream(adaptor,"token Number");
		RewriteRuleTokenStream stream_KW_LIMIT=new RewriteRuleTokenStream(adaptor,"token KW_LIMIT");

		 msgs.push("limit clause"); 
		try {
			// HiveParser.g:1925:4: ( KW_LIMIT num= Number -> ^( TOK_LIMIT $num) )
			// HiveParser.g:1926:4: KW_LIMIT num= Number
			{
			KW_LIMIT783=(Token)match(input,KW_LIMIT,FOLLOW_KW_LIMIT_in_limitClause12301);  
			stream_KW_LIMIT.add(KW_LIMIT783);

			num=(Token)match(input,Number,FOLLOW_Number_in_limitClause12305);  
			stream_Number.add(num);

			// AST REWRITE
			// elements: num
			// token labels: num
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleTokenStream stream_num=new RewriteRuleTokenStream(adaptor,"token num",num);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CommonTree)adaptor.nil();
			// 1926:24: -> ^( TOK_LIMIT $num)
			{
				// HiveParser.g:1926:27: ^( TOK_LIMIT $num)
				{
				CommonTree root_1 = (CommonTree)adaptor.nil();
				root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(TOK_LIMIT, "TOK_LIMIT"), root_1);
				adaptor.addChild(root_1, stream_num.nextNode());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

			 msgs.pop(); 
		}

		catch (RecognitionException e) {
		 reportError(e);
		  throw e;
		}

		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "limitClause"

	// Delegated rules
	public HiveParser_IdentifiersParser.whenExpression_return whenExpression() throws RecognitionException { return gIdentifiersParser.whenExpression(); }

	public HiveParser_IdentifiersParser.precedenceBitwiseOrOperator_return precedenceBitwiseOrOperator() throws RecognitionException { return gIdentifiersParser.precedenceBitwiseOrOperator(); }

	public HiveParser_IdentifiersParser.sortByClause_return sortByClause() throws RecognitionException { return gIdentifiersParser.sortByClause(); }

	public HiveParser_IdentifiersParser.precedenceAmpersandExpression_return precedenceAmpersandExpression() throws RecognitionException { return gIdentifiersParser.precedenceAmpersandExpression(); }

	public HiveParser_IdentifiersParser.clusterByClause_return clusterByClause() throws RecognitionException { return gIdentifiersParser.clusterByClause(); }

	public HiveParser_SelectClauseParser.startDate_return startDate() throws RecognitionException { return gSelectClauseParser.startDate(); }

	public HiveParser_SelectClauseParser.window_range_expression_return window_range_expression() throws RecognitionException { return gSelectClauseParser.window_range_expression(); }

	public HiveParser_SelectClauseParser.selectList_return selectList() throws RecognitionException { return gSelectClauseParser.selectList(); }

	public HiveParser_IdentifiersParser.precedenceEqualNegatableOperator_return precedenceEqualNegatableOperator() throws RecognitionException { return gIdentifiersParser.precedenceEqualNegatableOperator(); }

	public HiveParser_IdentifiersParser.precedenceStarExpression_return precedenceStarExpression() throws RecognitionException { return gIdentifiersParser.precedenceStarExpression(); }

	public HiveParser_IdentifiersParser.precedenceAndOperator_return precedenceAndOperator() throws RecognitionException { return gIdentifiersParser.precedenceAndOperator(); }

	public HiveParser_IdentifiersParser.tableOrPartition_return tableOrPartition() throws RecognitionException { return gIdentifiersParser.tableOrPartition(); }

	public HiveParser_IdentifiersParser.groupByExpression_return groupByExpression() throws RecognitionException { return gIdentifiersParser.groupByExpression(); }

	public HiveParser_IdentifiersParser.dropPartitionSpec_return dropPartitionSpec() throws RecognitionException { return gIdentifiersParser.dropPartitionSpec(); }

	public HiveParser_IdentifiersParser.precedenceNotOperator_return precedenceNotOperator() throws RecognitionException { return gIdentifiersParser.precedenceNotOperator(); }

	public HiveParser_FromClauseParser.uniqueJoinToken_return uniqueJoinToken() throws RecognitionException { return gFromClauseParser.uniqueJoinToken(); }

	public HiveParser_IdentifiersParser.precedenceOrExpression_return precedenceOrExpression() throws RecognitionException { return gIdentifiersParser.precedenceOrExpression(); }

	public HiveParser_SelectClauseParser.hintClause_return hintClause() throws RecognitionException { return gSelectClauseParser.hintClause(); }

	public HiveParser_FromClauseParser.tableSample_return tableSample() throws RecognitionException { return gFromClauseParser.tableSample(); }

	public HiveParser_IdentifiersParser.identifier_return identifier() throws RecognitionException { return gIdentifiersParser.identifier(); }

	public HiveParser_IdentifiersParser.partitionSpec_return partitionSpec() throws RecognitionException { return gIdentifiersParser.partitionSpec(); }

	public HiveParser_IdentifiersParser.orderByClause_return orderByClause() throws RecognitionException { return gIdentifiersParser.orderByClause(); }

	public HiveParser_SelectClauseParser.hintArgName_return hintArgName() throws RecognitionException { return gSelectClauseParser.hintArgName(); }

	public HiveParser_IdentifiersParser.havingCondition_return havingCondition() throws RecognitionException { return gIdentifiersParser.havingCondition(); }

	public HiveParser_SelectClauseParser.dateArgs_return dateArgs() throws RecognitionException { return gSelectClauseParser.dateArgs(); }

	public HiveParser_FromClauseParser.viewName_return viewName() throws RecognitionException { return gFromClauseParser.viewName(); }

	public HiveParser_SelectClauseParser.year_or_month_return year_or_month() throws RecognitionException { return gSelectClauseParser.year_or_month(); }

	public HiveParser_IdentifiersParser.expression_return expression() throws RecognitionException { return gIdentifiersParser.expression(); }

	public HiveParser_FromClauseParser.lateralView_return lateralView() throws RecognitionException { return gFromClauseParser.lateralView(); }

	public HiveParser_SelectClauseParser.incrementalClause_return incrementalClause() throws RecognitionException { return gSelectClauseParser.incrementalClause(); }

	public HiveParser_IdentifiersParser.precedenceEqualExpression_return precedenceEqualExpression() throws RecognitionException { return gIdentifiersParser.precedenceEqualExpression(); }

	public HiveParser_IdentifiersParser.groupingSetExpression_return groupingSetExpression() throws RecognitionException { return gIdentifiersParser.groupingSetExpression(); }

	public HiveParser_FromClauseParser.aliasList_return aliasList() throws RecognitionException { return gFromClauseParser.aliasList(); }

	public HiveParser_SelectClauseParser.trfmClause_return trfmClause() throws RecognitionException { return gSelectClauseParser.trfmClause(); }

	public HiveParser_FromClauseParser.uniqueJoinExpr_return uniqueJoinExpr() throws RecognitionException { return gFromClauseParser.uniqueJoinExpr(); }

	public HiveParser_IdentifiersParser.dropPartitionOperator_return dropPartitionOperator() throws RecognitionException { return gIdentifiersParser.dropPartitionOperator(); }

	public HiveParser_FromClauseParser.fromSource_return fromSource() throws RecognitionException { return gFromClauseParser.fromSource(); }

	public HiveParser_FromClauseParser.tableAlias_return tableAlias() throws RecognitionException { return gFromClauseParser.tableAlias(); }

	public HiveParser_IdentifiersParser.precedenceBitwiseXorOperator_return precedenceBitwiseXorOperator() throws RecognitionException { return gIdentifiersParser.precedenceBitwiseXorOperator(); }

	public HiveParser_IdentifiersParser.functionName_return functionName() throws RecognitionException { return gIdentifiersParser.functionName(); }

	public HiveParser_SelectClauseParser.hintArgs_return hintArgs() throws RecognitionException { return gSelectClauseParser.hintArgs(); }

	public HiveParser_IdentifiersParser.precedenceFieldExpression_return precedenceFieldExpression() throws RecognitionException { return gIdentifiersParser.precedenceFieldExpression(); }

	public HiveParser_SelectClauseParser.betweenDate_return betweenDate() throws RecognitionException { return gSelectClauseParser.betweenDate(); }

	public HiveParser_IdentifiersParser.castExpression_return castExpression() throws RecognitionException { return gIdentifiersParser.castExpression(); }

	public HiveParser_SelectClauseParser.hintName_return hintName() throws RecognitionException { return gSelectClauseParser.hintName(); }

	public HiveParser_FromClauseParser.joinSource_return joinSource() throws RecognitionException { return gFromClauseParser.joinSource(); }

	public HiveParser_IdentifiersParser.function_return function() throws RecognitionException { return gIdentifiersParser.function(); }

	public HiveParser_SelectClauseParser.window_frame_return window_frame() throws RecognitionException { return gSelectClauseParser.window_frame(); }

	public HiveParser_SelectClauseParser.window_specification_return window_specification() throws RecognitionException { return gSelectClauseParser.window_specification(); }

	public HiveParser_IdentifiersParser.atomExpression_return atomExpression() throws RecognitionException { return gIdentifiersParser.atomExpression(); }

	public HiveParser_SelectClauseParser.window_frame_start_boundary_return window_frame_start_boundary() throws RecognitionException { return gSelectClauseParser.window_frame_start_boundary(); }

	public HiveParser_IdentifiersParser.nonReserved_return nonReserved() throws RecognitionException { return gIdentifiersParser.nonReserved(); }

	public HiveParser_IdentifiersParser.stringLiteralSequence_return stringLiteralSequence() throws RecognitionException { return gIdentifiersParser.stringLiteralSequence(); }

	public HiveParser_IdentifiersParser.precedenceUnaryPrefixExpression_return precedenceUnaryPrefixExpression() throws RecognitionException { return gIdentifiersParser.precedenceUnaryPrefixExpression(); }

	public HiveParser_SelectClauseParser.window_value_expression_return window_value_expression() throws RecognitionException { return gSelectClauseParser.window_value_expression(); }

	public HiveParser_SelectClauseParser.indefinite_date_return indefinite_date() throws RecognitionException { return gSelectClauseParser.indefinite_date(); }

	public HiveParser_IdentifiersParser.precedenceOrOperator_return precedenceOrOperator() throws RecognitionException { return gIdentifiersParser.precedenceOrOperator(); }

	public HiveParser_FromClauseParser.whereClause_return whereClause() throws RecognitionException { return gFromClauseParser.whereClause(); }

	public HiveParser_FromClauseParser.subQuerySource_return subQuerySource() throws RecognitionException { return gFromClauseParser.subQuerySource(); }

	public HiveParser_SelectClauseParser.selectItem_return selectItem() throws RecognitionException { return gSelectClauseParser.selectItem(); }

	public HiveParser_IdentifiersParser.precedenceAndExpression_return precedenceAndExpression() throws RecognitionException { return gIdentifiersParser.precedenceAndExpression(); }

	public HiveParser_FromClauseParser.tableAllColumns_return tableAllColumns() throws RecognitionException { return gFromClauseParser.tableAllColumns(); }

	public HiveParser_SelectClauseParser.selectExpression_return selectExpression() throws RecognitionException { return gSelectClauseParser.selectExpression(); }

	public HiveParser_SelectClauseParser.hintList_return hintList() throws RecognitionException { return gSelectClauseParser.hintList(); }

	public HiveParser_IdentifiersParser.precedenceUnarySuffixExpression_return precedenceUnarySuffixExpression() throws RecognitionException { return gIdentifiersParser.precedenceUnarySuffixExpression(); }

	public HiveParser_SelectClauseParser.window_clause_return window_clause() throws RecognitionException { return gSelectClauseParser.window_clause(); }

	public HiveParser_IdentifiersParser.charSetStringLiteral_return charSetStringLiteral() throws RecognitionException { return gIdentifiersParser.charSetStringLiteral(); }

	public HiveParser_IdentifiersParser.precedenceBitwiseOrExpression_return precedenceBitwiseOrExpression() throws RecognitionException { return gIdentifiersParser.precedenceBitwiseOrExpression(); }

	public HiveParser_IdentifiersParser.distributeByClause_return distributeByClause() throws RecognitionException { return gIdentifiersParser.distributeByClause(); }

	public HiveParser_IdentifiersParser.nullCondition_return nullCondition() throws RecognitionException { return gIdentifiersParser.nullCondition(); }

	public HiveParser_IdentifiersParser.precedenceEqualOperator_return precedenceEqualOperator() throws RecognitionException { return gIdentifiersParser.precedenceEqualOperator(); }

	public HiveParser_IdentifiersParser.precedenceStarOperator_return precedenceStarOperator() throws RecognitionException { return gIdentifiersParser.precedenceStarOperator(); }

	public HiveParser_IdentifiersParser.precedenceAmpersandOperator_return precedenceAmpersandOperator() throws RecognitionException { return gIdentifiersParser.precedenceAmpersandOperator(); }

	public HiveParser_IdentifiersParser.dateLiteral_return dateLiteral() throws RecognitionException { return gIdentifiersParser.dateLiteral(); }

	public HiveParser_FromClauseParser.fromClause_return fromClause() throws RecognitionException { return gFromClauseParser.fromClause(); }

	public HiveParser_SelectClauseParser.hintItem_return hintItem() throws RecognitionException { return gSelectClauseParser.hintItem(); }

	public HiveParser_IdentifiersParser.expressions_return expressions() throws RecognitionException { return gIdentifiersParser.expressions(); }

	public HiveParser_IdentifiersParser.constant_return constant() throws RecognitionException { return gIdentifiersParser.constant(); }

	public HiveParser_SelectClauseParser.incrementalArgs_return incrementalArgs() throws RecognitionException { return gSelectClauseParser.incrementalArgs(); }

	public HiveParser_FromClauseParser.partitioningSpec_return partitioningSpec() throws RecognitionException { return gFromClauseParser.partitioningSpec(); }

	public HiveParser_FromClauseParser.tableSource_return tableSource() throws RecognitionException { return gFromClauseParser.tableSource(); }

	public HiveParser_IdentifiersParser.precedenceNotExpression_return precedenceNotExpression() throws RecognitionException { return gIdentifiersParser.precedenceNotExpression(); }

	public HiveParser_IdentifiersParser.precedenceUnaryOperator_return precedenceUnaryOperator() throws RecognitionException { return gIdentifiersParser.precedenceUnaryOperator(); }

	public HiveParser_IdentifiersParser.descFuncNames_return descFuncNames() throws RecognitionException { return gIdentifiersParser.descFuncNames(); }

	public HiveParser_FromClauseParser.expressionList_return expressionList() throws RecognitionException { return gFromClauseParser.expressionList(); }

	public HiveParser_IdentifiersParser.precedenceBitwiseXorExpression_return precedenceBitwiseXorExpression() throws RecognitionException { return gIdentifiersParser.precedenceBitwiseXorExpression(); }

	public HiveParser_FromClauseParser.partitionedTableFunction_return partitionedTableFunction() throws RecognitionException { return gFromClauseParser.partitionedTableFunction(); }

	public HiveParser_IdentifiersParser.partitionVal_return partitionVal() throws RecognitionException { return gIdentifiersParser.partitionVal(); }

	public HiveParser_IdentifiersParser.precedencePlusOperator_return precedencePlusOperator() throws RecognitionException { return gIdentifiersParser.precedencePlusOperator(); }

	public HiveParser_SelectClauseParser.window_frame_boundary_return window_frame_boundary() throws RecognitionException { return gSelectClauseParser.window_frame_boundary(); }

	public HiveParser_FromClauseParser.joinToken_return joinToken() throws RecognitionException { return gFromClauseParser.joinToken(); }

	public HiveParser_FromClauseParser.uniqueJoinSource_return uniqueJoinSource() throws RecognitionException { return gFromClauseParser.uniqueJoinSource(); }

	public HiveParser_FromClauseParser.partitionTableFunctionSource_return partitionTableFunctionSource() throws RecognitionException { return gFromClauseParser.partitionTableFunctionSource(); }

	public HiveParser_FromClauseParser.tableBucketSample_return tableBucketSample() throws RecognitionException { return gFromClauseParser.tableBucketSample(); }

	public HiveParser_IdentifiersParser.havingClause_return havingClause() throws RecognitionException { return gIdentifiersParser.havingClause(); }

	public HiveParser_FromClauseParser.searchCondition_return searchCondition() throws RecognitionException { return gFromClauseParser.searchCondition(); }

	public HiveParser_SelectClauseParser.explicit_time_return explicit_time() throws RecognitionException { return gSelectClauseParser.explicit_time(); }

	public HiveParser_SelectClauseParser.selectExpressionList_return selectExpressionList() throws RecognitionException { return gSelectClauseParser.selectExpressionList(); }

	public HiveParser_FromClauseParser.tableName_return tableName() throws RecognitionException { return gFromClauseParser.tableName(); }

	public HiveParser_IdentifiersParser.sysFuncNames_return sysFuncNames() throws RecognitionException { return gIdentifiersParser.sysFuncNames(); }

	public HiveParser_IdentifiersParser.caseExpression_return caseExpression() throws RecognitionException { return gIdentifiersParser.caseExpression(); }

	public HiveParser_FromClauseParser.splitSample_return splitSample() throws RecognitionException { return gFromClauseParser.splitSample(); }

	public HiveParser_SelectClauseParser.selectClause_return selectClause() throws RecognitionException { return gSelectClauseParser.selectClause(); }

	public HiveParser_IdentifiersParser.partitionByClause_return partitionByClause() throws RecognitionException { return gIdentifiersParser.partitionByClause(); }

	public HiveParser_IdentifiersParser.dropPartitionVal_return dropPartitionVal() throws RecognitionException { return gIdentifiersParser.dropPartitionVal(); }

	public HiveParser_SelectClauseParser.window_defn_return window_defn() throws RecognitionException { return gSelectClauseParser.window_defn(); }

	public HiveParser_IdentifiersParser.booleanValue_return booleanValue() throws RecognitionException { return gIdentifiersParser.booleanValue(); }

	public HiveParser_FromClauseParser.tableOrColumn_return tableOrColumn() throws RecognitionException { return gFromClauseParser.tableOrColumn(); }

	public HiveParser_IdentifiersParser.groupByClause_return groupByClause() throws RecognitionException { return gIdentifiersParser.groupByClause(); }

	public HiveParser_SelectClauseParser.selectTrfmClause_return selectTrfmClause() throws RecognitionException { return gSelectClauseParser.selectTrfmClause(); }

	public HiveParser_IdentifiersParser.precedencePlusExpression_return precedencePlusExpression() throws RecognitionException { return gIdentifiersParser.precedencePlusExpression(); }


	protected DFA9 dfa9 = new DFA9(this);
	protected DFA48 dfa48 = new DFA48(this);
	protected DFA160 dfa160 = new DFA160(this);
	static final String DFA9_eotS =
		"\106\uffff";
	static final String DFA9_eofS =
		"\106\uffff";
	static final String DFA9_minS =
		"\1\50\1\115\1\uffff\1\115\4\uffff\1\101\4\uffff\2\47\1\171\13\uffff\1"+
		"\171\52\uffff";
	static final String DFA9_maxS =
		"\1\u010f\1\u0116\1\uffff\1\u0116\4\uffff\1\u00f8\4\uffff\2\u010e\1\u00a4"+
		"\13\uffff\1\u00a4\52\uffff";
	static final String DFA9_acceptS =
		"\2\uffff\1\2\1\uffff\1\6\1\7\1\10\2\uffff\1\12\1\23\1\24\1\25\3\uffff"+
		"\1\17\1\26\1\1\1\uffff\1\4\1\uffff\1\13\1\uffff\1\5\1\14\1\20\1\uffff"+
		"\1\27\1\3\1\uffff\1\11\7\uffff\1\32\1\33\5\uffff\1\34\1\30\10\uffff\1"+
		"\35\1\31\10\uffff\1\15\1\16\1\21\1\22";
	static final String DFA9_specialS =
		"\106\uffff}>";
	static final String[] DFA9_transitionS = {
			"\1\5\1\12\35\uffff\1\1\20\uffff\2\6\6\uffff\1\3\32\uffff\1\15\44\uffff"+
			"\1\13\12\uffff\1\11\53\uffff\1\16\21\uffff\1\10\32\uffff\1\4\6\uffff"+
			"\1\14\3\uffff\1\2",
			"\1\22\36\uffff\1\24\32\uffff\1\20\54\uffff\1\26\45\uffff\1\21\3\uffff"+
			"\1\22\26\uffff\1\24\3\uffff\1\17\34\uffff\1\26",
			"",
			"\1\35\71\uffff\1\32\122\uffff\1\34\3\uffff\1\35\26\uffff\1\30\3\uffff"+
			"\1\33\34\uffff\1\31",
			"",
			"",
			"",
			"",
			"\1\37\5\uffff\1\37\6\uffff\1\37\47\uffff\1\37\3\uffff\1\37\1\47\13\uffff"+
			"\2\37\30\uffff\1\37\36\uffff\1\37\31\uffff\1\50\4\uffff\1\37\25\uffff"+
			"\2\37\1\uffff\1\37",
			"",
			"",
			"",
			"",
			"\2\57\36\uffff\1\57\30\uffff\1\57\46\uffff\1\57\30\uffff\1\57\71\uffff"+
			"\1\56\6\uffff\1\57\10\uffff\1\57\43\uffff\1\57",
			"\2\71\36\uffff\1\71\30\uffff\1\71\46\uffff\1\71\30\uffff\1\71\71\uffff"+
			"\1\70\6\uffff\1\71\10\uffff\1\71\43\uffff\1\71",
			"\1\102\52\uffff\1\103",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\104\52\uffff\1\105",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			""
	};

	static final short[] DFA9_eot = DFA.unpackEncodedString(DFA9_eotS);
	static final short[] DFA9_eof = DFA.unpackEncodedString(DFA9_eofS);
	static final char[] DFA9_min = DFA.unpackEncodedStringToUnsignedChars(DFA9_minS);
	static final char[] DFA9_max = DFA.unpackEncodedStringToUnsignedChars(DFA9_maxS);
	static final short[] DFA9_accept = DFA.unpackEncodedString(DFA9_acceptS);
	static final short[] DFA9_special = DFA.unpackEncodedString(DFA9_specialS);
	static final short[][] DFA9_transition;

	static {
		int numStates = DFA9_transitionS.length;
		DFA9_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA9_transition[i] = DFA.unpackEncodedString(DFA9_transitionS[i]);
		}
	}

	protected class DFA9 extends DFA {

		public DFA9(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 9;
			this.eot = DFA9_eot;
			this.eof = DFA9_eof;
			this.min = DFA9_min;
			this.max = DFA9_max;
			this.accept = DFA9_accept;
			this.special = DFA9_special;
			this.transition = DFA9_transition;
		}
		@Override
		public String getDescription() {
			return "607:1: ddlStatement : ( createDatabaseStatement | switchDatabaseStatement | dropDatabaseStatement | createTableStatement | dropTableStatement | truncateTableStatement | alterStatement | descStatement | showStatement | metastoreCheck | createViewStatement | dropViewStatement | createFunctionStatement | createMacroStatement | createIndexStatement | dropIndexStatement | dropFunctionStatement | dropMacroStatement | analyzeStatement | lockStatement | unlockStatement | createRoleStatement | dropRoleStatement | grantPrivileges | revokePrivileges | showGrants | showRoleGrants | grantRole | revokeRole );";
		}
	}

	static final String DFA48_eotS =
		"\107\uffff";
	static final String DFA48_eofS =
		"\107\uffff";
	static final String DFA48_minS =
		"\1\41\2\25\1\uffff\1\u00ff\1\101\6\uffff\1\160\5\uffff\1\75\4\uffff\1"+
		"\u00ff\1\101\6\uffff\1\160\6\uffff\1\75\40\uffff";
	static final String DFA48_maxS =
		"\1\u011b\2\u010c\1\uffff\1\u00ff\1\u00be\6\uffff\1\u00f8\5\uffff\1\u00f1"+
		"\4\uffff\1\u00ff\1\u00be\6\uffff\1\u00f8\6\uffff\1\u00f1\40\uffff";
	static final String DFA48_acceptS =
		"\3\uffff\1\12\2\uffff\1\2\1\3\1\4\1\6\1\7\1\10\1\uffff\1\11\6\uffff\1"+
		"\13\1\14\25\uffff\1\1\1\uffff\1\5\13\uffff\1\1\15\uffff";
	static final String DFA48_specialS =
		"\107\uffff}>";
	static final String[] DFA48_transitionS = {
			"\1\1\3\uffff\2\2\1\uffff\2\2\1\uffff\16\2\2\uffff\5\2\1\uffff\4\2\1\uffff"+
			"\2\2\1\uffff\1\2\1\uffff\2\2\1\uffff\3\2\1\uffff\13\2\1\uffff\4\2\1\uffff"+
			"\1\2\1\uffff\1\2\1\uffff\4\2\1\uffff\7\2\1\uffff\3\2\1\uffff\1\2\1\uffff"+
			"\4\2\1\uffff\1\2\1\uffff\1\2\1\uffff\15\2\1\uffff\3\2\1\uffff\4\2\1\uffff"+
			"\12\2\2\uffff\3\2\2\uffff\2\2\1\uffff\4\2\1\uffff\1\2\1\uffff\6\2\1\uffff"+
			"\1\2\1\uffff\5\2\2\uffff\14\2\1\uffff\16\2\2\uffff\25\2\1\uffff\4\2\1"+
			"\uffff\4\2\1\uffff\4\2\1\uffff\3\2\1\uffff\12\2\1\uffff\1\2\2\uffff\1"+
			"\2\1\uffff\1\2",
			"\1\25\17\uffff\1\5\5\uffff\1\12\17\uffff\1\7\1\uffff\1\3\6\uffff\1\3"+
			"\27\uffff\1\3\3\uffff\1\10\2\uffff\1\3\2\uffff\1\25\52\uffff\1\3\33\uffff"+
			"\1\22\20\uffff\1\3\24\uffff\1\4\1\uffff\1\6\20\uffff\1\14\4\uffff\1\24"+
			"\24\uffff\1\11\4\uffff\1\13\6\uffff\1\15",
			"\1\25\17\uffff\1\30\5\uffff\1\12\17\uffff\1\7\1\uffff\1\3\6\uffff\1"+
			"\3\27\uffff\1\3\3\uffff\1\10\2\uffff\1\3\2\uffff\1\25\52\uffff\1\3\33"+
			"\uffff\1\46\20\uffff\1\3\24\uffff\1\27\1\uffff\1\6\20\uffff\1\37\4\uffff"+
			"\1\24\24\uffff\1\11\4\uffff\1\13\6\uffff\1\15",
			"",
			"\1\53",
			"\1\6\100\uffff\1\55\73\uffff\1\55",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\3\56\uffff\1\3\104\uffff\2\3\5\uffff\1\3\14\uffff\1\15",
			"",
			"",
			"",
			"",
			"",
			"\1\3\u00ad\uffff\1\24\2\uffff\1\3\2\uffff\1\24",
			"",
			"",
			"",
			"",
			"\1\71",
			"\1\6\100\uffff\1\55\73\uffff\1\55",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\3\56\uffff\1\3\104\uffff\2\3\5\uffff\1\3\14\uffff\1\15",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\3\u00ad\uffff\1\24\2\uffff\1\3\2\uffff\1\24",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			""
	};

	static final short[] DFA48_eot = DFA.unpackEncodedString(DFA48_eotS);
	static final short[] DFA48_eof = DFA.unpackEncodedString(DFA48_eofS);
	static final char[] DFA48_min = DFA.unpackEncodedStringToUnsignedChars(DFA48_minS);
	static final char[] DFA48_max = DFA.unpackEncodedStringToUnsignedChars(DFA48_maxS);
	static final short[] DFA48_accept = DFA.unpackEncodedString(DFA48_acceptS);
	static final short[] DFA48_special = DFA.unpackEncodedString(DFA48_specialS);
	static final short[][] DFA48_transition;

	static {
		int numStates = DFA48_transitionS.length;
		DFA48_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA48_transition[i] = DFA.unpackEncodedString(DFA48_transitionS[i]);
		}
	}

	protected class DFA48 extends DFA {

		public DFA48(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 48;
			this.eot = DFA48_eot;
			this.eof = DFA48_eof;
			this.min = DFA48_min;
			this.max = DFA48_max;
			this.accept = DFA48_accept;
			this.special = DFA48_special;
			this.transition = DFA48_transition;
		}
		@Override
		public String getDescription() {
			return "873:1: alterTableStatementSuffix : ( alterStatementSuffixRename | alterStatementSuffixAddCol | alterStatementSuffixRenameCol | alterStatementSuffixDropPartitions | alterStatementSuffixAddPartitions | alterStatementSuffixTouch | alterStatementSuffixArchive | alterStatementSuffixUnArchive | alterStatementSuffixProperties | alterTblPartitionStatement | alterStatementSuffixSkewedby | alterStatementSuffixExchangePartition );";
		}
	}

	static final String DFA160_eotS =
		"\122\uffff";
	static final String DFA160_eofS =
		"\1\2\121\uffff";
	static final String DFA160_minS =
		"\1\55\1\11\33\uffff\1\4\64\uffff";
	static final String DFA160_maxS =
		"\1\u0130\1\u0141\33\uffff\1\u0136\64\uffff";
	static final String DFA160_acceptS =
		"\2\uffff\1\2\64\uffff\1\1\32\uffff";
	static final String DFA160_specialS =
		"\122\uffff}>";
	static final String[] DFA160_transitionS = {
			"\1\2\16\uffff\1\2\5\uffff\1\2\33\uffff\1\2\30\uffff\1\2\4\uffff\1\2\1"+
			"\uffff\1\2\3\uffff\1\2\12\uffff\1\2\11\uffff\1\2\3\uffff\2\2\2\uffff"+
			"\1\2\5\uffff\1\1\20\uffff\1\2\30\uffff\3\2\17\uffff\1\2\13\uffff\1\2"+
			"\3\uffff\1\2\6\uffff\1\2\17\uffff\1\2\10\uffff\1\2\6\uffff\1\2\1\uffff"+
			"\1\2\25\uffff\1\2",
			"\1\2\5\uffff\1\2\6\uffff\1\2\12\uffff\1\2\3\uffff\2\2\1\uffff\2\2\1"+
			"\uffff\25\2\1\uffff\4\2\1\uffff\2\2\1\uffff\1\2\1\uffff\2\2\1\uffff\3"+
			"\2\1\uffff\13\2\1\uffff\4\2\1\uffff\1\2\1\uffff\1\2\1\uffff\4\2\1\uffff"+
			"\7\2\1\uffff\3\2\1\uffff\1\2\1\uffff\4\2\1\uffff\1\2\1\uffff\17\2\1\uffff"+
			"\3\2\1\uffff\1\35\3\2\1\uffff\12\2\1\uffff\4\2\2\uffff\7\2\1\uffff\1"+
			"\2\1\uffff\6\2\1\uffff\1\2\1\uffff\5\2\2\uffff\14\2\1\uffff\16\2\2\uffff"+
			"\25\2\1\uffff\4\2\1\uffff\4\2\1\uffff\4\2\1\uffff\3\2\1\uffff\12\2\1"+
			"\uffff\1\2\2\uffff\1\2\1\uffff\1\2\3\uffff\1\2\4\uffff\1\2\6\uffff\1"+
			"\2\1\uffff\1\2\10\uffff\1\2\1\uffff\2\2\1\uffff\1\2\4\uffff\2\2",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\2\2\uffff\2\2\3\uffff\1\2\5\uffff\2\2\1\uffff\1\2\2\uffff\2\2\3\uffff"+
			"\2\2\13\uffff\1\2\5\uffff\1\2\124\uffff\1\2\14\uffff\1\2\7\uffff\1\2"+
			"\22\uffff\1\2\6\uffff\1\2\33\uffff\1\2\1\uffff\1\2\6\uffff\1\2\2\uffff"+
			"\1\2\35\uffff\1\67\26\uffff\1\2\13\uffff\4\2\3\uffff\1\2\1\uffff\1\2"+
			"\2\uffff\1\2\3\uffff\1\2\10\uffff\1\2",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			""
	};

	static final short[] DFA160_eot = DFA.unpackEncodedString(DFA160_eotS);
	static final short[] DFA160_eof = DFA.unpackEncodedString(DFA160_eofS);
	static final char[] DFA160_min = DFA.unpackEncodedStringToUnsignedChars(DFA160_minS);
	static final char[] DFA160_max = DFA.unpackEncodedStringToUnsignedChars(DFA160_maxS);
	static final short[] DFA160_accept = DFA.unpackEncodedString(DFA160_acceptS);
	static final short[] DFA160_special = DFA.unpackEncodedString(DFA160_specialS);
	static final short[][] DFA160_transition;

	static {
		int numStates = DFA160_transitionS.length;
		DFA160_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA160_transition[i] = DFA.unpackEncodedString(DFA160_transitionS[i]);
		}
	}

	protected class DFA160 extends DFA {

		public DFA160(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 160;
			this.eot = DFA160_eot;
			this.eof = DFA160_eof;
			this.min = DFA160_min;
			this.max = DFA160_max;
			this.accept = DFA160_accept;
			this.special = DFA160_special;
			this.transition = DFA160_transition;
		}
		@Override
		public String getDescription() {
			return "1527:103: ( tableRowFormatMapKeysIdentifier )?";
		}
	}

	public static final BitSet FOLLOW_explainStatement_in_statement925 = new BitSet(new long[]{0x0000000000000000L});
	public static final BitSet FOLLOW_EOF_in_statement927 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_execStatement_in_statement932 = new BitSet(new long[]{0x0000000000000000L});
	public static final BitSet FOLLOW_EOF_in_statement934 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_EXPLAIN_in_explainStatement955 = new BitSet(new long[]{0x0000030000000000L,0x08C00C0103800080L,0x0000082520002010L,0x0000020200820000L,0x0000000000008810L});
	public static final BitSet FOLLOW_KW_EXTENDED_in_explainStatement960 = new BitSet(new long[]{0x0000030000000000L,0x0880040103000080L,0x0000082120002010L,0x0000020200820000L,0x0000000000008810L});
	public static final BitSet FOLLOW_KW_FORMATTED_in_explainStatement964 = new BitSet(new long[]{0x0000030000000000L,0x0880040103000080L,0x0000082120002010L,0x0000020200820000L,0x0000000000008810L});
	public static final BitSet FOLLOW_KW_DEPENDENCY_in_explainStatement968 = new BitSet(new long[]{0x0000030000000000L,0x0880040103000080L,0x0000082120002010L,0x0000020200820000L,0x0000000000008810L});
	public static final BitSet FOLLOW_KW_LOGICAL_in_explainStatement972 = new BitSet(new long[]{0x0000030000000000L,0x0880040103000080L,0x0000082120002010L,0x0000020200820000L,0x0000000000008810L});
	public static final BitSet FOLLOW_execStatement_in_explainStatement976 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_queryStatementExpression_in_execStatement1018 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_loadStatement_in_execStatement1026 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_exportStatement_in_execStatement1034 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_importStatement_in_execStatement1042 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ddlStatement_in_execStatement1050 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOAD_in_loadStatement1077 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_KW_DATA_in_loadStatement1079 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000040000400L});
	public static final BitSet FOLLOW_KW_LOCAL_in_loadStatement1084 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
	public static final BitSet FOLLOW_KW_INPATH_in_loadStatement1088 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_loadStatement1093 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x1000000000020000L});
	public static final BitSet FOLLOW_KW_OVERWRITE_in_loadStatement1099 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000020000L});
	public static final BitSet FOLLOW_KW_INTO_in_loadStatement1103 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_loadStatement1105 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_loadStatement1110 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_EXPORT_in_exportStatement1162 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_exportStatement1164 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_exportStatement1169 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_KW_TO_in_exportStatement1172 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_exportStatement1177 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IMPORT_in_importStatement1218 = new BitSet(new long[]{0x0000000000000000L,0x0080100000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_EXTERNAL_in_importStatement1224 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_importStatement1228 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_importStatement1233 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L});
	public static final BitSet FOLLOW_KW_FROM_in_importStatement1238 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_importStatement1243 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableLocation_in_importStatement1246 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createDatabaseStatement_in_ddlStatement1298 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_switchDatabaseStatement_in_ddlStatement1306 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropDatabaseStatement_in_ddlStatement1314 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createTableStatement_in_ddlStatement1322 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropTableStatement_in_ddlStatement1330 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_truncateTableStatement_in_ddlStatement1338 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatement_in_ddlStatement1346 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_descStatement_in_ddlStatement1354 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_showStatement_in_ddlStatement1362 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_metastoreCheck_in_ddlStatement1370 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createViewStatement_in_ddlStatement1378 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropViewStatement_in_ddlStatement1386 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createFunctionStatement_in_ddlStatement1394 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createMacroStatement_in_ddlStatement1402 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createIndexStatement_in_ddlStatement1410 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropIndexStatement_in_ddlStatement1418 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropFunctionStatement_in_ddlStatement1426 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropMacroStatement_in_ddlStatement1434 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_analyzeStatement_in_ddlStatement1442 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_lockStatement_in_ddlStatement1450 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_unlockStatement_in_ddlStatement1458 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_createRoleStatement_in_ddlStatement1466 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_dropRoleStatement_in_ddlStatement1474 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_grantPrivileges_in_ddlStatement1482 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_revokePrivileges_in_ddlStatement1490 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_showGrants_in_ddlStatement1498 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_showRoleGrants_in_ddlStatement1506 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_grantRole_in_ddlStatement1514 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_revokeRole_in_ddlStatement1522 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IF_in_ifExists1549 = new BitSet(new long[]{0x0000000000000000L,0x0000010000000000L});
	public static final BitSet FOLLOW_KW_EXISTS_in_ifExists1551 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_RESTRICT_in_restrictOrCascade1588 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CASCADE_in_restrictOrCascade1606 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IF_in_ifNotExists1643 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
	public static final BitSet FOLLOW_KW_NOT_in_ifNotExists1645 = new BitSet(new long[]{0x0000000000000000L,0x0000010000000000L});
	public static final BitSet FOLLOW_KW_EXISTS_in_ifNotExists1647 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_storedAsDirs1684 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_storedAsDirs1686 = new BitSet(new long[]{0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_DIRECTORIES_in_storedAsDirs1688 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_OR_in_orReplace1725 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000200000L});
	public static final BitSet FOLLOW_KW_REPLACE_in_orReplace1727 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IGNORE_in_ignoreProtection1768 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000080L});
	public static final BitSet FOLLOW_KW_PROTECTION_in_ignoreProtection1770 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createDatabaseStatement1815 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L,0x0000000000000000L,0x0000000040000000L});
	public static final BitSet FOLLOW_KW_DATABASE_in_createDatabaseStatement1818 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_SCHEMA_in_createDatabaseStatement1820 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifNotExists_in_createDatabaseStatement1831 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_createDatabaseStatement1844 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_databaseComment_in_createDatabaseStatement1854 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_dbLocation_in_createDatabaseStatement1865 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_createDatabaseStatement1877 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
	public static final BitSet FOLLOW_KW_DBPROPERTIES_in_createDatabaseStatement1879 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_dbProperties_in_createDatabaseStatement1883 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOCATION_in_dbLocation1944 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_dbLocation1948 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_LPAREN_in_dbProperties1990 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_dbPropertiesList_in_dbProperties1992 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_dbProperties1994 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_keyValueProperty_in_dbPropertiesList2035 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_dbPropertiesList2038 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_keyValueProperty_in_dbPropertiesList2040 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_KW_USE_in_switchDatabaseStatement2079 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_switchDatabaseStatement2081 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropDatabaseStatement2120 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L,0x0000000000000000L,0x0000000040000000L});
	public static final BitSet FOLLOW_KW_DATABASE_in_dropDatabaseStatement2123 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_SCHEMA_in_dropDatabaseStatement2125 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifExists_in_dropDatabaseStatement2128 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_dropDatabaseStatement2131 = new BitSet(new long[]{0x0100000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_restrictOrCascade_in_dropDatabaseStatement2133 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COMMENT_in_databaseComment2179 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_databaseComment2183 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createTableStatement2223 = new BitSet(new long[]{0x0000000000000000L,0x0000100000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_EXTERNAL_in_createTableStatement2228 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_createTableStatement2232 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifNotExists_in_createTableStatement2234 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_createTableStatement2239 = new BitSet(new long[]{0x2000200000000002L,0x0000000000000004L,0x8000000084000000L,0x0102080010000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_KW_LIKE_in_createTableStatement2252 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_createTableStatement2256 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tableLocation_in_createTableStatement2267 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tablePropertiesPrefixed_in_createTableStatement2279 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_LPAREN_in_createTableStatement2292 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameTypeList_in_createTableStatement2294 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_createTableStatement2296 = new BitSet(new long[]{0x2000200000000002L,0x0000000000000004L,0x8000000080000000L,0x0102080010000000L});
	public static final BitSet FOLLOW_tableComment_in_createTableStatement2309 = new BitSet(new long[]{0x2000200000000002L,0x0000000000000000L,0x8000000080000000L,0x0102080010000000L});
	public static final BitSet FOLLOW_tablePartition_in_createTableStatement2321 = new BitSet(new long[]{0x2000200000000002L,0x0000000000000000L,0x0000000080000000L,0x0102080010000000L});
	public static final BitSet FOLLOW_tableBuckets_in_createTableStatement2333 = new BitSet(new long[]{0x0000200000000002L,0x0000000000000000L,0x0000000080000000L,0x0102080010000000L});
	public static final BitSet FOLLOW_tableSkewed_in_createTableStatement2345 = new BitSet(new long[]{0x0000200000000002L,0x0000000000000000L,0x0000000080000000L,0x0102000010000000L});
	public static final BitSet FOLLOW_tableRowFormat_in_createTableStatement2357 = new BitSet(new long[]{0x0000200000000002L,0x0000000000000000L,0x0000000080000000L,0x0102000000000000L});
	public static final BitSet FOLLOW_tableFileFormat_in_createTableStatement2369 = new BitSet(new long[]{0x0000200000000002L,0x0000000000000000L,0x0000000080000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tableLocation_in_createTableStatement2381 = new BitSet(new long[]{0x0000200000000002L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tablePropertiesPrefixed_in_createTableStatement2393 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_KW_AS_in_createTableStatement2406 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L,0x0000000200020000L});
	public static final BitSet FOLLOW_selectStatement_in_createTableStatement2408 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TRUNCATE_in_truncateTableStatement2611 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_truncateTableStatement2613 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tablePartitionPrefix_in_truncateTableStatement2615 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COLUMNS_in_truncateTableStatement2618 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_truncateTableStatement2620 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_truncateTableStatement2622 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_truncateTableStatement2624 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createIndexStatement2659 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000080L});
	public static final BitSet FOLLOW_KW_INDEX_in_createIndexStatement2661 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_createIndexStatement2665 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_createIndexStatement2673 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_createIndexStatement2675 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_createIndexStatement2679 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_createIndexStatement2681 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_createIndexStatement2685 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_createIndexStatement2687 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_createIndexStatement2695 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_createIndexStatement2699 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000022L,0x0102000010000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_autoRebuild_in_createIndexStatement2707 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000022L,0x0102000010000000L});
	public static final BitSet FOLLOW_indexPropertiesPrefixed_in_createIndexStatement2716 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000020L,0x0102000010000000L});
	public static final BitSet FOLLOW_indexTblName_in_createIndexStatement2725 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000000L,0x0102000010000000L});
	public static final BitSet FOLLOW_tableRowFormat_in_createIndexStatement2734 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000000L,0x0102000000000000L});
	public static final BitSet FOLLOW_tableFileFormat_in_createIndexStatement2743 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000080000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tableLocation_in_createIndexStatement2752 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tablePropertiesPrefixed_in_createIndexStatement2761 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
	public static final BitSet FOLLOW_indexComment_in_createIndexStatement2770 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COMMENT_in_indexComment2927 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_indexComment2931 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_WITH_in_autoRebuild2972 = new BitSet(new long[]{0x0000000000000000L,0x0000000000100000L});
	public static final BitSet FOLLOW_KW_DEFERRED_in_autoRebuild2974 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000004000L});
	public static final BitSet FOLLOW_KW_REBUILD_in_autoRebuild2976 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IN_in_indexTblName3012 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_indexTblName3014 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_indexTblName3018 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IDXPROPERTIES_in_indexPropertiesPrefixed3065 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_indexProperties_in_indexPropertiesPrefixed3068 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_LPAREN_in_indexProperties3101 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_indexPropertiesList_in_indexProperties3103 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_indexProperties3105 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_keyValueProperty_in_indexPropertiesList3146 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_indexPropertiesList3149 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_keyValueProperty_in_indexPropertiesList3151 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropIndexStatement3189 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000080L});
	public static final BitSet FOLLOW_KW_INDEX_in_dropIndexStatement3191 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifExists_in_dropIndexStatement3193 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_dropIndexStatement3198 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_dropIndexStatement3200 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_dropIndexStatement3204 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropTableStatement3249 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_dropTableStatement3251 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifExists_in_dropTableStatement3253 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_dropTableStatement3256 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ALTER_in_alterStatement3294 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L,0x0000000000000080L,0x0020000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_KW_TABLE_in_alterStatement3319 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_alterTableStatementSuffix_in_alterStatement3322 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_VIEW_in_alterStatement3346 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_alterViewStatementSuffix_in_alterStatement3349 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INDEX_in_alterStatement3373 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_alterIndexStatementSuffix_in_alterStatement3376 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DATABASE_in_alterStatement3400 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_alterDatabaseStatementSuffix_in_alterStatement3403 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixRename_in_alterTableStatementSuffix3440 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixAddCol_in_alterTableStatementSuffix3448 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixRenameCol_in_alterTableStatementSuffix3456 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixDropPartitions_in_alterTableStatementSuffix3464 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixAddPartitions_in_alterTableStatementSuffix3472 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixTouch_in_alterTableStatementSuffix3480 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixArchive_in_alterTableStatementSuffix3488 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixUnArchive_in_alterTableStatementSuffix3496 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixProperties_in_alterTableStatementSuffix3504 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterTblPartitionStatement_in_alterTableStatementSuffix3512 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixSkewedby_in_alterTableStatementSuffix3520 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixExchangePartition_in_alterTableStatementSuffix3528 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterViewSuffixProperties_in_alterViewStatementSuffix3555 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixRename_in_alterViewStatementSuffix3563 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixAddPartitions_in_alterViewStatementSuffix3587 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixDropPartitions_in_alterViewStatementSuffix3611 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_tableName_in_alterViewStatementSuffix3637 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_alterViewStatementSuffix3639 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L,0x0000000200020000L});
	public static final BitSet FOLLOW_selectStatement_in_alterViewStatementSuffix3641 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterIndexStatementSuffix3689 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_alterIndexStatementSuffix3698 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_alterIndexStatementSuffix3702 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L,0x0000004000004000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterIndexStatementSuffix3711 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000004000004000L});
	public static final BitSet FOLLOW_KW_REBUILD_in_alterIndexStatementSuffix3726 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterIndexStatementSuffix3760 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_IDXPROPERTIES_in_alterIndexStatementSuffix3762 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_indexProperties_in_alterIndexStatementSuffix3770 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterDatabaseSuffixProperties_in_alterDatabaseStatementSuffix3822 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterDatabaseSuffixProperties3851 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000004000000000L});
	public static final BitSet FOLLOW_KW_SET_in_alterDatabaseSuffixProperties3853 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
	public static final BitSet FOLLOW_KW_DBPROPERTIES_in_alterDatabaseSuffixProperties3855 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_dbProperties_in_alterDatabaseSuffixProperties3857 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixRename3901 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000080000L});
	public static final BitSet FOLLOW_KW_RENAME_in_alterStatementSuffixRename3903 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_KW_TO_in_alterStatementSuffixRename3905 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixRename3909 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixAddCol3952 = new BitSet(new long[]{0x0000002000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000200000L});
	public static final BitSet FOLLOW_KW_ADD_in_alterStatementSuffixAddCol3957 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_REPLACE_in_alterStatementSuffixAddCol3963 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COLUMNS_in_alterStatementSuffixAddCol3966 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_alterStatementSuffixAddCol3968 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameTypeList_in_alterStatementSuffixAddCol3970 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_alterStatementSuffixAddCol3972 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixRenameCol4045 = new BitSet(new long[]{0x0800000000000000L});
	public static final BitSet FOLLOW_KW_CHANGE_in_alterStatementSuffixRenameCol4047 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADFL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_COLUMN_in_alterStatementSuffixRenameCol4049 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixRenameCol4054 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixRenameCol4058 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_colType_in_alterStatementSuffixRenameCol4060 = new BitSet(new long[]{0x0000004000000002L,0x0002000000000004L});
	public static final BitSet FOLLOW_KW_COMMENT_in_alterStatementSuffixRenameCol4063 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_alterStatementSuffixRenameCol4067 = new BitSet(new long[]{0x0000004000000002L,0x0002000000000000L});
	public static final BitSet FOLLOW_alterStatementChangeColPosition_in_alterStatementSuffixRenameCol4071 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_FIRST_in_alterStatementChangeColPosition4117 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_AFTER_in_alterStatementChangeColPosition4119 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_alterStatementChangeColPosition4123 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixAddPartitions4175 = new BitSet(new long[]{0x0000002000000000L});
	public static final BitSet FOLLOW_KW_ADD_in_alterStatementSuffixAddPartitions4177 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000004L});
	public static final BitSet FOLLOW_ifNotExists_in_alterStatementSuffixAddPartitions4179 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_alterStatementSuffixAddPartitionsElement_in_alterStatementSuffixAddPartitions4182 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixAddPartitionsElement4218 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_partitionLocation_in_alterStatementSuffixAddPartitionsElement4220 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixTouch4248 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
	public static final BitSet FOLLOW_KW_TOUCH_in_alterStatementSuffixTouch4250 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixTouch4253 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixArchive4299 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_KW_ARCHIVE_in_alterStatementSuffixArchive4301 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixArchive4304 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixUnArchive4350 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
	public static final BitSet FOLLOW_KW_UNARCHIVE_in_alterStatementSuffixUnArchive4352 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixUnArchive4355 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_KW_LOCATION_in_partitionLocation4407 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_partitionLocation4411 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixDropPartitions4447 = new BitSet(new long[]{0x0000000000000000L,0x0000000100000000L});
	public static final BitSet FOLLOW_KW_DROP_in_alterStatementSuffixDropPartitions4449 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000004L});
	public static final BitSet FOLLOW_ifExists_in_alterStatementSuffixDropPartitions4451 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_dropPartitionSpec_in_alterStatementSuffixDropPartitions4454 = new BitSet(new long[]{0x0000000000001002L,0x0000000000000000L,0x0000000000000008L});
	public static final BitSet FOLLOW_COMMA_in_alterStatementSuffixDropPartitions4457 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_dropPartitionSpec_in_alterStatementSuffixDropPartitions4459 = new BitSet(new long[]{0x0000000000001002L,0x0000000000000000L,0x0000000000000008L});
	public static final BitSet FOLLOW_ignoreProtection_in_alterStatementSuffixDropPartitions4463 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixProperties4514 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000004000000000L});
	public static final BitSet FOLLOW_KW_SET_in_alterStatementSuffixProperties4516 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_alterStatementSuffixProperties4518 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterStatementSuffixProperties4520 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixProperties4545 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_KW_UNSET_in_alterStatementSuffixProperties4547 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_alterStatementSuffixProperties4549 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000004L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_ifExists_in_alterStatementSuffixProperties4551 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterStatementSuffixProperties4554 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterViewSuffixProperties4601 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000004000000000L});
	public static final BitSet FOLLOW_KW_SET_in_alterViewSuffixProperties4603 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_alterViewSuffixProperties4605 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterViewSuffixProperties4607 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterViewSuffixProperties4632 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_KW_UNSET_in_alterViewSuffixProperties4634 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_alterViewSuffixProperties4636 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000004L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_ifExists_in_alterViewSuffixProperties4638 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterViewSuffixProperties4641 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterStatementSuffixSerdeProperties4686 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
	public static final BitSet FOLLOW_KW_SERDE_in_alterStatementSuffixSerdeProperties4688 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_alterStatementSuffixSerdeProperties4692 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_alterStatementSuffixSerdeProperties4695 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
	public static final BitSet FOLLOW_KW_SERDEPROPERTIES_in_alterStatementSuffixSerdeProperties4697 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterStatementSuffixSerdeProperties4699 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterStatementSuffixSerdeProperties4725 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
	public static final BitSet FOLLOW_KW_SERDEPROPERTIES_in_alterStatementSuffixSerdeProperties4727 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_alterStatementSuffixSerdeProperties4729 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_tablePartitionPrefix4767 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_tablePartitionPrefix4769 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_tablePartitionPrefix_in_alterTblPartitionStatement4806 = new BitSet(new long[]{0x2000000000000000L,0x0000000810000010L,0x0000200000020000L,0x0000004000080000L});
	public static final BitSet FOLLOW_alterTblPartitionStatementSuffix_in_alterTblPartitionStatement4808 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_Identifier_in_alterTblPartitionStatement4825 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_KW_PARTITION_in_alterTblPartitionStatement4827 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
	public static final BitSet FOLLOW_KW_COLUMN_in_alterTblPartitionStatement4829 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_alterTblPartitionStatement4831 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameType_in_alterTblPartitionStatement4833 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_alterTblPartitionStatement4835 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixFileFormat_in_alterTblPartitionStatementSuffix4870 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixLocation_in_alterTblPartitionStatementSuffix4876 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixProtectMode_in_alterTblPartitionStatementSuffix4882 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixMergeFiles_in_alterTblPartitionStatementSuffix4888 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixSerdeProperties_in_alterTblPartitionStatementSuffix4894 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixRenamePart_in_alterTblPartitionStatementSuffix4900 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixBucketNum_in_alterTblPartitionStatementSuffix4906 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterTblPartitionStatementSuffixSkewedLocation_in_alterTblPartitionStatementSuffix4912 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterStatementSuffixClusterbySortby_in_alterTblPartitionStatementSuffix4918 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterStatementSuffixFileFormat4940 = new BitSet(new long[]{0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_KW_FILEFORMAT_in_alterStatementSuffixFileFormat4942 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_fileFormat_in_alterStatementSuffixFileFormat4944 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_NOT_in_alterStatementSuffixClusterbySortby4975 = new BitSet(new long[]{0x2000000000000000L});
	public static final BitSet FOLLOW_KW_CLUSTERED_in_alterStatementSuffixClusterbySortby4977 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_NOT_in_alterStatementSuffixClusterbySortby4991 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000400000000000L});
	public static final BitSet FOLLOW_KW_SORTED_in_alterStatementSuffixClusterbySortby4993 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_tableBuckets_in_alterStatementSuffixClusterbySortby5007 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterTblPartitionStatementSuffixSkewedLocation5038 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_KW_SKEWED_in_alterTblPartitionStatementSuffixSkewedLocation5040 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_KW_LOCATION_in_alterTblPartitionStatementSuffixSkewedLocation5042 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_skewedLocations_in_alterTblPartitionStatementSuffixSkewedLocation5044 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_LPAREN_in_skewedLocations5087 = new BitSet(new long[]{0x0000000000408200L,0x0000200000008000L,0x0000000000000000L,0x0000000000000000L,0x0300080080000008L,0x0000000000000003L});
	public static final BitSet FOLLOW_skewedLocationsList_in_skewedLocations5089 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_skewedLocations5091 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedLocationMap_in_skewedLocationsList5132 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_skewedLocationsList5135 = new BitSet(new long[]{0x0000000000408200L,0x0000200000008000L,0x0000000000000000L,0x0000000000000000L,0x0300080080000008L,0x0000000000000003L});
	public static final BitSet FOLLOW_skewedLocationMap_in_skewedLocationsList5137 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_skewedValueLocationElement_in_skewedLocationMap5183 = new BitSet(new long[]{0x0000000001000000L});
	public static final BitSet FOLLOW_EQUAL_in_skewedLocationMap5185 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_skewedLocationMap5189 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SET_in_alterStatementSuffixLocation5226 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_KW_LOCATION_in_alterStatementSuffixLocation5228 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_alterStatementSuffixLocation5232 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixSkewedby5267 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_tableSkewed_in_alterStatementSuffixSkewedby5269 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixSkewedby5288 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
	public static final BitSet FOLLOW_KW_NOT_in_alterStatementSuffixSkewedby5290 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_KW_SKEWED_in_alterStatementSuffixSkewedby5292 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_alterStatementSuffixSkewedby5309 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000200000000000L});
	public static final BitSet FOLLOW_KW_NOT_in_alterStatementSuffixSkewedby5311 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
	public static final BitSet FOLLOW_storedAsDirs_in_alterStatementSuffixSkewedby5313 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_tableName_in_alterStatementSuffixExchangePartition5349 = new BitSet(new long[]{0x0000000000000000L,0x0000004000000000L});
	public static final BitSet FOLLOW_KW_EXCHANGE_in_alterStatementSuffixExchangePartition5351 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixExchangePartition5353 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_alterStatementSuffixExchangePartition5355 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_alterStatementSuffixExchangePartition5357 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_alterStatementSuffixExchangePartition5361 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_alterProtectMode_in_alterStatementSuffixProtectMode5406 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_RENAME_in_alterStatementSuffixRenamePart5445 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_KW_TO_in_alterStatementSuffixRenamePart5447 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_alterStatementSuffixRenamePart5449 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CONCATENATE_in_alterStatementSuffixMergeFiles5487 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ENABLE_in_alterProtectMode5524 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0002400000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_alterProtectModeMode_in_alterProtectMode5526 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DISABLE_in_alterProtectMode5543 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0002400000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_alterProtectModeMode_in_alterProtectMode5545 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_OFFLINE_in_alterProtectModeMode5581 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_NO_DROP_in_alterProtectModeMode5596 = new BitSet(new long[]{0x0100000000000002L});
	public static final BitSet FOLLOW_KW_CASCADE_in_alterProtectModeMode5598 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_READONLY_in_alterProtectModeMode5616 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INTO_in_alterStatementSuffixBucketNum5650 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_Number_in_alterStatementSuffixBucketNum5654 = new BitSet(new long[]{0x0040000000000000L});
	public static final BitSet FOLLOW_KW_BUCKETS_in_alterStatementSuffixBucketNum5656 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SEQUENCEFILE_in_fileFormat5696 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TEXTFILE_in_fileFormat5711 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_RCFILE_in_fileFormat5726 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ORCFILE_in_fileFormat5741 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INPUTFORMAT_in_fileFormat5755 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_fileFormat5759 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_OUTPUTFORMAT_in_fileFormat5761 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_fileFormat5765 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000800L});
	public static final BitSet FOLLOW_KW_INPUTDRIVER_in_fileFormat5768 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_fileFormat5772 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_OUTPUTDRIVER_in_fileFormat5774 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_fileFormat5778 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_fileFormat5816 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_tabTypeExpr5852 = new BitSet(new long[]{0x0000000000200002L});
	public static final BitSet FOLLOW_DOT_in_tabTypeExpr5855 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_ELEM_TYPE_in_tabTypeExpr5859 = new BitSet(new long[]{0x0000000000200002L});
	public static final BitSet FOLLOW_KW_KEY_TYPE_in_tabTypeExpr5863 = new BitSet(new long[]{0x0000000000200002L});
	public static final BitSet FOLLOW_KW_VALUE_TYPE_in_tabTypeExpr5867 = new BitSet(new long[]{0x0000000000200002L});
	public static final BitSet FOLLOW_identifier_in_tabTypeExpr5871 = new BitSet(new long[]{0x0000000000200002L});
	public static final BitSet FOLLOW_identifier_in_descTabTypeExpr5900 = new BitSet(new long[]{0xF9FFFB6200200002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_DOT_in_descTabTypeExpr5903 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_ELEM_TYPE_in_descTabTypeExpr5907 = new BitSet(new long[]{0xF9FFFB6200200002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_KEY_TYPE_in_descTabTypeExpr5911 = new BitSet(new long[]{0xF9FFFB6200200002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_VALUE_TYPE_in_descTabTypeExpr5915 = new BitSet(new long[]{0xF9FFFB6200200002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_descTabTypeExpr5919 = new BitSet(new long[]{0xF9FFFB6200200002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_descTabTypeExpr5924 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_tabTypeExpr_in_partTypeExpr5952 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_partTypeExpr5954 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_descTabTypeExpr_in_descPartTypeExpr5994 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_descPartTypeExpr5996 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DESCRIBE_in_descStatement6036 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77FFABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_DESC_in_descStatement6038 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77FFABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_FORMATTED_in_descStatement6044 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_EXTENDED_in_descStatement6048 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_PRETTY_in_descStatement6052 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_descPartTypeExpr_in_descStatement6059 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DESCRIBE_in_descStatement6082 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_DESC_in_descStatement6084 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_FUNCTION_in_descStatement6087 = new BitSet(new long[]{0xFBFFFF62630C0190L,0xBD77FFABDFFDDADEL,0xD7FBF9EFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x0A4022506ADFFBBDL});
	public static final BitSet FOLLOW_KW_EXTENDED_in_descStatement6089 = new BitSet(new long[]{0xFBFFFF62630C0190L,0xBD77F7ABDFFDDADEL,0xD7FBF9EFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x0A4022506ADFFBBDL});
	public static final BitSet FOLLOW_descFuncNames_in_descStatement6095 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DESCRIBE_in_descStatement6117 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L});
	public static final BitSet FOLLOW_KW_DESC_in_descStatement6119 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L});
	public static final BitSet FOLLOW_KW_DATABASE_in_descStatement6122 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77FFABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_EXTENDED_in_descStatement6124 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_descStatement6130 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ANALYZE_in_analyzeStatement6170 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_analyzeStatement6172 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_analyzeStatement6177 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
	public static final BitSet FOLLOW_KW_COMPUTE_in_analyzeStatement6180 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_KW_STATISTICS_in_analyzeStatement6182 = new BitSet(new long[]{0x0000000000000002L,0x0010000000000000L,0x2000100000000000L});
	public static final BitSet FOLLOW_KW_NOSCAN_in_analyzeStatement6188 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_PARTIALSCAN_in_analyzeStatement6196 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_FOR_in_analyzeStatement6202 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COLUMNS_in_analyzeStatement6204 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_analyzeStatement6208 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6259 = new BitSet(new long[]{0x0000000000000000L,0x0000000000004000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_KW_DATABASES_in_showStatement6262 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_SCHEMAS_in_showStatement6264 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_LIKE_in_showStatement6268 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6270 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6289 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
	public static final BitSet FOLLOW_KW_TABLES_in_showStatement6291 = new BitSet(new long[]{0xF9FFFB6200000002L,0xBDF7F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_FROM_in_showStatement6295 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_IN_in_showStatement6297 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6302 = new BitSet(new long[]{0xF9FFFB6200000002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_LIKE_in_showStatement6307 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6309 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6311 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6339 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COLUMNS_in_showStatement6341 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L,0x0000000000000020L});
	public static final BitSet FOLLOW_KW_FROM_in_showStatement6344 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_IN_in_showStatement6346 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_showStatement6351 = new BitSet(new long[]{0x0000000000000002L,0x0080000000000000L,0x0000000000000020L});
	public static final BitSet FOLLOW_KW_FROM_in_showStatement6355 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_IN_in_showStatement6357 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6362 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6390 = new BitSet(new long[]{0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_FUNCTIONS_in_showStatement6392 = new BitSet(new long[]{0xF9FFFB6200000002L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6394 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6413 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
	public static final BitSet FOLLOW_KW_PARTITIONS_in_showStatement6415 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6417 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_showStatement6419 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6439 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000080L});
	public static final BitSet FOLLOW_KW_CREATE_in_showStatement6441 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_showStatement6443 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_showStatement6447 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6464 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_showStatement6466 = new BitSet(new long[]{0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_KW_EXTENDED_in_showStatement6468 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L,0x0000000004000020L});
	public static final BitSet FOLLOW_KW_FROM_in_showStatement6472 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_IN_in_showStatement6474 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6479 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_LIKE_in_showStatement6483 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6485 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_showStatement6487 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6515 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_showStatement6517 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6521 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_showStatement6524 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_showStatement6528 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_showStatement6530 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6553 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000200000000L});
	public static final BitSet FOLLOW_KW_LOCKS_in_showStatement6555 = new BitSet(new long[]{0xF9FFFB6200000002L,0xBD77FFABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_partTypeExpr_in_showStatement6560 = new BitSet(new long[]{0x0000000000000002L,0x0000080000000000L});
	public static final BitSet FOLLOW_KW_EXTENDED_in_showStatement6567 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showStatement6591 = new BitSet(new long[]{0x0000000000000000L,0x0040000000000000L,0x0000000000000180L});
	public static final BitSet FOLLOW_KW_FORMATTED_in_showStatement6596 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000180L});
	public static final BitSet FOLLOW_KW_INDEX_in_showStatement6601 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_INDEXES_in_showStatement6603 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_showStatement6606 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x020000000A5FFBBDL});
	public static final BitSet FOLLOW_showStmtIdentifier_in_showStatement6608 = new BitSet(new long[]{0x0000000000000002L,0x0080000000000000L,0x0000000000000020L});
	public static final BitSet FOLLOW_KW_FROM_in_showStatement6612 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_IN_in_showStatement6614 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_showStatement6619 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOCK_in_lockStatement6668 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_lockStatement6670 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_lockStatement6672 = new BitSet(new long[]{0x0000000000000000L,0x0000008000000000L,0x4000000000000000L,0x0000010000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_lockStatement6674 = new BitSet(new long[]{0x0000000000000000L,0x0000008000000000L,0x0000000000000000L,0x0000010000000000L});
	public static final BitSet FOLLOW_lockMode_in_lockStatement6677 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_UNLOCK_in_unlockStatement6748 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_unlockStatement6750 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_unlockStatement6752 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_unlockStatement6754 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createRoleStatement6794 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_ROLE_in_createRoleStatement6796 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_createRoleStatement6800 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropRoleStatement6840 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_ROLE_in_dropRoleStatement6842 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_dropRoleStatement6846 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_GRANT_in_grantPrivileges6886 = new BitSet(new long[]{0x0000018000000000L,0x0000000100000080L,0x0000000100000080L,0x0000040200000000L,0x0000000000004000L});
	public static final BitSet FOLLOW_privilegeList_in_grantPrivileges6890 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_privilegeObject_in_grantPrivileges6898 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_KW_TO_in_grantPrivileges6907 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalSpecification_in_grantPrivileges6909 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_grantPrivileges6918 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L});
	public static final BitSet FOLLOW_withOption_in_grantPrivileges6920 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_REVOKE_in_revokePrivileges6970 = new BitSet(new long[]{0x0000018000000000L,0x0000000100000080L,0x0000000100000080L,0x0000040200000000L,0x0000000000004000L});
	public static final BitSet FOLLOW_privilegeList_in_revokePrivileges6972 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_privilegeObject_in_revokePrivileges6974 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L});
	public static final BitSet FOLLOW_KW_FROM_in_revokePrivileges6977 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalSpecification_in_revokePrivileges6979 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_GRANT_in_grantRole7023 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_ROLE_in_grantRole7025 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_grantRole7027 = new BitSet(new long[]{0x0000000000001000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_COMMA_in_grantRole7030 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_grantRole7032 = new BitSet(new long[]{0x0000000000001000L,0x0000000000000000L,0x0000000000000000L,0x8000000000000000L});
	public static final BitSet FOLLOW_KW_TO_in_grantRole7036 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalSpecification_in_grantRole7038 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_REVOKE_in_revokeRole7080 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_ROLE_in_revokeRole7082 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_revokeRole7084 = new BitSet(new long[]{0x0000000000001000L,0x0080000000000000L});
	public static final BitSet FOLLOW_COMMA_in_revokeRole7087 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_revokeRole7089 = new BitSet(new long[]{0x0000000000001000L,0x0080000000000000L});
	public static final BitSet FOLLOW_KW_FROM_in_revokeRole7093 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalSpecification_in_revokeRole7095 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showRoleGrants7137 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_KW_ROLE_in_showRoleGrants7139 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L});
	public static final BitSet FOLLOW_KW_GRANT_in_showRoleGrants7141 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalName_in_showRoleGrants7143 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_in_showGrants7182 = new BitSet(new long[]{0x0000000000000000L,0x0800000000000000L});
	public static final BitSet FOLLOW_KW_GRANT_in_showGrants7184 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalName_in_showGrants7186 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_privilegeIncludeColObject_in_showGrants7188 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ON_in_privilegeIncludeColObject7231 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_privilegeIncludeColObject7236 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_DATABASE_in_privilegeIncludeColObject7238 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_privilegeIncludeColObject7241 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_privilegeIncludeColObject7244 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_privilegeIncludeColObject7248 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_privilegeIncludeColObject7250 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_privilegeIncludeColObject7254 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ON_in_privilegeObject7305 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_privilegeObject7310 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_KW_DATABASE_in_privilegeObject7312 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_privilegeObject7315 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_privilegeObject7317 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_privlegeDef_in_privilegeList7364 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_privilegeList7367 = new BitSet(new long[]{0x0000018000000000L,0x0000000100000080L,0x0000000100000080L,0x0000040200000000L,0x0000000000004000L});
	public static final BitSet FOLLOW_privlegeDef_in_privilegeList7369 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_privilegeType_in_privlegeDef7411 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_privlegeDef7414 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_privlegeDef7418 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_privlegeDef7420 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ALL_in_privilegeType7465 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ALTER_in_privilegeType7479 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_UPDATE_in_privilegeType7493 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_privilegeType7507 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_privilegeType7521 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INDEX_in_privilegeType7535 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOCK_in_privilegeType7549 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SELECT_in_privilegeType7563 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SHOW_DATABASE_in_privilegeType7577 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_principalName_in_principalSpecification7610 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_principalSpecification7613 = new BitSet(new long[]{0x0000000000000000L,0x1000000000000000L,0x0000000000000000L,0x0000000004000000L,0x0000000000010000L});
	public static final BitSet FOLLOW_principalName_in_principalSpecification7615 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_KW_USER_in_principalName7653 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_principalName7655 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_GROUP_in_principalName7671 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_principalName7673 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ROLE_in_principalName7689 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_principalName7691 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_GRANT_in_withOption7726 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
	public static final BitSet FOLLOW_KW_OPTION_in_withOption7728 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_MSCK_in_metastoreCheck7765 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0020000000100000L});
	public static final BitSet FOLLOW_KW_REPAIR_in_metastoreCheck7770 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_metastoreCheck7775 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_metastoreCheck7779 = new BitSet(new long[]{0x0000000000001002L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_metastoreCheck7781 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_metastoreCheck7785 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x4000000000000000L});
	public static final BitSet FOLLOW_partitionSpec_in_metastoreCheck7787 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createFunctionStatement7841 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_TEMPORARY_in_createFunctionStatement7843 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_FUNCTION_in_createFunctionStatement7845 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_createFunctionStatement7847 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_createFunctionStatement7849 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_createFunctionStatement7851 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropFunctionStatement7892 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_TEMPORARY_in_dropFunctionStatement7894 = new BitSet(new long[]{0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_FUNCTION_in_dropFunctionStatement7896 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifExists_in_dropFunctionStatement7898 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_dropFunctionStatement7901 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createMacroStatement7943 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_TEMPORARY_in_createMacroStatement7945 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
	public static final BitSet FOLLOW_KW_MACRO_in_createMacroStatement7947 = new BitSet(new long[]{0x0000000200000000L});
	public static final BitSet FOLLOW_Identifier_in_createMacroStatement7949 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_createMacroStatement7957 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000100000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameTypeList_in_createMacroStatement7959 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_createMacroStatement7962 = new BitSet(new long[]{0xFFFFFB6200408200L,0xBD77F7ABDFFDDADEL,0xD7EBF9EFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x0B0028108A5FFBBDL,0x0000000000000003L});
	public static final BitSet FOLLOW_expression_in_createMacroStatement7964 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropMacroStatement8008 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_TEMPORARY_in_dropMacroStatement8010 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
	public static final BitSet FOLLOW_KW_MACRO_in_dropMacroStatement8012 = new BitSet(new long[]{0x0000000200000000L,0x0000000000000000L,0x0000000000000004L});
	public static final BitSet FOLLOW_ifExists_in_dropMacroStatement8014 = new BitSet(new long[]{0x0000000200000000L});
	public static final BitSet FOLLOW_Identifier_in_dropMacroStatement8017 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CREATE_in_createViewStatement8059 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0010000000000000L,0x0000000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_orReplace_in_createViewStatement8062 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_KW_VIEW_in_createViewStatement8066 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifNotExists_in_createViewStatement8069 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableName_in_createViewStatement8075 = new BitSet(new long[]{0x0000200000000000L,0x0000000000000004L,0x8000000000000000L,0x0100000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_createViewStatement8086 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameCommentList_in_createViewStatement8088 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_createViewStatement8090 = new BitSet(new long[]{0x0000200000000000L,0x0000000000000004L,0x8000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tableComment_in_createViewStatement8094 = new BitSet(new long[]{0x0000200000000000L,0x0000000000000000L,0x8000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_viewPartition_in_createViewStatement8097 = new BitSet(new long[]{0x0000200000000000L,0x0000000000000000L,0x0000000000000000L,0x0100000000000000L});
	public static final BitSet FOLLOW_tablePropertiesPrefixed_in_createViewStatement8108 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_createViewStatement8119 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L,0x0000000200020000L});
	public static final BitSet FOLLOW_selectStatement_in_createViewStatement8129 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_PARTITIONED_in_viewPartition8252 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_viewPartition8254 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_viewPartition8256 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_viewPartition8258 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_viewPartition8260 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DROP_in_dropViewStatement8299 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_KW_VIEW_in_dropViewStatement8301 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFEL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_ifExists_in_dropViewStatement8303 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_viewName_in_dropViewStatement8306 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_showStmtIdentifier8344 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_StringLiteral_in_showStmtIdentifier8352 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COMMENT_in_tableComment8385 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableComment8389 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_PARTITIONED_in_tablePartition8426 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tablePartition8428 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_tablePartition8430 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameTypeList_in_tablePartition8432 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tablePartition8434 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_CLUSTERED_in_tableBuckets8479 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableBuckets8481 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_tableBuckets8483 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_tableBuckets8487 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tableBuckets8489 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000020000L,0x0000400000000000L});
	public static final BitSet FOLLOW_KW_SORTED_in_tableBuckets8492 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableBuckets8494 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_tableBuckets8496 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameOrderList_in_tableBuckets8500 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tableBuckets8502 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000020000L});
	public static final BitSet FOLLOW_KW_INTO_in_tableBuckets8506 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_Number_in_tableBuckets8510 = new BitSet(new long[]{0x0040000000000000L});
	public static final BitSet FOLLOW_KW_BUCKETS_in_tableBuckets8512 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SKEWED_in_tableSkewed8564 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableSkewed8566 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_tableSkewed8568 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameList_in_tableSkewed8572 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tableSkewed8574 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0004000000000000L});
	public static final BitSet FOLLOW_KW_ON_in_tableSkewed8576 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_tableSkewed8578 = new BitSet(new long[]{0x0000000000408200L,0x0000200000008000L,0x0000000000000000L,0x0000000000000000L,0x0300080080000008L,0x0000000000000003L});
	public static final BitSet FOLLOW_skewedValueElement_in_tableSkewed8583 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tableSkewed8586 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
	public static final BitSet FOLLOW_storedAsDirs_in_tableSkewed8589 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_rowFormatSerde_in_rowFormat8637 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_rowFormatDelimited_in_rowFormat8653 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_RECORDREADER_in_recordReader8702 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_recordReader8704 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_RECORDWRITER_in_recordWriter8753 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_recordWriter8755 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ROW_in_rowFormatSerde8804 = new BitSet(new long[]{0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_FORMAT_in_rowFormatSerde8806 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000001000000000L});
	public static final BitSet FOLLOW_KW_SERDE_in_rowFormatSerde8808 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_rowFormatSerde8812 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_rowFormatSerde8815 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
	public static final BitSet FOLLOW_KW_SERDEPROPERTIES_in_rowFormatSerde8817 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_rowFormatSerde8821 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ROW_in_rowFormatDelimited8873 = new BitSet(new long[]{0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_FORMAT_in_rowFormatDelimited8875 = new BitSet(new long[]{0x0000000000000000L,0x0000000000400000L});
	public static final BitSet FOLLOW_KW_DELIMITED_in_rowFormatDelimited8877 = new BitSet(new long[]{0x8000000000000002L,0x0000800000000000L,0x0000002010000000L});
	public static final BitSet FOLLOW_tableRowFormatFieldIdentifier_in_rowFormatDelimited8879 = new BitSet(new long[]{0x8000000000000002L,0x0000000000000000L,0x0000002010000000L});
	public static final BitSet FOLLOW_tableRowFormatCollItemsIdentifier_in_rowFormatDelimited8882 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000002010000000L});
	public static final BitSet FOLLOW_tableRowFormatMapKeysIdentifier_in_rowFormatDelimited8885 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000010000000L});
	public static final BitSet FOLLOW_tableRowFormatLinesIdentifier_in_rowFormatDelimited8888 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_rowFormatDelimited_in_tableRowFormat8944 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_rowFormatSerde_in_tableRowFormat8964 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TBLPROPERTIES_in_tablePropertiesPrefixed9011 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_tablePropertiesPrefixed9014 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_LPAREN_in_tableProperties9047 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_tablePropertiesList_in_tableProperties9049 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_tableProperties9051 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_keyValueProperty_in_tablePropertiesList9092 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_tablePropertiesList9095 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_keyValueProperty_in_tablePropertiesList9097 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_keyProperty_in_tablePropertiesList9122 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_tablePropertiesList9125 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_keyProperty_in_tablePropertiesList9127 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_StringLiteral_in_keyValueProperty9173 = new BitSet(new long[]{0x0000000001000000L});
	public static final BitSet FOLLOW_EQUAL_in_keyValueProperty9175 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_keyValueProperty9179 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_StringLiteral_in_keyProperty9226 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_FIELDS_in_tableRowFormatFieldIdentifier9270 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_TERMINATED_in_tableRowFormatFieldIdentifier9272 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableRowFormatFieldIdentifier9274 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableRowFormatFieldIdentifier9278 = new BitSet(new long[]{0x0000000000000002L,0x0000002000000000L});
	public static final BitSet FOLLOW_KW_ESCAPED_in_tableRowFormatFieldIdentifier9281 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableRowFormatFieldIdentifier9283 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableRowFormatFieldIdentifier9287 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_COLLECTION_in_tableRowFormatCollItemsIdentifier9339 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000080000L});
	public static final BitSet FOLLOW_KW_ITEMS_in_tableRowFormatCollItemsIdentifier9341 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_TERMINATED_in_tableRowFormatCollItemsIdentifier9343 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableRowFormatCollItemsIdentifier9345 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableRowFormatCollItemsIdentifier9349 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_MAP_in_tableRowFormatMapKeysIdentifier9395 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000200000L});
	public static final BitSet FOLLOW_KW_KEYS_in_tableRowFormatMapKeysIdentifier9397 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_TERMINATED_in_tableRowFormatMapKeysIdentifier9399 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableRowFormatMapKeysIdentifier9401 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableRowFormatMapKeysIdentifier9405 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LINES_in_tableRowFormatLinesIdentifier9451 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_TERMINATED_in_tableRowFormatLinesIdentifier9453 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableRowFormatLinesIdentifier9455 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableRowFormatLinesIdentifier9459 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9505 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9507 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000800000000L});
	public static final BitSet FOLLOW_KW_SEQUENCEFILE_in_tableFileFormat9509 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9524 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9526 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
	public static final BitSet FOLLOW_KW_TEXTFILE_in_tableFileFormat9528 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9543 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9545 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
	public static final BitSet FOLLOW_KW_RCFILE_in_tableFileFormat9547 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9562 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9564 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_ORCFILE_in_tableFileFormat9566 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9580 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9582 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000001000L});
	public static final BitSet FOLLOW_KW_INPUTFORMAT_in_tableFileFormat9584 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableFileFormat9588 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0400000000000000L});
	public static final BitSet FOLLOW_KW_OUTPUTFORMAT_in_tableFileFormat9590 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableFileFormat9594 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000800L});
	public static final BitSet FOLLOW_KW_INPUTDRIVER_in_tableFileFormat9597 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableFileFormat9601 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_KW_OUTPUTDRIVER_in_tableFileFormat9603 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableFileFormat9607 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9645 = new BitSet(new long[]{0x0080000000000000L});
	public static final BitSet FOLLOW_KW_BY_in_tableFileFormat9647 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableFileFormat9651 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_WITH_in_tableFileFormat9663 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000002000000000L});
	public static final BitSet FOLLOW_KW_SERDEPROPERTIES_in_tableFileFormat9665 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_tableProperties_in_tableFileFormat9669 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STORED_in_tableFileFormat9700 = new BitSet(new long[]{0x0000200000000000L});
	public static final BitSet FOLLOW_KW_AS_in_tableFileFormat9702 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_identifier_in_tableFileFormat9706 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOCATION_in_tableLocation9754 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_tableLocation9758 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_columnNameType_in_columnNameTypeList9794 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_columnNameTypeList9797 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameType_in_columnNameTypeList9799 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_columnNameColonType_in_columnNameColonTypeList9837 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_columnNameColonTypeList9840 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameColonType_in_columnNameColonTypeList9842 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_columnName_in_columnNameList9880 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_columnNameList9883 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnName_in_columnNameList9885 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_identifier_in_columnName9929 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_columnNameOrder_in_columnNameOrderList9956 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_columnNameOrderList9959 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameOrder_in_columnNameOrderList9961 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_skewedColumnValues_in_skewedValueElement10006 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedColumnValuePairList_in_skewedValueElement10015 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedColumnValuePair_in_skewedColumnValuePairList10042 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_skewedColumnValuePairList10045 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_skewedColumnValuePair_in_skewedColumnValuePairList10047 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_LPAREN_in_skewedColumnValuePair10092 = new BitSet(new long[]{0x0000000000408200L,0x0000200000008000L,0x0000000000000000L,0x0000000000000000L,0x0300080000000008L,0x0000000000000003L});
	public static final BitSet FOLLOW_skewedColumnValues_in_skewedColumnValuePair10096 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_skewedColumnValuePair10098 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedColumnValue_in_skewedColumnValues10141 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_skewedColumnValues10144 = new BitSet(new long[]{0x0000000000408200L,0x0000200000008000L,0x0000000000000000L,0x0000000000000000L,0x0300080000000008L,0x0000000000000003L});
	public static final BitSet FOLLOW_skewedColumnValue_in_skewedColumnValues10146 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_constant_in_skewedColumnValue10190 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedColumnValue_in_skewedValueLocationElement10224 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_skewedColumnValuePair_in_skewedValueLocationElement10233 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_columnNameOrder10264 = new BitSet(new long[]{0x0000400000000002L,0x0000000001000000L});
	public static final BitSet FOLLOW_KW_ASC_in_columnNameOrder10269 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DESC_in_columnNameOrder10275 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_columnNameComment_in_columnNameCommentList10347 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_columnNameCommentList10350 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameComment_in_columnNameCommentList10352 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_identifier_in_columnNameComment10392 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
	public static final BitSet FOLLOW_KW_COMMENT_in_columnNameComment10395 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_columnNameComment10399 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_expression_in_columnRefOrder10447 = new BitSet(new long[]{0x0000400000000002L,0x0000000001000000L});
	public static final BitSet FOLLOW_KW_ASC_in_columnRefOrder10452 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DESC_in_columnRefOrder10458 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_columnNameType10532 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_colType_in_columnNameType10534 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
	public static final BitSet FOLLOW_KW_COMMENT_in_columnNameType10537 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_columnNameType10541 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_identifier_in_columnNameColonType10627 = new BitSet(new long[]{0x0000000000000800L});
	public static final BitSet FOLLOW_COLON_in_columnNameColonType10629 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_colType_in_columnNameColonType10631 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
	public static final BitSet FOLLOW_KW_COMMENT_in_columnNameColonType10634 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_columnNameColonType10638 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_type_in_colType10722 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_colType_in_colTypeList10749 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_COMMA_in_colTypeList10752 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_colType_in_colTypeList10754 = new BitSet(new long[]{0x0000000000001002L});
	public static final BitSet FOLLOW_primitiveType_in_type10782 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_listType_in_type10790 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_structType_in_type10798 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_mapType_in_type10806 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_unionType_in_type10814 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TINYINT_in_primitiveType10836 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_SMALLINT_in_primitiveType10857 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INT_in_primitiveType10877 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_BIGINT_in_primitiveType10902 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_BOOLEAN_in_primitiveType10924 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_FLOAT_in_primitiveType10945 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DOUBLE_in_primitiveType10968 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DATE_in_primitiveType10990 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DATETIME_in_primitiveType11014 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TIMESTAMP_in_primitiveType11034 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STRING_in_primitiveType11053 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_BINARY_in_primitiveType11075 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DECIMAL_in_primitiveType11097 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_VARCHAR_in_primitiveType11118 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000080000000L});
	public static final BitSet FOLLOW_LPAREN_in_primitiveType11120 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_Number_in_primitiveType11124 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0001000000000000L});
	public static final BitSet FOLLOW_RPAREN_in_primitiveType11126 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_ARRAY_in_listType11170 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000020000000L});
	public static final BitSet FOLLOW_LESSTHAN_in_listType11172 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_type_in_listType11174 = new BitSet(new long[]{0x0000000020000000L});
	public static final BitSet FOLLOW_GREATERTHAN_in_listType11176 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_STRUCT_in_structType11213 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000020000000L});
	public static final BitSet FOLLOW_LESSTHAN_in_structType11215 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_columnNameColonTypeList_in_structType11217 = new BitSet(new long[]{0x0000000020000000L});
	public static final BitSet FOLLOW_GREATERTHAN_in_structType11219 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_MAP_in_mapType11254 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000020000000L});
	public static final BitSet FOLLOW_LESSTHAN_in_mapType11256 = new BitSet(new long[]{0x000E000000000000L,0x0004000080098000L,0x0000000000004000L,0x6008100000000000L,0x0000000000200000L});
	public static final BitSet FOLLOW_primitiveType_in_mapType11260 = new BitSet(new long[]{0x0000000000001000L});
	public static final BitSet FOLLOW_COMMA_in_mapType11262 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_type_in_mapType11266 = new BitSet(new long[]{0x0000000020000000L});
	public static final BitSet FOLLOW_GREATERTHAN_in_mapType11268 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_UNIONTYPE_in_unionType11311 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000020000000L});
	public static final BitSet FOLLOW_LESSTHAN_in_unionType11313 = new BitSet(new long[]{0x000E100000000000L,0x0004000080098000L,0x0000002000004000L,0x6018100000000000L,0x0000000000200200L});
	public static final BitSet FOLLOW_colTypeList_in_unionType11315 = new BitSet(new long[]{0x0000000020000000L});
	public static final BitSet FOLLOW_GREATERTHAN_in_unionType11317 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_UNION_in_queryOperator11352 = new BitSet(new long[]{0x0000008000000000L});
	public static final BitSet FOLLOW_KW_ALL_in_queryOperator11354 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_queryStatement_in_queryStatementExpression11378 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000100L});
	public static final BitSet FOLLOW_queryOperator_in_queryStatementExpression11381 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L,0x0000002000002000L,0x0000000200020000L});
	public static final BitSet FOLLOW_queryStatement_in_queryStatementExpression11384 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000100L});
	public static final BitSet FOLLOW_fromClause_in_queryStatement11407 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000002000L,0x0000000200020000L});
	public static final BitSet FOLLOW_body_in_queryStatement11417 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000002000002000L,0x0000000200020000L});
	public static final BitSet FOLLOW_regular_body_in_queryStatement11439 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_insertClause_in_regular_body11458 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L,0x0000000200020000L});
	public static final BitSet FOLLOW_selectClause_in_regular_body11463 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L});
	public static final BitSet FOLLOW_fromClause_in_regular_body11468 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_whereClause_in_regular_body11473 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_groupByClause_in_regular_body11479 = new BitSet(new long[]{0x1000000000000002L,0x4000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_havingClause_in_regular_body11485 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_orderByClause_in_regular_body11491 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_clusterByClause_in_regular_body11497 = new BitSet(new long[]{0x0000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_distributeByClause_in_regular_body11503 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_sortByClause_in_regular_body11509 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_window_clause_in_regular_body11515 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_limitClause_in_regular_body11521 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_selectStatement_in_regular_body11617 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_selectClause_in_selectStatement11635 = new BitSet(new long[]{0x0000000000000000L,0x0080000000000000L});
	public static final BitSet FOLLOW_fromClause_in_selectStatement11640 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_whereClause_in_selectStatement11645 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_groupByClause_in_selectStatement11651 = new BitSet(new long[]{0x1000000000000002L,0x4000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_havingClause_in_selectStatement11657 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_orderByClause_in_selectStatement11663 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_clusterByClause_in_selectStatement11669 = new BitSet(new long[]{0x0000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_distributeByClause_in_selectStatement11675 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_sortByClause_in_selectStatement11681 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_window_clause_in_selectStatement11687 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_limitClause_in_selectStatement11693 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_insertClause_in_body11806 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000002000000000L,0x0000000200020000L});
	public static final BitSet FOLLOW_selectClause_in_body11811 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008800000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_lateralView_in_body11816 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_whereClause_in_body11822 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_groupByClause_in_body11828 = new BitSet(new long[]{0x1000000000000002L,0x4000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_havingClause_in_body11834 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_orderByClause_in_body11840 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_clusterByClause_in_body11846 = new BitSet(new long[]{0x0000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_distributeByClause_in_body11852 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_sortByClause_in_body11858 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_window_clause_in_body11864 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_limitClause_in_body11870 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_selectClause_in_body11963 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008800000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_lateralView_in_body11968 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000005000000L});
	public static final BitSet FOLLOW_whereClause_in_body11974 = new BitSet(new long[]{0x1000000000000002L,0x5000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_groupByClause_in_body11980 = new BitSet(new long[]{0x1000000000000002L,0x4000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_havingClause_in_body11986 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0040000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_orderByClause_in_body11992 = new BitSet(new long[]{0x1000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_clusterByClause_in_body11998 = new BitSet(new long[]{0x0000000000000002L,0x0000000040000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_distributeByClause_in_body12004 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000200000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_sortByClause_in_body12010 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L,0x0000000000000000L,0x0000000004000000L});
	public static final BitSet FOLLOW_window_clause_in_body12016 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_limitClause_in_body12022 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INSERT_in_insertClause12143 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x1000000000000000L});
	public static final BitSet FOLLOW_KW_OVERWRITE_in_insertClause12145 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L,0x0000000040000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_destination_in_insertClause12147 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000004L});
	public static final BitSet FOLLOW_ifNotExists_in_insertClause12149 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_INSERT_in_insertClause12168 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000020000L});
	public static final BitSet FOLLOW_KW_INTO_in_insertClause12170 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0020000000000000L});
	public static final BitSet FOLLOW_KW_TABLE_in_insertClause12172 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_insertClause12174 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LOCAL_in_destination12219 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
	public static final BitSet FOLLOW_KW_DIRECTORY_in_destination12221 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_destination12223 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0002000010000000L});
	public static final BitSet FOLLOW_tableRowFormat_in_destination12225 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
	public static final BitSet FOLLOW_tableFileFormat_in_destination12228 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_DIRECTORY_in_destination12250 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0200000000000000L});
	public static final BitSet FOLLOW_StringLiteral_in_destination12252 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_TABLE_in_destination12267 = new BitSet(new long[]{0xF9FFFB6200000000L,0xBD77F7ABDFFDDADEL,0xD7EBD9CFFDEEFFFAL,0xEF7FFFFCFFFDFFE7L,0x000000000A5FFBBDL});
	public static final BitSet FOLLOW_tableOrPartition_in_destination12269 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_KW_LIMIT_in_limitClause12301 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000080000000000L});
	public static final BitSet FOLLOW_Number_in_limitClause12305 = new BitSet(new long[]{0x0000000000000002L});
}
